C  6/23/2004: DIVIDE BY ZERO IN VS
C  3/04/2003
C	bottom.inc for NEVERLIQ when liquid/two-phase is missing
C

VSV
	CALL HUNT(TEMP,N,T,JL,JH)
	FRACJ		= MIN(1.0,MAX(0.0,(T - TEMP(JL))/(TEMP(JH) - TEMP(JL))))
	PX		= PRES(JL) + DBLE(FRACJ)*(PRES(JH) - PRES(JL))
	IF(P .LT. PRES(1))THEN
		VL		= (1. - FRACJ)*VOLMV(JL,1) +
     .				  FRACJ*VOLMV(JH,1)
		RGAS		= SNGL(PRES(1))*VL/MAX(T,TEMP(JL))
		V		= RGAS*T/SNGL(P)
	ELSEIF(JL .GE. NC .OR. P .GT. PRES(NC))THEN
		PX		= P
		CALL HUNTP(PRES,M,PX,KL,KH)
		FRACK		= MIN(1.0,MAX(0.0,SNGL((PX - PRES(KL))/
     .				  (PRES(KH) - PRES(KL)))))
		DENS		= (1. - FRACK)
     .					/((1. - FRACJ)*VOLMV(JL,KL) +
     .	         		FRACJ*VOLMV(JH,KL)) +
     .		  		FRACK/(FRACJ*VOLMV(JH,KH) +
     .           		(1. - FRACJ)*VOLMV(JL,KH))
		V		= 1./DENS
	ELSEIF(P .LT. PX)THEN
C
C FOR LOW PARTIAL PRESSURES, USE PERFECT GAS TO EXTRAPOLATE
C
		CALL HUNTP(PRES,M,P,KL,KH)
		FRACK		= SNGL((P - PRES(KL))/
     .				  (PRES(KH) - PRES(KL)))
		IF(JL .EQ. KL)THEN
			VSAT	= 1.0/(1.0/VOLMV(JL,JL) + FRACJ
     .				*(1.0/VOLMV(JH,JH) - 1.0/VOLMV(JL,JL)))
			VMID	= 1.0/(1.0/VOLMV(JL,JL) + FRACJ
     .				*(1.0/VOLMV(JH,KL) - 1.0/VOLMV(JL,JL)))
     			FRACK	= SNGL(P - PRES(KL))/
     .				  (PX - PRES(KL))
     			DENS	= 1.0/VMID + FRACK*
     .				(1.0/VSAT - 1.0/VMID)
     			V	= 1.0/DENS
		ELSE
			DENS	= (1. - FRACK)
     .					/((1. - FRACJ)*VOLMV(JL,KL) +
     .	         		FRACJ*VOLMV(JH,KL)) +
     .		  		FRACK/(FRACJ*VOLMV(JH,KH) +
     .           		(1. - FRACJ)*VOLMV(JL,KH))
			V	= 1./DENS
		ENDIF
C
C INTO LIQUID REGIME: CAREFUL TO AVOID DISCONTINUITIES
C
	ELSE
C		RGASL	= PRES(JL)*VOLMV(JL,JL)/TEMP(JL)
C		RGASH	= PRES(JH)*VOLMV(JH,JH)/TEMP(JH)
C		RGAS	= RGASL + FRACJ*(RGASH - RGASL)
C		V	= RGAS*T/SNGL(P)
		V	= 1.0/(1.0/VOLMV(JL,JL) + FRACJ*
     .			(1.0/VOLMV(JH,JH) - 1.0/VOLMV(JL,JL)))
C NOTE "T" CANCELS IN NEXT TWO EQUATIONS, SO IT IS LEFT OUT
		RGAS	= PX*V
		V	= RGAS/SNGL(P)
	ENDIF
C
VCPV
	CALL HUNT(TEMP,N,T,JL,JH)
	FRACJ		= MIN(1.0,MAX(0.0,(T - TEMP(JL))/(TEMP(JH) - TEMP(JL))))
	PX		= PRES(JL) + DBLE(FRACJ)*(PRES(JH) - PRES(JL))
	IF(JL .GE. NC .OR. P .LE. PX .OR. P .GT. PRES(NC))THEN
		CALL HUNTP(PRES,M,P,KL,KH)
		FRACK	= MIN(1.0,MAX(0.0,SNGL((P - PRES(KL))/(PRES(KH) - PRES(KL)))))
		HHI	= ENTHV(JH,KL) + FRACK*(ENTHV(JH,KH) -
     .			ENTHV(JH,KL))
		HHL	= ENTHV(JL,KL) + FRACK*(ENTHV(JL,KH) -
     .			ENTHV(JL,KL))
	ELSE
		HHI	= ENTHV(JH,JL)
		HHL	= ENTHV(JL,JL)
	ENDIF
	CP		= (HHI - HHL)/(TEMP(JH) - TEMP(JL))
C
VTAV2
        CALL HUNTPS(ENTHV,N,H,JL,JH,PRES,M,P,KL,KH,FRACJ,FRACK)
	T		= TEMP(JL) + FRACJ*(TEMP(JH) - TEMP(JL))
C
C CHECK FOR RETURN IN LIQUID REGION
C
	IF(JL .LT. NC .AND. JL .LT. KL .AND. KH .LE. NC) THEN
		CALL HUNTP(PRES,M,P,KL,KH)
		FRACK	= MIN(1.0,MAX(0.0,SNGL((P - PRES(KL))/(PRES(KH) - PRES(KL)))))
		TSAT	= TEMP(KL) + FRACK*(TEMP(KH) - TEMP(KL))
		HHI	= ENTHV(KH,KL)
		HHL	= ENTHV(KL,KL)
		CP	= (HHI - HHL)/(TEMP(KH) - TEMP(KL))
		HS	= ENTHV(KL,KL) 
     .			+ FRACK*(ENTHV(KH,KH)-ENTHV(KL,KL))
		T	= TSAT + (H-HS)/CP
C		RGASL	= PRES(KL)*VOLMV(KL,KL)/TEMP(KL)
C		RGASH	= PRES(KH)*VOLMV(KH,KH)/TEMP(KH)
C		RGAS	= RGASL + FRACK*(RGASH - RGASL)
C		V	= RGAS*T/SNGL(P)
		DENS	= 1.0/VOLMV(KL,KL)+ FRACK*
     .			(1.0/VOLMV(KH,KH) - 1.0/VOLMV(KL,KL))
		V	= 1./DENS
C NOTE "P" CANCELS IN NEXT TWO EQUATIONS, SO IT IS LEFT OUT
		RGAS	= V/TSAT
		V	= RGAS*T
C
C CHECK FOR RETURN AT TOO-LOW PRESSURE
C
	ELSEIF(FRACK .GE. 0.0)THEN
		DENS	= (1. - FRACK)/((1. - FRACJ)*VOLMV(JL,KL) +
     .	         	FRACJ*VOLMV(JH,KL)) +
     .		  	FRACK/(FRACJ*VOLMV(JH,KH) +
     .           	(1. - FRACJ)*VOLMV(JL,KH))
		V	= 1./DENS
	ELSE
		VL	= (1. - FRACJ)*VOLMV(JL,KL) +
     .			  FRACJ*VOLMV(JH,KL)
		RGAS	= PRES(KL)*VL/MAX(T,TEMP(JL))
		V	= RGAS*T/SNGL(P)
	ENDIF
C
VH
	CALL HUNT(TEMP,N,T,JL,JH)
	FRACJ		= MAX(0.0,MIN(1.0,(T - TEMP(JL))/(TEMP(JH) - TEMP(JL))))
	PX		= PRES(JL) + DBLE(FRACJ)*(PRES(JH) - PRES(JL))
	IF(JL .GE. NC .OR. P .LE. PX.OR. P .GT. PRES(NC))THEN
C		PX	= P
		CALL HUNTP(PRES,M,P,KL,KH)
		IF(JL .EQ. KL .AND. JL .LT. NC)THEN
			HSAT	= ENTHV(JL,JL) + FRACJ
     .				*(ENTHV(JH,JH) - ENTHV(JL,JL))
			HMID	= ENTHV(JL,JL) + FRACJ
     .				*(ENTHV(JH,KL) - ENTHV(JL,JL))
     			IF(PX .GT. PRES(KL))THEN
     			   FRACK	= MIN(1.0,MAX(0.0,SNGL(P - PRES(KL))/
     .				  	(PX - PRES(KL))))
     			ELSE
			   FRACK	= 0.0
			ENDIF
     			H	= HMID + FRACK*
     .				(HSAT - HMID)
		ELSE
			FRACK	= MIN(1.0,MAX(0.0,SNGL((P - PRES(KL))
     .				/(PRES(KH) - PRES(KL)))))
			H	= (1. - FRACJ)*(1. - FRACK)*ENTHV(JL,KL) 
     .	         		+ (1. - FRACK)*FRACJ*ENTHV(JH,KL)
     .		 		+ FRACK*FRACJ*ENTHV(JH,KH)
     .           		+ (1. - FRACJ)*FRACK*ENTHV(JL,KH)
     		ENDIF
	ELSE
C		CALL HUNTP(PRES,M,P,KL,KH)
C		FRACK	= MIN(1.0,MAX(0.0,SNGL((P - PRES(KL))/(PRES(KH) - PRES(KL)))))
C		TS	= TEMP(KL) + FRACK*(TEMP(KH) - TEMP(KL))
C		HHI	= ENTHV(KH,KL)
C		HHL	= ENTHV(KL,KL)
C		CP	= (HHI - HHL)/(TEMP(KH) - TEMP(KL))
C		HS	= ENTHV(KL,KL) 
C     .			+ FRACK*(ENTHV(KH,KH)-ENTHV(KL,KL))
C		H	= HS + (T-TS)*CP
		VALL	= ENTHV(JL,JL)
		VALH	= ENTHV(JH,JH)
		VAL	= VALL + FRACJ*(VALH - VALL)
		DERIV	= (VALH - ENTHV(JH,JL))
     .			/SNGL(PRES(JH)-PRES(JL))
		H	= VAL + SNGL(P-PX)*DERIV
	ENDIF
C
VS
C
C FOR VALUES BELOW TABLE, VS IS COMPUTED BASED ON AN IDEAL GAS
C APPROXIMATION
C
        CALL HUNTTV(VOLMV,M,V,JL,JH,TEMP,N,T,KL,KH,FRACJ,FRACK)
C
C FORCE EXTRAPOLATION IF IN LIQUID REGION
C
	IF(JL .LT. NC .AND. JL .LT. KL .AND. KL .LT. NC) THEN
C		EXTRAP FROM SAT TEMP
		CALL HUNT(TEMP,N,T,JL,JH)
		FRACJ	= MIN(1.0,MAX(0.0,(T - TEMP(JL))/(TEMP(JH) - TEMP(JL))))
		PX	= PRES(JL) + DBLE(FRACJ)*(PRES(JH) - PRES(JL))
		VSAT	= 1.0/(1.0/VOLMV(JL,JL) + FRACJ
     .			*(1.0/VOLMV(JH,JH) - 1.0/VOLMV(JL,JL)))
		RGAS	= SNGL(PX)*VSAT
		P	= DBLE(RGAS/V)
		RTERM	= RGAS/T
		S	= ENTRV(JL,JL) + FRACJ*(ENTRV(JH,JH) -
     .			ENTRV(JL,JL))
C		CP	= (ENTHV(JH,JL) - ENTHV(JL,JL))/
C    .			  (TEMP(JH) - TEMP(JL))
		S	= S - RTERM*ALOG(SNGL(P/PX))
	ELSE
C
	FRAK		= FRACK
	FRAJ		= FRACJ
	FRACK		= MIN(1.0,MAX(0.0,FRACK))
	FRACJ		= MIN(1.0,MAX(0.0,FRACJ))
	IF(FRAK .LT. 0.0)THEN
		IF(FRAJ .LT. 0.0)THEN
C
C SPECIFIC VOLUME BELOW TABLE LOW TEMP, 
C COMPUTE RTERM,P (ASSUMES SI UNITS)
C
			RGAS	= PRES(KL)*VOLMV(JL,KL)/TEMP(JL)
			RTERM	= RGAS
			P	= RGAS*T/V
		ELSEIF(FRAJ .GE. 0.0)THEN
C
C SPECIFIC VOLUME BELOW TABLE HIGH TEMP, 
C COMPUTE RTERM,P (ASSUMES SI UNITS)
C
			RGAS	= PRES(KL)*VOLMV(JH,KL)/TEMP(JH)
			RTERM	= RGAS
			P	= RGAS*T/V
		ENDIF
	ENDIF
	IF(FRAJ .LT. 0.0 .OR. FRAJ .GT. 1.0)THEN
C
C TEMPERATURE IS BELOW TABLE COMPUTE CP
C
		CPL		= (ENTHV(JH,KL) - ENTHV(JL,KL))/
     .				  (TEMP(JH) - TEMP(JL))
		CPH		= (ENTHV(JH,KH) - ENTHV(JL,KH))/
     .				  (TEMP(JH) - TEMP(JL))
		CP		= (1. - FRACK)*CPL + 
     .				  FRACK*CPH
	ENDIF
	IF(FRAK .LT. 0.0)THEN
		IF(FRAJ .LE. 1.0 .AND. FRAJ .GE. 0.0)THEN
C
C ONLY SPECIFIC VOLUME BELOW TABLE 
C
			S	= (1. - FRACJ)*ENTRV(JL,KL) +
     .				  FRACJ*ENTRV(JH,KL)
			S	= S - RTERM*ALOG(SNGL(P/PRES(KL)))
		ELSEIF(FRAJ .GE. 1.0)THEN
C
C SPECIFIC VOLUME BELOW TABLE - TEMP HIGH
C
			S	= ENTRV(JH,KL)
			S	= S - RTERM*ALOG(SNGL(P/PRES(KL)))
     .				  + CP * ALOG(T/TEMP(JH))
		ELSEIF(FRAJ .LT. 0.0)THEN
C
C SPECIFIC VOLUME AND TEMPERATURE ARE BELOW TABLE
C
			S	= ENTRV(JL,KL) 
			S	= S + CP * ALOG(T/TEMP(JL))
     .				  - RTERM*ALOG(SNGL(P/PRES(KL)))
		ELSE
	        	VLO	= VOLMV(JL,KL) 
     .				+ FRACJ*(VOLMV(JH,KL) - VOLMV(JL,KL))
			VHI	= VOLMV(JL,KH) 
     .				+ FRACJ*(VOLMV(JH,KH) - VOLMV(JL,KH))
			FRACK	= (1./V - 1./VLO)/(1./VHI - 1./VLO)
			S	= (1. - FRACJ)*(1. - FRACK)*ENTRV(JL,KL)+
     .	       		  	(1. - FRACK)*FRACJ*ENTRV(JH,KL) +
     .			 	FRACK*FRACJ*ENTRV(JH,KH) +
     .         		  	(1. - FRACJ)*FRACK*ENTRV(JL,KH)
		ENDIF
	ELSE
C
C ALL VALUES WITHIN TABLE
C
		IF(JL .EQ. KL .AND. JL .LT. NC)THEN
			VSAT	= 1.0/(1.0/VOLMV(JL,JL) + FRACJ
     .				*(1.0/VOLMV(JH,JH) - 1.0/VOLMV(JL,JL)))
			SSAT	= ENTRV(JL,JL) 
     .				+ FRACJ*(ENTRV(JH,JH) - ENTRV(JL,JL))
     			IF(V .LT. VSAT)THEN
				PX	= PRES(JL) + DBLE(FRACJ)
     .					*(PRES(JH) - PRES(JL))
C T REMOVED FROM NEXT 2 EQUATIONS FOR EFFICIENCY
				RGAS	= SNGL(PX)*VSAT
				P	= DBLE(RGAS/V)
				RTERM	= RGAS/T
				S	= SSAT - RTERM*ALOG(SNGL(P/PX))
			ELSEIF(FRACJ .LE. 2.0E-7)THEN
				S	= SSAT
			ELSE
	        	  VLO	= VOLMV(JL,KL) 
     .				+ FRACJ*(VOLMV(JH,KL) - VOLMV(JL,KL))
			  IF(VSAT .GE. VLO)THEN
				S	= SSAT
			  ELSE
			    FRACK = (1./V - 1./VLO)/(1./VSAT - 1./VLO)
			    SMID = ENTRV(JL,JL) + FRACJ*(ENTRV(JH,KL) -
     .				ENTRV(JL,KL))
			    S	= SMID + FRACK*(SSAT - SMID)
			  ENDIF
			ENDIF
		ELSE
	        	VLO	= VOLMV(JL,KL) 
     .				+ FRACJ*(VOLMV(JH,KL) - VOLMV(JL,KL))
			VHI	= VOLMV(JL,KH) 
     .				+ FRACJ*(VOLMV(JH,KH) - VOLMV(JL,KH))
			FRACK	= (1./V - 1./VLO)/(1./VHI - 1./VLO)
			S	= (1. - FRACJ)*(1. - FRACK)*ENTRV(JL,KL)
     .	       	  		+ (1. - FRACK)*FRACJ*ENTRV(JH,KL)
     .			 	+ FRACK*FRACJ*ENTRV(JH,KH)
     .         		  	+ (1. - FRACJ)*FRACK*ENTRV(JL,KH)
     		ENDIF
     	ENDIF
C
     	ENDIF
VTAV1
        CALL HUNTPS(ENTRV,N,S,JL,JH,PRES,M,P,KL,KH,FRACJ,FRACK)
	T		= TEMP(JL) + FRACJ*(TEMP(JH) - TEMP(JL))
C
C CHECK FOR RETURN IN LIQUID REGION
C
	IF(JL .LT. NC .AND. (JL .LT. KL .OR.
     .	  (JL.EQ.KL .AND. FRACJ .LT. FRACK))) THEN
		CALL HUNTP(PRES,M,P,KL,KH)
		FRACK	= MIN(1.0,MAX(0.0,SNGL((P - PRES(KL))/(PRES(KH) - PRES(KL)))))
		TSAT	= TEMP(KL) + FRACK*(TEMP(KH) - TEMP(KL))
		HHI	= ENTHV(KH,KL)
		HHL	= ENTHV(KL,KL)
		CP	= (HHI - HHL)/(TEMP(KH) - TEMP(KL))
		SS	= ENTRV(KL,KL) 
     .			+ FRACK*(ENTRV(KH,KH)-ENTRV(KL,KL))
		T	= TSAT * EXP((S-SS)/CP)
C		RGASL	= PRES(KL)*VOLMV(KL,KL)/TEMP(KL)
C		RGASH	= PRES(KH)*VOLMV(KH,KH)/TEMP(KH)
C		RGAS	= RGASL + FRACK*(RGASH - RGASL)
C		V	= RGAS*T/SNGL(P)
		DENS	= 1.0/VOLMV(KL,KL)+ FRACK*
     .			(1.0/VOLMV(KH,KH) - 1.0/VOLMV(KL,KL))
		V	= 1./DENS
C NOTE "P" CANCELS IN NEXT TWO EQUATIONS, SO IT IS LEFT OUT
		RGAS	= V/TSAT
		V	= RGAS*T
C
C CHECK FOR RETURN AT TOO-LOW PRESSURE
C
	ELSEIF(FRACK .LT. 0.)THEN
		VL	= (1. - FRACJ)*VOLMV(JL,KL) +
     .			  FRACJ*VOLMV(JH,KL)
		RGAS	= PRES(KL)*VL/MAX(T,TEMP(JL))
		V	= RGAS*T/SNGL(P)
	ELSE
		DENS	= (1. - FRACK)/((1. - FRACJ)*VOLMV(JL,KL) +
     .	         	FRACJ*VOLMV(JH,KL)) +
     .		  	FRACK/(FRACJ*VOLMV(JH,KH) +
     .           	(1. - FRACJ)*VOLMV(JL,KH))
		V	= 1./DENS
	ENDIF
VSOS
	CALL HUNT(TEMP,N,T,JL,JH)
	FRACJ		= MIN(1.0,MAX(0.0,(T - TEMP(JL))/(TEMP(JH) - TEMP(JL))))
	PX		= PRES(JL) + DBLE(FRACJ)*(PRES(JH) - PRES(JL))
	IF(JL .GE. NC .OR. P .LE. PX .OR. P .GT. PRES(NC))THEN
		PX		= P
		CALL HUNTP(PRES,M,PX,KL,KH)
		FRACK	= MIN(1.0,MAX(0.0,SNGL((PX - PRES(KL))/(PRES(KH) - PRES(KL)))))
		SOS	= (1. - FRACJ)*(1. - FRACK)*SOSV(JL,KL) +
     .	         	(1. - FRACK)*FRACJ*SOSV(JH,KL) +
     .		 	FRACK*FRACJ*SOSV(JH,KH) +
     .           	(1. - FRACJ)*FRACK*SOSV(JL,KH)
	ELSE
C		VALL	= SOSV(JL,JL)
		VALH	= SOSV(JH,JH)
C		VAL	= VALL + FRACJ*(VALH - VALL)
		FRACK	= FRACJ
		VAL	= (1. - FRACJ)*(1. - FRACK)*SOSV(JL,JL) +
     .	         	(1. - FRACK)*FRACJ*SOSV(JH,JL) +
     .		 	FRACK*FRACJ*SOSV(JH,JH) +
     .           	(1. - FRACJ)*FRACK*SOSV(JL,JH)
		FRAC	= MIN(1.0,MAX(0.0,SNGL((P-PX)/(PRES(JH)-PRES(JL)))))
		SOS	= VAL + (VALH - SOSV(JH,JL))*FRAC
C		DERIV	= (VALH - SOSV(JH,JL))
C     .			/SNGL(PRES(JH)-PRES(JL))
C		SOS	= VAL + SNGL(P-PX)*DERIV
C
C TRIED ...  BUT NO BETTER
C
C		CALL HUNTP(PRES,M,P,KL,KH)
C		FRACK	= SNGL((P - PRES(KL))/(PRES(KH) - PRES(KL)))
C		TS	= TEMP(KL) + FRACK*(TEMP(KH) - TEMP(KL))
C		VALL	= SOSV(KL,KL)
C		VALH	= SOSV(KH,KH)
C		VAL	= VALL + FRACK*(VALH - VALL)
C		DERIV	= (SOSV(KH,KL) - VALL)
C     .			/SNGL(TEMP(KH)-TEMP(KL))
C		SOS	= VAL + (T-TS)*DERIV
	ENDIF
VCONDV
	CALL HUNT(TEMP,N,T,JL,JH)
	FRACJ		= MIN(1.0,MAX(0.0,(T - TEMP(JL))/(TEMP(JH) - TEMP(JL))))
	PX		= PRES(JL) + DBLE(FRACJ)*(PRES(JH) - PRES(JL))
	IF(JL .GE. NC .OR. P .LE. PX .OR. P .GT. PRES(NC))THEN
		PX		= P
		CALL HUNTP(PRES,M,PX,KL,KH)
		FRACK	= MIN(1.0,MAX(0.0,SNGL((PX - PRES(KL))/(PRES(KH) - PRES(KL)))))
		COND	= (1. - FRACJ)*(1. - FRACK)*CONDV(JL,KL) +
     .	         	(1. - FRACK)*FRACJ*CONDV(JH,KL) +
     .		 	FRACK*FRACJ*CONDV(JH,KH) +
     .           	(1. - FRACJ)*FRACK*CONDV(JL,KH)
	ELSE
C		VALL	= CONDV(JL,JL)
		VALH	= CONDV(JH,JH)
C		VAL	= VALL + FRACJ*(VALH - VALL)
		FRACK	= FRACJ
		VAL	= (1. - FRACJ)*(1. - FRACK)*CONDV(JL,JL) +
     .	         	(1. - FRACK)*FRACJ*CONDV(JH,JL) +
     .		 	FRACK*FRACJ*CONDV(JH,JH) +
     .           	(1. - FRACJ)*FRACK*CONDV(JL,JH)
		FRAC	= MIN(1.0,MAX(0.0,SNGL((P-PX)/(PRES(JH)-PRES(JL)))))
		COND	= VAL + (VALH - CONDV(JH,JL))*FRAC
C		DERIV	= (VALH - CONDV(JH,JL))
C     .			/SNGL(PRES(JH)-PRES(JL))
C		COND	= VAL + SNGL(P-PX)*DERIV
	ENDIF
C
VVISCV
	CALL HUNT(TEMP,N,T,JL,JH)
	FRACJ		= MIN(1.0,MAX(0.0,(T - TEMP(JL))/(TEMP(JH) - TEMP(JL))))
	PX		= PRES(JL) + DBLE(FRACJ)*(PRES(JH) - PRES(JL))
	IF(JL .GE. NC .OR. P .LE. PX .OR. P .GT. PRES(NC))THEN
		PX		= P
		CALL HUNTP(PRES,M,PX,KL,KH)
		FRACK	= MIN(1.0,MAX(0.0,SNGL((PX - PRES(KL))/(PRES(KH) - PRES(KL)))))
		VISC	= (1. - FRACJ)*(1. - FRACK)*VISCV(JL,KL) +
     .	         	(1. - FRACK)*FRACJ*VISCV(JH,KL) +
     .		 	FRACK*FRACJ*VISCV(JH,KH) +
     .           	(1. - FRACJ)*FRACK*VISCV(JL,KH)
	ELSE
C		VALL	= VISCV(JL,JL)
		VALH	= VISCV(JH,JH)
C		VAL	= VALL + FRACJ*(VALH - VALL)
		FRACK	= FRACJ
		VAL	= (1. - FRACJ)*(1. - FRACK)*VISCV(JL,JL) +
     .	         	(1. - FRACK)*FRACJ*VISCV(JH,JL) +
     .		 	FRACK*FRACJ*VISCV(JH,JH) +
     .           	(1. - FRACJ)*FRACK*VISCV(JL,JH)
		FRAC	= MIN(1.0,MAX(0.0,SNGL((P-PX)/(PRES(JH)-PRES(JL)))))
		VISC	= VAL + (VALH - VISCV(JH,JL))*FRAC
C		DERIV	= (VALH - VISCV(JH,JL))
C     .			/SNGL(PRES(JH)-PRES(JL))
C		VISC	= VAL + SNGL(P-PX)*DERIV
	ENDIF
