HEADER FPROP DATA, 6018, SI, 0.0
C
C  PROPERTIES FOR helium
C  NEVERLIQ VERSION (REAL GAS, NO LIQUID OR TWO-PHASE!)
C
C**********************************************
C USE AT OWN RISK: VERIFY WITH OTHER SOURCES! *
C**********************************************
C******************************************************
C CAUTION: MANY POINTS REPLACED WITH INTERPOLATIONS.  *
C These are usually in metastable regions:            *
C   Psat<P<Pcrit for vapor, Tsat<T<Tcrit for liquid   *
C The last 4 digits for replaced points are 4444      *
C******************************************************
C
C  GENERATED WITH NIST REFPROP V7.1 BETA 2/10/03
C
C  TEMPERATURE RANGE FROM   10.0     K TO  1.500E+03 K
C                   (FROM  -442.     F TO  2.240E+03 F)
C  PRESSURE RANGE FROM  2.275E-02  kPa TO   100.     MPa
C                (FROM  3.299E-03 psia TO  1.450E+04 psia)
C
C  GENERATOR: PROPGEN2
C  MODIFIED by DAJ/BAC  6/19/2003       now featuring spinodals!
C              C&R Technologies
C              www.crtech.com
C              303-971-0292
C
C  ====================================================
C  SMOOTHER T, P POINTS: BAC 11/14/2003 ===============
C  ====================================================
C
C """"""""""""""""""""""""""""""""""""""""""""""""
C Uncomment the following for real gas (no liquid):
        NEVERLIQ
C If chosen, set Pcrit to min allowed gas pressure
C but you should stay above saturation temperature
C since vapor props below that are questionable
C """"""""""""""""""""""""""""""""""""""""""""""""
C
        TCRIT =   5.1953000    
C This is the minimum, not the real critical pressure
        PCRIT =   22.746000    
        TGMAX =   1500.0000    
        TMIN =    10.000000    
        MOLW =    4.0026000    
        WSRK =    0.0000000    
        DIFV =    2.6700001    
C
C ------------------------------------------------
C THIS SHOULD AGREE WITH PGMAX BELOW (IN VINIT)!
        PGMAX =  1.00000000E+08
C Set them both less than Pcrit for incompressible
C liquid above Pcrit. No gas allowed above PGMAX
C ------------------------------------------------
C
VINIT
        INTEGER nmax,ncrit
        PARAMETER (nmax =    81)
        PARAMETER (ncrit=    54)
        DOUBLE PRECISION PRES(nmax),VPS,PX,PGMAX
        REAL TEMP(nmax),VOLMV(nmax,nmax)
        REAL ENTHV(nmax,nmax),ENTRV(nmax,nmax)
        REAL SOSV(nmax,nmax),VISCV(nmax,nmax)
        REAL CONDV(nmax,nmax)
        SAVE KL,KH,JL,JH,N,M,NC,PGMAX
        SAVE TEMP,PRES,VOLMV,ENTHV,ENTRV
        SAVE SOSV,VISCV,CONDV
        DATA N,M,NC/nmax,nmax,ncrit/
C ------------------------------------------------
C THIS SHOULD AGREE WITH PGMAX ABOVE (IN HEADER SUBBLOCK)!
        DATA PGMAX/ 1.00000000E+08/
C Set them both less than Pcrit for incompressible
C liquid above Pcrit. No gas allowed above PGMAX
C ------------------------------------------------
C
        DATA (TEMP  (J),J= 1,81) /
     *   10.001000    ,  10.647411    ,  11.335603    ,  12.068276    ,
     *   12.848304    ,  13.678750    ,  14.562871    ,  15.504138    ,
     *   16.506242    ,  17.573117    ,  18.708950    ,  19.918196    ,
     *   21.205602    ,  22.576219    ,  24.035425    ,  25.588946    ,
     *   27.242879    ,  29.003713    ,  30.878357    ,  32.874169    ,
     *   34.998980    ,  37.261127    ,  39.669487    ,  42.233510    ,
     *   44.963258    ,  47.869443    ,  50.963468    ,  54.257474    ,
     *   57.764387    ,  61.497968    ,  65.472868    ,  69.704684    ,
     *   74.210022    ,  79.006561    ,  84.113123    ,  89.549745    ,
     *   95.337762    ,  101.49988    ,  108.06029    ,  115.04473    ,
     *   122.48061    ,  130.39710    ,  138.82527    ,  147.79820    ,
     *   157.35108    ,  167.52141    ,  178.34910    ,  189.87664    ,
     *   202.14925    ,  215.21509    ,  229.12545    ,  243.93489    ,
     *   259.70154    ,  276.48725    ,  294.35791    ,  313.38363    ,
     *   333.63908    ,  355.20372    ,  378.16219    ,  402.60457    ,
     *   428.62678    ,  456.33092    ,  485.82571    ,  517.22689    ,
     *   550.65767    ,  586.24924    ,  624.14125    ,  664.48241    ,
     *   707.43100    ,  753.15555    ,  801.83550    ,  853.66186    ,
     *   908.83800    ,  967.58043    ,  1030.1197    ,  1096.7011    ,
     *   1167.5860    ,  1243.0525    ,  1323.3967    ,  1408.9340    ,
     *   1500.0000    /
        DATA (PRES  (J),J= 1,81) /
     *   22.746000    ,  1250022.5    ,  2500022.2    ,  3750021.9    ,
     *   5000021.6    ,  6250021.3    ,  7500021.0    ,  8750020.8    ,
     *   10000020.    ,  11250020.    ,  12500020.    ,  13750020.    ,
     *   15000019.    ,  16250019.    ,  17500019.    ,  18750018.    ,
     *   20000018.    ,  21250018.    ,  22500018.    ,  23750017.    ,
     *   25000017.    ,  26250017.    ,  27500016.    ,  28750016.    ,
     *   30000016.    ,  31250016.    ,  32500015.    ,  33750015.    ,
     *   35000015.    ,  36250015.    ,  37500014.    ,  38750014.    ,
     *   40000014.    ,  41250013.    ,  42500013.    ,  43750013.    ,
     *   45000013.    ,  46250012.    ,  47500012.    ,  48750012.    ,
     *   50000011.    ,  51250011.    ,  52500011.    ,  53750011.    ,
     *   55000010.    ,  56250010.    ,  57500010.    ,  58750009.    ,
     *   60000009.    ,  61250009.    ,  62500009.    ,  63750008.    ,
     *   65000008.    ,  66250008.    ,  67500007.    ,  68750007.    ,
     *   70000007.    ,  71250007.    ,  72500006.    ,  73750006.    ,
     *   75000006.    ,  76250005.    ,  77500005.    ,  78750005.    ,
     *   80000005.    ,  81250004.    ,  82500004.    ,  83750004.    ,
     *   85000003.    ,  86250003.    ,  87500003.    ,  88750003.    ,
     *   90000002.    ,  91250002.    ,  92500002.    ,  93750001.    ,
     *   95000001.    ,  96250001.    ,  97500001.    ,  98750000.    ,
     *  1.00000000E+08/
        DATA ((VOLMV (J,K),J= 1, 9),K= 1, 9) /
     *   913.31318    ,  972.34590    ,  1035.1941    ,  1102.1044    ,
     *   1173.3393    ,  1249.1784    ,  1329.9193    ,  1415.8787    ,
     *   1507.3941    ,
     *  1.30115898E-02, 1.44186485E-02, 1.59309139E-02, 1.75326633E-02,
     *  1.92144875E-02, 2.09722036E-02, 2.28056445E-02, 2.47175252E-02,
     *  2.67125538E-02,
     *  8.16272034E-03, 8.61006004E-03, 9.13354003E-03, 9.73754732E-03,
     *  1.04228074E-02, 1.11871045E-02, 1.20267313E-02, 1.29377995E-02,
     *  1.39170231E-02,
     *  6.96923438E-03, 7.21065635E-03, 7.48902548E-03, 7.80932085E-03,
     *  8.17633365E-03, 8.59419740E-03, 9.06596024E-03, 9.59337118E-03,
     *  1.01769765E-02,
     *  6.36515855E-03, 6.53080318E-03, 6.71919925E-03, 6.93338972E-03,
     *  7.17664852E-03, 7.45236339E-03, 7.76386016E-03, 8.11418778E-03,
     *  8.50590948E-03,
     *  5.97540483E-03, 6.10195946E-03, 6.24472679E-03, 6.40572831E-03,
     *  6.58719310E-03, 6.79153378E-03, 7.02129599E-03, 7.27907694E-03,
     *  7.56741583E-03,
     *  5.69355191E-03, 5.79608706E-03, 5.91118486E-03, 6.04031304E-03,
     *  6.18509758E-03, 6.34732139E-03, 6.52891188E-03, 6.73191329E-03,
     *  6.95844095E-03,
     *  5.47577130E-03, 5.56195028E-03, 5.65838167E-03, 5.76620304E-03,
     *  5.88667326E-03, 6.02117684E-03, 6.17122320E-03, 6.33843857E-03,
     *  6.52454801E-03,
     *  5.30000820E-03, 5.37428326E-03, 5.45721881E-03, 5.54973876E-03,
     *  5.65286279E-03, 5.76771180E-03, 5.89551078E-03, 6.03758798E-03,
     *  6.19536865E-03/
        DATA ((VOLMV (J,K),J= 1, 9),K=10,18) /
     *  5.15368956E-03, 5.21889133E-03, 5.29158863E-03, 5.37255791E-03,
     *  5.46265358E-03, 5.56281319E-03, 5.67406139E-03, 5.79751178E-03,
     *  5.93436572E-03,
     *  5.02901127E-03, 5.08705940E-03, 5.15171189E-03, 5.22363826E-03,
     *  5.30357306E-03, 5.39232063E-03, 5.49075920E-03, 5.59984365E-03,
     *  5.72060655E-03,
     *  4.92082067E-03, 4.97308156E-03, 5.03124156E-03, 5.09588960E-03,
     *  5.16766995E-03, 5.24728656E-03, 5.33550696E-03, 5.43316536E-03,
     *  5.54116461E-03,
     *  4.82555211E-03, 4.87303556E-03, 4.92584489E-03, 4.98450641E-03,
     *  5.04959429E-03, 5.12173451E-03, 5.20160851E-03, 5.28995634E-03,
     *  5.38757898E-03,
     *  4.74064510E-03, 4.78412011E-03, 4.83244485E-03, 4.88609583E-03,
     *  4.94559143E-03, 5.01149558E-03, 5.08442115E-03, 5.16503301E-03,
     *  5.25405053E-03,
     *  4.66420488E-03, 4.70427164E-03, 4.74878547E-03, 4.79818246E-03,
     *  4.85293574E-03, 4.91355884E-03, 4.98060892E-03, 5.05468968E-03,
     *  5.13645390E-03,
     *  4.59479398E-03, 4.63193070E-03, 4.67316867E-03, 4.71891077E-03,
     *  4.76959281E-03, 4.82568674E-03, 4.88770367E-03, 4.95619670E-03,
     *  5.03176341E-03,
     *  4.53129873E-03, 4.56589309E-03, 4.60428781E-03, 4.64685808E-03,
     *  4.69400857E-03, 4.74617643E-03, 4.80383420E-03, 4.86749252E-03,
     *  4.93770261E-03,
     *  4.47284058E-03, 4.50521169E-03, 4.54111829E-03, 4.58091231E-03,
     *  4.62497212E-03, 4.67370547E-03, 4.72755220E-03, 4.78698693E-03,
     *  4.85252142E-03/
        DATA ((VOLMV (J,K),J= 1, 9),K=19,27) /
     *  4.41871557E-03, 4.44912958E-03, 4.48284350E-03, 4.52018958E-03,
     *  4.56152384E-03, 4.60722889E-03, 4.65771664E-03, 4.71343079E-03,
     *  4.77484924E-03,
     *  4.36835182E-03, 4.39703333E-03, 4.42880326E-03, 4.46397713E-03,
     *  4.50289183E-03, 4.54590838E-03, 4.59341456E-03, 4.64582736E-03,
     *  4.70359535E-03,
     *  4.32127911E-03, 4.34841963E-03, 4.37845710E-03, 4.41169278E-03,
     *  4.44844710E-03, 4.48906241E-03, 4.53390553E-03, 4.58337022E-03,
     *  4.63787943E-03,
     *  4.27710654E-03, 4.30287095E-03, 4.33135758E-03, 4.36285555E-03,
     *  4.39767109E-03, 4.43613034E-03, 4.47858182E-03, 4.52539892E-03,
     *  4.57698211E-03,
     *  4.23550604E-03, 4.26003747E-03, 4.28713055E-03, 4.31706403E-03,
     *  4.35013189E-03, 4.38664612E-03, 4.42693923E-03, 4.47136666E-03,
     *  4.52030901E-03,
     *  4.19619979E-03, 4.21962353E-03, 4.24546031E-03, 4.27398012E-03,
     *  4.30546635E-03, 4.34021865E-03, 4.37855543E-03, 4.42081626E-03,
     *  4.46736413E-03,
     *  4.15895066E-03, 4.18137716E-03, 4.20607830E-03, 4.23331668E-03,
     *  4.26336660E-03, 4.29651691E-03, 4.33307358E-03, 4.37336213E-03,
     *  4.41772985E-03,
     *  4.12355476E-03, 4.14508207E-03, 4.16875431E-03, 4.19482799E-03,
     *  4.22356958E-03, 4.25525852E-03, 4.29018980E-03, 4.32867643E-03,
     *  4.37105166E-03,
     *  4.08983562E-03, 4.11055133E-03, 4.13328972E-03, 4.15830233E-03,
     *  4.18584899E-03, 4.21620092E-03, 4.24964343E-03, 4.28647837E-03,
     *  4.32702644E-03/
        DATA ((VOLMV (J,K),J= 1, 9),K=28,36) /
     *  4.05763953E-03, 4.07762238E-03, 4.09951203E-03, 4.12355611E-03,
     *  4.15000886E-03, 4.17913438E-03, 4.21120941E-03, 4.24652589E-03,
     *  4.28539321E-03,
     *  4.02683186E-03, 4.04615302E-03, 4.06727057E-03, 4.09042919E-03,
     *  4.11587850E-03, 4.14387645E-03, 4.17469225E-03, 4.20860898E-03,
     *  4.24592589E-03,
     *  3.99729404E-03, 4.01601825E-03, 4.03643307E-03, 4.05878116E-03,
     *  4.08330843E-03, 4.11026757E-03, 4.13992119E-03, 4.17254445E-03,
     *  4.20842750E-03,
     *  3.96892115E-03, 3.98710758E-03, 4.00688276E-03, 4.02848826E-03,
     *  4.05216705E-03, 4.07816744E-03, 4.10674626E-03, 4.13817165E-03,
     *  4.17272551E-03,
     *  3.94161990E-03, 3.95932293E-03, 3.97851615E-03, 3.99944088E-03,
     *  4.02233800E-03, 4.04745216E-03, 4.07503518E-03, 4.10534898E-03,
     *  4.13866806E-03,
     *  3.91530700E-03, 3.93257685E-03, 3.95124108E-03, 3.97154158E-03,
     *  3.99371791E-03, 4.01801177E-03, 4.04467071E-03, 4.07395112E-03,
     *  4.10612087E-03,
     *  3.88990774E-03, 3.90679105E-03, 3.92497515E-03, 3.94470334E-03,
     *  3.96621457E-03, 3.98974833E-03, 4.01554850E-03, 4.04386666E-03,
     *  4.07496470E-03,
     *  3.86535489E-03, 3.88189518E-03, 3.89964440E-03, 3.91884814E-03,
     *  3.93974545E-03, 3.96257421E-03, 3.98757534E-03, 4.01499614E-03,
     *  4.04509323E-03,
     *  3.84158768E-03, 3.85782576E-03, 3.87518223E-03, 3.89390580E-03,
     *  3.91423635E-03, 3.93641079E-03, 3.96066762E-03, 3.98725051E-03,
     *  4.01641132E-03/
        DATA ((VOLMV (J,K),J= 1, 9),K=37,45) /
     *  3.81855103E-03, 3.83452535E-03, 3.85152845E-03, 3.86981300E-03,
     *  3.88962040E-03, 3.91118723E-03, 3.93475012E-03, 3.96054967E-03,
     *  3.98883353E-03,
     *  3.79619479E-03, 3.81194180E-03, 3.82862847E-03, 3.84651235E-03,
     *  3.86583710E-03, 3.88683952E-03, 3.90975496E-03, 3.93482142E-03,
     *  3.96228286E-03,
     *  3.77447321E-03, 3.79002759E-03, 3.80643265E-03, 3.82395177E-03,
     *  3.84283155E-03, 3.86330965E-03, 3.88562065E-03, 3.91000043E-03,
     *  3.93668975E-03,
     *  3.75334436E-03, 3.76873930E-03, 3.78489571E-03, 3.80208380E-03,
     *  3.82055382E-03, 3.84054490E-03, 3.86229134E-03, 3.88602741E-03,
     *  3.91199110E-03,
     *  3.73276973E-03, 3.74803714E-03, 3.76397625E-03, 3.78086507E-03,
     *  3.79895834E-03, 3.81849720E-03, 3.83971620E-03, 3.86284844E-03,
     *  3.88812959E-03,
     *  3.71271382E-03, 3.72788456E-03, 3.74363626E-03, 3.76025589E-03,
     *  3.77800341E-03, 3.79712262E-03, 3.81784881E-03, 3.84041433E-03,
     *  3.86505296E-03,
     *  3.69314380E-03, 3.70824785E-03, 3.72384082E-03, 3.74021981E-03,
     *  3.75765083E-03, 3.77638095E-03, 3.79664668E-03, 3.81868010E-03,
     *  3.84271346E-03,
     *  3.67402925E-03, 3.68909589E-03, 3.70455773E-03, 3.72072328E-03,
     *  3.73786545E-03, 3.75623522E-03, 3.77607084E-03, 3.79760452E-03,
     *  3.82106735E-03,
     *  3.65534186E-03, 3.67039983E-03, 3.68575724E-03, 3.70173535E-03,
     *  3.71861491E-03, 3.73665144E-03, 3.75608545E-03, 3.77714969E-03,
     *  3.80007451E-03/
        DATA ((VOLMV (J,K),J= 1, 9),K=46,54) /
     *  3.63705518E-03, 3.65213288E-03, 3.66741177E-03, 3.68322740E-03,
     *  3.69986933E-03, 3.71759827E-03, 3.73665750E-03, 3.75728076E-03,
     *  3.77969799E-03,
     *  3.61914450E-03, 3.63427008E-03, 3.64949575E-03, 3.66517295E-03,
     *  3.68160104E-03, 3.69904671E-03, 3.71775651E-03, 3.73796556E-03,
     *  3.75990376E-03,
     *  3.60158657E-03, 3.61678814E-03, 3.63198537E-03, 3.64754736E-03,
     *  3.66378443E-03, 3.68096994E-03, 3.69935427E-03, 3.71917434E-03,
     *  3.74066038E-03,
     *  3.58435950E-03, 3.59966524E-03, 3.61485841E-03, 3.63032774E-03,
     *  3.64639569E-03, 3.66334307E-03, 3.68142464E-03, 3.70087958E-03,
     *  3.72193877E-03,
     *  3.56744256E-03, 3.58288091E-03, 3.59809412E-03, 3.61349275E-03,
     *  3.62941267E-03, 3.64614296E-03, 3.66394337E-03, 3.68305573E-03,
     *  3.70371195E-03,
     *  3.55081608E-03, 3.56641586E-03, 3.58167306E-03, 3.59702246E-03,
     *  3.61281470E-03, 3.62934808E-03, 3.64688787E-03, 3.66567905E-03,
     *  3.68595488E-03,
     *  3.53446131E-03, 3.55025190E-03, 3.56557699E-03, 3.58089819E-03,
     *  3.59658251E-03, 3.61293833E-03, 3.63023713E-03, 3.64872745E-03,
     *  3.66864426E-03,
     *  3.51836029E-03, 3.53437180E-03, 3.54978871E-03, 3.56510247E-03,
     *  3.58069805E-03, 3.59689495E-03, 3.61397152E-03, 3.63218032E-03,
     *  3.65175841E-03,
     *  3.50249575E-03, 3.51875921E-03, 3.53429205E-03, 3.54961886E-03,
     *  3.56514441E-03, 3.58120040E-03, 3.59807271E-03, 3.61601843E-03,
     *  3.63527707E-03/
        DATA ((VOLMV (J,K),J= 1, 9),K=55,63) /
     *  3.48685099E-03, 3.50339855E-03, 3.51907169E-03, 3.53443190E-03,
     *  3.54990572E-03, 3.56583821E-03, 3.58252353E-03, 3.60022379E-03,
     *  3.61918133E-03,
     *  3.47140979E-03, 3.48827492E-03, 3.50411313E-03, 3.51952701E-03,
     *  3.53496706E-03, 3.55079295E-03, 3.56730790E-03, 3.58477957E-03,
     *  3.60345350E-03,
     *  3.45615629E-03, 3.47337403E-03, 3.48940260E-03, 3.50489041E-03,
     *  3.52031438E-03, 3.53605010E-03, 3.55241072E-03, 3.56966997E-03,
     *  3.58807697E-03,
     *  3.44107489E-03, 3.45868213E-03, 3.47492698E-03, 3.49050908E-03,
     *  3.50593441E-03, 3.52159602E-03, 3.53781779E-03, 3.55488016E-03,
     *  3.57303621E-03,
     *  3.42615015E-03, 3.44418593E-03, 3.46067376E-03, 3.47637066E-03,
     *  3.49181465E-03, 3.50741782E-03, 3.52351578E-03, 3.54039620E-03,
     *  3.55831658E-03,
     *  3.41136666E-03, 3.42987252E-03, 3.44663094E-03, 3.46246340E-03,
     *  3.47794325E-03, 3.49350337E-03, 3.50949208E-03, 3.52620497E-03,
     *  3.54390435E-03,
     *  3.39670893E-03, 3.41572930E-03, 3.43278703E-03, 3.44877613E-03,
     *  3.46430898E-03, 3.47984117E-03, 3.49573482E-03, 3.51229409E-03,
     *  3.52978657E-03,
     *  3.38216127E-03, 3.40174393E-03, 3.41913096E-03, 3.43529818E-03,
     *  3.45090120E-03, 3.46642036E-03, 3.48223279E-03, 3.49865191E-03,
     *  3.51595103E-03,
     *  3.36770758E-03, 3.38790425E-03, 3.40565201E-03, 3.42201936E-03,
     *  3.43770976E-03, 3.45323065E-03, 3.46897537E-03, 3.48526739E-03,
     *  3.50238623E-03/
        DATA ((VOLMV (J,K),J= 1, 9),K=64,72) /
     *  3.35333126E-03, 3.37419820E-03, 3.39233983E-03, 3.40892991E-03,
     *  3.42472503E-03, 3.44026226E-03, 3.45595252E-03, 3.47213010E-03,
     *  3.48908128E-03,
     *  3.33901495E-03, 3.36061376E-03, 3.37918431E-03, 3.39602044E-03,
     *  3.41193781E-03, 3.42750591E-03, 3.44315471E-03, 3.45923020E-03,
     *  3.47602589E-03,
     *  3.32474030E-03, 3.34713884E-03, 3.36617561E-03, 3.38328193E-03,
     *  3.39933932E-03, 3.41495276E-03, 3.43057290E-03, 3.44655830E-03,
     *  3.46321031E-03,
     *  3.31048771E-03, 3.33376124E-03, 3.35330405E-03, 3.37070567E-03,
     *  3.38692113E-03, 3.40259439E-03, 3.41819850E-03, 3.43410555E-03,
     *  3.45062531E-03,
     *  3.29623593E-03, 3.32046850E-03, 3.34056013E-03, 3.35828322E-03,
     *  3.37467520E-03, 3.39042279E-03, 3.40602333E-03, 3.42186352E-03,
     *  3.43826214E-03,
     *  3.28196163E-03, 3.30724783E-03, 3.32793440E-03, 3.34600641E-03,
     *  3.36259378E-03, 3.37843028E-03, 3.39403961E-03, 3.40982418E-03,
     *  3.42611248E-03,
     *  3.26763881E-03, 3.29408596E-03, 3.31541751E-03, 3.33386727E-03,
     *  3.35066942E-03, 3.36660952E-03, 3.38223991E-03, 3.39797993E-03,
     *  3.41416842E-03,
     *  3.25323807E-03, 3.28096903E-03, 3.30300006E-03, 3.32185803E-03,
     *  3.33889492E-03, 3.35495348E-03, 3.37061717E-03, 3.38632350E-03,
     *  3.40242245E-03,
     *  3.23872554E-03, 3.26788235E-03, 3.29067262E-03, 3.30997108E-03,
     *  3.32726336E-03, 3.34345544E-03, 3.35916460E-03, 3.37484796E-03,
     *  3.39086740E-03/
        DATA ((VOLMV (J,K),J= 1, 9),K=73,81) /
     *  3.22406154E-03, 3.25481025E-03, 3.27842563E-03, 3.29819891E-03,
     *  3.31576800E-03, 3.33210890E-03, 3.34787573E-03, 3.36354670E-03,
     *  3.37949645E-03,
     *  3.20919862E-03, 3.24173583E-03, 3.26624935E-03, 3.28653415E-03,
     *  3.30440233E-03, 3.32090764E-03, 3.33674436E-03, 3.35241343E-03,
     *  3.36830310E-03,
     *  3.19407873E-03, 3.22864057E-03, 3.25413378E-03, 3.27496946E-03,
     *  3.29316000E-03, 3.30984566E-03, 3.32576454E-03, 3.34144209E-03,
     *  3.35728114E-03,
     *  3.17862900E-03, 3.21550402E-03, 3.24206857E-03, 3.26349756E-03,
     *  3.28203481E-03, 3.29891715E-03, 3.31493057E-03, 3.33062692E-03,
     *  3.34642464E-03,
     *  3.16275520E-03, 3.20230323E-03, 3.23004293E-03, 3.25211115E-03,
     *  3.27102073E-03, 3.28811653E-03, 3.30423696E-03, 3.31996239E-03,
     *  3.33572791E-03,
     *  3.14633092E-03, 3.18901207E-03, 3.21804552E-03, 3.24080291E-03,
     *  3.26011180E-03, 3.27743836E-03, 3.29367844E-03, 3.30944318E-03,
     *  3.32518553E-03,
     *  3.12917877E-03, 3.17560039E-03, 3.20606432E-03, 3.22956543E-03,
     *  3.24930219E-03, 3.26687738E-03, 3.28324991E-03, 3.29906421E-03,
     *  3.31479231E-03,
     *  3.11103457E-03, 3.16203273E-03, 3.19408644E-03, 3.21839119E-03,
     *  3.23858615E-03, 3.25642848E-03, 3.27294649E-03, 3.28882059E-03,
     *  3.30454326E-03,
     *  3.09147144E-03, 3.14826665E-03, 3.18209796E-03, 3.20727252E-03,
     *  3.22795796E-03, 3.24608666E-03, 3.26276342E-03, 3.27870762E-03,
     *  3.29443361E-03/
        DATA ((VOLMV (J,K),J=10,18),K= 1, 9) /
     *   1604.8245    ,  1708.5522    ,  1818.9842    ,  1936.5540    ,
     *   2061.7228    ,  2194.9817    ,  2336.8538    ,  2487.8957    ,
     *   2648.7002    ,
     *  2.87968171E-02, 3.09773920E-02, 3.32621168E-02, 3.56594693E-02,
     *  3.81785096E-02, 4.08288641E-02, 4.36207352E-02, 4.65649253E-02,
     *  4.96728710E-02,
     *  1.49620654E-02, 1.60716539E-02, 1.72455899E-02, 1.84847019E-02,
     *  1.97907681E-02, 2.11664248E-02, 2.26150760E-02, 2.41408134E-02,
     *  2.57483531E-02,
     *  1.08164698E-02, 1.15111342E-02, 1.22602285E-02, 1.30632573E-02,
     *  1.39201310E-02, 1.48312521E-02, 1.57975545E-02, 1.68205158E-02,
     *  1.79021522E-02,
     *  8.94096166E-03, 9.42062909E-03, 9.94564351E-03, 1.05163670E-02,
     *  1.11330008E-02, 1.17957714E-02, 1.25050722E-02, 1.32615591E-02,
     *  1.40662117E-02,
     *  7.88866936E-03, 8.24489674E-03, 8.63778363E-03, 9.06862727E-03,
     *  9.53838714E-03, 1.00477851E-02, 1.05974279E-02, 1.11879264E-02,
     *  1.18199957E-02,
     *  7.21061730E-03, 7.49049476E-03, 7.79997637E-03, 8.14075001E-03,
     *  8.51425216E-03, 8.92167102E-03, 9.36398845E-03, 9.84205018E-03,
     *  1.03566488E-02,
     *  6.73134564E-03, 6.96065263E-03, 7.21426547E-03, 7.49390020E-03,
     *  7.80114204E-03, 8.13741077E-03, 8.50395011E-03, 8.90184449E-03,
     *  9.33205953E-03,
     *  6.37036176E-03, 6.56413839E-03, 6.77830155E-03, 7.01444884E-03,
     *  7.27413164E-03, 7.55881686E-03, 7.86985830E-03, 8.20848382E-03,
     *  8.57580199E-03/
        DATA ((VOLMV (J,K),J=10,18),K=10,18) /
     *  6.08590685E-03, 6.25349037E-03, 6.43852607E-03, 6.64245503E-03,
     *  6.86672119E-03, 7.11274021E-03, 7.38187006E-03, 7.67538827E-03,
     *  7.99448059E-03,
     *  5.85415654E-03, 6.00167324E-03, 6.16439798E-03, 6.34361965E-03,
     *  6.54065586E-03, 6.75683024E-03, 6.99344799E-03, 7.25177293E-03,
     *  7.53300974E-03,
     *  5.66047646E-03, 5.79213956E-03, 5.93725455E-03, 6.09697560E-03,
     *  6.27249821E-03, 6.46504335E-03, 6.67583882E-03, 6.90609957E-03,
     *  7.15700965E-03,
     *  5.49533959E-03, 5.61416313E-03, 5.74503403E-03, 5.88899123E-03,
     *  6.04712037E-03, 6.22054290E-03, 6.41040240E-03, 6.61784895E-03,
     *  6.84402312E-03,
     *  5.35224928E-03, 5.46046160E-03, 5.57957574E-03, 5.71053311E-03,
     *  5.85432335E-03, 6.01197693E-03, 6.18455523E-03, 6.37313859E-03,
     *  6.57881307E-03,
     *  5.22660537E-03, 5.32590001E-03, 5.43514590E-03, 5.55520193E-03,
     *  5.68697474E-03, 5.83141373E-03, 5.98950398E-03, 6.16225723E-03,
     *  6.35070122E-03,
     *  5.11504791E-03, 5.20674228E-03, 5.30758716E-03, 5.41837126E-03,
     *  5.53992960E-03, 5.67314017E-03, 5.81891890E-03, 5.97821289E-03,
     *  6.15199205E-03,
     *  5.01505831E-03, 5.10019773E-03, 5.19380421E-03, 5.29660638E-03,
     *  5.40937730E-03, 5.53293227E-03, 5.66812525E-03, 5.81584383E-03,
     *  5.97700277E-03,
     *  4.92470670E-03, 5.00413480E-03, 5.09143988E-03, 5.18729878E-03,
     *  5.29243068E-03, 5.40759578E-03, 5.53359279E-03, 5.67125520E-03,
     *  5.82144623E-03/
        DATA ((VOLMV (J,K),J=10,18),K=19,27) /
     *  4.84248619E-03, 4.91689388E-03, 4.99866396E-03, 5.08842824E-03,
     *  5.18685882E-03, 5.29466732E-03, 5.41260323E-03, 5.54145106E-03,
     *  5.68202654E-03,
     *  4.76720074E-03, 4.83716119E-03, 4.91403125E-03, 4.99840333E-03,
     *  5.09090812E-03, 5.19221427E-03, 5.30302730E-03, 5.42408755E-03,
     *  5.55616719E-03,
     *  4.69788740E-03, 4.76388147E-03, 4.83638362E-03, 4.91595154E-03,
     *  5.00317929E-03, 5.09869731E-03, 5.20317179E-03, 5.31730316E-03,
     *  5.44182384E-03,
     *  4.63376100E-03, 4.69619619E-03, 4.76478083E-03, 4.84004187E-03,
     *  4.92254078E-03, 5.01287388E-03, 5.11167204E-03, 5.21959959E-03,
     *  5.33735267E-03,
     *  4.57417410E-03, 4.63339881E-03, 4.69845066E-03, 4.76982916E-03,
     *  4.84806668E-03, 4.93372892E-03, 5.02741490E-03, 5.12975628E-03,
     *  5.24141603E-03,
     *  4.51858746E-03, 4.57490195E-03, 4.63675225E-03, 4.70461328E-03,
     *  4.77899125E-03, 4.86042429E-03, 4.94948263E-03, 5.04676819E-03,
     *  5.15291365E-03,
     *  4.46654780E-03, 4.52021277E-03, 4.57914881E-03, 4.64380873E-03,
     *  4.71467516E-03, 4.79226126E-03, 4.87711114E-03, 4.96979964E-03,
     *  5.07093166E-03,
     *  4.41767104E-03, 4.46891426E-03, 4.52518687E-03, 4.58692169E-03,
     *  4.65457996E-03, 4.72865221E-03, 4.80965873E-03, 4.89814961E-03,
     *  4.99470428E-03,
     *  4.37162919E-03, 4.42065093E-03, 4.47448043E-03, 4.53353239E-03,
     *  4.59824861E-03, 4.66909900E-03, 4.74658210E-03, 4.83122529E-03,
     *  4.92358458E-03/
        DATA ((VOLMV (J,K),J=10,18),K=28,36) /
     *  4.32814032E-03, 4.37511759E-03, 4.42669858E-03, 4.48328147E-03,
     *  4.54529038E-03, 4.61317632E-03, 4.68741791E-03, 4.76852169E-03,
     *  4.85702205E-03,
     *  4.28696051E-03, 4.33205059E-03, 4.38155581E-03, 4.43585930E-03,
     *  4.49536898E-03, 4.56051857E-03, 4.63176837E-03, 4.70960571E-03,
     *  4.79454499E-03,
     *  4.24787752E-03, 4.29122078E-03, 4.33880431E-03, 4.39099746E-03,
     *  4.44819328E-03, 4.51080959E-03, 4.57928983E-03, 4.65410357E-03,
     *  4.73574674E-03,
     *  4.21070569E-03, 4.25242798E-03, 4.29822783E-03, 4.34846196E-03,
     *  4.40350976E-03, 4.46377440E-03, 4.52968373E-03, 4.60169089E-03,
     *  4.68027464E-03,
     *  4.17528179E-03, 4.21549637E-03, 4.25963667E-03, 4.30804781E-03,
     *  4.36109658E-03, 4.41917259E-03, 4.48268930E-03, 4.55208460E-03,
     *  4.62782127E-03,
     *  4.14146162E-03, 4.18027084E-03, 4.22286367E-03, 4.26957454E-03,
     *  4.32075860E-03, 4.37679296E-03, 4.43807767E-03, 4.50503647E-03,
     *  4.57811727E-03,
     *  4.10911730E-03, 4.14661395E-03, 4.18776084E-03, 4.23288255E-03,
     *  4.28232347E-03, 4.33644909E-03, 4.39564703E-03, 4.46032785E-03,
     *  4.53092556E-03,
     *  4.07813492E-03, 4.11440340E-03, 4.15419665E-03, 4.19783013E-03,
     *  4.24563827E-03, 4.29797578E-03, 4.35521871E-03, 4.41776529E-03,
     *  4.48603655E-03,
     *  4.04841263E-03, 4.08352996E-03, 4.12205373E-03, 4.16429096E-03,
     *  4.21056684E-03, 4.26122605E-03, 4.31663383E-03, 4.37717693E-03,
     *  4.44326422E-03/
        DATA ((VOLMV (J,K),J=10,18),K=37,45) /
     *  4.01985908E-03, 4.05389575E-03, 4.09122697E-03, 4.13215201E-03,
     *  4.17698745E-03, 4.22606860E-03, 4.27975065E-03, 4.33840956E-03,
     *  4.40244283E-03,
     *  3.99239200E-03, 4.02541269E-03, 4.06162196E-03, 4.10131182E-03,
     *  4.14479090E-03, 4.19238577E-03, 4.24444220E-03, 4.30132608E-03,
     *  4.36342417E-03,
     *  3.96593714E-03, 3.99800136E-03, 4.03315354E-03, 4.07167900E-03,
     *  4.11387893E-03, 4.16007177E-03, 4.21059445E-03, 4.26580338E-03,
     *  4.32607529E-03,
     *  3.94042721E-03, 3.97158986E-03, 4.00574475E-03, 4.04317100E-03,
     *  4.08416286E-03, 4.12903117E-03, 4.17810458E-03, 4.23173062E-03,
     *  4.29027654E-03,
     *  3.91580112E-03, 3.94611296E-03, 3.97932579E-03, 4.01571299E-03,
     *  4.05556237E-03, 4.09917763E-03, 4.14687967E-03, 4.19900765E-03,
     *  4.25591988E-03,
     *  3.89200323E-03, 3.92151128E-03, 3.95383320E-03, 3.98923704E-03,
     *  4.02800458E-03, 4.07043286E-03, 4.11683549E-03, 4.16754375E-03,
     *  4.22290754E-03,
     *  3.86898275E-03, 3.89773068E-03, 3.92920914E-03, 3.96368123E-03,
     *  4.00142313E-03, 4.04272563E-03, 4.08789548E-03, 4.13725655E-03,
     *  4.19115077E-03,
     *  3.84669318E-03, 3.87472164E-03, 3.90540074E-03, 3.93898904E-03,
     *  3.97575748E-03, 4.01599099E-03, 4.05998987E-03, 4.10807100E-03,
     *  4.16056879E-03,
     *  3.82509189E-03, 3.85243875E-03, 3.88235960E-03, 3.91510875E-03,
     *  3.95095227E-03, 3.99016959E-03, 4.03305495E-03, 4.07991864E-03,
     *  4.13108793E-03/
        DATA ((VOLMV (J,K),J=10,18),K=46,54) /
     *  3.80413968E-03, 3.83084034E-03, 3.86004128E-03, 3.89199291E-03,
     *  3.92695673E-03, 3.96520705E-03, 4.00703240E-03, 4.05273681E-03,
     *  4.10264082E-03,
     *  3.78380044E-03, 3.80988802E-03, 3.83840490E-03, 3.86959788E-03,
     *  3.90372426E-03, 3.94105348E-03, 3.98186871E-03, 4.02646807E-03,
     *  4.07516573E-03,
     *  3.76404087E-03, 3.78954640E-03, 3.81741278E-03, 3.84788352E-03,
     *  3.88121193E-03, 3.91766296E-03, 3.95751468E-03, 4.00105965E-03,
     *  4.04860599E-03,
     *  3.74483014E-03, 3.76978278E-03, 3.79703015E-03, 3.82681273E-03,
     *  3.85938017E-03, 3.89499316E-03, 3.93392500E-03, 3.97646297E-03,
     *  4.02290944E-03,
     *  3.72613971E-03, 3.75056687E-03, 3.77722482E-03, 3.80635125E-03,
     *  3.83819241E-03, 3.87300501E-03, 3.91105785E-03, 3.95263321E-03,
     *  3.99802801E-03,
     *  3.70794310E-03, 3.73187060E-03, 3.75796696E-03, 3.78646733E-03,
     *  3.81761481E-03, 3.85166237E-03, 3.88887457E-03, 3.92952897E-03,
     *  3.97391731E-03,
     *  3.69021569E-03, 3.71366788E-03, 3.73922887E-03, 3.76713152E-03,
     *  3.79761597E-03, 3.83093174E-03, 3.86733936E-03, 3.90711193E-03,
     *  3.95053626E-03,
     *  3.67293455E-03, 3.69593447E-03, 3.72098483E-03, 3.74831645E-03,
     *  3.77816676E-03, 3.81078202E-03, 3.84641901E-03, 3.88534655E-03,
     *  3.92784681E-03,
     *  3.65607834E-03, 3.67864774E-03, 3.70321086E-03, 3.72999665E-03,
     *  3.75924007E-03, 3.79118433E-03, 3.82608264E-03, 3.86419984E-03,
     *  3.90581362E-03/
        DATA ((VOLMV (J,K),J=10,18),K=55,63) /
     *  3.63962708E-03, 3.66178660E-03, 3.68588459E-03, 3.71214838E-03,
     *  3.74081064E-03, 3.77211174E-03, 3.80630155E-03, 3.84364109E-03,
     *  3.88440385E-03,
     *  3.62356213E-03, 3.64533133E-03, 3.66898516E-03, 3.69474948E-03,
     *  3.72285492E-03, 3.75353917E-03, 3.78704897E-03, 3.82364174E-03,
     *  3.86358694E-03,
     *  3.60786601E-03, 3.62926349E-03, 3.65249303E-03, 3.67777925E-03,
     *  3.70535089E-03, 3.73544319E-03, 3.76829993E-03, 3.80417510E-03,
     *  3.84333437E-03,
     *  3.59252235E-03, 3.61356580E-03, 3.63638991E-03, 3.66121830E-03,
     *  3.68827798E-03, 3.71780190E-03, 3.75003108E-03, 3.78521629E-03,
     *  3.82361953E-03,
     *  3.57751578E-03, 3.59822202E-03, 3.62065867E-03, 3.64504846E-03,
     *  3.67161689E-03, 3.70059480E-03, 3.73222060E-03, 3.76674200E-03,
     *  3.80441755E-03,
     *  3.56283184E-03, 3.58321695E-03, 3.60528320E-03, 3.62925270E-03,
     *  3.65534954E-03, 3.68380266E-03, 3.71484801E-03, 3.74873042E-03,
     *  3.78570514E-03,
     *  3.54845693E-03, 3.56853624E-03, 3.59024839E-03, 3.61381499E-03,
     *  3.63945897E-03, 3.66740746E-03, 3.69789413E-03, 3.73116110E-03,
     *  3.76746047E-03,
     *  3.53437826E-03, 3.55416641E-03, 3.57553999E-03, 3.59872028E-03,
     *  3.62392919E-03, 3.65139223E-03, 3.68134094E-03, 3.71401484E-03,
     *  3.74966308E-03,
     *  3.52058374E-03, 3.54009476E-03, 3.56114459E-03, 3.58395440E-03,
     *  3.60874521E-03, 3.63574106E-03, 3.66517149E-03, 3.69727361E-03,
     *  3.73229373E-03/
        DATA ((VOLMV (J,K),J=10,18),K=64,72) /
     *  3.50706196E-03, 3.52630928E-03, 3.54704956E-03, 3.56950399E-03,
     *  3.59389287E-03, 3.62043891E-03, 3.64936983E-03, 3.68092043E-03,
     *  3.71533433E-03,
     *  3.49380214E-03, 3.51279866E-03, 3.53324296E-03, 3.55535643E-03,
     *  3.57935882E-03, 3.60547166E-03, 3.63392094E-03, 3.66493931E-03,
     *  3.69876786E-03,
     *  3.48079410E-03, 3.49955219E-03, 3.51971350E-03, 3.54149982E-03,
     *  3.56513048E-03, 3.59082594E-03, 3.61881064E-03, 3.64931520E-03,
     *  3.68257826E-03,
     *  3.46802817E-03, 3.48655973E-03, 3.50645053E-03, 3.52792291E-03,
     *  3.55119593E-03, 3.57648916E-03, 3.60402556E-03, 3.63403386E-03,
     *  3.66675041E-03,
     *  3.45549521E-03, 3.47381168E-03, 3.49344394E-03, 3.51461505E-03,
     *  3.53754394E-03, 3.56244939E-03, 3.58955305E-03, 3.61908187E-03,
     *  3.65127000E-03,
     *  3.44318653E-03, 3.46129894E-03, 3.48068417E-03, 3.50156614E-03,
     *  3.52416383E-03, 3.54869535E-03, 3.57538116E-03, 3.60444652E-03,
     *  3.63612354E-03,
     *  3.43109388E-03, 3.44901289E-03, 3.46816214E-03, 3.48876664E-03,
     *  3.51104552E-03, 3.53521637E-03, 3.56149856E-03, 3.59011580E-03,
     *  3.62129825E-03,
     *  3.41920943E-03, 3.43694530E-03, 3.45586924E-03, 3.47620746E-03,
     *  3.49817943E-03, 3.52200232E-03, 3.54789452E-03, 3.57607832E-03,
     *  3.60678203E-03,
     *  3.40752573E-03, 3.42508840E-03, 3.44379728E-03, 3.46388000E-03,
     *  3.48555647E-03, 3.50904359E-03, 3.53455888E-03, 3.56232330E-03,
     *  3.59256342E-03/
        DATA ((VOLMV (J,K),J=10,18),K=73,81) /
     *  3.39603569E-03, 3.41343476E-03, 3.43193848E-03, 3.45177608E-03,
     *  3.47316802E-03, 3.49633106E-03, 3.52148198E-03, 3.54884049E-03,
     *  3.57863154E-03,
     *  3.38473254E-03, 3.40197732E-03, 3.42028545E-03, 3.43988790E-03,
     *  3.46100586E-03, 3.48385607E-03, 3.50865465E-03, 3.53562018E-03,
     *  3.56497608E-03,
     *  3.37360983E-03, 3.39070936E-03, 3.40883113E-03, 3.42820805E-03,
     *  3.44906220E-03, 3.47161037E-03, 3.49606817E-03, 3.52265314E-03,
     *  3.55158724E-03,
     *  3.36266143E-03, 3.37962446E-03, 3.39756881E-03, 3.41672949E-03,
     *  3.43732960E-03, 3.45958613E-03, 3.48371425E-03, 3.50993057E-03,
     *  3.53845570E-03,
     *  3.35188144E-03, 3.36871649E-03, 3.38649208E-03, 3.40544549E-03,
     *  3.42580099E-03, 3.44777587E-03, 3.47158499E-03, 3.49744412E-03,
     *  3.52557259E-03,
     *  3.34126426E-03, 3.35797962E-03, 3.37559482E-03, 3.39434963E-03,
     *  3.41446960E-03, 3.43617248E-03, 3.45967288E-03, 3.48518583E-03,
     *  3.51292948E-03,
     *  3.33080452E-03, 3.34740826E-03, 3.36487120E-03, 3.38343579E-03,
     *  3.40332901E-03, 3.42476917E-03, 3.44797075E-03, 3.47314811E-03,
     *  3.50051833E-03,
     *  3.32049708E-03, 3.33699707E-03, 3.35431564E-03, 3.37269812E-03,
     *  3.39237307E-03, 3.41355946E-03, 3.43647175E-03, 3.46132374E-03,
     *  3.48833148E-03,
     *  3.31033701E-03, 3.32674094E-03, 3.34392281E-03, 3.36213103E-03,
     *  3.38159590E-03, 3.40253717E-03, 3.42516937E-03, 3.44970580E-03,
     *  3.47636162E-03/
        DATA ((VOLMV (J,K),J=19,27),K= 1, 9) /
     *   2819.8981    ,  3002.1613    ,  3196.2050    ,  3402.7906    ,
     *   3622.7288    ,  3856.8826    ,  4106.1709    ,  4371.5717    ,
     *   4654.1267    ,
     *  5.29566843E-02, 5.64291977E-02, 6.01040137E-02, 6.39955572E-02,
     *  6.81191317E-02, 7.24909780E-02, 7.71283370E-02, 8.20495158E-02,
     *  8.72739580E-02,
     *  2.74429882E-02, 2.92305583E-02, 3.11174315E-02, 3.31104996E-02,
     *  3.52171805E-02, 3.74454299E-02, 3.98037580E-02, 4.23012524E-02,
     *  4.49476041E-02,
     *  1.90450039E-02, 2.02521159E-02, 2.15270184E-02, 2.28737100E-02,
     *  2.42966449E-02, 2.58007254E-02, 2.73912992E-02, 2.90741628E-02,
     *  3.08555684E-02,
     *  1.49203695E-02, 1.58257516E-02, 1.67844659E-02, 1.77990117E-02,
     *  1.88722787E-02, 2.00075444E-02, 2.12084723E-02, 2.24791110E-02,
     *  2.38238957E-02,
     *  1.24945309E-02, 1.32126610E-02, 1.39757856E-02, 1.47855988E-02,
     *  1.56441051E-02, 1.65536291E-02, 1.75168220E-02, 1.85366659E-02,
     *  1.96164777E-02,
     *  1.09086051E-02, 1.14988388E-02, 1.21284244E-02, 1.27986338E-02,
     *  1.35109668E-02, 1.42671736E-02, 1.50692707E-02, 1.59195521E-02,
     *  1.68205991E-02,
     *  9.79549827E-03, 1.02930628E-02, 1.08257134E-02, 1.13945195E-02,
     *  1.20007017E-02, 1.26456636E-02, 1.33310169E-02, 1.40586001E-02,
     *  1.48304932E-02,
     *  8.97282734E-03, 9.40051970E-03, 9.85983126E-03, 1.03517545E-02,
     *  1.08773667E-02, 1.14378680E-02, 1.20346124E-02, 1.26691331E-02,
     *  1.33431619E-02/
        DATA ((VOLMV (J,K),J=19,27),K=10,18) /
     *  8.34024404E-03, 8.71370441E-03, 9.11584577E-03, 9.54764735E-03,
     *  1.00101229E-02, 1.05043590E-02, 1.10315484E-02, 1.15930196E-02,
     *  1.21902604E-02,
     *  7.83829504E-03, 8.16869970E-03, 8.52524255E-03, 8.90891402E-03,
     *  9.32070633E-03, 9.76164653E-03, 1.02328293E-02, 1.07354468E-02,
     *  1.12708155E-02,
     *  7.42970853E-03, 7.72528480E-03, 8.04477884E-03, 8.38919482E-03,
     *  8.75952083E-03, 9.15675459E-03, 9.58193190E-03, 1.00361551E-02,
     *  1.05206201E-02,
     *  7.09004167E-03, 7.35698739E-03, 7.64590510E-03, 7.95780530E-03,
     *  8.29367547E-03, 8.65449811E-03, 9.04127332E-03, 9.45504394E-03,
     *  9.89692074E-03,
     *  6.80265727E-03, 7.04573127E-03, 7.30906922E-03, 7.59367766E-03,
     *  7.90054015E-03, 8.23062854E-03, 8.58491956E-03, 8.96441545E-03,
     *  9.37016634E-03,
     *  6.55586850E-03, 6.77878570E-03, 7.02046502E-03, 7.28189943E-03,
     *  7.56406285E-03, 7.86791601E-03, 8.19441772E-03, 8.54454078E-03,
     *  8.91929090E-03,
     *  6.34123980E-03, 6.54694349E-03, 6.77008584E-03, 7.01163875E-03,
     *  7.27256068E-03, 7.55379858E-03, 7.85629486E-03, 8.18099890E-03,
     *  8.52888235E-03,
     *  6.15253632E-03, 6.34339004E-03, 6.55051282E-03, 6.77485026E-03,
     *  7.01734048E-03, 7.27891351E-03, 7.56049483E-03, 7.86301322E-03,
     *  8.18741266E-03,
     *  5.98505268E-03, 6.16297801E-03, 6.35613524E-03, 6.56544043E-03,
     *  6.79180784E-03, 7.03614765E-03, 7.29936710E-03, 7.58237540E-03,
     *  7.88609254E-03/
        DATA ((VOLMV (J,K),J=19,27),K=19,27) /
     *  5.83517160E-03, 6.00174866E-03, 6.18263437E-03, 6.37871365E-03,
     *  6.59087457E-03, 6.82000522E-03, 7.06699313E-03, 7.33272803E-03,
     *  7.61810796E-03,
     *  5.70006630E-03, 5.85660801E-03, 6.02663326E-03, 6.21099528E-03,
     *  6.41055474E-03, 6.62617609E-03, 6.85872593E-03, 7.10907412E-03,
     *  7.37809789E-03,
     *  5.57749506E-03, 5.72510292E-03, 5.88545381E-03, 6.05936964E-03,
     *  6.24768322E-03, 6.45123447E-03, 6.67086822E-03, 6.90743405E-03,
     *  7.16178884E-03,
     *  5.46565665E-03, 5.60526290E-03, 5.75694491E-03, 5.92149410E-03,
     *  6.09971556E-03, 6.29242440E-03, 6.50044311E-03, 6.72460071E-03,
     *  6.96573401E-03,
     *  5.36308648E-03, 5.49548660E-03, 5.63935877E-03, 5.79546506E-03,
     *  5.96458345E-03, 6.14750432E-03, 6.34502770E-03, 6.55796185E-03,
     *  6.78712372E-03,
     *  5.26858088E-03, 5.39445874E-03, 5.53126028E-03, 5.67971960E-03,
     *  5.84058843E-03, 6.01463283E-03, 6.20263049E-03, 6.40536897E-03,
     *  6.62364553E-03,
     *  5.18114102E-03, 5.30108855E-03, 5.43145983E-03, 5.57296240E-03,
     *  5.72632277E-03, 5.89228334E-03, 6.07159980E-03, 6.26503921E-03,
     *  6.47337936E-03,
     *  5.09993062E-03, 5.21446347E-03, 5.33896266E-03, 5.47411064E-03,
     *  5.62060977E-03, 5.77917962E-03, 5.95055439E-03, 6.13548099E-03,
     *  6.33471806E-03,
     *  5.02424389E-03, 5.13381389E-03, 5.25293029E-03, 5.38225189E-03,
     *  5.52245808E-03, 5.67424645E-03, 5.83833038E-03, 6.01543705E-03,
     *  6.20630639E-03/
        DATA ((VOLMV (J,K),J=19,27),K=28,36) /
     *  4.95348073E-03, 5.05848590E-03, 5.17265074E-03, 5.29661173E-03,
     *  5.43102647E-03, 5.57657151E-03, 5.73394008E-03, 5.90384024E-03,
     *  6.08699360E-03,
     *  4.88712740E-03, 4.98792016E-03, 5.09751535E-03, 5.21652842E-03,
     *  5.34559634E-03, 5.48537553E-03, 5.63653989E-03, 5.79977891E-03,
     *  5.97579640E-03,
     *  4.82474139E-03, 4.92163520E-03, 5.02700051E-03, 5.14143298E-03,
     *  5.26555000E-03, 5.39998886E-03, 5.54540485E-03, 5.70246958E-03,
     *  5.87186958E-03,
     *  4.76593926E-03, 4.85921417E-03, 4.96065319E-03, 5.07083334E-03,
     *  5.19035349E-03, 5.31983270E-03, 5.45990847E-03, 5.61123515E-03,
     *  5.77448259E-03,
     *  4.71038702E-03, 4.80029422E-03, 4.89807927E-03, 5.00430165E-03,
     *  5.11954272E-03, 5.24440416E-03, 5.37950648E-03, 5.52548743E-03,
     *  5.68300075E-03,
     *  4.65779229E-03, 4.74455791E-03, 4.83893419E-03, 4.94146408E-03,
     *  5.05271232E-03, 5.17326412E-03, 5.30372371E-03, 5.44471293E-03,
     *  5.59686998E-03,
     *  4.60789789E-03, 4.69172624E-03, 4.78291531E-03, 4.88199243E-03,
     *  4.98950660E-03, 5.10602736E-03, 5.23214342E-03, 5.36846135E-03,
     *  5.51560440E-03,
     *  4.56047667E-03, 4.64155295E-03, 4.72975563E-03, 4.82559728E-03,
     *  4.92961203E-03, 5.04235448E-03, 5.16439852E-03, 5.29633611E-03,
     *  5.43877610E-03,
     *  4.51532714E-03, 4.59381974E-03, 4.67921863E-03, 4.77202244E-03,
     *  4.87275117E-03, 4.98194522E-03, 5.10016436E-03, 5.22798651E-03,
     *  5.36600671E-03/
        DATA ((VOLMV (J,K),J=19,27),K=37,45) /
     *  4.47226990E-03, 4.54833239E-03, 4.63109400E-03, 4.72104018E-03,
     *  4.81867753E-03, 4.92453296E-03, 5.03915270E-03, 5.16310128E-03,
     *  5.29696043E-03,
     *  4.43114468E-03, 4.50491746E-03, 4.58519404E-03, 4.67244739E-03,
     *  4.76717137E-03, 4.86988004E-03, 4.98110673E-03, 5.10140311E-03,
     *  5.23133816E-03,
     *  4.39180776E-03, 4.46341955E-03, 4.54135067E-03, 4.62606226E-03,
     *  4.71803608E-03, 4.81777393E-03, 4.92579685E-03, 5.04264417E-03,
     *  5.16887261E-03,
     *  4.35412990E-03, 4.42369898E-03, 4.49941291E-03, 4.58172156E-03,
     *  4.67109521E-03, 4.76802398E-03, 4.87301713E-03, 4.98660219E-03,
     *  5.10932413E-03,
     *  4.31799449E-03, 4.38562982E-03, 4.45924468E-03, 4.53927827E-03,
     *  4.62618991E-03, 4.72045860E-03, 4.82258232E-03, 4.93307731E-03,
     *  5.05247722E-03,
     *  4.28329604E-03, 4.34909821E-03, 4.42072305E-03, 4.49859960E-03,
     *  4.58317677E-03, 4.67492292E-03, 4.77432528E-03, 4.88188922E-03,
     *  4.99813754E-03,
     *  4.24993888E-03, 4.31400092E-03, 4.38373659E-03, 4.45956528E-03,
     *  4.54192595E-03, 4.63127682E-03, 4.72809479E-03, 4.83287486E-03,
     *  4.94612938E-03,
     *  4.21783596E-03, 4.28024412E-03, 4.34818409E-03, 4.42206609E-03,
     *  4.50231961E-03, 4.58939313E-03, 4.68375372E-03, 4.78588638E-03,
     *  4.89629342E-03,
     *  4.18690796E-03, 4.24774230E-03, 4.31397338E-03, 4.38600264E-03,
     *  4.46425051E-03, 4.54915622E-03, 4.64117735E-03, 4.74078935E-03,
     *  4.84848487E-03/
        DATA ((VOLMV (J,K),J=19,27),K=46,54) /
     *  4.15708236E-03, 4.21641739E-03, 4.28102031E-03, 4.35128421E-03,
     *  4.42762087E-03, 4.51046064E-03, 4.60025204E-03, 4.69746131E-03,
     *  4.80257183E-03,
     *  4.12829278E-03, 4.18619792E-03, 4.24924790E-03, 4.31782785E-03,
     *  4.39234129E-03, 4.47321005E-03, 4.56087396E-03, 4.65579043E-03,
     *  4.75843390E-03,
     *  4.10047828E-03, 4.15701832E-03, 4.21858558E-03, 4.28555756E-03,
     *  4.35832988E-03, 4.43731623E-03, 4.52294808E-03, 4.61567435E-03,
     *  4.71596089E-03,
     *  4.07358283E-03, 4.12881834E-03, 4.18896850E-03, 4.25440353E-03,
     *  4.32551148E-03, 4.40269823E-03, 4.48638723E-03, 4.57701924E-03,
     *  4.67505180E-03,
     *  4.04755480E-03, 4.10154249E-03, 4.16033699E-03, 4.22430155E-03,
     *  4.29381697E-03, 4.36928163E-03, 4.45111129E-03, 4.53973884E-03,
     *  4.63561386E-03,
     *  4.02234653E-03, 4.07513958E-03, 4.13263601E-03, 4.19519241E-03,
     *  4.26318264E-03, 4.33699788E-03, 4.41704649E-03, 4.50375379E-03,
     *  4.59756166E-03,
     *  3.99791398E-03, 4.04956230E-03, 4.10581473E-03, 4.16702147E-03,
     *  4.23354972E-03, 4.30578373E-03, 4.38412478E-03, 4.46899088E-03,
     *  4.56081650E-03,
     *  3.97421631E-03, 4.02476684E-03, 4.07982609E-03, 4.13973815E-03,
     *  4.20486382E-03, 4.27558073E-03, 4.35228329E-03, 4.43538249E-03,
     *  4.52530565E-03,
     *  3.95121568E-03, 4.00071259E-03, 4.05462649E-03, 4.11329561E-03,
     *  4.17707461E-03, 4.24633474E-03, 4.32146381E-03, 4.40286606E-03,
     *  4.49096187E-03/
        DATA ((VOLMV (J,K),J=19,27),K=55,63) /
     *  3.92887690E-03, 3.97736182E-03, 4.03017544E-03, 4.08765038E-03,
     *  4.15013539E-03, 4.21799558E-03, 4.29161241E-03, 4.37138360E-03,
     *  4.45772285E-03,
     *  3.90716723E-03, 3.95467945E-03, 4.00643532E-03, 4.06276206E-03,
     *  4.12400276E-03, 4.19051663E-03, 4.26267900E-03, 4.34088128E-03,
     *  4.42553076E-03,
     *  3.88605617E-03, 3.93263279E-03, 3.98337107E-03, 4.03859305E-03,
     *  4.09863637E-03, 4.16385454E-03, 4.23461700E-03, 4.31130909E-03,
     *  4.39433185E-03,
     *  3.86551525E-03, 3.91119136E-03, 3.96095002E-03, 4.01510829E-03,
     *  4.07399859E-03, 4.13796893E-03, 4.20738306E-03, 4.28262046E-03,
     *  4.36407614E-03,
     *  3.84551786E-03, 3.89032668E-03, 3.93914166E-03, 3.99227510E-03,
     *  4.05005434E-03, 4.11282214E-03, 4.18093676E-03, 4.25477199E-03,
     *  4.33471702E-03,
     *  3.82603913E-03, 3.87001212E-03, 3.91791748E-03, 3.97006289E-03,
     *  4.02677085E-03, 4.08837901E-03, 4.15524034E-03, 4.22772315E-03,
     *  4.30621100E-03,
     *  3.80705573E-03, 3.85022275E-03, 3.89725078E-03, 3.94844308E-03,
     *  4.00411746E-03, 4.06460666E-03, 4.13025854E-03, 4.20143611E-03,
     *  4.27851747E-03,
     *  3.78854579E-03, 3.83093520E-03, 3.87711655E-03, 3.92738887E-03,
     *  3.98206545E-03, 4.04147430E-03, 4.10595833E-03, 4.17587543E-03,
     *  4.25159842E-03,
     *  3.77048880E-03, 3.81212751E-03, 3.85749132E-03, 3.90687513E-03,
     *  3.96058791E-03, 4.01895308E-03, 4.08230878E-03, 4.15100794E-03,
     *  4.22541827E-03/
        DATA ((VOLMV (J,K),J=19,27),K=64,72) /
     *  3.75286544E-03, 3.79377908E-03, 3.83835304E-03, 3.88687828E-03,
     *  3.93965957E-03, 3.99701594E-03, 4.05928087E-03, 4.12680252E-03,
     *  4.19994364E-03,
     *  3.73565755E-03, 3.77587051E-03, 3.81968098E-03, 3.86737613E-03,
     *  3.91925670E-03, 3.97563742E-03, 4.03684735E-03, 4.10322996E-03,
     *  4.17514323E-03,
     *  3.71884804E-03, 3.75838354E-03, 3.80145564E-03, 3.84834783E-03,
     *  3.89935695E-03, 3.95479363E-03, 4.01498259E-03, 4.08026281E-03,
     *  4.15098760E-03,
     *  3.70242076E-03, 3.74130096E-03, 3.78365862E-03, 3.82977371E-03,
     *  3.87993931E-03, 3.93446205E-03, 3.99366248E-03, 4.05787522E-03,
     *  4.12744907E-03,
     *  3.68636049E-03, 3.72460653E-03, 3.76627258E-03, 3.81163525E-03,
     *  3.86098395E-03, 3.91462148E-03, 3.97286432E-03, 4.03604288E-03,
     *  4.10450158E-03,
     *  3.67065285E-03, 3.70828491E-03, 3.74928117E-03, 3.79391495E-03,
     *  3.84247217E-03, 3.89525189E-03, 3.95256668E-03, 4.01474286E-03,
     *  4.08212057E-03,
     *  3.65528424E-03, 3.69232160E-03, 3.73266890E-03, 3.77659630E-03,
     *  3.82438632E-03, 3.87633442E-03, 3.93274937E-03, 3.99395351E-03,
     *  4.06028287E-03,
     *  3.64024177E-03, 3.67670289E-03, 3.71642115E-03, 3.75966367E-03,
     *  3.80670970E-03, 3.85785120E-03, 3.91339327E-03, 3.97365440E-03,
     *  4.03896660E-03,
     *  3.62551327E-03, 3.66141579E-03, 3.70052407E-03, 3.74310229E-03,
     *  3.78942653E-03, 3.83978537E-03, 3.89448035E-03, 3.95382622E-03,
     *  4.01815110E-03/
        DATA ((VOLMV (J,K),J=19,27),K=73,81) /
     *  3.61108716E-03, 3.64644800E-03, 3.68496454E-03, 3.72689815E-03,
     *  3.77252185E-03, 3.82212095E-03, 3.87599352E-03, 3.93445069E-03,
     *  3.99781680E-03,
     *  3.59695248E-03, 3.63178782E-03, 3.66973012E-03, 3.71103799E-03,
     *  3.75598151E-03, 3.80484281E-03, 3.85791661E-03, 3.91551051E-03,
     *  3.97794520E-03,
     *  3.58309882E-03, 3.61742420E-03, 3.65480900E-03, 3.69550923E-03,
     *  3.73979206E-03, 3.78793659E-03, 3.84023427E-03, 3.89698929E-03,
     *  3.95851875E-03,
     *  3.56951627E-03, 3.60334658E-03, 3.64018998E-03, 3.68029990E-03,
     *  3.72394076E-03, 3.77138868E-03, 3.82293197E-03, 3.87887147E-03,
     *  3.93952084E-03,
     *  3.55619542E-03, 3.58954498E-03, 3.62586240E-03, 3.66539865E-03,
     *  3.70841550E-03, 3.75518616E-03, 3.80599589E-03, 3.86114231E-03,
     *  3.92093569E-03,
     *  3.54312732E-03, 3.57600987E-03, 3.61181612E-03, 3.65079470E-03,
     *  3.69320476E-03, 3.73931675E-03, 3.78941292E-03, 3.84378778E-03,
     *  3.90274831E-03,
     *  3.53030343E-03, 3.56273217E-03, 3.59804151E-03, 3.63647777E-03,
     *  3.67829760E-03, 3.72376875E-03, 3.77317059E-03, 3.82679457E-03,
     *  3.88494448E-03,
     *  3.51771564E-03, 3.54970327E-03, 3.58452938E-03, 3.62243808E-03,
     *  3.66368360E-03, 3.70853106E-03, 3.75725703E-03, 3.81015000E-03,
     *  3.86751064E-03,
     *  3.50535617E-03, 3.53691492E-03, 3.57127097E-03, 3.60866631E-03,
     *  3.64935283E-03, 3.69359309E-03, 3.74166095E-03, 3.79384201E-03,
     *  3.85043393E-03/
        DATA ((VOLMV (J,K),J=28,36),K= 1, 9) /
     *   4954.9445    ,  5275.2055    ,  5616.1664    ,  5979.1653    ,
     *   6365.6264    ,  6777.0663    ,  7215.0995    ,  7681.4448    ,
     *   8177.9321    ,
     *  9.28223185E-02, 9.87165423E-02, 0.10497995    , 0.11163732    ,
     *  0.11871500    , 0.12624100    , 0.13424508    , 0.14275890    ,
     *  0.15181613    ,
     *  4.77531391E-02, 5.07288522E-02, 5.38864451E-02, 5.72383678E-02,
     *  6.07978632E-02, 6.45790156E-02, 6.85968023E-02, 7.28671495E-02,
     *  7.74069919E-02,
     *  3.27422363E-02, 3.47413698E-02, 3.68606753E-02, 3.91083845E-02,
     *  4.14932801E-02, 4.40247250E-02, 4.67126931E-02, 4.95678050E-02,
     *  5.26013647E-02,
     *  2.52476532E-02, 2.67556083E-02, 2.83533945E-02, 3.00470666E-02,
     *  3.18431169E-02, 3.37484931E-02, 3.57706195E-02, 3.79174208E-02,
     *  4.01973478E-02,
     *  2.07599138E-02, 2.19709745E-02, 2.32540116E-02, 2.46137367E-02,
     *  2.60552318E-02, 2.75839622E-02, 2.92057914E-02, 3.09269979E-02,
     *  3.27542946E-02,
     *  1.77752869E-02, 1.87867918E-02, 1.98585984E-02, 2.09945067E-02,
     *  2.21986409E-02, 2.34754595E-02, 2.48297669E-02, 2.62667261E-02,
     *  2.77918742E-02,
     *  1.56490289E-02, 1.65168025E-02, 1.74366806E-02, 1.84118095E-02,
     *  1.94456231E-02, 2.05418527E-02, 2.17045362E-02, 2.29380299E-02,
     *  2.42470200E-02,
     *  1.40586451E-02, 1.48177563E-02, 1.56229077E-02, 1.64767592E-02,
     *  1.73822283E-02, 1.83424988E-02, 1.93610305E-02, 2.04415689E-02,
     *  2.15881563E-02/
        DATA ((VOLMV (J,K),J=28,36),K=10,18) /
     *  1.28249376E-02, 1.34989128E-02, 1.42142560E-02, 1.49732569E-02,
     *  1.57784357E-02, 1.66325528E-02, 1.75386177E-02, 1.84998997E-02,
     *  1.95199373E-02,
     *  1.18403979E-02, 1.24458217E-02, 1.30888955E-02, 1.37716220E-02,
     *  1.44962098E-02, 1.52650842E-02, 1.60808972E-02, 1.69465372E-02,
     *  1.78651390E-02,
     *  1.10366396E-02, 1.15856645E-02, 1.21693011E-02, 1.27893264E-02,
     *  1.34477012E-02, 1.41465816E-02, 1.48883303E-02, 1.56755259E-02,
     *  1.65109735E-02,
     *  1.03681063E-02, 1.08699168E-02, 1.14038008E-02, 1.19713561E-02,
     *  1.25743437E-02, 1.32147011E-02, 1.38945533E-02, 1.46162236E-02,
     *  1.53822436E-02,
     *  9.80329301E-03, 1.02650083E-02, 1.07566371E-02, 1.12796334E-02,
     *  1.18355962E-02, 1.24262829E-02, 1.30536217E-02, 1.37197225E-02,
     *  1.44268879E-02,
     *  9.31972722E-03, 9.74698288E-03, 1.02022846E-02, 1.06869706E-02,
     *  1.12025071E-02, 1.17505022E-02, 1.23327194E-02, 1.29510890E-02,
     *  1.36077190E-02,
     *  8.90095691E-03, 9.29829323E-03, 9.72203977E-03, 1.01734407E-02,
     *  1.06538525E-02, 1.11647589E-02, 1.17077843E-02, 1.22847064E-02,
     *  1.28974670E-02,
     *  8.53466712E-03, 8.90579745E-03, 9.30188892E-03, 9.72410861E-03,
     *  1.01737219E-02, 1.06521079E-02, 1.11607732E-02, 1.17013646E-02,
     *  1.22756809E-02,
     *  8.21146133E-03, 8.55946196E-03, 8.93112794E-03, 9.32756261E-03,
     *  9.74995521E-03, 1.01995962E-02, 1.06778916E-02, 1.11863757E-02,
     *  1.17267232E-02/
        DATA ((VOLMV (J,K),J=28,36),K=19,27) /
     *  7.92404888E-03, 8.25149687E-03, 8.60144235E-03, 8.97493531E-03,
     *  9.37310079E-03, 9.79715391E-03, 1.02484141E-02, 1.07283183E-02,
     *  1.12384333E-02,
     *  7.66668909E-03, 7.97576439E-03, 8.30627760E-03, 8.65923353E-03,
     *  9.03570257E-03, 9.43683524E-03, 9.86387627E-03, 1.03181779E-02,
     *  1.08012122E-02,
     *  7.43480221E-03, 7.72736470E-03, 8.04039837E-03, 8.37486924E-03,
     *  8.73180073E-03, 9.11228760E-03, 9.51750967E-03, 9.94874506E-03,
     *  1.04073827E-02,
     *  7.22469156E-03, 7.50234015E-03, 7.79957376E-03, 8.11732454E-03,
     *  8.45657515E-03, 8.81837182E-03, 9.20383767E-03, 9.61418570E-03,
     *  1.00507312E-02,
     *  7.03334161E-03, 7.29746025E-03, 7.58034831E-03, 7.88290797E-03,
     *  8.20608605E-03, 8.55088626E-03, 8.91838185E-03, 9.30972826E-03,
     *  9.72617549E-03,
     *  6.85826880E-03, 7.11006277E-03, 7.37987290E-03, 7.66857442E-03,
     *  7.97708234E-03, 8.30636275E-03, 8.65744476E-03, 9.03143274E-03,
     *  9.42951845E-03,
     *  6.69740977E-03, 6.93793462E-03, 7.19577782E-03, 7.47179008E-03,
     *  7.76685784E-03, 8.08191360E-03, 8.41794715E-03, 8.77601730E-03,
     *  9.15726367E-03,
     *  6.54903647E-03, 6.77922139E-03, 7.02607648E-03, 7.29042985E-03,
     *  7.57314203E-03, 7.87511529E-03, 8.19730415E-03, 8.54072655E-03,
     *  8.90647523E-03,
     *  6.41169101E-03, 6.63235782E-03, 6.86909124E-03, 7.12269841E-03,
     *  7.39401607E-03, 7.68391908E-03, 7.99333010E-03, 8.32323022E-03,
     *  8.67466985E-03/
        DATA ((VOLMV (J,K),J=28,36),K=28,36) /
     *  6.28413503E-03, 6.49601374E-03, 6.72339587E-03, 6.96706885E-03,
     *  7.22784743E-03, 7.50658140E-03, 7.80416449E-03, 8.12154435E-03,
     *  8.45973300E-03,
     *  6.16530998E-03, 6.36905174E-03, 6.58777030E-03, 6.82223448E-03,
     *  7.07323857E-03, 7.34160925E-03, 7.62821379E-03, 7.93396935E-03,
     *  8.25985300E-03,
     *  6.05430571E-03, 6.25049351E-03, 6.46116478E-03, 6.68707067E-03,
     *  6.92898628E-03, 7.18771686E-03, 7.46410531E-03, 7.75904091E-03,
     *  8.07346874E-03,
     *  5.95033540E-03, 6.13949308E-03, 6.34267127E-03, 6.56060426E-03,
     *  6.79404909E-03, 7.04379099E-03, 7.31065035E-03, 7.59549072E-03,
     *  7.89922785E-03,
     *  5.85271533E-03, 6.03531518E-03, 6.23150033E-03, 6.44198900E-03,
     *  6.66752108E-03, 6.90886308E-03, 7.16681439E-03, 7.44221482E-03,
     *  7.73595302E-03,
     *  5.76084857E-03, 5.93731772E-03, 6.12696244E-03, 6.33048551E-03,
     *  6.54861057E-03, 6.78208645E-03, 7.03169296E-03, 7.29824781E-03,
     *  7.58261459E-03,
     *  5.67421161E-03, 5.84493752E-03, 6.02845266E-03, 6.22544502E-03,
     *  6.43662269E-03, 6.66271783E-03, 6.90449184E-03, 7.16274184E-03,
     *  7.43830813E-03,
     *  5.59234338E-03, 5.75767854E-03, 5.93543811E-03, 6.12629586E-03,
     *  6.33094506E-03, 6.55010202E-03, 6.78451083E-03, 7.03494929E-03,
     *  7.30223598E-03,
     *  5.51483621E-03, 5.67510211E-03, 5.84744748E-03, 6.03253239E-03,
     *  6.23103591E-03, 6.44365928E-03, 6.67113020E-03, 6.91420836E-03,
     *  7.17369201E-03/
        DATA ((VOLMV (J,K),J=28,36),K=37,45) /
     *  5.44132829E-03, 5.59681895E-03, 5.76406246E-03, 5.94370572E-03,
     *  6.13641420E-03, 6.34287475E-03, 6.56379954E-03, 6.79993118E-03,
     *  7.05204883E-03,
     *  5.37149738E-03, 5.52248230E-03, 5.68491043E-03, 5.85941598E-03,
     *  6.04665135E-03, 6.24728965E-03, 6.46202829E-03, 6.69159371E-03,
     *  6.93674713E-03,
     *  5.30505552E-03, 5.45178231E-03, 5.60965841E-03, 5.77930580E-03,
     *  5.96136429E-03, 6.15649386E-03, 6.36537785E-03, 6.58872738E-03,
     *  6.82728672E-03,
     *  5.24174455E-03, 5.38444123E-03, 5.53800791E-03, 5.70305478E-03,
     *  5.88020957E-03, 6.07011963E-03, 6.27345489E-03, 6.49091191E-03,
     *  6.72321892E-03,
     *  5.18133239E-03, 5.32020934E-03, 5.46969057E-03, 5.63037486E-03,
     *  5.80287834E-03, 5.98783623E-03, 6.18590563E-03, 6.39776924E-03,
     *  6.62414009E-03,
     *  5.12360974E-03, 5.25886149E-03, 5.40446441E-03, 5.56100633E-03,
     *  5.72909214E-03, 5.90934544E-03, 6.10241103E-03, 6.30895840E-03,
     *  6.52968613E-03,
     *  5.06838740E-03, 5.20019413E-03, 5.34211070E-03, 5.49471436E-03,
     *  5.65859920E-03, 5.83437761E-03, 6.02268261E-03, 6.22417104E-03,
     *  6.43952774E-03,
     *  5.01549384E-03, 5.14402276E-03, 5.28243120E-03, 5.43128618E-03,
     *  5.59117135E-03, 5.76268834E-03, 5.94645885E-03, 6.14312763E-03,
     *  6.35336638E-03,
     *  4.96477320E-03, 5.09017977E-03, 5.22524580E-03, 5.37052845E-03,
     *  5.52660130E-03, 5.69405560E-03, 5.87350216E-03, 6.06557416E-03,
     *  6.27093076E-03/
        DATA ((VOLMV (J,K),J=28,36),K=46,54) /
     *  4.91608356E-03, 5.03851251E-03, 5.17039050E-03, 5.31226513E-03,
     *  5.46470027E-03, 5.62827717E-03, 5.80359617E-03, 5.99127931E-03,
     *  6.19197378E-03,
     *  4.86929532E-03, 4.98888166E-03, 5.11771562E-03, 5.25633557E-03,
     *  5.40529602E-03, 5.56516855E-03, 5.73654340E-03, 5.92003196E-03,
     *  6.11626991E-03,
     *  4.82428996E-03, 4.94115979E-03, 5.06708427E-03, 5.20259287E-03,
     *  5.34823102E-03, 5.50456097E-03, 5.67216327E-03, 5.85163902E-03,
     *  6.04361288E-03,
     *  4.78095883E-03, 4.89523011E-03, 5.01837101E-03, 5.15090239E-03,
     *  5.29336092E-03, 5.44629983E-03, 5.61029031E-03, 5.78592355E-03,
     *  5.97381365E-03,
     *  4.73920216E-03, 4.85098539E-03, 4.97146068E-03, 5.10114056E-03,
     *  5.24055322E-03, 5.39024318E-03, 5.55077258E-03, 5.72272311E-03,
     *  5.90669867E-03,
     *  4.69892814E-03, 4.80832697E-03, 4.92624732E-03, 5.05319368E-03,
     *  5.18968602E-03, 5.33626046E-03, 5.49347038E-03, 5.66188829E-03,
     *  5.84210832E-03,
     *  4.66005213E-03, 4.76716391E-03, 4.88263331E-03, 5.00695701E-03,
     *  5.14064705E-03, 5.28423138E-03, 5.43825496E-03, 5.60328143E-03,
     *  5.77989550E-03,
     *  4.62249599E-03, 4.72741227E-03, 4.84052853E-03, 4.96233387E-03,
     *  5.09333265E-03, 5.23404494E-03, 5.38500753E-03, 5.54677550E-03,
     *  5.71992448E-03,
     *  4.58618745E-03, 4.68899445E-03, 4.79984965E-03, 4.91923488E-03,
     *  5.04764702E-03, 5.18559851E-03, 5.33361825E-03, 5.49225306E-03,
     *  5.66206978E-03/
        DATA ((VOLMV (J,K),J=28,36),K=55,63) /
     *  4.55105958E-03, 4.65183853E-03, 4.76051953E-03, 4.87757727E-03,
     *  5.00350145E-03, 5.13879710E-03, 5.28398547E-03, 5.43960538E-03,
     *  5.60621523E-03,
     *  4.51705025E-03, 4.61587784E-03, 4.72246658E-03, 4.83728431E-03,
     *  4.96081370E-03, 5.09355262E-03, 5.23601492E-03, 5.38873168E-03,
     *  5.55225312E-03,
     *  4.48410176E-03, 4.58105044E-03, 4.68562436E-03, 4.79828471E-03,
     *  4.91950737E-03, 5.04978326E-03, 5.18961905E-03, 5.33953834E-03,
     *  5.50008345E-03,
     *  4.45216043E-03, 4.54729869E-03, 4.64993104E-03, 4.76051218E-03,
     *  4.87951143E-03, 5.00741297E-03, 5.14471649E-03, 5.29193835E-03,
     *  5.44961323E-03,
     *  4.42117623E-03, 4.51456892E-03, 4.61532903E-03, 4.72390501E-03,
     *  4.84075976E-03, 4.96637093E-03, 5.10123146E-03, 5.24585069E-03,
     *  5.40075589E-03,
     *  4.39110250E-03, 4.48281106E-03, 4.58176465E-03, 4.68840562E-03,
     *  4.80319068E-03, 4.92659111E-03, 5.05909332E-03, 5.20119982E-03,
     *  5.35343072E-03,
     *  4.36189565E-03, 4.45197836E-03, 4.54918775E-03, 4.65396028E-03,
     *  4.76674662E-03, 4.88801188E-03, 5.01823612E-03, 5.15791524E-03,
     *  5.30756241E-03,
     *  4.33351492E-03, 4.42202709E-03, 4.51755147E-03, 4.62051875E-03,
     *  4.73137377E-03, 4.85057564E-03, 4.97859825E-03, 5.11593108E-03,
     *  5.26308056E-03,
     *  4.30592213E-03, 4.39291632E-03, 4.48681191E-03, 4.58803402E-03,
     *  4.69702178E-03, 4.81422850E-03, 4.94012204E-03, 5.07518568E-03,
     *  5.21991932E-03/
        DATA ((VOLMV (J,K),J=28,36),K=64,72) /
     *  4.27908150E-03, 4.36460770E-03, 4.45692798E-03, 4.55646204E-03,
     *  4.66364349E-03, 4.77891996E-03, 4.90275350E-03, 5.03562132E-03,
     *  5.17801701E-03,
     *  4.25295947E-03, 4.33706524E-03, 4.42786110E-03, 4.52576149E-03,
     *  4.63119464E-03, 4.74460267E-03, 4.86644196E-03, 4.99718386E-03,
     *  5.13731579E-03,
     *  4.22752449E-03, 4.31025512E-03, 4.39957505E-03, 4.49589357E-03,
     *  4.59963370E-03, 4.71123219E-03, 4.83113991E-03, 4.95982250E-03,
     *  5.09776139E-03,
     *  4.20274690E-03, 4.28414558E-03, 4.37203578E-03, 4.46682183E-03,
     *  4.56892163E-03, 4.67876674E-03, 4.79680266E-03, 4.92348947E-03,
     *  5.05930279E-03,
     *  4.17859877E-03, 4.25870669E-03, 4.34521125E-03, 4.43851195E-03,
     *  4.53902172E-03, 4.64716704E-03, 4.76338821E-03, 4.88813987E-03,
     *  5.02189204E-03,
     *  4.15505380E-03, 4.23391027E-03, 4.31907129E-03, 4.41093161E-03,
     *  4.50989937E-03, 4.61639609E-03, 4.73085698E-03, 4.85373144E-03,
     *  4.98548397E-03,
     *  4.13208717E-03, 4.20972975E-03, 4.29358743E-03, 4.38405037E-03,
     *  4.48152199E-03, 4.58641902E-03, 4.69917170E-03, 4.82022432E-03,
     *  4.95003604E-03,
     *  4.10967546E-03, 4.18614006E-03, 4.26873284E-03, 4.35783948E-03,
     *  4.45385884E-03, 4.55720294E-03, 4.66829721E-03, 4.78758095E-03,
     *  4.91550811E-03,
     *  4.08779655E-03, 4.16311750E-03, 4.24448214E-03, 4.33227180E-03,
     *  4.42688086E-03, 4.52871679E-03, 4.63820030E-03, 4.75576584E-03,
     *  4.88186230E-03/
        DATA ((VOLMV (J,K),J=28,36),K=73,81) /
     *  4.06642950E-03, 4.14063967E-03, 4.22081138E-03, 4.30732168E-03,
     *  4.40056063E-03, 4.50093123E-03, 4.60884962E-03, 4.72474550E-03,
     *  4.84906284E-03,
     *  4.04555450E-03, 4.11868538E-03, 4.19769785E-03, 4.28296485E-03,
     *  4.37487219E-03, 4.47381851E-03, 4.58021550E-03, 4.69448823E-03,
     *  4.81707587E-03,
     *  4.02515280E-03, 4.09723455E-03, 4.17512010E-03, 4.25917835E-03,
     *  4.34979096E-03, 4.44735236E-03, 4.55226986E-03, 4.66496404E-03,
     *  4.78586938E-03,
     *  4.00520660E-03, 4.07626816E-03, 4.15305777E-03, 4.23594039E-03,
     *  4.32529368E-03, 4.42150790E-03, 4.52498612E-03, 4.63614453E-03,
     *  4.75541304E-03,
     *  3.98569905E-03, 4.05576817E-03, 4.13149156E-03, 4.21323036E-03,
     *  4.30135827E-03, 4.39626153E-03, 4.49833907E-03, 4.60800278E-03,
     *  4.72567811E-03,
     *  3.96661412E-03, 4.03571744E-03, 4.11040315E-03, 4.19102865E-03,
     *  4.27796379E-03, 4.37159089E-03, 4.47230481E-03, 4.58051325E-03,
     *  4.69663734E-03,
     *  3.94793659E-03, 4.01609971E-03, 4.08977516E-03, 4.16931668E-03,
     *  4.25509038E-03, 4.34747473E-03, 4.44686063E-03, 4.55365171E-03,
     *  4.66826484E-03,
     *  3.92965200E-03, 3.99689952E-03, 4.06959104E-03, 4.14807676E-03,
     *  4.23271913E-03, 4.32389286E-03, 4.42198498E-03, 4.52739514E-03,
     *  4.64053605E-03,
     *  3.91174658E-03, 3.97810214E-03, 4.04983508E-03, 4.12729211E-03,
     *  4.21083210E-03, 4.30082610E-03, 4.39765736E-03, 4.50172165E-03,
     *  4.61342762E-03/
        DATA ((VOLMV (J,K),J=37,45),K= 1, 9) /
     *   8706.5097    ,  9269.2518    ,  9868.3665    ,  10506.205    ,
     *   11185.269    ,  11908.225    ,  12677.909    ,  13497.341    ,
     *   14369.737    ,
     *  0.16145256    , 0.17170627    , 0.18261777    , 0.19423013    ,
     *  0.20658919    , 0.21974371    , 0.23374557    , 0.24864998    ,
     *  0.26451568    ,
     *  8.22343367E-02, 8.73683313E-02, 9.28293371E-02, 9.86390065E-02,
     *  0.10482037    , 0.11139791    , 0.11839768    , 0.12584739    ,
     *  0.13377650    ,
     *  5.58254010E-02, 5.92527109E-02, 6.28969071E-02, 6.67724684E-02,
     *  7.08947942E-02, 7.52802624E-02, 7.99462918E-02, 8.49114085E-02,
     *  9.01953168E-02,
     *  4.26194066E-02, 4.51931894E-02, 4.79289086E-02, 5.08374336E-02,
     *  5.39303302E-02, 5.72199034E-02, 6.07192428E-02, 6.44422717E-02,
     *  6.84037998E-02,
     *  3.46948502E-02, 3.67563128E-02, 3.89468356E-02, 4.12751053E-02,
     *  4.37503728E-02, 4.63824858E-02, 4.91819251E-02, 5.21598425E-02,
     *  5.53281023E-02,
     *  2.94111389E-02, 3.11308569E-02, 3.29577949E-02, 3.48991720E-02,
     *  3.69626840E-02, 3.91565305E-02, 4.14894437E-02, 4.39707199E-02,
     *  4.66102528E-02,
     *  2.56365370E-02, 2.71119709E-02, 2.86790880E-02, 3.03440495E-02,
     *  3.21134322E-02, 3.39942502E-02, 3.59939798E-02, 3.81205852E-02,
     *  4.03825468E-02,
     *  2.28051439E-02, 2.40972044E-02, 2.54693470E-02, 2.69269330E-02,
     *  2.84756932E-02, 3.01217467E-02, 3.18716220E-02, 3.37322790E-02,
     *  3.57111336E-02/
        DATA ((VOLMV (J,K),J=37,45),K=10,18) /
     *  2.06025493E-02, 2.17518466E-02, 2.29722449E-02, 2.42684785E-02,
     *  2.56456154E-02, 2.71090740E-02, 2.86646413E-02, 3.03184919E-02,
     *  3.20772097E-02,
     *  1.88400940E-02, 1.98750611E-02, 2.09739781E-02, 2.21410746E-02,
     *  2.33808851E-02, 2.46982638E-02, 2.60984010E-02, 2.75868398E-02,
     *  2.91694953E-02,
     *  1.73977144E-02, 1.83390366E-02, 1.93384854E-02, 2.03998751E-02,
     *  2.15273013E-02, 2.27251542E-02, 2.39981330E-02, 2.53512618E-02,
     *  2.67899058E-02,
     *  1.61953636E-02, 1.70585622E-02, 1.79750566E-02, 1.89483140E-02,
     *  1.99820626E-02, 2.10803040E-02, 2.22473263E-02, 2.34877188E-02,
     *  2.48063866E-02,
     *  1.51776225E-02, 1.59746437E-02, 1.68208912E-02, 1.77195374E-02,
     *  1.86739989E-02, 1.96879469E-02, 2.07653205E-02, 2.19103393E-02,
     *  2.31275174E-02,
     *  1.43049053E-02, 1.50451420E-02, 1.58311311E-02, 1.66657924E-02,
     *  1.75522745E-02, 1.84939649E-02, 1.94945021E-02, 2.05577878E-02,
     *  2.16879996E-02,
     *  1.35481827E-02, 1.42391551E-02, 1.49728807E-02, 1.57520605E-02,
     *  1.65796106E-02, 1.74586720E-02, 1.83926222E-02, 1.93850862E-02,
     *  2.04399491E-02,
     *  1.28856836E-02, 1.35335070E-02, 1.42214686E-02, 1.49520782E-02,
     *  1.57280486E-02, 1.65523048E-02, 1.74279952E-02, 1.83585022E-02,
     *  1.93474540E-02,
     *  1.23007605E-02, 1.29104758E-02, 1.35580292E-02, 1.42457625E-02,
     *  1.49762092E-02, 1.57521036E-02, 1.65763918E-02, 1.74522415E-02,
     *  1.83830537E-02/
        DATA ((VOLMV (J,K),J=37,45),K=19,27) /
     *  1.17804668E-02, 1.23562786E-02, 1.29678900E-02, 1.36174939E-02,
     *  1.43074647E-02, 1.50403673E-02, 1.58189678E-02, 1.66462429E-02,
     *  1.75253908E-02,
     *  1.13145828E-02, 1.18600354E-02, 1.24394683E-02, 1.30549420E-02,
     *  1.37086887E-02, 1.44031222E-02, 1.51408471E-02, 1.59246693E-02,
     *  1.67576053E-02,
     *  1.08949337E-02, 1.14130430E-02, 1.19634988E-02, 1.25482430E-02,
     *  1.31693807E-02, 1.38291897E-02, 1.45301296E-02, 1.52748519E-02,
     *  1.60662098E-02,
     *  1.05149035E-02, 1.10082570E-02, 1.15324816E-02, 1.20894129E-02,
     *  1.26810412E-02, 1.33095214E-02, 1.39771824E-02, 1.46865359E-02,
     *  1.54402870E-02,
     *  1.01690797E-02, 1.06399146E-02, 1.11402815E-02, 1.16719198E-02,
     *  1.22367163E-02, 1.28367146E-02, 1.34741246E-02, 1.41513313E-02,
     *  1.48709049E-02,
     *  9.85299263E-03, 1.03032562E-02, 1.07818307E-02, 1.12903684E-02,
     *  1.18306622E-02, 1.24046545E-02, 1.30144465E-02, 1.36623079E-02,
     *  1.43506856E-02,
     *  9.56291816E-03, 9.99431608E-03, 1.04529067E-02, 1.09402633E-02,
     *  1.14580930E-02, 1.20082458E-02, 1.25927240E-02, 1.32136912E-02,
     *  1.38734814E-02,
     *  9.29572901E-03, 9.70976383E-03, 1.01499633E-02, 1.06178286E-02,
     *  1.11149887E-02, 1.16432090E-02, 1.22044009E-02, 1.28006307E-02,
     *  1.34341287E-02,
     *  9.04877975E-03, 9.44678196E-03, 9.87000020E-03, 1.03198700E-02,
     *  1.07979484E-02, 1.13059234E-02, 1.18456226E-02, 1.24190229E-02,
     *  1.30282586E-02/
        DATA ((VOLMV (J,K),J=37,45),K=28,36) /
     *  8.81981757E-03, 9.20297096E-03, 9.61046223E-03, 1.00436667E-02,
     *  1.05040754E-02, 1.09933050E-02, 1.15131059E-02, 1.20653723E-02,
     *  1.26521499E-02,
     *  8.60691208E-03, 8.97627461E-03, 9.36915956E-03, 9.78688686E-03,
     *  1.02308870E-02, 1.07027106E-02, 1.12040368E-02, 1.17366831E-02,
     *  1.23026132E-02,
     *  8.40839972E-03, 8.76492074E-03, 9.14420478E-03, 9.54752079E-03,
     *  9.97624335E-03, 1.04318619E-02, 1.09159898E-02, 1.14303732E-02,
     *  1.19768995E-02,
     *  8.22283920E-03, 8.56737387E-03, 8.93396246E-03, 9.32382692E-03,
     *  9.73829003E-03, 1.01787847E-02, 1.06468629E-02, 1.11442047E-02,
     *  1.16726264E-02,
     *  8.04897567E-03, 8.38229700E-03, 8.73700852E-03, 9.11428867E-03,
     *  9.51541224E-03, 9.94175962E-03, 1.03948257E-02, 1.08762289E-02,
     *  1.13877191E-02,
     *  7.88571150E-03, 8.20852057E-03, 8.55209713E-03, 8.91757925E-03,
     *  9.30619718E-03, 9.71928242E-03, 1.01582767E-02, 1.06247407E-02,
     *  1.11203626E-02,
     *  7.73208249E-03, 8.04501709E-03, 8.37813368E-03, 8.73253290E-03,
     *  9.10940348E-03, 9.51003139E-03, 9.93580866E-03, 1.03882421E-02,
     *  1.08689617E-02,
     *  7.58723814E-03, 7.89088016E-03, 8.21415259E-03, 8.55812117E-03,
     *  8.92393597E-03, 9.31284041E-03, 9.72618002E-03, 1.01654111E-02,
     *  1.06321093E-02,
     *  7.45042545E-03, 7.74530723E-03, 8.05929878E-03, 8.39343331E-03,
     *  8.74882478E-03, 9.12667678E-03, 9.52829131E-03, 9.95507732E-03,
     *  1.04085591E-02/
        DATA ((VOLMV (J,K),J=37,45),K=37,45) /
     *  7.32097534E-03, 7.60758510E-03, 7.91281235E-03, 8.23765990E-03,
     *  8.58320791E-03, 8.95062267E-03, 9.34116529E-03, 9.75620021E-03,
     *  1.01972036E-02,
     *  7.19829126E-03, 7.47707786E-03, 7.77401571E-03, 8.09007915E-03,
     *  8.42631667E-03, 8.78385954E-03, 9.16393045E-03, 9.56785196E-03,
     *  9.99705477E-03,
     *  7.08183966E-03, 7.35321667E-03, 7.64230270E-03, 7.95004535E-03,
     *  8.27746336E-03, 8.62565511E-03, 8.99580712E-03, 9.38920247E-03,
     *  9.80722901E-03,
     *  6.97114187E-03, 7.23549121E-03, 7.51712945E-03, 7.81697910E-03,
     *  8.13603090E-03, 8.47535227E-03, 8.83609566E-03, 9.21950686E-03,
     *  9.62693325E-03,
     *  6.86576724E-03, 7.12344229E-03, 7.39800660E-03, 7.69035903E-03,
     *  8.00146400E-03, 8.33235971E-03, 8.68416645E-03, 9.05809480E-03,
     *  9.45545384E-03,
     *  6.76532727E-03, 7.01665562E-03, 7.28449258E-03, 7.56971472E-03,
     *  7.87326160E-03, 8.19614384E-03, 8.53945134E-03, 8.90436140E-03,
     *  9.29214680E-03,
     *  6.66947058E-03, 6.91475648E-03, 7.17618799E-03, 7.45462060E-03,
     *  7.75097039E-03, 8.06622194E-03, 8.40143637E-03, 8.75775945E-03,
     *  9.13642955E-03,
     *  6.57787857E-03, 6.81740508E-03, 7.07273062E-03, 7.34469075E-03,
     *  7.63417931E-03, 7.94215623E-03, 8.26965540E-03, 8.61779265E-03,
     *  8.98777372E-03,
     *  6.49026168E-03, 6.72429259E-03, 6.97379127E-03, 7.23957437E-03,
     *  7.52251470E-03, 7.82354878E-03, 8.14368470E-03, 8.48400988E-03,
     *  8.84569905E-03/
        DATA ((VOLMV (J,K),J=37,45),K=46,54) /
     *  6.40635618E-03, 6.63513771E-03, 6.87907004E-03, 7.13895190E-03,
     *  7.41563612E-03, 7.71003706E-03, 8.02313824E-03, 8.35600015E-03,
     *  8.70976796E-03,
     *  6.32592133E-03, 6.54968362E-03, 6.78829315E-03, 7.04253159E-03,
     *  7.31323280E-03, 7.60129006E-03, 7.90766359E-03, 8.23338820E-03,
     *  8.57958099E-03,
     *  6.24873695E-03, 6.46769546E-03, 6.70121018E-03, 6.95004657E-03,
     *  7.21502043E-03, 7.49700501E-03, 7.79693833E-03, 8.11583077E-03,
     *  8.45477265E-03,
     *  6.17460123E-03, 6.38895792E-03, 6.61759158E-03, 6.86125220E-03,
     *  7.12073841E-03, 7.39690434E-03, 7.69066691E-03, 8.00301319E-03,
     *  8.33500798E-03,
     *  6.10332889E-03, 6.31327334E-03, 6.53722658E-03, 6.77592387E-03,
     *  7.03014743E-03, 7.30073320E-03, 7.58857794E-03, 7.89464652E-03,
     *  8.21997935E-03,
     *  6.03474950E-03, 6.24045989E-03, 6.45992132E-03, 6.69385494E-03,
     *  6.94302734E-03, 7.20825710E-03, 7.49042174E-03, 7.79046492E-03,
     *  8.10940375E-03,
     *  5.96870604E-03, 6.17035003E-03, 6.38549711E-03, 6.61485499E-03,
     *  6.85917528E-03, 7.11925997E-03, 7.39596823E-03, 7.69022342E-03,
     *  8.00302040E-03,
     *  5.90505357E-03, 6.10278911E-03, 6.31378908E-03, 6.53874826E-03,
     *  6.77840398E-03, 7.03354238E-03, 7.30500502E-03, 7.59369591E-03,
     *  7.90058856E-03,
     *  5.84365811E-03, 6.03763418E-03, 6.24464476E-03, 6.46537227E-03,
     *  6.70054034E-03, 6.95091992E-03, 7.21733577E-03, 7.50067333E-03,
     *  7.80188570E-03/
        DATA ((VOLMV (J,K),J=37,45),K=55,63) /
     *  5.78439564E-03, 5.97475289E-03, 6.17792302E-03, 6.39457657E-03,
     *  6.62542406E-03, 6.87122187E-03, 7.13277869E-03, 7.41096213E-03,
     *  7.70670575E-03,
     *  5.72715113E-03, 5.91402253E-03, 6.11349299E-03, 6.32622168E-03,
     *  6.55290651E-03, 6.79428993E-03, 7.05116518E-03, 7.32438283E-03,
     *  7.61485764E-03,
     *  5.67181782E-03, 5.85532915E-03, 6.05123315E-03, 6.26017805E-03,
     *  6.48284968E-03, 6.71997710E-03, 6.97233872E-03, 7.24076876E-03,
     *  7.52616395E-03,
     *  5.61829641E-03, 5.79856680E-03, 5.99103051E-03, 6.19632526E-03,
     *  6.41512525E-03, 6.64814669E-03, 6.89615375E-03, 7.15996496E-03,
     *  7.44045972E-03,
     *  5.56649447E-03, 5.74363684E-03, 5.93277989E-03, 6.13455118E-03,
     *  6.34961374E-03, 6.57867143E-03, 6.82247477E-03, 7.08182714E-03,
     *  7.35759135E-03,
     *  5.51632582E-03, 5.69044732E-03, 5.87638320E-03, 6.07475126E-03,
     *  6.28620377E-03, 6.51143270E-03, 6.75117542E-03, 7.00622081E-03,
     *  7.27741565E-03,
     *  5.46771005E-03, 5.63891243E-03, 5.82174893E-03, 6.01682794E-03,
     *  6.22479138E-03, 6.44631976E-03, 6.68213782E-03, 6.93302043E-03,
     *  7.19979900E-03,
     *  5.42057199E-03, 5.58895196E-03, 5.76879154E-03, 5.96069006E-03,
     *  6.16527942E-03, 6.38322914E-03, 6.61525175E-03, 6.86210870E-03,
     *  7.12461652E-03,
     *  5.37484132E-03, 5.54049088E-03, 5.71743103E-03, 5.90625231E-03,
     *  6.10757702E-03, 6.32206404E-03, 6.55041416E-03, 6.79337585E-03,
     *  7.05175137E-03/
        DATA ((VOLMV (J,K),J=37,45),K=64,72) /
     *  5.33045220E-03, 5.49345892E-03, 5.66759243E-03, 5.85343481E-03,
     *  6.05159905E-03, 6.26273378E-03, 6.48752848E-03, 6.72671912E-03,
     *  6.98109416E-03,
     *  5.28734289E-03, 5.44779020E-03, 5.61920550E-03, 5.80216266E-03,
     *  5.99726571E-03, 6.20515337E-03, 6.42650421E-03, 6.66204213E-03,
     *  6.91254230E-03,
     *  5.24545541E-03, 5.40342288E-03, 5.57220428E-03, 5.75236557E-03,
     *  5.94450210E-03, 6.14924304E-03, 6.36725640E-03, 6.59925445E-03,
     *  6.84599952E-03,
     *  5.20473533E-03, 5.36029886E-03, 5.52652682E-03, 5.70397750E-03,
     *  5.89323785E-03, 6.09492782E-03, 6.30970523E-03, 6.53827111E-03,
     *  6.78137538E-03,
     *  5.16513144E-03, 5.31836351E-03, 5.48211485E-03, 5.65693633E-03,
     *  5.84340678E-03, 6.04213723E-03, 6.25377565E-03, 6.47901221E-03,
     *  6.71858484E-03,
     *  5.12659553E-03, 5.27756539E-03, 5.43891351E-03, 5.61118360E-03,
     *  5.79494661E-03, 5.99080493E-03, 6.19939703E-03, 6.42140254E-03,
     *  6.65754784E-03,
     *  5.08908218E-03, 5.23785604E-03, 5.39687115E-03, 5.56666424E-03,
     *  5.74779865E-03, 5.94086842E-03, 6.14650279E-03, 6.36537126E-03,
     *  6.59818898E-03,
     *  5.05254856E-03, 5.19918975E-03, 5.35593901E-03, 5.52332629E-03,
     *  5.70190756E-03, 5.89226875E-03, 6.09503019E-03, 6.31085155E-03,
     *  6.54043713E-03,
     *  5.01695422E-03, 5.16152341E-03, 5.31607111E-03, 5.48112074E-03,
     *  5.65722110E-03, 5.84495028E-03, 6.04491999E-03, 6.25778035E-03,
     *  6.48422518E-03/
        DATA ((VOLMV (J,K),J=37,45),K=73,81) /
     *  4.98226098E-03, 5.12481625E-03, 5.27722400E-03, 5.44000127E-03,
     *  5.61368993E-03, 5.79886048E-03, 5.99611624E-03, 6.20609811E-03,
     *  6.42948975E-03,
     *  4.94843272E-03, 5.08902974E-03, 5.23935659E-03, 5.39992410E-03,
     *  5.57126742E-03, 5.75394967E-03, 5.94856605E-03, 6.15574853E-03,
     *  6.37617092E-03,
     *  4.91543526E-03, 5.05412745E-03, 5.20243002E-03, 5.36084781E-03,
     *  5.52990943E-03, 5.71017084E-03, 5.90221937E-03, 6.10667834E-03,
     *  6.32421198E-03,
     *  4.88323624E-03, 5.02007484E-03, 5.16640748E-03, 5.32273317E-03,
     *  5.48957418E-03, 5.66747949E-03, 5.85702883E-03, 6.05883710E-03,
     *  6.27355926E-03,
     *  4.85180500E-03, 4.98683920E-03, 5.13125410E-03, 5.28554302E-03,
     *  5.45022206E-03, 5.62583346E-03, 5.81294954E-03, 6.01217703E-03,
     *  6.22416191E-03,
     *  4.82111244E-03, 4.95438951E-03, 5.09693680E-03, 5.24924211E-03,
     *  5.41181553E-03, 5.58519276E-03, 5.76993892E-03, 5.96665283E-03,
     *  6.17597171E-03,
     *  4.79113096E-03, 4.92269633E-03, 5.06342420E-03, 5.21379699E-03,
     *  5.37431897E-03, 5.54551946E-03, 5.72795659E-03, 5.92222148E-03,
     *  6.12894291E-03,
     *  4.76183434E-03, 4.89173169E-03, 5.03068648E-03, 5.17917590E-03,
     *  5.33769853E-03, 5.50677751E-03, 5.68696418E-03, 5.87884218E-03,
     *  6.08303205E-03,
     *  4.73319767E-03, 4.86146902E-03, 4.99869532E-03, 5.14534864E-03,
     *  5.30192206E-03, 5.46893268E-03, 5.64692524E-03, 5.83647612E-03,
     *  6.03819786E-03/
        DATA ((VOLMV (J,K),J=46,54),K= 1, 9) /
     *   15298.520    ,  16287.334    ,  17340.060    ,  18460.828    ,
     *   19654.037    ,  20924.369    ,  22276.808    ,  23716.662    ,
     *   25249.580    ,
     *  0.28140518    , 0.29938501    , 0.31852596    , 0.33890339    ,
     *  0.36059749    , 0.38369361    , 0.40828263    , 0.43446123    ,
     *  0.46233237    ,
     *  0.14221638    , 0.15120039    , 0.16076400    , 0.17094499    ,
     *  0.18178353    , 0.19332239    , 0.20560706    , 0.21868597    ,
     *  0.23261065    ,
     *  9.58189752E-02, 0.10180468    , 0.10817614    , 0.11495858    ,
     *  0.12217886    , 0.12986551    , 0.13804893    , 0.14676144    ,
     *  0.15603745    ,
     *  7.26195792E-02, 7.71063645E-02, 8.18819773E-02, 8.69653742E-02,
     *  9.23767205E-02, 9.81374679E-02, 0.10427044    , 0.11079991    ,
     *  0.11775172    ,
     *  5.86993257E-02, 6.22869381E-02, 6.61052200E-02, 7.01693612E-02,
     *  7.44955192E-02, 7.91008812E-02, 8.40037304E-02, 8.92235165E-02,
     *  9.47809316E-02,
     *  4.94185702E-02, 5.24068728E-02, 5.55870762E-02, 5.89718554E-02,
     *  6.25746931E-02, 6.64099312E-02, 7.04928253E-02, 7.48396036E-02,
     *  7.94675295E-02,
     *  4.27888921E-02, 4.53492284E-02, 4.80737782E-02, 5.09734170E-02,
     *  5.40597145E-02, 5.73449778E-02, 6.08422984E-02, 6.45656021E-02,
     *  6.85297021E-02,
     *  3.78160837E-02, 4.00555378E-02, 4.24384453E-02, 4.49743293E-02,
     *  4.76733222E-02, 5.05462033E-02, 5.36044392E-02, 5.68602275E-02,
     *  6.03265431E-02/
        DATA ((VOLMV (J,K),J=46,54),K=10,18) /
     *  3.39478106E-02, 3.59377674E-02, 3.80550365E-02, 4.03080868E-02,
     *  4.27059306E-02, 4.52581568E-02, 4.79749671E-02, 5.08672135E-02,
     *  5.39464404E-02,
     *  3.08526750E-02, 3.26431003E-02, 3.45479308E-02, 3.65747898E-02,
     *  3.87317915E-02, 4.10275713E-02, 4.34713169E-02, 4.60728033E-02,
     *  4.88424289E-02,
     *  2.83197902E-02, 2.99470197E-02, 3.16780998E-02, 3.35199599E-02,
     *  3.54799778E-02, 3.75660069E-02, 3.97864046E-02, 4.21500630E-02,
     *  4.46664425E-02,
     *  2.62085677E-02, 2.76998507E-02, 2.92861942E-02, 3.09739477E-02,
     *  3.27698739E-02, 3.46811734E-02, 3.67155100E-02, 3.88810395E-02,
     *  4.11864394E-02,
     *  2.44216789E-02, 2.57979741E-02, 2.72618974E-02, 2.88193061E-02,
     *  3.04764410E-02, 3.22399489E-02, 3.41169060E-02, 3.61148440E-02,
     *  3.82417772E-02,
     *  2.28896055E-02, 2.41673787E-02, 2.55264143E-02, 2.69721465E-02,
     *  2.85103677E-02, 3.01472487E-02, 3.18893612E-02, 3.37437009E-02,
     *  3.57177130E-02,
     *  2.15613689E-02, 2.27537912E-02, 2.40219636E-02, 2.53709526E-02,
     *  2.68061607E-02, 2.83333458E-02, 2.99586408E-02, 3.16885763E-02,
     *  3.35301036E-02,
     *  2.03987368E-02, 2.15165080E-02, 2.27052108E-02, 2.39695886E-02,
     *  2.53147020E-02, 2.67459463E-02, 2.82690702E-02, 2.98901963E-02,
     *  3.16158431E-02,
     *  1.93724738E-02, 2.04244046E-02, 2.15430193E-02, 2.27327758E-02,
     *  2.39984320E-02, 2.53450626E-02, 2.67780763E-02, 2.83032352E-02,
     *  2.99266753E-02/
        DATA ((VOLMV (J,K),J=46,54),K=19,27) /
     *  1.84598427E-02, 1.94532740E-02, 2.05096175E-02, 2.16330765E-02,
     *  2.28281391E-02, 2.40995943E-02, 2.54525478E-02, 2.68924409E-02,
     *  2.84250686E-02,
     *  1.76428938E-02, 1.85840066E-02, 1.95846605E-02, 2.06488304E-02,
     *  2.17807625E-02, 2.29849894E-02, 2.42663454E-02, 2.56299836E-02,
     *  2.70813939E-02,
     *  1.69072683E-02, 1.78013154E-02, 1.87518732E-02, 1.97627103E-02,
     *  2.08378547E-02, 2.19816077E-02, 2.31985585E-02, 2.44936006E-02,
     *  2.58719487E-02,
     *  1.62413434E-02, 1.70928264E-02, 1.79980815E-02, 1.89606904E-02,
     *  1.99844829E-02, 2.10735505E-02, 2.22322604E-02, 2.34652706E-02,
     *  2.47775463E-02,
     *  1.56356099E-02, 1.64484159E-02, 1.73125074E-02, 1.82312956E-02,
     *  1.92084299E-02, 2.02478108E-02, 2.13536028E-02, 2.25302496E-02,
     *  2.37824889E-02,
     *  1.50822133E-02, 1.58597216E-02, 1.66862479E-02, 1.75650474E-02,
     *  1.84996043E-02, 1.94936442E-02, 2.05511464E-02, 2.16763583E-02,
     *  2.28738097E-02,
     *  1.45746085E-02, 1.53197753E-02, 1.61118843E-02, 1.69540474E-02,
     *  1.78495970E-02, 1.88020978E-02, 1.98153592E-02, 2.08934481E-02,
     *  2.20407034E-02,
     *  1.41072981E-02, 1.48227246E-02, 1.55831858E-02, 1.63916617E-02,
     *  1.72513448E-02, 1.81656517E-02, 1.91382348E-02, 2.01729947E-02,
     *  2.12740943E-02,
     *  1.36756311E-02, 1.43636175E-02, 1.50948803E-02, 1.58722775E-02,
     *  1.66988720E-02, 1.75779435E-02, 1.85129990E-02, 1.95077856E-02,
     *  2.05663033E-02/
        DATA ((VOLMV (J,K),J=46,54),K=28,36) /
     *  1.32756456E-02, 1.39382362E-02, 1.46424774E-02, 1.53911137E-02,
     *  1.61870883E-02, 1.70335535E-02, 1.79338818E-02, 1.88916774E-02,
     *  1.99107894E-02,
     *  1.29039464E-02, 1.35429659E-02, 1.42221283E-02, 1.49440729E-02,
     *  1.57116312E-02, 1.65278371E-02, 1.73959377E-02, 1.83194047E-02,
     *  1.93019465E-02,
     *  1.25576065E-02, 1.31746905E-02, 1.38305157E-02, 1.45276231E-02,
     *  1.52687401E-02, 1.60567903E-02, 1.68949039E-02, 1.77864287E-02,
     *  1.87349420E-02,
     *  1.22340896E-02, 1.28307098E-02, 1.34647646E-02, 1.41387034E-02,
     *  1.48551563E-02, 1.56169436E-02, 1.64270862E-02, 1.72888162E-02,
     *  1.82055881E-02,
     *  1.19311871E-02, 1.25086722E-02, 1.31223715E-02, 1.37746483E-02,
     *  1.44680417E-02, 1.52052752E-02, 1.59892673E-02, 1.68231416E-02,
     *  1.77102376E-02,
     *  1.16469663E-02, 1.22065203E-02, 1.28011458E-02, 1.34331257E-02,
     *  1.41049134E-02, 1.48191416E-02, 1.55786326E-02, 1.63864080E-02,
     *  1.72456995E-02,
     *  1.13797291E-02, 1.19224462E-02, 1.24991629E-02, 1.31120864E-02,
     *  1.37635895E-02, 1.44562196E-02, 1.51927086E-02, 1.59759819E-02,
     *  1.68091698E-02,
     *  1.11279776E-02, 1.16548550E-02, 1.22147247E-02, 1.28097224E-02,
     *  1.34421451E-02, 1.41144599E-02, 1.48293131E-02, 1.55895399E-02,
     *  1.63981746E-02,
     *  1.08903848E-02, 1.14023341E-02, 1.19463272E-02, 1.25244325E-02,
     *  1.31388755E-02, 1.37920473E-02, 1.44865137E-02, 1.52250243E-02,
     *  1.60105231E-02/
        DATA ((VOLMV (J,K),J=46,54),K=37,45) /
     *  1.06657714E-02, 1.11636280E-02, 1.16926338E-02, 1.22547937E-02,
     *  1.28522656E-02, 1.34873687E-02, 1.41625926E-02, 1.48806063E-02,
     *  1.56442679E-02,
     *  1.04530860E-02, 1.09376172E-02, 1.14524525E-02, 1.19995369E-02,
     *  1.25809641E-02, 1.31989854E-02, 1.38560181E-02, 1.45546548E-02,
     *  1.52976724E-02,
     *  1.02513876E-02, 1.07232999E-02, 1.12247170E-02, 1.17575267E-02,
     *  1.23237621E-02, 1.29256102E-02, 1.35654198E-02, 1.42457107E-02,
     *  1.49691830E-02,
     *  1.00598319E-02, 1.05197774E-02, 1.10084702E-02, 1.15277442E-02,
     *  1.20795751E-02, 1.26660884E-02, 1.32895680E-02, 1.39524647E-02,
     *  1.46574055E-02,
     *  9.87765913E-03, 1.03262407E-02, 1.08028510E-02, 1.13092727E-02,
     *  1.18474267E-02, 1.24193805E-02, 1.30273560E-02, 1.36737385E-02,
     *  1.43610853E-02,
     *  9.70418379E-03, 1.01419600E-02, 1.06070824E-02, 1.11012848E-02,
     *  1.16264363E-02, 1.21845487E-02, 1.27777853E-02, 1.34084688E-02,
     *  1.40790904E-02,
     *  9.53878561E-03, 9.96627501E-03, 1.04204613E-02, 1.09030321E-02,
     *  1.14158069E-02, 1.19607447E-02, 1.25399527E-02, 1.31556940E-02,
     *  1.38103965E-02,
     *  9.38090210E-03, 9.79858684E-03, 1.02423503E-02, 1.07138359E-02,
     *  1.12148158E-02, 1.17471990E-02, 1.23130388E-02, 1.29145416E-02,
     *  1.35540750E-02,
     *  9.23002196E-03, 9.63835119E-03, 1.00721698E-02, 1.05330792E-02,
     *  1.10228064E-02, 1.15432122E-02, 1.20962990E-02, 1.26842188E-02,
     *  1.33092815E-02/
        DATA ((VOLMV (J,K),J=46,54),K=46,54) /
     *  9.08567936E-03, 9.48507214E-03, 9.90939196E-03, 1.03601999E-02,
     *  1.08391800E-02, 1.13481472E-02, 1.18890550E-02, 1.24640033E-02,
     *  1.30752469E-02,
     *  8.94744901E-03, 9.33829695E-03, 9.75353468E-03, 1.01946848E-02,
     *  1.06633904E-02, 1.11614224E-02, 1.16906874E-02, 1.22532357E-02,
     *  1.28512692E-02,
     *  8.81494186E-03, 9.19761143E-03, 9.60415706E-03, 1.00360647E-02,
     *  1.04949379E-02, 1.09825056E-02, 1.15006296E-02, 1.20513126E-02,
     *  1.26367059E-02,
     *  8.68780130E-03, 9.06263594E-03, 9.46085494E-03, 9.88390906E-03,
     *  1.03333642E-02, 1.08109091E-02, 1.13183625E-02, 1.18576813E-02,
     *  1.24309684E-02,
     *  8.56569983E-03, 8.93302185E-03, 9.32325719E-03, 9.73782293E-03,
     *  1.01782489E-02, 1.06461850E-02, 1.11434091E-02, 1.16718340E-02,
     *  1.22335159E-02,
     *  8.44833619E-03, 8.80844846E-03, 9.19102238E-03, 9.59744278E-03,
     *  1.00292048E-02, 1.04879215E-02, 1.09753308E-02, 1.14933036E-02,
     *  1.20438514E-02,
     *  8.33543276E-03, 8.68862021E-03, 9.06383590E-03, 9.46243371E-03,
     *  9.88587555E-03, 1.03357388E-02, 1.08137234E-02, 1.13216598E-02,
     *  1.18615163E-02,
     *  8.22673326E-03, 8.57326432E-03, 8.94140736E-03, 9.33248655E-03,
     *  9.74793188E-03, 1.01892865E-02, 1.06582138E-02, 1.11565054E-02,
     *  1.16860880E-02,
     *  8.12200080E-03, 8.46212860E-03, 8.82346829E-03, 9.20731551E-03,
     *  9.61506959E-03, 1.00482407E-02, 1.05084573E-02, 1.09974731E-02,
     *  1.15171752E-02/
        DATA ((VOLMV (J,K),J=46,54),K=55,63) /
     *  8.02101602E-03, 8.35497954E-03, 8.70977012E-03, 9.08665600E-03,
     *  9.48700697E-03, 9.91230158E-03, 1.03641343E-02, 1.08442230E-02,
     *  1.13544162E-02,
     *  7.92357553E-03, 8.25160063E-03, 8.60008239E-03, 8.97026266E-03,
     *  9.36348285E-03, 9.78119102E-03, 1.02249491E-02, 1.06964400E-02,
     *  1.11974752E-02,
     *  7.82949046E-03, 8.15179084E-03, 8.49419109E-03, 8.85790770E-03,
     *  9.24425472E-03, 9.65465086E-03, 1.00906266E-02, 1.05538312E-02,
     *  1.10460406E-02,
     *  7.73858521E-03, 8.05536324E-03, 8.39189725E-03, 8.74937930E-03,
     *  9.12909710E-03, 9.53244104E-03, 9.96091125E-03, 1.04161248E-02,
     *  1.08998228E-02,
     *  7.65069628E-03, 7.96214381E-03, 8.29301563E-03, 8.64448028E-03,
     *  9.01780008E-03, 9.41433811E-03, 9.83556524E-03, 1.02830672E-02,
     *  1.07585519E-02,
     *  7.56567127E-03, 7.87197030E-03, 8.19737354E-03, 8.54302683E-03,
     *  8.91016799E-03, 9.30013376E-03, 9.71436677E-03, 1.01544226E-02,
     *  1.06219768E-02,
     *  7.48336793E-03, 7.78469133E-03, 8.10480983E-03, 8.44484740E-03,
     *  8.80601823E-03, 9.18963360E-03, 9.59710887E-03, 1.00299704E-02,
     *  1.04898626E-02,
     *  7.40365332E-03, 7.70016539E-03, 8.01517389E-03, 8.34978169E-03,
     *  8.70518015E-03, 9.08265599E-03, 9.48359817E-03, 9.90950482E-03,
     *  1.03619903E-02,
     *  7.32640311E-03, 7.61826014E-03, 7.92832487E-03, 8.25767977E-03,
     *  8.60749416E-03, 8.97903102E-03, 9.37365379E-03, 9.79283331E-03,
     *  1.02381548E-02/
        DATA ((VOLMV (J,K),J=46,54),K=64,72) /
     *  7.25150084E-03, 7.53885163E-03, 7.84413082E-03, 8.16840120E-03,
     *  8.51281078E-03, 8.87859957E-03, 9.26710635E-03, 9.67977551E-03,
     *  1.01181640E-02,
     *  7.17883732E-03, 7.46182365E-03, 7.76246806E-03, 8.08181434E-03,
     *  8.42098989E-03, 8.78121250E-03, 9.16379706E-03, 9.57016239E-03,
     *  1.00018381E-02,
     *  7.10831010E-03, 7.38706714E-03, 7.68322053E-03, 7.99779565E-03,
     *  8.33189999E-03, 8.68672982E-03, 9.06357691E-03, 9.46383530E-03,
     *  9.88900807E-03,
     *  7.03982290E-03, 7.31447966E-03, 7.60627919E-03, 7.91622909E-03,
     *  8.24541756E-03, 8.59502006E-03, 8.96630595E-03, 9.36064524E-03,
     *  9.77951532E-03,
     *  6.97328522E-03, 7.24396487E-03, 7.53154151E-03, 7.83700553E-03,
     *  8.16142646E-03, 8.50595959E-03, 8.87185257E-03, 9.26045211E-03,
     *  9.67321069E-03,
     *  6.90861185E-03, 7.17543209E-03, 7.45891100E-03, 7.76002227E-03,
     *  8.07981738E-03, 8.41943206E-03, 8.78009292E-03, 9.16312407E-03,
     *  9.56995381E-03,
     *  6.84572253E-03, 7.10879591E-03, 7.38829673E-03, 7.68518257E-03,
     *  8.00048735E-03, 8.33532787E-03, 8.69091034E-03, 9.06853692E-03,
     *  9.46961245E-03,
     *  6.78454158E-03, 7.04397578E-03, 7.31961301E-03, 7.61239519E-03,
     *  7.92333928E-03, 8.25354369E-03, 8.60419482E-03, 8.97657357E-03,
     *  9.37206196E-03,
     *  6.72499757E-03, 6.98089569E-03, 7.25277893E-03, 7.54157406E-03,
     *  7.84828156E-03, 8.17398201E-03, 8.51984259E-03, 8.88712353E-03,
     *  9.27718471E-03/
        DATA ((VOLMV (J,K),J=46,54),K=73,81) /
     *  6.66702304E-03, 6.91948386E-03, 7.18771812E-03, 7.47263788E-03,
     *  7.77522765E-03, 8.09655074E-03, 8.43775561E-03, 8.80008245E-03,
     *  9.18486962E-03,
     *  6.61055422E-03, 6.85967241E-03, 7.12435833E-03, 7.40550979E-03,
     *  7.70409579E-03, 8.02116282E-03, 8.35784125E-03, 8.71535173E-03,
     *  9.09501171E-03,
     *  6.55553078E-03, 6.80139716E-03, 7.06263128E-03, 7.34011711E-03,
     *  7.63480860E-03, 7.94773594E-03, 8.28001187E-03, 8.63283808E-03,
     *  9.00751167E-03,
     *  6.50189560E-03, 6.74459732E-03, 7.00247227E-03, 7.27639100E-03,
     *  7.56729285E-03, 7.87619215E-03, 8.20418450E-03, 8.55245318E-03,
     *  8.92227550E-03,
     *  6.44959457E-03, 6.68921530E-03, 6.94382003E-03, 7.21426627E-03,
     *  7.50147915E-03, 7.80645759E-03, 8.13028056E-03, 8.47411339E-03,
     *  8.83921414E-03,
     *  6.39857637E-03, 6.63519650E-03, 6.88661647E-03, 7.15368110E-03,
     *  7.43730172E-03, 7.73846228E-03, 8.05822555E-03, 8.39773941E-03,
     *  8.75824318E-03,
     *  6.34879230E-03, 6.58248913E-03, 6.83080647E-03, 7.09457684E-03,
     *  7.37469815E-03, 7.67213979E-03, 7.98794877E-03, 8.32325600E-03,
     *  8.67928254E-03,
     *  6.30019616E-03, 6.53104399E-03, 6.77633769E-03, 7.03689779E-03,
     *  7.31360918E-03, 7.60742706E-03, 7.91938313E-03, 8.25059174E-03,
     *  8.60225618E-03,
     *  6.25274400E-03, 6.48081435E-03, 6.72316040E-03, 6.98059107E-03,
     *  7.25397853E-03, 7.54426421E-03, 7.85246487E-03, 8.17967877E-03,
     *  8.52709189E-03/
        DATA ((VOLMV (J,K),J=55,63),K= 1, 9) /
     *   26881.577    ,  28619.058    ,  30468.841    ,  32438.184    ,
     *   34534.814    ,  36766.960    ,  39143.380    ,  41673.398    ,
     *   44366.943    ,
     *  0.49200561    , 0.52359760    , 0.55723251    , 0.59304251    ,
     *  0.63116830    , 0.67175967    , 0.71497609    , 0.76098730    ,
     *  0.80997402    ,
     *  0.24743597    , 0.26322029    , 0.28002575    , 0.29791849    ,
     *  0.31696891    , 0.33725195    , 0.35884739    , 0.38184012    ,
     *  0.40632056    ,
     *  0.16591356    , 0.17642874    , 0.18762444    , 0.19954479    ,
     *  0.21223676    , 0.22575034    , 0.24013873    , 0.25545858    ,
     *  0.27177016    ,
     *  0.12515336    , 0.13303406    , 0.14142497    , 0.15035920    ,
     *  0.15987200    , 0.17000088    , 0.18078579    , 0.19226920    ,
     *  0.20449636    ,
     *  0.10069799    , 0.10699812    , 0.11370623    , 0.12084885    ,
     *  0.12845421    , 0.13655233    , 0.14517517    , 0.15435675    ,
     *  0.16413327    ,
     *  8.43949684E-02, 8.96414589E-02, 9.52277892E-02, 0.10117608    ,
     *  0.10750986    , 0.11425418    , 0.12143568    , 0.12908274    ,
     *  0.13722552    ,
     *  7.27503567E-02, 7.72443296E-02, 8.20294553E-02, 8.71247081E-02,
     *  9.25502760E-02, 9.83276398E-02, 0.10447966    , 0.11103065    ,
     *  0.11800650    ,
     *  6.40171882E-02, 6.79468447E-02, 7.21311316E-02, 7.65866651E-02,
     *  8.13311232E-02, 8.63833144E-02, 9.17632514E-02, 9.74922287E-02,
     *  0.10359291    /
        DATA ((VOLMV (J,K),J=55,63),K=10,18) /
     *  5.72249273E-02, 6.07157370E-02, 6.44327648E-02, 6.83907926E-02,
     *  7.26055461E-02, 7.70937557E-02, 8.18732214E-02, 8.69628829E-02,
     *  9.23828927E-02,
     *  5.17912551E-02, 5.49310482E-02, 5.82743245E-02, 6.18343983E-02,
     *  6.56254332E-02, 6.96624971E-02, 7.39616202E-02, 7.85398582E-02,
     *  8.34153579E-02,
     *  4.73456068E-02, 5.01982612E-02, 5.32357930E-02, 5.64703157E-02,
     *  5.99147146E-02, 6.35826972E-02, 6.74888460E-02, 7.16486752E-02,
     *  7.60786908E-02,
     *  4.36409416E-02, 4.62543663E-02, 4.90371601E-02, 5.20004351E-02,
     *  5.51560113E-02, 5.85164627E-02, 6.20951651E-02, 6.59063482E-02,
     *  6.99651510E-02,
     *  4.05062327E-02, 4.29172817E-02, 4.54845740E-02, 4.82183741E-02,
     *  5.11296008E-02, 5.42298685E-02, 5.75315319E-02, 6.10477341E-02,
     *  6.47924571E-02,
     *  3.78193199E-02, 4.00569502E-02, 4.24395703E-02, 4.49767181E-02,
     *  4.76785394E-02, 5.05558259E-02, 5.36200574E-02, 5.68834454E-02,
     *  6.03589804E-02,
     *  3.54906205E-02, 3.75779979E-02, 3.98006098E-02, 4.21673640E-02,
     *  4.46877358E-02, 4.73718043E-02, 5.02302906E-02, 5.32745987E-02,
     *  5.65168600E-02,
     *  3.34529487E-02, 3.54088958E-02, 3.74915393E-02, 3.97092353E-02,
     *  4.20708727E-02, 4.45859064E-02, 4.72643936E-02, 5.01170320E-02,
     *  5.31552011E-02,
     *  3.16549284E-02, 3.34949460E-02, 3.54541246E-02, 3.75403334E-02,
     *  3.97619432E-02, 4.21278583E-02, 4.46475500E-02, 4.73310925E-02,
     *  5.01892019E-02/
        DATA ((VOLMV (J,K),J=55,63),K=19,27) /
     *  3.00566014E-02, 3.17936068E-02, 3.36430738E-02, 3.56124380E-02,
     *  3.77096097E-02, 3.99430036E-02, 4.23215698E-02, 4.48548285E-02,
     *  4.75529061E-02,
     *  2.86264227E-02, 3.02712937E-02, 3.20226305E-02, 3.38874809E-02,
     *  3.58733430E-02, 3.79881926E-02, 4.02405141E-02, 4.26393314E-02,
     *  4.51942434E-02,
     *  2.73391571E-02, 2.89011395E-02, 3.05641906E-02, 3.23350086E-02,
     *  3.42207202E-02, 3.62289066E-02, 3.83676321E-02, 4.06454746E-02,
     *  4.30715577E-02,
     *  2.61743770E-02, 2.76613957E-02, 2.92445990E-02, 3.09303687E-02,
     *  3.27254950E-02, 3.46372019E-02, 3.66731739E-02, 3.88415846E-02,
     *  4.11511279E-02,
     *  2.51153694E-02, 2.65342684E-02, 2.80449112E-02, 2.96533914E-02,
     *  3.13661935E-02, 3.31902164E-02, 3.51327988E-02, 3.72017471E-02,
     *  3.94053643E-02,
     *  2.41483287E-02, 2.55050591E-02, 2.69494778E-02, 2.84874156E-02,
     *  3.01250770E-02, 3.18690640E-02, 3.37263998E-02, 3.57045550E-02,
     *  3.78114758E-02,
     *  2.32617509E-02, 2.45615194E-02, 2.59452585E-02, 2.74185572E-02,
     *  2.89873635E-02, 3.06580071E-02, 3.24372214E-02, 3.43321694E-02,
     *  3.63504700E-02,
     *  2.24459728E-02, 2.36933613E-02, 2.50212997E-02, 2.64351541E-02,
     *  2.79406367E-02, 2.95438261E-02, 3.12511892E-02, 3.30696058E-02,
     *  3.50063936E-02,
     *  2.16928187E-02, 2.28918800E-02, 2.41683332E-02, 2.55273389E-02,
     *  2.69743908E-02, 2.85153357E-02, 3.01563946E-02, 3.19041854E-02,
     *  3.37657477E-02/
        DATA ((VOLMV (J,K),J=55,63),K=28,36) /
     *  2.09953242E-02, 2.21496606E-02, 2.33784646E-02, 2.46867062E-02,
     *  2.60796767E-02, 2.75630081E-02, 2.91426933E-02, 3.08251079E-02,
     *  3.26170339E-02,
     *  2.03475205E-02, 2.14603479E-02, 2.26449275E-02, 2.39060517E-02,
     *  2.52488241E-02, 2.66786768E-02, 2.82013907E-02, 2.98231163E-02,
     *  3.15503962E-02,
     *  1.97442624E-02, 2.08184637E-02, 2.19618890E-02, 2.31791654E-02,
     *  2.44752209E-02, 2.58553018E-02, 2.73249914E-02, 2.88902304E-02,
     *  3.05573386E-02,
     *  1.91810908E-02, 2.02192605E-02, 2.13242944E-02, 2.25006652E-02,
     *  2.37531371E-02, 2.50867824E-02, 2.65070000E-02, 2.80195346E-02,
     *  2.96304977E-02,
     *  1.86541224E-02, 1.96586035E-02, 2.07277413E-02, 2.18658639E-02,
     *  2.30775820E-02, 2.43678050E-02, 2.57417590E-02, 2.72050054E-02,
     *  2.87634609E-02,
     *  1.81599598E-02, 1.91328753E-02, 2.01683782E-02, 2.12706606E-02,
     *  2.24441891E-02, 2.36937205E-02, 2.50243187E-02, 2.64413728E-02,
     *  2.79506169E-02,
     *  1.76956174E-02, 1.86388970E-02, 1.96428203E-02, 2.07114514E-02,
     *  2.18491215E-02, 2.30604436E-02, 2.43503291E-02, 2.57240055E-02,
     *  2.71870349E-02,
     *  1.72584610E-02, 1.81738640E-02, 1.91480814E-02, 2.01850569E-02,
     *  2.12889938E-02, 2.24643698E-02, 2.37159527E-02, 2.50488174E-02,
     *  2.64683643E-02,
     *  1.68461580E-02, 1.77352924E-02, 1.86815168E-02, 1.96886609E-02,
     *  2.07608076E-02, 2.19023066E-02, 2.31177901E-02, 2.44121894E-02,
     *  2.57907519E-02/
        DATA ((VOLMV (J,K),J=55,63),K=37,45) /
     *  1.64566349E-02, 1.73209746E-02, 1.82407758E-02, 1.92197607E-02,
     *  2.02618980E-02, 2.13714165E-02, 2.25528204E-02, 2.38109047E-02,
     *  2.51507728E-02,
     *  1.60880426E-02, 1.69289416E-02, 1.78237620E-02, 1.87761240E-02,
     *  1.97898882E-02, 2.08691689E-02, 2.20183489E-02, 2.32420945E-02,
     *  2.45453724E-02,
     *  1.57387268E-02, 1.65574321E-02, 1.74286000E-02, 1.83557538E-02,
     *  1.93426518E-02, 2.03932997E-02, 2.15119649E-02, 2.27031919E-02,
     *  2.39718177E-02,
     *  1.54072030E-02, 1.62048653E-02, 1.70536065E-02, 1.79568581E-02,
     *  1.89182807E-02, 1.99417771E-02, 2.10315053E-02, 2.21918936E-02,
     *  2.34276563E-02,
     *  1.50921354E-02, 1.58698188E-02, 1.66972670E-02, 1.75778240E-02,
     *  1.85150577E-02, 1.95127727E-02, 2.05750230E-02, 2.17061266E-02,
     *  2.29106809E-02,
     *  1.47923186E-02, 1.55510092E-02, 1.63582149E-02, 1.72171963E-02,
     *  1.81314332E-02, 1.91046365E-02, 2.01407612E-02, 2.12440204E-02,
     *  2.24188999E-02,
     *  1.45066620E-02, 1.52472752E-02, 1.60352136E-02, 1.68736585E-02,
     *  1.77660053E-02, 1.87158758E-02, 1.97271306E-02, 2.08038825E-02,
     *  2.19505113E-02,
     *  1.42341767E-02, 1.49575637E-02, 1.57271419E-02, 1.65460166E-02,
     *  1.74175027E-02, 1.83451369E-02, 1.93326896E-02, 2.03841781E-02,
     *  2.15038808E-02,
     *  1.39739637E-02, 1.46809176E-02, 1.54329806E-02, 1.62331852E-02,
     *  1.70847697E-02, 1.79911892E-02, 1.89561280E-02, 1.99835121E-02,
     *  2.10775229E-02/
        DATA ((VOLMV (J,K),J=55,63),K=46,54) /
     *  1.37252040E-02, 1.44164647E-02, 1.51518009E-02, 1.59341756E-02,
     *  1.67667533E-02, 1.76529116E-02, 1.85962520E-02, 1.96006133E-02,
     *  2.06700842E-02,
     *  1.34871500E-02, 1.41634091E-02, 1.48827553E-02, 1.56480850E-02,
     *  1.64624925E-02, 1.73292805E-02, 1.82519718E-02, 1.92343211E-02,
     *  2.02803288E-02,
     *  1.32591178E-02, 1.39210223E-02, 1.46250681E-02, 1.53740877E-02,
     *  1.61711078E-02, 1.70193597E-02, 1.79222902E-02, 1.88835740E-02,
     *  1.99071264E-02,
     *  1.30404804E-02, 1.36886369E-02, 1.43780286E-02, 1.51114268E-02,
     *  1.58917934E-02, 1.67222908E-02, 1.76062934E-02, 1.85473988E-02,
     *  1.95494408E-02,
     *  1.28306623E-02, 1.34656399E-02, 1.41409841E-02, 1.48594072E-02,
     *  1.56238089E-02, 1.64372857E-02, 1.73031421E-02, 1.82249019E-02,
     *  1.92063204E-02,
     *  1.26291338E-02, 1.32514675E-02, 1.39133341E-02, 1.46173896E-02,
     *  1.53664737E-02, 1.61636195E-02, 1.70120645E-02, 1.79152612E-02,
     *  1.88768899E-02,
     *  1.24354070E-02, 1.30455999E-02, 1.36945253E-02, 1.43847848E-02,
     *  1.51191603E-02, 1.59006241E-02, 1.67323490E-02, 1.76177192E-02,
     *  1.85603426E-02,
     *  1.22490317E-02, 1.28475578E-02, 1.34840472E-02, 1.41610490E-02,
     *  1.48812897E-02, 1.56476829E-02, 1.64633390E-02, 1.73315767E-02,
     *  1.82559340E-02,
     *  1.20695913E-02, 1.26568977E-02, 1.32814275E-02, 1.39456795E-02,
     *  1.46523266E-02, 1.54042257E-02, 1.62044276E-02, 1.70561873E-02,
     *  1.79629758E-02/
        DATA ((VOLMV (J,K),J=55,63),K=55,63) /
     *  1.18967006E-02, 1.24732092E-02, 1.30862293E-02, 1.37382109E-02,
     *  1.44317753E-02, 1.51697249E-02, 1.59550526E-02, 1.67909525E-02,
     *  1.76808307E-02,
     *  1.17300021E-02, 1.22961119E-02, 1.28980474E-02, 1.35382116E-02,
     *  1.42191763E-02, 1.49436911E-02, 1.57146932E-02, 1.65353175E-02,
     *  1.74089078E-02,
     *  1.15691640E-02, 1.21252523E-02, 1.27165055E-02, 1.33452812E-02,
     *  1.40141031E-02, 1.47256700E-02, 1.54828653E-02, 1.62887671E-02,
     *  1.71466586E-02,
     *  1.14138779E-02, 1.19603020E-02, 1.25412538E-02, 1.31590470E-02,
     *  1.38161589E-02, 1.45152392E-02, 1.52591193E-02, 1.60508222E-02,
     *  1.68935729E-02,
     *  1.12638566E-02, 1.18009552E-02, 1.23719667E-02, 1.29791623E-02,
     *  1.36249745E-02, 1.43120055E-02, 1.50430363E-02, 1.58210369E-02,
     *  1.66491758E-02,
     *  1.11188323E-02, 1.16469269E-02, 1.22083406E-02, 1.28053039E-02,
     *  1.34402057E-02, 1.41156023E-02, 1.48342261E-02, 1.55989955E-02,
     *  1.64130248E-02,
     *  1.09785554E-02, 1.14979510E-02, 1.20500924E-02, 1.26371701E-02,
     *  1.32615312E-02, 1.39256875E-02, 1.46323243E-02, 1.53843102E-02,
     *  1.61847067E-02,
     *  1.08427923E-02, 1.13537791E-02, 1.18969573E-02, 1.24744792E-02,
     *  1.30886510E-02, 1.37419416E-02, 1.44369906E-02, 1.51766184E-02,
     *  1.59638355E-02,
     *  1.07113248E-02, 1.12141787E-02, 1.17486878E-02, 1.23169674E-02,
     *  1.29212844E-02, 1.35640656E-02, 1.42479067E-02, 1.49755813E-02,
     *  1.57500503E-02/
        DATA ((VOLMV (J,K),J=55,63),K=64,72) /
     *  1.05839484E-02, 1.10789320E-02, 1.16050522E-02, 1.21643881E-02,
     *  1.27591684E-02, 1.33917796E-02, 1.40647744E-02, 1.47808811E-02,
     *  1.55430128E-02,
     *  1.04604716E-02, 1.09478351E-02, 1.14658330E-02, 1.20165097E-02,
     *  1.26020566E-02, 1.32248211E-02, 1.38873143E-02, 1.45922205E-02,
     *  1.53424063E-02,
     *  1.03407144E-02, 1.08206963E-02, 1.13308265E-02, 1.18731152E-02,
     *  1.24497179E-02, 1.30629439E-02, 1.37152641E-02, 1.44093201E-02,
     *  1.51479332E-02,
     *  1.02245079E-02, 1.06973360E-02, 1.11998411E-02, 1.17340005E-02,
     *  1.23019350E-02, 1.29059167E-02, 1.35483775E-02, 1.42319176E-02,
     *  1.49593144E-02,
     *  1.01116934E-02, 1.05775850E-02, 1.10726967E-02, 1.15989740E-02,
     *  1.21585037E-02, 1.27535221E-02, 1.33864230E-02, 1.40597663E-02,
     *  1.47762870E-02,
     *  1.00021214E-02, 1.04612841E-02, 1.09492239E-02, 1.14678552E-02,
     *  1.20192320E-02, 1.26055555E-02, 1.32291826E-02, 1.38926342E-02,
     *  1.45986039E-02,
     *  9.89565115E-03, 1.03482835E-02, 1.08292631E-02, 1.13404742E-02,
     *  1.18839387E-02, 1.24618240E-02, 1.30764510E-02, 1.37303027E-02,
     *  1.44260323E-02,
     *  9.79214986E-03, 1.02384418E-02, 1.07126638E-02, 1.12166706E-02,
     *  1.17524532E-02, 1.23221459E-02, 1.29280348E-02, 1.35725656E-02,
     *  1.42583528E-02,
     *  9.69149234E-03, 1.01316257E-02, 1.05992839E-02, 1.10962933E-02,
     *  1.16246145E-02, 1.21863498E-02, 1.27837511E-02, 1.34192285E-02,
     *  1.40953582E-02/
        DATA ((VOLMV (J,K),J=55,63),K=73,81) /
     *  9.59356031E-03, 1.00277092E-02, 1.04889895E-02, 1.09791996E-02,
     *  1.15002706E-02, 1.20542737E-02, 1.26434278E-02, 1.32701078E-02,
     *  1.39368528E-02,
     *  9.49824201E-03, 9.92657347E-03, 1.03816538E-02, 1.08652544E-02,
     *  1.13792778E-02, 1.19257646E-02, 1.25069017E-02, 1.31250298E-02,
     *  1.37826520E-02,
     *  9.40543171E-03, 9.82810580E-03, 1.02771569E-02, 1.07543301E-02,
     *  1.12615001E-02, 1.18006778E-02, 1.23740187E-02, 1.29838303E-02,
     *  1.36325807E-02,
     *  9.31502932E-03, 9.73219966E-03, 1.01753854E-02, 1.06463060E-02,
     *  1.11468088E-02, 1.16788762E-02, 1.22446329E-02, 1.28463541E-02,
     *  1.34864736E-02,
     *  9.22694006E-03, 9.63875414E-03, 1.00762318E-02, 1.05410675E-02,
     *  1.10350822E-02, 1.15602301E-02, 1.21186060E-02, 1.27124538E-02,
     *  1.33441738E-02,
     *  9.14107404E-03, 9.54767353E-03, 9.97959417E-03, 1.04385062E-02,
     *  1.09262047E-02, 1.14446163E-02, 1.19958072E-02, 1.25819900E-02,
     *  1.32055328E-02,
     *  9.05734601E-03, 9.45886707E-03, 9.88537595E-03, 1.03385192E-02,
     *  1.08200667E-02, 1.13319184E-02, 1.18761119E-02, 1.24548303E-02,
     *  1.30704095E-02,
     *  8.97567504E-03, 9.37224859E-03, 9.79348536E-03, 1.02410088E-02,
     *  1.07165641E-02, 1.12220253E-02, 1.17594023E-02, 1.23308489E-02,
     *  1.29386701E-02,
     *  8.89598424E-03, 9.28773624E-03, 9.70383524E-03, 1.01458821E-02,
     *  1.06155982E-02, 1.11148319E-02, 1.16455664E-02, 1.22099266E-02,
     *  1.28101876E-02/
        DATA ((VOLMV (J,K),J=64,72),K= 1, 9) /
     *   47234.585    ,  50287.576    ,  53537.896    ,  56998.299    ,
     *   60682.364    ,  64604.547    ,  68780.240    ,  73225.826    ,
     *   77958.752    ,
     *  0.86212864    , 0.91765596    , 0.97677403    ,  1.0397150    ,
     *   1.1067259    ,  1.1780700    ,  1.2540272    ,  1.3348958    ,
     *   1.4209931    ,
     *  0.43238491    , 0.46013562    , 0.48968174    , 0.52113935    ,
     *  0.55463203    , 0.59029137    , 0.62825740    , 0.66867926    ,
     *  0.71171568    ,
     *  0.28913766    , 0.30762938    , 0.32731803    , 0.34828104    ,
     *  0.37060080    , 0.39436505    , 0.41966716    , 0.44660656    ,
     *  0.47528909    ,
     *  0.21751542    , 0.23137762    , 0.24613752    , 0.26185318    ,
     *  0.27858644    , 0.29640308    , 0.31537317    , 0.33557128    ,
     *  0.35707679    ,
     *  0.17454327    , 0.18562776    , 0.19743040    , 0.20999765    ,
     *  0.22337897    , 0.23762703    , 0.25279788    , 0.26895118    ,
     *  0.28615044    ,
     *  0.14589616    , 0.15512885    , 0.16495998    , 0.17542828    ,
     *  0.18657498    , 0.19844397    , 0.21108197    , 0.22453870    ,
     *  0.23886711    ,
     *  0.12543476    , 0.13334475    , 0.14176766    , 0.15073671    ,
     *  0.16028724    , 0.17045689    , 0.18128570    , 0.19281630    ,
     *  0.20509409    ,
     *  0.11008940    , 0.11700737    , 0.12437413    , 0.13221874    ,
     *  0.14057215    , 0.14946729    , 0.15893920    , 0.16902520    ,
     *  0.17976499    /
        DATA ((VOLMV (J,K),J=64,72),K=10,18) /
     *  9.81546954E-02, 0.10430111    , 0.11084643    , 0.11781649    ,
     *  0.12523880    , 0.13314265    , 0.14155919    , 0.15052160    ,
     *  0.16006518    ,
     *  8.86074287E-02, 9.41366176E-02, 0.10002479    , 0.10629522    ,
     *  0.11297266    , 0.12008348    , 0.12765572    , 0.13571925    ,
     *  0.14430585    ,
     *  8.07964553E-02, 8.58206560E-02, 9.11711784E-02, 9.68691836E-02,
     *  0.10293719    , 0.10939917    , 0.11628063    , 0.12360871    ,
     *  0.13141232    ,
     *  7.42876802E-02, 7.88910736E-02, 8.37935668E-02, 8.90145646E-02,
     *  9.45747168E-02, 0.10049600    , 0.10680180    , 0.11351701    ,
     *  0.12066813    ,
     *  6.87805764E-02, 7.30279186E-02, 7.75513235E-02, 8.23687098E-02,
     *  8.74991450E-02, 9.29629204E-02, 9.87816305E-02, 0.10497826    ,
     *  0.11157726    ,
     *  6.40604823E-02, 6.80026543E-02, 7.22011399E-02, 7.66725841E-02,
     *  8.14346985E-02, 8.65063306E-02, 9.19075377E-02, 9.76596653E-02,
     *  0.10378543    ,
     *  5.99699799E-02, 6.36476876E-02, 6.75645902E-02, 7.17362290E-02,
     *  7.61791406E-02, 8.09109215E-02, 8.59502966E-02, 9.13171935E-02,
     *  9.70328197E-02,
     *  5.63910059E-02, 5.98373239E-02, 6.35078553E-02, 6.74171757E-02,
     *  7.15807938E-02, 7.60152115E-02, 8.07379885E-02, 8.57678113E-02,
     *  9.11245663E-02,
     *  5.32332772E-02, 5.64754443E-02, 5.99286031E-02, 6.36064777E-02,
     *  6.75236697E-02, 7.16957152E-02, 7.61391461E-02, 8.08715540E-02,
     *  8.59116597E-02/
        DATA ((VOLMV (J,K),J=64,72),K=19,27) /
     *  5.04265739E-02, 5.34872898E-02, 5.67472426E-02, 6.02193991E-02,
     *  6.39175550E-02, 6.78563885E-02, 7.20515173E-02, 7.65195603E-02,
     *  8.12782023E-02,
     *  4.79154597E-02, 5.08138406E-02, 5.39009385E-02, 5.71890433E-02,
     *  6.06912294E-02, 6.44214070E-02, 6.83943768E-02, 7.26258871E-02,
     *  7.71326961E-02,
     *  4.56555857E-02, 4.84078809E-02, 5.13394234E-02, 5.44618933E-02,
     *  5.77877163E-02, 6.13301117E-02, 6.51031446E-02, 6.91217802E-02,
     *  7.34019425E-02,
     *  4.36110508E-02, 4.62311890E-02, 4.90220044E-02, 5.19946260E-02,
     *  5.51608922E-02, 5.85333976E-02, 6.21255417E-02, 6.59515812E-02,
     *  7.00266859E-02,
     *  4.17524817E-02, 4.42524925E-02, 4.69153879E-02, 4.97517953E-02,
     *  5.27730199E-02, 5.59910881E-02, 5.94187945E-02, 6.30697519E-02,
     *  6.69584443E-02,
     *  4.00556138E-02, 4.24459582E-02, 4.49920703E-02, 4.77041200E-02,
     *  5.05929252E-02, 5.36699938E-02, 5.69475683E-02, 6.04386735E-02,
     *  6.41571675E-02,
     *  3.85002268E-02, 4.07900585E-02, 4.32291325E-02, 4.58271991E-02,
     *  4.85946298E-02, 5.15424573E-02, 5.46824178E-02, 5.80269974E-02,
     *  6.15894805E-02,
     *  3.70693357E-02, 3.92667105E-02, 4.16073223E-02, 4.41005360E-02,
     *  4.67563122E-02, 4.95852462E-02, 5.25986089E-02, 5.58083907E-02,
     *  5.92273482E-02,
     *  3.57485692E-02, 3.78606133E-02, 4.01103499E-02, 4.25067876E-02,
     *  4.50595079E-02, 4.77787026E-02, 5.06752129E-02, 5.37605718E-02,
     *  5.70470487E-02/
        DATA ((VOLMV (J,K),J=64,72),K=28,36) /
     *  3.45256849E-02, 3.65587332E-02, 3.87243387E-02, 4.10311802E-02,
     *  4.34884882E-02, 4.61060809E-02, 4.88944017E-02, 5.18645601E-02,
     *  5.50283747E-02,
     *  3.33901897E-02, 3.53498985E-02, 3.74373947E-02, 3.96610508E-02,
     *  4.20297714E-02, 4.45530278E-02, 4.72408942E-02, 5.01040868E-02,
     *  5.31540055E-02,
     *  3.23330381E-02, 3.42244787E-02, 3.62392646E-02, 3.83854832E-02,
     *  4.06717356E-02, 4.31071701E-02, 4.57015171E-02, 4.84651269E-02,
     *  5.14090096E-02,
     *  3.13463905E-02, 3.31741274E-02, 3.51210624E-02, 3.71950167E-02,
     *  3.94043083E-02, 4.17577841E-02, 4.42648536E-02, 4.69355256E-02,
     *  4.97804464E-02,
     *  3.04234194E-02, 3.21915753E-02, 3.40750486E-02, 3.60814115E-02,
     *  3.82187170E-02, 4.04955301E-02, 4.29209602E-02, 4.55046964E-02,
     *  4.82570452E-02,
     *  2.95581506E-02, 3.12704621E-02, 3.30944516E-02, 3.50374579E-02,
     *  3.71072859E-02, 3.93122359E-02, 4.16611362E-02, 4.41633764E-02,
     *  4.68289440E-02,
     *  2.87453344E-02, 3.04051982E-02, 3.21733203E-02, 3.40568203E-02,
     *  3.60632694E-02, 3.82007200E-02, 4.04777359E-02, 4.29034254E-02,
     *  4.54874764E-02,
     *  2.79803387E-02, 2.95908520E-02, 3.13064043E-02, 3.31339083E-02,
     *  3.50807159E-02, 3.71546457E-02, 3.93640128E-02, 4.17176608E-02,
     *  4.42249957E-02,
     *  2.72590610E-02, 2.88230557E-02, 3.04890529E-02, 3.22637707E-02,
     *  3.41543540E-02, 3.61684008E-02, 3.83139918E-02, 4.05997211E-02,
     *  4.30347290E-02/
        DATA ((VOLMV (J,K),J=64,72),K=37,45) /
     *  2.65778547E-02, 2.80979266E-02, 2.97171325E-02, 3.14420065E-02,
     *  3.32794978E-02, 3.52369965E-02, 3.73223616E-02, 3.95439516E-02,
     *  4.19106559E-02,
     *  2.59334676E-02, 2.74120022E-02, 2.89869564E-02, 3.06646905E-02,
     *  3.24519685E-02, 3.43559835E-02, 3.63843853E-02, 3.85453091E-02,
     *  4.08474072E-02,
     *  2.53229898E-02, 2.67621843E-02, 2.82952262E-02, 2.99283108E-02,
     *  3.16680269E-02, 3.35213810E-02, 3.54958244E-02, 3.75992811E-02,
     *  3.98401786E-02,
     *  2.47438101E-02, 2.61456926E-02, 2.76389816E-02, 2.92297158E-02,
     *  3.09243175E-02, 3.27296164E-02, 3.46528754E-02, 3.67018181E-02,
     *  3.88846588E-02,
     *  2.41935785E-02, 2.55600251E-02, 2.70155586E-02, 2.85660691E-02,
     *  3.02178205E-02, 3.19774745E-02, 3.38521151E-02, 3.58492756E-02,
     *  3.79769676E-02,
     *  2.36701743E-02, 2.50029238E-02, 2.64225532E-02, 2.79348109E-02,
     *  2.95458106E-02, 3.12620538E-02, 3.30904544E-02, 3.50383646E-02,
     *  3.71136034E-02,
     *  2.31716788E-02, 2.44723460E-02, 2.58577903E-02, 2.73336256E-02,
     *  2.89058222E-02, 3.05807292E-02, 3.23650983E-02, 3.42661096E-02,
     *  3.62913981E-02,
     *  2.26963521E-02, 2.39664388E-02, 2.53192974E-02, 2.67604129E-02,
     *  2.82956191E-02, 2.99311198E-02, 3.16735121E-02, 3.35298115E-02,
     *  3.55074783E-02,
     *  2.22426123E-02, 2.34835180E-02, 2.48052810E-02, 2.62132635E-02,
     *  2.77131685E-02, 2.93110613E-02, 3.10133913E-02, 3.28270172E-02,
     *  3.47592320E-02/
        DATA ((VOLMV (J,K),J=64,72),K=46,54) /
     *  2.18090183E-02, 2.30220493E-02, 2.43141076E-02, 2.56904378E-02,
     *  2.71566183E-02, 2.87185817E-02, 3.03826364E-02, 3.21554911E-02,
     *  3.40442793E-02,
     *  2.13942544E-02, 2.25806317E-02, 2.38442853E-02, 2.51903476E-02,
     *  2.66242775E-02, 2.81518805E-02, 2.97793305E-02, 3.15131924E-02,
     *  3.33604472E-02,
     *  2.09971168E-02, 2.21579835E-02, 2.33944497E-02, 2.47115399E-02,
     *  2.61145990E-02, 2.76093108E-02, 2.92017199E-02, 3.08982540E-02,
     *  3.27057478E-02,
     *  2.06165023E-02, 2.17529300E-02, 2.29633497E-02, 2.42526829E-02,
     *  2.56261647E-02, 2.70893625E-02, 2.86481971E-02, 3.03089643E-02,
     *  3.20783589E-02,
     *  2.02513976E-02, 2.13643922E-02, 2.25498367E-02, 2.38125535E-02,
     *  2.51576724E-02, 2.65906491E-02, 2.81172857E-02, 2.97437515E-02,
     *  3.14766070E-02,
     *  1.99008707E-02, 2.09913778E-02, 2.21528540E-02, 2.33900265E-02,
     *  2.47079240E-02, 2.61118951E-02, 2.76076275E-02, 2.92011695E-02,
     *  3.08989524E-02,
     *  1.95640626E-02, 2.06329721E-02, 2.17714276E-02, 2.29840649E-02,
     *  2.42758156E-02, 2.56519249E-02, 2.71179711E-02, 2.86798859E-02,
     *  3.03439765E-02,
     *  1.92401805E-02, 2.02883309E-02, 2.14046587E-02, 2.25937116E-02,
     *  2.38603279E-02, 2.52096535E-02, 2.66471611E-02, 2.81786704E-02,
     *  2.98103695E-02,
     *  1.89284916E-02, 1.99566738E-02, 2.10517163E-02, 2.22180819E-02,
     *  2.34605189E-02, 2.47840776E-02, 2.61941294E-02, 2.76963860E-02,
     *  2.92969207E-02/
        DATA ((VOLMV (J,K),J=64,72),K=55,63) /
     *  1.86283171E-02, 1.96372783E-02, 2.07118310E-02, 2.18563565E-02,
     *  2.30755162E-02, 2.43742686E-02, 2.57578872E-02, 2.72319797E-02,
     *  2.88025091E-02,
     *  1.83390279E-02, 1.93294744E-02, 2.03842894E-02, 2.15077757E-02,
     *  2.27045111E-02, 2.39793652E-02, 2.53375174E-02, 2.67844752E-02,
     *  2.83260951E-02,
     *  1.80600399E-02, 1.90326398E-02, 2.00684291E-02, 2.11716342E-02,
     *  2.23467524E-02, 2.35985678E-02, 2.49321686E-02, 2.63529659E-02,
     *  2.78667134E-02,
     *  1.77908098E-02, 1.87461964E-02, 1.97636342E-02, 2.08472762E-02,
     *  2.20015419E-02, 2.32311327E-02, 2.45410491E-02, 2.59366089E-02,
     *  2.74234667E-02,
     *  1.75308319E-02, 1.84696056E-02, 1.94693313E-02, 2.05340912E-02,
     *  2.16682295E-02, 2.28763678E-02, 2.41634218E-02, 2.55346194E-02,
     *  2.69955192E-02,
     *  1.72796350E-02, 1.82023654E-02, 1.91849858E-02, 2.02315099E-02,
     *  2.13462091E-02, 2.25336278E-02, 2.37985998E-02, 2.51462658E-02,
     *  2.65820923E-02,
     *  1.70367790E-02, 1.79440074E-02, 1.89100991E-02, 1.99390014E-02,
     *  2.10349152E-02, 2.22023105E-02, 2.34459418E-02, 2.47708655E-02,
     *  2.61824588E-02,
     *  1.68018530E-02, 1.76940940E-02, 1.86442050E-02, 1.96560692E-02,
     *  2.07338193E-02, 2.18818532E-02, 2.31048485E-02, 2.44077805E-02,
     *  2.57959395E-02,
     *  1.65744725E-02, 1.74522157E-02, 1.83868676E-02, 1.93822491E-02,
     *  2.04424271E-02, 2.15717294E-02, 2.27747596E-02, 2.40564139E-02,
     *  2.54218990E-02/
        DATA ((VOLMV (J,K),J=64,72),K=64,72) /
     *  1.63542775E-02, 1.72179891E-02, 1.81376785E-02, 1.91171063E-02,
     *  2.01602756E-02, 2.12714463E-02, 2.24551501E-02, 2.37162069E-02,
     *  2.50597422E-02,
     *  1.61409305E-02, 1.69910548E-02, 1.78962551E-02, 1.88602334E-02,
     *  1.98869309E-02, 2.09805417E-02, 2.21455280E-02, 2.33866356E-02,
     *  2.47089113E-02,
     *  1.59341147E-02, 1.67710755E-02, 1.76622381E-02, 1.86112478E-02,
     *  1.96219856E-02, 2.06985821E-02, 2.18454315E-02, 2.30672082E-02,
     *  2.43688828E-02,
     *  1.57335326E-02, 1.65577345E-02, 1.74352903E-02, 1.83697903E-02,
     *  1.93650573E-02, 2.04251599E-02, 2.15544270E-02, 2.27574630E-02,
     *  2.40391648E-02,
     *  1.55389047E-02, 1.63507339E-02, 1.72150944E-02, 1.81355231E-02,
     *  1.91157862E-02, 2.01598922E-02, 2.12721064E-02, 2.24569656E-02,
     *  2.37192950E-02,
     *  1.53499676E-02, 1.61497933E-02, 1.70013519E-02, 1.79081284E-02,
     *  1.88738338E-02, 1.99024186E-02, 2.09980860E-02, 2.21653075E-02,
     *  2.34088383E-02,
     *  1.51664733E-02, 1.59546487E-02, 1.67937816E-02, 1.76873066E-02,
     *  1.86388814E-02, 1.96523995E-02, 2.07320043E-02, 2.18821034E-02,
     *  2.31073845E-02,
     *  1.49881882E-02, 1.57650512E-02, 1.65921184E-02, 1.74727755E-02,
     *  1.84106281E-02, 1.94095148E-02, 2.04735204E-02, 2.16069906E-02,
     *  2.28145474E-02,
     *  1.48148917E-02, 1.55807658E-02, 1.63961122E-02, 1.72642687E-02,
     *  1.81887904E-02, 1.91734623E-02, 2.02223125E-02, 2.13396264E-02,
     *  2.25299621E-02/
        DATA ((VOLMV (J,K),J=64,72),K=73,81) /
     *  1.46463754E-02, 1.54015708E-02, 1.62055268E-02, 1.70615346E-02,
     *  1.79731003E-02, 1.89439568E-02, 1.99780769E-02, 2.10796874E-02,
     *  2.22532842E-02,
     *  1.44824426E-02, 1.52272565E-02, 1.60201388E-02, 1.68643355E-02,
     *  1.77633048E-02, 1.87207287E-02, 1.97405265E-02, 2.08268678E-02,
     *  2.19841881E-02,
     *  1.43229070E-02, 1.50576245E-02, 1.58397370E-02, 1.66724464E-02,
     *  1.75591641E-02, 1.85035229E-02, 1.95093897E-02, 2.05808785E-02,
     *  2.17223660E-02,
     *  1.41675923E-02, 1.48924873E-02, 1.56641216E-02, 1.64856544E-02,
     *  1.73604517E-02, 1.82920981E-02, 1.92844093E-02, 2.03414457E-02,
     *  2.14675262E-02,
     *  1.40163316E-02, 1.47316669E-02, 1.54931033E-02, 1.63037580E-02,
     *  1.71669527E-02, 1.80862254E-02, 1.90653419E-02, 2.01083100E-02,
     *  2.12193927E-02,
     *  1.38689666E-02, 1.45749948E-02, 1.53265024E-02, 1.61265658E-02,
     *  1.69784636E-02, 1.78856880E-02, 1.88519566E-02, 1.98812256E-02,
     *  2.09777037E-02,
     *  1.37253471E-02, 1.44223111E-02, 1.51641486E-02, 1.59538965E-02,
     *  1.67947913E-02, 1.76902804E-02, 1.86440343E-02, 1.96599592E-02,
     *  2.07422107E-02,
     *  1.35853307E-02, 1.42734640E-02, 1.50058804E-02, 1.57855780E-02,
     *  1.66157523E-02, 1.74998072E-02, 1.84413671E-02, 1.94442894E-02,
     *  2.05126780E-02,
     *  1.34487820E-02, 1.41283092E-02, 1.48515442E-02, 1.56214468E-02,
     *  1.64411725E-02, 1.73140829E-02, 1.82437575E-02, 1.92340059E-02,
     *  2.02888816E-02/
        DATA ((VOLMV (J,K),J=73,81),K= 1, 9) /
     *   82997.589    ,  88362.109    ,  94073.363    ,  100153.76    ,
     *   106627.17    ,  113518.98    ,  120856.23    ,  128667.74    ,
     *   136984.13    ,
     *   1.5126573    ,  1.6102481    ,  1.7141486    ,  1.8247665    ,
     *   1.9425361    ,  2.0679196    ,  2.2014090    ,  2.3435284    ,
     *   2.4948355    ,
     *  0.75753566    , 0.80631912    , 0.85825761    , 0.91355503    ,
     *  0.97242849    ,  1.0351091    ,  1.1018430    ,  1.1728920    ,
     *   1.2485351    ,
     *  0.50582742    , 0.53834151    , 0.57295907    , 0.60981603    ,
     *  0.64905715    , 0.69083651    , 0.73531815    , 0.78267672    ,
     *  0.83309816    ,
     *  0.37997423    , 0.40435355    , 0.43031056    , 0.45794720    ,
     *  0.48737206    , 0.51870069    , 0.55205613    , 0.58756937    ,
     *  0.62537986    ,
     *  0.30446329    , 0.32396172    , 0.34472235    , 0.36682676    ,
     *  0.39036180    , 0.41541994    , 0.44209961    , 0.47050560    ,
     *  0.50074947    ,
     *  0.25412355    , 0.27036801    , 0.28766436    , 0.30608058    ,
     *  0.32568905    , 0.34656683    , 0.36879595    , 0.39246373    ,
     *  0.41766316    ,
     *  0.21816735    , 0.23208753    , 0.24690937    , 0.26269114    ,
     *  0.27949490    , 0.29738668    , 0.31643681    , 0.33672013    ,
     *  0.35831635    ,
     *  0.19120087    , 0.20337782    , 0.21634376    , 0.23014968    ,
     *  0.24484987    , 0.26050214    , 0.27716800    , 0.29491296    ,
     *  0.31380674    /
        DATA ((VOLMV (J,K),J=73,81),K=10,18) /
     *  0.17022751    , 0.18104861    , 0.19257106    , 0.20484019    ,
     *  0.21790427    , 0.23181466    , 0.24662608    , 0.26239673    ,
     *  0.27918862    ,
     *  0.15344935    , 0.16318575    , 0.17355339    , 0.18459308    ,
     *  0.19634825    , 0.20886514    , 0.22219298    , 0.23638418    ,
     *  0.25149452    ,
     *  0.13972221    , 0.14857113    , 0.15799393    , 0.16802769    ,
     *  0.17871193    , 0.19008867    , 0.20220266    , 0.21510157    ,
     *  0.22883609    ,
     *  0.12828335    , 0.13639269    , 0.14502810    , 0.15422359    ,
     *  0.16401537    , 0.17444197    , 0.18554442    , 0.19736640    ,
     *  0.20995440    ,
     *  0.11860468    , 0.12608822    , 0.13405738    , 0.14254356    ,
     *  0.15158017    , 0.16120280    , 0.17144932    , 0.18236004    ,
     *  0.19397789    ,
     *  0.11030901    , 0.11725615    , 0.12465423    , 0.13253242    ,
     *  0.14092174    , 0.14985525    , 0.15936810    , 0.16949774    ,
     *  0.18028402    ,
     *  0.10311975    , 0.10960200    , 0.11650514    , 0.12385640    ,
     *  0.13168473    , 0.14002099    , 0.14889799    , 0.15835068    ,
     *  0.16841626    ,
     *  9.68294179E-02, 0.10290489    , 0.10937496    , 0.11626515    ,
     *  0.12360261    , 0.13141627    , 0.13973690    , 0.14859725    ,
     *  0.15803222    ,
     *  9.12793866E-02, 9.69959388E-02, 0.10308388    , 0.10956724    ,
     *  0.11647158    , 0.12382412    , 0.13165382    , 0.13999152    ,
     *  0.14887005    /
        DATA ((VOLMV (J,K),J=73,81),K=19,27) /
     *  8.63462638E-02, 9.17437740E-02, 9.74920505E-02, 0.10361378    ,
     *  0.11013312    , 0.11707577    , 0.12446908    , 0.13234220    ,
     *  0.14072612    ,
     *  8.19326371E-02, 8.70446891E-02, 9.24890505E-02, 9.82872190E-02,
     *  0.10446208    , 0.11103798    , 0.11804084    , 0.12549827    ,
     *  0.13343963    ,
     *  7.79605771E-02, 8.28157172E-02, 8.79865546E-02, 9.34935149E-02,
     *  9.93583379E-02, 0.10560416    , 0.11225562    , 0.11933892    ,
     *  0.12688198    ,
     *  7.43669978E-02, 7.89896949E-02, 8.39130582E-02, 8.91565435E-02,
     *  9.47408579E-02, 0.10068804    , 0.10702155    , 0.11376636    ,
     *  0.12094905    ,
     *  7.11002836E-02, 7.55116704E-02, 8.02100576E-02, 8.52140196E-02,
     *  9.05433248E-02, 9.62190134E-02, 0.10226348    , 0.10870056    ,
     *  0.11555563    ,
     *  6.81177956E-02, 7.23362486E-02, 7.68292236E-02, 8.16144903E-02,
     *  8.67109600E-02, 9.21387606E-02, 9.79193151E-02, 0.10407543    ,
     *  0.11063137    ,
     *  6.53840014E-02, 6.94256004E-02, 7.37302820E-02, 7.83150780E-02,
     *  8.31981147E-02, 8.83986833E-02, 9.39373163E-02, 9.98358683E-02,
     *  0.10611760    ,
     *  6.28690538E-02, 6.67479494E-02, 7.08794023E-02, 7.52797659E-02,
     *  7.99664437E-02, 8.49579578E-02, 9.02740216E-02, 9.59356169E-02,
     *  0.10196508    ,
     *  6.05476977E-02, 6.42764080E-02, 6.82479590E-02, 7.24780779E-02,
     *  7.69835014E-02, 8.17820414E-02, 8.68926551E-02, 9.23355196E-02,
     *  9.81321106E-02/
        DATA ((VOLMV (J,K),J=73,81),K=28,36) /
     *  5.83984192E-02, 6.19880718E-02, 6.58115673E-02, 6.98840532E-02,
     *  7.42216487E-02, 7.88415085E-02, 8.37618897E-02, 8.90022239E-02,
     *  9.45831932E-02,
     *  5.64027783E-02, 5.98633087E-02, 6.35493261E-02, 6.74754396E-02,
     *  7.16571953E-02, 7.61111375E-02, 8.08548733E-02, 8.59071423E-02,
     *  9.12878896E-02,
     *  5.45448782E-02, 5.78851944E-02, 6.14432170E-02, 6.52330541E-02,
     *  6.92697182E-02, 7.35691853E-02, 7.81484576E-02, 8.30256303E-02,
     *  8.82199624E-02,
     *  5.28109419E-02, 5.60390613E-02, 5.94776244E-02, 6.31402717E-02,
     *  6.70415177E-02, 7.11968082E-02, 7.56225808E-02, 8.03363293E-02,
     *  8.53566726E-02,
     *  5.11889699E-02, 5.43121344E-02, 5.76389474E-02, 6.11826123E-02,
     *  6.49571779E-02, 6.89775939E-02, 7.32597697E-02, 7.78206368E-02,
     *  8.26782151E-02,
     *  4.96684630E-02, 5.26932354E-02, 5.59152854E-02, 5.93474061E-02,
     *  6.30032099E-02, 6.68971815E-02, 7.10447353E-02, 7.54622755E-02,
     *  8.01672607E-02,
     *  4.82401943E-02, 5.11725414E-02, 5.42961803E-02, 5.76235190E-02,
     *  6.11677598E-02, 6.49429510E-02, 6.89640417E-02, 7.32469411E-02,
     *  7.78085804E-02,
     *  4.68960228E-02, 4.97413849E-02, 5.27724042E-02, 5.60011266E-02,
     *  5.94403685E-02, 6.31037670E-02, 6.70058340E-02, 7.11620123E-02,
     *  7.55887371E-02,
     *  4.56287377E-02, 4.83920889E-02, 5.13357842E-02, 5.44715276E-02,
     *  5.78117719E-02, 6.13697669E-02, 6.51596118E-02, 6.91963102E-02,
     *  7.34958294E-02/
        DATA ((VOLMV (J,K),J=73,81),K=37,45) /
     *  4.44319295E-02, 4.71178298E-02, 4.99790552E-02, 5.30269874E-02,
     *  5.62737356E-02, 5.97321838E-02, 6.34160416E-02, 6.73398979E-02,
     *  7.15192780E-02,
     *  4.32998818E-02, 4.59125213E-02, 4.86957377E-02, 5.16606076E-02,
     *  5.48189152E-02, 5.81831987E-02, 6.17667991E-02, 6.55839129E-02,
     *  6.96496476E-02,
     *  4.22274798E-02, 4.47707181E-02, 4.74800343E-02, 5.03662159E-02,
     *  5.34407395E-02, 5.67158155E-02, 6.02044359E-02, 6.39204255E-02,
     *  6.78784961E-02,
     *  4.12101333E-02, 4.36875333E-02, 4.63267422E-02, 4.91382733E-02,
     *  5.21333114E-02, 5.53237558E-02, 5.87222678E-02, 6.23423195E-02,
     *  6.61982470E-02,
     *  4.02437113E-02, 4.26585687E-02, 4.52311788E-02, 4.79717945E-02,
     *  5.08913232E-02, 5.40013692E-02, 5.73142790E-02, 6.08431900E-02,
     *  6.46020817E-02,
     *  3.93244857E-02, 4.16798553E-02, 4.41891185E-02, 4.68622806E-02,
     *  4.97099854E-02, 5.27435562E-02, 5.59750406E-02, 5.94172574E-02,
     *  6.30838468E-02,
     *  3.84490837E-02, 4.07478021E-02, 4.31967381E-02, 4.58056613E-02,
     *  4.85849644E-02, 5.15457033E-02, 5.46996408E-02, 5.80592922E-02,
     *  6.16379749E-02,
     *  3.76144460E-02, 3.98591520E-02, 4.22505700E-02, 4.47982449E-02,
     *  4.75123299E-02, 5.04036260E-02, 5.34836245E-02, 5.67645515E-02,
     *  6.02594165E-02,
     *  3.68177917E-02, 3.90109443E-02, 4.13474621E-02, 4.38366754E-02,
     *  4.64885089E-02, 4.93135204E-02, 5.23229418E-02, 5.55287236E-02,
     *  5.89435812E-02/
        DATA ((VOLMV (J,K),J=73,81),K=46,54) /
     *  3.60565869E-02, 3.82004813E-02, 4.04845422E-02, 4.29178950E-02,
     *  4.55102460E-02, 4.82719205E-02, 5.12139029E-02, 5.43478801E-02,
     *  5.76862865E-02,
     *  3.53285183E-02, 3.74253001E-02, 3.96591881E-02, 4.20391118E-02,
     *  4.45745687E-02, 4.72756618E-02, 5.01531387E-02, 5.32184341E-02,
     *  5.64837139E-02,
     *  3.46314693E-02, 3.66831471E-02, 3.88690007E-02, 4.11977717E-02,
     *  4.36787578E-02, 4.63218492E-02, 4.91375669E-02, 5.21371040E-02,
     *  5.53323696E-02,
     *  3.39634997E-02, 3.59719569E-02, 3.81117808E-02, 4.03915333E-02,
     *  4.28203206E-02, 4.54078289E-02, 4.81643621E-02, 5.11008819E-02,
     *  5.42290510E-02,
     *  3.33228280E-02, 3.52898324E-02, 3.73855088E-02, 3.96182463E-02,
     *  4.19969677E-02, 4.45311635E-02, 4.72309293E-02, 5.01070050E-02,
     *  5.31708170E-02,
     *  3.27078148E-02, 3.46350286E-02, 3.66883267E-02, 3.88759328E-02,
     *  4.12065932E-02, 4.36896110E-02, 4.63348816E-02, 4.91529320E-02,
     *  5.21549620E-02,
     *  3.21169497E-02, 3.40059371E-02, 3.60185221E-02, 3.81627695E-02,
     *  4.04472562E-02, 4.28811048E-02, 4.54740188E-02, 4.82363207E-02,
     *  5.11789922E-02,
     *  3.15488383E-02, 3.34010734E-02, 3.53745146E-02, 3.74770738E-02,
     *  3.97171651E-02, 4.21037377E-02, 4.46463104E-02, 4.73550090E-02,
     *  5.02406059E-02,
     *  3.10021915E-02, 3.28190650E-02, 3.47548429E-02, 3.68172900E-02,
     *  3.90146636E-02, 4.13557461E-02, 4.38498787E-02, 4.65069981E-02,
     *  4.93376750E-02/
        DATA ((VOLMV (J,K),J=73,81),K=55,63) /
     *  3.04758157E-02, 3.22586411E-02, 3.41581541E-02, 3.61819774E-02,
     *  3.83382179E-02, 4.06354973E-02, 4.30829856E-02, 4.56904373E-02,
     *  4.84682293E-02,
     *  2.99686041E-02, 3.17186234E-02, 3.35831934E-02, 3.55698005E-02,
     *  3.76864061E-02, 3.99414772E-02, 4.23440190E-02, 4.49036105E-02,
     *  4.76304415E-02,
     *  2.94795290E-02, 3.11979176E-02, 3.30287960E-02, 3.49795189E-02,
     *  3.70579077E-02, 3.92722799E-02, 4.16314821E-02, 4.41449240E-02,
     *  4.68226151E-02,
     *  2.90076349E-02, 3.06955064E-02, 3.24938787E-02, 3.44099794E-02,
     *  3.64514947E-02, 3.86265983E-02, 4.09439833E-02, 4.34128962E-02,
     *  4.60431725E-02,
     *  2.85520321E-02, 3.02104426E-02, 3.19774329E-02, 3.38601083E-02,
     *  3.58660241E-02, 3.80032152E-02, 4.02802267E-02, 4.27061474E-02,
     *  4.52906452E-02,
     *  2.81118914E-02, 2.97418433E-02, 3.14785187E-02, 3.33289046E-02,
     *  3.53004302E-02, 3.74009961E-02, 3.96390044E-02, 4.20233918E-02,
     *  4.45636638E-02,
     *  2.76864387E-02, 2.92888843E-02, 3.09962587E-02, 3.28154342E-02,
     *  3.47537185E-02, 3.68188821E-02, 3.90191892E-02, 4.13634291E-02,
     *  4.38609507E-02,
     *  2.72749508E-02, 2.88507955E-02, 3.05298329E-02, 3.23188243E-02,
     *  3.42249596E-02, 3.62558838E-02, 3.84197275E-02, 4.07251377E-02,
     *  4.31813116E-02,
     *  2.68767512E-02, 2.84268568E-02, 3.00784743E-02, 3.18382583E-02,
     *  3.37132841E-02, 3.57110756E-02, 3.78396339E-02, 4.01074684E-02,
     *  4.25236296E-02/
        DATA ((VOLMV (J,K),J=73,81),K=64,72) /
     *  2.64912062E-02, 2.80163934E-02, 2.96414649E-02, 3.13729714E-02,
     *  3.32178779E-02, 3.51835906E-02, 3.72779856E-02, 3.95094387E-02,
     *  4.18868586E-02,
     *  2.61177218E-02, 2.76187729E-02, 2.92181312E-02, 3.09222467E-02,
     *  3.27379776E-02, 3.46726162E-02, 3.67339172E-02, 3.89301274E-02,
     *  4.12700179E-02,
     *  2.57557408E-02, 2.72334020E-02, 2.88078413E-02, 3.04854116E-02,
     *  3.22728671E-02, 3.41773898E-02, 3.62066169E-02, 3.83686701E-02,
     *  4.06721872E-02,
     *  2.54047394E-02, 2.68597229E-02, 2.84100017E-02, 3.00618339E-02,
     *  3.18218733E-02, 3.36971949E-02, 3.56953219E-02, 3.78242547E-02,
     *  4.00925018E-02,
     *  2.50642253E-02, 2.64972117E-02, 2.80240542E-02, 2.96509194E-02,
     *  3.13843636E-02, 3.32313580E-02, 3.51993151E-02, 3.72961176E-02,
     *  3.95301489E-02,
     *  2.47337352E-02, 2.61453748E-02, 2.76494735E-02, 2.92521088E-02,
     *  3.09597426E-02, 3.27792449E-02, 3.47179214E-02, 3.67835403E-02,
     *  3.89843633E-02,
     *  2.44128325E-02, 2.58037475E-02, 2.72857647E-02, 2.88648754E-02,
     *  3.05474492E-02, 3.23402586E-02, 3.42505049E-02, 3.62858456E-02,
     *  3.84544242E-02,
     *  2.41011058E-02, 2.54718917E-02, 2.69324614E-02, 2.84887223E-02,
     *  3.01469546E-02, 3.19138359E-02, 3.37964662E-02, 3.58023954E-02,
     *  3.79396521E-02,
     *  2.37981666E-02, 2.51493938E-02, 2.65891233E-02, 2.81231807E-02,
     *  2.97577597E-02, 3.14994455E-02, 3.33552396E-02, 3.53325872E-02,
     *  3.74394057E-02/
        DATA ((VOLMV (J,K),J=73,81),K=73,81) /
     *  2.35036483E-02, 2.48358634E-02, 2.62553346E-02, 2.77678081E-02,
     *  2.93793932E-02, 3.10965854E-02, 3.29262906E-02, 3.48758523E-02,
     *  3.69530793E-02,
     *  2.32172042E-02, 2.45309314E-02, 2.59307022E-02, 2.74221858E-02,
     *  2.90114096E-02, 3.07047813E-02, 3.25091143E-02, 3.44316528E-02,
     *  3.64801005E-02,
     *  2.29385063E-02, 2.42342485E-02, 2.56148545E-02, 2.70859183E-02,
     *  2.86533873E-02, 3.03235847E-02, 3.21032330E-02, 3.39994803E-02,
     *  3.60199278E-02,
     *  2.26672444E-02, 2.39454844E-02, 2.53074395E-02, 2.67586307E-02,
     *  2.83049276E-02, 2.99525706E-02, 3.17081944E-02, 3.35788533E-02,
     *  3.55720486E-02,
     *  2.24031243E-02, 2.36643259E-02, 2.50081238E-02, 2.64399680E-02,
     *  2.79656524E-02, 2.95913367E-02, 3.13235700E-02, 3.31693155E-02,
     *  3.51359771E-02,
     *  2.21458672E-02, 2.33904762E-02, 2.47165915E-02, 2.61295938E-02,
     *  2.76352034E-02, 2.92395016E-02, 3.09489538E-02, 3.27704345E-02,
     *  3.47112530E-02,
     *  2.18952088E-02, 2.31236536E-02, 2.44325426E-02, 2.58271889E-02,
     *  2.73132408E-02, 2.88967032E-02, 3.05839604E-02, 3.23818001E-02,
     *  3.42974395E-02,
     *  2.16508979E-02, 2.28635909E-02, 2.41556926E-02, 2.55324501E-02,
     *  2.69994418E-02, 2.85625981E-02, 3.02282240E-02, 3.20030228E-02,
     *  3.38941219E-02,
     *  2.14126960E-02, 2.26100341E-02, 2.38857709E-02, 2.52450894E-02,
     *  2.66934998E-02, 2.82368598E-02, 2.98813970E-02, 3.16337326E-02,
     *  3.35009063E-02/
        DATA ((ENTHV (J,K),J= 1, 9),K= 1, 9) /
     *   57146.440    ,  60503.328    ,  64077.184    ,  67882.030    ,
     *   71932.799    ,  76245.384    ,  80836.709    ,  85724.790    ,
     *   90928.808    ,
     *   37718.900    ,  42654.714    ,  47769.888    ,  53045.613    ,
     *   58481.163    ,  64087.743    ,  69883.978    ,  75892.810    ,
     *   82139.597    ,
     *   35158.815    ,  38969.595    ,  43217.057    ,  47898.603    ,
     *   52996.632    ,  58485.922    ,  64341.817    ,  70545.548    ,
     *   77086.197    ,
     *   38532.831    ,  41751.828    ,  45351.119    ,  49359.145    ,
     *   53799.293    ,  58687.570    ,  64031.380    ,  69830.186    ,
     *   76078.067    ,
     *   43131.976    ,  46061.682    ,  49331.878    ,  52971.640    ,
     *   57009.549    ,  61472.488    ,  66384.221    ,  71764.036    ,
     *   77625.868    ,
     *   48125.443    ,  50876.876    ,  53945.752    ,  57359.367    ,
     *   61145.624    ,  65332.535    ,  69947.510    ,  75016.480    ,
     *   80562.924    ,
     *   53272.545    ,  55897.963    ,  58826.130    ,  62082.845    ,
     *   65694.801    ,  69689.377    ,  74094.297    ,  78937.158    ,
     *   84244.821    ,
     *   58479.434    ,  61008.082    ,  63829.243    ,  66967.618    ,
     *   70448.876    ,  74299.571    ,  78546.979    ,  83218.847    ,
     *   88343.046    ,
     *   63702.903    ,  66153.168    ,  68888.311    ,  71932.227    ,
     *   75309.792    ,  79046.831    ,  83170.056    ,  87706.935    ,
     *   92685.490    /
        DATA ((ENTHV (J,K),J= 1, 9),K=10,18) /
     *   68920.947    ,  71305.381    ,  73968.691    ,  76934.170    ,
     *   80226.074    ,  83869.639    ,  87891.054    ,  92317.409    ,
     *   97176.580    ,
     *   74121.641    ,  76449.348    ,  79051.019    ,  81949.479    ,
     *   85168.503    ,  88732.846    ,  92668.251    ,  97001.436    ,
     *   101760.04    ,
     *   79298.301    ,  81576.202    ,  84123.908    ,  86963.882    ,
     *   90119.514    ,  93615.168    ,  97476.211    ,  101729.03    ,
     *   106401.01    ,
     *   84447.143    ,  86680.697    ,  89180.441    ,  91968.549    ,
     *   95068.101    ,  98503.143    ,  102298.73    ,  106480.95    ,
     *   111076.94    ,
     *   89566.074    ,  91759.719    ,  94216.338    ,  96957.875    ,
     *   100007.16    ,  103387.97    ,  107125.11    ,  111244.40    ,
     *   115772.77    ,
     *   94654.013    ,  96811.453    ,  99228.946    ,  101928.26    ,
     *   104932.01    ,  108263.77    ,  111948.11    ,  116010.64    ,
     *   120478.10    ,
     *   99710.501    ,  101834.89    ,  104216.64    ,  106877.37    ,
     *   109839.54    ,  113126.54    ,  116762.74    ,  120773.59    ,
     *   125185.63    ,
     *   104735.47    ,  106829.56    ,  109178.48    ,  111803.73    ,
     *   114727.67    ,  117973.52    ,  121565.51    ,  125528.92    ,
     *   129890.13    ,
     *   109729.09    ,  111795.31    ,  114113.94    ,  116706.44    ,
     *   119595.03    ,  122802.83    ,  126353.95    ,  130273.52    ,
     *   134587.80    /
        DATA ((ENTHV (J,K),J= 1, 9),K=19,27) /
     *   114691.69    ,  116732.22    ,  119022.84    ,  121584.95    ,
     *   124440.72    ,  127613.18    ,  131126.32    ,  135005.15    ,
     *   139275.84    ,
     *   119623.68    ,  121640.50    ,  123905.15    ,  126439.01    ,
     *   129264.21    ,  132403.70    ,  135881.39    ,  139722.21    ,
     *   143952.20    ,
     *   124525.51    ,  126520.46    ,  128761.01    ,  131268.55    ,
     *   134065.19    ,  137173.83    ,  140618.32    ,  144423.50    ,
     *   148615.35    ,
     *   129397.67    ,  131372.46    ,  133590.64    ,  136073.62    ,
     *   138843.52    ,  141923.23    ,  145336.52    ,  149108.21    ,
     *   153264.18    ,
     *   134240.66    ,  136196.90    ,  138394.31    ,  140854.37    ,
     *   143599.20    ,  146651.70    ,  150035.63    ,  153775.73    ,
     *   157897.85    ,
     *   139054.95    ,  140994.18    ,  143172.34    ,  145610.99    ,
     *   148332.31    ,  151359.20    ,  154715.41    ,  158425.66    ,
     *   162515.76    ,
     *   143841.01    ,  145764.71    ,  147925.06    ,  150343.74    ,
     *   153042.99    ,  156045.75    ,  159375.77    ,  163057.76    ,
     *   167117.50    ,
     *   148599.29    ,  150508.90    ,  152652.82    ,  155052.89    ,
     *   157731.42    ,  160711.42    ,  164016.66    ,  167671.85    ,
     *   171702.76    ,
     *   153330.22    ,  155227.13    ,  157355.97    ,  159738.72    ,
     *   162397.83    ,  165356.36    ,  168638.14    ,  172267.89    ,
     *   176271.37    /
        DATA ((ENTHV (J,K),J= 1, 9),K=28,36) /
     *   158034.19    ,  159919.80    ,  162034.84    ,  164401.53    ,
     *   167042.43    ,  169980.72    ,  173240.28    ,  176845.85    ,
     *   180823.21    ,
     *   162711.60    ,  164587.25    ,  166689.78    ,  169041.61    ,
     *   171665.50    ,  174584.71    ,  177823.20    ,  181405.78    ,
     *   185358.25    ,
     *   167362.78    ,  169229.83    ,  171321.10    ,  173659.26    ,
     *   176267.27    ,  179168.52    ,  182387.06    ,  185947.77    ,
     *   189876.47    ,
     *   171988.05    ,  173847.87    ,  175929.12    ,  178254.77    ,
     *   180848.00    ,  183732.36    ,  186932.02    ,  190471.92    ,
     *   194377.94    ,
     *   176587.71    ,  178441.67    ,  180514.13    ,  182828.42    ,
     *   185407.95    ,  188276.46    ,  191458.25    ,  194978.36    ,
     *   198862.72    ,
     *   181162.04    ,  183011.51    ,  185076.43    ,  187380.48    ,
     *   189947.36    ,  192801.04    ,  195965.95    ,  199467.23    ,
     *   203330.91    ,
     *   185711.26    ,  187557.65    ,  189616.26    ,  191911.20    ,
     *   194466.49    ,  197306.32    ,  200455.30    ,  203938.70    ,
     *   207782.62    ,
     *   190235.59    ,  192080.34    ,  194133.89    ,  196420.85    ,
     *   198965.57    ,  201792.52    ,  204926.50    ,  208392.91    ,
     *   212217.97    ,
     *   194735.22    ,  196579.78    ,  198629.54    ,  200909.64    ,
     *   203444.84    ,  206259.86    ,  209379.74    ,  212830.04    ,
     *   216637.10    /
        DATA ((ENTHV (J,K),J= 1, 9),K=37,45) /
     *   199210.31    ,  201056.18    ,  203103.44    ,  205377.82    ,
     *   207904.50    ,  210708.54    ,  213815.22    ,  217250.27    ,
     *   221040.16    ,
     *   203661.00    ,  205509.72    ,  207555.79    ,  209825.59    ,
     *   212344.78    ,  215138.78    ,  218233.12    ,  221653.76    ,
     *   225427.29    ,
     *   208087.38    ,  209940.55    ,  211986.77    ,  214253.15    ,
     *   216765.87    ,  219550.76    ,  222633.64    ,  226040.68    ,
     *   229798.64    ,
     *   212489.56    ,  214348.81    ,  216396.55    ,  218660.68    ,
     *   221167.98    ,  223944.69    ,  227016.96    ,  230411.20    ,
     *   234154.36    ,
     *   216867.56    ,  218734.62    ,  220785.29    ,  223048.37    ,
     *   225551.28    ,  228320.74    ,  231383.26    ,  234765.50    ,
     *   238494.61    ,
     *   221221.44    ,  223098.06    ,  225153.11    ,  227416.36    ,
     *   229915.94    ,  232679.09    ,  235732.70    ,  239103.73    ,
     *   242819.54    ,
     *   225551.18    ,  227439.23    ,  229500.15    ,  231764.82    ,
     *   234262.14    ,  237019.92    ,  240065.46    ,  243426.05    ,
     *   247129.29    ,
     *   229856.75    ,  231758.16    ,  233826.50    ,  236093.87    ,
     *   238590.02    ,  241343.37    ,  244381.70    ,  247732.63    ,
     *   251424.02    ,
     *   234138.10    ,  236054.89    ,  238132.26    ,  240403.64    ,
     *   242899.72    ,  245649.61    ,  248681.58    ,  252023.62    ,
     *   255703.87    /
        DATA ((ENTHV (J,K),J= 1, 9),K=46,54) /
     *   238395.14    ,  240329.44    ,  242417.50    ,  244694.23    ,
     *   247191.38    ,  249938.78    ,  252965.24    ,  256299.15    ,
     *   259968.98    ,
     *   242627.74    ,  244581.79    ,  246682.27    ,  248965.76    ,
     *   251465.12    ,  254211.01    ,  257232.82    ,  260559.39    ,
     *   264219.50    ,
     *   246835.76    ,  248811.91    ,  250926.62    ,  253218.30    ,
     *   255721.06    ,  258466.44    ,  261484.47    ,  264804.46    ,
     *   268455.55    ,
     *   251019.01    ,  253019.75    ,  255150.57    ,  257451.92    ,
     *   259959.29    ,  262705.18    ,  265720.31    ,  269034.50    ,
     *   272677.27    ,
     *   255177.26    ,  257205.22    ,  259354.13    ,  261666.70    ,
     *   264179.92    ,  266927.35    ,  269940.47    ,  273249.64    ,
     *   276884.79    ,
     *   259310.24    ,  261368.22    ,  263537.29    ,  265862.66    ,
     *   268383.03    ,  271133.06    ,  274145.07    ,  277450.00    ,
     *   281078.23    ,
     *   263417.65    ,  265508.63    ,  267700.02    ,  270039.86    ,
     *   272568.68    ,  275322.41    ,  278334.22    ,  281635.70    ,
     *   285257.71    ,
     *   267499.14    ,  269626.28    ,  271842.27    ,  274198.32    ,
     *   276736.95    ,  279495.47    ,  282508.02    ,  285806.86    ,
     *   289423.36    ,
     *   271554.30    ,  273720.98    ,  275963.99    ,  278338.03    ,
     *   280887.89    ,  283652.35    ,  286666.57    ,  289963.58    ,
     *   293575.28    /
        DATA ((ENTHV (J,K),J= 1, 9),K=55,63) /
     *   275582.68    ,  277792.53    ,  280065.08    ,  282459.01    ,
     *   285021.55    ,  287793.10    ,  290809.97    ,  294105.97    ,
     *   297713.58    ,
     *   279583.76    ,  281840.67    ,  284145.46    ,  286561.24    ,
     *   289137.95    ,  291917.81    ,  294938.30    ,  298234.12    ,
     *   301838.37    ,
     *   283556.96    ,  285865.12    ,  288204.99    ,  290644.67    ,
     *   293237.14    ,  296026.52    ,  299051.65    ,  302348.13    ,
     *   305949.74    ,
     *   287501.63    ,  289865.55    ,  292243.53    ,  294709.28    ,
     *   297319.11    ,  300119.30    ,  303150.09    ,  306448.10    ,
     *   310047.80    ,
     *   291417.03    ,  293841.62    ,  296260.91    ,  298754.99    ,
     *   301383.88    ,  304196.18    ,  307233.69    ,  310534.09    ,
     *   314132.63    ,
     *   295302.33    ,  297792.90    ,  300256.94    ,  302781.74    ,
     *   305431.44    ,  308257.21    ,  311302.51    ,  314606.20    ,
     *   318204.33    ,
     *   299156.60    ,  301718.96    ,  304231.40    ,  306789.43    ,
     *   309461.78    ,  312302.41    ,  315356.62    ,  318664.49    ,
     *   322262.98    ,
     *   302978.80    ,  305619.28    ,  308184.06    ,  310777.97    ,
     *   313474.87    ,  316331.80    ,  319396.05    ,  322709.04    ,
     *   326308.66    ,
     *   306767.74    ,  309493.30    ,  312114.62    ,  314747.22    ,
     *   317470.67    ,  320345.40    ,  323420.86    ,  326739.91    ,
     *   330341.45    /
        DATA ((ENTHV (J,K),J= 1, 9),K=64,72) /
     *   310522.08    ,  313340.39    ,  316022.79    ,  318697.04    ,
     *   321449.13    ,  324343.22    ,  327431.09    ,  330757.16    ,
     *   334361.41    ,
     *   314240.31    ,  317159.86    ,  319908.22    ,  322627.28    ,
     *   325410.20    ,  328325.25    ,  331426.77    ,  334760.85    ,
     *   338368.63    ,
     *   317920.67    ,  320950.93    ,  323770.54    ,  326537.75    ,
     *   329353.79    ,  332291.48    ,  335407.93    ,  338751.03    ,
     *   342363.16    ,
     *   321561.20    ,  324712.72    ,  327609.34    ,  330428.25    ,
     *   333279.83    ,  336241.90    ,  339374.59    ,  342727.75    ,
     *   346345.07    ,
     *   325159.58    ,  328444.27    ,  331424.14    ,  334298.56    ,
     *   337188.21    ,  340176.47    ,  343326.76    ,  346691.04    ,
     *   350314.42    ,
     *   328713.17    ,  332144.48    ,  335214.44    ,  338148.44    ,
     *   341078.83    ,  344095.16    ,  347264.46    ,  350640.95    ,
     *   354271.25    ,
     *   332218.84    ,  335812.15    ,  338979.68    ,  341977.60    ,
     *   344951.56    ,  347997.93    ,  351187.68    ,  354577.50    ,
     *   358215.63    ,
     *   335672.94    ,  339445.88    ,  342719.23    ,  345785.76    ,
     *   348806.26    ,  351884.72    ,  355096.44    ,  358500.73    ,
     *   362147.59    ,
     *   339071.07    ,  343044.12    ,  346432.41    ,  349572.57    ,
     *   352642.76    ,  355755.47    ,  358990.70    ,  362410.66    ,
     *   366067.19    /
        DATA ((ENTHV (J,K),J= 1, 9),K=73,81) /
     *   342407.95    ,  346605.10    ,  350118.45    ,  353337.67    ,
     *   356460.91    ,  359610.11    ,  362870.47    ,  366307.31    ,
     *   369974.46    ,
     *   345677.11    ,  350126.80    ,  353776.51    ,  357080.67    ,
     *   360260.49    ,  363448.55    ,  366735.72    ,  370190.69    ,
     *   373869.44    ,
     *   348870.46    ,  353606.90    ,  357405.66    ,  360801.14    ,
     *   364041.32    ,  367270.70    ,  370586.41    ,  374060.81    ,
     *   377752.16    ,
     *   351977.73    ,  357042.72    ,  361004.85    ,  364498.59    ,
     *   367803.15    ,  371076.45    ,  374422.52    ,  377917.67    ,
     *   381622.64    ,
     *   354985.48    ,  360431.12    ,  364572.91    ,  368172.50    ,
     *   371545.73    ,  374865.68    ,  378244.00    ,  381761.28    ,
     *   385480.93    ,
     *   357875.59    ,  363768.44    ,  368108.54    ,  371822.31    ,
     *   375268.80    ,  378638.28    ,  382050.79    ,  385591.63    ,
     *   389327.03    ,
     *   360622.53    ,  367050.29    ,  371610.28    ,  375447.36    ,
     *   378972.04    ,  382394.09    ,  385842.85    ,  389408.70    ,
     *   393160.97    ,
     *   363188.33    ,  370271.43    ,  375076.47    ,  379046.99    ,
     *   382655.14    ,  386132.96    ,  389620.10    ,  393212.49    ,
     *   396982.76    ,
     *   365511.76    ,  373425.43    ,  378505.23    ,  382620.42    ,
     *   386317.75    ,  389854.72    ,  393382.47    ,  397002.98    ,
     *   400792.41    /
        DATA ((ENTHV (J,K),J=10,18),K= 1, 9) /
     *   96469.183    ,  102367.66    ,  108647.37    ,  115332.97    ,
     *   122450.69    ,  130028.47    ,  138096.02    ,  146685.02    ,
     *   155829.16    ,
     *   88651.097    ,  95455.010    ,  102579.86    ,  110055.04    ,
     *   117910.92    ,  126179.08    ,  134892.43    ,  144085.45    ,
     *   153794.33    ,
     *   83960.709    ,  91173.163    ,  98733.894    ,  106658.64    ,
     *   114967.77    ,  123685.65    ,  132840.10    ,  142462.05    ,
     *   152585.33    ,
     *   82767.210    ,  89891.141    ,  97446.951    ,  105436.46    ,
     *   113866.64    ,  122749.62    ,  132102.44    ,  141946.87    ,
     *   152309.05    ,
     *   83978.312    ,  90825.663    ,  98169.772    ,  106012.18    ,
     *   114356.06    ,  123207.60    ,  132576.93    ,  142478.57    ,
     *   152931.58    ,
     *   86607.024    ,  93165.172    ,  100250.06    ,  107871.41    ,
     *   116037.29    ,  124755.58    ,  134035.52    ,  143888.89    ,
     *   154330.88    ,
     *   90042.712    ,  96354.141    ,  103199.80    ,  110597.56    ,
     *   118562.78    ,  127108.95    ,  136248.86    ,  145995.74    ,
     *   156364.49    ,
     *   93947.106    ,  100057.69    ,  106700.07    ,  113897.64    ,
     *   121671.75    ,  130041.73    ,  139025.35    ,  148639.59    ,
     *   158901.59    ,
     *   98134.016    ,  104080.71    ,  110553.27    ,  117578.43    ,
     *   125181.62    ,  133386.73    ,  142216.15    ,  151691.03    ,
     *   161831.95    /
        DATA ((ENTHV (J,K),J=10,18),K=10,18) /
     *   102497.06    ,  108307.73    ,  114637.52    ,  121515.12    ,
     *   128968.56    ,  137024.96    ,  145710.31    ,  155049.50    ,
     *   165066.59    ,
     *   106972.53    ,  112668.02    ,  118876.12    ,  125626.60    ,
     *   132949.15    ,  140873.05    ,  149426.97    ,  158638.78    ,
     *   168535.59    ,
     *   111520.48    ,  117116.64    ,  123219.38    ,  129859.15    ,
     *   137066.64    ,  144872.63    ,  153307.67    ,  162401.90    ,
     *   172184.98    ,
     *   116114.90    ,  121623.96    ,  127634.18    ,  134176.36    ,
     *   141281.86    ,  148982.45    ,  157310.03    ,  166296.46    ,
     *   175973.39    ,
     *   120738.23    ,  126169.87    ,  132097.77    ,  138552.95    ,
     *   145567.20    ,  153172.97    ,  161403.12    ,  170290.79    ,
     *   179869.20    ,
     *   125378.33    ,  130740.33    ,  136594.17    ,  142970.99    ,
     *   149902.86    ,  157422.69    ,  165564.07    ,  174361.09    ,
     *   183848.19    ,
     *   130026.58    ,  135325.31    ,  141111.87    ,  147417.46    ,
     *   154274.34    ,  161715.75    ,  169775.80    ,  178489.32    ,
     *   187891.69    ,
     *   134676.74    ,  139917.51    ,  145642.46    ,  151882.80    ,
     *   158670.90    ,  166040.26    ,  174025.38    ,  182661.65    ,
     *   191985.22    ,
     *   139324.25    ,  144511.55    ,  150179.67    ,  156359.80    ,
     *   163084.42    ,  170387.18    ,  178302.90    ,  186867.39    ,
     *   196117.43    /
        DATA ((ENTHV (J,K),J=10,18),K=19,27) /
     *   143965.72    ,  149103.40    ,  154718.76    ,  160843.02    ,
     *   167508.68    ,  174749.56    ,  182600.66    ,  191098.19    ,
     *   200279.40    ,
     *   148598.62    ,  153689.99    ,  159256.14    ,  165328.27    ,
     *   171938.91    ,  179121.97    ,  186912.66    ,  195347.45    ,
     *   204464.00    ,
     *   153221.04    ,  158269.00    ,  163789.04    ,  169812.30    ,
     *   176371.36    ,  183500.18    ,  191234.14    ,  199609.93    ,
     *   208665.55    ,
     *   157831.53    ,  162838.66    ,  168315.30    ,  174292.57    ,
     *   180803.07    ,  187880.83    ,  195561.31    ,  203881.42    ,
     *   212879.44    ,
     *   162429.03    ,  167397.60    ,  172833.25    ,  178767.10    ,
     *   185231.73    ,  192261.21    ,  199891.12    ,  208158.52    ,
     *   217101.93    ,
     *   167012.70    ,  171944.76    ,  177341.60    ,  183234.30    ,
     *   189655.46    ,  196639.18    ,  204221.11    ,  212438.47    ,
     *   221329.97    ,
     *   171581.95    ,  176479.35    ,  181839.32    ,  187692.94    ,
     *   194072.78    ,  201012.99    ,  208549.29    ,  216719.00    ,
     *   225561.03    ,
     *   176136.32    ,  181000.75    ,  186325.63    ,  192142.02    ,
     *   198482.50    ,  205381.24    ,  212874.02    ,  220998.27    ,
     *   229793.03    ,
     *   180675.51    ,  185508.49    ,  190799.89    ,  196580.75    ,
     *   202883.65    ,  209742.78    ,  217193.97    ,  225274.74    ,
     *   234024.26    /
        DATA ((ENTHV (J,K),J=10,18),K=28,36) /
     *   185199.28    ,  190002.24    ,  195261.65    ,  201008.53    ,
     *   207275.48    ,  214096.69    ,  221508.04    ,  229547.13    ,
     *   238253.28    ,
     *   189707.51    ,  194481.76    ,  199710.54    ,  205424.87    ,
     *   211657.35    ,  218442.20    ,  225815.33    ,  233814.42    ,
     *   242478.87    ,
     *   194200.11    ,  198946.86    ,  204146.28    ,  209829.39    ,
     *   216028.78    ,  222778.70    ,  230115.10    ,  238075.71    ,
     *   246700.05    ,
     *   198677.05    ,  203397.45    ,  208568.69    ,  214221.80    ,
     *   220389.38    ,  227105.69    ,  234406.73    ,  242330.28    ,
     *   250915.96    ,
     *   203138.35    ,  207833.46    ,  212977.62    ,  218601.87    ,
     *   224738.83    ,  231422.77    ,  238689.72    ,  246577.53    ,
     *   255125.90    ,
     *   207584.04    ,  212254.86    ,  217372.99    ,  222969.45    ,
     *   229076.89    ,  235729.61    ,  242963.67    ,  250816.96    ,
     *   259329.27    ,
     *   212014.18    ,  216661.68    ,  221754.74    ,  227324.43    ,
     *   233403.39    ,  240025.96    ,  247228.24    ,  255048.15    ,
     *   263525.57    ,
     *   216428.86    ,  221053.95    ,  226122.87    ,  231666.72    ,
     *   237718.19    ,  244311.62    ,  251483.15    ,  259270.76    ,
     *   267714.38    ,
     *   220828.19    ,  225431.71    ,  230477.37    ,  235996.30    ,
     *   242021.19    ,  248586.43    ,  255728.19    ,  263484.50    ,
     *   271895.36    /
        DATA ((ENTHV (J,K),J=10,18),K=37,45) /
     *   225212.26    ,  229795.06    ,  234818.29    ,  240313.13    ,
     *   246312.32    ,  252850.27    ,  259963.18    ,  267689.15    ,
     *   276068.20    ,
     *   229581.20    ,  234144.06    ,  239145.67    ,  244617.24    ,
     *   250591.56    ,  257103.06    ,  264188.00    ,  271884.50    ,
     *   280232.67    ,
     *   233935.14    ,  238478.82    ,  243459.57    ,  248908.65    ,
     *   254858.88    ,  261344.75    ,  268402.54    ,  276070.42    ,
     *   284388.57    ,
     *   238274.19    ,  242799.44    ,  247760.07    ,  253187.40    ,
     *   259114.30    ,  265575.30    ,  272606.72    ,  280246.79    ,
     *   288535.74    ,
     *   242598.51    ,  247106.04    ,  252047.25    ,  257453.54    ,
     *   263357.83    ,  269794.69    ,  276800.49    ,  284413.51    ,
     *   292674.03    ,
     *   246908.21    ,  251398.71    ,  256321.20    ,  261707.15    ,
     *   267589.51    ,  274002.93    ,  280983.82    ,  288570.52    ,
     *   296803.35    ,
     *   251203.43    ,  255677.59    ,  260582.02    ,  265948.28    ,
     *   271809.38    ,  278200.04    ,  285156.70    ,  292717.76    ,
     *   300923.62    ,
     *   255484.32    ,  259942.80    ,  264829.81    ,  270177.01    ,
     *   276017.51    ,  282386.04    ,  289319.13    ,  296855.22    ,
     *   305034.77    ,
     *   259751.00    ,  264194.44    ,  269064.67    ,  274393.45    ,
     *   280213.94    ,  286560.97    ,  293471.12    ,  300982.87    ,
     *   309136.75    /
        DATA ((ENTHV (J,K),J=10,18),K=46,54) /
     *   264003.60    ,  268432.64    ,  273286.71    ,  278597.66    ,
     *   284398.76    ,  290724.89    ,  297612.69    ,  305100.72    ,
     *   313229.55    ,
     *   268242.27    ,  272657.53    ,  277496.03    ,  282789.74    ,
     *   288572.02    ,  294877.83    ,  301743.87    ,  309208.76    ,
     *   317313.13    ,
     *   272467.13    ,  276869.22    ,  281692.74    ,  286969.79    ,
     *   292733.82    ,  299019.87    ,  305864.71    ,  313307.02    ,
     *   321387.51    ,
     *   276678.30    ,  281067.83    ,  285876.96    ,  291137.90    ,
     *   296884.23    ,  303151.06    ,  309975.24    ,  317395.52    ,
     *   325452.67    ,
     *   280875.91    ,  285253.48    ,  290048.78    ,  295294.17    ,
     *   301023.33    ,  307271.47    ,  314075.53    ,  321474.30    ,
     *   329508.64    ,
     *   285060.08    ,  289426.29    ,  294208.32    ,  299438.69    ,
     *   305151.21    ,  311381.18    ,  318165.61    ,  325543.40    ,
     *   333555.44    ,
     *   289230.93    ,  293586.36    ,  298355.68    ,  303571.57    ,
     *   309267.96    ,  315480.25    ,  322245.57    ,  329602.85    ,
     *   337593.09    ,
     *   293388.58    ,  297733.82    ,  302490.97    ,  307692.89    ,
     *   313373.65    ,  319568.77    ,  326315.44    ,  333652.71    ,
     *   341621.63    ,
     *   297533.14    ,  301868.76    ,  306614.29    ,  311802.76    ,
     *   317468.39    ,  323646.81    ,  330375.31    ,  337693.03    ,
     *   345641.09    /
        DATA ((ENTHV (J,K),J=10,18),K=55,63) /
     *   301664.72    ,  305991.31    ,  310725.75    ,  315901.27    ,
     *   321552.25    ,  327714.44    ,  334425.23    ,  341723.85    ,
     *   349651.51    ,
     *   305783.42    ,  310101.56    ,  314825.45    ,  319988.52    ,
     *   325625.32    ,  331771.74    ,  338465.28    ,  345745.25    ,
     *   353652.93    ,
     *   309889.35    ,  314199.61    ,  318913.47    ,  324064.60    ,
     *   329687.70    ,  335818.80    ,  342495.52    ,  349757.27    ,
     *   357645.42    ,
     *   313982.61    ,  318285.57    ,  322989.94    ,  328129.61    ,
     *   333739.46    ,  339855.70    ,  346516.03    ,  353759.98    ,
     *   361629.00    ,
     *   318063.29    ,  322359.53    ,  327054.93    ,  332183.62    ,
     *   337780.70    ,  343882.50    ,  350526.88    ,  357753.44    ,
     *   365603.75    ,
     *   322131.49    ,  326421.59    ,  331108.54    ,  336226.75    ,
     *   341811.50    ,  347899.30    ,  354528.13    ,  361737.71    ,
     *   369569.70    ,
     *   326187.30    ,  330471.84    ,  335150.87    ,  340259.07    ,
     *   345831.94    ,  351906.16    ,  358519.85    ,  365712.86    ,
     *   373526.92    ,
     *   330230.80    ,  334510.36    ,  339181.99    ,  344280.66    ,
     *   349842.11    ,  355903.17    ,  362502.13    ,  369678.94    ,
     *   377475.46    ,
     *   334262.08    ,  338537.25    ,  343202.01    ,  348291.63    ,
     *   353842.08    ,  359890.41    ,  366475.03    ,  373636.04    ,
     *   381415.38    /
        DATA ((ENTHV (J,K),J=10,18),K=64,72) /
     *   338281.22    ,  342552.59    ,  347211.00    ,  352292.04    ,
     *   357831.95    ,  363867.95    ,  370438.63    ,  377584.20    ,
     *   385346.74    ,
     *   342288.30    ,  346556.46    ,  351209.04    ,  356281.99    ,
     *   361811.78    ,  367835.86    ,  374392.98    ,  381523.49    ,
     *   389269.59    ,
     *   346283.39    ,  350548.94    ,  355196.23    ,  360261.54    ,
     *   365781.65    ,  371794.22    ,  378338.17    ,  385453.99    ,
     *   393183.99    ,
     *   350266.56    ,  354530.11    ,  359172.62    ,  364230.79    ,
     *   369741.66    ,  375743.11    ,  382274.26    ,  389375.75    ,
     *   397090.00    ,
     *   354237.87    ,  358500.03    ,  363138.31    ,  368189.80    ,
     *   373691.85    ,  379682.60    ,  386201.33    ,  393288.84    ,
     *   400987.69    ,
     *   358197.41    ,  362458.79    ,  367093.37    ,  372138.66    ,
     *   377632.32    ,  383612.75    ,  390119.43    ,  397193.31    ,
     *   404877.10    ,
     *   362145.22    ,  366406.44    ,  371037.86    ,  376077.42    ,
     *   381563.14    ,  387533.64    ,  394028.64    ,  401089.25    ,
     *   408758.30    ,
     *   366081.36    ,  370343.06    ,  374971.86    ,  380006.18    ,
     *   385484.37    ,  391445.34    ,  397929.02    ,  404976.70    ,
     *   412631.35    ,
     *   370005.90    ,  374268.71    ,  378895.44    ,  383924.99    ,
     *   389396.08    ,  395347.92    ,  401820.65    ,  408855.73    ,
     *   416496.30    /
        DATA ((ENTHV (J,K),J=10,18),K=73,81) /
     *   373918.89    ,  378183.44    ,  382808.66    ,  387833.92    ,
     *   393298.35    ,  399241.44    ,  405703.57    ,  412726.41    ,
     *   420353.22    ,
     *   377820.36    ,  382087.33    ,  386711.58    ,  391733.04    ,
     *   397191.23    ,  403125.97    ,  409577.87    ,  416588.78    ,
     *   424202.16    ,
     *   381710.39    ,  385980.42    ,  390604.27    ,  395622.41    ,
     *   401074.80    ,  407001.57    ,  413443.59    ,  420442.92    ,
     *   428043.17    ,
     *   385589.00    ,  389862.77    ,  394486.78    ,  399502.10    ,
     *   404949.12    ,  410868.31    ,  417300.81    ,  424288.88    ,
     *   431876.31    ,
     *   389456.24    ,  393734.44    ,  398359.18    ,  403372.17    ,
     *   408814.25    ,  414726.25    ,  421149.57    ,  428126.72    ,
     *   435701.65    ,
     *   393312.14    ,  397595.46    ,  402221.52    ,  407232.67    ,
     *   412670.25    ,  418575.44    ,  424989.96    ,  431956.50    ,
     *   439519.22    ,
     *   397156.76    ,  401445.89    ,  406073.85    ,  411083.67    ,
     *   416517.17    ,  422415.96    ,  428822.01    ,  435778.28    ,
     *   443329.10    ,
     *   400990.11    ,  405285.77    ,  409916.23    ,  414925.21    ,
     *   420355.09    ,  426247.85    ,  432645.79    ,  439592.11    ,
     *   447131.33    ,
     *   404812.22    ,  409115.15    ,  413748.70    ,  418757.36    ,
     *   424184.05    ,  430071.17    ,  436461.35    ,  443398.04    ,
     *   450925.97    /
        DATA ((ENTHV (J,K),J=19,27),K= 1, 9) /
     *   165564.33    ,  175928.73    ,  186963.02    ,  198710.51    ,
     *   211217.30    ,  224532.46    ,  238708.23    ,  253800.25    ,
     *   269867.74    ,
     *   164057.21    ,  174914.35    ,  186408.28    ,  198584.05    ,
     *   211489.38    ,  225174.88    ,  239694.23    ,  255104.44    ,
     *   271466.05    ,
     *   163246.46    ,  174484.69    ,  186341.97    ,  198863.04    ,
     *   212095.53    ,  226090.12    ,  240900.70    ,  256584.56    ,
     *   273202.58    ,
     *   163219.26    ,  174711.68    ,  186824.24    ,  199598.52    ,
     *   213079.69    ,  227316.50    ,  242361.37    ,  258270.47    ,
     *   275103.87    ,
     *   163959.64    ,  175590.94    ,  187858.11    ,  200798.15    ,
     *   214452.30    ,  228866.04    ,  244089.05    ,  260175.27    ,
     *   277182.90    ,
     *   165380.70    ,  177061.88    ,  189402.44    ,  202434.99    ,
     *   216196.74    ,  230729.52    ,  246079.78    ,  262298.63    ,
     *   279441.86    ,
     *   167372.65    ,  179041.19    ,  191395.06    ,  204463.52    ,
     *   218280.39    ,  232884.21    ,  248318.32    ,  264630.95    ,
     *   281875.28    ,
     *   169829.73    ,  181444.59    ,  193769.76    ,  206832.51    ,
     *   220664.29    ,  235301.03    ,  250783.43    ,  267157.13    ,
     *   284472.84    ,
     *   172659.62    ,  184195.87    ,  196464.52    ,  209492.20    ,
     *   223309.06    ,  237949.32    ,  253451.66    ,  269859.59    ,
     *   287221.67    /
        DATA ((ENTHV (J,K),J=19,27),K=10,18) /
     *   175785.25    ,  187229.49    ,  199424.47    ,  212397.30    ,
     *   226177.86    ,  240799.51    ,  256299.66    ,  272720.21    ,
     *   290107.97    ,
     *   179144.04    ,  190490.64    ,  202602.49    ,  215507.97    ,
     *   229237.50    ,  243824.37    ,  259305.37    ,  275721.40    ,
     *   293117.96    ,
     *   182686.13    ,  193934.36    ,  205958.92    ,  218789.87    ,
     *   232458.76    ,  246999.40    ,  262448.57    ,  278846.70    ,
     *   296238.45    ,
     *   186372.23    ,  197524.25    ,  209460.81    ,  222213.82    ,
     *   235816.27    ,  250302.93    ,  265711.04    ,  282081.02    ,
     *   299457.12    ,
     *   190171.56    ,  201231.08    ,  213081.07    ,  225755.27    ,
     *   239288.26    ,  253716.00    ,  269076.55    ,  285410.69    ,
     *   302762.64    ,
     *   194060.04    ,  205031.48    ,  216797.56    ,  229393.74    ,
     *   242856.16    ,  257222.16    ,  272530.79    ,  288823.48    ,
     *   306144.73    ,
     *   198018.77    ,  208906.77    ,  220592.24    ,  233112.19    ,
     *   246504.29    ,  260807.23    ,  276061.20    ,  292308.48    ,
     *   309594.07    ,
     *   202032.89    ,  212842.01    ,  224450.43    ,  236896.53    ,
     *   250219.40    ,  264459.05    ,  279656.87    ,  295856.07    ,
     *   313102.32    ,
     *   206090.60    ,  216825.18    ,  228360.14    ,  240735.07    ,
     *   253990.34    ,  268167.23    ,  283308.28    ,  299457.73    ,
     *   316662.04    /
        DATA ((ENTHV (J,K),J=19,27),K=19,27) /
     *   210182.50    ,  220846.60    ,  232311.59    ,  244618.14    ,
     *   257807.75    ,  271922.89    ,  287007.23    ,  303106.02    ,
     *   320266.58    ,
     *   214301.07    ,  224898.42    ,  236296.76    ,  248537.70    ,
     *   261663.75    ,  275718.47    ,  290746.61    ,  306794.42    ,
     *   323910.09    ,
     *   218440.21    ,  228974.23    ,  240309.04    ,  252487.05    ,
     *   265551.71    ,  279547.54    ,  294520.29    ,  310517.21    ,
     *   327587.35    ,
     *   222594.95    ,  233068.79    ,  244342.97    ,  256460.63    ,
     *   269466.04    ,  283404.60    ,  298323.00    ,  314269.42    ,
     *   331293.78    ,
     *   226761.26    ,  237177.78    ,  248394.02    ,  260453.76    ,
     *   273401.99    ,  287284.95    ,  302150.18    ,  318046.71    ,
     *   335025.33    ,
     *   230935.80    ,  241297.60    ,  252458.39    ,  264462.50    ,
     *   277355.58    ,  291184.59    ,  305997.87    ,  321845.28    ,
     *   338778.42    ,
     *   235115.80    ,  245425.29    ,  256532.92    ,  268483.54    ,
     *   281323.37    ,  295100.06    ,  309862.68    ,  325661.84    ,
     *   342549.93    ,
     *   239298.98    ,  249558.35    ,  260614.95    ,  272514.07    ,
     *   285302.48    ,  299028.43    ,  313741.65    ,  329493.50    ,
     *   346337.07    ,
     *   243483.41    ,  253694.69    ,  264702.23    ,  276551.72    ,
     *   289290.42    ,  302967.13    ,  317632.23    ,  333337.72    ,
     *   350137.41    /
        DATA ((ENTHV (J,K),J=19,27),K=28,36) /
     *   247667.50    ,  257832.55    ,  268792.83    ,  280594.44    ,
     *   293285.05    ,  306913.99    ,  321532.20    ,  337192.32    ,
     *   353948.80    ,
     *   251849.89    ,  261970.42    ,  272885.16    ,  284640.50    ,
     *   297284.56    ,  310867.10    ,  325439.62    ,  341055.34    ,
     *   357769.33    ,
     *   256029.46    ,  266107.06    ,  276977.81    ,  288688.42    ,
     *   301287.35    ,  314824.82    ,  329352.81    ,  344925.10    ,
     *   361597.33    ,
     *   260205.23    ,  270241.39    ,  281069.62    ,  292736.90    ,
     *   305292.06    ,  318785.72    ,  333270.30    ,  348800.10    ,
     *   365431.32    ,
     *   264376.39    ,  274372.49    ,  285159.56    ,  296784.86    ,
     *   309297.53    ,  322748.55    ,  337190.79    ,  352679.02    ,
     *   369269.99    ,
     *   268542.26    ,  278499.58    ,  289246.77    ,  300831.34    ,
     *   313302.72    ,  326712.23    ,  341113.16    ,  356560.73    ,
     *   373112.16    ,
     *   272702.26    ,  282621.99    ,  293330.51    ,  304875.52    ,
     *   317306.74    ,  330675.82    ,  345036.42    ,  360444.19    ,
     *   376956.82    ,
     *   276855.88    ,  286739.16    ,  297410.12    ,  308916.69    ,
     *   321308.82    ,  334638.49    ,  348959.70    ,  364328.50    ,
     *   380803.04    ,
     *   281002.72    ,  290850.60    ,  301485.06    ,  312954.22    ,
     *   325308.28    ,  338599.50    ,  352882.22    ,  368212.87    ,
     *   384650.01    /
        DATA ((ENTHV (J,K),J=19,27),K=37,45) /
     *   285142.41    ,  294955.89    ,  305554.85    ,  316987.59    ,
     *   329304.54    ,  342558.24    ,  356803.32    ,  372096.59    ,
     *   388497.01    ,
     *   289274.66    ,  299054.68    ,  309619.07    ,  321016.33    ,
     *   333297.09    ,  346514.12    ,  360722.39    ,  375979.04    ,
     *   392343.40    ,
     *   293399.21    ,  303146.65    ,  313677.38    ,  325040.04    ,
     *   337285.47    ,  350466.68    ,  364638.92    ,  379859.66    ,
     *   396188.60    ,
     *   297515.86    ,  307231.57    ,  317729.48    ,  329058.37    ,
     *   341269.29    ,  354415.47    ,  368552.44    ,  383737.96    ,
     *   400032.10    ,
     *   301624.43    ,  311309.21    ,  321775.09    ,  333071.02    ,
     *   345248.21    ,  358360.12    ,  372462.53    ,  387613.50    ,
     *   403873.44    ,
     *   305724.77    ,  315379.38    ,  325814.00    ,  337077.72    ,
     *   349221.93    ,  362300.30    ,  376368.84    ,  391485.90    ,
     *   407712.21    ,
     *   309816.78    ,  319441.93    ,  329846.02    ,  341078.26    ,
     *   353190.19    ,  366235.71    ,  380271.04    ,  395354.82    ,
     *   411548.06    ,
     *   313900.35    ,  323496.74    ,  333870.98    ,  345072.43    ,
     *   357152.77    ,  370166.10    ,  384168.85    ,  399219.93    ,
     *   415380.66    ,
     *   317975.40    ,  327543.69    ,  337888.75    ,  349060.06    ,
     *   361109.47    ,  374091.23    ,  388062.03    ,  403080.99    ,
     *   419209.72    /
        DATA ((ENTHV (J,K),J=19,27),K=46,54) /
     *   322041.90    ,  331582.71    ,  341899.22    ,  353041.02    ,
     *   365060.12    ,  378010.93    ,  391950.34    ,  406937.73    ,
     *   423034.97    ,
     *   326099.78    ,  335613.72    ,  345902.28    ,  357015.19    ,
     *   369004.57    ,  381925.01    ,  395833.61    ,  410789.95    ,
     *   426856.20    ,
     *   330149.02    ,  339636.67    ,  349897.87    ,  360982.46    ,
     *   372942.69    ,  385833.33    ,  399711.65    ,  414637.47    ,
     *   430673.19    ,
     *   334189.61    ,  343651.52    ,  353885.92    ,  364942.74    ,
     *   376874.38    ,  389735.75    ,  403584.31    ,  418480.10    ,
     *   434485.77    ,
     *   338221.54    ,  347658.25    ,  357866.38    ,  368895.96    ,
     *   380799.54    ,  393632.16    ,  407451.47    ,  422317.71    ,
     *   438293.76    ,
     *   342244.81    ,  351656.83    ,  361839.21    ,  372842.08    ,
     *   384718.10    ,  397522.47    ,  411313.01    ,  426150.16    ,
     *   442097.03    ,
     *   346259.42    ,  355647.26    ,  365804.38    ,  376781.03    ,
     *   388629.99    ,  401406.60    ,  415168.83    ,  429977.34    ,
     *   445895.44    ,
     *   350265.41    ,  359629.53    ,  369761.88    ,  380712.79    ,
     *   392535.16    ,  405284.46    ,  419018.85    ,  433799.14    ,
     *   449688.89    ,
     *   354262.77    ,  363603.66    ,  373711.69    ,  384637.33    ,
     *   396433.56    ,  409156.02    ,  422862.99    ,  437615.49    ,
     *   453477.27    /
        DATA ((ENTHV (J,K),J=19,27),K=55,63) /
     *   358251.55    ,  367569.64    ,  377653.82    ,  388554.62    ,
     *   400325.17    ,  413021.21    ,  426701.19    ,  441426.30    ,
     *   457260.50    ,
     *   362231.78    ,  371527.51    ,  381588.27    ,  392464.67    ,
     *   404209.95    ,  416879.99    ,  430533.39    ,  445231.51    ,
     *   461038.50    ,
     *   366203.49    ,  375477.29    ,  385515.03    ,  396367.46    ,
     *   408087.89    ,  420732.35    ,  434359.56    ,  449031.06    ,
     *   464811.20    ,
     *   370166.71    ,  379418.99    ,  389434.14    ,  400262.99    ,
     *   411958.98    ,  424578.24    ,  438179.65    ,  452824.90    ,
     *   468578.54    ,
     *   374121.49    ,  383352.65    ,  393345.61    ,  404151.28    ,
     *   415823.21    ,  428417.65    ,  441993.63    ,  456613.00    ,
     *   472340.48    ,
     *   378067.88    ,  387278.31    ,  397249.45    ,  408032.32    ,
     *   419680.58    ,  432250.58    ,  445801.49    ,  460395.32    ,
     *   476096.97    ,
     *   382005.92    ,  391195.99    ,  401145.69    ,  411906.14    ,
     *   423531.09    ,  436077.01    ,  449603.21    ,  464171.84    ,
     *   479847.98    ,
     *   385935.65    ,  395105.74    ,  405034.37    ,  415772.76    ,
     *   427374.75    ,  439896.94    ,  453398.76    ,  467942.53    ,
     *   483593.48    ,
     *   389857.13    ,  399007.59    ,  408915.51    ,  419632.19    ,
     *   431211.57    ,  443710.38    ,  457188.16    ,  471707.37    ,
     *   487333.44    /
        DATA ((ENTHV (J,K),J=19,27),K=64,72) /
     *   393770.40    ,  402901.59    ,  412789.15    ,  423484.46    ,
     *   435041.58    ,  447517.33    ,  460971.39    ,  475466.37    ,
     *   491067.84    ,
     *   397675.51    ,  406787.78    ,  416655.32    ,  427329.60    ,
     *   438864.77    ,  451317.79    ,  464748.45    ,  479219.50    ,
     *   494796.67    ,
     *   401572.53    ,  410666.21    ,  420514.05    ,  431167.63    ,
     *   442681.19    ,  455111.79    ,  468519.35    ,  482966.77    ,
     *   498519.92    ,
     *   405461.49    ,  414536.92    ,  424365.40    ,  434998.59    ,
     *   446490.85    ,  458899.34    ,  472284.11    ,  486708.17    ,
     *   502237.59    ,
     *   409342.46    ,  418399.96    ,  428209.38    ,  438822.50    ,
     *   450293.77    ,  462680.45    ,  476042.71    ,  490443.72    ,
     *   505949.66    ,
     *   413215.48    ,  422255.37    ,  432046.06    ,  442639.41    ,
     *   454089.98    ,  466455.14    ,  479795.19    ,  494173.41    ,
     *   509656.15    ,
     *   417080.62    ,  426103.20    ,  435875.46    ,  446449.34    ,
     *   457879.51    ,  470223.45    ,  483541.56    ,  497897.25    ,
     *   513357.05    ,
     *   420937.91    ,  429943.51    ,  439697.63    ,  450252.34    ,
     *   461662.40    ,  473985.38    ,  487281.82    ,  501615.27    ,
     *   517052.37    ,
     *   424787.43    ,  433776.33    ,  443512.61    ,  454048.44    ,
     *   465438.66    ,  477740.97    ,  491016.01    ,  505327.46    ,
     *   520742.11    /
        DATA ((ENTHV (J,K),J=19,27),K=73,81) /
     *   428629.21    ,  437601.72    ,  447320.45    ,  457837.67    ,
     *   469208.34    ,  481490.24    ,  494744.15    ,  509033.85    ,
     *   524426.29    ,
     *   432463.31    ,  441419.72    ,  451121.19    ,  461620.09    ,
     *   472971.46    ,  485233.23    ,  498466.25    ,  512734.45    ,
     *   528104.92    ,
     *   436289.80    ,  445230.39    ,  454914.88    ,  465395.72    ,
     *   476728.07    ,  488969.95    ,  502182.33    ,  516429.28    ,
     *   531778.01    ,
     *   440108.71    ,  449033.78    ,  458701.55    ,  469164.60    ,
     *   480478.19    ,  492700.44    ,  505892.44    ,  520118.37    ,
     *   535445.58    ,
     *   443920.10    ,  452829.92    ,  462481.26    ,  472926.78    ,
     *   484221.86    ,  496424.73    ,  509596.58    ,  523801.72    ,
     *   539107.64    ,
     *   447724.03    ,  456618.88    ,  466254.04    ,  476682.30    ,
     *   487959.12    ,  500142.85    ,  513294.79    ,  527479.37    ,
     *   542764.22    ,
     *   451520.54    ,  460400.69    ,  470019.95    ,  480431.19    ,
     *   491690.00    ,  503854.83    ,  516987.09    ,  531151.34    ,
     *   546415.32    ,
     *   455309.69    ,  464175.42    ,  473779.02    ,  484173.50    ,
     *   495414.55    ,  507560.70    ,  520673.52    ,  534817.65    ,
     *   550060.98    ,
     *   459091.53    ,  467943.09    ,  477531.30    ,  487909.27    ,
     *   499132.78    ,  511260.51    ,  524354.10    ,  538478.33    ,
     *   553701.21    /
        DATA ((ENTHV (J,K),J=28,36),K= 1, 9) /
     *   286973.74    ,  305185.39    ,  324574.13    ,  345216.06    ,
     *   367192.18    ,  390588.71    ,  415497.46    ,  442016.19    ,
     *   470248.94    ,
     *   288843.38    ,  307304.74    ,  326922.77    ,  347774.67    ,
     *   369942.51    ,  393513.57    ,  418580.66    ,  445242.46    ,
     *   473603.97    ,
     *   290819.47    ,  309504.03    ,  329329.36    ,  350373.18    ,
     *   372718.10    ,  396451.96    ,  421668.12    ,  448465.88    ,
     *   476950.80    ,
     *   292925.69    ,  311804.31    ,  331812.57    ,  353028.08    ,
     *   375533.42    ,  399416.48    ,  424770.79    ,  451695.82    ,
     *   480297.39    ,
     *   295174.59    ,  314217.53    ,  334383.64    ,  355749.77    ,
     *   378397.98    ,  402415.75    ,  427896.33    ,  454939.04    ,
     *   483649.63    ,
     *   297570.04    ,  316748.61    ,  337048.03    ,  358543.96    ,
     *   381317.46    ,  405455.23    ,  431049.89    ,  458200.27    ,
     *   487011.78    ,
     *   300109.57    ,  319397.22    ,  339806.92    ,  361412.79    ,
     *   384294.62    ,  408538.00    ,  434234.64    ,  461482.65    ,
     *   490386.82    ,
     *   302786.50    ,  322159.42    ,  342658.38    ,  364355.82    ,
     *   387330.02    ,  411665.30    ,  437452.26    ,  464788.07    ,
     *   493776.72    ,
     *   305591.72    ,  325029.02    ,  345598.48    ,  367370.79    ,
     *   390422.67    ,  414837.05    ,  440703.28    ,  468117.45    ,
     *   497182.62    /
        DATA ((ENTHV (J,K),J=28,36),K=10,18) /
     *   308514.95    ,  327998.59    ,  348622.03    ,  370454.29    ,
     *   393570.52    ,  418052.19    ,  443987.38    ,  471471.00    ,
     *   500605.10    ,
     *   311545.59    ,  331060.16    ,  351723.22    ,  373602.22    ,
     *   396770.80    ,  421309.03    ,  447303.66    ,  474848.40    ,
     *   504044.22    ,
     *   314673.25    ,  334205.70    ,  354895.98    ,  376810.13    ,
     *   400020.38    ,  424605.45    ,  450650.80    ,  478248.94    ,
     *   507499.74    ,
     *   317888.04    ,  337427.41    ,  358134.28    ,  380073.45    ,
     *   403315.91    ,  427939.10    ,  454027.23    ,  481671.66    ,
     *   510971.14    ,
     *   321180.72    ,  340717.87    ,  361432.26    ,  383387.68    ,
     *   406653.99    ,  431307.48    ,  457431.22    ,  485115.41    ,
     *   514457.74    ,
     *   324542.75    ,  344070.13    ,  364784.37    ,  386748.45    ,
     *   410031.27    ,  434708.10    ,  460860.94    ,  488578.94    ,
     *   517958.74    ,
     *   327966.34    ,  347477.74    ,  368185.37    ,  390151.58    ,
     *   413444.49    ,  438138.47    ,  464314.57    ,  492060.95    ,
     *   521473.26    ,
     *   331444.39    ,  350934.77    ,  371630.38    ,  393593.14    ,
     *   416890.53    ,  441596.19    ,  467790.30    ,  495560.13    ,
     *   525000.39    ,
     *   334970.47    ,  354435.80    ,  375114.90    ,  397069.44    ,
     *   420366.45    ,  445078.94    ,  471286.36    ,  499075.16    ,
     *   528539.19    /
        DATA ((ENTHV (J,K),J=28,36),K=19,27) /
     *   338538.82    ,  357975.87    ,  378634.77    ,  400577.06    ,
     *   423869.47    ,  448584.52    ,  474801.04    ,  502604.75    ,
     *   532088.73    ,
     *   342144.24    ,  361550.50    ,  382186.16    ,  404112.80    ,
     *   427396.98    ,  452110.84    ,  478332.71    ,  506147.67    ,
     *   535648.09    ,
     *   345782.09    ,  365155.62    ,  385765.59    ,  407673.74    ,
     *   430946.56    ,  455655.95    ,  481879.82    ,  509702.72    ,
     *   539216.40    ,
     *   349448.22    ,  368787.56    ,  389369.88    ,  411257.16    ,
     *   434515.95    ,  459217.99    ,  485440.89    ,  513268.75    ,
     *   542792.77    ,
     *   353138.94    ,  372443.01    ,  392996.13    ,  414860.59    ,
     *   438103.06    ,  462795.25    ,  489014.54    ,  516844.69    ,
     *   546376.38    ,
     *   356850.96    ,  376119.01    ,  396641.71    ,  418481.74    ,
     *   441705.96    ,  466386.12    ,  492599.48    ,  520429.49    ,
     *   549966.45    ,
     *   360581.34    ,  379812.89    ,  400304.25    ,  422118.53    ,
     *   445322.87    ,  469989.12    ,  496194.47    ,  524022.19    ,
     *   553562.22    ,
     *   364327.50    ,  383522.25    ,  403981.58    ,  425769.06    ,
     *   448952.15    ,  473602.85    ,  499798.39    ,  527621.87    ,
     *   557162.98    ,
     *   368087.11    ,  387244.94    ,  407671.75    ,  429431.59    ,
     *   452592.28    ,  477226.04    ,  503410.16    ,  531227.67    ,
     *   560768.04    /
        DATA ((ENTHV (J,K),J=28,36),K=28,36) /
     *   371858.12    ,  390979.05    ,  411373.01    ,  433104.56    ,
     *   456241.90    ,  480857.51    ,  507028.80    ,  534838.78    ,
     *   564376.78    ,
     *   375638.71    ,  394722.85    ,  415083.77    ,  436786.52    ,
     *   459899.72    ,  484496.15    ,  510653.38    ,  538454.45    ,
     *   567988.58    ,
     *   379427.24    ,  398474.79    ,  418802.58    ,  440476.16    ,
     *   463564.59    ,  488140.96    ,  514283.05    ,  542073.97    ,
     *   571602.89    ,
     *   383222.27    ,  402233.50    ,  422528.15    ,  444172.31    ,
     *   467235.45    ,  491791.02    ,  517917.02    ,  545696.69    ,
     *   575219.18    ,
     *   387022.51    ,  405997.73    ,  426259.32    ,  447873.87    ,
     *   470911.32    ,  495445.46    ,  521554.55    ,  549321.98    ,
     *   578836.94    ,
     *   390826.82    ,  409766.38    ,  429995.04    ,  451579.89    ,
     *   474591.32    ,  499103.50    ,  525194.97    ,  552949.29    ,
     *   582455.72    ,
     *   394634.18    ,  413538.44    ,  433734.35    ,  455289.47    ,
     *   478274.63    ,  502764.41    ,  528837.64    ,  556578.08    ,
     *   586075.07    ,
     *   398443.66    ,  417313.03    ,  437476.39    ,  459001.79    ,
     *   481960.53    ,  506427.54    ,  532482.00    ,  560207.86    ,
     *   589694.61    ,
     *   402254.45    ,  421089.34    ,  441220.39    ,  462716.15    ,
     *   485648.33    ,  510092.28    ,  536127.49    ,  563838.17    ,
     *   593313.94    /
        DATA ((ENTHV (J,K),J=28,36),K=37,45) /
     *   406065.83    ,  424866.65    ,  444965.66    ,  466431.86    ,
     *   489337.42    ,  513758.07    ,  539773.64    ,  567468.60    ,
     *   596932.72    ,
     *   409877.14    ,  428644.32    ,  448711.56    ,  470148.34    ,
     *   493027.24    ,  517424.40    ,  543419.99    ,  571098.74    ,
     *   600550.62    ,
     *   413687.80    ,  432421.75    ,  452457.53    ,  473865.03    ,
     *   496717.27    ,  521090.80    ,  547066.12    ,  574728.24    ,
     *   604167.34    ,
     *   417497.29    ,  436198.44    ,  456203.04    ,  477581.43    ,
     *   500407.06    ,  524756.85    ,  550711.65    ,  578356.77    ,
     *   607782.59    ,
     *   421305.14    ,  439973.90    ,  459947.64    ,  481297.11    ,
     *   504096.18    ,  528422.15    ,  554356.22    ,  581984.02    ,
     *   611396.13    ,
     *   425110.93    ,  443747.72    ,  463690.91    ,  485011.66    ,
     *   507784.23    ,  532086.34    ,  557999.52    ,  585609.70    ,
     *   615007.70    ,
     *   428914.28    ,  447519.51    ,  467432.46    ,  488724.69    ,
     *   511470.88    ,  535749.09    ,  561641.24    ,  589233.55    ,
     *   618617.09    ,
     *   432714.86    ,  451288.92    ,  471171.95    ,  492435.88    ,
     *   515155.79    ,  539410.11    ,  565281.12    ,  592855.33    ,
     *   622224.08    ,
     *   436512.36    ,  455055.66    ,  474909.07    ,  496144.93    ,
     *   518838.67    ,  543069.12    ,  568918.90    ,  596474.82    ,
     *   625828.50    /
        DATA ((ENTHV (J,K),J=28,36),K=46,54) /
     *   440306.52    ,  458819.44    ,  478643.55    ,  499851.55    ,
     *   522519.26    ,  546725.87    ,  572554.35    ,  600091.82    ,
     *   629430.16    ,
     *   444097.09    ,  462580.01    ,  482375.12    ,  503555.50    ,
     *   526197.32    ,  550380.14    ,  576187.26    ,  603706.14    ,
     *   633028.91    ,
     *   447883.85    ,  466337.14    ,  486103.57    ,  507256.55    ,
     *   529872.62    ,  554031.70    ,  579817.44    ,  607317.60    ,
     *   636624.59    ,
     *   451666.61    ,  470090.63    ,  489828.67    ,  510954.49    ,
     *   533544.96    ,  557680.38    ,  583444.71    ,  610926.05    ,
     *   640217.07    ,
     *   455445.19    ,  473840.31    ,  493550.26    ,  514649.13    ,
     *   537214.17    ,  561326.00    ,  587068.92    ,  614531.35    ,
     *   643806.23    ,
     *   459219.44    ,  477586.00    ,  497268.15    ,  518340.31    ,
     *   540880.08    ,  564968.40    ,  590689.92    ,  618133.36    ,
     *   647391.96    ,
     *   462989.23    ,  481327.56    ,  500982.19    ,  522027.88    ,
     *   544542.53    ,  568607.43    ,  594307.57    ,  621731.96    ,
     *   650974.13    ,
     *   466754.41    ,  485064.86    ,  504692.26    ,  525711.69    ,
     *   548201.39    ,  572242.97    ,  597921.75    ,  625327.05    ,
     *   654552.68    ,
     *   470514.90    ,  488797.77    ,  508398.23    ,  529391.63    ,
     *   551856.54    ,  575874.90    ,  601532.35    ,  628918.52    ,
     *   658127.49    /
        DATA ((ENTHV (J,K),J=28,36),K=55,63) /
     *   474270.58    ,  492526.20    ,  512099.98    ,  533067.57    ,
     *   555507.86    ,  579503.11    ,  605139.27    ,  632506.27    ,
     *   661698.51    ,
     *   478021.38    ,  496250.06    ,  515797.42    ,  536739.43    ,
     *   559155.26    ,  583127.50    ,  608742.41    ,  636090.24    ,
     *   665265.64    ,
     *   481767.21    ,  499969.25    ,  519490.46    ,  540407.10    ,
     *   562798.64    ,  586747.99    ,  612341.70    ,  639670.34    ,
     *   668828.84    ,
     *   485508.01    ,  503683.70    ,  523179.02    ,  544070.50    ,
     *   566437.92    ,  590364.48    ,  615937.06    ,  643246.51    ,
     *   672388.04    ,
     *   489243.73    ,  507393.35    ,  526863.03    ,  547729.57    ,
     *   570073.03    ,  593976.92    ,  619528.42    ,  646818.68    ,
     *   675943.19    ,
     *   492974.30    ,  511098.15    ,  530542.43    ,  551384.24    ,
     *   573703.90    ,  597585.24    ,  623115.72    ,  650386.79    ,
     *   679494.24    ,
     *   496699.69    ,  514798.03    ,  534217.17    ,  555034.44    ,
     *   577330.48    ,  601189.38    ,  626698.91    ,  653950.81    ,
     *   683041.14    ,
     *   500419.86    ,  518492.97    ,  537887.19    ,  558680.14    ,
     *   580952.71    ,  604789.28    ,  630277.93    ,  657510.68    ,
     *   686583.87    ,
     *   504134.78    ,  522182.91    ,  541552.46    ,  562321.27    ,
     *   584570.54    ,  608384.91    ,  633852.75    ,  661066.37    ,
     *   690122.39    /
        DATA ((ENTHV (J,K),J=28,36),K=64,72) /
     *   507844.43    ,  525867.84    ,  545212.94    ,  565957.82    ,
     *   588183.93    ,  611976.22    ,  637423.32    ,  664617.84    ,
     *   693656.66    ,
     *   511548.78    ,  529547.72    ,  548868.59    ,  569589.73    ,
     *   591792.85    ,  615563.18    ,  640989.62    ,  668165.06    ,
     *   697186.67    ,
     *   515247.81    ,  533222.53    ,  552519.39    ,  573216.99    ,
     *   595397.27    ,  619145.75    ,  644551.60    ,  671708.00    ,
     *   700712.39    ,
     *   518941.51    ,  536892.25    ,  556165.32    ,  576839.56    ,
     *   598997.16    ,  622723.90    ,  648109.25    ,  675246.65    ,
     *   704233.80    ,
     *   522629.88    ,  540556.87    ,  559806.37    ,  580457.42    ,
     *   602592.50    ,  626297.63    ,  651662.55    ,  678780.97    ,
     *   707750.89    ,
     *   526312.91    ,  544216.38    ,  563442.50    ,  584070.56    ,
     *   606183.27    ,  629866.90    ,  655211.47    ,  682310.96    ,
     *   711263.64    ,
     *   529990.60    ,  547870.77    ,  567073.73    ,  587678.97    ,
     *   609769.44    ,  633431.69    ,  658756.00    ,  685836.61    ,
     *   714772.04    ,
     *   533662.94    ,  551520.04    ,  570700.03    ,  591282.62    ,
     *   613351.02    ,  636992.00    ,  662296.12    ,  689357.89    ,
     *   718276.09    ,
     *   537329.94    ,  555164.19    ,  574321.40    ,  594881.52    ,
     *   616927.99    ,  640547.82    ,  665831.83    ,  692874.80    ,
     *   721775.78    /
        DATA ((ENTHV (J,K),J=28,36),K=73,81) /
     *   540991.60    ,  558803.20    ,  577937.84    ,  598475.66    ,
     *   620500.33    ,  644099.13    ,  669363.12    ,  696387.34    ,
     *   725271.11    ,
     *   544647.94    ,  562437.10    ,  581549.35    ,  602065.04    ,
     *   624068.06    ,  647645.94    ,  672889.98    ,  699895.51    ,
     *   728762.06    ,
     *   548298.96    ,  566065.89    ,  585155.93    ,  605649.65    ,
     *   627631.16    ,  651188.23    ,  676412.42    ,  703399.29    ,
     *   732248.66    ,
     *   551944.67    ,  569689.56    ,  588757.58    ,  609229.49    ,
     *   631189.63    ,  654726.01    ,  679930.42    ,  706898.69    ,
     *   735730.89    ,
     *   555585.08    ,  573308.14    ,  592354.31    ,  612804.58    ,
     *   634743.49    ,  658259.27    ,  683443.99    ,  710393.71    ,
     *   739208.76    ,
     *   559220.22    ,  576921.63    ,  595946.13    ,  616374.90    ,
     *   638292.71    ,  661788.02    ,  686953.13    ,  713884.35    ,
     *   742682.27    ,
     *   562850.08    ,  580530.04    ,  599533.05    ,  619940.48    ,
     *   641837.33    ,  665312.27    ,  690457.84    ,  717370.62    ,
     *   746151.43    ,
     *   566474.70    ,  584133.39    ,  603115.07    ,  623501.32    ,
     *   645377.33    ,  668832.01    ,  693958.14    ,  720852.52    ,
     *   749616.25    ,
     *   570094.09    ,  587731.68    ,  606692.21    ,  627057.43    ,
     *   648912.73    ,  672347.26    ,  697454.02    ,  724330.07    ,
     *   753076.73    /
        DATA ((ENTHV (J,K),J=37,45),K= 1, 9) /
     *   500306.51    ,  532306.84    ,  566375.50    ,  602646.17    ,
     *   641261.19    ,  682372.07    ,  726140.14    ,  772737.14    ,
     *   822345.93    ,
     *   503776.85    ,  535879.90    ,  570039.48    ,  606390.07    ,
     *   645074.71    ,  686245.65    ,  730064.86    ,  776704.73    ,
     *   826348.70    ,
     *   507235.14    ,  539438.28    ,  573687.18    ,  610116.89    ,
     *   648871.02    ,  690102.38    ,  733973.50    ,  780657.28    ,
     *   830337.69    ,
     *   510688.06    ,  542987.53    ,  577323.13    ,  613830.27    ,
     *   652652.98    ,  693944.47    ,  737867.69    ,  784595.96    ,
     *   834313.67    ,
     *   514140.66    ,  546531.93    ,  580950.88    ,  617533.14    ,
     *   656422.94    ,  697773.75    ,  741748.80    ,  788521.75    ,
     *   838277.30    ,
     *   517596.73    ,  550074.76    ,  584573.26    ,  621227.82    ,
     *   660182.78    ,  701591.71    ,  745618.00    ,  792435.49    ,
     *   842229.12    ,
     *   521059.01    ,  553618.49    ,  588192.40    ,  624916.18    ,
     *   663934.06    ,  705399.60    ,  749476.23    ,  796337.87    ,
     *   846169.61    ,
     *   524529.42    ,  557164.92    ,  591809.96    ,  628599.65    ,
     *   667678.00    ,  709198.43    ,  753324.29    ,  800229.51    ,
     *   850099.18    ,
     *   528009.22    ,  560715.34    ,  595427.15    ,  632279.34    ,
     *   671415.58    ,  712989.03    ,  757162.86    ,  804110.90    ,
     *   854018.20    /
        DATA ((ENTHV (J,K),J=37,45),K=10,18) /
     *   531499.19    ,  564270.60    ,  599044.86    ,  635956.11    ,
     *   675147.58    ,  716772.06    ,  760992.48    ,  807982.47    ,
     *   857926.95    ,
     *   534999.67    ,  567831.24    ,  602663.70    ,  639630.59    ,
     *   678874.59    ,  720548.07    ,  764813.62    ,  811844.58    ,
     *   861825.71    ,
     *   538510.73    ,  571397.51    ,  606284.06    ,  643303.21    ,
     *   682597.06    ,  724317.49    ,  768626.64    ,  815697.55    ,
     *   865714.70    ,
     *   542032.20    ,  574969.48    ,  609906.15    ,  646974.29    ,
     *   686315.35    ,  728080.65    ,  772431.86    ,  819541.62    ,
     *   869594.12    ,
     *   545563.72    ,  578547.06    ,  613530.06    ,  650644.02    ,
     *   690029.70    ,  731837.82    ,  776229.53    ,  823377.04    ,
     *   873464.15    ,
     *   549104.86    ,  582130.05    ,  617155.76    ,  654312.49    ,
     *   693740.28    ,  735589.20    ,  780019.86    ,  827203.97    ,
     *   877324.93    ,
     *   552655.05    ,  585718.16    ,  620783.15    ,  657979.73    ,
     *   697447.20    ,  739334.96    ,  783803.02    ,  831022.58    ,
     *   881176.61    ,
     *   556213.71    ,  589311.04    ,  624412.08    ,  661645.72    ,
     *   701150.52    ,  743075.20    ,  787579.15    ,  834833.02    ,
     *   885019.31    ,
     *   559780.21    ,  592908.31    ,  628042.34    ,  665310.39    ,
     *   704850.27    ,  746810.00    ,  791348.35    ,  838635.40    ,
     *   888853.13    /
        DATA ((ENTHV (J,K),J=37,45),K=19,27) /
     *   563353.91    ,  596509.55    ,  631673.69    ,  668973.64    ,
     *   708546.44    ,  750539.43    ,  795110.73    ,  842429.81    ,
     *   892678.17    ,
     *   566934.16    ,  600114.34    ,  635305.89    ,  672635.33    ,
     *   712239.01    ,  754263.52    ,  798866.34    ,  846216.37    ,
     *   896494.52    ,
     *   570520.33    ,  603722.24    ,  638938.65    ,  676295.35    ,
     *   715927.92    ,  757982.28    ,  802615.26    ,  849995.13    ,
     *   900302.28    ,
     *   574111.78    ,  607332.83    ,  642571.73    ,  679953.53    ,
     *   719613.11    ,  761695.72    ,  806357.52    ,  853766.18    ,
     *   904101.51    ,
     *   577707.91    ,  610945.69    ,  646204.83    ,  683609.71    ,
     *   723294.53    ,  765403.85    ,  810093.18    ,  857529.58    ,
     *   907892.29    ,
     *   581308.14    ,  614560.39    ,  649837.68    ,  687263.74    ,
     *   726972.10    ,  769106.65    ,  813822.26    ,  861285.39    ,
     *   911674.69    ,
     *   584911.90    ,  618176.54    ,  653470.02    ,  690915.46    ,
     *   730645.74    ,  772804.10    ,  817544.80    ,  865033.66    ,
     *   915448.79    ,
     *   588518.66    ,  621793.75    ,  657101.59    ,  694564.71    ,
     *   734315.37    ,  776496.19    ,  821260.81    ,  868774.46    ,
     *   919214.64    ,
     *   592127.90    ,  625411.64    ,  660732.14    ,  698211.33    ,
     *   737980.91    ,  780182.90    ,  824970.32    ,  872507.81    ,
     *   922972.31    /
        DATA ((ENTHV (J,K),J=37,45),K=28,36) /
     *   595739.13    ,  629029.87    ,  664361.41    ,  701855.18    ,
     *   741642.29    ,  783864.21    ,  828673.35    ,  876233.78    ,
     *   926721.87    ,
     *   599351.90    ,  632648.10    ,  667989.18    ,  705496.09    ,
     *   745299.43    ,  787540.09    ,  832369.92    ,  879952.41    ,
     *   930463.37    ,
     *   602965.76    ,  636265.99    ,  671615.21    ,  709133.94    ,
     *   748952.25    ,  791210.52    ,  836060.04    ,  883663.74    ,
     *   934196.88    ,
     *   606580.30    ,  639883.25    ,  675239.31    ,  712768.58    ,
     *   752600.69    ,  794875.49    ,  839743.74    ,  887367.82    ,
     *   937922.45    ,
     *   610195.14    ,  643499.58    ,  678861.25    ,  716399.89    ,
     *   756244.67    ,  798534.97    ,  843421.02    ,  891064.69    ,
     *   941640.14    ,
     *   613809.91    ,  647114.72    ,  682480.86    ,  720027.74    ,
     *   759884.13    ,  802188.94    ,  847091.91    ,  894754.39    ,
     *   945350.02    ,
     *   617424.28    ,  650728.39    ,  686097.94    ,  723652.02    ,
     *   763519.01    ,  805837.38    ,  850756.43    ,  898436.97    ,
     *   949052.15    ,
     *   621037.90    ,  654340.37    ,  689712.34    ,  727272.61    ,
     *   767149.24    ,  809480.29    ,  854414.58    ,  902112.46    ,
     *   952746.57    ,
     *   624650.50    ,  657950.42    ,  693323.87    ,  730889.41    ,
     *   770774.78    ,  813117.64    ,  858066.39    ,  905780.91    ,
     *   956433.36    /
        DATA ((ENTHV (J,K),J=37,45),K=37,45) /
     *   628261.78    ,  661558.33    ,  696932.40    ,  734502.33    ,
     *   774395.57    ,  816749.43    ,  861711.88    ,  909442.37    ,
     *   960112.56    ,
     *   631871.49    ,  665163.90    ,  700537.77    ,  738111.27    ,
     *   778011.57    ,  820375.64    ,  865351.07    ,  913096.87    ,
     *   963784.24    ,
     *   635479.39    ,  668766.94    ,  704139.86    ,  741716.15    ,
     *   781622.73    ,  823996.27    ,  868983.98    ,  916744.45    ,
     *   967448.46    ,
     *   639085.23    ,  672367.27    ,  707738.54    ,  745316.89    ,
     *   785229.02    ,  827611.31    ,  872610.63    ,  920385.17    ,
     *   971105.27    ,
     *   642688.82    ,  675964.75    ,  711333.69    ,  748913.41    ,
     *   788830.39    ,  831220.76    ,  876231.04    ,  924019.06    ,
     *   974754.72    ,
     *   646289.96    ,  679559.20    ,  714925.21    ,  752505.64    ,
     *   792426.82    ,  834824.61    ,  879845.24    ,  927646.16    ,
     *   978396.88    ,
     *   649888.46    ,  683150.50    ,  718513.00    ,  756093.53    ,
     *   796018.27    ,  838422.87    ,  883453.25    ,  931266.52    ,
     *   982031.81    ,
     *   653484.17    ,  686738.52    ,  722096.95    ,  759677.01    ,
     *   799604.72    ,  842015.53    ,  887055.09    ,  934880.18    ,
     *   985659.55    ,
     *   657076.92    ,  690323.12    ,  725677.00    ,  763256.03    ,
     *   803186.15    ,  845602.60    ,  890650.79    ,  938487.18    ,
     *   989280.17    /
        DATA ((ENTHV (J,K),J=37,45),K=46,54) /
     *   660666.56    ,  693904.21    ,  729253.05    ,  766830.54    ,
     *   806762.53    ,  849184.09    ,  894240.38    ,  942087.57    ,
     *   992893.73    ,
     *   664252.98    ,  697481.68    ,  732825.03    ,  770400.50    ,
     *   810333.85    ,  852759.99    ,  897823.87    ,  945681.39    ,
     *   996500.27    ,
     *   667836.04    ,  701055.44    ,  736392.89    ,  773965.87    ,
     *   813900.09    ,  856330.32    ,  901401.31    ,  949268.68    ,
     *   1000099.9    ,
     *   671415.63    ,  704625.39    ,  739956.55    ,  777526.62    ,
     *   817461.24    ,  859895.09    ,  904972.71    ,  952849.49    ,
     *   1003692.5    ,
     *   674991.66    ,  708191.47    ,  743515.97    ,  781082.70    ,
     *   821017.30    ,  863454.30    ,  908538.11    ,  956423.86    ,
     *   1007278.4    ,
     *   678564.03    ,  711753.59    ,  747071.08    ,  784634.10    ,
     *   824568.24    ,  867007.98    ,  912097.53    ,  959991.83    ,
     *   1010857.4    ,
     *   682132.64    ,  715311.70    ,  750621.86    ,  788180.79    ,
     *   828114.08    ,  870556.13    ,  915651.01    ,  963553.45    ,
     *   1014429.7    ,
     *   685697.43    ,  718865.73    ,  754168.25    ,  791722.74    ,
     *   831654.81    ,  874098.77    ,  919198.58    ,  967108.76    ,
     *   1017995.4    ,
     *   689258.33    ,  722415.62    ,  757710.22    ,  795259.95    ,
     *   835190.42    ,  877635.91    ,  922740.25    ,  970657.80    ,
     *   1021554.3    /
        DATA ((ENTHV (J,K),J=37,45),K=55,63) /
     *   692815.26    ,  725961.34    ,  761247.75    ,  798792.39    ,
     *   838720.92    ,  881167.57    ,  926276.08    ,  974200.62    ,
     *   1025106.8    ,
     *   696368.17    ,  729502.83    ,  764780.79    ,  802320.06    ,
     *   842246.32    ,  884693.78    ,  929806.08    ,  977737.25    ,
     *   1028652.7    ,
     *   699917.00    ,  733040.06    ,  768309.33    ,  805842.93    ,
     *   845766.61    ,  888214.54    ,  933330.30    ,  981267.75    ,
     *   1032192.1    ,
     *   703461.72    ,  736572.99    ,  771833.34    ,  809361.02    ,
     *   849281.80    ,  891729.89    ,  936848.76    ,  984792.16    ,
     *   1035725.1    ,
     *   707002.27    ,  740101.59    ,  775352.81    ,  812874.30    ,
     *   852791.91    ,  895239.83    ,  940361.49    ,  988310.52    ,
     *   1039251.7    ,
     *   710538.62    ,  743625.83    ,  778867.72    ,  816382.78    ,
     *   856296.94    ,  898744.39    ,  943868.53    ,  991822.86    ,
     *   1042772.0    ,
     *   714070.73    ,  747145.70    ,  782378.06    ,  819886.46    ,
     *   859796.90    ,  902243.60    ,  947369.91    ,  995329.25    ,
     *   1046286.1    ,
     *   717598.58    ,  750661.16    ,  785883.82    ,  823385.34    ,
     *   863291.81    ,  905737.48    ,  950865.67    ,  998829.70    ,
     *   1049793.9    ,
     *   721122.14    ,  754172.21    ,  789385.00    ,  826879.43    ,
     *   866781.68    ,  909226.06    ,  954355.84    ,  1002324.3    ,
     *   1053295.6    /
        DATA ((ENTHV (J,K),J=37,45),K=64,72) /
     *   724641.39    ,  757678.83    ,  792881.58    ,  830368.72    ,
     *   870266.52    ,  912709.34    ,  957840.45    ,  1005813.0    ,
     *   1056791.1    ,
     *   728156.30    ,  761181.00    ,  796373.57    ,  833853.22    ,
     *   873746.36    ,  916187.37    ,  961319.54    ,  1009296.0    ,
     *   1060280.6    ,
     *   731666.87    ,  764678.73    ,  799860.96    ,  837332.95    ,
     *   877221.20    ,  919660.17    ,  964793.14    ,  1012773.2    ,
     *   1063764.1    ,
     *   735173.08    ,  768172.00    ,  803343.75    ,  840807.90    ,
     *   880691.07    ,  923127.76    ,  968261.28    ,  1016244.6    ,
     *   1067241.5    ,
     *   738674.91    ,  771660.80    ,  806821.96    ,  844278.10    ,
     *   884155.98    ,  926590.18    ,  971724.01    ,  1019710.4    ,
     *   1070713.1    ,
     *   742172.37    ,  775145.14    ,  810295.58    ,  847743.55    ,
     *   887615.95    ,  930047.44    ,  975181.35    ,  1023170.6    ,
     *   1074178.8    ,
     *   745665.44    ,  778625.02    ,  813764.61    ,  851204.27    ,
     *   891071.01    ,  933499.57    ,  978633.34    ,  1026625.2    ,
     *   1077638.7    ,
     *   749154.12    ,  782100.44    ,  817229.07    ,  854660.27    ,
     *   894521.17    ,  936946.61    ,  982080.01    ,  1030074.3    ,
     *   1081092.7    ,
     *   752638.41    ,  785571.39    ,  820688.97    ,  858111.56    ,
     *   897966.45    ,  940388.58    ,  985521.40    ,  1033517.8    ,
     *   1084541.1    /
        DATA ((ENTHV (J,K),J=37,45),K=73,81) /
     *   756118.31    ,  789037.89    ,  824144.31    ,  861558.16    ,
     *   901406.89    ,  943825.51    ,  988957.54    ,  1036955.9    ,
     *   1087983.7    ,
     *   759593.82    ,  792499.94    ,  827595.10    ,  865000.09    ,
     *   904842.49    ,  947257.43    ,  992388.47    ,  1040388.5    ,
     *   1091420.8    ,
     *   763064.94    ,  795957.55    ,  831041.36    ,  868437.37    ,
     *   908273.29    ,  950684.37    ,  995814.22    ,  1043815.8    ,
     *   1094852.2    ,
     *   766531.68    ,  799410.72    ,  834483.10    ,  871870.00    ,
     *   911699.30    ,  954106.35    ,  999234.83    ,  1047237.7    ,
     *   1098278.0    ,
     *   769994.05    ,  802859.47    ,  837920.34    ,  875298.02    ,
     *   915120.55    ,  957523.40    ,  1002650.3    ,  1050654.3    ,
     *   1101698.4    ,
     *   773452.05    ,  806303.80    ,  841353.08    ,  878721.43    ,
     *   918537.06    ,  960935.56    ,  1006060.7    ,  1054065.6    ,
     *   1105113.2    ,
     *   776905.68    ,  809743.73    ,  844781.35    ,  882140.27    ,
     *   921948.86    ,  964342.85    ,  1009466.1    ,  1057471.7    ,
     *   1108522.7    ,
     *   780354.97    ,  813179.27    ,  848205.15    ,  885554.54    ,
     *   925355.98    ,  967745.30    ,  1012866.5    ,  1060872.6    ,
     *   1111926.7    ,
     *   783799.91    ,  816610.44    ,  851624.51    ,  888964.28    ,
     *   928758.43    ,  971142.94    ,  1016261.9    ,  1064268.4    ,
     *   1115325.5    /
        DATA ((ENTHV (J,K),J=46,54),K= 1, 9) /
     *   875161.16    ,  931390.09    ,  991253.35    ,  1054985.9    ,
     *   1122837.7    ,  1195075.1    ,  1271981.5    ,  1353858.8    ,
     *   1441028.2    ,
     *   879192.00    ,  935442.43    ,  995321.14    ,  1059063.5    ,
     *   1126920.1    ,  1199157.5    ,  1276059.7    ,  1357928.7    ,
     *   1445086.3    ,
     *   883210.47    ,  939483.88    ,  999379.53    ,  1063133.3    ,
     *   1130996.0    ,  1203234.9    ,  1280134.1    ,  1361996.2    ,
     *   1449143.1    ,
     *   887216.99    ,  943514.58    ,  1003428.5    ,  1067194.9    ,
     *   1135065.2    ,  1207306.8    ,  1284204.3    ,  1366060.7    ,
     *   1453198.1    ,
     *   891211.93    ,  947534.69    ,  1007467.9    ,  1071248.2    ,
     *   1139127.3    ,  1211372.9    ,  1288269.9    ,  1370121.7    ,
     *   1457250.7    ,
     *   895195.63    ,  951544.32    ,  1011497.8    ,  1075293.1    ,
     *   1143182.0    ,  1215432.7    ,  1292330.5    ,  1374178.8    ,
     *   1461300.5    ,
     *   899168.34    ,  955543.57    ,  1015518.2    ,  1079329.2    ,
     *   1147229.1    ,  1219486.0    ,  1296385.5    ,  1378231.5    ,
     *   1465347.0    ,
     *   903130.32    ,  959532.54    ,  1019528.9    ,  1083356.6    ,
     *   1151268.3    ,  1223532.4    ,  1300434.8    ,  1382279.4    ,
     *   1469389.7    ,
     *   907081.78    ,  963511.31    ,  1023529.9    ,  1087375.1    ,
     *   1155299.4    ,  1227571.7    ,  1304477.8    ,  1386322.2    ,
     *   1473428.3    /
        DATA ((ENTHV (J,K),J=46,54),K=10,18) /
     *   911022.89    ,  967479.96    ,  1027521.3    ,  1091384.5    ,
     *   1159322.3    ,  1231603.6    ,  1308514.5    ,  1390359.4    ,
     *   1477462.4    ,
     *   914953.83    ,  971438.55    ,  1031503.0    ,  1095384.8    ,
     *   1163336.7    ,  1235627.8    ,  1312544.4    ,  1394390.9    ,
     *   1481491.6    ,
     *   918874.74    ,  975387.14    ,  1035475.0    ,  1099375.9    ,
     *   1167342.6    ,  1239644.3    ,  1316567.3    ,  1398416.3    ,
     *   1485515.7    ,
     *   922785.75    ,  979325.81    ,  1039437.3    ,  1103357.6    ,
     *   1171339.7    ,  1243652.7    ,  1320582.9    ,  1402435.3    ,
     *   1489534.3    ,
     *   926686.97    ,  983254.59    ,  1043389.8    ,  1107330.0    ,
     *   1175328.0    ,  1247652.9    ,  1324591.2    ,  1406447.8    ,
     *   1493547.1    ,
     *   930578.53    ,  987173.56    ,  1047332.7    ,  1111293.0    ,
     *   1179307.4    ,  1251644.9    ,  1328591.9    ,  1410453.4    ,
     *   1497554.0    ,
     *   934460.50    ,  991082.76    ,  1051265.8    ,  1115246.6    ,
     *   1183277.8    ,  1255628.3    ,  1332584.8    ,  1414452.0    ,
     *   1501554.7    ,
     *   938333.00    ,  994982.26    ,  1055189.2    ,  1119190.6    ,
     *   1187239.0    ,  1259603.2    ,  1336569.7    ,  1418443.4    ,
     *   1505549.0    ,
     *   942196.09    ,  998872.10    ,  1059102.9    ,  1123125.2    ,
     *   1191191.1    ,  1263569.5    ,  1340546.6    ,  1422427.5    ,
     *   1509536.6    /
        DATA ((ENTHV (J,K),J=46,54),K=19,27) /
     *   946049.87    ,  1002752.3    ,  1063007.0    ,  1127050.3    ,
     *   1195134.0    ,  1267527.0    ,  1344515.4    ,  1426404.0    ,
     *   1513517.5    ,
     *   949894.42    ,  1006623.0    ,  1066901.5    ,  1130965.8    ,
     *   1199067.7    ,  1271475.7    ,  1348475.8    ,  1430372.9    ,
     *   1517491.4    ,
     *   953729.81    ,  1010484.3    ,  1070786.4    ,  1134871.8    ,
     *   1202992.1    ,  1275415.5    ,  1352427.9    ,  1434334.0    ,
     *   1521458.3    ,
     *   957556.10    ,  1014336.1    ,  1074661.7    ,  1138768.4    ,
     *   1206907.3    ,  1279346.4    ,  1356371.6    ,  1438287.3    ,
     *   1525417.9    ,
     *   961373.39    ,  1018178.5    ,  1078527.5    ,  1142655.4    ,
     *   1210813.1    ,  1283268.4    ,  1360306.7    ,  1442232.5    ,
     *   1529370.2    ,
     *   965181.72    ,  1022011.6    ,  1082383.8    ,  1146533.0    ,
     *   1214709.7    ,  1287181.3    ,  1364233.3    ,  1446169.8    ,
     *   1533315.1    ,
     *   968981.19    ,  1025835.5    ,  1086230.7    ,  1150401.1    ,
     *   1218596.9    ,  1291085.2    ,  1368151.2    ,  1450098.9    ,
     *   1537252.4    ,
     *   972771.84    ,  1029650.2    ,  1090068.3    ,  1154259.9    ,
     *   1222474.9    ,  1294980.2    ,  1372060.6    ,  1454019.9    ,
     *   1541182.1    ,
     *   976553.76    ,  1033455.8    ,  1093896.5    ,  1158109.2    ,
     *   1226343.6    ,  1298866.0    ,  1375961.2    ,  1457932.6    ,
     *   1545104.1    /
        DATA ((ENTHV (J,K),J=46,54),K=28,36) /
     *   980327.00    ,  1037252.3    ,  1097715.4    ,  1161949.3    ,
     *   1230203.0    ,  1302742.9    ,  1379853.1    ,  1461837.1    ,
     *   1549018.3    ,
     *   984091.64    ,  1041039.8    ,  1101525.1    ,  1165780.0    ,
     *   1234053.3    ,  1306610.7    ,  1383736.3    ,  1465733.2    ,
     *   1552924.8    ,
     *   987847.75    ,  1044818.5    ,  1105325.7    ,  1169601.5    ,
     *   1237894.3    ,  1310469.5    ,  1387610.8    ,  1469621.0    ,
     *   1556823.4    ,
     *   991595.39    ,  1048588.2    ,  1109117.2    ,  1173413.9    ,
     *   1241726.2    ,  1314319.3    ,  1391476.6    ,  1473500.5    ,
     *   1560714.0    ,
     *   995334.63    ,  1052349.2    ,  1112899.7    ,  1177217.1    ,
     *   1245549.0    ,  1318160.2    ,  1395333.6    ,  1477371.6    ,
     *   1564596.7    ,
     *   999065.54    ,  1056101.5    ,  1116673.1    ,  1181011.2    ,
     *   1249362.7    ,  1321992.1    ,  1399181.9    ,  1481234.3    ,
     *   1568471.5    ,
     *   1002788.2    ,  1059845.1    ,  1120437.8    ,  1184796.3    ,
     *   1253167.4    ,  1325815.0    ,  1403021.5    ,  1485088.6    ,
     *   1572338.3    ,
     *   1006502.6    ,  1063580.2    ,  1124193.5    ,  1188572.4    ,
     *   1256963.1    ,  1329629.1    ,  1406852.5    ,  1488934.5    ,
     *   1576197.0    ,
     *   1010208.9    ,  1067306.7    ,  1127940.5    ,  1192339.6    ,
     *   1260749.9    ,  1333434.4    ,  1410674.8    ,  1492772.0    ,
     *   1580047.8    /
        DATA ((ENTHV (J,K),J=46,54),K=37,45) /
     *   1013907.2    ,  1071024.9    ,  1131678.9    ,  1196098.0    ,
     *   1264527.8    ,  1337230.8    ,  1414488.4    ,  1496601.2    ,
     *   1583890.5    ,
     *   1017597.5    ,  1074734.6    ,  1135408.5    ,  1199847.7    ,
     *   1268296.9    ,  1341018.5    ,  1418293.5    ,  1500422.0    ,
     *   1587725.1    ,
     *   1021279.8    ,  1078436.1    ,  1139129.7    ,  1203588.6    ,
     *   1272057.2    ,  1344797.5    ,  1422090.0    ,  1504234.5    ,
     *   1591551.8    ,
     *   1024954.3    ,  1082129.3    ,  1142842.4    ,  1207320.8    ,
     *   1275808.8    ,  1348567.8    ,  1425877.9    ,  1508038.7    ,
     *   1595370.4    ,
     *   1028620.9    ,  1085814.4    ,  1146546.6    ,  1211044.5    ,
     *   1279551.8    ,  1352329.5    ,  1429657.3    ,  1511834.5    ,
     *   1599181.1    ,
     *   1032279.9    ,  1089491.4    ,  1150242.5    ,  1214759.7    ,
     *   1283286.2    ,  1356082.6    ,  1433428.3    ,  1515622.1    ,
     *   1602983.7    ,
     *   1035931.2    ,  1093160.4    ,  1153930.1    ,  1218466.4    ,
     *   1287012.1    ,  1359827.2    ,  1437190.9    ,  1519401.5    ,
     *   1606778.4    ,
     *   1039574.9    ,  1096821.5    ,  1157609.6    ,  1222164.8    ,
     *   1290729.5    ,  1363563.4    ,  1440945.1    ,  1523172.6    ,
     *   1610565.1    ,
     *   1043211.0    ,  1100474.7    ,  1161280.9    ,  1225854.9    ,
     *   1294438.5    ,  1367291.1    ,  1444690.9    ,  1526935.6    ,
     *   1614343.8    /
        DATA ((ENTHV (J,K),J=46,54),K=46,54) /
     *   1046839.7    ,  1104120.1    ,  1164944.2    ,  1229536.7    ,
     *   1298139.2    ,  1371010.5    ,  1448428.5    ,  1530690.5    ,
     *   1618114.7    ,
     *   1050461.0    ,  1107757.8    ,  1168599.4    ,  1233210.4    ,
     *   1301831.6    ,  1374721.6    ,  1452157.9    ,  1534437.2    ,
     *   1621877.6    ,
     *   1054075.0    ,  1111387.8    ,  1172246.8    ,  1236875.9    ,
     *   1305515.8    ,  1378424.5    ,  1455879.0    ,  1538175.9    ,
     *   1625632.7    ,
     *   1057681.6    ,  1115010.2    ,  1175886.3    ,  1240533.5    ,
     *   1309191.9    ,  1382119.2    ,  1459592.1    ,  1541906.6    ,
     *   1629380.0    ,
     *   1061281.1    ,  1118625.1    ,  1179518.1    ,  1244183.0    ,
     *   1312859.9    ,  1385805.8    ,  1463297.0    ,  1545629.3    ,
     *   1633119.4    ,
     *   1064873.4    ,  1122232.6    ,  1183142.1    ,  1247824.7    ,
     *   1316519.8    ,  1389484.4    ,  1466993.9    ,  1549344.0    ,
     *   1636851.1    ,
     *   1068458.7    ,  1125832.6    ,  1186758.5    ,  1251458.6    ,
     *   1320171.9    ,  1393154.9    ,  1470682.9    ,  1553050.9    ,
     *   1640575.1    ,
     *   1072036.9    ,  1129425.4    ,  1190367.3    ,  1255084.7    ,
     *   1323816.1    ,  1396817.5    ,  1474363.9    ,  1556750.0    ,
     *   1644291.4    ,
     *   1075608.1    ,  1133010.9    ,  1193968.7    ,  1258703.1    ,
     *   1327452.4    ,  1400472.3    ,  1478037.1    ,  1560441.2    ,
     *   1648000.0    /
        DATA ((ENTHV (J,K),J=46,54),K=55,63) /
     *   1079172.5    ,  1136589.2    ,  1197562.6    ,  1262314.0    ,
     *   1331081.0    ,  1404119.2    ,  1481702.5    ,  1564124.7    ,
     *   1651701.0    ,
     *   1082730.0    ,  1140160.3    ,  1201149.1    ,  1265917.2    ,
     *   1334702.0    ,  1407758.4    ,  1485360.1    ,  1567800.6    ,
     *   1655394.5    ,
     *   1086280.7    ,  1143724.4    ,  1204728.4    ,  1269513.0    ,
     *   1338315.3    ,  1411389.9    ,  1489010.0    ,  1571468.7    ,
     *   1659080.4    ,
     *   1089824.7    ,  1147281.6    ,  1208300.4    ,  1273101.4    ,
     *   1341921.1    ,  1415013.8    ,  1492652.2    ,  1575129.3    ,
     *   1662758.8    ,
     *   1093362.0    ,  1150831.7    ,  1211865.2    ,  1276682.4    ,
     *   1345519.4    ,  1418630.1    ,  1496286.9    ,  1578782.3    ,
     *   1666429.8    ,
     *   1096892.8    ,  1154375.0    ,  1215423.0    ,  1280256.1    ,
     *   1349110.2    ,  1422238.9    ,  1499914.1    ,  1582427.8    ,
     *   1670093.3    ,
     *   1100416.9    ,  1157911.5    ,  1218973.7    ,  1283822.6    ,
     *   1352693.8    ,  1425840.2    ,  1503533.7    ,  1586065.9    ,
     *   1673749.5    ,
     *   1103934.6    ,  1161441.3    ,  1222517.4    ,  1287381.9    ,
     *   1356270.0    ,  1429434.2    ,  1507146.0    ,  1589696.6    ,
     *   1677398.4    ,
     *   1107445.9    ,  1164964.3    ,  1226054.3    ,  1290934.2    ,
     *   1359838.9    ,  1433020.8    ,  1510750.9    ,  1593319.9    ,
     *   1681040.0    /
        DATA ((ENTHV (J,K),J=46,54),K=64,72) /
     *   1110950.7    ,  1168480.7    ,  1229584.2    ,  1294479.4    ,
     *   1363400.8    ,  1436600.2    ,  1514348.5    ,  1596936.0    ,
     *   1684674.4    ,
     *   1114449.2    ,  1171990.6    ,  1233107.4    ,  1298017.7    ,
     *   1366955.5    ,  1440172.4    ,  1517938.8    ,  1600544.8    ,
     *   1688301.5    ,
     *   1117941.5    ,  1175493.9    ,  1236623.9    ,  1301549.0    ,
     *   1370503.1    ,  1443737.5    ,  1521522.0    ,  1604146.4    ,
     *   1691921.6    ,
     *   1121427.5    ,  1178990.8    ,  1240133.7    ,  1305073.5    ,
     *   1374043.8    ,  1447295.4    ,  1525098.0    ,  1607740.8    ,
     *   1695534.5    ,
     *   1124907.4    ,  1182481.3    ,  1243636.9    ,  1308591.2    ,
     *   1377577.5    ,  1450846.3    ,  1528666.9    ,  1611328.2    ,
     *   1699140.4    ,
     *   1128381.1    ,  1185965.4    ,  1247133.5    ,  1312102.2    ,
     *   1381104.4    ,  1454390.3    ,  1532228.8    ,  1614908.5    ,
     *   1702739.4    ,
     *   1131848.8    ,  1189443.3    ,  1250623.7    ,  1315606.6    ,
     *   1384624.5    ,  1457927.4    ,  1535783.7    ,  1618481.9    ,
     *   1706331.3    ,
     *   1135310.4    ,  1192914.9    ,  1254107.4    ,  1319104.3    ,
     *   1388137.8    ,  1461457.6    ,  1539331.7    ,  1622048.3    ,
     *   1709916.3    ,
     *   1138766.1    ,  1196380.3    ,  1257584.8    ,  1322595.5    ,
     *   1391644.4    ,  1464981.0    ,  1542872.9    ,  1625607.8    ,
     *   1713494.5    /
        DATA ((ENTHV (J,K),J=46,54),K=73,81) /
     *   1142215.9    ,  1199839.6    ,  1261055.8    ,  1326080.1    ,
     *   1395144.4    ,  1468497.6    ,  1546407.2    ,  1629160.5    ,
     *   1717065.9    ,
     *   1145659.9    ,  1203292.9    ,  1264520.6    ,  1329558.4    ,
     *   1398637.8    ,  1472007.6    ,  1549934.8    ,  1632706.4    ,
     *   1720630.5    ,
     *   1149098.0    ,  1206740.1    ,  1267979.1    ,  1333030.3    ,
     *   1402124.7    ,  1475510.9    ,  1553455.7    ,  1636245.6    ,
     *   1724188.4    ,
     *   1152530.3    ,  1210181.4    ,  1271431.5    ,  1336495.8    ,
     *   1405605.2    ,  1479007.7    ,  1556969.9    ,  1639778.1    ,
     *   1727739.6    ,
     *   1155956.9    ,  1213616.7    ,  1274877.8    ,  1339955.1    ,
     *   1409079.2    ,  1482497.9    ,  1560477.6    ,  1643304.0    ,
     *   1731284.1    ,
     *   1159377.9    ,  1217046.2    ,  1278318.1    ,  1343408.1    ,
     *   1412546.9    ,  1485981.7    ,  1563978.7    ,  1646823.2    ,
     *   1734822.1    ,
     *   1162793.2    ,  1220469.9    ,  1281752.3    ,  1346855.1    ,
     *   1416008.2    ,  1489459.1    ,  1567473.3    ,  1650336.0    ,
     *   1738353.5    ,
     *   1166203.0    ,  1223887.7    ,  1285180.6    ,  1350295.8    ,
     *   1419463.4    ,  1492930.1    ,  1570961.4    ,  1653842.2    ,
     *   1741878.5    ,
     *   1169607.2    ,  1227299.9    ,  1288603.0    ,  1353730.6    ,
     *   1422912.3    ,  1496394.8    ,  1574443.2    ,  1657342.0    ,
     *   1745397.0    /
        DATA ((ENTHV (J,K),J=55,63),K= 1, 9) /
     *   1533831.7    ,  1632633.6    ,  1737821.5    ,  1849808.2    ,
     *   1969033.1    ,  2095964.0    ,  2231099.1    ,  2374968.6    ,
     *   2528137.1    ,
     *   1537874.8    ,  1636658.6    ,  1741825.9    ,  1853789.5    ,
     *   1972989.2    ,  2099893.0    ,  2234999.3    ,  2378838.5    ,
     *   2531975.4    ,
     *   1541917.6    ,  1640684.4    ,  1745831.9    ,  1857773.2    ,
     *   1976948.4    ,  2103825.7    ,  2238903.7    ,  2382713.1    ,
     *   2535818.7    ,
     *   1545959.7    ,  1644710.4    ,  1749839.0    ,  1861758.8    ,
     *   1980910.2    ,  2107761.7    ,  2242812.0    ,  2386591.9    ,
     *   2539666.7    ,
     *   1550000.4    ,  1648736.1    ,  1753846.6    ,  1865745.8    ,
     *   1984874.2    ,  2111700.4    ,  2246723.5    ,  2390474.6    ,
     *   2543519.0    ,
     *   1554039.4    ,  1652760.9    ,  1757854.4    ,  1869733.7    ,
     *   1988839.7    ,  2115641.4    ,  2250638.0    ,  2394360.7    ,
     *   2547375.2    ,
     *   1558076.0    ,  1656784.4    ,  1761861.7    ,  1873722.0    ,
     *   1992806.5    ,  2119584.3    ,  2254555.0    ,  2398249.9    ,
     *   2551234.9    ,
     *   1562109.9    ,  1660806.2    ,  1765868.1    ,  1877710.3    ,
     *   1996774.0    ,  2123528.7    ,  2258474.0    ,  2402141.8    ,
     *   2555097.8    ,
     *   1566140.7    ,  1664825.7    ,  1769873.3    ,  1881698.2    ,
     *   2000741.9    ,  2127474.2    ,  2262394.9    ,  2406035.9    ,
     *   2558963.5    /
        DATA ((ENTHV (J,K),J=55,63),K=10,18) /
     *   1570167.9    ,  1668842.6    ,  1773876.7    ,  1885685.2    ,
     *   2004709.7    ,  2131420.3    ,  2266317.0    ,  2409932.0    ,
     *   2562831.7    ,
     *   1574191.2    ,  1672856.6    ,  1777878.1    ,  1889671.0    ,
     *   2008677.1    ,  2135366.8    ,  2270240.2    ,  2413829.8    ,
     *   2566702.1    ,
     *   1578210.3    ,  1676867.2    ,  1781877.0    ,  1893655.2    ,
     *   2012643.8    ,  2139313.2    ,  2274164.1    ,  2417728.9    ,
     *   2570574.5    ,
     *   1582224.8    ,  1680874.2    ,  1785873.2    ,  1897637.5    ,
     *   2016609.3    ,  2143259.3    ,  2278088.3    ,  2421629.0    ,
     *   2574448.3    ,
     *   1586234.5    ,  1684877.3    ,  1789866.3    ,  1901617.5    ,
     *   2020573.4    ,  2147204.8    ,  2282012.5    ,  2425529.7    ,
     *   2578323.6    ,
     *   1590239.1    ,  1688876.1    ,  1793856.0    ,  1905595.1    ,
     *   2024535.8    ,  2151149.2    ,  2285936.6    ,  2429430.9    ,
     *   2582199.8    ,
     *   1594238.3    ,  1692870.3    ,  1797842.1    ,  1909569.8    ,
     *   2028496.2    ,  2155092.5    ,  2289860.1    ,  2433332.3    ,
     *   2586076.8    ,
     *   1598231.9    ,  1696859.9    ,  1801824.3    ,  1913541.4    ,
     *   2032454.2    ,  2159034.2    ,  2293782.8    ,  2437233.5    ,
     *   2589954.3    ,
     *   1602219.7    ,  1700844.4    ,  1805802.2    ,  1917509.6    ,
     *   2036409.8    ,  2162974.1    ,  2297704.4    ,  2441134.4    ,
     *   2593832.1    /
        DATA ((ENTHV (J,K),J=55,63),K=19,27) /
     *   1606201.5    ,  1704823.7    ,  1809775.8    ,  1921474.3    ,
     *   2040362.5    ,  2166912.0    ,  2301624.8    ,  2445034.7    ,
     *   2597709.9    ,
     *   1610177.1    ,  1708797.7    ,  1813744.8    ,  1925435.2    ,
     *   2044312.2    ,  2170847.7    ,  2305543.6    ,  2448934.1    ,
     *   2601587.6    ,
     *   1614146.3    ,  1712766.0    ,  1817709.0    ,  1929392.1    ,
     *   2048258.7    ,  2174780.9    ,  2309460.7    ,  2452832.5    ,
     *   2605464.8    ,
     *   1618109.0    ,  1716728.6    ,  1821668.2    ,  1933344.7    ,
     *   2052201.8    ,  2178711.4    ,  2313375.8    ,  2456729.6    ,
     *   2609341.4    ,
     *   1622065.1    ,  1720685.3    ,  1825622.3    ,  1937293.0    ,
     *   2056141.2    ,  2182638.9    ,  2317288.8    ,  2460625.3    ,
     *   2613217.2    ,
     *   1626014.5    ,  1724635.9    ,  1829571.0    ,  1941236.7    ,
     *   2060076.7    ,  2186563.5    ,  2321199.4    ,  2464519.3    ,
     *   2617092.0    ,
     *   1629956.9    ,  1728580.3    ,  1833514.2    ,  1945175.6    ,
     *   2064008.3    ,  2190484.7    ,  2325107.4    ,  2468411.4    ,
     *   2620965.6    ,
     *   1633892.3    ,  1732518.4    ,  1837451.8    ,  1949109.6    ,
     *   2067935.7    ,  2194402.5    ,  2329012.8    ,  2472301.5    ,
     *   2624837.9    ,
     *   1637820.7    ,  1736450.0    ,  1841383.7    ,  1953038.6    ,
     *   2071858.8    ,  2198316.8    ,  2332915.2    ,  2476189.4    ,
     *   2628708.5    /
        DATA ((ENTHV (J,K),J=55,63),K=28,36) /
     *   1641741.8    ,  1740375.1    ,  1845309.7    ,  1956962.5    ,
     *   2075777.5    ,  2202227.2    ,  2336814.6    ,  2480074.9    ,
     *   2632577.5    ,
     *   1645655.7    ,  1744293.6    ,  1849229.7    ,  1960881.0    ,
     *   2079691.5    ,  2206133.8    ,  2340710.8    ,  2483957.9    ,
     *   2636444.6    ,
     *   1649562.3    ,  1748205.3    ,  1853143.6    ,  1964794.2    ,
     *   2083600.9    ,  2210036.4    ,  2344603.7    ,  2487838.2    ,
     *   2640309.7    ,
     *   1653461.5    ,  1752110.2    ,  1857051.4    ,  1968701.8    ,
     *   2087505.4    ,  2213934.8    ,  2348493.1    ,  2491715.8    ,
     *   2644172.7    ,
     *   1657353.3    ,  1756008.3    ,  1860952.9    ,  1972603.8    ,
     *   2091404.9    ,  2217828.9    ,  2352378.8    ,  2495590.3    ,
     *   2648033.3    ,
     *   1661237.6    ,  1759899.4    ,  1864848.0    ,  1976500.1    ,
     *   2095299.4    ,  2221718.6    ,  2356260.9    ,  2499461.8    ,
     *   2651891.5    ,
     *   1665114.4    ,  1763783.6    ,  1868736.8    ,  1980390.5    ,
     *   2099188.7    ,  2225603.8    ,  2360139.1    ,  2503330.2    ,
     *   2655747.2    ,
     *   1668983.6    ,  1767660.6    ,  1872619.0    ,  1984275.1    ,
     *   2103072.7    ,  2229484.4    ,  2364013.3    ,  2507195.1    ,
     *   2659600.1    ,
     *   1672845.2    ,  1771530.7    ,  1876494.7    ,  1988153.8    ,
     *   2106951.5    ,  2233360.3    ,  2367883.5    ,  2511056.7    ,
     *   2663450.3    /
        DATA ((ENTHV (J,K),J=55,63),K=37,45) /
     *   1676699.2    ,  1775393.5    ,  1880363.9    ,  1992026.4    ,
     *   2110824.8    ,  2237231.4    ,  2371749.5    ,  2514914.8    ,
     *   2667297.5    ,
     *   1680545.6    ,  1779249.3    ,  1884226.3    ,  1995893.0    ,
     *   2114692.6    ,  2241097.6    ,  2375611.2    ,  2518769.2    ,
     *   2671141.8    ,
     *   1684384.4    ,  1783097.8    ,  1888082.1    ,  1999753.4    ,
     *   2118554.8    ,  2244958.8    ,  2379468.6    ,  2522619.8    ,
     *   2674982.9    ,
     *   1688215.5    ,  1786939.1    ,  1891931.2    ,  2003607.6    ,
     *   2122411.4    ,  2248815.1    ,  2383321.6    ,  2526466.7    ,
     *   2678820.8    ,
     *   1692038.9    ,  1790773.2    ,  1895773.5    ,  2007455.6    ,
     *   2126262.4    ,  2252666.2    ,  2387170.0    ,  2530309.6    ,
     *   2682655.4    ,
     *   1695854.7    ,  1794600.0    ,  1899609.1    ,  2011297.3    ,
     *   2130107.6    ,  2256512.1    ,  2391013.9    ,  2534148.6    ,
     *   2686486.6    ,
     *   1699662.9    ,  1798419.6    ,  1903437.8    ,  2015132.7    ,
     *   2133947.0    ,  2260352.8    ,  2394853.1    ,  2537983.5    ,
     *   2690314.3    ,
     *   1703463.4    ,  1802232.0    ,  1907259.7    ,  2018961.7    ,
     *   2137780.6    ,  2264188.3    ,  2398687.6    ,  2541814.2    ,
     *   2694138.5    ,
     *   1707256.3    ,  1806037.0    ,  1911074.7    ,  2022784.3    ,
     *   2141608.3    ,  2268018.4    ,  2402517.3    ,  2545640.7    ,
     *   2697959.0    /
        DATA ((ENTHV (J,K),J=55,63),K=46,54) /
     *   1711041.5    ,  1809834.8    ,  1914882.9    ,  2026600.6    ,
     *   2145430.1    ,  2271843.0    ,  2406342.2    ,  2549463.0    ,
     *   2701775.8    ,
     *   1714819.2    ,  1813625.3    ,  1918684.2    ,  2030410.4    ,
     *   2149245.9    ,  2275662.3    ,  2410162.1    ,  2553280.9    ,
     *   2705588.9    ,
     *   1718589.2    ,  1817408.5    ,  1922478.6    ,  2034213.7    ,
     *   2153055.8    ,  2279476.1    ,  2413977.2    ,  2557094.4    ,
     *   2709398.0    ,
     *   1722351.7    ,  1821184.5    ,  1926266.1    ,  2038010.6    ,
     *   2156859.6    ,  2283284.4    ,  2417787.2    ,  2560903.4    ,
     *   2713203.3    ,
     *   1726106.6    ,  1824953.2    ,  1930046.8    ,  2041801.0    ,
     *   2160657.4    ,  2287087.1    ,  2421592.2    ,  2564707.9    ,
     *   2717004.6    ,
     *   1729854.0    ,  1828714.7    ,  1933820.5    ,  2045584.9    ,
     *   2164449.2    ,  2290884.2    ,  2425392.1    ,  2568507.9    ,
     *   2720801.8    ,
     *   1733593.8    ,  1832469.0    ,  1937587.4    ,  2049362.3    ,
     *   2168234.9    ,  2294675.7    ,  2429186.8    ,  2572303.2    ,
     *   2724595.0    ,
     *   1737326.2    ,  1836216.0    ,  1941347.4    ,  2053133.2    ,
     *   2172014.5    ,  2298461.6    ,  2432976.5    ,  2576093.9    ,
     *   2728384.0    ,
     *   1741051.2    ,  1839955.9    ,  1945100.5    ,  2056897.6    ,
     *   2175788.0    ,  2302241.9    ,  2436760.9    ,  2579879.9    ,
     *   2732168.9    /
        DATA ((ENTHV (J,K),J=55,63),K=55,63) /
     *   1744768.7    ,  1843688.6    ,  1948846.7    ,  2060655.5    ,
     *   2179555.3    ,  2306016.4    ,  2440540.1    ,  2583661.2    ,
     *   2735949.5    ,
     *   1748478.8    ,  1847414.1    ,  1952586.0    ,  2064406.8    ,
     *   2183316.6    ,  2309785.2    ,  2444314.1    ,  2587437.7    ,
     *   2739725.8    ,
     *   1752181.6    ,  1851132.5    ,  1956318.6    ,  2068151.6    ,
     *   2187071.7    ,  2313548.4    ,  2448082.8    ,  2591209.4    ,
     *   2743497.8    ,
     *   1755877.0    ,  1854843.8    ,  1960044.3    ,  2071890.0    ,
     *   2190820.7    ,  2317305.7    ,  2451846.2    ,  2594976.3    ,
     *   2747265.5    ,
     *   1759565.1    ,  1858548.0    ,  1963763.1    ,  2075621.8    ,
     *   2194563.5    ,  2321057.4    ,  2455604.3    ,  2598738.2    ,
     *   2751028.8    ,
     *   1763246.0    ,  1862245.2    ,  1967475.2    ,  2079347.2    ,
     *   2198300.2    ,  2324803.3    ,  2459357.0    ,  2602495.3    ,
     *   2754787.6    ,
     *   1766919.7    ,  1865935.3    ,  1971180.5    ,  2083066.0    ,
     *   2202030.7    ,  2328543.4    ,  2463104.4    ,  2606247.5    ,
     *   2758542.0    ,
     *   1770586.2    ,  1869618.5    ,  1974879.1    ,  2086778.4    ,
     *   2205755.1    ,  2332277.7    ,  2466846.4    ,  2609994.8    ,
     *   2762291.9    ,
     *   1774245.5    ,  1873294.6    ,  1978570.9    ,  2090484.3    ,
     *   2209473.4    ,  2336006.3    ,  2470583.0    ,  2613737.1    ,
     *   2766037.3    /
        DATA ((ENTHV (J,K),J=55,63),K=64,72) /
     *   1777897.7    ,  1876963.9    ,  1982256.0    ,  2094183.8    ,
     *   2213185.5    ,  2339729.1    ,  2474314.3    ,  2617474.4    ,
     *   2769778.2    ,
     *   1781542.8    ,  1880626.2    ,  1985934.4    ,  2097876.9    ,
     *   2216891.5    ,  2343446.1    ,  2478040.1    ,  2621206.7    ,
     *   2773514.4    ,
     *   1785180.9    ,  1884281.6    ,  1989606.1    ,  2101563.5    ,
     *   2220591.4    ,  2347157.3    ,  2481760.5    ,  2624934.0    ,
     *   2777246.1    ,
     *   1788812.1    ,  1887930.2    ,  1993271.2    ,  2105243.7    ,
     *   2224285.1    ,  2350862.7    ,  2485475.5    ,  2628656.2    ,
     *   2780973.2    ,
     *   1792436.2    ,  1891572.0    ,  1996929.6    ,  2108917.6    ,
     *   2227972.8    ,  2354562.4    ,  2489185.1    ,  2632373.4    ,
     *   2784695.6    ,
     *   1796053.5    ,  1895207.0    ,  2000581.5    ,  2112585.0    ,
     *   2231654.4    ,  2358256.2    ,  2492889.2    ,  2636085.6    ,
     *   2788413.4    ,
     *   1799663.8    ,  1898835.3    ,  2004226.8    ,  2116246.2    ,
     *   2235329.9    ,  2361944.3    ,  2496587.9    ,  2639792.7    ,
     *   2792126.5    ,
     *   1803267.4    ,  1902456.9    ,  2007865.5    ,  2119901.0    ,
     *   2238999.3    ,  2365626.7    ,  2500281.2    ,  2643494.7    ,
     *   2795834.9    ,
     *   1806864.1    ,  1906071.8    ,  2011497.8    ,  2123549.5    ,
     *   2242662.7    ,  2369303.2    ,  2503969.0    ,  2647191.6    ,
     *   2799538.6    /
        DATA ((ENTHV (J,K),J=55,63),K=73,81) /
     *   1810454.1    ,  1909680.0    ,  2015123.6    ,  2127191.7    ,
     *   2246320.0    ,  2372974.0    ,  2507651.4    ,  2650883.5    ,
     *   2803237.6    ,
     *   1814037.4    ,  1913281.7    ,  2018742.9    ,  2130827.7    ,
     *   2249971.4    ,  2376639.1    ,  2511328.4    ,  2654570.3    ,
     *   2806931.9    ,
     *   1817614.1    ,  1916876.7    ,  2022355.8    ,  2134457.5    ,
     *   2253616.7    ,  2380298.5    ,  2514999.9    ,  2658251.9    ,
     *   2810621.4    ,
     *   1821184.1    ,  1920465.3    ,  2025962.3    ,  2138081.0    ,
     *   2257256.0    ,  2383952.1    ,  2518666.0    ,  2661928.5    ,
     *   2814306.2    ,
     *   1824747.5    ,  1924047.3    ,  2029562.4    ,  2141698.3    ,
     *   2260889.4    ,  2387600.0    ,  2522326.7    ,  2665600.0    ,
     *   2817986.3    ,
     *   1828304.3    ,  1927622.9    ,  2033156.2    ,  2145309.5    ,
     *   2264516.8    ,  2391242.1    ,  2525981.9    ,  2669266.3    ,
     *   2821661.6    ,
     *   1831854.7    ,  1931192.1    ,  2036743.7    ,  2148914.6    ,
     *   2268138.3    ,  2394878.7    ,  2529631.8    ,  2672927.6    ,
     *   2825332.1    ,
     *   1835398.6    ,  1934754.9    ,  2040325.0    ,  2152513.5    ,
     *   2271753.8    ,  2398509.5    ,  2533276.2    ,  2676583.7    ,
     *   2828997.9    ,
     *   1838936.1    ,  1938311.3    ,  2043900.0    ,  2156106.4    ,
     *   2275363.5    ,  2402134.6    ,  2536915.2    ,  2680234.8    ,
     *   2832658.8    /
        DATA ((ENTHV (J,K),J=64,72),K= 1, 9) /
     *   2691205.6    ,  2864813.9    ,  3049643.3    ,  3246419.1    ,
     *   3455913.5    ,  3678948.5    ,  3916399.2    ,  4169197.5    ,
     *   4438335.3    ,
     *   2695011.1    ,  2868585.7    ,  3053380.6    ,  3250121.2    ,
     *   3459579.8    ,  3682578.6    ,  3919992.7    ,  4172754.2    ,
     *   4441855.1    ,
     *   2698822.0    ,  2872363.2    ,  3057123.7    ,  3253829.3    ,
     *   3463252.2    ,  3686214.7    ,  3923592.4    ,  4176317.0    ,
     *   4445380.9    ,
     *   2702637.9    ,  2876145.9    ,  3060872.3    ,  3257543.0    ,
     *   3466930.3    ,  3689856.7    ,  3927197.9    ,  4179885.7    ,
     *   4448912.6    ,
     *   2706458.5    ,  2879933.6    ,  3064626.1    ,  3261262.0    ,
     *   3470613.9    ,  3693504.4    ,  3930809.0    ,  4183460.1    ,
     *   4452449.9    ,
     *   2710283.3    ,  2883725.8    ,  3068384.8    ,  3264986.1    ,
     *   3474302.8    ,  3697157.4    ,  3934425.7    ,  4187040.0    ,
     *   4455992.7    ,
     *   2714112.1    ,  2887522.4    ,  3072148.0    ,  3268715.1    ,
     *   3477996.7    ,  3700815.5    ,  3938047.5    ,  4190625.1    ,
     *   4459540.9    ,
     *   2717944.5    ,  2891322.9    ,  3075915.5    ,  3272448.6    ,
     *   3481695.3    ,  3704478.6    ,  3941674.4    ,  4194215.5    ,
     *   4463094.3    ,
     *   2721780.2    ,  2895127.2    ,  3079687.1    ,  3276186.5    ,
     *   3485398.5    ,  3708146.4    ,  3945306.2    ,  4197810.7    ,
     *   4466652.7    /
        DATA ((ENTHV (J,K),J=64,72),K=10,18) /
     *   2725618.8    ,  2898934.8    ,  3083462.4    ,  3279928.3    ,
     *   3489106.0    ,  3711818.7    ,  3948942.7    ,  4201410.8    ,
     *   4470215.9    ,
     *   2729460.2    ,  2902745.6    ,  3087241.2    ,  3283674.0    ,
     *   3492817.6    ,  3715495.3    ,  3952583.6    ,  4205015.4    ,
     *   4473783.9    ,
     *   2733303.9    ,  2906559.2    ,  3091023.3    ,  3287423.3    ,
     *   3496533.0    ,  3719176.0    ,  3956228.8    ,  4208624.5    ,
     *   4477356.4    ,
     *   2737149.8    ,  2910375.4    ,  3094808.4    ,  3291176.0    ,
     *   3500252.1    ,  3722860.6    ,  3959878.1    ,  4212237.9    ,
     *   4480933.2    ,
     *   2740997.5    ,  2914193.9    ,  3098596.2    ,  3294931.7    ,
     *   3503974.7    ,  3726548.9    ,  3963531.3    ,  4215855.3    ,
     *   4484514.4    ,
     *   2744846.8    ,  2918014.5    ,  3102386.5    ,  3298690.4    ,
     *   3507700.4    ,  3730240.7    ,  3967188.3    ,  4219476.7    ,
     *   4488099.6    ,
     *   2748697.5    ,  2921837.0    ,  3106179.1    ,  3302451.7    ,
     *   3511429.2    ,  3733935.9    ,  3970848.9    ,  4223101.9    ,
     *   4491688.7    ,
     *   2752549.2    ,  2925661.0    ,  3109973.8    ,  3306215.6    ,
     *   3515160.9    ,  3737634.2    ,  3974512.9    ,  4226730.8    ,
     *   4495281.7    ,
     *   2756401.8    ,  2929486.5    ,  3113770.4    ,  3309981.7    ,
     *   3518895.2    ,  3741335.5    ,  3978180.2    ,  4230363.1    ,
     *   4498878.3    /
        DATA ((ENTHV (J,K),J=64,72),K=19,27) /
     *   2760255.0    ,  2933313.1    ,  3117568.6    ,  3313749.9    ,
     *   3522632.0    ,  3745039.6    ,  3981850.5    ,  4233998.7    ,
     *   4502478.5    ,
     *   2764108.6    ,  2937140.7    ,  3121368.3    ,  3317520.1    ,
     *   3526371.1    ,  3748746.4    ,  3985523.8    ,  4237637.6    ,
     *   4506082.1    ,
     *   2767962.4    ,  2940969.0    ,  3125169.3    ,  3321291.9    ,
     *   3530112.3    ,  3752455.6    ,  3989199.9    ,  4241279.5    ,
     *   4509688.9    ,
     *   2771816.3    ,  2944797.9    ,  3128971.3    ,  3325065.3    ,
     *   3533855.5    ,  3756167.2    ,  3992878.6    ,  4244924.3    ,
     *   4513298.9    ,
     *   2775669.9    ,  2948627.1    ,  3132774.2    ,  3328840.0    ,
     *   3537600.4    ,  3759880.9    ,  3996559.7    ,  4248571.8    ,
     *   4516911.9    ,
     *   2779523.1    ,  2952456.6    ,  3136577.8    ,  3332616.0    ,
     *   3541347.0    ,  3763596.6    ,  4000243.3    ,  4252222.0    ,
     *   4520527.8    ,
     *   2783375.7    ,  2956286.0    ,  3140381.9    ,  3336392.9    ,
     *   3545095.0    ,  3767314.2    ,  4003929.0    ,  4255874.7    ,
     *   4524146.4    ,
     *   2787227.7    ,  2960115.3    ,  3144186.5    ,  3340170.7    ,
     *   3548844.4    ,  3771033.4    ,  4007616.8    ,  4259529.8    ,
     *   4527767.7    ,
     *   2791078.6    ,  2963944.2    ,  3147991.2    ,  3343949.3    ,
     *   3552594.9    ,  3774754.3    ,  4011306.6    ,  4263187.1    ,
     *   4531391.5    /
        DATA ((ENTHV (J,K),J=64,72),K=28,36) /
     *   2794928.5    ,  2967772.7    ,  3151796.0    ,  3347728.3    ,
     *   3556346.4    ,  3778476.6    ,  4014998.1    ,  4266846.6    ,
     *   4535017.8    ,
     *   2798777.2    ,  2971600.5    ,  3155600.6    ,  3351507.8    ,
     *   3560098.8    ,  3782200.1    ,  4018691.3    ,  4270508.1    ,
     *   4538646.3    ,
     *   2802624.5    ,  2975427.5    ,  3159405.1    ,  3355287.6    ,
     *   3563851.9    ,  3785924.9    ,  4022386.0    ,  4274171.4    ,
     *   4542277.0    ,
     *   2806470.2    ,  2979253.5    ,  3163209.1    ,  3359067.5    ,
     *   3567605.7    ,  3789650.7    ,  4026082.2    ,  4277836.5    ,
     *   4545909.8    ,
     *   2810314.2    ,  2983078.5    ,  3167012.6    ,  3362847.3    ,
     *   3571359.9    ,  3793377.3    ,  4029779.7    ,  4281503.3    ,
     *   4549544.5    ,
     *   2814156.5    ,  2986902.2    ,  3170815.5    ,  3366627.1    ,
     *   3575114.4    ,  3797104.8    ,  4033478.4    ,  4285171.6    ,
     *   4553181.1    ,
     *   2817996.8    ,  2990724.6    ,  3174617.5    ,  3370406.5    ,
     *   3578869.2    ,  3800832.9    ,  4037178.1    ,  4288841.4    ,
     *   4556819.5    ,
     *   2821835.0    ,  2994545.5    ,  3178418.7    ,  3374185.6    ,
     *   3582624.1    ,  3804561.6    ,  4040878.8    ,  4292512.5    ,
     *   4560459.5    ,
     *   2825671.0    ,  2998364.8    ,  3182218.8    ,  3377964.2    ,
     *   3586378.9    ,  3808290.7    ,  4044580.3    ,  4296184.8    ,
     *   4564101.1    /
        DATA ((ENTHV (J,K),J=64,72),K=37,45) /
     *   2829504.8    ,  3002182.4    ,  3186017.7    ,  3381742.1    ,
     *   3590133.6    ,  3812020.2    ,  4048282.6    ,  4299858.2    ,
     *   4567744.1    ,
     *   2833336.1    ,  3005998.2    ,  3189815.4    ,  3385519.3    ,
     *   3593888.1    ,  3815749.8    ,  4051985.5    ,  4303532.7    ,
     *   4571388.5    ,
     *   2837164.9    ,  3009812.0    ,  3193611.7    ,  3389295.7    ,
     *   3597642.2    ,  3819479.6    ,  4055689.0    ,  4307208.0    ,
     *   4575034.2    ,
     *   2840991.1    ,  3013623.8    ,  3197406.6    ,  3393071.1    ,
     *   3601395.9    ,  3823209.4    ,  4059392.9    ,  4310884.2    ,
     *   4578681.1    ,
     *   2844814.6    ,  3017433.5    ,  3201199.8    ,  3396845.4    ,
     *   3605149.0    ,  3826939.0    ,  4063097.1    ,  4314561.2    ,
     *   4582329.0    ,
     *   2848635.3    ,  3021240.9    ,  3204991.4    ,  3400618.6    ,
     *   3608901.4    ,  3830668.5    ,  4066801.6    ,  4318238.8    ,
     *   4585978.0    ,
     *   2852453.1    ,  3025046.0    ,  3208781.1    ,  3404390.5    ,
     *   3612653.1    ,  3834397.7    ,  4070506.3    ,  4321916.9    ,
     *   4589627.9    ,
     *   2856267.8    ,  3028848.7    ,  3212569.0    ,  3408161.1    ,
     *   3616404.0    ,  3838126.6    ,  4074211.0    ,  4325595.5    ,
     *   4593278.6    ,
     *   2860079.6    ,  3032648.8    ,  3216355.0    ,  3411930.3    ,
     *   3620153.9    ,  3841854.9    ,  4077915.6    ,  4329274.5    ,
     *   4596930.0    /
        DATA ((ENTHV (J,K),J=64,72),K=46,54) /
     *   2863888.1    ,  3036446.4    ,  3220138.9    ,  3415697.9    ,
     *   3623902.8    ,  3845582.8    ,  4081620.2    ,  4332953.7    ,
     *   4600582.2    ,
     *   2867693.5    ,  3040241.3    ,  3223920.6    ,  3419463.9    ,
     *   3627650.5    ,  3849309.9    ,  4085324.5    ,  4336633.2    ,
     *   4604234.9    ,
     *   2871495.5    ,  3044033.5    ,  3227700.2    ,  3423228.2    ,
     *   3631397.1    ,  3853036.4    ,  4089028.6    ,  4340312.8    ,
     *   4607888.1    ,
     *   2875294.2    ,  3047822.8    ,  3231477.5    ,  3426990.8    ,
     *   3635142.4    ,  3856762.0    ,  4092732.3    ,  4343992.5    ,
     *   4611541.7    ,
     *   2879089.5    ,  3051609.3    ,  3235252.4    ,  3430751.5    ,
     *   3638886.4    ,  3860486.8    ,  4096435.6    ,  4347672.1    ,
     *   4615195.8    ,
     *   2882881.2    ,  3055392.7    ,  3239024.8    ,  3434510.3    ,
     *   3642628.9    ,  3864210.6    ,  4100138.4    ,  4351351.7    ,
     *   4618850.1    ,
     *   2886669.4    ,  3059173.2    ,  3242794.8    ,  3438267.1    ,
     *   3646370.0    ,  3867933.4    ,  4103840.6    ,  4355031.0    ,
     *   4622504.6    ,
     *   2890454.0    ,  3062950.6    ,  3246562.2    ,  3442021.8    ,
     *   3650109.4    ,  3871655.1    ,  4107542.1    ,  4358710.2    ,
     *   4626159.2    ,
     *   2894234.9    ,  3066724.8    ,  3250327.0    ,  3445774.4    ,
     *   3653847.2    ,  3875375.6    ,  4111242.9    ,  4362389.0    ,
     *   4629814.0    /
        DATA ((ENTHV (J,K),J=64,72),K=55,63) /
     *   2898012.1    ,  3070495.8    ,  3254089.0    ,  3449524.8    ,
     *   3657583.3    ,  3879094.8    ,  4114942.8    ,  4366067.4    ,
     *   4633468.7    ,
     *   2901785.6    ,  3074263.5    ,  3257848.3    ,  3453272.9    ,
     *   3661317.6    ,  3882812.8    ,  4118642.0    ,  4369745.4    ,
     *   4637123.4    ,
     *   2905555.2    ,  3078028.0    ,  3261604.8    ,  3457018.8    ,
     *   3665050.1    ,  3886529.3    ,  4122340.2    ,  4373422.9    ,
     *   4640777.9    ,
     *   2909320.9    ,  3081789.0    ,  3265358.4    ,  3460762.2    ,
     *   3668780.7    ,  3890244.5    ,  4126037.3    ,  4377099.8    ,
     *   4644432.3    ,
     *   2913082.8    ,  3085546.7    ,  3269109.1    ,  3464503.2    ,
     *   3672509.3    ,  3893958.1    ,  4129733.5    ,  4380776.0    ,
     *   4648086.4    ,
     *   2916840.7    ,  3089300.9    ,  3272856.9    ,  3468241.7    ,
     *   3676235.9    ,  3897670.2    ,  4133428.5    ,  4384451.6    ,
     *   4651740.3    ,
     *   2920594.6    ,  3093051.6    ,  3276601.6    ,  3471977.7    ,
     *   3679960.4    ,  3901380.6    ,  4137122.3    ,  4388126.3    ,
     *   4655393.7    ,
     *   2924344.5    ,  3096798.7    ,  3280343.2    ,  3475711.0    ,
     *   3683682.8    ,  3905089.4    ,  4140814.9    ,  4391800.3    ,
     *   4659046.7    ,
     *   2928090.3    ,  3100542.3    ,  3284081.7    ,  3479441.8    ,
     *   3687403.1    ,  3908796.4    ,  4144506.2    ,  4395473.4    ,
     *   4662699.3    /
        DATA ((ENTHV (J,K),J=64,72),K=64,72) /
     *   2931832.0    ,  3104282.2    ,  3287817.1    ,  3483169.8    ,
     *   3691121.0    ,  3912501.7    ,  4148196.2    ,  4399145.6    ,
     *   4666351.3    ,
     *   2935569.6    ,  3108018.4    ,  3291549.2    ,  3486895.1    ,
     *   3694836.7    ,  3916205.1    ,  4151884.7    ,  4402816.7    ,
     *   4670002.7    ,
     *   2939303.1    ,  3111751.0    ,  3295278.1    ,  3490617.6    ,
     *   3698550.1    ,  3919906.7    ,  4155571.8    ,  4406486.9    ,
     *   4673653.5    ,
     *   2943032.4    ,  3115479.8    ,  3299003.7    ,  3494337.3    ,
     *   3702261.1    ,  3923606.3    ,  4159257.4    ,  4410155.9    ,
     *   4677303.5    ,
     *   2946757.4    ,  3119204.9    ,  3302726.1    ,  3498054.1    ,
     *   3705969.7    ,  3927303.9    ,  4162941.5    ,  4413823.8    ,
     *   4680952.9    ,
     *   2950478.3    ,  3122926.1    ,  3306445.0    ,  3501768.0    ,
     *   3709675.8    ,  3930999.5    ,  4166623.9    ,  4417490.5    ,
     *   4684601.4    ,
     *   2954194.9    ,  3126643.5    ,  3310160.6    ,  3505479.0    ,
     *   3713379.4    ,  3934693.1    ,  4170304.7    ,  4421156.0    ,
     *   4688249.1    ,
     *   2957907.2    ,  3130357.1    ,  3313872.7    ,  3509187.0    ,
     *   3717080.5    ,  3938384.5    ,  4173983.8    ,  4424820.2    ,
     *   4691895.9    ,
     *   2961615.2    ,  3134066.8    ,  3317581.4    ,  3512891.9    ,
     *   3720779.0    ,  3942073.8    ,  4177661.2    ,  4428483.1    ,
     *   4695541.7    /
        DATA ((ENTHV (J,K),J=64,72),K=73,81) /
     *   2965318.9    ,  3137772.6    ,  3321286.7    ,  3516593.9    ,
     *   3724474.9    ,  3945760.9    ,  4181336.8    ,  4432144.6    ,
     *   4699186.6    ,
     *   2969018.2    ,  3141474.5    ,  3324988.4    ,  3520292.7    ,
     *   3728168.1    ,  3949445.7    ,  4185010.6    ,  4435804.7    ,
     *   4702830.4    ,
     *   2972713.2    ,  3145172.4    ,  3328686.5    ,  3523988.4    ,
     *   3731858.6    ,  3953128.3    ,  4188682.5    ,  4439463.3    ,
     *   4706473.2    ,
     *   2976403.9    ,  3148866.3    ,  3332381.1    ,  3527681.0    ,
     *   3735546.4    ,  3956808.5    ,  4192352.5    ,  4443120.4    ,
     *   4710114.8    ,
     *   2980090.2    ,  3152556.3    ,  3336072.2    ,  3531370.4    ,
     *   3739231.4    ,  3960486.4    ,  4196020.6    ,  4446776.0    ,
     *   4713755.3    ,
     *   2983772.0    ,  3156242.3    ,  3339759.6    ,  3535056.6    ,
     *   3742913.6    ,  3964162.0    ,  4199686.7    ,  4450430.0    ,
     *   4717394.6    ,
     *   2987449.5    ,  3159924.2    ,  3343443.4    ,  3538739.5    ,
     *   3746593.0    ,  3967835.1    ,  4203350.8    ,  4454082.3    ,
     *   4721032.7    ,
     *   2991122.5    ,  3163602.1    ,  3347123.5    ,  3542419.2    ,
     *   3750269.6    ,  3971505.7    ,  4207012.8    ,  4457733.1    ,
     *   4724669.4    ,
     *   2994791.2    ,  3167275.9    ,  3350800.0    ,  3546095.7    ,
     *   3753943.3    ,  3975173.9    ,  4210672.8    ,  4461382.1    ,
     *   4728304.9    /
        DATA ((ENTHV (J,K),J=73,81),K= 1, 9) /
     *   4724868.8    ,  5029922.2    ,  5354692.7    ,  5700454.5    ,
     *   6068564.6    ,  6460467.4    ,  6877700.6    ,  7321901.6    ,
     *   7794813.4    ,
     *   4728351.5    ,  5033367.9    ,  5358101.4    ,  5703826.5    ,
     *   6071900.0    ,  6463766.4    ,  6880963.6    ,  7325128.8    ,
     *   7798005.2    ,
     *   4731840.2    ,  5036819.5    ,  5361516.0    ,  5707204.2    ,
     *   6075240.9    ,  6467070.8    ,  6884231.7    ,  7328361.0    ,
     *   7801201.9    ,
     *   4735334.7    ,  5040276.9    ,  5364936.2    ,  5710587.3    ,
     *   6078587.2    ,  6470380.4    ,  6887505.0    ,  7331598.2    ,
     *   7804403.4    ,
     *   4738834.9    ,  5043739.8    ,  5368361.9    ,  5713975.9    ,
     *   6081938.8    ,  6473695.2    ,  6890783.3    ,  7334840.4    ,
     *   7807609.7    ,
     *   4742340.6    ,  5047208.2    ,  5371793.0    ,  5717369.8    ,
     *   6085295.6    ,  6477015.1    ,  6894066.6    ,  7338087.3    ,
     *   7810820.6    ,
     *   4745851.6    ,  5050681.9    ,  5375229.4    ,  5720768.8    ,
     *   6088657.5    ,  6480340.1    ,  6897354.8    ,  7341339.1    ,
     *   7814036.3    ,
     *   4749367.8    ,  5054160.7    ,  5378670.9    ,  5724173.0    ,
     *   6092024.4    ,  6483669.9    ,  6900647.8    ,  7344595.5    ,
     *   7817256.5    ,
     *   4752889.0    ,  5057644.7    ,  5382117.4    ,  5727582.1    ,
     *   6095396.2    ,  6487004.6    ,  6903945.5    ,  7347856.6    ,
     *   7820481.2    /
        DATA ((ENTHV (J,K),J=73,81),K=10,18) /
     *   4756415.1    ,  5061133.5    ,  5385568.8    ,  5730996.1    ,
     *   6098772.9    ,  6490344.0    ,  6907247.9    ,  7351122.2    ,
     *   7823710.3    ,
     *   4759946.0    ,  5064627.1    ,  5389025.0    ,  5734414.9    ,
     *   6102154.2    ,  6493688.1    ,  6910554.9    ,  7354392.3    ,
     *   7826943.9    ,
     *   4763481.5    ,  5068125.4    ,  5392485.9    ,  5737838.3    ,
     *   6105540.2    ,  6497036.7    ,  6913866.3    ,  7357666.8    ,
     *   7830181.8    ,
     *   4767021.5    ,  5071628.2    ,  5395951.3    ,  5741266.3    ,
     *   6108930.8    ,  6500389.9    ,  6917182.3    ,  7360945.7    ,
     *   7833423.9    ,
     *   4770565.8    ,  5075135.4    ,  5399421.2    ,  5744698.8    ,
     *   6112325.7    ,  6503747.4    ,  6920502.5    ,  7364228.9    ,
     *   7836670.3    ,
     *   4774114.4    ,  5078646.9    ,  5402895.5    ,  5748135.6    ,
     *   6115725.0    ,  6507109.3    ,  6923827.1    ,  7367516.3    ,
     *   7839920.8    ,
     *   4777667.0    ,  5082162.6    ,  5406373.9    ,  5751576.6    ,
     *   6119128.6    ,  6510475.5    ,  6927155.8    ,  7370807.9    ,
     *   7843175.4    ,
     *   4781223.6    ,  5085682.3    ,  5409856.5    ,  5755021.8    ,
     *   6122536.4    ,  6513845.7    ,  6930488.7    ,  7374103.5    ,
     *   7846434.0    ,
     *   4784783.9    ,  5089206.0    ,  5413343.1    ,  5758471.1    ,
     *   6125948.2    ,  6517220.1    ,  6933825.7    ,  7377403.2    ,
     *   7849696.6    /
        DATA ((ENTHV (J,K),J=73,81),K=19,27) /
     *   4788348.0    ,  5092733.4    ,  5416833.5    ,  5761924.4    ,
     *   6129364.1    ,  6520598.5    ,  6937166.7    ,  7380706.9    ,
     *   7852963.2    ,
     *   4791915.6    ,  5096264.6    ,  5420327.8    ,  5765381.5    ,
     *   6132783.8    ,  6523980.8    ,  6940511.6    ,  7384014.4    ,
     *   7856233.5    ,
     *   4795486.7    ,  5099799.4    ,  5423825.8    ,  5768842.4    ,
     *   6136207.4    ,  6527367.0    ,  6943860.3    ,  7387325.8    ,
     *   7859507.7    ,
     *   4799061.2    ,  5103337.6    ,  5427327.4    ,  5772306.9    ,
     *   6139634.7    ,  6530756.9    ,  6947212.8    ,  7390641.0    ,
     *   7862785.7    ,
     *   4802638.8    ,  5106879.2    ,  5430832.5    ,  5775775.1    ,
     *   6143065.7    ,  6534150.6    ,  6950569.1    ,  7393959.9    ,
     *   7866067.3    ,
     *   4806219.5    ,  5110424.1    ,  5434341.0    ,  5779246.8    ,
     *   6146500.3    ,  6537547.9    ,  6953929.0    ,  7397282.4    ,
     *   7869352.6    ,
     *   4809803.2    ,  5113972.1    ,  5437852.8    ,  5782721.9    ,
     *   6149938.4    ,  6540948.7    ,  6957292.5    ,  7400608.5    ,
     *   7872641.4    ,
     *   4813389.8    ,  5117523.2    ,  5441367.8    ,  5786200.3    ,
     *   6153379.9    ,  6544353.0    ,  6960659.5    ,  7403938.2    ,
     *   7875933.8    ,
     *   4816979.1    ,  5121077.3    ,  5444885.9    ,  5789682.0    ,
     *   6156824.7    ,  6547760.7    ,  6964029.9    ,  7407271.3    ,
     *   7879229.6    /
        DATA ((ENTHV (J,K),J=73,81),K=28,36) /
     *   4820571.1    ,  5124634.2    ,  5448407.0    ,  5793166.8    ,
     *   6160272.8    ,  6551171.8    ,  6967403.8    ,  7410607.9    ,
     *   7882528.9    ,
     *   4824165.6    ,  5128193.9    ,  5451931.1    ,  5796654.7    ,
     *   6163724.1    ,  6554586.1    ,  6970780.9    ,  7413947.8    ,
     *   7885831.5    ,
     *   4827762.6    ,  5131756.2    ,  5455458.0    ,  5800145.6    ,
     *   6167178.5    ,  6558003.6    ,  6974161.4    ,  7417291.0    ,
     *   7889137.5    ,
     *   4831361.9    ,  5135321.1    ,  5458987.7    ,  5803639.4    ,
     *   6170635.9    ,  6561424.3    ,  6977545.0    ,  7420637.4    ,
     *   7892446.7    ,
     *   4834963.5    ,  5138888.5    ,  5462520.1    ,  5807136.1    ,
     *   6174096.3    ,  6564848.0    ,  6980931.7    ,  7423987.0    ,
     *   7895759.1    ,
     *   4838567.2    ,  5142458.2    ,  5466055.0    ,  5810635.4    ,
     *   6177559.5    ,  6568274.7    ,  6984321.6    ,  7427339.8    ,
     *   7899074.7    ,
     *   4842172.9    ,  5146030.3    ,  5469592.4    ,  5814137.5    ,
     *   6181025.6    ,  6571704.4    ,  6987714.4    ,  7430695.6    ,
     *   7902393.4    ,
     *   4845780.6    ,  5149604.5    ,  5473132.3    ,  5817642.2    ,
     *   6184494.4    ,  6575136.9    ,  6991110.2    ,  7434054.4    ,
     *   7905715.1    ,
     *   4849390.1    ,  5153180.8    ,  5476674.5    ,  5821149.3    ,
     *   6187966.0    ,  6578572.2    ,  6994508.9    ,  7437416.2    ,
     *   7909039.9    /
        DATA ((ENTHV (J,K),J=73,81),K=37,45) /
     *   4853001.4    ,  5156759.2    ,  5480218.9    ,  5824659.0    ,
     *   6191440.1    ,  6582010.2    ,  6997910.4    ,  7440781.0    ,
     *   7912367.6    ,
     *   4856614.4    ,  5160339.5    ,  5483765.5    ,  5828171.0    ,
     *   6194916.7    ,  6585450.9    ,  7001314.7    ,  7444148.5    ,
     *   7915698.2    ,
     *   4860229.0    ,  5163921.7    ,  5487314.2    ,  5831685.2    ,
     *   6198395.8    ,  6588894.2    ,  7004721.7    ,  7447518.9    ,
     *   7919031.7    ,
     *   4863845.0    ,  5167505.7    ,  5490864.9    ,  5835201.8    ,
     *   6201877.3    ,  6592340.0    ,  7008131.4    ,  7450892.0    ,
     *   7922368.0    ,
     *   4867462.5    ,  5171091.3    ,  5494417.5    ,  5838720.4    ,
     *   6205361.2    ,  6595788.4    ,  7011543.7    ,  7454267.8    ,
     *   7925707.1    ,
     *   4871081.3    ,  5174678.6    ,  5497972.1    ,  5842241.2    ,
     *   6208847.3    ,  6599239.1    ,  7014958.5    ,  7457646.3    ,
     *   7929048.9    ,
     *   4874701.3    ,  5178267.3    ,  5501528.4    ,  5845763.9    ,
     *   6212335.6    ,  6602692.2    ,  7018375.8    ,  7461027.4    ,
     *   7932393.4    ,
     *   4878322.5    ,  5181857.6    ,  5505086.4    ,  5849288.7    ,
     *   6215826.0    ,  6606147.7    ,  7021795.6    ,  7464411.0    ,
     *   7935740.5    ,
     *   4881944.8    ,  5185449.2    ,  5508646.1    ,  5852815.2    ,
     *   6219318.6    ,  6609605.3    ,  7025217.7    ,  7467797.1    ,
     *   7939090.2    /
        DATA ((ENTHV (J,K),J=73,81),K=46,54) /
     *   4885568.1    ,  5189042.2    ,  5512207.4    ,  5856343.7    ,
     *   6222813.1    ,  6613065.2    ,  7028642.2    ,  7471185.6    ,
     *   7942442.4    ,
     *   4889192.3    ,  5192636.4    ,  5515770.1    ,  5859873.8    ,
     *   6226309.6    ,  6616527.2    ,  7032068.9    ,  7474576.6    ,
     *   7945797.1    ,
     *   4892817.4    ,  5196231.7    ,  5519334.3    ,  5863405.7    ,
     *   6229808.0    ,  6619991.2    ,  7035497.9    ,  7477969.9    ,
     *   7949154.2    ,
     *   4896443.2    ,  5199828.1    ,  5522899.9    ,  5866939.1    ,
     *   6233308.3    ,  6623457.3    ,  7038929.1    ,  7481365.5    ,
     *   7952513.8    ,
     *   4900069.8    ,  5203425.6    ,  5526466.8    ,  5870474.1    ,
     *   6236810.3    ,  6626925.4    ,  7042362.4    ,  7484763.3    ,
     *   7955875.7    ,
     *   4903697.0    ,  5207024.0    ,  5530034.9    ,  5874010.7    ,
     *   6240314.0    ,  6630395.3    ,  7045797.7    ,  7488163.4    ,
     *   7959240.0    ,
     *   4907324.8    ,  5210623.3    ,  5533604.3    ,  5877548.6    ,
     *   6243819.4    ,  6633867.2    ,  7049235.1    ,  7491565.6    ,
     *   7962606.5    ,
     *   4910953.1    ,  5214223.5    ,  5537174.7    ,  5881087.9    ,
     *   6247326.4    ,  6637340.8    ,  7052674.4    ,  7494969.9    ,
     *   7965975.2    ,
     *   4914581.8    ,  5217824.4    ,  5540746.2    ,  5884628.6    ,
     *   6250835.0    ,  6640816.1    ,  7056115.7    ,  7498376.4    ,
     *   7969346.2    /
        DATA ((ENTHV (J,K),J=73,81),K=55,63) /
     *   4918210.8    ,  5221426.0    ,  5544318.7    ,  5888170.5    ,
     *   6254345.1    ,  6644293.2    ,  7059558.9    ,  7501784.8    ,
     *   7972719.2    ,
     *   4921840.2    ,  5225028.2    ,  5547892.1    ,  5891713.6    ,
     *   6257856.6    ,  6647771.9    ,  7063003.8    ,  7505195.2    ,
     *   7976094.4    ,
     *   4925469.8    ,  5228631.0    ,  5551466.4    ,  5895257.9    ,
     *   6261369.4    ,  6651252.3    ,  7066450.6    ,  7508607.6    ,
     *   7979471.7    ,
     *   4929099.6    ,  5232234.3    ,  5555041.5    ,  5898803.2    ,
     *   6264883.7    ,  6654734.2    ,  7069899.1    ,  7512021.8    ,
     *   7982851.0    ,
     *   4932729.5    ,  5235838.1    ,  5558617.4    ,  5902349.6    ,
     *   6268399.2    ,  6658217.5    ,  7073349.3    ,  7515437.9    ,
     *   7986232.2    ,
     *   4936359.5    ,  5239442.3    ,  5562194.0    ,  5905897.0    ,
     *   6271915.9    ,  6661702.4    ,  7076801.1    ,  7518855.8    ,
     *   7989615.4    ,
     *   4939989.5    ,  5243046.8    ,  5565771.2    ,  5909445.3    ,
     *   6275433.8    ,  6665188.6    ,  7080254.5    ,  7522275.5    ,
     *   7993000.6    ,
     *   4943619.4    ,  5246651.6    ,  5569349.0    ,  5912994.5    ,
     *   6278952.9    ,  6668676.2    ,  7083709.5    ,  7525696.9    ,
     *   7996387.6    ,
     *   4947249.2    ,  5250256.6    ,  5572927.4    ,  5916544.5    ,
     *   6282473.0    ,  6672165.1    ,  7087166.0    ,  7529119.9    ,
     *   7999776.4    /
        DATA ((ENTHV (J,K),J=73,81),K=64,72) /
     *   4950878.8    ,  5253861.8    ,  5576506.3    ,  5920095.3    ,
     *   6285994.2    ,  6675655.3    ,  7090624.0    ,  7532544.7    ,
     *   8003167.0    ,
     *   4954508.2    ,  5257467.1    ,  5580085.6    ,  5923646.8    ,
     *   6289516.3    ,  6679146.7    ,  7094083.4    ,  7535971.0    ,
     *   8006559.3    ,
     *   4958137.4    ,  5261072.5    ,  5583665.2    ,  5927199.0    ,
     *   6293039.4    ,  6682639.2    ,  7097544.1    ,  7539398.9    ,
     *   8009953.4    ,
     *   4961766.2    ,  5264677.9    ,  5587245.3    ,  5930751.9    ,
     *   6296563.4    ,  6686132.9    ,  7101006.3    ,  7542828.3    ,
     *   8013349.2    ,
     *   4965394.6    ,  5268283.3    ,  5590825.6    ,  5934305.3    ,
     *   6300088.3    ,  6689627.7    ,  7104469.7    ,  7546259.2    ,
     *   8016746.6    ,
     *   4969022.6    ,  5271888.6    ,  5594406.1    ,  5937859.2    ,
     *   6303613.9    ,  6693123.5    ,  7107934.3    ,  7549691.5    ,
     *   8020145.6    ,
     *   4972650.2    ,  5275493.8    ,  5597986.9    ,  5941413.7    ,
     *   6307140.3    ,  6696620.4    ,  7111400.2    ,  7553125.2    ,
     *   8023546.1    ,
     *   4976277.2    ,  5279098.8    ,  5601567.8    ,  5944968.6    ,
     *   6310667.5    ,  6700118.2    ,  7114867.3    ,  7556560.4    ,
     *   8026948.3    ,
     *   4979903.6    ,  5282703.5    ,  5605148.8    ,  5948523.9    ,
     *   6314195.3    ,  6703616.9    ,  7118335.5    ,  7559996.8    ,
     *   8030351.9    /
        DATA ((ENTHV (J,K),J=73,81),K=73,81) /
     *   4983529.4    ,  5286308.0    ,  5608729.9    ,  5952079.5    ,
     *   6317723.7    ,  6707116.5    ,  7121804.8    ,  7563434.5    ,
     *   8033756.9    ,
     *   4987154.6    ,  5289912.2    ,  5612310.9    ,  5955635.5    ,
     *   6321252.7    ,  6710616.9    ,  7125275.1    ,  7566873.5    ,
     *   8037163.4    ,
     *   4990779.1    ,  5293516.1    ,  5615892.0    ,  5959191.7    ,
     *   6324782.3    ,  6714118.1    ,  7128746.5    ,  7570313.8    ,
     *   8040571.4    ,
     *   4994402.8    ,  5297119.5    ,  5619472.9    ,  5962748.1    ,
     *   6328312.4    ,  6717620.1    ,  7132218.9    ,  7573755.2    ,
     *   8043980.6    ,
     *   4998025.7    ,  5300722.5    ,  5623053.8    ,  5966304.8    ,
     *   6331842.9    ,  6721122.8    ,  7135692.2    ,  7577197.7    ,
     *   8047391.2    ,
     *   5001647.8    ,  5304325.0    ,  5626634.5    ,  5969861.6    ,
     *   6335373.9    ,  6724626.2    ,  7139166.5    ,  7580641.4    ,
     *   8050803.1    ,
     *   5005269.0    ,  5307927.0    ,  5630215.0    ,  5973418.5    ,
     *   6338905.2    ,  6728130.2    ,  7142641.6    ,  7584086.2    ,
     *   8054216.3    ,
     *   5008889.3    ,  5311528.4    ,  5633795.2    ,  5976975.5    ,
     *   6342436.9    ,  6731634.9    ,  7146117.5    ,  7587532.0    ,
     *   8057630.7    ,
     *   5012508.7    ,  5315129.3    ,  5637375.2    ,  5980532.5    ,
     *   6345968.9    ,  6735140.1    ,  7149594.3    ,  7590978.8    ,
     *   8061046.3    /
        DATA ((ENTRV (J,K),J= 1, 9),K= 1, 9) /
     *   27789.195    ,  28114.448    ,  28439.702    ,  28764.955    ,
     *   29090.207    ,  29415.460    ,  29740.712    ,  30065.964    ,
     *   30391.216    ,
     *   3812.0704    ,  4290.3654    ,  4755.9659    ,  5207.0324    ,
     *   5643.5490    ,  6066.4613    ,  6477.1302    ,  6877.0095    ,
     *   7267.4804    ,
     *   2326.1216    ,  2695.2554    ,  3081.7310    ,  3481.8677    ,
     *   3891.1735    ,  4305.1587    ,  4719.9979    ,  5132.8096    ,
     *   5541.6259    ,
     *   1728.4862    ,  2040.2966    ,  2367.7841    ,  2710.3295    ,
     *   3066.7785    ,  3435.3913    ,  3813.9050    ,  4199.7255    ,
     *   4590.2014    ,
     *   1358.2767    ,  1642.0679    ,  1939.6141    ,  2250.6853    ,
     *   2574.8388    ,  2911.3685    ,  3259.2626    ,  3617.1863    ,
     *   3983.5125    ,
     *   1087.8507    ,  1354.3743    ,  1633.6040    ,  1925.3483    ,
     *   2229.2997    ,  2545.0138    ,  2871.8852    ,  3209.1219    ,
     *   3555.7295    ,
     *   874.10695    ,  1128.4239    ,  1394.8509    ,  1673.1859    ,
     *   1963.1448    ,  2264.3556    ,  2576.3480    ,  2898.5397    ,
     *   3230.2220    ,
     *   697.25842    ,  942.20098    ,  1198.8914    ,  1467.1123    ,
     *   1746.5789    ,  2036.9400    ,  2337.7755    ,  2648.5902    ,
     *   2968.8061    ,
     *   546.49446    ,  783.84356    ,  1032.7068    ,  1292.8543    ,
     *   1563.9962    ,  1845.7867    ,  2137.8262    ,  2439.6596    ,
     *   2750.7730    /
        DATA ((ENTRV (J,K),J= 1, 9),K=10,18) /
     *   415.21561    ,  646.18698    ,  888.51371    ,  1141.9569    ,
     *   1406.2218    ,  1680.9634    ,  1965.7914    ,  2260.2711    ,
     *   2563.9235    ,
     *   299.07281    ,  524.54843    ,  761.26597    ,  1008.9808    ,
     *   1267.3944    ,  1536.1618    ,  1814.8974    ,  2103.1782    ,
     *   2400.5456    ,
     *   195.03563    ,  415.68588    ,  647.49268    ,  890.20840    ,
     *   1143.5324    ,  1407.1198    ,  1680.5880    ,  1963.5216    ,
     *   2255.4751    ,
     *   100.90088    ,  317.25460    ,  544.69674    ,  782.97910    ,
     *   1031.8007    ,  1290.8171    ,  1559.6484    ,  1837.8846    ,
     *   2125.0896    ,
     *   15.012404    ,  227.49966    ,  451.01731    ,  685.31887    ,
     *   930.10450    ,  1185.0314    ,  1449.7222    ,  1723.7713    ,
     *   2006.7499    ,
     *  -63.908863    ,  145.07071    ,  365.02785    ,  595.71998    ,
     *   836.85004    ,  1088.0777    ,  1349.0286    ,  1619.3014    ,
     *   1898.4728    ,
     *  -136.87312    ,  68.904744    ,  285.60901    ,  513.00314    ,
     *   750.79447    ,  998.64627    ,  1256.1877    ,  1523.0214    ,
     *   1798.7295    ,
     *  -204.69342    , -1.8512296    ,  211.86516    ,  436.22741    ,
     *   670.94889    ,  915.69763    ,  1170.1070    ,  1433.7839    ,
     *   1706.3156    ,
     *  -268.03487    , -67.893039    ,  143.06762    ,  364.62921    ,
     *   596.51281    ,  838.39244    ,  1089.9064    ,  1350.6665    ,
     *   1620.2647    /
        DATA ((ENTRV (J,K),J= 1, 9),K=19,27) /
     *  -327.44927    , -129.79642    ,  78.614998    ,  297.57980    ,
     *   526.82857    ,  766.04260    ,  1014.8661    ,  1272.9160    ,
     *   1539.7894    ,
     *  -383.40016    , -188.04373    ,  18.004625    ,  234.55485    ,
     *   461.34887    ,  698.07658    ,  944.38909    ,  1199.9091    ,
     *   1464.2393    ,
     *  -436.28127    , -243.04360    , -39.188318    ,  175.11217    ,
     *   399.61303    ,  634.01427    ,  877.97490    ,  1131.1242    ,
     *   1393.0705    ,
     *  -486.43042    , -295.14565    , -93.326451    ,  118.87509    ,
     *   341.22942    ,  573.44816    ,  815.19938    ,  1066.1197    ,
     *   1325.8236    ,
     *  -534.14010    , -344.65174    , -144.72209    ,  65.519896    ,
     *   285.86205    ,  516.02927    ,  755.69987    ,  1004.5186    ,
     *   1262.1069    ,
     *  -579.66566    , -391.82459    , -193.64639    ,  14.766089    ,
     *   233.22036    ,  461.45628    ,  699.16370    ,  945.99648    ,
     *   1201.5835    ,
     *  -623.23181    , -436.89463    , -240.33656    , -33.631149    ,
     *   183.05119    ,  409.46710    ,  645.31931    ,  890.27179    ,
     *   1143.9616    ,
     *  -665.03767    , -480.06536    , -285.00150    , -79.886956    ,
     *   135.13250    ,  359.83220    ,  593.92922    ,  837.09870    ,
     *   1088.9866    ,
     *  -705.26092    , -521.51766    , -327.82637    , -124.19157    ,
     *   89.268330    ,  312.34937    ,  544.78449    ,  786.26116    ,
     *   1036.4351    /
        DATA ((ENTRV (J,K),J= 1, 9),K=28,36) /
     *  -744.06114    , -561.41333    , -368.97625    , -166.71416    ,
     *   45.284742    ,  266.83941    ,  497.70025    ,  737.56825    ,
     *   986.10976    ,
     *  -781.58255    , -599.89791    , -408.59913    , -207.60602    ,
     *   3.0265419    ,  223.14269    ,  452.51204    ,  690.85037    ,
     *   937.83560    ,
     *  -817.95623    , -637.10302    , -446.82837    , -247.00309    ,
     *  -37.645434    ,  181.11635    ,  409.07288    ,  645.95610    ,
     *   891.45651    ,
     *  -853.30203    , -673.14839    , -483.78477    , -285.02813    ,
     *  -76.856551    ,  140.63190    ,  367.25080    ,  602.74966    ,
     *   846.83265    ,
     *  -887.73018    , -708.14340    , -519.57823    , -321.79245    ,
     *  -114.72023    ,  101.57334    ,  326.92682    ,  561.10880    ,
     *   803.83824    ,
     *  -921.34256    , -742.18855    , -554.30923    , -357.39750    ,
     *  -151.33953    ,  63.835489    ,  287.99323    ,  520.92300    ,
     *   762.35972    ,
     *  -954.23390    , -775.37658    , -588.06999    , -391.93600    ,
     *  -186.80842    ,  27.322612    ,  250.35218    ,  482.09198    ,
     *   722.29417    ,
     *  -986.49276    , -807.79347    , -620.94558    , -425.49314    ,
     *  -221.21293    , -8.0527135    ,  213.91446    ,  444.52445    ,
     *   683.54796    ,
     *  -1018.2023    , -839.51935    , -653.01472    , -458.14741    ,
     *  -254.63211    , -42.370610    ,  178.59845    ,  408.13702    ,
     *   646.03571    /
        DATA ((ENTRV (J,K),J= 1, 9),K=37,45) /
     *  -1049.4413    , -870.62919    , -684.35061    , -489.97143    ,
     *  -287.13881    , -75.704746    ,  144.32928    ,  372.85328    ,
     *   609.67927    ,
     *  -1080.2843    , -901.19350    , -715.02155    , -521.03262    ,
     *  -318.80041    , -108.12306    ,  111.03803    ,  338.60302    ,
     *   574.40691    ,
     *  -1110.8027    , -931.27886    , -745.09156    , -551.39377    ,
     *  -349.67942    , -139.68840    ,  78.661069    ,  305.32156    ,
     *   540.15263    ,
     *  -1141.0651    , -960.94846    , -774.62083    , -581.11359    ,
     *  -379.83404    , -170.45908    ,  47.139533    ,  272.94912    ,
     *   506.85554    ,
     *  -1171.1377    , -990.26253    , -803.66622    , -610.24716    ,
     *  -409.31856    , -200.48933    ,  16.418784    ,  241.43034    ,
     *   474.45931    ,
     *  -1201.0848    , -1019.2788    , -832.28161    , -638.84630    ,
     *  -438.18385    , -229.82974    , -13.552007    ,  210.71382    ,
     *   442.91173    ,
     *  -1230.9691    , -1048.0526    , -860.51828    , -666.95994    ,
     *  -466.47765    , -258.52764    , -42.820241    ,  180.75173    ,
     *   412.16428    ,
     *  -1260.8525    , -1076.6378    , -888.42524    , -694.63443    ,
     *  -494.24492    , -286.62740    , -71.430230    ,  151.49945    ,
     *   382.17178    ,
     *  -1290.7958    , -1105.0864    , -916.04947    , -721.91382    ,
     *  -521.52811    , -314.17073    , -99.423490    ,  122.91527    ,
     *   352.89206    /
        DATA ((ENTRV (J,K),J= 1, 9),K=46,54) /
     *  -1320.8597    , -1133.4492    , -943.43622    , -748.84013    ,
     *  -548.36742    , -341.19692    , -126.83901    ,  94.960129    ,
     *   324.28571    ,
     *  -1351.1047    , -1161.7762    , -970.62920    , -775.45353    ,
     *  -574.80105    , -367.74310    , -153.71348    ,  67.597348    ,
     *   296.31579    ,
     *  -1381.5916    , -1190.1164    , -997.67088    , -801.79260    ,
     *  -600.86533    , -393.84442    , -180.08151    ,  40.792445    ,
     *   268.94766    ,
     *  -1412.3821    , -1218.5186    , -1024.6026    , -827.89449    ,
     *  -626.59498    , -419.53426    , -205.97580    ,  14.512923    ,
     *   242.14872    ,
     *  -1443.5386    , -1247.0310    , -1051.4649    , -853.79507    ,
     *  -652.02324    , -444.84436    , -231.42734    , -11.271897    ,
     *   215.88827    ,
     *  -1475.1252    , -1275.7022    , -1078.2974    , -879.52915    ,
     *  -677.18202    , -469.80498    , -256.46551    , -36.591031    ,
     *   190.13736    ,
     *  -1507.2078    , -1304.5807    , -1105.1394    , -905.13056    ,
     *  -702.10204    , -494.44506    , -281.11828    , -61.471973    ,
     *   164.86861    ,
     *  -1539.8544    , -1333.7157    , -1132.0297    , -930.63233    ,
     *  -726.81298    , -518.79234    , -305.41228    , -85.940820    ,
     *   140.05611    ,
     *  -1573.1359    , -1363.1569    , -1159.0070    , -956.06682    ,
     *  -751.34356    , -542.87341    , -329.37294    , -110.02239    ,
     *   115.67530    /
        DATA ((ENTRV (J,K),J= 1, 9),K=55,63) /
     *  -1607.1264    , -1392.9552    , -1186.1098    , -981.46582    ,
     *  -775.72167    , -566.71392    , -353.02460    , -133.74030    ,
     *   91.702844    ,
     *  -1641.9040    , -1423.1627    , -1213.3768    , -1006.8607    ,
     *  -799.97447    , -590.33859    , -376.39058    , -157.11713    ,
     *   68.116565    ,
     *  -1677.5513    , -1453.8330    , -1240.8470    , -1032.2824    ,
     *  -824.12849    , -613.77133    , -399.49326    , -180.17441    ,
     *   44.895328    ,
     *  -1714.1561    , -1485.0215    , -1268.5598    , -1057.7619    ,
     *  -848.20970    , -637.03531    , -422.35421    , -202.93279    ,
     *   22.018975    ,
     *  -1751.8126    , -1516.7858    , -1296.5552    , -1083.3297    ,
     *  -872.24361    , -660.15306    , -444.99421    , -225.41205    ,
     * -0.53175050    ,
     *  -1790.6219    , -1549.1863    , -1324.8741    , -1109.0167    ,
     *  -896.25536    , -683.14651    , -467.43334    , -247.63120    ,
     *  -22.775271    ,
     *  -1830.6940    , -1582.2862    , -1353.5581    , -1134.8535    ,
     *  -920.26978    , -706.03709    , -489.69103    , -269.60853    ,
     *  -44.729235    ,
     *  -1872.1481    , -1616.1522    , -1382.6503    , -1160.8714    ,
     *  -944.31148    , -728.84577    , -511.78613    , -291.36165    ,
     *  -66.410577    ,
     *  -1915.1156    , -1650.8549    , -1412.1950    , -1187.1016    ,
     *  -968.40491    , -751.59310    , -533.73697    , -312.90759    ,
     *  -87.835565    /
        DATA ((ENTRV (J,K),J= 1, 9),K=64,72) /
     *  -1959.7410    , -1686.4697    , -1442.2383    , -1213.5760    ,
     *  -992.57445    , -774.29932    , -555.56139    , -334.26280    ,
     *  -109.01985    ,
     *  -2006.1850    , -1723.0772    , -1472.8278    , -1240.3270    ,
     *  -1016.8445    , -796.98438    , -577.27680    , -355.44321    ,
     *  -129.97852    ,
     *  -2054.6277    , -1760.7641    , -1504.0138    , -1267.3876    ,
     *  -1041.2394    , -819.66799    , -598.90022    , -376.46427    ,
     *  -150.72612    ,
     *  -2105.2719    , -1799.6242    , -1535.8486    , -1294.7918    ,
     *  -1065.7838    , -842.36969    , -620.44834    , -397.34102    ,
     *  -171.27671    ,
     *  -2158.3483    , -1839.7594    , -1568.3876    , -1322.5744    ,
     *  -1090.5026    , -865.10888    , -641.93753    , -418.08807    ,
     *  -191.64388    ,
     *  -2214.1217    , -1881.2811    , -1601.6893    , -1350.7715    ,
     *  -1115.4207    , -887.90490    , -663.38390    , -438.71969    ,
     *  -211.84083    ,
     *  -2272.8988    , -1924.3118    , -1635.8159    , -1379.4203    ,
     *  -1140.5636    , -910.77703    , -684.80335    , -459.24979    ,
     *  -231.88033    ,
     *  -2335.0389    , -1968.9870    , -1670.8338    , -1408.5597    ,
     *  -1165.9573    , -933.74458    , -706.21155    , -479.69201    ,
     *  -251.77480    ,
     *  -2400.9682    , -2015.4573    , -1706.8141    , -1438.2300    ,
     *  -1191.6282    , -956.82694    , -727.62404    , -500.05971    ,
     *  -271.53634    /
        DATA ((ENTRV (J,K),J= 1, 9),K=73,81) /
     *  -2471.1989    , -2063.8916    , -1743.8333    , -1468.4736    ,
     *  -1217.6034    , -980.04360    , -749.05625    , -520.36598    ,
     *  -291.17671    ,
     *  -2546.3570    , -2114.4804    , -1781.9743    , -1499.3349    ,
     *  -1243.9107    , -1003.4142    , -770.52349    , -540.62373    ,
     *  -310.70741    ,
     *  -2627.2214    , -2167.4404    , -1821.3270    , -1530.8608    ,
     *  -1270.5788    , -1026.9587    , -792.04104    , -560.84566    ,
     *  -330.13965    ,
     *  -2714.7838    , -2223.0199    , -1861.9895    , -1563.1007    ,
     *  -1297.6372    , -1050.6971    , -813.62412    , -581.04430    ,
     *  -349.48444    ,
     *  -2810.3404    , -2281.5065    , -1904.0695    , -1596.1074    ,
     *  -1325.1166    , -1074.6500    , -835.28800    , -601.23204    ,
     *  -368.75252    ,
     *  -2915.6435    , -2343.2368    , -1947.6859    , -1629.9367    ,
     *  -1353.0488    , -1098.8381    , -857.04796    , -621.42117    ,
     *  -387.95446    ,
     *  -3033.1653    , -2408.6088    , -1992.9705    , -1664.6487    ,
     *  -1381.4671    , -1123.2829    , -878.91937    , -641.62385    ,
     *  -407.10063    ,
     *  -3166.5978    , -2478.1001    , -2040.0702    , -1700.3076    ,
     *  -1410.4061    , -1148.0061    , -900.91771    , -661.85220    ,
     *  -426.20126    ,
     *  -3321.9137    , -2552.2921    , -2089.1504    , -1736.9827    ,
     *  -1439.9022    , -1173.0300    , -923.05858    , -682.11826    ,
     *  -445.26640    /
        DATA ((ENTRV (J,K),J=10,18),K= 1, 9) /
     *   30716.468    ,  31041.720    ,  31366.971    ,  31692.222    ,
     *   32017.474    ,  32342.725    ,  32667.976    ,  32993.227    ,
     *   33318.478    ,
     *   7649.7824    ,  8024.9960    ,  8394.0503    ,  8757.7402    ,
     *   9116.7456    ,  9471.6496    ,  9822.9543    ,  10171.094    ,
     *   10516.446    ,
     *   5945.2285    ,  6342.9668    ,  6734.5992    ,  7120.1657    ,
     *   7499.8895    ,  7874.1038    ,  8243.1997    ,  8607.5907    ,
     *   8967.6901    ,
     *   4982.8867    ,  5375.7161    ,  5767.0727    ,  6155.7751    ,
     *   6541.0202    ,  6922.3144    ,  7299.4048    ,  7672.2194    ,
     *   8040.8169    ,
     *   4356.4080    ,  4733.9630    ,  5114.3336    ,  5495.8611    ,
     *   5877.1473    ,  6257.0805    ,  6634.8273    ,  7009.8015    ,
     *   7381.6254    ,
     *   3910.5136    ,  4272.1091    ,  4639.0396    ,  5009.7989    ,
     *   5382.9378    ,  5757.1400    ,  6131.2727    ,  6504.4106    ,
     *   6875.8358    ,
     *   3570.5487    ,  3918.5343    ,  4273.0671    ,  4632.9403    ,
     *   4996.9005    ,  5363.7058    ,  5732.1842    ,  6101.2817    ,
     *   6470.0946    ,
     *   3297.7529    ,  3634.6614    ,  3978.6619    ,  4328.7913    ,
     *   4684.0132    ,  5043.2493    ,  5405.4199    ,  5769.4878    ,
     *   6134.4978    ,
     *   3070.5889    ,  3398.4596    ,  3733.6629    ,  4075.4018    ,
     *   4422.8099    ,  4774.9654    ,  5130.9143    ,  5489.7002    ,
     *   5850.3982    /
        DATA ((ENTRV (J,K),J=10,18),K=10,18) /
     *   2876.2227    ,  3196.5920    ,  3524.4003    ,  3858.9589    ,
     *   4199.5220    ,  4545.2917    ,  4895.4291    ,  5249.0729    ,
     *   5605.3624    ,
     *   2706.5049    ,  3020.5235    ,  3342.0280    ,  3670.4015    ,
     *   4004.9820    ,  4345.0632    ,  4689.8998    ,  5038.7169    ,
     *   5390.7255    ,
     *   2555.9742    ,  2864.5151    ,  3180.5629    ,  3503.5495    ,
     *   3832.8718    ,  4167.8907    ,  4507.9328    ,  4852.2956    ,
     *   5200.2563    ,
     *   2420.8032    ,  2724.5416    ,  3035.7969    ,  3354.0357    ,
     *   3678.6968    ,  4009.1909    ,  4344.8997    ,  4685.1786    ,
     *   5029.3618    ,
     *   2298.2082    ,  2597.6772    ,  2904.6689    ,  3218.6750    ,
     *   3539.1658    ,  3865.5891    ,  4197.3691    ,  4533.9072    ,
     *   4874.5848    ,
     *   2186.1018    ,  2481.7306    ,  2784.8863    ,  3095.0800    ,
     *   3411.8060    ,  3734.5405    ,  4062.7409    ,  4395.8453    ,
     *   4733.2741    ,
     *   2082.8779    ,  2375.0182    ,  2674.6894    ,  2981.4179    ,
     *   3294.7167    ,  3614.0849    ,  3939.0058    ,  4268.9473    ,
     *   4603.3616    ,
     *   1987.2739    ,  2276.2185    ,  2572.6982    ,  2876.2519    ,
     *   3186.4079    ,  3502.6833    ,  3824.5829    ,  4151.5986    ,
     *   4483.2092    ,
     *   1898.2787    ,  2184.2749    ,  2477.8108    ,  2778.4356    ,
     *   3085.6903    ,  3399.1070    ,  3718.2081    ,  4042.5056    ,
     *   4371.5001    /
        DATA ((ENTRV (J,K),J=10,18),K=19,27) /
     *   1815.0696    ,  2098.3292    ,  2389.1331    ,  2687.0395    ,
     *   2991.6001    ,  3302.3599    ,  3618.8560    ,  3940.6172    ,
     *   4267.1629    ,
     *   1736.9681    ,  2017.6742    ,  2305.9293    ,  2601.2994    ,
     *   2903.3457    ,  3211.6239    ,  3525.6840    ,  3845.0690    ,
     *   4169.3145    ,
     *   1663.4079    ,  1941.7207    ,  2227.5869    ,  2520.5797    ,
     *   2820.2686    ,  3126.2189    ,  3437.9915    ,  3755.1420    ,
     *   4077.2198    ,
     *   1593.9110    ,  1869.9719    ,  2153.5902    ,  2444.3459    ,
     *   2741.8157    ,  3045.5736    ,  3355.1901    ,  3670.2319    ,
     *   3990.2606    ,
     *   1528.0705    ,  1802.0053    ,  2083.5011    ,  2372.1439    ,
     *   2667.5174    ,  2969.2032    ,  3276.7807    ,  3589.8262    ,
     *   3907.9122    ,
     *   1465.5369    ,  1737.4586    ,  2016.9439    ,  2303.5849    ,
     *   2596.9718    ,  2896.6933    ,  3202.3365    ,  3513.4866    ,
     *   3829.7257    ,
     *   1406.0077    ,  1676.0182    ,  1953.5941    ,  2238.3335    ,
     *   2529.8325    ,  2827.6863    ,  3131.4896    ,  3440.8353    ,
     *   3755.3143    ,
     *   1349.2194    ,  1617.4113    ,  1893.1696    ,  2176.0979    ,
     *   2465.7982    ,  2761.8721    ,  3063.9207    ,  3371.5445    ,
     *   3684.3424    ,
     *   1294.9407    ,  1561.3990    ,  1835.4234    ,  2116.6231    ,
     *   2404.6060    ,  2698.9795    ,  2999.3511    ,  3305.3280    ,
     *   3616.5166    /
        DATA ((ENTRV (J,K),J=10,18),K=28,36) /
     *   1242.9678    ,  1507.7706    ,  1780.1378    ,  2059.6845    ,
     *   2346.0242    ,  2638.7701    ,  2937.5356    ,  3241.9343    ,
     *   3551.5796    ,
     *   1193.1201    ,  1456.3396    ,  1727.1205    ,  2005.0837    ,
     *   2289.8485    ,  2581.0334    ,  2878.2579    ,  3181.1415    ,
     *   3489.3039    ,
     *   1145.2364    ,  1406.9399    ,  1676.2001    ,  1952.6442    ,
     *   2235.8969    ,  2525.5825    ,  2821.3258    ,  3122.7523    ,
     *   3429.4877    ,
     *   1099.1729    ,  1359.4231    ,  1627.2237    ,  1902.2083    ,
     *   2184.0073    ,  2472.2505    ,  2766.5682    ,  3066.5912    ,
     *   3371.9512    ,
     *   1054.7999    ,  1313.6557    ,  1580.0540    ,  1853.6347    ,
     *   2134.0343    ,  2420.8880    ,  2713.8314    ,  3012.5009    ,
     *   3316.5334    ,
     *   1012.0006    ,  1269.5177    ,  1534.5672    ,  1806.7962    ,
     *   2085.8471    ,  2371.3606    ,  2662.9777    ,  2960.3399    ,
     *   3263.0897    ,
     *   970.66936    ,  1226.9003    ,  1490.6517    ,  1761.5779    ,
     *   2039.3275    ,  2323.5470    ,  2613.8825    ,  2909.9808    ,
     *   3211.4894    ,
     *   930.71001    ,  1185.7047    ,  1448.2059    ,  1717.8755    ,
     *   1994.3686    ,  2277.3374    ,  2566.4332    ,  2861.3081    ,
     *   3161.6145    ,
     *   892.03500    ,  1145.8411    ,  1407.1376    ,  1675.5942    ,
     *   1950.8729    ,  2232.6317    ,  2520.5274    ,  2814.2169    ,
     *   3113.3577    /
        DATA ((ENTRV (J,K),J=10,18),K=37,45) /
     *   854.56424    ,  1107.2273    ,  1367.3624    ,  1634.6476    ,
     *   1908.7518    ,  2189.3391    ,  2476.0718    ,  2768.6117    ,
     *   3066.6215    ,
     *   818.22434    ,  1069.7882    ,  1328.8033    ,  1594.9566    ,
     *   1867.9241    ,  2147.3764    ,  2432.9811    ,  2724.4054    ,
     *   3021.3165    ,
     *   782.94780    ,  1033.4546    ,  1291.3894    ,  1556.4484    ,
     *   1828.3154    ,  2106.6672    ,  2391.1773    ,  2681.5179    ,
     *   2977.3612    ,
     *   748.67244    ,  998.16293    ,  1255.0556    ,  1519.0565    ,
     *   1789.8573    ,  2067.1417    ,  2350.5887    ,  2639.8760    ,
     *   2934.6804    ,
     *   715.34079    ,  963.85444    ,  1219.7418    ,  1482.7193    ,
     *   1752.4869    ,  2028.7351    ,  2311.1493    ,  2599.4121    ,
     *   2893.2053    ,
     *   682.89965    ,  930.47480    ,  1185.3925    ,  1447.3799    ,
     *   1716.1458    ,  1991.3881    ,  2272.7980    ,  2560.0638    ,
     *   2852.8722    ,
     *   651.29962    ,  897.97364    ,  1151.9561    ,  1412.9857    ,
     *   1680.7804    ,  1955.0454    ,  2235.4786    ,  2521.7737    ,
     *   2813.6223    ,
     *   620.49478    ,  866.30413    ,  1119.3850    ,  1379.4879    ,
     *   1646.3405    ,  1919.6561    ,  2199.1389    ,  2484.4884    ,
     *   2775.4011    ,
     *   590.44233    ,  835.42271    ,  1087.6345    ,  1346.8410    ,
     *   1612.7800    ,  1885.1727    ,  2163.7304    ,  2448.1583    ,
     *   2738.1580    /
        DATA ((ENTRV (J,K),J=10,18),K=46,54) /
     *   561.10231    ,  805.28873    ,  1056.6633    ,  1315.0028    ,
     *   1580.0554    ,  1851.5511    ,  2129.2081    ,  2412.7374    ,
     *   2701.8461    ,
     *   532.43733    ,  775.86420    ,  1026.4328    ,  1283.9338    ,
     *   1548.1267    ,  1818.7502    ,  2095.5298    ,  2378.1828    ,
     *   2666.4216    ,
     *   504.41236    ,  747.11358    ,  996.90673    ,  1253.5972    ,
     *   1516.9561    ,  1786.7315    ,  2062.6564    ,  2344.4545    ,
     *   2631.8436    ,
     *   476.99451    ,  719.00351    ,  968.05119    ,  1223.9584    ,
     *   1486.5085    ,  1755.4591    ,  2030.5512    ,  2311.5151    ,
     *   2598.0740    ,
     *   450.15284    ,  691.50271    ,  939.83441    ,  1194.9851    ,
     *   1456.7509    ,  1724.8994    ,  1999.1800    ,  2279.3296    ,
     *   2565.0772    ,
     *   423.85824    ,  664.58171    ,  912.22651    ,  1166.6469    ,
     *   1427.6522    ,  1695.0209    ,  1968.5106    ,  2247.8651    ,
     *   2532.8196    ,
     *   398.08322    ,  638.21277    ,  885.19936    ,  1138.9152    ,
     *   1399.1836    ,  1665.7939    ,  1938.5126    ,  2217.0909    ,
     *   2501.2699    ,
     *   372.80182    ,  612.36972    ,  858.72646    ,  1111.7631    ,
     *   1371.3175    ,  1637.1905    ,  1909.1578    ,  2186.9781    ,
     *   2470.3986    ,
     *   347.98948    ,  587.02782    ,  832.78280    ,  1085.1652    ,
     *   1344.0281    ,  1609.1844    ,  1880.4194    ,  2157.4993    ,
     *   2440.1779    /
        DATA ((ENTRV (J,K),J=10,18),K=55,63) /
     *   323.62293    ,  562.16368    ,  807.34474    ,  1059.0975    ,
     *   1317.2912    ,  1581.7510    ,  1852.2721    ,  2128.6289    ,
     *   2410.5817    ,
     *   299.68007    ,  537.75515    ,  782.38993    ,  1033.5375    ,
     *   1291.0837    ,  1554.8668    ,  1824.6922    ,  2100.3426    ,
     *   2381.5852    ,
     *   276.13993    ,  513.78119    ,  757.89716    ,  1008.4637    ,
     *   1265.3838    ,  1528.5096    ,  1797.6572    ,  2072.6177    ,
     *   2353.1652    ,
     *   252.98254    ,  490.22183    ,  733.84636    ,  983.85566    ,
     *   1240.1711    ,  1502.6587    ,  1771.1457    ,  2045.4323    ,
     *   2325.2997    ,
     *   230.18887    ,  467.05811    ,  710.21843    ,  959.69424    ,
     *   1215.4259    ,  1477.2942    ,  1745.1378    ,  2018.7661    ,
     *   2297.9679    ,
     *   207.74077    ,  444.27193    ,  686.99524    ,  935.96112    ,
     *   1191.1297    ,  1452.3972    ,  1719.6142    ,  1992.5996    ,
     *   2271.1499    ,
     *   185.62092    ,  421.84606    ,  664.15951    ,  912.63888    ,
     *   1167.2650    ,  1427.9499    ,  1694.5568    ,  1966.9144    ,
     *   2244.8270    ,
     *   163.81273    ,  399.76407    ,  641.69480    ,  889.71096    ,
     *   1143.8150    ,  1403.9355    ,  1669.9485    ,  1941.6930    ,
     *   2218.9815    ,
     *   142.30033    ,  378.01024    ,  619.58541    ,  867.16159    ,
     *   1120.7637    ,  1380.3376    ,  1645.7728    ,  1916.9188    ,
     *   2193.5965    /
        DATA ((ENTRV (J,K),J=10,18),K=64,72) /
     *   121.06849    ,  356.56956    ,  597.81636    ,  844.97573    ,
     *   1098.0960    ,  1357.1411    ,  1622.0142    ,  1892.5759    ,
     *   2168.6559    ,
     *   100.10261    ,  335.42762    ,  576.37333    ,  823.13901    ,
     *   1075.7975    ,  1334.3312    ,  1598.6579    ,  1868.6494    ,
     *   2144.1445    ,
     *   79.388637    ,  314.57066    ,  555.24261    ,  801.63771    ,
     *   1053.8542    ,  1311.8940    ,  1575.6897    ,  1845.1249    ,
     *   2120.0476    ,
     *   58.913065    ,  293.98542    ,  534.41110    ,  780.45872    ,
     *   1032.2531    ,  1289.8161    ,  1553.0961    ,  1821.9886    ,
     *   2096.3514    ,
     *   38.662873    ,  273.65922    ,  513.86621    ,  759.58947    ,
     *   1010.9814    ,  1268.0848    ,  1530.8642    ,  1799.2276    ,
     *   2073.0426    ,
     *   18.625505    ,  253.57981    ,  493.59589    ,  739.01793    ,
     *   990.02710    ,  1246.6880    ,  1508.9818    ,  1776.8294    ,
     *   2050.1085    ,
     *  -1.2111659    ,  233.73545    ,  473.58853    ,  718.73256    ,
     *   969.37865    ,  1225.6140    ,  1487.4370    ,  1754.7819    ,
     *   2027.5372    ,
     *  -20.858862    ,  214.11480    ,  453.83300    ,  698.72230    ,
     *   949.02496    ,  1204.8516    ,  1466.2185    ,  1733.0739    ,
     *   2005.3170    ,
     *  -40.328931    ,  194.70693    ,  434.31859    ,  678.97652    ,
     *   928.95538    ,  1184.3902    ,  1445.3157    ,  1711.6944    ,
     *   1983.4368    /
        DATA ((ENTRV (J,K),J=10,18),K=73,81) /
     *  -59.632370    ,  175.50128    ,  415.03498    ,  659.48499    ,
     *   909.15971    ,  1164.2194    ,  1424.7180    ,  1690.6329    ,
     *   1961.8861    ,
     *  -78.779847    ,  156.48765    ,  395.97222    ,  640.23788    ,
     *   889.62814    ,  1144.3295    ,  1404.4157    ,  1669.8795    ,
     *   1940.6546    ,
     *  -97.781727    ,  137.65619    ,  377.12072    ,  621.22573    ,
     *   870.35124    ,  1124.7109    ,  1384.3992    ,  1649.4244    ,
     *   1919.7328    ,
     *  -116.64809    ,  118.99734    ,  358.47122    ,  602.43943    ,
     *   851.31994    ,  1105.3546    ,  1364.6592    ,  1629.2585    ,
     *   1899.1111    ,
     *  -135.38874    ,  100.50183    ,  340.01476    ,  583.87017    ,
     *   832.52550    ,  1086.2519    ,  1345.1872    ,  1609.3728    ,
     *   1878.7807    ,
     *  -154.01325    ,  82.160685    ,  321.74269    ,  565.50947    ,
     *   813.95951    ,  1067.3943    ,  1325.9745    ,  1589.7589    ,
     *   1858.7329    ,
     *  -172.53095    ,  63.965177    ,  303.64664    ,  547.34914    ,
     *   795.61386    ,  1048.7738    ,  1307.0130    ,  1570.4086    ,
     *   1838.9595    ,
     *  -190.95097    ,  45.906822    ,  285.71848    ,  529.38127    ,
     *   777.48072    ,  1030.3824    ,  1288.2950    ,  1551.3139    ,
     *   1819.4524    ,
     *  -209.28222    ,  27.977366    ,  267.95035    ,  511.59819    ,
     *   759.55253    ,  1012.2128    ,  1269.8129    ,  1532.4672    ,
     *   1800.2040    /
        DATA ((ENTRV (J,K),J=19,27),K= 1, 9) /
     *   33643.729    ,  33968.980    ,  34294.231    ,  34619.482    ,
     *   34944.733    ,  35269.984    ,  35595.235    ,  35920.485    ,
     *   36245.736    ,
     *   10859.340    ,  11200.065    ,  11538.873    ,  11875.990    ,
     *   12211.613    ,  12545.916    ,  12879.056    ,  13211.169    ,
     *   13542.378    ,
     *   9323.8968    ,  9676.5874    ,  10026.113    ,  10372.795    ,
     *   10716.931    ,  11058.790    ,  11398.616    ,  11736.631    ,
     *   12073.033    ,
     *   8405.3465    ,  8766.0161    ,  9123.0686    ,  9476.7649    ,
     *   9827.3708    ,  10175.149    ,  10520.353    ,  10863.225    ,
     *   11203.990    ,
     *   7750.0895    ,  8115.1157    ,  8476.7250    ,  8835.0107    ,
     *   9190.1160    ,  9542.2172    ,  9891.5102    ,  10238.200    ,
     *   10582.494    ,
     *   7245.0219    ,  7611.6097    ,  7975.3796    ,  8336.2250    ,
     *   8694.1277    ,  9049.1365    ,  9401.3492    ,  9750.8980    ,
     *   10097.937    ,
     *   6837.8830    ,  7204.0697    ,  7568.2283    ,  7930.0653    ,
     *   8289.3996    ,  8646.1425    ,  9000.2782    ,  9351.8476    ,
     *   9700.9337    ,
     *   6499.6074    ,  6864.1045    ,  7227.4131    ,  7589.0890    ,
     *   7948.8084    ,  8306.3535    ,  8661.5959    ,  9014.4806    ,
     *   9365.0111    ,
     *   6212.1463    ,  6574.1722    ,  6935.8109    ,  7296.5122    ,
     *   7655.8410    ,  8013.4697    ,  8369.1680    ,  8722.7893    ,
     *   9074.2575    /
        DATA ((ENTRV (J,K),J=19,27),K=10,18) /
     *   5963.4644    ,  6322.5992    ,  6682.0628    ,  7041.2422    ,
     *   7399.6242    ,  7756.7962    ,  8112.4421    ,  8466.3339    ,
     *   8818.3210    ,
     *   5745.1419    ,  6101.2094    ,  6458.2196    ,  6815.5312    ,
     *   7172.5835    ,  7528.9036    ,  7884.1082    ,  8237.9009    ,
     *   8590.0648    ,
     *   5551.0855    ,  5904.0632    ,  6258.4977    ,  6613.7434    ,
     *   6969.2162    ,  7324.4048    ,  7678.8772    ,  8032.2824    ,
     *   8384.3476    ,
     *   5376.7710    ,  5726.7272    ,  6078.5656    ,  6431.6512    ,
     *   6785.3940    ,  7139.2619    ,  7492.7903    ,  7845.5872    ,
     *   8197.3342    ,
     *   5218.7691    ,  5565.8207    ,  5915.1054    ,  6266.0071    ,
     *   6617.9413    ,  6970.3682    ,  7322.8037    ,  7674.8267    ,
     *   8026.0835    ,
     *   5074.4331    ,  5418.7192    ,  5765.5290    ,  6114.2687    ,
     *   6464.3663    ,  6815.2832    ,  7166.5257    ,  7517.6540    ,
     *   7868.2879    ,
     *   4941.6875    ,  5283.3540    ,  5627.7863    ,  5974.4141    ,
     *   6322.6812    ,  6672.0562    ,  7022.0434    ,  7372.1916    ,
     *   7722.1022    ,
     *   4818.8810    ,  5158.0712    ,  5500.2311    ,  5844.8131    ,
     *   6191.2785    ,  6539.1063    ,  6887.8036    ,  7236.9144    ,
     *   7586.0276    ,
     *   4704.6820    ,  5041.5322    ,  5381.5258    ,  5724.1364    ,
     *   6068.8426    ,  6415.1360    ,  6762.5297    ,  7110.5671    ,
     *   7458.8301    /
        DATA ((ENTRV (J,K),J=19,27),K=19,27) /
     *   4598.0035    ,  4932.6411    ,  5270.5713    ,  5611.2875    ,
     *   5954.2853    ,  6299.0693    ,  6645.1607    ,  6992.1053    ,
     *   7339.4817    ,
     *   4497.9482    ,  4830.4905    ,  5166.4555    ,  5505.3542    ,
     *   5846.6983    ,  6190.0055    ,  6534.8064    ,  6880.6512    ,
     *   7227.1179    ,
     *   4403.7679    ,  4734.3224    ,  5068.4141    ,  5405.5700    ,
     *   5745.3166    ,  6087.1844    ,  6430.7137    ,  6775.4607    ,
     *   7121.0049    ,
     *   4314.8323    ,  4643.4975    ,  4975.8015    ,  5311.2858    ,
     *   5649.4907    ,  5989.9589    ,  6332.2404    ,  6675.8983    ,
     *   7020.5149    ,
     *   4230.6065    ,  4557.4723    ,  4888.0679    ,  5221.9481    ,
     *   5558.6656    ,  5897.7749    ,  6238.8354    ,  6581.4175    ,
     *   6925.1074    ,
     *   4150.6323    ,  4475.7809    ,  4804.7415    ,  5137.0808    ,
     *   5472.3633    ,  5810.1542    ,  6150.0223    ,  6491.5451    ,
     *   6834.3137    ,
     *   4074.5149    ,  4398.0214    ,  4725.4148    ,  5056.2725    ,
     *   5390.1699    ,  5726.6821    ,  6065.3870    ,  6405.8694    ,
     *   6747.7253    ,
     *   4001.9112    ,  4323.8447    ,  4649.7335    ,  4979.1650    ,
     *   5311.7246    ,  5646.9967    ,  5984.5678    ,  6324.0298    ,
     *   6664.9840    ,
     *   3932.5217    ,  4252.9456    ,  4577.3878    ,  4905.4449    ,
     *   5236.7113    ,  5570.7804    ,  5907.2468    ,  6245.7092    ,
     *   6585.7744    /
        DATA ((ENTRV (J,K),J=19,27),K=28,36) /
     *   3866.0835    ,  4185.0562    ,  4508.1054    ,  4834.8363    ,
     *   5164.8518    ,  5497.7534    ,  5833.1434    ,  6170.6274    ,
     *   6509.8175    ,
     *   3802.3641    ,  4119.9396    ,  4441.6457    ,  4767.0955    ,
     *   5095.8996    ,  5427.6676    ,  5762.0090    ,  6098.5356    ,
     *   6436.8650    ,
     *   3741.1574    ,  4057.3857    ,  4377.7950    ,  4702.0057    ,
     *   5029.6361    ,  5360.3026    ,  5693.6219    ,  6029.2120    ,
     *   6366.6957    ,
     *   3682.2796    ,  3997.2071    ,  4316.3628    ,  4639.3739    ,
     *   4965.8656    ,  5295.4614    ,  5627.7842    ,  5962.4583    ,
     *   6299.1114    ,
     *   3625.5663    ,  3939.2362    ,  4257.1786    ,  4579.0270    ,
     *   4904.4132    ,  5232.9673    ,  5564.3183    ,  5898.0962    ,
     *   6233.9337    ,
     *   3570.8696    ,  3883.3223    ,  4200.0889    ,  4520.8093    ,
     *   4845.1214    ,  5172.6613    ,  5503.0641    ,  5835.9652    ,
     *   6171.0022    ,
     *   3518.0563    ,  3829.3293    ,  4144.9556    ,  4464.5806    ,
     *   4787.8481    ,  5114.4000    ,  5443.8772    ,  5775.9201    ,
     *   6110.1712    ,
     *   3467.0056    ,  3777.1344    ,  4091.6535    ,  4410.2137    ,
     *   4732.4645    ,  5058.0534    ,  5386.6264    ,  5717.8293    ,
     *   6051.3090    ,
     *   3417.6080    ,  3726.6259    ,  4040.0689    ,  4357.5934    ,
     *   4678.8539    ,  5003.5032    ,  5331.1928    ,  5661.5731    ,
     *   5994.2954    /
        DATA ((ENTRV (J,K),J=19,27),K=37,45) /
     *   3369.7639    ,  3677.7021    ,  3990.0985    ,  4306.6144    ,
     *   4626.9096    ,  4950.6420    ,  5277.4677    ,  5607.0422    ,
     *   5939.0209    ,
     *   3323.3822    ,  3630.2701    ,  3941.6476    ,  4257.1809    ,
     *   4576.5345    ,  4899.3713    ,  5225.3521    ,  5554.1369    ,
     *   5885.3853    ,
     *   3278.3794    ,  3584.2450    ,  3894.6299    ,  4209.2050    ,
     *   4527.6396    ,  4849.6010    ,  5174.7550    ,  5502.7656    ,
     *   5833.2967    ,
     *   3234.6790    ,  3539.5487    ,  3848.9659    ,  4162.6061    ,
     *   4480.1430    ,  4801.2486    ,  5125.5929    ,  5452.8443    ,
     *   5782.6706    ,
     *   3192.2107    ,  3496.1095    ,  3804.5827    ,  4117.3099    ,
     *   4433.9695    ,  4754.2378    ,  5077.7890    ,  5404.2956    ,
     *   5733.4292    ,
     *   3150.9094    ,  3453.8612    ,  3761.4128    ,  4073.2481    ,
     *   4389.0499    ,  4708.4985    ,  5031.2723    ,  5357.0480    ,
     *   5685.5007    ,
     *   3110.7152    ,  3412.7427    ,  3719.3940    ,  4030.3575    ,
     *   4345.3199    ,  4663.9657    ,  4985.9775    ,  5311.0354    ,
     *   5638.8186    ,
     *   3071.5725    ,  3372.6972    ,  3678.4687    ,  3988.5795    ,
     *   4302.7202    ,  4620.5795    ,  4941.8436    ,  5266.1968    ,
     *   5593.3213    ,
     *   3033.4298    ,  3333.6724    ,  3638.5836    ,  3947.8598    ,
     *   4261.1958    ,  4578.2840    ,  4898.8145    ,  5222.4752    ,
     *   5548.9518    /
        DATA ((ENTRV (J,K),J=19,27),K=46,54) /
     *   2996.2390    ,  3295.6193    ,  3599.6888    ,  3908.1480    ,
     *   4220.6955    ,  4537.0275    ,  4856.8378    ,  5179.8179    ,
     *   5505.6568    ,
     *   2959.9556    ,  3258.4925    ,  3561.7383    ,  3869.3972    ,
     *   4181.1716    ,  4496.7617    ,  4815.8647    ,  5138.1756    ,
     *   5463.3869    ,
     *   2924.5380    ,  3222.2497    ,  3524.6888    ,  3831.5634    ,
     *   4142.5798    ,  4457.4416    ,  4775.8498    ,  5097.5026    ,
     *   5422.0959    ,
     *   2889.9473    ,  3186.8513    ,  3488.5001    ,  3794.6059    ,
     *   4104.8785    ,  4419.0252    ,  4736.7505    ,  5057.7560    ,
     *   5381.7405    ,
     *   2856.1471    ,  3152.2601    ,  3453.1345    ,  3758.4863    ,
     *   4068.0289    ,  4381.4733    ,  4698.5272    ,  5018.8955    ,
     *   5342.2804    ,
     *   2823.1033    ,  3118.4416    ,  3418.5569    ,  3723.1688    ,
     *   4031.9947    ,  4344.7489    ,  4661.1426    ,  4980.8838    ,
     *   5303.6778    ,
     *   2790.7840    ,  3085.3632    ,  3384.7339    ,  3688.6199    ,
     *   3996.7418    ,  4308.8176    ,  4624.5617    ,  4943.6855    ,
     *   5265.8970    ,
     *   2759.1591    ,  3052.9943    ,  3351.6347    ,  3654.8078    ,
     *   3962.2382    ,  4273.6469    ,  4588.7519    ,  4907.2675    ,
     *   5228.9048    ,
     *   2728.2004    ,  3021.3060    ,  3319.2298    ,  3621.7030    ,
     *   3928.4537    ,  4239.2064    ,  4553.6822    ,  4871.5987    ,
     *   5192.6697    /
        DATA ((ENTRV (J,K),J=19,27),K=55,63) /
     *   2697.8811    ,  2990.2715    ,  3287.4918    ,  3589.2775    ,
     *   3895.3599    ,  4205.4672    ,  4519.3236    ,  4836.6497    ,
     *   5157.1622    ,
     *   2668.1763    ,  2959.8650    ,  3256.3948    ,  3557.5048    ,
     *   3862.9302    ,  4172.4024    ,  4485.6487    ,  4802.3928    ,
     *   5122.3544    ,
     *   2639.0622    ,  2930.0625    ,  3225.9142    ,  3526.3602    ,
     *   3831.1393    ,  4139.9862    ,  4452.6316    ,  4768.8020    ,
     *   5088.2199    ,
     *   2610.5163    ,  2900.8413    ,  3196.0268    ,  3495.8201    ,
     *   3799.9633    ,  4108.1947    ,  4420.2480    ,  4735.8526    ,
     *   5054.7338    ,
     *   2582.5176    ,  2872.1796    ,  3166.7108    ,  3465.8622    ,
     *   3769.3798    ,  4077.0050    ,  4388.4746    ,  4703.5212    ,
     *   5021.8728    ,
     *   2555.0459    ,  2844.0572    ,  3137.9455    ,  3436.4656    ,
     *   3739.3673    ,  4046.3953    ,  4357.2897    ,  4671.7858    ,
     *   4989.6144    ,
     *   2528.0821    ,  2816.4547    ,  3109.7110    ,  3407.6102    ,
     *   3709.9056    ,  4016.3454    ,  4326.6725    ,  4640.6254    ,
     *   4957.9375    ,
     *   2501.6082    ,  2789.3537    ,  3081.9889    ,  3379.2772    ,
     *   3680.9756    ,  3986.8356    ,  4296.6034    ,  4610.0202    ,
     *   4926.8221    ,
     *   2475.6070    ,  2762.7367    ,  3054.7614    ,  3351.4485    ,
     *   3652.5589    ,  3957.8475    ,  4267.0636    ,  4579.9512    ,
     *   4896.2492    /
        DATA ((ENTRV (J,K),J=19,27),K=64,72) /
     *   2450.0623    ,  2736.5873    ,  3028.0116    ,  3324.1071    ,
     *   3624.6384    ,  3929.3637    ,  4238.0355    ,  4550.4006    ,
     *   4866.2007    ,
     *   2424.9584    ,  2710.8895    ,  3001.7235    ,  3297.2367    ,
     *   3597.1974    ,  3901.3673    ,  4209.5021    ,  4521.3514    ,
     *   4836.6594    ,
     *   2400.2806    ,  2685.6284    ,  2975.8820    ,  3270.8219    ,
     *   3570.2204    ,  3873.8426    ,  4181.4473    ,  4492.7872    ,
     *   4807.6090    ,
     *   2376.0148    ,  2660.7897    ,  2950.4724    ,  3244.8479    ,
     *   3543.6923    ,  3846.7744    ,  4153.8560    ,  4464.6926    ,
     *   4779.0337    ,
     *   2352.1475    ,  2636.3598    ,  2925.4809    ,  3219.3006    ,
     *   3517.5990    ,  3820.1483    ,  4126.7135    ,  4437.0529    ,
     *   4750.9188    ,
     *   2328.6660    ,  2612.3255    ,  2900.8943    ,  3194.1667    ,
     *   3491.9269    ,  3793.9505    ,  4100.0058    ,  4409.8541    ,
     *   4723.2501    ,
     *   2305.5578    ,  2588.6745    ,  2876.6999    ,  3169.4333    ,
     *   3466.6629    ,  3768.1679    ,  4073.7197    ,  4383.0826    ,
     *   4696.0140    ,
     *   2282.8113    ,  2565.3948    ,  2852.8858    ,  3145.0883    ,
     *   3441.7947    ,  3742.7879    ,  4047.8425    ,  4356.7257    ,
     *   4669.1975    ,
     *   2260.4154    ,  2542.4750    ,  2829.4402    ,  3121.1198    ,
     *   3417.3104    ,  3717.7985    ,  4022.3621    ,  4330.7711    ,
     *   4642.7884    /
        DATA ((ENTRV (J,K),J=19,27),K=73,81) /
     *   2238.3591    ,  2519.9044    ,  2806.3523    ,  3097.5167    ,
     *   3393.1986    ,  3693.1882    ,  3997.2667    ,  4305.2070    ,
     *   4616.7746    ,
     *   2216.6323    ,  2497.6724    ,  2783.6114    ,  3074.2684    ,
     *   3369.4486    ,  3668.9461    ,  3972.5454    ,  4280.0223    ,
     *   4591.1450    ,
     *   2195.2251    ,  2475.7690    ,  2761.2073    ,  3051.3644    ,
     *   3346.0499    ,  3645.0616    ,  3948.1874    ,  4255.2062    ,
     *   4565.8886    ,
     *   2174.1280    ,  2454.1846    ,  2739.1304    ,  3028.7949    ,
     *   3322.9924    ,  3621.5246    ,  3924.1825    ,  4230.7482    ,
     *   4540.9951    ,
     *   2153.3319    ,  2432.9101    ,  2717.3713    ,  3006.5506    ,
     *   3300.2668    ,  3598.3254    ,  3900.5210    ,  4206.6387    ,
     *   4516.4544    ,
     *   2132.8281    ,  2411.9366    ,  2695.9211    ,  2984.6223    ,
     *   3277.8636    ,  3575.4547    ,  3877.1934    ,  4182.8679    ,
     *   4492.2570    ,
     *   2112.6083    ,  2391.2556    ,  2674.7712    ,  2963.0013    ,
     *   3255.7743    ,  3552.9036    ,  3854.1908    ,  4159.4269    ,
     *   4468.3936    ,
     *   2092.6643    ,  2370.8589    ,  2653.9132    ,  2941.6793    ,
     *   3233.9901    ,  3530.6635    ,  3831.5043    ,  4136.3069    ,
     *   4444.8554    ,
     *   2072.9884    ,  2350.7388    ,  2633.3393    ,  2920.6482    ,
     *   3212.5031    ,  3508.7261    ,  3809.1258    ,  4113.4994    ,
     *   4421.6340    /
        DATA ((ENTRV (J,K),J=28,36),K= 1, 9) /
     *   36570.987    ,  36896.238    ,  37221.488    ,  37546.739    ,
     *   37871.990    ,  38197.240    ,  38522.491    ,  38847.742    ,
     *   39172.993    ,
     *   13872.792    ,  14202.506    ,  14531.606    ,  14860.167    ,
     *   15188.258    ,  15515.937    ,  15843.257    ,  16170.264    ,
     *   16496.999    ,
     *   12408.005    ,  12741.708    ,  13074.288    ,  13405.876    ,
     *   13736.590    ,  14066.533    ,  14395.802    ,  14724.477    ,
     *   15052.636    ,
     *   11542.861    ,  11880.031    ,  12215.682    ,  12549.977    ,
     *   12883.067    ,  13215.086    ,  13546.159    ,  13876.397    ,
     *   14205.901    ,
     *   10924.596    ,  11264.703    ,  11603.003    ,  11939.673    ,
     *   12274.878    ,  12608.771    ,  12941.495    ,  13273.177    ,
     *   13603.937    ,
     *   10442.635    ,  10785.166    ,  11125.703    ,  11464.419    ,
     *   11801.480    ,  12137.042    ,  12471.256    ,  12804.260    ,
     *   13136.183    ,
     *   10047.650    ,  10392.128    ,  10734.516    ,  11074.966    ,
     *   11413.630    ,  11750.661    ,  12086.207    ,  12420.409    ,
     *   12753.401    ,
     *   9713.2359    ,  10059.238    ,  10403.123    ,  10745.016    ,
     *   11085.048    ,  11423.357    ,  11760.083    ,  12095.362    ,
     *   12429.328    ,
     *   9423.5540    ,  9770.7054    ,  10115.773    ,  10458.846    ,
     *   10800.027    ,  11139.437    ,  11477.198    ,  11813.439    ,
     *   12148.286    /
        DATA ((ENTRV (J,K),J=28,36),K=10,18) /
     *   9168.3187    ,  9516.2973    ,  9862.2706    ,  10206.287    ,
     *   10548.421    ,  10888.766    ,  11227.428    ,  11564.521    ,
     *   11900.163    ,
     *   8940.4542    ,  9288.9845    ,  9635.6220    ,  9980.3747    ,
     *   10323.284    ,  10664.415    ,  11003.853    ,  11341.696    ,
     *   11678.049    ,
     *   8734.8723    ,  9083.7210    ,  9430.8145    ,  9776.1206    ,
     *   10119.646    ,  10461.428    ,  10801.529    ,  11140.027    ,
     *   11477.013    ,
     *   8547.7840    ,  8896.7554    ,  9244.1264    ,  9589.8264    ,
     *   9933.8282    ,  10276.140    ,  10616.799    ,  10955.865    ,
     *   11293.412    ,
     *   8376.2878    ,  8725.2186    ,  9072.7151    ,  9418.6705    ,
     *   9763.0248    ,  10105.758    ,  10446.882    ,  10786.435    ,
     *   11124.476    ,
     *   8218.1099    ,  8566.8650    ,  8914.3582    ,  9260.4494    ,
     *   9605.0476    ,  9948.1046    ,  10289.608    ,  10629.576    ,
     *   10968.049    ,
     *   8071.4334    ,  8419.9023    ,  8767.2837    ,  9113.4077    ,
     *   9458.1547    ,  9801.4498    ,  10143.257    ,  10483.572    ,
     *   10822.420    ,
     *   7934.7834    ,  8282.8760    ,  8630.0550    ,  8976.1238    ,
     *   9320.9367    ,  9664.3936    ,  10006.436    ,  10347.038    ,
     *   10686.207    ,
     *   7806.9454    ,  8154.5895    ,  8501.4907    ,  8847.4294    ,
     *   9192.2360    ,  9535.7875    ,  9878.0028    ,  10218.838    ,
     *   10558.281    /
        DATA ((ENTRV (J,K),J=28,36),K=19,27) /
     *   7686.9077    ,  8034.0459    ,  8380.6073    ,  8726.3524    ,
     *   9071.0903    ,  9414.6769    ,  9757.0107    ,  10098.029    ,
     *   10437.701    ,
     *   7573.8188    ,  7920.4063    ,  8266.5771    ,  8612.0749    ,
     *   8956.6903    ,  9300.2599    ,  9642.6631    ,  9983.8187    ,
     *   10323.680    ,
     *   7466.9555    ,  7812.9575    ,  8158.6967    ,  8503.9024    ,
     *   8848.3491    ,  9191.8560    ,  9534.2849    ,  9875.5376    ,
     *   10215.551    ,
     *   7365.6985    ,  7711.0890    ,  8056.3637    ,  8401.2399    ,
     *   8745.4783    ,  9088.8825    ,  9431.2984    ,  9772.6115    ,
     *   10112.744    ,
     *   7269.5139    ,  7614.2739    ,  7959.0579    ,  8303.5739    ,
     *   8647.5702    ,  8990.8370    ,  9333.2053    ,  9674.5461    ,
     *   10014.767    ,
     *   7177.9383    ,  7522.0544    ,  7866.3275    ,  8210.4578    ,
     *   8554.1835    ,  8897.2826    ,  9239.5729    ,  9580.9117    ,
     *   9921.1931    ,
     *   7090.5674    ,  7434.0308    ,  7777.7775    ,  8121.5015    ,
     *   8464.9324    ,  8807.8375    ,  9150.0230    ,  9491.3333    ,
     *   9831.6497    ,
     *   7007.0462    ,  7349.8518    ,  7693.0605    ,  8036.3617    ,
     *   8379.4775    ,  8722.1661    ,  9064.2229    ,  9405.4808    ,
     *   9745.8094    ,
     *   6927.0616    ,  7269.2073    ,  7611.8699    ,  7954.7350    ,
     *   8297.5188    ,  8639.9714    ,  8981.8786    ,  9323.0629    ,
     *   9663.3827    /
        DATA ((ENTRV (J,K),J=28,36),K=28,36) /
     *   6850.3364    ,  7191.8224    ,  7533.9335    ,  7876.3522    ,
     *   8218.7899    ,  8560.9896    ,  8902.7290    ,  9243.8207    ,
     *   9584.1127    ,
     *   6776.6239    ,  7117.4523    ,  7459.0085    ,  7800.9730    ,
     *   8143.0530    ,  8484.9857    ,  8826.5410    ,  9167.5230    ,
     *   9507.7702    ,
     *   6705.7036    ,  7045.8781    ,  7386.8780    ,  7728.3824    ,
     *   8070.0952    ,  8411.7487    ,  8753.1059    ,  9093.9630    ,
     *   9434.1499    ,
     *   6637.3780    ,  6976.9033    ,  7317.3469    ,  7658.3871    ,
     *   7999.7252    ,  8341.0890    ,  8682.2358    ,  9022.9546    ,
     *   9363.0671    ,
     *   6571.4695    ,  6910.3512    ,  7250.2397    ,  7590.8130    ,
     *   7931.7703    ,  8272.8358    ,  8613.7614    ,  8954.3298    ,
     *   9294.3551    ,
     *   6507.8175    ,  6846.0618    ,  7185.3974    ,  7525.5024    ,
     *   7866.0742    ,  8206.8340    ,  8547.5291    ,  8887.9364    ,
     *   9227.8631    ,
     *   6446.2769    ,  6783.8905    ,  7122.6762    ,  7462.3122    ,
     *   7802.4951    ,  8142.9430    ,  8483.3996    ,  8823.6362    ,
     *   9163.4540    ,
     *   6386.7157    ,  6723.7058    ,  7061.9451    ,  7401.1125    ,
     *   7740.9037    ,  8081.0348    ,  8421.2459    ,  8761.3034    ,
     *   9101.0029    ,
     *   6329.0138    ,  6665.3877    ,  7003.0847    ,  7341.7845    ,
     *   7681.1823    ,  8020.9925    ,  8360.9519    ,  8700.8229    ,
     *   9040.3955    /
        DATA ((ENTRV (J,K),J=28,36),K=37,45) /
     *   6273.0617    ,  6608.8267    ,  6945.9858    ,  7284.2196    ,
     *   7623.2230    ,  7962.7089    ,  8302.4115    ,  8642.0893    ,
     *   8981.5275    ,
     *   6218.7588    ,  6553.9226    ,  6890.5485    ,  7228.3182    ,
     *   7566.9268    ,  7906.0858    ,  8245.5271    ,  8585.0059    ,
     *   8924.3027    ,
     *   6166.0132    ,  6500.5833    ,  6836.6809    ,  7173.9890    ,
     *   7512.2027    ,  7851.0328    ,  8190.2091    ,  8529.4836    ,
     *   8868.6329    ,
     *   6114.7401    ,  6448.7240    ,  6784.2984    ,  7121.1476    ,
     *   7458.9670    ,  7797.4667    ,  8136.3748    ,  8475.4405    ,
     *   8814.4366    ,
     *   6064.8616    ,  6398.2668    ,  6733.3231    ,  7069.7163    ,
     *   7407.1422    ,  7745.3105    ,  8083.9477    ,  8422.8005    ,
     *   8761.6384    ,
     *   6016.3055    ,  6349.1394    ,  6683.6830    ,  7019.6232    ,
     *   7356.6568    ,  7694.4930    ,  8032.8571    ,  8371.4936    ,
     *   8710.1687    ,
     *   5969.0053    ,  6301.2752    ,  6635.3111    ,  6970.8018    ,
     *   7307.4444    ,  7644.9482    ,  7983.0374    ,  8321.4544    ,
     *   8659.9626    ,
     *   5922.8989    ,  6254.6120    ,  6588.1457    ,  6923.1902    ,
     *   7259.4435    ,  7596.6150    ,  7934.4277    ,  8272.6225    ,
     *   8610.9602    ,
     *   5877.9292    ,  6209.0926    ,  6542.1292    ,  6876.7309    ,
     *   7212.5968    ,  7549.4361    ,  7886.9713    ,  8224.9416    ,
     *   8563.1053    /
        DATA ((ENTRV (J,K),J=28,36),K=46,54) /
     *   5834.0427    ,  6164.6632    ,  6497.2080    ,  6831.3706    ,
     *   7166.8509    ,  7503.3585    ,  7840.6153    ,  8178.3590    ,
     *   8516.3458    ,
     *   5791.1896    ,  6121.2741    ,  6453.3323    ,  6787.0593    ,
     *   7122.1561    ,  7458.3326    ,  7795.3104    ,  8132.8258    ,
     *   8470.6329    ,
     *   5749.3235    ,  6078.8786    ,  6410.4553    ,  6743.7503    ,
     *   7078.4659    ,  7414.3122    ,  7751.0104    ,  8088.2959    ,
     *   8425.9210    ,
     *   5708.4010    ,  6037.4332    ,  6368.5334    ,  6701.4001    ,
     *   7035.7367    ,  7371.2537    ,  7707.6722    ,  8044.7266    ,
     *   8382.1675    ,
     *   5668.3815    ,  5996.8972    ,  6327.5259    ,  6659.9679    ,
     *   6993.9277    ,  7329.1165    ,  7665.2553    ,  8002.0775    ,
     *   8339.3322    ,
     *   5629.2270    ,  5957.2323    ,  6287.3945    ,  6619.4154    ,
     *   6953.0008    ,  7287.8626    ,  7623.7216    ,  7960.3107    ,
     *   8297.3776    ,
     *   5590.9016    ,  5918.4027    ,  6248.1031    ,  6579.7065    ,
     *   6912.9200    ,  7247.4560    ,  7583.0356    ,  7919.3908    ,
     *   8256.2682    ,
     *   5553.3719    ,  5880.3746    ,  6209.6180    ,  6540.8075    ,
     *   6873.6515    ,  7207.8631    ,  7543.1635    ,  7879.2843    ,
     *   8215.9709    ,
     *   5516.6062    ,  5843.1164    ,  6171.9074    ,  6502.6866    ,
     *   6835.1634    ,  7169.0520    ,  7504.0736    ,  7839.9596    ,
     *   8176.4542    /
        DATA ((ENTRV (J,K),J=28,36),K=55,63) /
     *   5480.5747    ,  5806.5980    ,  6134.9413    ,  6465.3136    ,
     *   6797.4258    ,  7130.9929    ,  7465.7363    ,  7801.3870    ,
     *   8137.6884    ,
     *   5445.2495    ,  5770.7914    ,  6098.6914    ,  6428.6603    ,
     *   6760.4104    ,  7093.6573    ,  7428.1231    ,  7763.5384    ,
     *   8099.6458    ,
     *   5410.6039    ,  5735.6698    ,  6063.1310    ,  6392.6999    ,
     *   6724.0903    ,  7057.0188    ,  7391.2076    ,  7726.3873    ,
     *   8062.2997    ,
     *   5376.6131    ,  5701.2082    ,  6028.2348    ,  6357.4072    ,
     *   6688.4403    ,  7021.0518    ,  7354.9644    ,  7689.9085    ,
     *   8025.6253    ,
     *   5343.2532    ,  5667.3827    ,  5993.9790    ,  6322.7581    ,
     *   6653.4365    ,  6985.7326    ,  7319.3697    ,  7654.0783    ,
     *   7989.5987    ,
     *   5310.5018    ,  5634.1708    ,  5960.3409    ,  6288.7301    ,
     *   6619.0561    ,  6951.0385    ,  7284.4010    ,  7618.8740    ,
     *   7954.1976    ,
     *   5278.3377    ,  5601.5510    ,  5927.2990    ,  6255.3015    ,
     *   6585.2776    ,  6916.9478    ,  7250.0366    ,  7584.2743    ,
     *   7919.4006    ,
     *   5246.7407    ,  5569.5031    ,  5894.8330    ,  6222.4520    ,
     *   6552.0806    ,  6883.4403    ,  7216.2562    ,  7550.2588    ,
     *   7885.1874    ,
     *   5215.6916    ,  5538.0078    ,  5862.9236    ,  6190.1622    ,
     *   6519.4456    ,  6850.4965    ,  7183.0404    ,  7516.8082    ,
     *   7851.5388    /
        DATA ((ENTRV (J,K),J=28,36),K=64,72) /
     *   5185.1722    ,  5507.0468    ,  5831.5522    ,  6158.4136    ,
     *   6487.3542    ,  6818.0979    ,  7150.3708    ,  7483.9042    ,
     *   7818.4365    ,
     *   5155.1652    ,  5476.6026    ,  5800.7015    ,  6127.1886    ,
     *   6455.7888    ,  6786.2269    ,  7118.2299    ,  7451.5291    ,
     *   7785.8629    ,
     *   5125.6541    ,  5446.6587    ,  5770.3548    ,  6096.4706    ,
     *   6424.7327    ,  6754.8669    ,  7086.6009    ,  7419.6664    ,
     *   7753.8016    ,
     *   5096.6231    ,  5417.1993    ,  5740.4961    ,  6066.2437    ,
     *   6394.1699    ,  6724.0018    ,  7055.4679    ,  7388.3000    ,
     *   7722.2365    ,
     *   5068.0574    ,  5388.2093    ,  5711.1104    ,  6036.4926    ,
     *   6364.0852    ,  6693.6165    ,  7024.8156    ,  7357.4150    ,
     *   7691.1527    ,
     *   5039.9425    ,  5359.6742    ,  5682.1831    ,  6007.2028    ,
     *   6334.4641    ,  6663.6964    ,  6994.6296    ,  7326.9966    ,
     *   7660.5356    ,
     *   5012.2649    ,  5331.5805    ,  5653.7005    ,  5978.3606    ,
     *   6305.2927    ,  6634.2276    ,  6964.8960    ,  7297.0312    ,
     *   7630.3714    ,
     *   4985.0114    ,  5303.9148    ,  5625.6495    ,  5949.9525    ,
     *   6276.5577    ,  6605.1968    ,  6935.6015    ,  7267.5054    ,
     *   7600.6469    ,
     *   4958.1697    ,  5276.6648    ,  5598.0172    ,  5921.9661    ,
     *   6248.2465    ,  6576.5914    ,  6906.7334    ,  7238.4066    ,
     *   7571.3495    /
        DATA ((ENTRV (J,K),J=28,36),K=73,81) /
     *   4931.7278    ,  5249.8183    ,  5570.7918    ,  5894.3891    ,
     *   6220.3469    ,  6548.3992    ,  6878.2795    ,  7209.7226    ,
     *   7542.4670    ,
     *   4905.6742    ,  5223.3638    ,  5543.9616    ,  5867.2100    ,
     *   6192.8472    ,  6520.6086    ,  6850.2283    ,  7181.4419    ,
     *   7513.9880    ,
     *   4879.9980    ,  5197.2904    ,  5517.5156    ,  5840.4177    ,
     *   6165.7364    ,  6493.2083    ,  6822.5686    ,  7153.5533    ,
     *   7485.9012    ,
     *   4854.6887    ,  5171.5875    ,  5491.4431    ,  5814.0015    ,
     *   6139.0038    ,  6466.1878    ,  6795.2897    ,  7126.0460    ,
     *   7458.1959    ,
     *   4829.7363    ,  5146.2450    ,  5465.7340    ,  5787.9511    ,
     *   6112.6390    ,  6439.5367    ,  6768.3813    ,  7098.9099    ,
     *   7430.8621    ,
     *   4805.1311    ,  5121.2530    ,  5440.3785    ,  5762.2568    ,
     *   6086.6323    ,  6413.2451    ,  6741.8335    ,  7072.1351    ,
     *   7403.8898    ,
     *   4780.8637    ,  5096.6024    ,  5415.3671    ,  5736.9091    ,
     *   6060.9741    ,  6387.3037    ,  6715.6369    ,  7045.7122    ,
     *   7377.2696    ,
     *   4756.9254    ,  5072.2840    ,  5390.6909    ,  5711.8990    ,
     *   6035.6555    ,  6361.7033    ,  6689.7824    ,  7019.6320    ,
     *   7350.9924    ,
     *   4733.3075    ,  5048.2894    ,  5366.3412    ,  5687.2178    ,
     *   6010.6677    ,  6336.4352    ,  6664.2613    ,  6993.8858    ,
     *   7325.0495    /
        DATA ((ENTRV (J,K),J=37,45),K= 1, 9) /
     *   39498.243    ,  39823.494    ,  40148.745    ,  40473.995    ,
     *   40799.246    ,  41124.496    ,  41449.747    ,  41774.998    ,
     *   42100.248    ,
     *   16823.499    ,  17149.795    ,  17475.914    ,  17801.882    ,
     *   18127.720    ,  18453.446    ,  18779.077    ,  19104.628    ,
     *   19430.109    ,
     *   15380.342    ,  15707.656    ,  16034.629    ,  16361.308    ,
     *   16687.731    ,  17013.936    ,  17339.953    ,  17665.811    ,
     *   17991.532    ,
     *   14534.759    ,  14863.053    ,  15190.854    ,  15518.228    ,
     *   15845.229    ,  16171.911    ,  16498.315    ,  16824.483    ,
     *   17150.449    ,
     *   13933.882    ,  14263.110    ,  14591.708    ,  14919.755    ,
     *   15247.323    ,  15574.474    ,  15901.264    ,  16227.744    ,
     *   16553.959    ,
     *   13467.145    ,  13797.256    ,  14126.614    ,  14455.310    ,
     *   14783.427    ,  15111.038    ,  15438.210    ,  15765.001    ,
     *   16091.465    ,
     *   13085.308    ,  13416.246    ,  13746.325    ,  14075.642    ,
     *   14404.290    ,  14732.349    ,  15059.895    ,  15386.995    ,
     *   15713.709    ,
     *   12762.106    ,  13093.818    ,  13424.576    ,  13754.485    ,
     *   14083.642    ,  14412.136    ,  14740.048    ,  15067.453    ,
     *   15394.416    ,
     *   12481.865    ,  12814.295    ,  13145.691    ,  13476.161    ,
     *   13805.806    ,  14134.719    ,  14462.989    ,  14790.692    ,
     *   15117.902    /
        DATA ((ENTRV (J,K),J=37,45),K=10,18) /
     *   12234.472    ,  12567.566    ,  12899.559    ,  13230.559    ,
     *   13560.669    ,  13889.987    ,  14218.603    ,  14546.599    ,
     *   14874.054    ,
     *   12013.022    ,  12346.728    ,  12679.277    ,  13010.776    ,
     *   13341.329    ,  13671.035    ,  13999.986    ,  14328.269    ,
     *   14655.964    ,
     *   11812.588    ,  12146.855    ,  12479.920    ,  12811.888    ,
     *   13142.861    ,  13472.939    ,  13802.214    ,  14130.776    ,
     *   14458.708    ,
     *   11629.529    ,  11964.309    ,  12297.853    ,  12630.260    ,
     *   12961.632    ,  13292.064    ,  13621.653    ,  13950.486    ,
     *   14278.649    ,
     *   11461.079    ,  11796.327    ,  12130.314    ,  12463.132    ,
     *   12794.879    ,  13125.651    ,  13455.540    ,  13784.638    ,
     *   14113.028    ,
     *   11305.086    ,  11640.760    ,  11975.154    ,  12308.356    ,
     *   12640.458    ,  12971.553    ,  13301.732    ,  13631.085    ,
     *   13959.697    ,
     *   11159.843    ,  11495.902    ,  11830.671    ,  12164.231    ,
     *   12496.668    ,  12828.070    ,  13158.527    ,  13488.127    ,
     *   13816.956    ,
     *   11023.972    ,  11360.379    ,  11695.492    ,  12029.385    ,
     *   12362.136    ,  12693.830    ,  13024.554    ,  13354.394    ,
     *   13683.435    ,
     *   10896.345    ,  11233.065    ,  11568.493    ,  11902.694    ,
     *   12235.740    ,  12567.712    ,  12898.692    ,  13228.763    ,
     *   13558.011    /
        DATA ((ENTRV (J,K),J=37,45),K=19,27) /
     *   10776.026    ,  11113.026    ,  11448.742    ,  11783.228    ,
     *   12116.552    ,  12448.787    ,  12780.012    ,  13110.308    ,
     *   13439.756    ,
     *   10662.231    ,  10999.481    ,  11335.458    ,  11670.209    ,
     *   12003.793    ,  12336.278    ,  12667.737    ,  12998.248    ,
     *   13327.892    ,
     *   10554.296    ,  10891.766    ,  11227.980    ,  11562.976    ,
     *   11896.803    ,  12229.524    ,  12561.207    ,  12891.927    ,
     *   13221.761    ,
     *   10451.651    ,  10789.316    ,  11125.745    ,  11460.966    ,
     *   11795.021    ,  12127.965    ,  12459.862    ,  12790.783    ,
     *   13120.802    ,
     *   10353.809    ,  10691.644    ,  11028.266    ,  11363.694    ,
     *   11697.961    ,  12031.117    ,  12363.219    ,  12694.334    ,
     *   13024.532    ,
     *   10260.345    ,  10598.326    ,  10935.122    ,  11270.740    ,
     *   11605.205    ,  11938.560    ,  12270.858    ,  12602.159    ,
     *   12932.532    ,
     *   10170.888    ,  10508.995    ,  10845.945    ,  11181.736    ,
     *   11516.387    ,  11849.930    ,  12182.414    ,  12513.895    ,
     *   12844.437    ,
     *   10085.112    ,  10423.325    ,  10760.413    ,  11096.362    ,
     *   11431.184    ,  11764.905    ,  12097.567    ,  12429.221    ,
     *   12759.927    ,
     *   10002.731    ,  10341.032    ,  10678.239    ,  11014.333    ,
     *   11349.314    ,  11683.203    ,  12016.034    ,  12347.854    ,
     *   12678.720    /
        DATA ((ENTRV (J,K),J=37,45),K=28,36) /
     *   9923.4874    ,  10261.859    ,  10599.172    ,  10935.396    ,
     *   11270.525    ,  11604.571    ,  11937.564    ,  12269.545    ,
     *   12600.565    ,
     *   9847.1550    ,  10185.582    ,  10522.986    ,  10859.328    ,
     *   11194.593    ,  11528.788    ,  11861.934    ,  12194.069    ,
     *   12525.239    ,
     *   9773.5296    ,  10111.997    ,  10449.479    ,  10785.927    ,
     *   11121.318    ,  11455.652    ,  11788.944    ,  12121.227    ,
     *   12452.543    ,
     *   9702.4277    ,  10040.923    ,  10378.469    ,  10715.012    ,
     *   11050.519    ,  11384.984    ,  11718.415    ,  12050.840    ,
     *   12382.297    ,
     *   9633.6838    ,  9972.1940    ,  10309.794    ,  10646.420    ,
     *   10982.034    ,  11316.621    ,  11650.185    ,  11982.747    ,
     *   12314.340    ,
     *   9567.1483    ,  9905.6619    ,  10243.304    ,  10580.004    ,
     *   10915.716    ,  11250.418    ,  11584.107    ,  11916.800    ,
     *   12248.526    ,
     *   9502.6848    ,  9841.1912    ,  10178.866    ,  10515.630    ,
     *   10851.431    ,  11186.240    ,  11520.049    ,  11852.868    ,
     *   12184.722    ,
     *   9440.1695    ,  9778.6589    ,  10116.357    ,  10453.176    ,
     *   10789.058    ,  11123.968    ,  11457.890    ,  11790.830    ,
     *   12122.808    ,
     *   9379.4890    ,  9717.9523    ,  10055.664    ,  10392.531    ,
     *   10728.486    ,  11063.489    ,  11397.519    ,  11730.575    ,
     *   12062.673    /
        DATA ((ENTRV (J,K),J=37,45),K=37,45) /
     *   9320.5396    ,  9658.9684    ,  9996.6857    ,  10333.592    ,
     *   10669.613    ,  11004.703    ,  11338.834    ,  11672.002    ,
     *   12004.216    ,
     *   9263.2260    ,  9601.6124    ,  9939.3277    ,  10276.266    ,
     *   10612.347    ,  10947.517    ,  11281.745    ,  11615.019    ,
     *   11947.346    ,
     *   9207.4604    ,  9545.7973    ,  9883.5033    ,  10220.466    ,
     *   10556.600    ,  10891.845    ,  11226.164    ,  11559.541    ,
     *   11891.977    ,
     *   9153.1620    ,  9491.4427    ,  9829.1327    ,  10166.114    ,
     *   10502.294    ,  10837.608    ,  11172.013    ,  11505.488    ,
     *   11838.030    ,
     *   9100.2559    ,  9438.4742    ,  9776.1419    ,  10113.135    ,
     *   10449.356    ,  10784.734    ,  11119.221    ,  11452.789    ,
     *   11785.433    ,
     *   9048.6730    ,  9386.8232    ,  9724.4626    ,  10061.462    ,
     *   10397.718    ,  10733.155    ,  11067.718    ,  11401.377    ,
     *   11734.119    ,
     *   8998.3490    ,  9336.4257    ,  9674.0314    ,  10011.031    ,
     *   10347.318    ,  10682.808    ,  11017.444    ,  11351.189    ,
     *   11684.027    ,
     *   8949.2241    ,  9287.2224    ,  9624.7891    ,  9961.7847    ,
     *   10298.096    ,  10633.635    ,  10968.339    ,  11302.167    ,
     *   11635.097    ,
     *   8901.2427    ,  9239.1581    ,  9576.6810    ,  9913.6673    ,
     *   10249.999    ,  10585.582    ,  10920.350    ,  11254.257    ,
     *   11587.276    /
        DATA ((ENTRV (J,K),J=37,45),K=46,54) /
     *   8854.3529    ,  9192.1811    ,  9529.6558    ,  9866.6281    ,
     *   10202.975    ,  10538.599    ,  10873.427    ,  11207.409    ,
     *   11540.514    ,
     *   8808.5064    ,  9146.2435    ,  9483.6656    ,  9820.6196    ,
     *   10156.978    ,  10492.638    ,  10827.522    ,  11161.576    ,
     *   11494.765    ,
     *   8763.6577    ,  9101.3000    ,  9438.6656    ,  9775.5971    ,
     *   10111.963    ,  10447.655    ,  10782.592    ,  11116.714    ,
     *   11449.984    ,
     *   8719.7645    ,  9057.3086    ,  9394.6139    ,  9731.5191    ,
     *   10067.888    ,  10403.609    ,  10738.595    ,  11072.783    ,
     *   11406.130    ,
     *   8676.7869    ,  9014.2296    ,  9351.4712    ,  9688.3464    ,
     *   10024.715    ,  10360.461    ,  10695.493    ,  11029.743    ,
     *   11363.166    ,
     *   8634.6875    ,  8972.0260    ,  9309.2005    ,  9646.0421    ,
     *   9982.4065    ,  10318.174    ,  10653.249    ,  10987.559    ,
     *   11321.054    ,
     *   8593.4312    ,  8930.6626    ,  9267.7669    ,  9604.5718    ,
     *   9940.9289    ,  10276.714    ,  10611.829    ,  10946.195    ,
     *   11279.760    ,
     *   8552.9848    ,  8890.1067    ,  9227.1379    ,  9563.9028    ,
     *   9900.2494    ,  10236.050    ,  10571.201    ,  10905.621    ,
     *   11239.254    ,
     *   8513.3172    ,  8850.3271    ,  9187.2825    ,  9524.0045    ,
     *   9860.3375    ,  10196.150    ,  10531.334    ,  10865.806    ,
     *   11199.504    /
        DATA ((ENTRV (J,K),J=37,45),K=55,63) /
     *   8474.3989    ,  8811.2946    ,  9148.1716    ,  9484.8479    ,
     *   9821.1644    ,  10156.986    ,  10492.201    ,  10826.722    ,
     *   11160.483    ,
     *   8436.2021    ,  8772.9815    ,  9109.7777    ,  9446.4056    ,
     *   9782.7028    ,  10118.531    ,  10453.774    ,  10788.341    ,
     *   11122.162    ,
     *   8398.7004    ,  8735.3617    ,  9072.0747    ,  9408.6517    ,
     *   9744.9270    ,  10080.758    ,  10416.027    ,  10750.638    ,
     *   11084.518    ,
     *   8361.8690    ,  8698.4103    ,  9035.0381    ,  9371.5617    ,
     *   9707.8126    ,  10043.645    ,  10378.937    ,  10713.589    ,
     *   11047.525    ,
     *   8325.6843    ,  8662.1040    ,  8998.6444    ,  9335.1124    ,
     *   9671.3363    ,  10007.167    ,  10342.480    ,  10677.171    ,
     *   11011.161    ,
     *   8290.1240    ,  8626.4204    ,  8962.8715    ,  9299.2817    ,
     *   9635.4765    ,  9971.3037    ,  10306.635    ,  10641.363    ,
     *   10975.405    ,
     *   8255.1667    ,  8591.3384    ,  8927.6985    ,  9264.0488    ,
     *   9600.2121    ,  9936.0333    ,  10271.380    ,  10606.143    ,
     *   10940.236    ,
     *   8220.7923    ,  8556.8380    ,  8893.1053    ,  9229.3937    ,
     *   9565.5234    ,  9901.3363    ,  10236.697    ,  10571.493    ,
     *   10905.634    ,
     *   8186.9817    ,  8522.9000    ,  8859.0729    ,  9195.2975    ,
     *   9531.3916    ,  9867.1942    ,  10202.567    ,  10537.393    ,
     *   10871.580    /
        DATA ((ENTRV (J,K),J=37,45),K=64,72) /
     *   8153.7166    ,  8489.5064    ,  8825.5832    ,  9161.7424    ,
     *   9497.7988    ,  9833.5889    ,  10168.971    ,  10503.826    ,
     *   10838.058    ,
     *   8120.9796    ,  8456.6397    ,  8792.6191    ,  9128.7110    ,
     *   9464.7280    ,  9800.5037    ,  10135.894    ,  10470.776    ,
     *   10805.050    ,
     *   8088.7541    ,  8424.2835    ,  8760.1641    ,  9096.1871    ,
     *   9432.1628    ,  9767.9222    ,  10103.318    ,  10438.225    ,
     *   10772.541    ,
     *   8057.0243    ,  8392.4221    ,  8728.2025    ,  9064.1551    ,
     *   9400.0878    ,  9735.8291    ,  10071.229    ,  10406.159    ,
     *   10740.514    ,
     *   8025.7753    ,  8361.0404    ,  8696.7195    ,  9032.6001    ,
     *   9368.4882    ,  9704.2096    ,  10039.612    ,  10374.563    ,
     *   10708.956    ,
     *   7994.9925    ,  8330.1242    ,  8665.7007    ,  9001.5079    ,
     *   9337.3497    ,  9673.0496    ,  10008.452    ,  10343.423    ,
     *   10677.852    ,
     *   7964.6622    ,  8299.6596    ,  8635.1325    ,  8970.8650    ,
     *   9306.6589    ,  9642.3356    ,  9977.7368    ,  10312.726    ,
     *   10647.189    ,
     *   7934.7712    ,  8269.6337    ,  8605.0018    ,  8940.6583    ,
     *   9276.4029    ,  9612.0547    ,  9947.4531    ,  10282.459    ,
     *   10616.955    ,
     *   7905.3070    ,  8240.0337    ,  8575.2961    ,  8910.8753    ,
     *   9246.5693    ,  9582.1947    ,  9917.5887    ,  10252.609    ,
     *   10587.137    /
        DATA ((ENTRV (J,K),J=37,45),K=73,81) /
     *   7876.2575    ,  8210.8479    ,  8546.0036    ,  8881.5043    ,
     *   9217.1461    ,  9552.7437    ,  9888.1317    ,  10223.166    ,
     *   10557.723    ,
     *   7847.6111    ,  8182.0645    ,  8517.1126    ,  8852.5337    ,
     *   9188.1221    ,  9523.6904    ,  9859.0710    ,  10194.117    ,
     *   10528.703    ,
     *   7819.3567    ,  8153.6726    ,  8488.6122    ,  8823.9526    ,
     *   9159.4863    ,  9495.0239    ,  9830.3956    ,  10165.452    ,
     *   10500.065    ,
     *   7791.4838    ,  8125.6616    ,  8460.4919    ,  8795.7505    ,
     *   9131.2283    ,  9466.7339    ,  9802.0953    ,  10137.161    ,
     *   10471.800    ,
     *   7763.9820    ,  8098.0213    ,  8432.7415    ,  8767.9173    ,
     *   9103.3380    ,  9438.8103    ,  9774.1600    ,  10109.233    ,
     *   10443.896    ,
     *   7736.8417    ,  8070.7419    ,  8405.3514    ,  8740.4433    ,
     *   9075.8058    ,  9411.2435    ,  9746.5802    ,  10081.659    ,
     *   10416.346    ,
     *   7710.0533    ,  8043.8141    ,  8378.3121    ,  8713.3193    ,
     *   9048.6224    ,  9384.0243    ,  9719.3467    ,  10054.431    ,
     *   10389.139    ,
     *   7683.6079    ,  8017.2288    ,  8351.6146    ,  8686.5363    ,
     *   9021.7789    ,  9357.1438    ,  9692.4507    ,  10027.539    ,
     *   10362.268    ,
     *   7657.4967    ,  7990.9774    ,  8325.2504    ,  8660.0856    ,
     *   8995.2668    ,  9330.5935    ,  9665.8836    ,  10000.974    ,
     *   10335.722    /
        DATA ((ENTRV (J,K),J=46,54),K= 1, 9) /
     *   42425.499    ,  42750.750    ,  43076.000    ,  43401.251    ,
     *   43726.502    ,  44051.752    ,  44377.003    ,  44702.254    ,
     *   45027.504    ,
     *   19755.533    ,  20080.908    ,  20406.243    ,  20731.544    ,
     *   21056.818    ,  21382.068    ,  21707.301    ,  22032.519    ,
     *   22357.726    ,
     *   18317.137    ,  18642.646    ,  18968.073    ,  19293.432    ,
     *   19618.735    ,  19943.992    ,  20269.213    ,  20594.403    ,
     *   20919.570    ,
     *   17476.243    ,  17801.892    ,  18127.418    ,  18452.842    ,
     *   18778.182    ,  19103.452    ,  19428.665    ,  19753.833    ,
     *   20078.964    ,
     *   16879.946    ,  17205.740    ,  17531.372    ,  17856.867    ,
     *   18182.248    ,  18507.536    ,  18832.748    ,  19157.897    ,
     *   19482.998    ,
     *   16417.649    ,  16743.593    ,  17069.335    ,  17394.907    ,
     *   17720.336    ,  18045.647    ,  18370.861    ,  18695.997    ,
     *   19021.071    ,
     *   16040.092    ,  16366.190    ,  16692.047    ,  17017.699    ,
     *   17343.181    ,  17668.520    ,  17993.742    ,  18318.868    ,
     *   18643.919    ,
     *   15720.998    ,  16047.253    ,  16373.228    ,  16698.966    ,
     *   17024.504    ,  17349.876    ,  17675.110    ,  18000.231    ,
     *   18325.262    ,
     *   15444.685    ,  15771.097    ,  16097.194    ,  16423.021    ,
     *   16748.620    ,  17074.028    ,  17399.278    ,  17724.399    ,
     *   18049.414    /
        DATA ((ENTRV (J,K),J=46,54),K=10,18) /
     *   15201.035    ,  15527.607    ,  15853.828    ,  16179.747    ,
     *   16505.410    ,  16830.860    ,  17156.130    ,  17481.253    ,
     *   17806.256    ,
     *   14983.144    ,  15309.876    ,  15636.222    ,  15962.236    ,
     *   16287.968    ,  16613.461    ,  16938.755    ,  17263.885    ,
     *   17588.880    ,
     *   14786.084    ,  15112.977    ,  15439.450    ,  15765.562    ,
     *   16091.365    ,  16416.906    ,  16742.227    ,  17067.367    ,
     *   17392.357    ,
     *   14606.221    ,  14933.274    ,  15259.875    ,  15586.086    ,
     *   15911.963    ,  16237.555    ,  16562.908    ,  16888.060    ,
     *   17213.049    ,
     *   14440.792    ,  14768.004    ,  15094.735    ,  15421.047    ,
     *   15747.000    ,  16072.646    ,  16398.033    ,  16723.202    ,
     *   17048.192    ,
     *   14287.651    ,  14615.022    ,  14941.882    ,  15268.298    ,
     *   15594.330    ,  15920.032    ,  16245.456    ,  16570.645    ,
     *   16895.640    ,
     *   14145.097    ,  14472.625    ,  14799.616    ,  15126.136    ,
     *   15452.248    ,  15778.010    ,  16103.474    ,  16428.686    ,
     *   16753.688    ,
     *   14011.759    ,  14339.444    ,  14666.564    ,  14993.190    ,
     *   15319.385    ,  15645.208    ,  15970.714    ,  16295.952    ,
     *   16620.965    ,
     *   13886.515    ,  14214.355    ,  14541.606    ,  14868.338    ,
     *   15194.617    ,  15520.504    ,  15846.055    ,  16171.321    ,
     *   16496.348    /
        DATA ((ENTRV (J,K),J=46,54),K=19,27) /
     *   13768.437    ,  14096.430    ,  14423.811    ,  14750.650    ,
     *   15077.014    ,  15402.967    ,  15728.566    ,  16053.863    ,
     *   16378.907    ,
     *   13656.747    ,  13984.891    ,  14312.401    ,  14639.348    ,
     *   14965.800    ,  15291.820    ,  15617.469    ,  15942.800    ,
     *   16267.862    ,
     *   13550.786    ,  13879.080    ,  14206.719    ,  14533.774    ,
     *   14860.314    ,  15186.404    ,  15512.104    ,  15837.471    ,
     *   16162.555    ,
     *   13449.994    ,  13778.436    ,  14106.202    ,  14433.365    ,
     *   14759.995    ,  15086.156    ,  15411.910    ,  15737.315    ,
     *   16062.423    ,
     *   13353.887    ,  13682.474    ,  14010.368    ,  14337.639    ,
     *   14664.359    ,  14990.593    ,  15316.403    ,  15641.849    ,
     *   15966.982    ,
     *   13262.047    ,  13590.778    ,  13918.797    ,  14246.177    ,
     *   14572.988    ,  14899.296    ,  15225.164    ,  15550.652    ,
     *   15875.814    ,
     *   13174.108    ,  13502.980    ,  13831.125    ,  14158.614    ,
     *   14485.516    ,  14811.899    ,  15137.827    ,  15463.359    ,
     *   15788.552    ,
     *   13089.751    ,  13418.763    ,  13747.031    ,  14074.628    ,
     *   14401.623    ,  14728.082    ,  15054.071    ,  15379.649    ,
     *   15704.875    ,
     *   13008.694    ,  13337.842    ,  13666.234    ,  13993.939    ,
     *   14321.026    ,  14647.563    ,  14973.614    ,  15299.241    ,
     *   15624.501    /
        DATA ((ENTRV (J,K),J=46,54),K=28,36) /
     *   12930.685    ,  13259.968    ,  13588.481    ,  13916.294    ,
     *   14243.474    ,  14570.089    ,  14896.204    ,  15221.881    ,
     *   15547.178    ,
     *   12855.501    ,  13184.917    ,  13513.551    ,  13841.471    ,
     *   14168.745    ,  14495.439    ,  14821.619    ,  15147.348    ,
     *   15472.683    ,
     *   12782.944    ,  13112.490    ,  13441.244    ,  13769.271    ,
     *   14096.638    ,  14423.413    ,  14749.659    ,  15075.440    ,
     *   15400.816    ,
     *   12712.834    ,  13042.508    ,  13371.380    ,  13699.513    ,
     *   14026.975    ,  14353.830    ,  14680.144    ,  15005.979    ,
     *   15331.397    ,
     *   12645.010    ,  12974.810    ,  13303.798    ,  13632.037    ,
     *   13959.593    ,  14286.529    ,  14612.912    ,  14938.803    ,
     *   15264.264    ,
     *   12579.326    ,  12909.249    ,  13238.352    ,  13566.697    ,
     *   13894.346    ,  14221.365    ,  14547.817    ,  14873.766    ,
     *   15199.272    ,
     *   12515.648    ,  12845.693    ,  13174.910    ,  13503.360    ,
     *   13831.103    ,  14158.204    ,  14484.726    ,  14810.733    ,
     *   15136.286    ,
     *   12453.857    ,  12784.021    ,  13113.351    ,  13441.904    ,
     *   13769.742    ,  14096.925    ,  14423.519    ,  14749.586    ,
     *   15075.186    ,
     *   12393.842    ,  12724.123    ,  13053.565    ,  13382.221    ,
     *   13710.152    ,  14037.419    ,  14364.085    ,  14690.212    ,
     *   15015.862    /
        DATA ((ENTRV (J,K),J=46,54),K=37,45) /
     *   12335.503    ,  12665.899    ,  12995.450    ,  13324.209    ,
     *   13652.234    ,  13979.585    ,  14306.323    ,  14632.512    ,
     *   14958.212    ,
     *   12278.747    ,  12609.256    ,  12938.916    ,  13267.776    ,
     *   13595.894    ,  13923.329    ,  14250.141    ,  14576.392    ,
     *   14902.144    ,
     *   12223.489    ,  12554.109    ,  12883.875    ,  13212.837    ,
     *   13541.048    ,  13868.567    ,  14195.453    ,  14521.768    ,
     *   14847.573    ,
     *   12169.651    ,  12500.380    ,  12830.251    ,  13159.313    ,
     *   13487.617    ,  13815.220    ,  14142.181    ,  14468.560    ,
     *   14794.419    ,
     *   12117.161    ,  12447.995    ,  12777.971    ,  13107.132    ,
     *   13435.529    ,  13763.216    ,  14090.252    ,  14416.697    ,
     *   14742.611    ,
     *   12065.950    ,  12396.890    ,  12726.968    ,  13056.228    ,
     *   13384.716    ,  13712.487    ,  14039.599    ,  14366.110    ,
     *   14692.081    ,
     *   12015.958    ,  12347.000    ,  12677.180    ,  13006.537    ,
     *   13335.117    ,  13662.973    ,  13990.160    ,  14316.738    ,
     *   14642.766    ,
     *   11967.127    ,  12298.269    ,  12628.549    ,  12958.002    ,
     *   13286.674    ,  13614.614    ,  13941.878    ,  14268.523    ,
     *   14594.608    ,
     *   11919.402    ,  12250.642    ,  12581.021    ,  12910.570    ,
     *   13239.332    ,  13567.357    ,  13894.697    ,  14221.410    ,
     *   14547.555    /
        DATA ((ENTRV (J,K),J=46,54),K=46,54) /
     *   11872.733    ,  12204.071    ,  12534.546    ,  12864.190    ,
     *   13193.043    ,  13521.151    ,  13848.569    ,  14175.351    ,
     *   14501.555    ,
     *   11827.075    ,  12158.507    ,  12489.078    ,  12818.815    ,
     *   13147.758    ,  13475.951    ,  13803.446    ,  14130.297    ,
     *   14456.562    ,
     *   11782.382    ,  12113.907    ,  12444.572    ,  12774.403    ,
     *   13103.435    ,  13431.712    ,  13759.284    ,  14086.205    ,
     *   14412.531    ,
     *   11738.615    ,  12070.231    ,  12400.989    ,  12730.911    ,
     *   13060.032    ,  13388.393    ,  13716.043    ,  14043.034    ,
     *   14369.422    ,
     *   11695.734    ,  12027.439    ,  12358.288    ,  12688.302    ,
     *   13017.511    ,  13345.956    ,  13673.684    ,  14000.745    ,
     *   14327.196    ,
     *   11653.703    ,  11985.496    ,  12316.436    ,  12646.540    ,
     *   12975.837    ,  13304.365    ,  13632.170    ,  13959.302    ,
     *   14285.816    ,
     *   11612.490    ,  11944.368    ,  12275.397    ,  12605.590    ,
     *   12934.974    ,  13263.586    ,  13591.468    ,  13918.672    ,
     *   14245.250    ,
     *   11572.061    ,  11904.023    ,  12235.139    ,  12565.420    ,
     *   12894.891    ,  13223.586    ,  13551.547    ,  13878.822    ,
     *   14205.464    ,
     *   11532.387    ,  11864.431    ,  12195.633    ,  12526.002    ,
     *   12855.558    ,  13184.336    ,  13512.375    ,  13839.722    ,
     *   14166.429    /
        DATA ((ENTRV (J,K),J=46,54),K=55,63) /
     *   11493.438    ,  11825.564    ,  12156.850    ,  12487.305    ,
     *   12816.947    ,  13145.807    ,  13473.924    ,  13801.343    ,
     *   14128.115    ,
     *   11455.189    ,  11787.394    ,  12118.764    ,  12449.304    ,
     *   12779.031    ,  13107.973    ,  13436.168    ,  13763.659    ,
     *   14090.497    ,
     *   11417.615    ,  11749.896    ,  12081.349    ,  12411.973    ,
     *   12741.784    ,  13070.808    ,  13399.081    ,  13726.645    ,
     *   14053.549    ,
     *   11380.690    ,  11713.047    ,  12044.581    ,  12375.288    ,
     *   12705.183    ,  13034.288    ,  13362.639    ,  13690.276    ,
     *   14017.246    ,
     *   11344.392    ,  11676.824    ,  12008.437    ,  12339.227    ,
     *   12669.204    ,  12998.391    ,  13326.819    ,  13654.529    ,
     *   13981.567    ,
     *   11308.700    ,  11641.204    ,  11972.896    ,  12303.768    ,
     *   12633.827    ,  12963.094    ,  13291.600    ,  13619.383    ,
     *   13946.488    ,
     *   11273.592    ,  11606.168    ,  11937.937    ,  12268.889    ,
     *   12599.030    ,  12928.378    ,  13256.961    ,  13584.817    ,
     *   13911.990    ,
     *   11239.051    ,  11571.696    ,  11903.541    ,  12234.573    ,
     *   12564.795    ,  12894.223    ,  13222.883    ,  13550.813    ,
     *   13878.053    ,
     *   11205.056    ,  11537.770    ,  11869.690    ,  12200.801    ,
     *   12531.103    ,  12860.610    ,  13189.348    ,  13517.350    ,
     *   13844.659    /
        DATA ((ENTRV (J,K),J=46,54),K=64,72) /
     *   11171.591    ,  11504.372    ,  11836.366    ,  12167.554    ,
     *   12497.936    ,  12827.522    ,  13156.337    ,  13484.412    ,
     *   13811.790    ,
     *   11138.639    ,  11471.485    ,  11803.551    ,  12134.817    ,
     *   12465.277    ,  12794.942    ,  13123.834    ,  13451.983    ,
     *   13779.429    ,
     *   11106.184    ,  11439.094    ,  11771.231    ,  12102.572    ,
     *   12433.111    ,  12762.854    ,  13091.822    ,  13420.045    ,
     *   13747.560    ,
     *   11074.210    ,  11407.183    ,  11739.390    ,  12070.806    ,
     *   12401.422    ,  12731.244    ,  13060.288    ,  13388.584    ,
     *   13716.167    ,
     *   11042.702    ,  11375.737    ,  11708.013    ,  12039.503    ,
     *   12370.196    ,  12700.095    ,  13029.216    ,  13357.585    ,
     *   13685.238    ,
     *   11011.648    ,  11344.743    ,  11677.087    ,  12008.650    ,
     *   12339.419    ,  12669.395    ,  12998.591    ,  13327.034    ,
     *   13654.756    ,
     *   10981.033    ,  11314.187    ,  11646.598    ,  11978.234    ,
     *   12309.078    ,  12639.130    ,  12968.402    ,  13296.918    ,
     *   13624.709    ,
     *   10950.846    ,  11284.057    ,  11616.534    ,  11948.241    ,
     *   12279.160    ,  12609.288    ,  12938.635    ,  13267.224    ,
     *   13595.085    ,
     *   10921.073    ,  11254.340    ,  11586.882    ,  11918.659    ,
     *   12249.653    ,  12579.856    ,  12909.279    ,  13237.940    ,
     *   13565.871    /
        DATA ((ENTRV (J,K),J=46,54),K=73,81) /
     *   10891.703    ,  11225.026    ,  11557.631    ,  11889.478    ,
     *   12220.545    ,  12550.823    ,  12880.321    ,  13209.055    ,
     *   13537.056    ,
     *   10862.725    ,  11196.102    ,  11528.769    ,  11860.685    ,
     *   12191.825    ,  12522.178    ,  12851.750    ,  13180.557    ,
     *   13508.627    ,
     *   10834.129    ,  11167.558    ,  11500.287    ,  11832.271    ,
     *   12163.482    ,  12493.909    ,  12823.555    ,  13152.435    ,
     *   13480.575    ,
     *   10805.903    ,  11139.383    ,  11472.173    ,  11804.224    ,
     *   12135.507    ,  12466.008    ,  12795.728    ,  13124.680    ,
     *   13452.890    ,
     *   10778.039    ,  11111.569    ,  11444.418    ,  11776.536    ,
     *   12107.889    ,  12438.463    ,  12768.256    ,  13097.281    ,
     *   13425.561    ,
     *   10750.526    ,  11084.105    ,  11417.013    ,  11749.196    ,
     *   12080.619    ,  12411.266    ,  12741.132    ,  13070.229    ,
     *   13398.579    ,
     *   10723.355    ,  11056.983    ,  11389.948    ,  11722.195    ,
     *   12053.688    ,  12384.407    ,  12714.346    ,  13043.515    ,
     *   13371.934    ,
     *   10696.518    ,  11030.193    ,  11363.215    ,  11695.526    ,
     *   12027.087    ,  12357.877    ,  12687.889    ,  13017.130    ,
     *   13345.619    ,
     *   10670.007    ,  11003.728    ,  11336.805    ,  11669.179    ,
     *   12000.808    ,  12331.669    ,  12661.753    ,  12991.066    ,
     *   13319.625    /
        DATA ((ENTRV (J,K),J=55,63),K= 1, 9) /
     *   45352.755    ,  45678.006    ,  46003.256    ,  46328.507    ,
     *   46653.758    ,  46979.008    ,  47304.259    ,  47629.509    ,
     *   47954.760    ,
     *   22682.924    ,  23008.115    ,  23333.302    ,  23658.485    ,
     *   23983.667    ,  24308.849    ,  24634.030    ,  24959.212    ,
     *   25284.396    ,
     *   21244.719    ,  21569.854    ,  21894.980    ,  22220.099    ,
     *   22545.214    ,  22870.327    ,  23195.441    ,  23520.555    ,
     *   23845.672    ,
     *   20404.068    ,  20729.150    ,  21054.217    ,  21379.274    ,
     *   21704.324    ,  22029.371    ,  22354.418    ,  22679.466    ,
     *   23004.518    ,
     *   19808.060    ,  20133.093    ,  20458.104    ,  20783.101    ,
     *   21108.088    ,  21433.070    ,  21758.051    ,  22083.034    ,
     *   22408.022    ,
     *   19346.095    ,  19671.081    ,  19996.040    ,  20320.979    ,
     *   20645.905    ,  20970.825    ,  21295.742    ,  21620.661    ,
     *   21945.584    ,
     *   18968.908    ,  19293.852    ,  19618.760    ,  19943.644    ,
     *   20268.512    ,  20593.370    ,  20918.225    ,  21243.081    ,
     *   21567.942    ,
     *   18650.221    ,  18975.124    ,  19299.985    ,  19624.817    ,
     *   19949.628    ,  20274.427    ,  20599.221    ,  20924.015    ,
     *   21248.814    ,
     *   18374.345    ,  18699.212    ,  19024.029    ,  19348.810    ,
     *   19673.566    ,  19998.308    ,  20323.042    ,  20647.777    ,
     *   20972.516    /
        DATA ((ENTRV (J,K),J=55,63),K=10,18) /
     *   18131.164    ,  18455.996    ,  18780.771    ,  19105.505    ,
     *   19430.209    ,  19754.895    ,  20079.572    ,  20404.247    ,
     *   20728.927    ,
     *   17913.767    ,  18238.568    ,  18563.305    ,  18887.993    ,
     *   19212.647    ,  19537.279    ,  19861.900    ,  20186.518    ,
     *   20511.140    ,
     *   17717.226    ,  18042.000    ,  18366.701    ,  18691.346    ,
     *   19015.952    ,  19340.533    ,  19665.099    ,  19989.661    ,
     *   20314.226    ,
     *   17537.904    ,  17862.653    ,  18187.320    ,  18511.925    ,
     *   18836.486    ,  19161.017    ,  19485.530    ,  19810.038    ,
     *   20134.547    ,
     *   17373.037    ,  17697.764    ,  18022.400    ,  18346.967    ,
     *   18671.484    ,  18995.967    ,  19320.430    ,  19644.885    ,
     *   19969.340    ,
     *   17220.476    ,  17545.185    ,  17869.793    ,  18194.324    ,
     *   18518.800    ,  18843.237    ,  19167.651    ,  19492.054    ,
     *   19816.456    ,
     *   17078.519    ,  17403.212    ,  17727.795    ,  18052.293    ,
     *   18376.730    ,  18701.123    ,  19025.490    ,  19349.842    ,
     *   19674.192    ,
     *   16945.794    ,  17270.473    ,  17595.033    ,  17919.501    ,
     *   18243.901    ,  18568.253    ,  18892.573    ,  19216.877    ,
     *   19541.177    ,
     *   16821.177    ,  17145.846    ,  17470.386    ,  17794.826    ,
     *   18119.191    ,  18443.502    ,  18767.779    ,  19092.036    ,
     *   19416.287    /
        DATA ((ENTRV (J,K),J=55,63),K=19,27) /
     *   16703.739    ,  17028.400    ,  17352.922    ,  17677.336    ,
     *   18001.668    ,  18325.942    ,  18650.176    ,  18974.388    ,
     *   19298.591    ,
     *   16592.700    ,  16917.355    ,  17241.862    ,  17566.253    ,
     *   17890.555    ,  18214.792    ,  18538.986    ,  18863.154    ,
     *   19187.311    ,
     *   16487.402    ,  16812.054    ,  17136.548    ,  17460.917    ,
     *   17785.191    ,  18109.394    ,  18433.549    ,  18757.675    ,
     *   19081.787    ,
     *   16387.281    ,  16711.932    ,  17036.416    ,  17360.766    ,
     *   17685.014    ,  18009.185    ,  18333.303    ,  18657.388    ,
     *   18981.457    ,
     *   16291.854    ,  16616.507    ,  16940.983    ,  17265.316    ,
     *   17589.540    ,  17913.681    ,  18237.764    ,  18561.810    ,
     *   18885.836    ,
     *   16200.701    ,  16525.358    ,  16849.828    ,  17174.147    ,
     *   17498.349    ,  17822.462    ,  18146.511    ,  18470.519    ,
     *   18794.505    ,
     *   16113.457    ,  16438.121    ,  16762.587    ,  17086.894    ,
     *   17411.075    ,  17735.161    ,  18059.179    ,  18383.151    ,
     *   18707.098    ,
     *   16029.800    ,  16354.473    ,  16678.938    ,  17003.234    ,
     *   17327.398    ,  17651.459    ,  17975.447    ,  18299.385    ,
     *   18623.293    ,
     *   15949.448    ,  16274.132    ,  16598.598    ,  16922.886    ,
     *   17247.033    ,  17571.072    ,  17895.031    ,  18218.936    ,
     *   18542.808    /
        DATA ((ENTRV (J,K),J=55,63),K=28,36) /
     *   15872.149    ,  16196.846    ,  16521.315    ,  16845.597    ,
     *   17169.730    ,  17493.748    ,  17817.681    ,  18141.554    ,
     *   18465.391    ,
     *   15797.681    ,  16122.393    ,  16446.866    ,  16771.144    ,
     *   17095.265    ,  17419.263    ,  17743.171    ,  18067.015    ,
     *   18390.818    ,
     *   15725.842    ,  16050.571    ,  16375.051    ,  16699.326    ,
     *   17023.437    ,  17347.418    ,  17671.303    ,  17995.118    ,
     *   18318.889    ,
     *   15656.453    ,  15981.201    ,  16305.690    ,  16629.965    ,
     *   16954.067    ,  17278.033    ,  17601.896    ,  17925.684    ,
     *   18249.424    ,
     *   15589.352    ,  15914.121    ,  16238.620    ,  16562.897    ,
     *   16886.992    ,  17210.944    ,  17534.787    ,  17858.551    ,
     *   18182.261    ,
     *   15524.393    ,  15849.184    ,  16173.696    ,  16497.976    ,
     *   16822.066    ,  17146.006    ,  17469.831    ,  17793.570    ,
     *   18117.253    ,
     *   15461.442    ,  15786.258    ,  16110.784    ,  16435.069    ,
     *   16759.156    ,  17083.086    ,  17406.894    ,  17730.611    ,
     *   18054.266    ,
     *   15400.379    ,  15725.221    ,  16049.763    ,  16374.055    ,
     *   16698.141    ,  17022.062    ,  17345.854    ,  17669.550    ,
     *   17993.180    ,
     *   15341.093    ,  15665.963    ,  15990.523    ,  16314.823    ,
     *   16638.909    ,  16962.823    ,  17286.601    ,  17610.278    ,
     *   17933.884    /
        DATA ((ENTRV (J,K),J=55,63),K=37,45) /
     *   15283.483    ,  15608.382    ,  15932.961    ,  16257.272    ,
     *   16581.360    ,  16905.268    ,  17229.034    ,  17552.693    ,
     *   17876.276    ,
     *   15227.457    ,  15552.386    ,  15876.986    ,  16201.309    ,
     *   16525.400    ,  16849.304    ,  17173.059    ,  17496.702    ,
     *   17820.263    ,
     *   15172.928    ,  15497.889    ,  15822.512    ,  16146.848    ,
     *   16470.944    ,  16794.846    ,  17118.592    ,  17442.219    ,
     *   17765.760    ,
     *   15119.818    ,  15444.813    ,  15769.460    ,  16093.811    ,
     *   16417.914    ,  16741.814    ,  17065.552    ,  17389.166    ,
     *   17712.688    ,
     *   15068.054    ,  15393.084    ,  15717.757    ,  16042.124    ,
     *   16366.235    ,  16690.136    ,  17013.868    ,  17337.469    ,
     *   17660.974    ,
     *   15017.570    ,  15342.637    ,  15667.336    ,  15991.721    ,
     *   16315.842    ,  16639.745    ,  16963.472    ,  17287.062    ,
     *   17610.550    ,
     *   14968.302    ,  15293.407    ,  15618.134    ,  15942.539    ,
     *   16266.671    ,  16590.577    ,  16914.301    ,  17237.881    ,
     *   17561.353    ,
     *   14920.194    ,  15245.337    ,  15570.094    ,  15894.520    ,
     *   16218.664    ,  16542.575    ,  16866.296    ,  17189.868    ,
     *   17513.327    ,
     *   14873.190    ,  15198.373    ,  15523.161    ,  15847.609    ,
     *   16171.767    ,  16495.684    ,  16819.405    ,  17142.969    ,
     *   17466.415    /
        DATA ((ENTRV (J,K),J=55,63),K=46,54) /
     *   14827.240    ,  15152.465    ,  15477.285    ,  15801.756    ,
     *   16125.930    ,  16449.854    ,  16773.575    ,  17097.134    ,
     *   17420.568    ,
     *   14782.298    ,  15107.565    ,  15432.419    ,  15756.915    ,
     *   16081.105    ,  16405.038    ,  16728.761    ,  17052.315    ,
     *   17375.739    ,
     *   14738.320    ,  15063.631    ,  15388.519    ,  15713.041    ,
     *   16037.249    ,  16361.192    ,  16684.918    ,  17008.468    ,
     *   17331.883    ,
     *   14695.264    ,  15020.619    ,  15345.544    ,  15670.093    ,
     *   15994.319    ,  16318.274    ,  16642.004    ,  16965.552    ,
     *   17288.959    ,
     *   14653.092    ,  14978.493    ,  15303.454    ,  15628.031    ,
     *   15952.278    ,  16276.246    ,  16599.981    ,  16923.529    ,
     *   17246.929    ,
     *   14611.768    ,  14937.215    ,  15262.214    ,  15586.821    ,
     *   15911.089    ,  16235.071    ,  16558.813    ,  16882.360    ,
     *   17205.755    ,
     *   14571.257    ,  14896.752    ,  15221.790    ,  15546.427    ,
     *   15870.718    ,  16194.715    ,  16518.465    ,  16842.014    ,
     *   17165.403    ,
     *   14531.528    ,  14857.071    ,  15182.149    ,  15506.818    ,
     *   15831.133    ,  16155.145    ,  16478.904    ,  16802.456    ,
     *   17125.842    ,
     *   14492.550    ,  14818.142    ,  15143.261    ,  15467.963    ,
     *   15792.303    ,  16116.332    ,  16440.102    ,  16763.657    ,
     *   17087.040    /
        DATA ((ENTRV (J,K),J=55,63),K=55,63) /
     *   14454.295    ,  14779.936    ,  15105.097    ,  15429.833    ,
     *   15754.199    ,  16078.247    ,  16402.028    ,  16725.587    ,
     *   17048.970    ,
     *   14416.735    ,  14742.428    ,  15067.631    ,  15392.402    ,
     *   15716.795    ,  16040.863    ,  16364.655    ,  16688.221    ,
     *   17011.603    ,
     *   14379.846    ,  14705.590    ,  15030.837    ,  15355.644    ,
     *   15680.065    ,  16004.153    ,  16327.959    ,  16651.532    ,
     *   16974.915    ,
     *   14343.603    ,  14669.399    ,  14994.691    ,  15319.535    ,
     *   15643.985    ,  15968.094    ,  16291.915    ,  16615.495    ,
     *   16938.880    ,
     *   14307.983    ,  14633.833    ,  14959.170    ,  15284.051    ,
     *   15608.531    ,  15932.663    ,  16256.500    ,  16580.089    ,
     *   16903.476    ,
     *   14272.965    ,  14598.868    ,  14924.252    ,  15249.172    ,
     *   15573.683    ,  15897.839    ,  16221.691    ,  16545.290    ,
     *   16868.681    ,
     *   14238.529    ,  14564.486    ,  14889.916    ,  15214.876    ,
     *   15539.418    ,  15863.599    ,  16187.469    ,  16511.079    ,
     *   16834.475    ,
     *   14204.654    ,  14530.666    ,  14856.144    ,  15181.143    ,
     *   15505.719    ,  15829.925    ,  16153.814    ,  16477.436    ,
     *   16800.837    ,
     *   14171.322    ,  14497.389    ,  14822.916    ,  15147.956    ,
     *   15472.565    ,  15796.798    ,  16120.706    ,  16444.341    ,
     *   16767.749    /
        DATA ((ENTRV (J,K),J=55,63),K=64,72) /
     *   14138.515    ,  14464.639    ,  14790.214    ,  15115.296    ,
     *   15439.940    ,  15764.200    ,  16088.129    ,  16411.777    ,
     *   16735.193    ,
     *   14106.217    ,  14432.397    ,  14758.022    ,  15083.147    ,
     *   15407.826    ,  15732.114    ,  16056.064    ,  16379.727    ,
     *   16703.151    ,
     *   14074.411    ,  14400.648    ,  14726.324    ,  15051.492    ,
     *   15376.208    ,  15700.525    ,  16024.497    ,  16348.175    ,
     *   16671.609    ,
     *   14043.083    ,  14369.378    ,  14695.104    ,  15020.316    ,
     *   15345.069    ,  15669.416    ,  15993.411    ,  16317.106    ,
     *   16640.550    ,
     *   14012.217    ,  14338.570    ,  14664.348    ,  14989.605    ,
     *   15314.395    ,  15638.773    ,  15962.792    ,  16286.504    ,
     *   16609.959    ,
     *   13981.799    ,  14308.211    ,  14634.041    ,  14959.344    ,
     *   15284.172    ,  15608.582    ,  15932.626    ,  16256.356    ,
     *   16579.823    ,
     *   13951.818    ,  14278.288    ,  14604.171    ,  14929.519    ,
     *   15254.387    ,  15578.829    ,  15902.898    ,  16226.648    ,
     *   16550.127    ,
     *   13922.258    ,  14248.788    ,  14574.724    ,  14900.119    ,
     *   15225.027    ,  15549.502    ,  15873.598    ,  16197.367    ,
     *   16520.860    ,
     *   13893.109    ,  14219.699    ,  14545.689    ,  14871.131    ,
     *   15196.079    ,  15520.588    ,  15844.711    ,  16168.501    ,
     *   16492.008    /
        DATA ((ENTRV (J,K),J=55,63),K=73,81) /
     *   13864.359    ,  14191.009    ,  14517.053    ,  14842.543    ,
     *   15167.533    ,  15492.076    ,  15816.227    ,  16140.038    ,
     *   16463.561    ,
     *   13835.996    ,  14162.706    ,  14488.805    ,  14814.344    ,
     *   15139.375    ,  15463.954    ,  15788.133    ,  16111.967    ,
     *   16435.505    ,
     *   13808.010    ,  14134.781    ,  14460.935    ,  14786.523    ,
     *   15111.597    ,  15436.211    ,  15760.420    ,  16084.276    ,
     *   16407.832    ,
     *   13780.391    ,  14107.223    ,  14433.432    ,  14759.069    ,
     *   15084.186    ,  15408.837    ,  15733.076    ,  16056.956    ,
     *   16380.529    ,
     *   13753.128    ,  14080.021    ,  14406.286    ,  14731.973    ,
     *   15057.134    ,  15381.823    ,  15706.092    ,  16029.997    ,
     *   16353.588    ,
     *   13726.212    ,  14053.167    ,  14379.488    ,  14705.226    ,
     *   15030.431    ,  15355.157    ,  15679.459    ,  16003.388    ,
     *   16326.999    ,
     *   13699.634    ,  14026.651    ,  14353.029    ,  14678.818    ,
     *   15004.068    ,  15328.832    ,  15653.166    ,  15977.121    ,
     *   16300.751    ,
     *   13673.385    ,  14000.464    ,  14326.900    ,  14652.740    ,
     *   14978.035    ,  15302.839    ,  15627.205    ,  15951.187    ,
     *   16274.838    ,
     *   13647.457    ,  13974.599    ,  14301.092    ,  14626.984    ,
     *   14952.325    ,  15277.168    ,  15601.568    ,  15925.577    ,
     *   16249.249    /
        DATA ((ENTRV (J,K),J=64,72),K= 1, 9) /
     *   48280.011    ,  48605.261    ,  48930.512    ,  49255.763    ,
     *   49581.013    ,  49906.264    ,  50231.515    ,  50556.765    ,
     *   50882.016    ,
     *   25609.581    ,  25934.768    ,  26259.958    ,  26585.151    ,
     *   26910.346    ,  27235.544    ,  27560.744    ,  27885.947    ,
     *   28211.153    ,
     *   24170.793    ,  24495.918    ,  24821.047    ,  25146.182    ,
     *   25471.321    ,  25796.466    ,  26121.617    ,  26446.773    ,
     *   26771.934    ,
     *   23329.574    ,  23654.637    ,  23979.706    ,  24304.783    ,
     *   24629.867    ,  24954.960    ,  25280.060    ,  25605.169    ,
     *   25930.285    ,
     *   22733.015    ,  23058.016    ,  23383.026    ,  23708.045    ,
     *   24033.074    ,  24358.114    ,  24683.165    ,  25008.226    ,
     *   25333.298    ,
     *   22270.515    ,  22595.455    ,  22920.406    ,  23245.368    ,
     *   23570.343    ,  23895.330    ,  24220.331    ,  24545.345    ,
     *   24870.372    ,
     *   21892.811    ,  22217.691    ,  22542.582    ,  22867.488    ,
     *   23192.408    ,  23517.344    ,  23842.295    ,  24167.261    ,
     *   24492.243    ,
     *   21573.623    ,  21898.443    ,  22223.276    ,  22548.126    ,
     *   22872.992    ,  23197.875    ,  23522.777    ,  23847.696    ,
     *   24172.634    ,
     *   21297.264    ,  21622.025    ,  21946.801    ,  22271.595    ,
     *   22596.407    ,  22921.239    ,  23246.091    ,  23570.964    ,
     *   23895.857    /
        DATA ((ENTRV (J,K),J=64,72),K=10,18) /
     *   21053.616    ,  21378.319    ,  21703.039    ,  22027.777    ,
     *   22352.536    ,  22677.316    ,  23002.119    ,  23326.945    ,
     *   23651.794    ,
     *   20835.771    ,  21160.417    ,  21485.080    ,  21809.764    ,
     *   22134.469    ,  22459.199    ,  22783.953    ,  23108.732    ,
     *   23433.536    ,
     *   20638.800    ,  20963.390    ,  21287.997    ,  21612.627    ,
     *   21937.280    ,  22261.959    ,  22586.664    ,  22911.397    ,
     *   23236.157    ,
     *   20459.066    ,  20783.599    ,  21108.152    ,  21432.728    ,
     *   21757.329    ,  22081.958    ,  22406.615    ,  22731.301    ,
     *   23056.017    ,
     *   20293.803    ,  20618.282    ,  20942.781    ,  21267.304    ,
     *   21591.853    ,  21916.432    ,  22241.041    ,  22565.681    ,
     *   22890.353    ,
     *   20140.866    ,  20465.291    ,  20789.736    ,  21114.207    ,
     *   21438.705    ,  21763.234    ,  22087.796    ,  22412.390    ,
     *   22737.018    ,
     *   19998.550    ,  20322.922    ,  20647.315    ,  20971.734    ,
     *   21296.182    ,  21620.662    ,  21945.176    ,  22269.725    ,
     *   22594.309    ,
     *   19865.483    ,  20189.804    ,  20514.145    ,  20838.513    ,
     *   21162.911    ,  21487.342    ,  21811.809    ,  22136.313    ,
     *   22460.854    ,
     *   19740.542    ,  20064.812    ,  20389.103    ,  20713.420    ,
     *   21037.769    ,  21362.152    ,  21686.572    ,  22011.031    ,
     *   22335.529    /
        DATA ((ENTRV (J,K),J=64,72),K=19,27) /
     *   19622.798    ,  19947.017    ,  20271.258    ,  20595.526    ,
     *   20919.826    ,  21244.161    ,  21568.535    ,  21892.949    ,
     *   22217.405    ,
     *   19511.470    ,  19835.641    ,  20159.832    ,  20484.051    ,
     *   20808.303    ,  21132.591    ,  21456.919    ,  21781.289    ,
     *   22105.702    ,
     *   19405.899    ,  19730.022    ,  20054.166    ,  20378.337    ,
     *   20702.541    ,  21026.782    ,  21351.065    ,  21675.391    ,
     *   21999.761    ,
     *   19305.523    ,  19629.600    ,  19953.696    ,  20277.820    ,
     *   20601.977    ,  20926.172    ,  21250.410    ,  21574.692    ,
     *   21899.020    ,
     *   19209.858    ,  19533.889    ,  19857.939    ,  20182.016    ,
     *   20506.127    ,  20830.277    ,  21154.470    ,  21478.709    ,
     *   21802.995    ,
     *   19118.484    ,  19442.471    ,  19766.475    ,  20090.506    ,
     *   20414.571    ,  20738.677    ,  21062.826    ,  21387.022    ,
     *   21711.266    ,
     *   19031.035    ,  19354.978    ,  19678.938    ,  20002.924    ,
     *   20326.945    ,  20651.005    ,  20975.111    ,  21299.264    ,
     *   21623.468    ,
     *   18947.190    ,  19271.091    ,  19595.007    ,  19918.949    ,
     *   20242.925    ,  20566.942    ,  20891.005    ,  21215.116    ,
     *   21539.279    ,
     *   18866.666    ,  19190.525    ,  19514.399    ,  19838.298    ,
     *   20162.230    ,  20486.204    ,  20810.224    ,  21134.293    ,
     *   21458.416    /
        DATA ((ENTRV (J,K),J=64,72),K=28,36) /
     *   18789.211    ,  19113.030    ,  19436.862    ,  19760.718    ,
     *   20084.608    ,  20408.539    ,  20732.517    ,  21056.545    ,
     *   21380.627    ,
     *   18714.601    ,  19038.381    ,  19362.172    ,  19685.987    ,
     *   20009.835    ,  20333.724    ,  20657.660    ,  20981.647    ,
     *   21305.690    ,
     *   18642.637    ,  18966.378    ,  19290.130    ,  19613.904    ,
     *   19937.711    ,  20261.558    ,  20585.453    ,  20909.400    ,
     *   21233.403    ,
     *   18573.137    ,  18896.842    ,  19220.555    ,  19544.289    ,
     *   19868.055    ,  20191.862    ,  20515.716    ,  20839.623    ,
     *   21163.587    ,
     *   18505.941    ,  18829.610    ,  19153.285    ,  19476.980    ,
     *   19800.706    ,  20124.473    ,  20448.287    ,  20772.155    ,
     *   21096.080    ,
     *   18440.901    ,  18764.535    ,  19088.174    ,  19411.830    ,
     *   19735.517    ,  20059.245    ,  20383.020    ,  20706.848    ,
     *   21030.735    ,
     *   18377.884    ,  18701.485    ,  19025.087    ,  19348.707    ,
     *   19672.355    ,  19996.044    ,  20319.780    ,  20643.570    ,
     *   20967.419    ,
     *   18316.768    ,  18640.337    ,  18963.905    ,  19287.488    ,
     *   19611.099    ,  19934.749    ,  20258.446    ,  20582.198    ,
     *   20906.010    ,
     *   18257.444    ,  18580.981    ,  18904.515    ,  19228.062    ,
     *   19551.637    ,  19875.249    ,  20198.909    ,  20522.623    ,
     *   20846.398    /
        DATA ((ENTRV (J,K),J=64,72),K=37,45) /
     *   18199.809    ,  18523.316    ,  18846.817    ,  19170.330    ,
     *   19493.868    ,  19817.444    ,  20141.066    ,  20464.744    ,
     *   20788.481    ,
     *   18143.770    ,  18467.248    ,  18790.718    ,  19114.197    ,
     *   19437.699    ,  19761.239    ,  20084.825    ,  20408.466    ,
     *   20732.167    ,
     *   18089.243    ,  18412.693    ,  18736.131    ,  19059.577    ,
     *   19383.046    ,  19706.550    ,  20030.100    ,  20353.704    ,
     *   20677.369    ,
     *   18036.147    ,  18359.570    ,  18682.979    ,  19006.393    ,
     *   19329.827    ,  19653.297    ,  19976.811    ,  20300.380    ,
     *   20624.010    ,
     *   17984.411    ,  18307.808    ,  18631.188    ,  18954.570    ,
     *   19277.972    ,  19601.407    ,  19924.887    ,  20248.421    ,
     *   20572.015    ,
     *   17933.966    ,  18257.338    ,  18580.690    ,  18904.042    ,
     *   19227.412    ,  19550.813    ,  19874.259    ,  20197.758    ,
     *   20521.318    ,
     *   17884.750    ,  18208.099    ,  18531.424    ,  18854.746    ,
     *   19178.084    ,  19501.453    ,  19824.865    ,  20148.330    ,
     *   20471.856    ,
     *   17836.705    ,  18160.030    ,  18483.329    ,  18806.623    ,
     *   19129.931    ,  19453.268    ,  19776.646    ,  20100.078    ,
     *   20423.570    ,
     *   17789.775    ,  18113.080    ,  18436.354    ,  18759.620    ,
     *   19082.898    ,  19406.203    ,  19729.549    ,  20052.948    ,
     *   20376.407    /
        DATA ((ENTRV (J,K),J=64,72),K=46,54) /
     *   17743.912    ,  18067.196    ,  18390.446    ,  18713.685    ,
     *   19036.934    ,  19360.208    ,  19683.523    ,  20006.889    ,
     *   20330.315    ,
     *   17699.068    ,  18022.332    ,  18345.559    ,  18668.772    ,
     *   18991.992    ,  19315.237    ,  19638.520    ,  19961.854    ,
     *   20285.248    ,
     *   17655.198    ,  17978.443    ,  18301.648    ,  18624.836    ,
     *   18948.029    ,  19271.244    ,  19594.497    ,  19917.799    ,
     *   20241.161    ,
     *   17612.261    ,  17935.489    ,  18258.672    ,  18581.836    ,
     *   18905.002    ,  19228.189    ,  19551.411    ,  19874.683    ,
     *   20198.013    ,
     *   17570.218    ,  17893.430    ,  18216.593    ,  18539.733    ,
     *   18862.873    ,  19186.032    ,  19509.225    ,  19832.466    ,
     *   20155.766    ,
     *   17529.033    ,  17852.229    ,  18175.373    ,  18498.491    ,
     *   18821.606    ,  19144.737    ,  19467.901    ,  19791.112    ,
     *   20114.381    ,
     *   17488.672    ,  17811.853    ,  18134.979    ,  18458.075    ,
     *   18781.165    ,  19104.270    ,  19427.406    ,  19750.588    ,
     *   20073.827    ,
     *   17449.102    ,  17772.270    ,  18095.378    ,  18418.453    ,
     *   18741.519    ,  19064.598    ,  19387.707    ,  19710.860    ,
     *   20034.069    ,
     *   17410.292    ,  17733.448    ,  18056.539    ,  18379.594    ,
     *   18702.638    ,  19025.691    ,  19348.773    ,  19671.898    ,
     *   19995.078    /
        DATA ((ENTRV (J,K),J=64,72),K=55,63) /
     *   17372.215    ,  17695.359    ,  18018.434    ,  18341.470    ,
     *   18664.492    ,  18987.521    ,  19310.576    ,  19633.673    ,
     *   19956.824    ,
     *   17334.842    ,  17657.976    ,  17981.037    ,  18304.054    ,
     *   18627.054    ,  18950.059    ,  19273.088    ,  19596.158    ,
     *   19919.282    ,
     *   17298.149    ,  17621.273    ,  17944.320    ,  18267.319    ,
     *   18590.299    ,  18913.281    ,  19236.285    ,  19559.328    ,
     *   19882.424    ,
     *   17262.111    ,  17585.226    ,  17908.259    ,  18231.242    ,
     *   18554.202    ,  18877.161    ,  19200.141    ,  19523.158    ,
     *   19846.226    ,
     *   17226.704    ,  17549.811    ,  17872.833    ,  18195.800    ,
     *   18518.740    ,  18841.677    ,  19164.633    ,  19487.624    ,
     *   19810.666    ,
     *   17191.907    ,  17515.008    ,  17838.018    ,  18160.970    ,
     *   18483.891    ,  18806.808    ,  19129.740    ,  19452.706    ,
     *   19775.722    ,
     *   17157.700    ,  17480.794    ,  17803.794    ,  18126.731    ,
     *   18449.635    ,  18772.531    ,  19095.440    ,  19418.382    ,
     *   19741.372    ,
     *   17124.062    ,  17447.151    ,  17770.141    ,  18093.065    ,
     *   18415.952    ,  18738.828    ,  19061.715    ,  19384.633    ,
     *   19707.598    ,
     *   17090.975    ,  17414.060    ,  17737.041    ,  18059.952    ,
     *   18382.822    ,  18705.679    ,  19028.545    ,  19351.439    ,
     *   19674.379    /
        DATA ((ENTRV (J,K),J=64,72),K=64,72) /
     *   17058.421    ,  17381.502    ,  17704.475    ,  18027.374    ,
     *   18350.229    ,  18673.067    ,  18995.912    ,  19318.784    ,
     *   19641.699    ,
     *   17026.382    ,  17349.461    ,  17672.427    ,  17995.314    ,
     *   18318.154    ,  18640.975    ,  18963.799    ,  19286.649    ,
     *   19609.540    ,
     *   16994.843    ,  17317.920    ,  17640.880    ,  17963.757    ,
     *   18286.583    ,  18609.386    ,  18932.191    ,  19255.018    ,
     *   19577.886    ,
     *   16963.788    ,  17286.865    ,  17609.819    ,  17932.686    ,
     *   18255.498    ,  18578.285    ,  18901.070    ,  19223.877    ,
     *   19546.722    ,
     *   16933.203    ,  17256.279    ,  17579.228    ,  17902.086    ,
     *   18224.886    ,  18547.657    ,  18870.424    ,  19193.209    ,
     *   19516.032    ,
     *   16903.073    ,  17226.150    ,  17549.095    ,  17871.945    ,
     *   18194.732    ,  18517.488    ,  18840.237    ,  19163.002    ,
     *   19485.803    ,
     *   16873.384    ,  17196.463    ,  17519.405    ,  17842.247    ,
     *   18165.023    ,  18487.764    ,  18810.496    ,  19133.241    ,
     *   19456.020    ,
     *   16844.125    ,  17167.206    ,  17490.145    ,  17812.981    ,
     *   18135.746    ,  18458.473    ,  18781.187    ,  19103.914    ,
     *   19426.672    ,
     *   16815.282    ,  17138.366    ,  17461.304    ,  17784.133    ,
     *   18106.888    ,  18429.602    ,  18752.300    ,  19075.008    ,
     *   19397.745    /
        DATA ((ENTRV (J,K),J=64,72),K=73,81) /
     *   16786.843    ,  17109.932    ,  17432.868    ,  17755.692    ,
     *   18078.438    ,  18401.139    ,  18723.821    ,  19046.511    ,
     *   19369.228    ,
     *   16758.798    ,  17081.891    ,  17404.828    ,  17727.647    ,
     *   18050.384    ,  18373.072    ,  18695.740    ,  19018.412    ,
     *   19341.110    ,
     *   16731.136    ,  17054.234    ,  17377.171    ,  17699.986    ,
     *   18022.715    ,  18345.392    ,  18668.045    ,  18990.700    ,
     *   19313.379    ,
     *   16703.845    ,  17026.950    ,  17349.888    ,  17672.699    ,
     *   17995.421    ,  18318.087    ,  18640.726    ,  18963.364    ,
     *   19286.024    ,
     *   16676.916    ,  17000.028    ,  17322.968    ,  17645.777    ,
     *   17968.492    ,  18291.147    ,  18613.773    ,  18936.395    ,
     *   19259.037    ,
     *   16650.340    ,  16973.459    ,  17296.402    ,  17619.209    ,
     *   17941.918    ,  18264.563    ,  18587.176    ,  18909.782    ,
     *   19232.407    ,
     *   16624.106    ,  16947.234    ,  17270.180    ,  17592.986    ,
     *   17915.689    ,  18238.325    ,  18560.926    ,  18883.517    ,
     *   19206.124    ,
     *   16598.207    ,  16921.344    ,  17244.294    ,  17567.099    ,
     *   17889.797    ,  18212.425    ,  18535.014    ,  18857.591    ,
     *   19180.181    ,
     *   16572.634    ,  16895.780    ,  17218.735    ,  17541.540    ,
     *   17864.234    ,  18186.854    ,  18509.431    ,  18831.994    ,
     *   19154.568    /
        DATA ((ENTRV (J,K),J=73,81),K= 1, 9) /
     *   51207.267    ,  51532.517    ,  51857.768    ,  52183.019    ,
     *   52508.269    ,  52833.520    ,  53158.770    ,  53484.021    ,
     *   53809.272    ,
     *   28536.362    ,  28861.573    ,  29186.787    ,  29512.003    ,
     *   29837.221    ,  30162.442    ,  30487.664    ,  30812.889    ,
     *   31138.115    ,
     *   27097.101    ,  27422.272    ,  27747.449    ,  28072.630    ,
     *   28397.816    ,  28723.006    ,  29048.200    ,  29373.398    ,
     *   29698.600    ,
     *   26255.410    ,  26580.541    ,  26905.681    ,  27230.827    ,
     *   27555.980    ,  27881.140    ,  28206.306    ,  28531.478    ,
     *   28856.655    ,
     *   25658.380    ,  25983.472    ,  26308.574    ,  26633.685    ,
     *   26958.806    ,  27283.935    ,  27609.072    ,  27934.218    ,
     *   28259.370    ,
     *   25195.411    ,  25520.464    ,  25845.529    ,  26170.605    ,
     *   26495.693    ,  26820.791    ,  27145.900    ,  27471.019    ,
     *   27796.147    ,
     *   24817.241    ,  25142.254    ,  25467.281    ,  25792.322    ,
     *   26117.377    ,  26442.445    ,  26767.525    ,  27092.617    ,
     *   27417.720    ,
     *   24497.589    ,  24822.562    ,  25147.552    ,  25472.558    ,
     *   25797.580    ,  26122.617    ,  26447.669    ,  26772.734    ,
     *   27097.812    ,
     *   24220.770    ,  24545.703    ,  24870.655    ,  25195.626    ,
     *   25520.615    ,  25845.622    ,  26170.644    ,  26495.683    ,
     *   26820.736    /
        DATA ((ENTRV (J,K),J=73,81),K=10,18) /
     *   23976.665    ,  24301.558    ,  24626.473    ,  24951.409    ,
     *   25276.365    ,  25601.340    ,  25926.334    ,  26251.345    ,
     *   26576.373    ,
     *   23758.365    ,  24083.219    ,  24408.096    ,  24732.997    ,
     *   25057.920    ,  25382.864    ,  25707.829    ,  26032.813    ,
     *   26357.816    ,
     *   23560.944    ,  23885.758    ,  24210.597    ,  24535.463    ,
     *   24860.353    ,  25185.266    ,  25510.202    ,  25835.159    ,
     *   26160.137    ,
     *   23380.762    ,  23705.536    ,  24030.339    ,  24355.169    ,
     *   24680.025    ,  25004.908    ,  25329.815    ,  25654.745    ,
     *   25979.697    ,
     *   23215.057    ,  23539.791    ,  23864.556    ,  24189.351    ,
     *   24514.175    ,  24839.026    ,  25163.904    ,  25488.807    ,
     *   25813.734    ,
     *   23061.680    ,  23386.375    ,  23711.103    ,  24035.863    ,
     *   24360.653    ,  24685.473    ,  25010.322    ,  25335.198    ,
     *   25660.099    ,
     *   22918.930    ,  23243.585    ,  23568.276    ,  23893.000    ,
     *   24217.758    ,  24542.547    ,  24867.366    ,  25192.215    ,
     *   25517.091    ,
     *   22785.433    ,  23110.049    ,  23434.702    ,  23759.392    ,
     *   24084.116    ,  24408.874    ,  24733.664    ,  25058.486    ,
     *   25383.336    ,
     *   22660.067    ,  22984.644    ,  23309.260    ,  23633.914    ,
     *   23958.605    ,  24283.332    ,  24608.094    ,  24932.888    ,
     *   25257.713    /
        DATA ((ENTRV (J,K),J=73,81),K=19,27) /
     *   22541.901    ,  22866.440    ,  23191.019    ,  23515.638    ,
     *   23840.296    ,  24164.992    ,  24489.724    ,  24814.490    ,
     *   25139.290    ,
     *   22430.158    ,  22754.657    ,  23079.199    ,  23403.783    ,
     *   23728.408    ,  24053.073    ,  24377.776    ,  24702.515    ,
     *   25027.289    ,
     *   22324.177    ,  22648.637    ,  22973.142    ,  23297.692    ,
     *   23622.284    ,  23946.917    ,  24271.591    ,  24596.303    ,
     *   24921.052    ,
     *   22223.395    ,  22547.817    ,  22872.286    ,  23196.800    ,
     *   23521.360    ,  23845.962    ,  24170.607    ,  24495.291    ,
     *   24820.014    ,
     *   22127.330    ,  22451.714    ,  22776.146    ,  23100.625    ,
     *   23425.152    ,  23749.723    ,  24074.339    ,  24398.996    ,
     *   24723.693    ,
     *   22035.561    ,  22359.907    ,  22684.302    ,  23008.747    ,
     *   23333.241    ,  23657.782    ,  23982.368    ,  24306.998    ,
     *   24631.669    ,
     *   21947.723    ,  22272.031    ,  22596.390    ,  22920.800    ,
     *   23245.261    ,  23569.771    ,  23894.328    ,  24218.930    ,
     *   24543.576    ,
     *   21863.495    ,  22187.764    ,  22512.087    ,  22836.463    ,
     *   23160.891    ,  23485.370    ,  23809.898    ,  24134.473    ,
     *   24459.094    ,
     *   21782.592    ,  22106.824    ,  22431.111    ,  22755.453    ,
     *   23079.849    ,  23404.297    ,  23728.796    ,  24053.343    ,
     *   24377.938    /
        DATA ((ENTRV (J,K),J=73,81),K=28,36) /
     *   21704.765    ,  22028.959    ,  22353.211    ,  22677.518    ,
     *   23001.881    ,  23326.299    ,  23650.769    ,  23975.289    ,
     *   24299.858    ,
     *   21629.789    ,  21953.946    ,  22278.162    ,  22602.435    ,
     *   22926.766    ,  23251.153    ,  23575.594    ,  23900.087    ,
     *   24224.630    ,
     *   21557.464    ,  21881.584    ,  22205.764    ,  22530.004    ,
     *   22854.303    ,  23178.659    ,  23503.071    ,  23827.537    ,
     *   24152.054    ,
     *   21487.610    ,  21811.694    ,  22135.839    ,  22460.045    ,
     *   22784.311    ,  23108.636    ,  23433.020    ,  23757.458    ,
     *   24081.950    ,
     *   21420.065    ,  21744.112    ,  22068.222    ,  22392.395    ,
     *   22716.629    ,  23040.924    ,  23365.278    ,  23689.690    ,
     *   24014.156    ,
     *   21354.683    ,  21678.694    ,  22002.769    ,  22326.908    ,
     *   22651.110    ,  22975.375    ,  23299.700    ,  23624.085    ,
     *   23948.525    ,
     *   21291.329    ,  21615.304    ,  21939.345    ,  22263.450    ,
     *   22587.621    ,  22911.855    ,  23236.152    ,  23560.509    ,
     *   23884.925    ,
     *   21229.884    ,  21553.823    ,  21877.829    ,  22201.901    ,
     *   22526.040    ,  22850.245    ,  23174.513    ,  23498.843    ,
     *   23823.233    ,
     *   21170.235    ,  21494.139    ,  21818.111    ,  22142.151    ,
     *   22466.258    ,  22790.432    ,  23114.672    ,  23438.975    ,
     *   23763.339    /
        DATA ((ENTRV (J,K),J=73,81),K=37,45) /
     *   21112.283    ,  21436.152    ,  21760.089    ,  22084.096    ,
     *   22408.172    ,  22732.316    ,  23056.527    ,  23380.804    ,
     *   23705.143    ,
     *   21055.933    ,  21379.767    ,  21703.671    ,  22027.645    ,
     *   22351.690    ,  22675.804    ,  22999.987    ,  23324.236    ,
     *   23648.550    ,
     *   21001.100    ,  21324.900    ,  21648.770    ,  21972.712    ,
     *   22296.725    ,  22620.810    ,  22944.965    ,  23269.187    ,
     *   23593.475    ,
     *   20947.706    ,  21271.471    ,  21595.308    ,  21919.218    ,
     *   22243.200    ,  22567.255    ,  22891.382    ,  23215.577    ,
     *   23539.840    ,
     *   20895.676    ,  21219.408    ,  21543.212    ,  21867.089    ,
     *   22191.041    ,  22515.067    ,  22839.165    ,  23163.334    ,
     *   23487.572    ,
     *   20844.945    ,  21168.643    ,  21492.414    ,  21816.260    ,
     *   22140.181    ,  22464.178    ,  22788.248    ,  23112.390    ,
     *   23436.602    ,
     *   20795.449    ,  21119.113    ,  21442.852    ,  21766.666    ,
     *   22090.557    ,  22414.524    ,  22738.567    ,  23062.682    ,
     *   23386.869    ,
     *   20747.130    ,  21070.761    ,  21394.467    ,  21718.250    ,
     *   22042.111    ,  22366.049    ,  22690.064    ,  23014.153    ,
     *   23338.315    ,
     *   20699.933    ,  21023.532    ,  21347.206    ,  21670.958    ,
     *   21994.789    ,  22318.698    ,  22642.684    ,  22966.747    ,
     *   23290.884    /
        DATA ((ENTRV (J,K),J=73,81),K=46,54) /
     *   20653.809    ,  20977.375    ,  21301.018    ,  21624.739    ,
     *   21948.539    ,  22272.420    ,  22596.379    ,  22920.415    ,
     *   23244.527    ,
     *   20608.709    ,  20932.243    ,  21255.855    ,  21579.545    ,
     *   21903.316    ,  22227.167    ,  22551.099    ,  22875.109    ,
     *   23199.197    ,
     *   20564.590    ,  20888.093    ,  21211.673    ,  21535.333    ,
     *   21859.074    ,  22182.897    ,  22506.802    ,  22830.786    ,
     *   23154.848    ,
     *   20521.411    ,  20844.882    ,  21168.431    ,  21492.061    ,
     *   21815.773    ,  22139.568    ,  22463.445    ,  22787.403    ,
     *   23111.440    ,
     *   20479.132    ,  20802.572    ,  21126.091    ,  21449.691    ,
     *   21773.373    ,  22097.140    ,  22420.990    ,  22744.922    ,
     *   23068.935    ,
     *   20437.717    ,  20761.127    ,  21084.615    ,  21408.185    ,
     *   21731.839    ,  22055.577    ,  22379.400    ,  22703.307    ,
     *   23027.295    ,
     *   20397.132    ,  20720.511    ,  21043.970    ,  21367.510    ,
     *   21691.135    ,  22014.846    ,  22338.642    ,  22662.522    ,
     *   22986.486    ,
     *   20357.345    ,  20680.694    ,  21004.122    ,  21327.633    ,
     *   21651.230    ,  21974.913    ,  22298.682    ,  22622.537    ,
     *   22946.476    ,
     *   20318.324    ,  20641.643    ,  20965.042    ,  21288.525    ,
     *   21612.093    ,  21935.748    ,  22259.491    ,  22583.320    ,
     *   22907.235    /
        DATA ((ENTRV (J,K),J=73,81),K=55,63) /
     *   20280.041    ,  20603.332    ,  20926.701    ,  21250.155    ,
     *   21573.695    ,  21897.323    ,  22221.039    ,  22544.843    ,
     *   22868.733    ,
     *   20242.470    ,  20565.731    ,  20889.072    ,  21212.497    ,
     *   21536.009    ,  21859.610    ,  22183.300    ,  22507.079    ,
     *   22830.945    ,
     *   20205.584    ,  20528.816    ,  20852.129    ,  21175.525    ,
     *   21499.010    ,  21822.583    ,  22146.247    ,  22470.001    ,
     *   22793.843    ,
     *   20169.358    ,  20492.563    ,  20815.847    ,  21139.216    ,
     *   21462.672    ,  21786.219    ,  22109.857    ,  22433.586    ,
     *   22757.403    ,
     *   20133.771    ,  20456.948    ,  20780.204    ,  21103.545    ,
     *   21426.974    ,  21750.494    ,  22074.106    ,  22397.810    ,
     *   22721.604    ,
     *   20098.799    ,  20421.949    ,  20745.177    ,  21068.490    ,
     *   21391.893    ,  21715.387    ,  22038.973    ,  22362.652    ,
     *   22686.422    ,
     *   20064.423    ,  20387.545    ,  20710.746    ,  21034.032    ,
     *   21357.408    ,  21680.876    ,  22004.436    ,  22328.090    ,
     *   22651.836    ,
     *   20030.622    ,  20353.717    ,  20676.892    ,  21000.151    ,
     *   21323.500    ,  21646.941    ,  21970.476    ,  22294.106    ,
     *   22617.828    ,
     *   19997.378    ,  20320.447    ,  20643.594    ,  20966.827    ,
     *   21290.149    ,  21613.565    ,  21937.075    ,  22260.680    ,
     *   22584.379    /
        DATA ((ENTRV (J,K),J=73,81),K=64,72) /
     *   19964.672    ,  20287.715    ,  20610.836    ,  20934.042    ,
     *   21257.339    ,  21580.729    ,  21904.213    ,  22227.794    ,
     *   22551.469    ,
     *   19932.489    ,  20255.506    ,  20578.601    ,  20901.781    ,
     *   21225.051    ,  21548.415    ,  21871.875    ,  22195.431    ,
     *   22519.084    ,
     *   19900.810    ,  20223.802    ,  20546.871    ,  20870.025    ,
     *   21193.270    ,  21516.609    ,  21840.044    ,  22163.576    ,
     *   22487.205    ,
     *   19869.621    ,  20192.588    ,  20515.632    ,  20838.761    ,
     *   21161.980    ,  21485.294    ,  21808.704    ,  22132.212    ,
     *   22455.818    ,
     *   19838.908    ,  20161.850    ,  20484.869    ,  20807.972    ,
     *   21131.166    ,  21454.455    ,  21777.841    ,  22101.326    ,
     *   22424.908    ,
     *   19808.655    ,  20131.573    ,  20454.567    ,  20777.646    ,
     *   21100.815    ,  21424.079    ,  21747.440    ,  22070.901    ,
     *   22394.461    ,
     *   19778.850    ,  20101.744    ,  20424.714    ,  20747.767    ,
     *   21070.912    ,  21394.151    ,  21717.489    ,  22040.926    ,
     *   22364.463    ,
     *   19749.479    ,  20072.350    ,  20395.296    ,  20718.325    ,
     *   21041.444    ,  21364.659    ,  21687.973    ,  22011.387    ,
     *   22334.901    ,
     *   19720.531    ,  20043.378    ,  20366.300    ,  20689.305    ,
     *   21012.400    ,  21335.591    ,  21658.881    ,  21982.272    ,
     *   22305.763    /
        DATA ((ENTRV (J,K),J=73,81),K=73,81) /
     *   19691.992    ,  20014.817    ,  20337.715    ,  20660.696    ,
     *   20983.768    ,  21306.935    ,  21630.201    ,  21953.568    ,
     *   22277.037    ,
     *   19663.852    ,  19986.655    ,  20309.530    ,  20632.487    ,
     *   20955.535    ,  21278.678    ,  21601.921    ,  21925.265    ,
     *   22248.712    ,
     *   19636.100    ,  19958.881    ,  20281.733    ,  20604.667    ,
     *   20927.691    ,  21250.811    ,  21574.030    ,  21897.352    ,
     *   22220.777    ,
     *   19608.726    ,  19931.485    ,  20254.314    ,  20577.225    ,
     *   20900.226    ,  21223.322    ,  21546.519    ,  21869.818    ,
     *   22193.220    ,
     *   19581.718    ,  19904.456    ,  20227.263    ,  20550.152    ,
     *   20873.129    ,  21196.203    ,  21519.376    ,  21842.653    ,
     *   22166.033    ,
     *   19555.069    ,  19877.785    ,  20200.571    ,  20523.437    ,
     *   20846.392    ,  21169.442    ,  21492.593    ,  21815.847    ,
     *   22139.206    ,
     *   19528.767    ,  19851.463    ,  20174.227    ,  20497.071    ,
     *   20820.003    ,  21143.031    ,  21466.159    ,  21789.391    ,
     *   22112.728    ,
     *   19502.805    ,  19825.481    ,  20148.224    ,  20471.046    ,
     *   20793.956    ,  21116.961    ,  21440.067    ,  21763.277    ,
     *   22086.592    ,
     *   19477.174    ,  19799.830    ,  20122.552    ,  20445.352    ,
     *   20768.240    ,  21091.223    ,  21414.307    ,  21737.495    ,
     *   22060.789    /
        DATA ((SOSV  (J,K),J= 1, 9),K= 1, 9) /
     *   186.07478    ,  191.99416    ,  198.10183    ,  204.40378    ,
     *   210.90620    ,  217.61546    ,  224.53814    ,  231.68103    ,
     *   239.05114    ,
     *   212.78367    ,  214.70835    ,  218.27054    ,  223.01312    ,
     *   228.61749    ,  234.86154    ,  241.59221    ,  248.70634    ,
     *   256.13643    ,
     *   300.46000    ,  294.01923    ,  288.70831    ,  284.90752    ,
     *   282.81618    ,  282.43366    ,  283.61642    ,  286.15868    ,
     *   289.85142    ,
     *   365.04479    ,  358.82153    ,  352.71955    ,  346.98777    ,
     *   341.90005    ,  337.72521    ,  334.68778    ,  332.93331    ,
     *   332.51379    ,
     *   413.65276    ,  408.07435    ,  402.40129    ,  396.76907    ,
     *   391.33636    ,  386.28296    ,  381.80189    ,  378.08448    ,
     *   375.30046    ,
     *   453.74575    ,  448.58565    ,  443.27534    ,  437.90751    ,
     *   432.58718    ,  427.43338    ,  422.57942    ,  418.17027    ,
     *   414.35635    ,
     *   488.55380    ,  483.65126    ,  478.57883    ,  473.41141    ,
     *   468.23023    ,  463.12443    ,  458.19234    ,  453.54203    ,
     *   449.29036    ,
     *   519.66961    ,  514.93611    ,  510.02162    ,  504.99225    ,
     *   499.91758    ,  494.87162    ,  489.93391    ,  485.19044    ,
     *   480.73416    ,
     *   547.98941    ,  543.37937    ,  538.57927    ,  533.64993    ,
     *   528.65429    ,  523.65794    ,  518.72989    ,  513.94328    ,
     *   509.37609    /
        DATA ((SOSV  (J,K),J= 1, 9),K=10,18) /
     *   574.07470    ,  569.56599    ,  564.85873    ,  560.00989    ,
     *   555.07797    ,  550.12322    ,  545.20821    ,  540.39827    ,
     *   535.76205    ,
     *   598.30815    ,  593.89121    ,  589.26755    ,  584.49101    ,
     *   579.61664    ,  574.70089    ,  569.80191    ,  564.97989    ,
     *   560.29743    ,
     *   620.96782    ,  616.63972    ,  612.09708    ,  607.39100    ,
     *   602.57364    ,  597.69839    ,  592.82009    ,  587.99522    ,
     *   583.28219    ,
     *   642.26559    ,  638.02688    ,  633.56617    ,  628.93207    ,
     *   624.17423    ,  619.34344    ,  614.49183    ,  609.67298    ,
     *   604.94214    ,
     *   662.36875    ,  658.22172    ,  653.84555    ,  649.28662    ,
     *   644.59231    ,  639.81113    ,  634.99287    ,  630.18872    ,
     *   625.45137    ,
     *   681.41282    ,  677.36063    ,  673.07242    ,  668.59255    ,
     *   663.96636    ,  659.24032    ,  654.46217    ,  649.68102    ,
     *   644.94743    ,
     *   699.50987    ,  695.55602    ,  691.35947    ,  686.96274    ,
     *   682.40934    ,  677.74392    ,  673.01239    ,  668.26201    ,
     *   663.54148    ,
     *   716.75392    ,  712.90205    ,  708.80091    ,  704.49134    ,
     *   700.01523    ,  695.41561    ,  690.73674    ,  686.02426    ,
     *   681.32520    ,
     *   733.22490    ,  729.47865    ,  725.47657    ,  721.25802    ,
     *   716.86344    ,  712.33439    ,  707.71371    ,  703.04556    ,
     *   698.37550    /
        DATA ((SOSV  (J,K),J= 1, 9),K=19,27) /
     *   748.99140    ,  745.35433    ,  741.45486    ,  737.33098    ,
     *   733.02184    ,  728.56774    ,  724.01023    ,  719.39218    ,
     *   714.75783    ,
     *   764.11278    ,  760.58840    ,  756.79493    ,  752.76915    ,
     *   748.54908    ,  744.17391    ,  739.68405    ,  735.12124    ,
     *   730.52856    ,
     *   778.64082    ,  775.23252    ,  771.54833    ,  767.62391    ,
     *   763.49627    ,  759.20363    ,  754.78545    ,  750.28247    ,
     *   745.73672    ,
     *   792.62094    ,  789.33205    ,  785.76030    ,  781.94032    ,
     *   777.90823    ,  773.70143    ,  769.35856    ,  764.91947    ,
     *   760.42534    ,
     *   806.09325    ,  802.92699    ,  799.47073    ,  795.75815    ,
     *   791.82455    ,  787.70663    ,  783.44234    ,  779.07081    ,
     *   774.63245    ,
     *   819.09333    ,  816.05284    ,  812.71505    ,  809.11269    ,
     *   805.28036    ,  801.25415    ,  797.07142    ,  792.77074    ,
     *   788.39185    ,
     *   831.65290    ,  828.74123    ,  825.52482    ,  822.03542    ,
     *   818.30699    ,  814.37512    ,  810.27672    ,  806.04985    ,
     *   801.73375    ,
     *   843.80041    ,  841.02050    ,  837.92828    ,  834.55451    ,
     *   830.93253    ,  827.09750    ,  823.08596    ,  818.93562    ,
     *   814.68528    ,
     *   855.56143    ,  852.91611    ,  849.95084    ,  846.69529    ,
     *   843.18221    ,  839.44640    ,  835.52411    ,  831.45279    ,
     *   827.27093    /
        DATA ((SOSV  (J,K),J= 1, 9),K=28,36) /
     *   866.95910    ,  864.45107    ,  861.61541    ,  858.48063    ,
     *   855.07884    ,  851.44452    ,  847.61373    ,  843.62374    ,
     *   839.51283    ,
     *   878.01439    ,  875.64621    ,  872.94276    ,  869.93122    ,
     *   866.64305    ,  863.11243    ,  859.37528    ,  855.46879    ,
     *   851.43110    ,
     *   888.74644    ,  886.52049    ,  883.95174    ,  881.06588    ,
     *   877.89361    ,  874.46883    ,  870.82739    ,  867.00643    ,
     *   863.04407    ,
     *   899.17276    ,  897.09121    ,  894.65957    ,  891.90174    ,
     *   888.84762    ,  885.53078    ,  881.98701    ,  878.25353    ,
     *   874.36848    ,
     *   909.30942    ,  907.37423    ,  905.08197    ,  902.45449    ,
     *   899.52070    ,  896.31385    ,  892.86969    ,  889.22554    ,
     *   885.41966    ,
     *   919.17127    ,  917.38413    ,  915.23338    ,  912.73847    ,
     *   909.92719    ,  906.83234    ,  903.48968    ,  899.93665    ,
     *   896.21171    ,
     *   928.77203    ,  927.13435    ,  925.12709    ,  922.76691    ,
     *   920.08024    ,  917.09938    ,  913.86005    ,  910.39989    ,
     *   906.75758    ,
     *   938.12447    ,  936.63736    ,  934.77539    ,  932.55199    ,
     *   929.99198    ,  927.12706    ,  923.99289    ,  920.62729    ,
     *   917.06923    ,
     *   947.24051    ,  945.90472    ,  944.18963    ,  942.10495    ,
     *   939.67361    ,  936.92656    ,  933.89933    ,  930.62996    ,
     *   927.15772    /
        DATA ((SOSV  (J,K),J= 1, 9),K=37,45) /
     *   956.13132    ,  954.94722    ,  953.38037    ,  951.43624    ,
     *   949.13552    ,  946.50821    ,  943.58969    ,  940.41817    ,
     *   937.03329    ,
     *   964.80738    ,  963.77494    ,  962.35746    ,  960.55555    ,
     *   958.38731    ,  955.88161    ,  953.07352    ,  950.00146    ,
     *   946.70543    ,
     *   973.27858    ,  972.39735    ,  971.13008    ,  969.47192    ,
     *   967.43795    ,  965.05565    ,  962.35971    ,  959.38869    ,
     *   956.18299    ,
     *   981.55430    ,  980.82336    ,  979.70685    ,  978.19379    ,
     *   976.29577    ,  974.03863    ,  971.45654    ,  968.58812    ,
     *   965.47419    ,
     *   989.64341    ,  989.06139    ,  988.09587    ,  986.72907    ,
     *   984.96859    ,  982.83831    ,  980.37171    ,  977.60745    ,
     *   974.58670    ,
     *   997.55436    ,  997.11940    ,  996.30477    ,  995.08517    ,
     *   993.46369    ,  991.46192    ,  989.11244    ,  986.45385    ,
     *   983.52769    ,
     *   1005.2952    ,  1005.0050    ,  1004.3408    ,  1003.2691    ,
     *   1001.7879    ,  999.91624    ,  997.68547    ,  995.13406    ,
     *   992.30388    ,
     *   1012.8737    ,  1012.7253    ,  1012.2107    ,  1011.2874    ,
     *   1009.9478    ,  1008.2076    ,  1006.0971    ,  1003.6544    ,
     *   1000.9215    ,
     *   1020.2972    ,  1020.2873    ,  1019.9211    ,  1019.1464    ,
     *   1017.9493    ,  1016.3421    ,  1014.3534    ,  1012.0207    ,
     *   1009.3866    /
        DATA ((SOSV  (J,K),J= 1, 9),K=46,54) /
     *   1027.5728    ,  1027.6975    ,  1027.4781    ,  1026.8519    ,
     *   1025.7982    ,  1024.3253    ,  1022.4598    ,  1020.2387    ,
     *   1017.7046    ,
     *   1034.7071    ,  1034.9623    ,  1034.8876    ,  1034.4096    ,
     *   1033.5000    ,  1032.1626    ,  1030.4216    ,  1028.3135    ,
     *   1025.8807    ,
     *   1041.7069    ,  1042.0877    ,  1042.1553    ,  1041.8249    ,
     *   1041.0598    ,  1039.8589    ,  1038.2438    ,  1036.2500    ,
     *   1033.9199    ,
     *   1048.5781    ,  1049.0796    ,  1049.2866    ,  1049.1028    ,
     *   1048.4825    ,  1047.4190    ,  1045.9312    ,  1044.0530    ,
     *   1041.8269    ,
     *   1055.3270    ,  1055.9435    ,  1056.2868    ,  1056.2482    ,
     *   1055.7728    ,  1054.8476    ,  1053.4881    ,  1051.7269    ,
     *   1049.6059    ,
     *   1061.9590    ,  1062.6849    ,  1063.1608    ,  1063.2659    ,
     *   1062.9351    ,  1062.1489    ,  1060.9188    ,  1059.2757    ,
     *   1057.2613    ,
     *   1068.4798    ,  1069.3090    ,  1069.9136    ,  1070.1603    ,
     *   1069.9738    ,  1069.3270    ,  1068.2273    ,  1066.7036    ,
     *   1064.7968    ,
     *   1074.8944    ,  1075.8207    ,  1076.5496    ,  1076.9358    ,
     *   1076.8928    ,  1076.3858    ,  1075.4175    ,  1074.0143    ,
     *   1072.2163    ,
     *   1081.2079    ,  1082.2250    ,  1083.0736    ,  1083.5966    ,
     *   1083.6962    ,  1083.3291    ,  1082.4929    ,  1081.2112    ,
     *   1079.5232    /
        DATA ((SOSV  (J,K),J= 1, 9),K=55,63) /
     *   1087.4249    ,  1088.5265    ,  1089.4898    ,  1090.1467    ,
     *   1090.3876    ,  1090.1605    ,  1089.4571    ,  1088.2980    ,
     *   1086.7210    ,
     *   1093.5497    ,  1094.7295    ,  1095.8024    ,  1096.5900    ,
     *   1096.9708    ,  1096.8834    ,  1096.3133    ,  1095.2777    ,
     *   1093.8129    ,
     *   1099.5865    ,  1100.8385    ,  1102.0156    ,  1102.9302    ,
     *   1103.4492    ,  1103.5012    ,  1103.0648    ,  1102.1536    ,
     *   1100.8019    ,
     *   1105.5392    ,  1106.8575    ,  1108.1332    ,  1109.1711    ,
     *   1109.8263    ,  1110.0169    ,  1109.7146    ,  1108.9285    ,
     *   1107.6910    ,
     *   1111.4112    ,  1112.7903    ,  1114.1591    ,  1115.3162    ,
     *   1116.1053    ,  1116.4338    ,  1116.2657    ,  1115.6053    ,
     *   1114.4829    ,
     *   1117.2058    ,  1118.6408    ,  1120.0969    ,  1121.3689    ,
     *   1122.2894    ,  1122.7547    ,  1122.7208    ,  1122.1868    ,
     *   1121.1803    ,
     *   1122.9260    ,  1124.4124    ,  1125.9502    ,  1127.3326    ,
     *   1128.3816    ,  1128.9826    ,  1129.0827    ,  1128.6756    ,
     *   1127.7858    ,
     *   1128.5742    ,  1130.1084    ,  1131.7225    ,  1133.2105    ,
     *   1134.3850    ,  1135.1202    ,  1135.3539    ,  1135.0741    ,
     *   1134.3019    ,
     *   1134.1529    ,  1135.7320    ,  1137.4169    ,  1139.0057    ,
     *   1140.3025    ,  1141.1702    ,  1141.5371    ,  1141.3848    ,
     *   1140.7308    /
        DATA ((SOSV  (J,K),J= 1, 9),K=64,72) /
     *   1139.6638    ,  1141.2861    ,  1143.0366    ,  1144.7213    ,
     *   1146.1369    ,  1147.1352    ,  1147.6347    ,  1147.6101    ,
     *   1147.0748    ,
     *   1145.1087    ,  1146.7733    ,  1148.5847    ,  1150.3602    ,
     *   1151.8909    ,  1153.0177    ,  1153.6490    ,  1153.7521    ,
     *   1153.3362    ,
     *   1150.4885    ,  1152.1961    ,  1154.0639    ,  1155.9253    ,
     *   1157.5673    ,  1158.8202    ,  1159.5823    ,  1159.8131    ,
     *   1159.5170    ,
     *   1155.8041    ,  1157.5567    ,  1159.4772    ,  1161.4193    ,
     *   1163.1686    ,  1164.5452    ,  1165.4369    ,  1165.7952    ,
     *   1165.6192    ,
     *   1161.0559    ,  1162.8572    ,  1164.8269    ,  1166.8450    ,
     *   1168.6973    ,  1170.1949    ,  1171.2149    ,  1171.7003    ,
     *   1171.6449    ,
     *   1166.2436    ,  1168.0993    ,  1170.1156    ,  1172.2048    ,
     *   1174.1559    ,  1175.7716    ,  1176.9185    ,  1177.5306    ,
     *   1177.5957    ,
     *   1171.3665    ,  1173.2845    ,  1175.3456    ,  1177.5013    ,
     *   1179.5468    ,  1181.2776    ,  1182.5496    ,  1183.2878    ,
     *   1183.4737    ,
     *   1176.4234    ,  1178.4139    ,  1180.5189    ,  1182.7369    ,
     *   1184.8724    ,  1186.7150    ,  1188.1102    ,  1188.9738    ,
     *   1189.2806    ,
     *   1181.4121    ,  1183.4886    ,  1185.6376    ,  1187.9137    ,
     *   1190.1348    ,  1192.0859    ,  1193.6024    ,  1194.5905    ,
     *   1195.0180    /
        DATA ((SOSV  (J,K),J= 1, 9),K=73,81) /
     *   1186.3298    ,  1188.5091    ,  1190.7033    ,  1193.0340    ,
     *   1195.3363    ,  1197.3923    ,  1199.0280    ,  1200.1396    ,
     *   1200.6876    ,
     *   1191.1725    ,  1193.4758    ,  1195.7179    ,  1198.0998    ,
     *   1200.4789    ,  1202.6363    ,  1204.3888    ,  1205.6228    ,
     *   1206.2911    ,
     *   1195.9348    ,  1198.3886    ,  1200.6826    ,  1203.1132    ,
     *   1205.5648    ,  1207.8198    ,  1209.6867    ,  1211.0418    ,
     *   1211.8300    ,
     *   1200.6095    ,  1203.2471    ,  1205.5988    ,  1208.0759    ,
     *   1210.5959    ,  1212.9448    ,  1214.9233    ,  1216.3982    ,
     *   1217.3058    ,
     *   1205.1869    ,  1208.0504    ,  1210.4675    ,  1212.9898    ,
     *   1215.5741    ,  1218.0130    ,  1220.1006    ,  1221.6935    ,
     *   1222.7200    ,
     *   1209.6534    ,  1212.7971    ,  1215.2895    ,  1217.8563    ,
     *   1220.5013    ,  1223.0263    ,  1225.2200    ,  1226.9295    ,
     *   1228.0740    ,
     *   1213.9897    ,  1217.4853    ,  1220.0656    ,  1222.6771    ,
     *   1225.3792    ,  1227.9865    ,  1230.2833    ,  1232.1075    ,
     *   1233.3693    ,
     *   1218.1667    ,  1222.1120    ,  1224.7962    ,  1227.4535    ,
     *   1230.2096    ,  1232.8952    ,  1235.2921    ,  1237.2290    ,
     *   1238.6072    ,
     *   1222.1371    ,  1226.6739    ,  1229.4813    ,  1232.1867    ,
     *   1234.9939    ,  1237.7542    ,  1240.2480    ,  1242.2956    ,
     *   1243.7891    /
        DATA ((SOSV  (J,K),J=10,18),K= 1, 9) /
     *   246.65570    ,  254.50217    ,  262.59823    ,  270.95184    ,
     *   279.57119    ,  288.46472    ,  297.64117    ,  307.10953    ,
     *   316.87909    ,
     *   263.84001    ,  271.79192    ,  279.97891    ,  288.39595    ,
     *   297.04365    ,  305.92654    ,  315.05194    ,  324.42911    ,
     *   334.06873    ,
     *   294.50992    ,  299.98100    ,  306.14139    ,  312.89389    ,
     *   320.16324    ,  327.89238    ,  336.03920    ,  344.57372    ,
     *   353.47570    ,
     *   333.39793    ,  335.49780    ,  338.69795    ,  342.87767    ,
     *   347.92399    ,  353.73749    ,  360.23390    ,  367.34367    ,
     *   375.01070    ,
     *   373.57821    ,  372.99169    ,  373.55871    ,  375.24968    ,
     *   378.00248    ,  381.73791    ,  386.37189    ,  391.82357    ,
     *   398.01969    ,
     *   411.28333    ,  409.07954    ,  407.84383    ,  407.63741    ,
     *   408.48205    ,  410.36452    ,  413.24532    ,  417.06875    ,
     *   421.77178    ,
     *   445.55982    ,  442.47276    ,  440.14347    ,  438.66932    ,
     *   438.12307    ,  438.54825    ,  439.95887    ,  442.34304    ,
     *   445.66927    ,
     *   476.66452    ,  473.08552    ,  470.10205    ,  467.81454    ,
     *   466.31254    ,  465.66847    ,  465.93293    ,  467.13276    ,
     *   469.27207    ,
     *   505.11145    ,  501.23728    ,  497.84494    ,  495.02658    ,
     *   492.87127    ,  491.46010    ,  490.86131    ,  491.12610    ,
     *   492.28636    /
        DATA ((SOSV  (J,K),J=10,18),K=10,18) /
     *   531.37196    ,  527.30433    ,  523.63900    ,  520.45830    ,
     *   517.84489    ,  515.87874    ,  514.63335    ,  514.17176    ,
     *   514.54308    ,
     *   555.81989    ,  551.61560    ,  547.75590    ,  544.31473    ,
     *   541.36758    ,  538.98980    ,  537.25406    ,  536.22725    ,
     *   535.96720    ,
     *   578.74150    ,  574.43599    ,  570.43089    ,  566.79372    ,
     *   563.59379    ,  560.90129    ,  558.78569    ,  557.31359    ,
     *   556.54614    ,
     *   600.35631    ,  595.97438    ,  591.85720    ,  588.06752    ,
     *   584.66978    ,  581.72957    ,  579.31268    ,  577.48369    ,
     *   576.30403    ,
     *   620.83513    ,  616.39591    ,  612.19131    ,  608.28054    ,
     *   604.72429    ,  601.58441    ,  598.92331    ,  596.80302    ,
     *   595.28387    ,
     *   640.31345    ,  635.83268    ,  631.56019    ,  627.55247    ,
     *   623.86735    ,  620.56369    ,  617.70107    ,  615.33908    ,
     *   613.53640    ,
     *   658.90096    ,  654.39208    ,  650.06787    ,  645.98269    ,
     *   642.19208    ,  638.75261    ,  635.72149    ,  633.15618    ,
     *   631.11369    ,
     *   676.68806    ,  672.16277    ,  667.80065    ,  663.65428    ,
     *   659.77738    ,  656.22463    ,  653.05137    ,  650.31327    ,
     *   648.06575    ,
     *   693.75055    ,  689.21913    ,  684.83106    ,  680.63742    ,
     *   676.69039    ,  673.04310    ,  669.74935    ,  666.86330    ,
     *   664.43905    /
        DATA ((SOSV  (J,K),J=10,18),K=19,27) /
     *   710.15286    ,  705.62437    ,  701.22083    ,  696.99198    ,
     *   692.98869    ,  689.26277    ,  685.86672    ,  682.85345    ,
     *   680.27590    ,
     *   725.95048    ,  721.43291    ,  717.02309    ,  712.76959    ,
     *   708.72210    ,  704.93126    ,  701.44848    ,  698.32560    ,
     *   695.61456    ,
     *   741.19164    ,  736.69203    ,  732.28406    ,  728.01519    ,
     *   723.93406    ,  720.09029    ,  716.53428    ,  713.31695    ,
     *   710.48941    ,
     *   755.91865    ,  751.44323    ,  747.04426    ,  742.76822    ,
     *   738.66276    ,  734.77658    ,  731.15919    ,  727.86067    ,
     *   724.93136    ,
     *   770.16892    ,  765.72319    ,  761.33956    ,  757.06359    ,
     *   752.94205    ,  749.02276    ,  745.35443    ,  741.98636    ,
     *   738.96823    ,
     *   783.97571    ,  779.56454    ,  775.20185    ,  770.93237    ,
     *   766.80205    ,  762.85793    ,  759.14792    ,  755.72065    ,
     *   752.62515    ,
     *   797.36877    ,  792.99649    ,  788.65970    ,  784.40242    ,
     *   780.26982    ,  776.30820    ,  772.56478    ,  769.08751    ,
     *   765.92484    ,
     *   810.37483    ,  806.04529    ,  801.73883    ,  797.49880    ,
     *   793.36971    ,  789.39716    ,  785.62770    ,  782.10866    ,
     *   778.88794    ,
     *   823.01803    ,  818.73466    ,  814.46246    ,  810.24421    ,
     *   806.12379    ,  802.14617    ,  798.35728    ,  794.80387    ,
     *   791.53329    /
        DATA ((SOSV  (J,K),J=10,18),K=28,36) /
     *   835.32021    ,  831.08609    ,  826.85168    ,  822.65924    ,
     *   818.55211    ,  814.57468    ,  810.77229    ,  807.19114    ,
     *   803.87808    ,
     *   847.30125    ,  843.11916    ,  838.92569    ,  834.76268    ,
     *   830.67298    ,  826.70044    ,  822.88988    ,  819.28699    ,
     *   815.93811    ,
     *   858.97925    ,  854.85171    ,  850.70203    ,  846.57169    ,
     *   842.50313    ,  838.53973    ,  834.72582    ,  831.10658    ,
     *   827.72790    ,
     *   870.37078    ,  866.30008    ,  862.19676    ,  858.10203    ,
     *   854.05795    ,  850.10750    ,  846.29457    ,  842.66388    ,
     *   839.26088    ,
     *   881.49103    ,  877.47927    ,  873.42466    ,  869.36817    ,
     *   865.35159    ,  861.41755    ,  857.60952    ,  853.97180    ,
     *   850.54945    ,
     *   892.35396    ,  888.40308    ,  884.39930    ,  880.38346    ,
     *   876.39712    ,  872.48260    ,  868.68302    ,  865.04231    ,
     *   861.60510    ,
     *   902.97242    ,  899.08422    ,  895.13324    ,  891.16024    ,
     *   887.20662    ,  883.31445    ,  879.52655    ,  875.88648    ,
     *   872.43854    ,
     *   913.35828    ,  909.53444    ,  905.63807    ,  901.70992    ,
     *   897.79129    ,  893.92404    ,  890.15074    ,  886.51465    ,
     *   883.05973    ,
     *   923.52253    ,  919.76463    ,  915.92455    ,  912.04310    ,
     *   908.16151    ,  904.32153    ,  900.56551    ,  896.93643    ,
     *   893.47795    /
        DATA ((SOSV  (J,K),J=10,18),K=37,45) /
     *   933.47534    ,  929.78488    ,  926.00265    ,  922.16960    ,
     *   918.32696    ,  914.51640    ,  910.78009    ,  907.16079    ,
     *   903.70189    ,
     *   943.22615    ,  939.60455    ,  935.88166    ,  932.09859    ,
     *   928.29666    ,  924.51748    ,  920.80312    ,  917.19614    ,
     *   913.73969    ,
     *   952.78377    ,  949.23239    ,  945.57023    ,  941.83862    ,
     *   938.07900    ,  934.33302    ,  930.64265    ,  927.05032    ,
     *   923.59895    ,
     *   962.15638    ,  958.67654    ,  955.07641    ,  951.39765    ,
     *   947.68186    ,  943.97075    ,  940.30626    ,  936.73071    ,
     *   933.28685    ,
     *   971.35163    ,  967.94458    ,  964.40776    ,  960.78315    ,
     *   957.11259    ,  953.43789    ,  949.80102    ,  946.24422    ,
     *   942.81011    ,
     *   980.37666    ,  977.04364    ,  973.57133    ,  970.00211    ,
     *   966.37809    ,  962.74125    ,  959.13360    ,  955.59737    ,
     *   952.17506    ,
     *   989.23816    ,  985.98036    ,  982.57373    ,  979.06107    ,
     *   975.48483    ,  971.88718    ,  968.31026    ,  964.79627    ,
     *   961.38766    ,
     *   997.94239    ,  994.76100    ,  991.42117    ,  987.96620    ,
     *   984.43889    ,  980.88171    ,  977.33689    ,  973.84671    ,
     *   970.45356    ,
     *   1006.4953    ,  1003.3914    ,  1000.1195    ,  996.72326    ,
     *   993.24601    ,  989.73046    ,  986.21905    ,  982.75412    ,
     *   979.37807    /
        DATA ((SOSV  (J,K),J=10,18),K=46,54) /
     *   1014.9023    ,  1011.8771    ,  1008.6741    ,  1005.3377    ,
     *   1001.9116    ,  998.43878    ,  994.96199    ,  991.52366    ,
     *   988.16621    ,
     *   1023.1687    ,  1020.2233    ,  1017.0903    ,  1013.8147    ,
     *   1010.4407    ,  1007.0117    ,  1003.5706    ,  1000.1602    ,
     *   996.82275    ,
     *   1031.2993    ,  1028.4348    ,  1025.3729    ,  1022.1591    ,
     *   1018.8381    ,  1015.4539    ,  1012.0497    ,  1008.6683    ,
     *   1005.3522    ,
     *   1039.2989    ,  1036.5164    ,  1033.5264    ,  1030.3754    ,
     *   1027.1084    ,  1023.7700    ,  1020.4036    ,  1017.0523    ,
     *   1013.7588    ,
     *   1047.1718    ,  1044.4723    ,  1041.5553    ,  1038.4679    ,
     *   1035.2559    ,  1031.9641    ,  1028.6366    ,  1025.3165    ,
     *   1022.0467    ,
     *   1054.9221    ,  1052.3067    ,  1049.4637    ,  1046.4408    ,
     *   1043.2846    ,  1040.0404    ,  1036.7525    ,  1033.4646    ,
     *   1030.2196    ,
     *   1062.5537    ,  1060.0235    ,  1057.2554    ,  1054.2980    ,
     *   1051.1984    ,  1048.0026    ,  1044.7553    ,  1041.5005    ,
     *   1038.2813    ,
     *   1070.0704    ,  1067.6264    ,  1064.9342    ,  1062.0431    ,
     *   1059.0010    ,  1055.8543    ,  1052.6485    ,  1049.4276    ,
     *   1046.2352    ,
     *   1077.4757    ,  1075.1189    ,  1072.5035    ,  1069.6796    ,
     *   1066.6957    ,  1063.5991    ,  1060.4354    ,  1057.2494    ,
     *   1054.0847    /
        DATA ((SOSV  (J,K),J=10,18),K=55,63) /
     *   1084.7730    ,  1082.5044    ,  1079.9667    ,  1077.2108    ,
     *   1074.2860    ,  1071.2401    ,  1068.1194    ,  1064.9690    ,
     *   1061.8329    ,
     *   1091.9653    ,  1089.7860    ,  1087.3270    ,  1084.6400    ,
     *   1081.7750    ,  1078.7806    ,  1075.7036    ,  1072.5896    ,
     *   1069.4828    ,
     *   1099.0559    ,  1096.9668    ,  1094.5874    ,  1091.9700    ,
     *   1089.1656    ,  1086.2234    ,  1083.1909    ,  1080.1139    ,
     *   1077.0373    ,
     *   1106.0475    ,  1104.0496    ,  1101.7507    ,  1099.2038    ,
     *   1096.4608    ,  1093.5715    ,  1090.5840    ,  1087.5449    ,
     *   1084.4992    ,
     *   1112.9430    ,  1111.0372    ,  1108.8196    ,  1106.3441    ,
     *   1103.6631    ,  1100.8275    ,  1097.8858    ,  1094.8851    ,
     *   1091.8710    ,
     *   1119.7449    ,  1117.9323    ,  1115.7969    ,  1113.3934    ,
     *   1110.7753    ,  1107.9939    ,  1105.0987    ,  1102.1372    ,
     *   1099.1553    ,
     *   1126.4559    ,  1124.7372    ,  1122.6849    ,  1120.3544    ,
     *   1117.7998    ,  1115.0734    ,  1112.2252    ,  1109.3035    ,
     *   1106.3545    ,
     *   1133.0783    ,  1131.4545    ,  1129.4862    ,  1127.2293    ,
     *   1124.7390    ,  1122.0681    ,  1119.2677    ,  1116.3863    ,
     *   1113.4709    ,
     *   1139.6144    ,  1138.0864    ,  1136.2029    ,  1134.0204    ,
     *   1131.5950    ,  1128.9805    ,  1126.2283    ,  1123.3879    ,
     *   1120.5067    /
        DATA ((SOSV  (J,K),J=10,18),K=64,72) /
     *   1146.0664    ,  1144.6352    ,  1142.8372    ,  1140.7300    ,
     *   1138.3702    ,  1135.8126    ,  1133.1093    ,  1130.3104    ,
     *   1127.4639    ,
     *   1152.4366    ,  1151.1028    ,  1149.3912    ,  1147.3600    ,
     *   1145.0666    ,  1142.5664    ,  1139.9127    ,  1137.1559    ,
     *   1134.3447    ,
     *   1158.7268    ,  1157.4914    ,  1155.8671    ,  1153.9126    ,
     *   1151.6861    ,  1149.2441    ,  1146.6404    ,  1143.9263    ,
     *   1141.1509    ,
     *   1164.9392    ,  1163.8029    ,  1162.2665    ,  1160.3895    ,
     *   1158.2308    ,  1155.8475    ,  1153.2944    ,  1150.6235    ,
     *   1147.8844    ,
     *   1171.0756    ,  1170.0391    ,  1168.5915    ,  1166.7927    ,
     *   1164.7023    ,  1162.3784    ,  1159.8764    ,  1157.2493    ,
     *   1154.5471    ,
     *   1177.1378    ,  1176.2019    ,  1174.8438    ,  1173.1239    ,
     *   1171.1025    ,  1168.8386    ,  1166.3883    ,  1163.8054    ,
     *   1161.1406    ,
     *   1183.1276    ,  1182.2929    ,  1181.0252    ,  1179.3848    ,
     *   1177.4331    ,  1175.2297    ,  1172.8317    ,  1170.2935    ,
     *   1167.6666    ,
     *   1189.0468    ,  1188.3140    ,  1187.1371    ,  1185.5771    ,
     *   1183.6957    ,  1181.5534    ,  1179.2082    ,  1176.7152    ,
     *   1174.1266    ,
     *   1194.8969    ,  1194.2665    ,  1193.1813    ,  1191.7023    ,
     *   1189.8918    ,  1187.8112    ,  1185.5194    ,  1183.0721    ,
     *   1180.5223    /
        DATA ((SOSV  (J,K),J=10,18),K=73,81) /
     *   1200.6795    ,  1200.1522    ,  1199.1593    ,  1197.7619    ,
     *   1196.0230    ,  1194.0047    ,  1191.7667    ,  1189.3656    ,
     *   1186.8551    ,
     *   1206.3962    ,  1205.9725    ,  1205.0726    ,  1203.7574    ,
     *   1202.0907    ,  1200.1353    ,  1197.9517    ,  1195.5972    ,
     *   1193.1264    ,
     *   1212.0485    ,  1211.7288    ,  1210.9225    ,  1209.6903    ,
     *   1208.0963    ,  1206.2043    ,  1204.0756    ,  1201.7683    ,
     *   1199.3376    ,
     *   1217.6378    ,  1217.4227    ,  1216.7104    ,  1215.5618    ,
     *   1214.0412    ,  1212.2132    ,  1210.1398    ,  1207.8801    ,
     *   1205.4900    ,
     *   1223.1655    ,  1223.0553    ,  1222.4378    ,  1221.3733    ,
     *   1219.9267    ,  1218.1632    ,  1216.1457    ,  1213.9341    ,
     *   1211.5849    ,
     *   1228.6331    ,  1228.6281    ,  1228.1058    ,  1227.1260    ,
     *   1225.7540    ,  1224.0556    ,  1222.0944    ,  1219.9313    ,
     *   1217.6235    ,
     *   1234.0418    ,  1234.1423    ,  1233.7157    ,  1232.8212    ,
     *   1231.5244    ,  1229.8915    ,  1227.9872    ,  1225.8730    ,
     *   1223.6070    ,
     *   1239.3929    ,  1239.5991    ,  1239.2687    ,  1238.4601    ,
     *   1237.2389    ,  1235.6722    ,  1233.8252    ,  1231.7604    ,
     *   1229.5366    ,
     *   1244.6876    ,  1244.9998    ,  1244.7660    ,  1244.0438    ,
     *   1242.8988    ,  1241.3987    ,  1239.6096    ,  1237.5946    ,
     *   1235.4134    /
        DATA ((SOSV  (J,K),J=19,27),K= 1, 9) /
     *   326.95944    ,  337.36045    ,  348.09232    ,  359.16560    ,
     *   370.59112    ,  382.38011    ,  394.54413    ,  407.09509    ,
     *   420.04532    ,
     *   343.98254    ,  354.18300    ,  364.68322    ,  375.49673    ,
     *   386.63746    ,  398.11964    ,  409.95780    ,  422.16670    ,
     *   434.76136    ,
     *   362.73259    ,  372.33801    ,  382.29037    ,  392.59191    ,
     *   403.24787    ,  414.26587    ,  425.65546    ,  437.42770    ,
     *   449.59490    ,
     *   383.19079    ,  391.85011    ,  400.96371    ,  410.51419    ,
     *   420.49043    ,  430.88663    ,  441.70131    ,  452.93665    ,
     *   464.59780    ,
     *   404.89646    ,  412.40005    ,  420.48619    ,  429.11948    ,
     *   438.27250    ,  447.92495    ,  458.06271    ,  468.67703    ,
     *   479.76380    ,
     *   427.29080    ,  433.56590    ,  440.54332    ,  448.17646    ,
     *   456.42622    ,  465.26074    ,  474.65495    ,  484.59003    ,
     *   495.05271    ,
     *   449.89353    ,  454.96570    ,  460.83460    ,  467.45147    ,
     *   474.77207    ,  482.75774    ,  491.37587    ,  500.59989    ,
     *   510.40896    ,
     *   472.33583    ,  476.29495    ,  481.11160    ,  486.74393    ,
     *   493.14979    ,  500.28932    ,  508.12650    ,  516.63011    ,
     *   525.77403    ,
     *   494.35456    ,  497.32581    ,  501.18142    ,  505.89311    ,
     *   511.42715    ,  517.74781    ,  524.82011    ,  532.61154    ,
     *   541.09332    /
        DATA ((SOSV  (J,K),J=19,27),K=10,18) /
     *   515.78026    ,  517.89966    ,  520.90219    ,  524.77595    ,
     *   529.49960    ,  535.04582    ,  541.38448    ,  548.48517    ,
     *   556.31908    ,
     *   536.51984    ,  537.91722    ,  540.17696    ,  543.30303    ,
     *   547.28781    ,  552.11476    ,  557.76147    ,  564.20236    ,
     *   571.41111    ,
     *   556.53628    ,  557.32636    ,  558.94653    ,  561.41420    ,
     *   564.73470    ,  568.90294    ,  573.90568    ,  579.72416    ,
     *   586.33650    ,
     *   575.82976    ,  576.10926    ,  577.18126    ,  579.07350    ,
     *   581.80236    ,  585.37344    ,  589.78308    ,  595.02026    ,
     *   601.06894    ,
     *   594.42274    ,  594.27112    ,  594.87313    ,  596.26391    ,
     *   598.46858    ,  601.50202    ,  605.36951    ,  610.06803    ,
     *   615.58808    ,
     *   612.34956    ,  611.83128    ,  612.02885    ,  612.98240    ,
     *   614.72358    ,  617.27484    ,  620.64931    ,  624.85156    ,
     *   629.87879    ,
     *   629.64961    ,  628.81691    ,  628.66450    ,  629.23571    ,
     *   630.56688    ,  632.68632    ,  635.61381    ,  639.36066    ,
     *   643.93051    ,
     *   646.36336    ,  645.25874    ,  644.80151    ,  645.03693    ,
     *   646.00458    ,  647.73721    ,  650.25993    ,  653.58990    ,
     *   657.73664    ,
     *   662.53006    ,  661.18843    ,  660.46395    ,  660.40298    ,
     *   661.04727    ,  662.43284    ,  664.58898    ,  667.53774    ,
     *   671.29382    /
        DATA ((SOSV  (J,K),J=19,27),K=19,27) /
     *   678.18659    ,  676.63698    ,  675.67673    ,  675.35279    ,
     *   675.70834    ,  676.78173    ,  678.60550    ,  681.20569    ,
     *   684.60145    ,
     *   693.36704    ,  691.63388    ,  690.46449    ,  689.90608    ,
     *   690.00273    ,  690.79449    ,  692.31636    ,  694.59759    ,
     *   697.66107    ,
     *   708.10256    ,  706.20669    ,  704.85091    ,  704.08249    ,
     *   703.94610    ,  704.48298    ,  705.73001    ,  707.71898    ,
     *   710.47592    ,
     *   722.42153    ,  720.38094    ,  718.85840    ,  717.90114    ,
     *   717.55421    ,  717.85969    ,  718.85589    ,  720.57663    ,
     *   723.05050    ,
     *   736.34972    ,  734.18012    ,  732.50792    ,  731.38030    ,
     *   730.84252    ,  730.93729    ,  731.70401    ,  733.17809    ,
     *   735.39026    ,
     *   749.91057    ,  747.62577    ,  745.81897    ,  744.53723    ,
     *   743.82597    ,  743.72833    ,  744.28459    ,  745.53142    ,
     *   747.50129    ,
     *   763.12541    ,  760.73769    ,  758.80963    ,  757.38817    ,
     *   756.51881    ,  756.24507    ,  756.60785    ,  757.64489    ,
     *   759.39007    ,
     *   776.01370    ,  773.53403    ,  771.49661    ,  769.94827    ,
     *   768.93456    ,  768.49927    ,  768.68384    ,  769.52683    ,
     *   771.06334    ,
     *   788.59324    ,  786.03147    ,  783.89538    ,  782.23169    ,
     *   781.08597    ,  780.50222    ,  780.52230    ,  781.18550    ,
     *   782.52790    /
        DATA ((SOSV  (J,K),J=19,27),K=28,36) /
     *   800.88036    ,  798.24537    ,  796.02026    ,  794.25162    ,
     *   792.98502    ,  792.26462    ,  792.13266    ,  792.62900    ,
     *   793.79058    ,
     *   812.89007    ,  810.18990    ,  807.88452    ,  806.02035    ,
     *   804.64296    ,  803.79663    ,  803.52392    ,  803.86517    ,
     *   804.85807    ,
     *   824.63621    ,  821.87818    ,  819.50047    ,  817.54934    ,
     *   816.07034    ,  815.10785    ,  814.70468    ,  814.90160    ,
     *   815.73694    ,
     *   836.13159    ,  833.32235    ,  830.87954    ,  828.84929    ,
     *   827.27707    ,  826.20734    ,  825.68313    ,  825.74558    ,
     *   826.43357    ,
     *   847.38807    ,  844.53368    ,  842.03240    ,  839.93018    ,
     *   838.27242    ,  837.10364    ,  836.46703    ,  836.40408    ,
     *   836.95414    ,
     *   858.41666    ,  855.52267    ,  852.96898    ,  850.80135    ,
     *   849.06512    ,  847.80481    ,  847.06377    ,  846.88376    ,
     *   847.30457    ,
     *   869.22763    ,  866.29911    ,  863.69857    ,  861.47157    ,
     *   859.66336    ,  858.31846    ,  857.48033    ,  857.19099    ,
     *   857.49060    ,
     *   879.83054    ,  876.87214    ,  874.22985    ,  871.94905    ,
     *   870.07485    ,  868.65176    ,  867.72334    ,  867.33182    ,
     *   867.51769    ,
     *   890.23433    ,  887.25031    ,  884.57098    ,  882.24149    ,
     *   880.30684    ,  878.81149    ,  877.79909    ,  877.31202    ,
     *   877.39108    /
        DATA ((SOSV  (J,K),J=19,27),K=37,45) /
     *   900.44736    ,  897.44165    ,  894.72960    ,  892.35616    ,
     *   890.36618    ,  888.80408    ,  887.71353    ,  887.13709    ,
     *   887.11580    ,
     *   910.47747    ,  907.45368    ,  904.71290    ,  902.29988    ,
     *   900.25932    ,  898.63557    ,  897.47232    ,  896.81225    ,
     *   896.69665    ,
     *   920.33203    ,  917.29349    ,  914.52766    ,  912.07910    ,
     *   909.99236    ,  908.31170    ,  907.08083    ,  906.34250    ,
     *   906.13822    ,
     *   930.01795    ,  926.96772    ,  924.18026    ,  921.69991    ,
     *   919.57108    ,  917.83793    ,  916.54415    ,  915.73258    ,
     *   915.44488    ,
     *   939.54175    ,  936.48266    ,  933.67671    ,  931.16806    ,
     *   929.00093    ,  927.21941    ,  925.86714    ,  924.98701    ,
     *   924.62084    ,
     *   948.90957    ,  945.84423    ,  943.02272    ,  940.48898    ,
     *   938.28710    ,  936.46104    ,  935.05440    ,  934.11011    ,
     *   933.67010    ,
     *   958.12720    ,  955.05804    ,  952.22366    ,  949.66785    ,
     *   947.43450    ,  945.56748    ,  944.11033    ,  943.10599    ,
     *   942.59649    ,
     *   967.20012    ,  964.12937    ,  961.28464    ,  958.70953    ,
     *   956.44780    ,  954.54317    ,  953.03911    ,  951.97859    ,
     *   951.40370    ,
     *   976.13348    ,  973.06323    ,  970.21049    ,  967.61868    ,
     *   965.33142    ,  963.39230    ,  961.84474    ,  960.73165    ,
     *   960.09521    /
        DATA ((SOSV  (J,K),J=19,27),K=46,54) /
     *   984.93220    ,  981.86438    ,  979.00579    ,  976.39971    ,
     *   974.08959    ,  972.11892    ,  970.53100    ,  969.36876    ,
     *   968.67441    ,
     *   993.60090    ,  990.53732    ,  987.67490    ,  985.05680    ,
     *   982.72632    ,  980.72683    ,  979.10155    ,  977.89337    ,
     *   977.14452    ,
     *   1002.1440    ,  999.08631    ,  996.22196    ,  993.59394    ,
     *   991.24544    ,  989.21970    ,  987.55985    ,  986.30874    ,
     *   985.50861    ,
     *   1010.5657    ,  1007.5154    ,  1004.6509    ,  1002.0149    ,
     *   999.65059    ,  997.60101    ,  995.90923    ,  994.61802    ,
     *   993.76965    ,
     *   1018.8698    ,  1015.8285    ,  1012.9655    ,  1010.3234    ,
     *   1007.9453    ,  1005.8741    ,  1004.1528    ,  1002.8242    ,
     *   1001.9305    ,
     *   1027.0603    ,  1024.0293    ,  1021.1692    ,  1018.5228    ,
     *   1016.1328    ,  1014.0421    ,  1012.2938    ,  1010.9302    ,
     *   1009.9939    ,
     *   1035.1407    ,  1032.1212    ,  1029.2656    ,  1026.6164    ,
     *   1024.2163    ,  1022.1082    ,  1020.3349    ,  1018.9388    ,
     *   1017.9624    ,
     *   1043.1144    ,  1040.1077    ,  1037.2578    ,  1034.6073    ,
     *   1032.1989    ,  1030.0752    ,  1028.2789    ,  1026.8527    ,
     *   1025.8385    ,
     *   1050.9846    ,  1047.9918    ,  1045.1489    ,  1042.4986    ,
     *   1040.0834    ,  1037.9459    ,  1036.1287    ,  1034.6743    ,
     *   1033.6248    /
        DATA ((SOSV  (J,K),J=19,27),K=55,63) /
     *   1058.7545    ,  1055.7766    ,  1052.9420    ,  1050.2932    ,
     *   1047.8726    ,  1045.7230    ,  1043.8867    ,  1042.4061    ,
     *   1041.3234    ,
     *   1066.4270    ,  1063.4651    ,  1060.6398    ,  1057.9937    ,
     *   1055.5693    ,  1053.4090    ,  1051.5554    ,  1050.0506    ,
     *   1048.9367    ,
     *   1074.0049    ,  1071.0599    ,  1068.2450    ,  1065.6029    ,
     *   1063.1759    ,  1061.0065    ,  1059.1371    ,  1057.6099    ,
     *   1056.4669    ,
     *   1081.4910    ,  1078.5638    ,  1075.7603    ,  1073.1232    ,
     *   1070.6949    ,  1068.5178    ,  1066.6342    ,  1065.0862    ,
     *   1063.9159    ,
     *   1088.8879    ,  1085.9792    ,  1083.1881    ,  1080.5571    ,
     *   1078.1286    ,  1075.9451    ,  1074.0488    ,  1072.4817    ,
     *   1071.2857    ,
     *   1096.1979    ,  1093.3087    ,  1090.5307    ,  1087.9068    ,
     *   1085.4794    ,  1083.2907    ,  1081.3830    ,  1079.7983    ,
     *   1078.5784    ,
     *   1103.4235    ,  1100.5544    ,  1097.7906    ,  1095.1747    ,
     *   1092.7493    ,  1090.5566    ,  1088.6388    ,  1087.0380    ,
     *   1085.7958    ,
     *   1110.5670    ,  1107.7188    ,  1104.9697    ,  1102.3628    ,
     *   1099.9404    ,  1097.7449    ,  1095.8183    ,  1094.2026    ,
     *   1092.9396    ,
     *   1117.6305    ,  1114.8038    ,  1112.0704    ,  1109.4732    ,
     *   1107.0548    ,  1104.8574    ,  1102.9232    ,  1101.2940    ,
     *   1100.0116    /
        DATA ((SOSV  (J,K),J=19,27),K=64,72) /
     *   1124.6160    ,  1121.8116    ,  1119.0945    ,  1116.5078    ,
     *   1114.0943    ,  1111.8961    ,  1109.9554    ,  1108.3139    ,
     *   1107.0135    ,
     *   1131.5257    ,  1128.7441    ,  1126.0440    ,  1123.4686    ,
     *   1121.0608    ,  1118.8627    ,  1116.9165    ,  1115.2640    ,
     *   1113.9469    ,
     *   1138.3614    ,  1135.6032    ,  1132.9207    ,  1130.3574    ,
     *   1127.9561    ,  1125.7591    ,  1123.8084    ,  1122.1460    ,
     *   1120.8133    ,
     *   1145.1249    ,  1142.3907    ,  1139.7265    ,  1137.1760    ,
     *   1134.7819    ,  1132.5868    ,  1130.6326    ,  1128.9612    ,
     *   1127.6142    ,
     *   1151.8181    ,  1149.1084    ,  1146.4631    ,  1143.9259    ,
     *   1141.5399    ,  1139.3474    ,  1137.3907    ,  1135.7114    ,
     *   1134.3512    ,
     *   1158.4426    ,  1155.7580    ,  1153.1321    ,  1150.6089    ,
     *   1148.2316    ,  1146.0426    ,  1144.0841    ,  1142.3979    ,
     *   1141.0255    ,
     *   1165.0001    ,  1162.3411    ,  1159.7352    ,  1157.2266    ,
     *   1154.8585    ,  1152.6738    ,  1150.7144    ,  1149.0222    ,
     *   1147.6386    ,
     *   1171.4921    ,  1168.8592    ,  1166.2738    ,  1163.7803    ,
     *   1161.4223    ,  1159.2424    ,  1157.2829    ,  1155.5855    ,
     *   1154.1918    ,
     *   1177.9202    ,  1175.3139    ,  1172.7494    ,  1170.2717    ,
     *   1167.9242    ,  1165.7499    ,  1163.7910    ,  1162.0894    ,
     *   1160.6864    /
        DATA ((SOSV  (J,K),J=19,27),K=73,81) /
     *   1184.2859    ,  1181.7065    ,  1179.1636    ,  1176.7020    ,
     *   1174.3657    ,  1172.1976    ,  1170.2401    ,  1168.5349    ,
     *   1167.1235    ,
     *   1190.5905    ,  1188.0386    ,  1185.5175    ,  1183.0727    ,
     *   1180.7481    ,  1178.5868    ,  1176.6313    ,  1174.9233    ,
     *   1173.5045    ,
     *   1196.8354    ,  1194.3114    ,  1191.8127    ,  1189.3851    ,
     *   1187.0727    ,  1184.9188    ,  1182.9659    ,  1181.2560    ,
     *   1179.8304    ,
     *   1203.0220    ,  1200.5262    ,  1198.0503    ,  1195.6404    ,
     *   1193.3407    ,  1191.1948    ,  1189.2452    ,  1187.5339    ,
     *   1186.1023    ,
     *   1209.1514    ,  1206.6843    ,  1204.2317    ,  1201.8398    ,
     *   1199.5534    ,  1197.4159    ,  1195.4702    ,  1193.7582    ,
     *   1192.3214    ,
     *   1215.2250    ,  1212.7870    ,  1210.3580    ,  1207.9846    ,
     *   1205.7118    ,  1203.5834    ,  1201.6421    ,  1199.9301    ,
     *   1198.4888    ,
     *   1221.2439    ,  1218.8353    ,  1216.4303    ,  1214.0759    ,
     *   1211.8172    ,  1209.6983    ,  1207.7620    ,  1206.0505    ,
     *   1204.6054    ,
     *   1227.2092    ,  1224.8304    ,  1222.4498    ,  1220.1147    ,
     *   1217.8706    ,  1215.7616    ,  1213.8308    ,  1212.1205    ,
     *   1210.6722    ,
     *   1233.1221    ,  1230.7735    ,  1228.4177    ,  1226.1023    ,
     *   1223.8731    ,  1221.7745    ,  1219.8497    ,  1218.1411    ,
     *   1216.6902    /
        DATA ((SOSV  (J,K),J=28,36),K= 1, 9) /
     *   433.40751    ,  447.19477    ,  461.42062    ,  476.09902    ,
     *   491.24436    ,  506.87149    ,  522.99573    ,  539.63292    ,
     *   556.79935    ,
     *   447.75702    ,  461.16918    ,  475.01355    ,  489.30613    ,
     *   504.06318    ,  519.30124    ,  535.03717    ,  551.28815    ,
     *   568.07173    ,
     *   462.17040    ,  475.16839    ,  488.60377    ,  502.49208    ,
     *   516.84941    ,  531.69233    ,  547.03788    ,  562.90353    ,
     *   579.30718    ,
     *   476.69236    ,  489.23000    ,  502.22207    ,  515.68136    ,
     *   529.62185    ,  544.05855    ,  559.00733    ,  574.48486    ,
     *   590.50847    ,
     *   491.32281    ,  503.35724    ,  515.87307    ,  528.87870    ,
     *   542.38458    ,  556.40285    ,  570.94716    ,  586.03241    ,
     *   601.67460    ,
     *   506.03472    ,  517.53215    ,  529.54491    ,  542.07619    ,
     *   555.13207    ,  568.72106    ,  582.85382    ,  597.54280    ,
     *   612.80204    ,
     *   520.78768    ,  531.72555    ,  543.21652    ,  555.25855    ,
     *   567.85307    ,  581.00465    ,  594.72053    ,  609.01033    ,
     *   623.88574    ,
     *   535.53732    ,  545.90402    ,  556.86288    ,  568.40699    ,
     *   580.53339    ,  593.24270    ,  606.53870    ,  620.42802    ,
     *   634.91976    ,
     *   550.24094    ,  560.03444    ,  570.45842    ,  581.50186    ,
     *   593.15788    ,  605.42345    ,  618.29905    ,  631.78833    ,
     *   645.89782    /
        DATA ((SOSV  (J,K),J=28,36),K=10,18) /
     *   564.86026    ,  574.08638    ,  583.97911    ,  594.52425    ,
     *   605.71168    ,  617.53519    ,  629.99225    ,  643.08375    ,
     *   656.81368    ,
     *   579.36239    ,  588.03315    ,  597.40346    ,  607.45697    ,
     *   618.18106    ,  629.56694    ,  641.60948    ,  654.30708    ,
     *   667.66141    ,
     *   593.71985    ,  601.85205    ,  610.71289    ,  620.28488    ,
     *   630.55376    ,  641.50877    ,  653.14267    ,  665.45172    ,
     *   678.43550    ,
     *   607.91023    ,  615.52425    ,  623.89170    ,  632.99502    ,
     *   642.81913    ,  653.35196    ,  664.58466    ,  676.51174    ,
     *   689.13101    ,
     *   621.91571    ,  629.03442    ,  636.92694    ,  645.57653    ,
     *   654.96813    ,  665.08899    ,  675.92922    ,  687.48197    ,
     *   699.74357    ,
     *   635.72253    ,  642.37045    ,  649.80811    ,  658.02048    ,
     *   666.99321    ,  676.71355    ,  687.17105    ,  698.35795    ,
     *   710.26944    ,
     *   649.32055    ,  655.52303    ,  662.52697    ,  670.31970    ,
     *   678.88824    ,  688.22043    ,  698.30575    ,  709.13595    ,
     *   720.70541    ,
     *   662.70279    ,  668.48538    ,  675.07726    ,  682.46860    ,
     *   690.64834    ,  699.60540    ,  709.32971    ,  719.81288    ,
     *   731.04883    ,
     *   675.86498    ,  681.25291    ,  687.45446    ,  694.46297    ,
     *   702.26973    ,  710.86517    ,  720.24004    ,  730.38626    ,
     *   741.29755    /
        DATA ((SOSV  (J,K),J=28,36),K=19,27) /
     *   688.80515    ,  693.82292    ,  699.65560    ,  706.29988    ,
     *   713.74965    ,  721.99723    ,  731.03455    ,  740.85414    ,
     *   751.44987    ,
     *   701.52325    ,  706.19436    ,  711.67907    ,  717.97747    ,
     *   725.08623    ,  732.99980    ,  741.71161    ,  751.21508    ,
     *   761.50449    ,
     *   714.02079    ,  718.36751    ,  723.52439    ,  729.49483    ,
     *   736.27837    ,  743.87175    ,  752.27012    ,  761.46805    ,
     *   771.46047    ,
     *   726.30049    ,  730.34381    ,  735.19208    ,  740.85191    ,
     *   747.32567    ,  754.61252    ,  762.70946    ,  771.61243    ,
     *   781.31723    ,
     *   738.36606    ,  742.12558    ,  746.68347    ,  752.04934    ,
     *   758.22833    ,  765.22202    ,  773.02941    ,  781.64792    ,
     *   791.07443    ,
     *   750.22190    ,  753.71587    ,  758.00057    ,  763.08836    ,
     *   768.98706    ,  775.70063    ,  783.23011    ,  791.57456    ,
     *   800.73203    ,
     *   761.87295    ,  765.11829    ,  769.14592    ,  773.97072    ,
     *   779.60300    ,  786.04908    ,  793.31204    ,  801.39263    ,
     *   810.29020    ,
     *   773.32446    ,  776.33686    ,  780.12249    ,  784.69855    ,
     *   790.07769    ,  796.26845    ,  803.27594    ,  811.10265    ,
     *   819.74931    ,
     *   784.58193    ,  787.37587    ,  790.93358    ,  795.27433    ,
     *   800.41294    ,  806.36008    ,  813.12282    ,  820.70537    ,
     *   829.10992    /
        DATA ((SOSV  (J,K),J=28,36),K=28,36) /
     *   795.65095    ,  798.23982    ,  801.58272    ,  805.70080    ,
     *   810.61086    ,  816.32554    ,  822.85385    ,  830.20170    ,
     *   838.37272    ,
     *   806.53713    ,  808.93332    ,  812.07362    ,  815.98088    ,
     *   820.67370    ,  826.16662    ,  832.47041    ,  839.59270    ,
     *   847.53857    ,
     *   817.24606    ,  819.46100    ,  822.41008    ,  826.11763    ,
     *   830.60393    ,  835.88522    ,  841.97403    ,  848.87958    ,
     *   856.60842    ,
     *   827.78322    ,  829.82752    ,  832.59595    ,  836.11421    ,
     *   840.40408    ,  845.48342    ,  851.36635    ,  858.06366    ,
     *   865.58334    ,
     *   838.15399    ,  840.03747    ,  842.63512    ,  845.97385    ,
     *   850.07681    ,  854.96334    ,  860.64910    ,  867.14635    ,
     *   874.46447    ,
     *   848.36358    ,  850.09538    ,  852.53143    ,  855.69977    ,
     *   859.62480    ,  864.32722    ,  869.82410    ,  876.12913    ,
     *   883.25303    ,
     *   858.41706    ,  860.00566    ,  862.28871    ,  865.29523    ,
     *   869.05077    ,  873.57731    ,  878.89322    ,  885.01356    ,
     *   891.95031    ,
     *   868.31933    ,  869.77264    ,  871.91069    ,  874.76343    ,
     *   878.35747    ,  882.71590    ,  887.85839    ,  893.80122    ,
     *   900.55764    ,
     *   878.07508    ,  879.40048    ,  881.40105    ,  884.10757    ,
     *   887.54760    ,  891.74532    ,  896.72155    ,  902.49376    ,
     *   909.07638    /
        DATA ((SOSV  (J,K),J=28,36),K=37,45) /
     *   887.68887    ,  888.89326    ,  890.76338    ,  893.33076    ,
     *   896.62387    ,  900.66787    ,  905.48465    ,  911.09282    ,
     *   917.50794    ,
     *   897.16506    ,  898.25489    ,  900.00115    ,  902.43608    ,
     *   905.58894    ,  909.48585    ,  914.14967    ,  919.60009    ,
     *   925.85372    ,
     *   906.50782    ,  907.48916    ,  909.11776    ,  911.42652    ,
     *   914.44545    ,  918.20154    ,  922.71857    ,  928.01724    ,
     *   934.11517    ,
     *   915.72118    ,  916.59970    ,  918.11648    ,  920.30499    ,
     *   923.19597    ,  926.81718    ,  931.19330    ,  936.34595    ,
     *   942.29373    ,
     *   924.80899    ,  925.59005    ,  927.00049    ,  929.07435    ,
     *   931.84302    ,  935.33499    ,  939.57579    ,  944.58789    ,
     *   950.39084    ,
     *   933.77496    ,  934.46358    ,  935.77286    ,  937.73736    ,
     *   940.38906    ,  943.75716    ,  947.86794    ,  952.74474    ,
     *   958.40794    ,
     *   942.62262    ,  943.22356    ,  944.43657    ,  946.29669    ,
     *   948.83649    ,  952.08580    ,  956.07164    ,  960.81812    ,
     *   966.34647    ,
     *   951.35539    ,  951.87311    ,  952.99447    ,  954.75496    ,
     *   957.18765    ,  960.32301    ,  964.18874    ,  968.80968    ,
     *   974.20785    ,
     *   959.97652    ,  960.41525    ,  961.44934    ,  963.11467    ,
     *   965.44482    ,  968.47083    ,  972.22105    ,  976.72101    ,
     *   981.99348    /
        DATA ((SOSV  (J,K),J=28,36),K=46,54) /
     *   968.48916    ,  968.85289    ,  969.80384    ,  971.37826    ,
     *   973.61021    ,  976.53125    ,  980.17034    ,  984.55369    ,
     *   989.70476    ,
     *   976.89631    ,  977.18882    ,  978.06055    ,  979.54810    ,
     *   981.68596    ,  984.50621    ,  988.03836    ,  992.30927    ,
     *   997.34307    ,
     *   985.20086    ,  985.42573    ,  986.22195    ,  987.62647    ,
     *   989.67417    ,  992.39759    ,  995.82681    ,  999.98927    ,
     *   1004.9097    ,
     *   993.40559    ,  993.56620    ,  994.29045    ,  995.61558    ,
     *   997.57684    ,  1000.2072    ,  1003.5374    ,  1007.5952    ,
     *   1012.4061    ,
     *   1001.5132    ,  1001.6127    ,  1002.2684    ,  1003.5176    ,
     *   1005.3959    ,  1007.9369    ,  1011.1716    ,  1015.1285    ,
     *   1019.8335    ,
     *   1009.5261    ,  1009.5677    ,  1010.1579    ,  1011.3345    ,
     *   1013.1334    ,  1015.5884    ,  1018.7311    ,  1022.5906    ,
     *   1027.1932    ,
     *   1017.4470    ,  1017.4335    ,  1017.9613    ,  1019.0684    ,
     *   1020.7910    ,  1023.1634    ,  1026.2175    ,  1029.9828    ,
     *   1034.4865    ,
     *   1025.2781    ,  1025.2122    ,  1025.6805    ,  1026.7211    ,
     *   1028.3706    ,  1030.6635    ,  1033.6322    ,  1037.3067    ,
     *   1041.7145    ,
     *   1033.0218    ,  1032.9062    ,  1033.3176    ,  1034.2946    ,
     *   1035.8739    ,  1038.0903    ,  1040.9767    ,  1044.5634    ,
     *   1048.8786    /
        DATA ((SOSV  (J,K),J=28,36),K=55,63) /
     *   1040.6802    ,  1040.5173    ,  1040.8746    ,  1041.7907    ,
     *   1043.3025    ,  1045.4454    ,  1048.2524    ,  1051.7543    ,
     *   1055.9798    ,
     *   1048.2555    ,  1048.0476    ,  1048.3532    ,  1049.2110    ,
     *   1050.6582    ,  1052.7303    ,  1055.4607    ,  1058.8807    ,
     *   1063.0193    ,
     *   1055.7496    ,  1055.4991    ,  1055.7554    ,  1056.5574    ,
     *   1057.9425    ,  1059.9464    ,  1062.6029    ,  1065.9438    ,
     *   1069.9983    ,
     *   1063.1647    ,  1062.8737    ,  1063.0829    ,  1063.8314    ,
     *   1065.1568    ,  1067.0952    ,  1069.6805    ,  1072.9448    ,
     *   1076.9178    ,
     *   1070.5025    ,  1070.1730    ,  1070.3373    ,  1071.0347    ,
     *   1072.3028    ,  1074.1780    ,  1076.6945    ,  1079.8848    ,
     *   1083.7790    ,
     *   1077.7650    ,  1077.3989    ,  1077.5204    ,  1078.1687    ,
     *   1079.3818    ,  1081.1962    ,  1083.6463    ,  1086.7651    ,
     *   1090.5829    ,
     *   1084.9538    ,  1084.5530    ,  1084.6337    ,  1085.2350    ,
     *   1086.3953    ,  1088.1510    ,  1090.5372    ,  1093.5867    ,
     *   1097.3305    ,
     *   1092.0708    ,  1091.6370    ,  1091.6786    ,  1092.2351    ,
     *   1093.3445    ,  1095.0439    ,  1097.3682    ,  1100.3508    ,
     *   1104.0229    ,
     *   1099.1174    ,  1098.6524    ,  1098.6568    ,  1099.1702    ,
     *   1100.2309    ,  1101.8759    ,  1104.1405    ,  1107.0583    ,
     *   1110.6609    /
        DATA ((SOSV  (J,K),J=28,36),K=64,72) /
     *   1106.0955    ,  1105.6008    ,  1105.5697    ,  1106.0419    ,
     *   1107.0557    ,  1108.6482    ,  1110.8552    ,  1113.7104    ,
     *   1117.2456    ,
     *   1113.0064    ,  1112.4835    ,  1112.4186    ,  1112.8513    ,
     *   1113.8200    ,  1115.3622    ,  1117.5135    ,  1120.3080    ,
     *   1123.7779    ,
     *   1119.8517    ,  1119.3022    ,  1119.2050    ,  1119.5998    ,
     *   1120.5252    ,  1122.0187    ,  1124.1163    ,  1126.8521    ,
     *   1130.2587    ,
     *   1126.6328    ,  1126.0580    ,  1125.9300    ,  1126.2886    ,
     *   1127.1724    ,  1128.6191    ,  1130.6647    ,  1133.3437    ,
     *   1136.6889    ,
     *   1133.3512    ,  1132.7524    ,  1132.5951    ,  1132.9189    ,
     *   1133.7628    ,  1135.1643    ,  1137.1597    ,  1139.7837    ,
     *   1143.0694    ,
     *   1140.0081    ,  1139.3866    ,  1139.2013    ,  1139.4920    ,
     *   1140.2974    ,  1141.6553    ,  1143.6023    ,  1146.1731    ,
     *   1149.4009    ,
     *   1146.6049    ,  1145.9620    ,  1145.7500    ,  1146.0088    ,
     *   1146.7773    ,  1148.0933    ,  1149.9934    ,  1152.5126    ,
     *   1155.6845    ,
     *   1153.1429    ,  1152.4796    ,  1152.2423    ,  1152.4706    ,
     *   1153.2036    ,  1154.4791    ,  1156.3339    ,  1158.8033    ,
     *   1161.9208    ,
     *   1159.6232    ,  1158.9407    ,  1158.6792    ,  1158.8784    ,
     *   1159.5772    ,  1160.8138    ,  1162.6248    ,  1165.0458    ,
     *   1168.1106    /
        DATA ((SOSV  (J,K),J=28,36),K=73,81) /
     *   1166.0472    ,  1165.3465    ,  1165.0619    ,  1165.2332    ,
     *   1165.8992    ,  1167.0982    ,  1168.8670    ,  1171.2411    ,
     *   1174.2547    ,
     *   1172.4158    ,  1171.6980    ,  1171.3915    ,  1171.5360    ,
     *   1172.1705    ,  1173.3333    ,  1175.0612    ,  1177.3900    ,
     *   1180.3539    ,
     *   1178.7303    ,  1177.9964    ,  1177.6690    ,  1177.7879    ,
     *   1178.3921    ,  1179.5199    ,  1181.2083    ,  1183.4932    ,
     *   1186.4090    ,
     *   1184.9917    ,  1184.2426    ,  1183.8953    ,  1183.9897    ,
     *   1184.5649    ,  1185.6589    ,  1187.3092    ,  1189.5515    ,
     *   1192.4205    ,
     *   1191.2010    ,  1190.4376    ,  1190.0715    ,  1190.1425    ,
     *   1190.6897    ,  1191.7512    ,  1193.3646    ,  1195.5657    ,
     *   1198.3893    ,
     *   1197.3594    ,  1196.5826    ,  1196.1985    ,  1196.2471    ,
     *   1196.7674    ,  1197.7976    ,  1199.3753    ,  1201.5364    ,
     *   1204.3159    ,
     *   1203.4677    ,  1202.6783    ,  1202.2773    ,  1202.3044    ,
     *   1202.7988    ,  1203.7989    ,  1205.3420    ,  1207.4645    ,
     *   1210.2012    ,
     *   1209.5270    ,  1208.7258    ,  1208.3086    ,  1208.3152    ,
     *   1208.7848    ,  1209.7558    ,  1211.2655    ,  1213.3505    ,
     *   1216.0456    ,
     *   1215.5382    ,  1214.7259    ,  1214.2934    ,  1214.2804    ,
     *   1214.7262    ,  1215.6691    ,  1217.1466    ,  1219.1952    ,
     *   1221.8500    /
        DATA ((SOSV  (J,K),J=37,45),K= 1, 9) /
     *   574.51188    ,  592.78786    ,  611.64523    ,  631.10247    ,
     *   651.17868    ,  671.89354    ,  693.26736    ,  715.32112    ,
     *   738.07644    ,
     *   585.40581    ,  603.30871    ,  621.79918    ,  640.89641    ,
     *   660.62007    ,  680.99035    ,  702.02797    ,  723.75422    ,
     *   746.19096    ,
     *   596.26713    ,  613.80210    ,  631.93125    ,  650.67416    ,
     *   670.05086    ,  690.08188    ,  710.78822    ,  732.19141    ,
     *   754.31354    ,
     *   607.09613    ,  624.26638    ,  642.03829    ,  660.43147    ,
     *   679.46603    ,  699.16260    ,  719.54231    ,  740.62683    ,
     *   762.43837    ,
     *   617.89066    ,  634.69840    ,  652.11636    ,  670.16380    ,
     *   688.86059    ,  708.22724    ,  728.28483    ,  749.05504    ,
     *   770.56010    ,
     *   628.64694    ,  645.09407    ,  662.16106    ,  679.86646    ,
     *   698.22967    ,  717.27082    ,  737.01077    ,  757.47104    ,
     *   778.67381    ,
     *   639.36021    ,  655.44876    ,  672.16778    ,  689.53486    ,
     *   707.56862    ,  726.28868    ,  745.71547    ,  765.87026    ,
     *   786.77503    ,
     *   650.02522    ,  665.75764    ,  682.13194    ,  699.16451    ,
     *   716.87307    ,  735.27650    ,  754.39470    ,  774.24852    ,
     *   794.85968    ,
     *   660.63655    ,  676.01586    ,  692.04904    ,  708.75119    ,
     *   726.13893    ,  744.23031    ,  763.04456    ,  782.60203    ,
     *   802.92407    /
        DATA ((SOSV  (J,K),J=37,45),K=10,18) /
     *   671.18889    ,  686.21872    ,  701.91485    ,  718.29093    ,
     *   735.36245    ,  753.14648    ,  771.66152    ,  790.92734    ,
     *   810.96483    ,
     *   681.67718    ,  696.36185    ,  711.72541    ,  727.78010    ,
     *   744.54019    ,  762.02173    ,  780.24241    ,  799.22135    ,
     *   818.97896    ,
     *   692.09676    ,  706.44118    ,  721.47712    ,  737.21540    ,
     *   753.66905    ,  770.85310    ,  788.78437    ,  807.48130    ,
     *   826.96373    ,
     *   702.44344    ,  716.45307    ,  731.16673    ,  746.59385    ,
     *   762.74626    ,  779.63794    ,  797.28485    ,  815.70468    ,
     *   834.91670    ,
     *   712.71351    ,  726.39429    ,  740.79135    ,  755.91282    ,
     *   771.76936    ,  788.37393    ,  805.74158    ,  823.88928    ,
     *   842.83570    ,
     *   722.90372    ,  736.26201    ,  750.34847    ,  765.17002    ,
     *   780.73621    ,  797.05899    ,  814.15256    ,  832.03315    ,
     *   850.71880    ,
     *   733.01132    ,  746.05382    ,  759.83592    ,  774.36345    ,
     *   789.64492    ,  805.69134    ,  822.51606    ,  840.13456    ,
     *   858.56429    ,
     *   743.03402    ,  755.76768    ,  769.25187    ,  783.49143    ,
     *   798.49391    ,  814.26944    ,  830.83054    ,  848.19201    ,
     *   866.37066    ,
     *   752.96992    ,  765.40191    ,  778.59478    ,  792.55252    ,
     *   807.28181    ,  822.79195    ,  839.09471    ,  856.20418    ,
     *   874.13660    /
        DATA ((SOSV  (J,K),J=37,45),K=19,27) /
     *   762.81751    ,  774.95515    ,  787.86341    ,  801.54555    ,
     *   816.00750    ,  831.25778    ,  847.30746    ,  864.16997    ,
     *   881.86095    ,
     *   772.57564    ,  784.42636    ,  797.05679    ,  810.46960    ,
     *   824.67005    ,  839.66601    ,  855.46785    ,  872.08839    ,
     *   889.54273    ,
     *   782.24345    ,  793.81473    ,  806.17415    ,  819.32392    ,
     *   833.26875    ,  848.01589    ,  863.57512    ,  879.95867    ,
     *   897.18110    ,
     *   791.82037    ,  803.11972    ,  815.21497    ,  828.10799    ,
     *   841.80303    ,  856.30684    ,  871.62863    ,  887.78011    ,
     *   904.77534    ,
     *   801.30608    ,  812.34099    ,  824.17889    ,  836.82142    ,
     *   850.27250    ,  864.53841    ,  879.62791    ,  895.55220    ,
     *   912.32486    ,
     *   810.70046    ,  821.47841    ,  833.06574    ,  845.46401    ,
     *   858.67689    ,  872.71030    ,  887.57259    ,  903.27450    ,
     *   919.82918    ,
     *   820.00361    ,  830.53200    ,  841.87548    ,  854.03567    ,
     *   867.01606    ,  880.82231    ,  895.46240    ,  910.94668    ,
     *   927.28791    ,
     *   829.21580    ,  839.50194    ,  850.60824    ,  862.53644    ,
     *   875.28999    ,  888.87434    ,  903.29719    ,  918.56853    ,
     *   934.70075    ,
     *   838.33743    ,  848.38854    ,  859.26422    ,  870.96647    ,
     *   883.49875    ,  896.86640    ,  911.07688    ,  926.13989    ,
     *   942.06749    /
        DATA ((SOSV  (J,K),J=37,45),K=28,36) /
     *   847.36907    ,  857.19223    ,  867.84377    ,  879.32599    ,
     *   891.64250    ,  904.79857    ,  918.80148    ,  933.66071    ,
     *   949.38799    ,
     *   856.31138    ,  865.91355    ,  876.34730    ,  887.61535    ,
     *   899.72148    ,  912.67100    ,  926.47107    ,  941.13096    ,
     *   956.66217    ,
     *   865.16513    ,  874.55312    ,  884.77532    ,  895.83494    ,
     *   907.73600    ,  920.48392    ,  934.08579    ,  948.55072    ,
     *   963.89001    ,
     *   873.93120    ,  883.11165    ,  893.12841    ,  903.98522    ,
     *   915.68644    ,  928.23760    ,  941.64582    ,  955.92011    ,
     *   971.07155    ,
     *   882.61051    ,  891.58991    ,  901.40721    ,  912.06672    ,
     *   923.57320    ,  935.93238    ,  949.15142    ,  963.23927    ,
     *   978.20688    ,
     *   891.20408    ,  899.98874    ,  909.61241    ,  920.08002    ,
     *   931.39676    ,  943.56863    ,  956.60287    ,  970.50842    ,
     *   985.29612    ,
     *   899.71296    ,  908.30903    ,  917.74474    ,  928.02573    ,
     *   939.15764    ,  951.14677    ,  964.00051    ,  977.72781    ,
     *   992.33944    ,
     *   908.13828    ,  916.55170    ,  925.80501    ,  935.90451    ,
     *   946.85638    ,  958.66725    ,  971.34469    ,  984.89771    ,
     *   999.33703    ,
     *   916.48118    ,  924.71773    ,  933.79401    ,  943.71705    ,
     *   954.49357    ,  966.13055    ,  978.63580    ,  992.01843    ,
     *   1006.2891    /
        DATA ((SOSV  (J,K),J=37,45),K=37,45) /
     *   924.74284    ,  932.80811    ,  941.71260    ,  951.46407    ,
     *   962.06980    ,  973.53717    ,  985.87427    ,  999.09030    ,
     *   1013.1960    ,
     *   932.92446    ,  940.82386    ,  949.56165    ,  959.14631    ,
     *   969.58570    ,  980.88766    ,  993.06053    ,  1006.1137    ,
     *   1020.0579    ,
     *   941.02727    ,  948.76604    ,  957.34205    ,  966.76453    ,
     *   977.04194    ,  988.18256    ,  1000.1951    ,  1013.0890    ,
     *   1026.8752    ,
     *   949.05251    ,  956.63569    ,  965.05470    ,  974.31950    ,
     *   984.43917    ,  995.42243    ,  1007.2783    ,  1020.0166    ,
     *   1033.6481    ,
     *   957.00140    ,  964.43388    ,  972.70053    ,  981.81203    ,
     *   991.77806    ,  1002.6079    ,  1014.3108    ,  1026.8968    ,
     *   1040.3771    ,
     *   964.87521    ,  972.16170    ,  980.28046    ,  989.24290    ,
     *   999.05932    ,  1009.7395    ,  1021.2930    ,  1033.7303    ,
     *   1047.0624    ,
     *   972.67517    ,  979.82021    ,  987.79542    ,  996.61294    ,
     *   1006.2836    ,  1016.8178    ,  1028.2255    ,  1040.5173    ,
     *   1053.7045    ,
     *   980.40252    ,  987.41050    ,  995.24637    ,  1003.9229    ,
     *   1013.4517    ,  1023.8435    ,  1035.1087    ,  1047.2583    ,
     *   1060.3037    ,
     *   988.05851    ,  994.93364    ,  1002.6342    ,  1011.1737    ,
     *   1020.5643    ,  1030.8172    ,  1041.9433    ,  1053.9538    ,
     *   1066.8603    /
        DATA ((SOSV  (J,K),J=37,45),K=46,54) /
     *   995.64434    ,  1002.3907    ,  1009.9599    ,  1018.3661    ,
     *   1027.6221    ,  1037.7395    ,  1048.7297    ,  1060.6042    ,
     *   1073.3749    ,
     *   1003.1612    ,  1009.7828    ,  1017.2244    ,  1025.5010    ,
     *   1034.6257    ,  1044.6110    ,  1055.4685    ,  1067.2100    ,
     *   1079.8477    ,
     *   1010.6104    ,  1017.1109    ,  1024.4286    ,  1032.5790    ,
     *   1041.5760    ,  1051.4324    ,  1062.1602    ,  1073.7717    ,
     *   1086.2792    ,
     *   1017.9930    ,  1024.3761    ,  1031.5735    ,  1039.6012    ,
     *   1048.4736    ,  1058.2042    ,  1068.8055    ,  1080.2898    ,
     *   1092.6699    ,
     *   1025.3102    ,  1031.5794    ,  1038.6598    ,  1046.5681    ,
     *   1055.3193    ,  1064.9272    ,  1075.4047    ,  1086.7647    ,
     *   1099.0200    ,
     *   1032.5632    ,  1038.7219    ,  1045.6887    ,  1053.4808    ,
     *   1062.1138    ,  1071.6019    ,  1081.9586    ,  1093.1969    ,
     *   1105.3301    ,
     *   1039.7530    ,  1045.8045    ,  1052.6609    ,  1060.3399    ,
     *   1068.8577    ,  1078.2289    ,  1088.4675    ,  1099.5869    ,
     *   1111.6006    ,
     *   1046.8808    ,  1052.8283    ,  1059.5773    ,  1067.1462    ,
     *   1075.5517    ,  1084.8089    ,  1094.9322    ,  1105.9352    ,
     *   1117.8318    ,
     *   1053.9477    ,  1059.7942    ,  1066.4389    ,  1073.9006    ,
     *   1082.1966    ,  1091.3425    ,  1101.3530    ,  1112.2422    ,
     *   1124.0242    /
        DATA ((SOSV  (J,K),J=37,45),K=55,63) /
     *   1060.9548    ,  1066.7032    ,  1073.2464    ,  1080.6038    ,
     *   1088.7931    ,  1097.8303    ,  1107.7306    ,  1118.5085    ,
     *   1130.1782    ,
     *   1067.9030    ,  1073.5562    ,  1080.0007    ,  1087.2565    ,
     *   1095.3417    ,  1104.2729    ,  1114.0655    ,  1124.7345    ,
     *   1136.2943    ,
     *   1074.7935    ,  1080.3542    ,  1086.7027    ,  1093.8596    ,
     *   1101.8433    ,  1110.6709    ,  1120.3583    ,  1130.9206    ,
     *   1142.3728    ,
     *   1081.6272    ,  1087.0980    ,  1093.3532    ,  1100.4136    ,
     *   1108.2984    ,  1117.0249    ,  1126.6094    ,  1137.0674    ,
     *   1148.4141    ,
     *   1088.4051    ,  1093.7886    ,  1099.9530    ,  1106.9195    ,
     *   1114.7077    ,  1123.3354    ,  1132.8194    ,  1143.1754    ,
     *   1154.4188    ,
     *   1095.1281    ,  1100.4268    ,  1106.5028    ,  1113.3779    ,
     *   1121.0719    ,  1129.6032    ,  1138.9888    ,  1149.2449    ,
     *   1160.3871    ,
     *   1101.7973    ,  1107.0136    ,  1113.0035    ,  1119.7894    ,
     *   1127.3916    ,  1135.8287    ,  1145.1181    ,  1155.2764    ,
     *   1166.3196    ,
     *   1108.4135    ,  1113.5496    ,  1119.4559    ,  1126.1549    ,
     *   1133.6674    ,  1142.0124    ,  1151.2079    ,  1161.2705    ,
     *   1172.2166    ,
     *   1114.9777    ,  1120.0359    ,  1125.8606    ,  1132.4749    ,
     *   1139.8999    ,  1148.1551    ,  1157.2586    ,  1167.2275    ,
     *   1178.0784    /
        DATA ((SOSV  (J,K),J=37,45),K=64,72) /
     *   1121.4906    ,  1126.4731    ,  1132.2185    ,  1138.7502    ,
     *   1146.0898    ,  1154.2572    ,  1163.2707    ,  1173.1479    ,
     *   1183.9056    ,
     *   1127.9533    ,  1132.8621    ,  1138.5302    ,  1144.9814    ,
     *   1152.2377    ,  1160.3192    ,  1169.2448    ,  1179.0322    ,
     *   1189.6985    ,
     *   1134.3664    ,  1139.2036    ,  1144.7965    ,  1151.1692    ,
     *   1158.3441    ,  1166.3417    ,  1175.1812    ,  1184.8807    ,
     *   1195.4575    ,
     *   1140.7309    ,  1145.4984    ,  1151.0180    ,  1157.3142    ,
     *   1164.4096    ,  1172.3253    ,  1181.0806    ,  1190.6940    ,
     *   1201.1830    ,
     *   1147.0476    ,  1151.7473    ,  1157.1955    ,  1163.4170    ,
     *   1170.4349    ,  1178.2704    ,  1186.9433    ,  1196.4724    ,
     *   1206.8754    ,
     *   1153.3171    ,  1157.9509    ,  1163.3296    ,  1169.4783    ,
     *   1176.4204    ,  1184.1776    ,  1192.7699    ,  1202.2163    ,
     *   1212.5351    ,
     *   1159.5404    ,  1164.1101    ,  1169.4209    ,  1175.4986    ,
     *   1182.3667    ,  1190.0473    ,  1198.5607    ,  1207.9263    ,
     *   1218.1624    ,
     *   1165.7182    ,  1170.2254    ,  1175.4702    ,  1181.4786    ,
     *   1188.2745    ,  1195.8801    ,  1204.3163    ,  1213.6026    ,
     *   1223.7577    ,
     *   1171.8511    ,  1176.2976    ,  1181.4780    ,  1187.4188    ,
     *   1194.1441    ,  1201.6765    ,  1210.0371    ,  1219.2458    ,
     *   1229.3214    /
        DATA ((SOSV  (J,K),J=37,45),K=73,81) /
     *   1177.9400    ,  1182.3273    ,  1187.4450    ,  1193.3198    ,
     *   1199.9761    ,  1207.4369    ,  1215.7236    ,  1224.8561    ,
     *   1234.8538    ,
     *   1183.9855    ,  1188.3152    ,  1193.3718    ,  1199.1821    ,
     *   1205.7711    ,  1213.1618    ,  1221.3760    ,  1230.4341    ,
     *   1240.3554    ,
     *   1189.9882    ,  1194.2619    ,  1199.2589    ,  1205.0064    ,
     *   1211.5295    ,  1218.8517    ,  1226.9950    ,  1235.9800    ,
     *   1245.8264    ,
     *   1195.9490    ,  1200.1680    ,  1205.1070    ,  1210.7931    ,
     *   1217.2518    ,  1224.5071    ,  1232.5809    ,  1241.4944    ,
     *   1251.2672    ,
     *   1201.8683    ,  1206.0343    ,  1210.9165    ,  1216.5427    ,
     *   1222.9386    ,  1230.1283    ,  1238.1342    ,  1246.9775    ,
     *   1256.6782    ,
     *   1207.7470    ,  1211.8612    ,  1216.6882    ,  1222.2559    ,
     *   1228.5904    ,  1235.7159    ,  1243.6552    ,  1252.4297    ,
     *   1262.0597    ,
     *   1213.5855    ,  1217.6493    ,  1222.4225    ,  1227.9331    ,
     *   1234.2075    ,  1241.2702    ,  1249.1443    ,  1257.8514    ,
     *   1267.4120    ,
     *   1219.3846    ,  1223.3993    ,  1228.1199    ,  1233.5748    ,
     *   1239.7904    ,  1246.7917    ,  1254.6019    ,  1263.2429    ,
     *   1272.7355    ,
     *   1225.1448    ,  1229.1117    ,  1233.7810    ,  1239.1814    ,
     *   1245.3397    ,  1252.2809    ,  1260.0285    ,  1268.6047    ,
     *   1278.0305    /
        DATA ((SOSV  (J,K),J=46,54),K= 1, 9) /
     *   761.55563    ,  785.78173    ,  810.77849    ,  836.57044    ,
     *   863.18286    ,  890.64186    ,  918.97437    ,  948.20817    ,
     *   978.37194    ,
     *   769.36069    ,  793.28656    ,  817.99238    ,  843.50270    ,
     *   869.84278    ,  897.03865    ,  925.11714    ,  954.10593    ,
     *   984.03354    ,
     *   777.17727    ,  800.80586    ,  825.22322    ,  850.45392    ,
     *   876.52323    ,  903.45716    ,  931.28249    ,  960.02680    ,
     *   989.71850    ,
     *   784.99972    ,  808.33422    ,  832.46587    ,  857.41928    ,
     *   883.21976    ,  909.89331    ,  937.46667    ,  965.96738    ,
     *   995.42377    ,
     *   792.82283    ,  815.86666    ,  839.71562    ,  864.39438    ,
     *   889.92826    ,  916.34328    ,  943.66619    ,  971.92448    ,
     *   1001.1464    ,
     *   800.64186    ,  823.39862    ,  846.96814    ,  871.37511    ,
     *   896.64490    ,  922.80355    ,  949.87779    ,  977.89512    ,
     *   1006.8838    ,
     *   808.45246    ,  830.92592    ,  854.21944    ,  878.35774    ,
     *   903.36618    ,  929.27083    ,  956.09844    ,  983.87652    ,
     *   1012.6333    ,
     *   816.25067    ,  838.44476    ,  861.46591    ,  885.33881    ,
     *   910.08884    ,  935.74208    ,  962.32531    ,  989.86605    ,
     *   1018.3926    ,
     *   824.03292    ,  845.95168    ,  868.70422    ,  892.31517    ,
     *   916.80990    ,  942.21450    ,  968.55578    ,  995.86129    ,
     *   1024.1593    /
        DATA ((SOSV  (J,K),J=46,54),K=10,18) /
     *   831.79594    ,  853.44352    ,  875.93133    ,  899.28391    ,
     *   923.52660    ,  948.68549    ,  974.78742    ,  1001.8600    ,
     *   1029.9315    ,
     *   839.53679    ,  860.91744    ,  883.14449    ,  906.24238    ,
     *   930.23641    ,  955.15265    ,  981.01797    ,  1007.8600    ,
     *   1035.7071    ,
     *   847.25281    ,  868.37084    ,  890.34119    ,  913.18817    ,
     *   936.93701    ,  961.61377    ,  987.24533    ,  1013.8593    ,
     *   1041.4842    ,
     *   854.94162    ,  875.80139    ,  897.51916    ,  920.11908    ,
     *   943.62629    ,  968.06682    ,  993.46756    ,  1019.8562    ,
     *   1047.2613    ,
     *   862.60107    ,  883.20699    ,  904.67633    ,  927.03308    ,
     *   950.30228    ,  974.50992    ,  999.68288    ,  1025.8489    ,
     *   1053.0365    ,
     *   870.22926    ,  890.58575    ,  911.81085    ,  933.92837    ,
     *   956.96322    ,  980.94134    ,  1005.8896    ,  1031.8358    ,
     *   1058.8086    ,
     *   877.82449    ,  897.93597    ,  918.92104    ,  940.80327    ,
     *   963.60748    ,  987.35951    ,  1012.0863    ,  1037.8155    ,
     *   1064.5760    ,
     *   885.38524    ,  905.25615    ,  926.00538    ,  947.65631    ,
     *   970.23358    ,  993.76299    ,  1018.2714    ,  1043.7866    ,
     *   1070.3374    ,
     *   892.91018    ,  912.54493    ,  933.06253    ,  954.48611    ,
     *   976.84018    ,  1000.1504    ,  1024.4437    ,  1049.7478    ,
     *   1076.0917    /
        DATA ((SOSV  (J,K),J=46,54),K=19,27) /
     *   900.39814    ,  919.80113    ,  940.09128    ,  961.29148    ,
     *   983.42606    ,  1006.5206    ,  1030.6020    ,  1055.6981    ,
     *   1081.8376    ,
     *   907.84810    ,  927.02370    ,  947.09055    ,  968.07130    ,
     *   989.99011    ,  1012.8725    ,  1036.7452    ,  1061.6362    ,
     *   1087.5742    ,
     *   915.25918    ,  934.21172    ,  954.05938    ,  974.82460    ,
     *   996.53134    ,  1019.2050    ,  1042.8723    ,  1067.5612    ,
     *   1093.3005    ,
     *   922.63062    ,  941.36437    ,  960.99694    ,  981.55051    ,
     *   1003.0489    ,  1025.5173    ,  1048.9824    ,  1073.4722    ,
     *   1099.0156    ,
     *   929.96178    ,  948.48097    ,  967.90249    ,  988.24824    ,
     *   1009.5418    ,  1031.8084    ,  1055.0747    ,  1079.3684    ,
     *   1104.7186    ,
     *   937.25210    ,  955.56092    ,  974.77537    ,  994.91711    ,
     *   1016.0096    ,  1038.0778    ,  1061.1483    ,  1085.2489    ,
     *   1110.4087    ,
     *   944.50115    ,  962.60372    ,  981.61504    ,  1001.5565    ,
     *   1022.4514    ,  1044.3246    ,  1067.2025    ,  1091.1131    ,
     *   1116.0853    ,
     *   951.70856    ,  969.60893    ,  988.42100    ,  1008.1659    ,
     *   1028.8667    ,  1050.5482    ,  1073.2368    ,  1096.9602    ,
     *   1121.7477    ,
     *   958.87405    ,  976.57622    ,  995.19286    ,  1014.7449    ,
     *   1035.2551    ,  1056.7483    ,  1079.2506    ,  1102.7898    ,
     *   1127.3953    /
        DATA ((SOSV  (J,K),J=46,54),K=28,36) /
     *   965.99740    ,  983.50531    ,  1001.9303    ,  1021.2930    ,
     *   1041.6161    ,  1062.9241    ,  1085.2433    ,  1108.6013    ,
     *   1133.0274    ,
     *   973.07848    ,  990.39597    ,  1008.6330    ,  1027.8099    ,
     *   1047.9492    ,  1069.0754    ,  1091.2144    ,  1114.3941    ,
     *   1138.6436    ,
     *   980.11718    ,  997.24805    ,  1015.3007    ,  1034.2953    ,
     *   1054.2542    ,  1075.2017    ,  1097.1636    ,  1120.1678    ,
     *   1144.2435    ,
     *   987.11347    ,  1004.0614    ,  1021.9333    ,  1040.7490    ,
     *   1060.5308    ,  1081.3027    ,  1103.0905    ,  1125.9221    ,
     *   1149.8265    ,
     *   994.06737    ,  1010.8361    ,  1028.5307    ,  1047.1709    ,
     *   1066.7787    ,  1087.3780    ,  1108.9948    ,  1131.6565    ,
     *   1155.3923    ,
     *   1000.9789    ,  1017.5720    ,  1035.0927    ,  1053.5607    ,
     *   1072.9977    ,  1093.4276    ,  1114.8761    ,  1137.3706    ,
     *   1160.9406    ,
     *   1007.8482    ,  1024.2691    ,  1041.6193    ,  1059.9183    ,
     *   1079.1877    ,  1099.4511    ,  1120.7341    ,  1143.0643    ,
     *   1166.4709    ,
     *   1014.6754    ,  1030.9275    ,  1048.1106    ,  1066.2437    ,
     *   1085.3485    ,  1105.4483    ,  1126.5688    ,  1148.7373    ,
     *   1171.9830    ,
     *   1021.4605    ,  1037.5474    ,  1054.5664    ,  1072.5369    ,
     *   1091.4800    ,  1111.4191    ,  1132.3798    ,  1154.3892    ,
     *   1177.4767    /
        DATA ((SOSV  (J,K),J=46,54),K=37,45) /
     *   1028.2039    ,  1044.1287    ,  1060.9870    ,  1078.7978    ,
     *   1097.5822    ,  1117.3635    ,  1138.1670    ,  1160.0200    ,
     *   1182.9516    ,
     *   1034.9058    ,  1050.6717    ,  1067.3723    ,  1085.0264    ,
     *   1103.6550    ,  1123.2812    ,  1143.9302    ,  1165.6293    ,
     *   1188.4076    ,
     *   1041.5662    ,  1057.1765    ,  1073.7225    ,  1091.2228    ,
     *   1109.6984    ,  1129.1722    ,  1149.6694    ,  1171.2172    ,
     *   1193.8445    ,
     *   1048.1856    ,  1063.6433    ,  1080.0376    ,  1097.3871    ,
     *   1115.7124    ,  1135.0365    ,  1155.3845    ,  1176.7833    ,
     *   1199.2621    ,
     *   1054.7641    ,  1070.0723    ,  1086.3178    ,  1103.5192    ,
     *   1121.6970    ,  1140.8741    ,  1161.0753    ,  1182.3277    ,
     *   1204.6602    ,
     *   1061.3021    ,  1076.4637    ,  1092.5633    ,  1109.6194    ,
     *   1127.6524    ,  1146.6849    ,  1166.7419    ,  1187.8502    ,
     *   1210.0388    ,
     *   1067.7999    ,  1082.8178    ,  1098.7743    ,  1115.6877    ,
     *   1133.5784    ,  1152.4690    ,  1172.3841    ,  1193.3507    ,
     *   1215.3976    ,
     *   1074.2577    ,  1089.1347    ,  1104.9509    ,  1121.7243    ,
     *   1139.4753    ,  1158.2263    ,  1178.0021    ,  1198.8293    ,
     *   1220.7367    ,
     *   1080.6759    ,  1095.4148    ,  1111.0933    ,  1127.7293    ,
     *   1145.3431    ,  1163.9570    ,  1183.5957    ,  1204.2857    ,
     *   1226.0560    /
        DATA ((SOSV  (J,K),J=46,54),K=46,54) /
     *   1087.0548    ,  1101.6584    ,  1117.2017    ,  1133.7029    ,
     *   1151.1819    ,  1169.6611    ,  1189.1650    ,  1209.7202    ,
     *   1231.3553    ,
     *   1093.3948    ,  1107.8656    ,  1123.2765    ,  1139.6452    ,
     *   1156.9919    ,  1175.3387    ,  1194.7100    ,  1215.1325    ,
     *   1236.6346    ,
     *   1099.6961    ,  1114.0369    ,  1129.3177    ,  1145.5564    ,
     *   1162.7731    ,  1180.9898    ,  1200.2308    ,  1220.5227    ,
     *   1241.8940    ,
     *   1105.9592    ,  1120.1724    ,  1135.3256    ,  1151.4367    ,
     *   1168.5257    ,  1186.6145    ,  1205.7274    ,  1225.8908    ,
     *   1247.1333    ,
     *   1112.1844    ,  1126.2725    ,  1141.3005    ,  1157.2863    ,
     *   1174.2498    ,  1192.2130    ,  1211.1999    ,  1231.2369    ,
     *   1252.3525    ,
     *   1118.3720    ,  1132.3375    ,  1147.2426    ,  1163.1054    ,
     *   1179.9457    ,  1197.7853    ,  1216.6483    ,  1236.5609    ,
     *   1257.5517    ,
     *   1124.5225    ,  1138.3676    ,  1153.1523    ,  1168.8943    ,
     *   1185.6134    ,  1203.3316    ,  1222.0727    ,  1241.8630    ,
     *   1262.7308    ,
     *   1130.6361    ,  1144.3633    ,  1159.0296    ,  1174.6530    ,
     *   1191.2532    ,  1208.8519    ,  1227.4732    ,  1247.1431    ,
     *   1267.8899    ,
     *   1136.7133    ,  1150.3248    ,  1164.8750    ,  1180.3819    ,
     *   1196.8652    ,  1214.3466    ,  1232.8499    ,  1252.4013    ,
     *   1273.0289    /
        DATA ((SOSV  (J,K),J=46,54),K=55,63) /
     *   1142.7544    ,  1156.2524    ,  1170.6886    ,  1186.0811    ,
     *   1202.4495    ,  1219.8155    ,  1238.2029    ,  1257.6377    ,
     *   1278.1480    ,
     *   1148.7598    ,  1162.1464    ,  1176.4708    ,  1191.7509    ,
     *   1208.0065    ,  1225.2590    ,  1243.5323    ,  1262.8524    ,
     *   1283.2472    ,
     *   1154.7298    ,  1168.0072    ,  1182.2218    ,  1197.3916    ,
     *   1213.5362    ,  1230.6772    ,  1248.8383    ,  1268.0453    ,
     *   1288.3264    ,
     *   1160.6648    ,  1173.8351    ,  1187.9419    ,  1203.0033    ,
     *   1219.0388    ,  1236.0701    ,  1254.1208    ,  1273.2167    ,
     *   1293.3858    ,
     *   1166.5652    ,  1179.6304    ,  1193.6314    ,  1208.5863    ,
     *   1224.5146    ,  1241.4381    ,  1259.3802    ,  1278.3666    ,
     *   1298.4254    ,
     *   1172.4313    ,  1185.3934    ,  1199.2905    ,  1214.1408    ,
     *   1229.9638    ,  1246.7812    ,  1264.6164    ,  1283.4951    ,
     *   1303.4453    ,
     *   1178.2635    ,  1191.1245    ,  1204.9196    ,  1219.6670    ,
     *   1235.3865    ,  1252.0995    ,  1269.8296    ,  1288.6023    ,
     *   1308.4455    ,
     *   1184.0622    ,  1196.8239    ,  1210.5188    ,  1225.1653    ,
     *   1240.7830    ,  1257.3934    ,  1275.0200    ,  1293.6883    ,
     *   1313.4262    ,
     *   1189.8277    ,  1202.4920    ,  1216.0886    ,  1230.6358    ,
     *   1246.1534    ,  1262.6629    ,  1280.1877    ,  1298.7532    ,
     *   1318.3873    /
        DATA ((SOSV  (J,K),J=46,54),K=64,72) /
     *   1195.5604    ,  1208.1291    ,  1221.6290    ,  1236.0787    ,
     *   1251.4980    ,  1267.9082    ,  1285.3327    ,  1303.7971    ,
     *   1323.3290    ,
     *   1201.2606    ,  1213.7354    ,  1227.1405    ,  1241.4944    ,
     *   1256.8169    ,  1273.1295    ,  1290.4554    ,  1308.8202    ,
     *   1328.2513    ,
     *   1206.9287    ,  1219.3114    ,  1232.6234    ,  1246.8831    ,
     *   1262.1104    ,  1278.3269    ,  1295.5558    ,  1313.8224    ,
     *   1333.1544    ,
     *   1212.5651    ,  1224.8574    ,  1238.0778    ,  1252.2449    ,
     *   1267.3787    ,  1283.5007    ,  1300.6340    ,  1318.8041    ,
     *   1338.0383    ,
     *   1218.1700    ,  1230.3735    ,  1243.5040    ,  1257.5802    ,
     *   1272.6220    ,  1288.6510    ,  1305.6902    ,  1323.7652    ,
     *   1342.9032    ,
     *   1223.7438    ,  1235.8603    ,  1248.9024    ,  1262.8892    ,
     *   1277.8405    ,  1293.7779    ,  1310.7246    ,  1328.7059    ,
     *   1347.7490    ,
     *   1229.2869    ,  1241.3178    ,  1254.2732    ,  1268.1721    ,
     *   1283.0344    ,  1298.8818    ,  1315.7373    ,  1333.6263    ,
     *   1352.5760    ,
     *   1234.7996    ,  1246.7465    ,  1259.6167    ,  1273.4291    ,
     *   1288.2040    ,  1303.9627    ,  1320.7285    ,  1338.5266    ,
     *   1357.3842    ,
     *   1240.2823    ,  1252.1467    ,  1264.9331    ,  1278.6606    ,
     *   1293.3493    ,  1309.0208    ,  1325.6983    ,  1343.4069    ,
     *   1362.1738    /
        DATA ((SOSV  (J,K),J=46,54),K=73,81) /
     *   1245.7352    ,  1257.5186    ,  1270.2227    ,  1283.8666    ,
     *   1298.4707    ,  1314.0563    ,  1330.6468    ,  1348.2672    ,
     *   1366.9447    ,
     *   1251.1587    ,  1262.8625    ,  1275.4857    ,  1289.0476    ,
     *   1303.5683    ,  1319.0695    ,  1335.5743    ,  1353.1078    ,
     *   1371.6972    ,
     *   1256.5531    ,  1268.1788    ,  1280.7225    ,  1294.2036    ,
     *   1308.6423    ,  1324.0604    ,  1340.4808    ,  1357.9288    ,
     *   1376.4313    ,
     *   1261.9187    ,  1273.4677    ,  1285.9333    ,  1299.3349    ,
     *   1313.6930    ,  1329.0292    ,  1345.3666    ,  1362.7303    ,
     *   1381.1472    ,
     *   1267.2559    ,  1278.7295    ,  1291.1183    ,  1304.4418    ,
     *   1318.7206    ,  1333.9762    ,  1350.2318    ,  1367.5123    ,
     *   1385.8449    ,
     *   1272.5649    ,  1283.9645    ,  1296.2778    ,  1309.5245    ,
     *   1323.7252    ,  1338.9014    ,  1355.0765    ,  1372.2752    ,
     *   1390.5246    ,
     *   1277.8461    ,  1289.1729    ,  1301.4121    ,  1314.5832    ,
     *   1328.7070    ,  1343.8052    ,  1359.9008    ,  1377.0189    ,
     *   1395.1864    ,
     *   1283.0997    ,  1294.3551    ,  1306.5213    ,  1319.6182    ,
     *   1333.6664    ,  1348.6876    ,  1364.7051    ,  1381.7437    ,
     *   1399.8303    ,
     *   1288.3262    ,  1299.5113    ,  1311.6058    ,  1324.6296    ,
     *   1338.6033    ,  1353.5488    ,  1369.4893    ,  1386.4496    ,
     *   1404.4566    /
        DATA ((SOSV  (J,K),J=55,63),K= 1, 9) /
     *   1009.4953    ,  1041.6087    ,  1074.7436    ,  1108.9327    ,
     *   1144.2093    ,  1180.6081    ,  1218.1649    ,  1256.9163    ,
     *   1296.9005    ,
     *   1014.9294    ,  1046.8238    ,  1079.7481    ,  1113.7345    ,
     *   1148.8164    ,  1185.0281    ,  1222.4052    ,  1260.9842    ,
     *   1300.8028    ,
     *   1020.3869    ,  1052.0621    ,  1084.7754    ,  1118.5587    ,
     *   1153.4453    ,  1189.4692    ,  1226.6659    ,  1265.0716    ,
     *   1304.7239    ,
     *   1025.8650    ,  1057.3212    ,  1089.8233    ,  1123.4034    ,
     *   1158.0942    ,  1193.9299    ,  1230.9456    ,  1269.1773    ,
     *   1308.6625    ,
     *   1031.3612    ,  1062.5987    ,  1094.8899    ,  1128.2666    ,
     *   1162.7616    ,  1198.4087    ,  1235.2429    ,  1273.3002    ,
     *   1312.6178    ,
     *   1036.8729    ,  1067.8924    ,  1099.9730    ,  1133.1466    ,
     *   1167.4457    ,  1202.9042    ,  1239.5567    ,  1277.4393    ,
     *   1316.5888    ,
     *   1042.3979    ,  1073.2002    ,  1105.0709    ,  1138.0417    ,
     *   1172.1452    ,  1207.4150    ,  1243.8858    ,  1281.5934    ,
     *   1320.5745    ,
     *   1047.9340    ,  1078.5200    ,  1110.1816    ,  1142.9502    ,
     *   1176.8584    ,  1211.9398    ,  1248.2289    ,  1285.7614    ,
     *   1324.5740    ,
     *   1053.4790    ,  1083.8501    ,  1115.3035    ,  1147.8706    ,
     *   1181.5841    ,  1216.4774    ,  1252.5850    ,  1289.9425    ,
     *   1328.5864    /
        DATA ((SOSV  (J,K),J=55,63),K=10,18) /
     *   1059.0311    ,  1089.1886    ,  1120.4349    ,  1152.8015    ,
     *   1186.3210    ,  1221.0266    ,  1256.9530    ,  1294.1356    ,
     *   1332.6110    ,
     *   1064.5884    ,  1094.5339    ,  1125.5744    ,  1157.7415    ,
     *   1191.0676    ,  1225.5863    ,  1261.3319    ,  1298.3399    ,
     *   1336.6467    ,
     *   1070.1493    ,  1099.8844    ,  1130.7204    ,  1162.6891    ,
     *   1195.8229    ,  1230.1553    ,  1265.7206    ,  1302.5544    ,
     *   1340.6929    ,
     *   1075.7120    ,  1105.2385    ,  1135.8717    ,  1167.6432    ,
     *   1200.5856    ,  1234.7325    ,  1270.1182    ,  1306.7782    ,
     *   1344.7488    ,
     *   1081.2752    ,  1110.5949    ,  1141.0268    ,  1172.6025    ,
     *   1205.3548    ,  1239.3171    ,  1274.5239    ,  1311.0106    ,
     *   1348.8137    ,
     *   1086.8373    ,  1115.9523    ,  1146.1845    ,  1177.5659    ,
     *   1210.1292    ,  1243.9079    ,  1278.9366    ,  1315.2508    ,
     *   1352.8867    ,
     *   1092.3971    ,  1121.3093    ,  1151.3437    ,  1182.5323    ,
     *   1214.9079    ,  1248.5042    ,  1283.3557    ,  1319.4979    ,
     *   1356.9673    ,
     *   1097.9533    ,  1126.6649    ,  1156.5034    ,  1187.5008    ,
     *   1219.6900    ,  1253.1050    ,  1287.7802    ,  1323.7513    ,
     *   1361.0548    ,
     *   1103.5048    ,  1132.0179    ,  1161.6623    ,  1192.4702    ,
     *   1224.4746    ,  1257.7094    ,  1292.2094    ,  1328.0102    ,
     *   1365.1484    /
        DATA ((SOSV  (J,K),J=55,63),K=19,27) /
     *   1109.0505    ,  1137.3673    ,  1166.8196    ,  1197.4397    ,
     *   1229.2607    ,  1262.3168    ,  1296.6426    ,  1332.2740    ,
     *   1369.2477    ,
     *   1114.5893    ,  1142.7121    ,  1171.9743    ,  1202.4084    ,
     *   1234.0477    ,  1266.9262    ,  1301.0791    ,  1336.5420    ,
     *   1373.3519    ,
     *   1120.1203    ,  1148.0514    ,  1177.1256    ,  1207.3755    ,
     *   1238.8345    ,  1271.5370    ,  1305.5181    ,  1340.8136    ,
     *   1377.4606    ,
     *   1125.6426    ,  1153.3843    ,  1182.2726    ,  1212.3402    ,
     *   1243.6207    ,  1276.1485    ,  1309.9590    ,  1345.0882    ,
     *   1381.5731    ,
     *   1131.1555    ,  1158.7101    ,  1187.4146    ,  1217.3017    ,
     *   1248.4053    ,  1280.7600    ,  1314.4012    ,  1349.3651    ,
     *   1385.6889    ,
     *   1136.6580    ,  1164.0280    ,  1192.5507    ,  1222.2594    ,
     *   1253.1879    ,  1285.3709    ,  1318.8441    ,  1353.6439    ,
     *   1389.8076    ,
     *   1142.1496    ,  1169.3372    ,  1197.6805    ,  1227.2126    ,
     *   1257.9676    ,  1289.9806    ,  1323.2872    ,  1357.9240    ,
     *   1393.9285    ,
     *   1147.6296    ,  1174.6372    ,  1202.8031    ,  1232.1606    ,
     *   1262.7440    ,  1294.5884    ,  1327.7298    ,  1362.2049    ,
     *   1398.0513    ,
     *   1153.0972    ,  1179.9273    ,  1207.9180    ,  1237.1029    ,
     *   1267.5165    ,  1299.1939    ,  1332.1715    ,  1366.4861    ,
     *   1402.1755    /
        DATA ((SOSV  (J,K),J=55,63),K=28,36) /
     *   1158.5521    ,  1185.2069    ,  1213.0246    ,  1242.0389    ,
     *   1272.2844    ,  1303.7966    ,  1336.6118    ,  1370.7671    ,
     *   1406.3005    ,
     *   1163.9935    ,  1190.4755    ,  1218.1224    ,  1246.9681    ,
     *   1277.0473    ,  1308.3959    ,  1341.0501    ,  1375.0475    ,
     *   1410.4261    ,
     *   1169.4211    ,  1195.7326    ,  1223.2109    ,  1251.8900    ,
     *   1281.8048    ,  1312.9913    ,  1345.4861    ,  1379.3268    ,
     *   1414.5518    ,
     *   1174.8344    ,  1200.9778    ,  1228.2896    ,  1256.8040    ,
     *   1286.5563    ,  1317.5824    ,  1349.9193    ,  1383.6047    ,
     *   1418.6771    ,
     *   1180.2330    ,  1206.2105    ,  1233.3580    ,  1261.7099    ,
     *   1291.3014    ,  1322.1688    ,  1354.3493    ,  1387.8807    ,
     *   1422.8018    ,
     *   1185.6165    ,  1211.4305    ,  1238.4159    ,  1266.6071    ,
     *   1296.0398    ,  1326.7501    ,  1358.7756    ,  1392.1544    ,
     *   1426.9254    ,
     *   1190.9845    ,  1216.6373    ,  1243.4627    ,  1271.4954    ,
     *   1300.7709    ,  1331.3259    ,  1363.1980    ,  1396.4255    ,
     *   1431.0477    ,
     *   1196.3367    ,  1221.8306    ,  1248.4982    ,  1276.3742    ,
     *   1305.4945    ,  1335.8959    ,  1367.6161    ,  1400.6937    ,
     *   1435.1682    ,
     *   1201.6728    ,  1227.0100    ,  1253.5219    ,  1281.2433    ,
     *   1310.2102    ,  1340.4596    ,  1372.0294    ,  1404.9586    ,
     *   1439.2866    /
        DATA ((SOSV  (J,K),J=55,63),K=37,45) /
     *   1206.9926    ,  1232.1754    ,  1258.5336    ,  1286.1023    ,
     *   1314.9176    ,  1345.0167    ,  1376.4378    ,  1409.2198    ,
     *   1443.4027    ,
     *   1212.2958    ,  1237.3264    ,  1263.5330    ,  1290.9510    ,
     *   1319.6166    ,  1349.5670    ,  1380.8408    ,  1413.4772    ,
     *   1447.5161    ,
     *   1217.5822    ,  1242.4627    ,  1268.5199    ,  1295.7891    ,
     *   1324.3067    ,  1354.1102    ,  1385.2383    ,  1417.7303    ,
     *   1451.6266    ,
     *   1222.8515    ,  1247.5841    ,  1273.4939    ,  1300.6162    ,
     *   1328.9877    ,  1358.6459    ,  1389.6298    ,  1421.9789    ,
     *   1455.7339    ,
     *   1228.1036    ,  1252.6905    ,  1278.4549    ,  1305.4322    ,
     *   1333.6593    ,  1363.1740    ,  1394.0152    ,  1426.2228    ,
     *   1459.8377    ,
     *   1233.3384    ,  1257.7817    ,  1283.4026    ,  1310.2369    ,
     *   1338.3213    ,  1367.6940    ,  1398.3941    ,  1430.4617    ,
     *   1463.9378    ,
     *   1238.5557    ,  1262.8574    ,  1288.3369    ,  1315.0300    ,
     *   1342.9736    ,  1372.2060    ,  1402.7664    ,  1434.6954    ,
     *   1468.0339    ,
     *   1243.7553    ,  1267.9175    ,  1293.2575    ,  1319.8113    ,
     *   1347.6158    ,  1376.7095    ,  1407.1319    ,  1438.9235    ,
     *   1472.1259    ,
     *   1248.9372    ,  1272.9619    ,  1298.1644    ,  1324.5806    ,
     *   1352.2477    ,  1381.2044    ,  1411.4902    ,  1443.1460    ,
     *   1476.2134    /
        DATA ((SOSV  (J,K),J=55,63),K=46,54) /
     *   1254.1012    ,  1277.9904    ,  1303.0573    ,  1329.3378    ,
     *   1356.8693    ,  1385.6905    ,  1415.8412    ,  1447.3625    ,
     *   1480.2963    ,
     *   1259.2473    ,  1283.0030    ,  1307.9361    ,  1334.0827    ,
     *   1361.4802    ,  1390.1676    ,  1420.1848    ,  1451.5730    ,
     *   1484.3743    ,
     *   1264.3754    ,  1287.9994    ,  1312.8007    ,  1338.8151    ,
     *   1366.0804    ,  1394.6355    ,  1424.5206    ,  1455.7772    ,
     *   1488.4474    ,
     *   1269.4854    ,  1292.9798    ,  1317.6510    ,  1343.5350    ,
     *   1370.6697    ,  1399.0941    ,  1428.8486    ,  1459.9748    ,
     *   1492.5152    ,
     *   1274.5773    ,  1297.9439    ,  1322.4868    ,  1348.2422    ,
     *   1375.2479    ,  1403.5432    ,  1433.1686    ,  1464.1659    ,
     *   1496.5777    ,
     *   1279.6511    ,  1302.8917    ,  1327.3081    ,  1352.9366    ,
     *   1379.8150    ,  1407.9827    ,  1437.4804    ,  1468.3501    ,
     *   1500.6346    ,
     *   1284.7067    ,  1307.8232    ,  1332.1149    ,  1357.6181    ,
     *   1384.3708    ,  1412.4124    ,  1441.7839    ,  1472.5273    ,
     *   1504.6858    ,
     *   1289.7441    ,  1312.7383    ,  1336.9070    ,  1362.2866    ,
     *   1388.9151    ,  1416.8322    ,  1446.0789    ,  1476.6974    ,
     *   1508.7312    ,
     *   1294.7633    ,  1317.6369    ,  1341.6843    ,  1366.9420    ,
     *   1393.4480    ,  1421.2421    ,  1450.3654    ,  1480.8603    ,
     *   1512.7705    /
        DATA ((SOSV  (J,K),J=55,63),K=55,63) /
     *   1299.7643    ,  1322.5191    ,  1346.4469    ,  1371.5842    ,
     *   1397.9692    ,  1425.6417    ,  1454.6431    ,  1485.0158    ,
     *   1516.8037    ,
     *   1304.7472    ,  1327.3848    ,  1351.1947    ,  1376.2133    ,
     *   1402.4788    ,  1430.0312    ,  1458.9120    ,  1489.1638    ,
     *   1520.8306    ,
     *   1309.7118    ,  1332.2340    ,  1355.9276    ,  1380.8290    ,
     *   1406.9766    ,  1434.4104    ,  1463.1719    ,  1493.3041    ,
     *   1524.8511    ,
     *   1314.6584    ,  1337.0668    ,  1360.6456    ,  1385.4314    ,
     *   1411.4625    ,  1438.7791    ,  1467.4228    ,  1497.4367    ,
     *   1528.8651    ,
     *   1319.5867    ,  1341.8830    ,  1365.3487    ,  1390.0204    ,
     *   1415.9366    ,  1443.1374    ,  1471.6646    ,  1501.5615    ,
     *   1532.8725    ,
     *   1324.4971    ,  1346.6827    ,  1370.0369    ,  1394.5960    ,
     *   1420.3987    ,  1447.4851    ,  1475.8972    ,  1505.6783    ,
     *   1536.8731    ,
     *   1329.3893    ,  1351.4660    ,  1374.7101    ,  1399.1581    ,
     *   1424.8487    ,  1451.8221    ,  1480.1204    ,  1509.7870    ,
     *   1540.8668    ,
     *   1334.2636    ,  1356.2328    ,  1379.3683    ,  1403.7068    ,
     *   1429.2867    ,  1456.1485    ,  1484.3343    ,  1513.8877    ,
     *   1544.8536    ,
     *   1339.1199    ,  1360.9832    ,  1384.0117    ,  1408.2419    ,
     *   1433.7126    ,  1460.4641    ,  1488.5387    ,  1517.9801    ,
     *   1548.8334    /
        DATA ((SOSV  (J,K),J=55,63),K=64,72) /
     *   1343.9582    ,  1365.7171    ,  1388.6400    ,  1412.7636    ,
     *   1438.1264    ,  1464.7690    ,  1492.7336    ,  1522.0642    ,
     *   1552.8060    ,
     *   1348.7788    ,  1370.4347    ,  1393.2535    ,  1417.2717    ,
     *   1442.5280    ,  1469.0629    ,  1496.9189    ,  1526.1399    ,
     *   1556.7714    ,
     *   1353.5816    ,  1375.1360    ,  1397.8520    ,  1421.7662    ,
     *   1446.9174    ,  1473.3460    ,  1501.0946    ,  1530.2072    ,
     *   1560.7295    ,
     *   1358.3666    ,  1379.8209    ,  1402.4356    ,  1426.2473    ,
     *   1451.2945    ,  1477.6181    ,  1505.2606    ,  1534.2660    ,
     *   1564.6803    ,
     *   1363.1340    ,  1384.4896    ,  1407.0043    ,  1430.7147    ,
     *   1455.6595    ,  1481.8793    ,  1509.4168    ,  1538.3163    ,
     *   1568.6236    ,
     *   1367.8838    ,  1389.1421    ,  1411.5582    ,  1435.1687    ,
     *   1460.0122    ,  1486.1295    ,  1513.5633    ,  1542.3579    ,
     *   1572.5594    ,
     *   1372.6161    ,  1393.7784    ,  1416.0973    ,  1439.6091    ,
     *   1464.3526    ,  1490.3686    ,  1517.6999    ,  1546.3908    ,
     *   1576.4876    ,
     *   1377.3310    ,  1398.3987    ,  1420.6215    ,  1444.0360    ,
     *   1468.6808    ,  1494.5968    ,  1521.8267    ,  1550.4151    ,
     *   1580.4082    ,
     *   1382.0285    ,  1403.0029    ,  1425.1310    ,  1448.4494    ,
     *   1472.9967    ,  1498.8138    ,  1525.9435    ,  1554.4305    ,
     *   1584.3212    /
        DATA ((SOSV  (J,K),J=55,63),K=73,81) /
     *   1386.7087    ,  1407.5911    ,  1429.6258    ,  1452.8493    ,
     *   1477.3004    ,  1503.0198    ,  1530.0505    ,  1558.4372    ,
     *   1588.2264    ,
     *   1391.3718    ,  1412.1633    ,  1434.1059    ,  1457.2358    ,
     *   1481.5918    ,  1507.2147    ,  1534.1475    ,  1562.4350    ,
     *   1592.1238    ,
     *   1396.0178    ,  1416.7198    ,  1438.5713    ,  1461.6088    ,
     *   1485.8709    ,  1511.3985    ,  1538.2346    ,  1566.4240    ,
     *   1596.0134    ,
     *   1400.6467    ,  1421.2604    ,  1443.0222    ,  1465.9685    ,
     *   1490.1379    ,  1515.5712    ,  1542.3116    ,  1570.4040    ,
     *   1599.8951    ,
     *   1405.2587    ,  1425.7853    ,  1447.4585    ,  1470.3147    ,
     *   1494.3926    ,  1519.7329    ,  1546.3787    ,  1574.3751    ,
     *   1603.7689    ,
     *   1409.8539    ,  1430.2945    ,  1451.8804    ,  1474.6477    ,
     *   1498.6350    ,  1523.8834    ,  1550.4357    ,  1578.3372    ,
     *   1607.6348    ,
     *   1414.4323    ,  1434.7882    ,  1456.2878    ,  1478.9673    ,
     *   1502.8653    ,  1528.0228    ,  1554.4828    ,  1582.2904    ,
     *   1611.4926    ,
     *   1418.9941    ,  1439.2663    ,  1460.6808    ,  1483.2736    ,
     *   1507.0835    ,  1532.1511    ,  1558.5198    ,  1586.2345    ,
     *   1615.3425    ,
     *   1423.5393    ,  1443.7290    ,  1465.0595    ,  1487.5668    ,
     *   1511.2894    ,  1536.2684    ,  1562.5467    ,  1590.1696    ,
     *   1619.1844    /
        DATA ((SOSV  (J,K),J=64,72),K= 1, 9) /
     *   1338.1566    ,  1380.7252    ,  1424.6479    ,  1469.9679    ,
     *   1516.7295    ,  1564.9787    ,  1614.7628    ,  1666.1306    ,
     *   1719.1324    ,
     *   1341.9002    ,  1384.3164    ,  1428.0931    ,  1473.2731    ,
     *   1519.9005    ,  1568.0211    ,  1617.6819    ,  1668.9316    ,
     *   1721.8204    ,
     *   1345.6615    ,  1387.9246    ,  1431.5543    ,  1476.5934    ,
     *   1523.0858    ,  1571.0769    ,  1620.6137    ,  1671.7445    ,
     *   1724.5194    ,
     *   1349.4398    ,  1391.5489    ,  1435.0309    ,  1479.9283    ,
     *   1526.2848    ,  1574.1458    ,  1623.5577    ,  1674.5690    ,
     *   1727.2293    ,
     *   1353.2341    ,  1395.1886    ,  1438.5222    ,  1483.2772    ,
     *   1529.4972    ,  1577.2272    ,  1626.5137    ,  1677.4047    ,
     *   1729.9497    ,
     *   1357.0435    ,  1398.8428    ,  1442.0275    ,  1486.6395    ,
     *   1532.7223    ,  1580.3208    ,  1629.4811    ,  1680.2512    ,
     *   1732.6804    ,
     *   1360.8673    ,  1402.5110    ,  1445.5462    ,  1490.0147    ,
     *   1535.9598    ,  1583.4261    ,  1632.4597    ,  1683.1083    ,
     *   1735.4210    ,
     *   1364.7046    ,  1406.1924    ,  1449.0777    ,  1493.4022    ,
     *   1539.2090    ,  1586.5427    ,  1635.4490    ,  1685.9756    ,
     *   1738.1714    ,
     *   1368.5547    ,  1409.8862    ,  1452.6213    ,  1496.8015    ,
     *   1542.4696    ,  1589.6702    ,  1638.4488    ,  1688.8528    ,
     *   1740.9312    /
        DATA ((SOSV  (J,K),J=64,72),K=10,18) /
     *   1372.4167    ,  1413.5919    ,  1456.1765    ,  1500.2120    ,
     *   1545.7412    ,  1592.8082    ,  1641.4586    ,  1691.7397    ,
     *   1743.7001    ,
     *   1376.2901    ,  1417.3087    ,  1459.7427    ,  1503.6333    ,
     *   1549.0231    ,  1595.9563    ,  1644.4782    ,  1694.6359    ,
     *   1746.4780    ,
     *   1380.1739    ,  1421.0361    ,  1463.3193    ,  1507.0648    ,
     *   1552.3151    ,  1599.1141    ,  1647.5072    ,  1697.5412    ,
     *   1749.2644    ,
     *   1384.0677    ,  1424.7734    ,  1466.9058    ,  1510.5061    ,
     *   1555.6166    ,  1602.2813    ,  1650.5452    ,  1700.4551    ,
     *   1752.0593    ,
     *   1387.9706    ,  1428.5200    ,  1470.5017    ,  1513.9567    ,
     *   1558.9274    ,  1605.4574    ,  1653.5919    ,  1703.3775    ,
     *   1754.8623    ,
     *   1391.8821    ,  1432.2754    ,  1474.1064    ,  1517.4161    ,
     *   1562.2468    ,  1608.6422    ,  1656.6471    ,  1706.3081    ,
     *   1757.6733    ,
     *   1395.8015    ,  1436.0389    ,  1477.7194    ,  1520.8840    ,
     *   1565.5747    ,  1611.8352    ,  1659.7104    ,  1709.2466    ,
     *   1760.4918    ,
     *   1399.7282    ,  1439.8101    ,  1481.3403    ,  1524.3598    ,
     *   1568.9105    ,  1615.0361    ,  1662.7814    ,  1712.1927    ,
     *   1763.3178    ,
     *   1403.6616    ,  1443.5884    ,  1484.9686    ,  1527.8431    ,
     *   1572.2539    ,  1618.2447    ,  1665.8600    ,  1715.1462    ,
     *   1766.1510    /
        DATA ((SOSV  (J,K),J=64,72),K=19,27) /
     *   1407.6012    ,  1447.3734    ,  1488.6038    ,  1531.3335    ,
     *   1575.6046    ,  1621.4604    ,  1668.9458    ,  1718.1068    ,
     *   1768.9912    ,
     *   1411.5465    ,  1451.1644    ,  1492.2455    ,  1534.8307    ,
     *   1578.9621    ,  1624.6832    ,  1672.0385    ,  1721.0743    ,
     *   1771.8381    ,
     *   1415.4968    ,  1454.9610    ,  1495.8932    ,  1538.3342    ,
     *   1582.3261    ,  1627.9125    ,  1675.1379    ,  1724.0484    ,
     *   1774.6914    ,
     *   1419.4517    ,  1458.7628    ,  1499.5465    ,  1541.8436    ,
     *   1585.6963    ,  1631.1481    ,  1678.2436    ,  1727.0288    ,
     *   1777.5511    ,
     *   1423.4107    ,  1462.5694    ,  1503.2050    ,  1545.3586    ,
     *   1589.0724    ,  1634.3898    ,  1681.3554    ,  1730.0153    ,
     *   1780.4169    ,
     *   1427.3733    ,  1466.3802    ,  1506.8683    ,  1548.8788    ,
     *   1592.4539    ,  1637.6371    ,  1684.4731    ,  1733.0077    ,
     *   1783.2885    ,
     *   1431.3390    ,  1470.1948    ,  1510.5360    ,  1552.4038    ,
     *   1595.8406    ,  1640.8899    ,  1687.5963    ,  1736.0058    ,
     *   1786.1659    ,
     *   1435.3075    ,  1474.0129    ,  1514.2077    ,  1555.9334    ,
     *   1599.2323    ,  1644.1478    ,  1690.7248    ,  1739.0093    ,
     *   1789.0486    ,
     *   1439.2783    ,  1477.8340    ,  1517.8832    ,  1559.4671    ,
     *   1602.6284    ,  1647.4106    ,  1693.8585    ,  1742.0180    ,
     *   1791.9367    /
        DATA ((SOSV  (J,K),J=64,72),K=28,36) /
     *   1443.2509    ,  1481.6578    ,  1521.5619    ,  1563.0048    ,
     *   1606.0289    ,  1650.6780    ,  1696.9969    ,  1745.0317    ,
     *   1794.8298    ,
     *   1447.2249    ,  1485.4839    ,  1525.2436    ,  1566.5459    ,
     *   1609.4334    ,  1653.9498    ,  1700.1400    ,  1748.0502    ,
     *   1797.7278    ,
     *   1451.2001    ,  1489.3119    ,  1528.9280    ,  1570.0903    ,
     *   1612.8415    ,  1657.2256    ,  1703.2875    ,  1751.0733    ,
     *   1800.6305    ,
     *   1455.1760    ,  1493.1415    ,  1532.6147    ,  1573.6376    ,
     *   1616.2532    ,  1660.5053    ,  1706.4390    ,  1754.1007    ,
     *   1803.5377    ,
     *   1459.1522    ,  1496.9724    ,  1536.3034    ,  1577.1876    ,
     *   1619.6679    ,  1663.7885    ,  1709.5945    ,  1757.1323    ,
     *   1806.4493    ,
     *   1463.1285    ,  1500.8041    ,  1539.9939    ,  1580.7400    ,
     *   1623.0857    ,  1667.0752    ,  1712.7538    ,  1760.1678    ,
     *   1809.3650    ,
     *   1467.1044    ,  1504.6365    ,  1543.6857    ,  1584.2944    ,
     *   1626.5060    ,  1670.3649    ,  1715.9165    ,  1763.2071    ,
     *   1812.2847    ,
     *   1471.0797    ,  1508.4692    ,  1547.3787    ,  1587.8507    ,
     *   1629.9288    ,  1673.6576    ,  1719.0825    ,  1766.2501    ,
     *   1815.2082    ,
     *   1475.0540    ,  1512.3020    ,  1551.0725    ,  1591.4086    ,
     *   1633.3538    ,  1676.9529    ,  1722.2515    ,  1769.2964    ,
     *   1818.1353    /
        DATA ((SOSV  (J,K),J=64,72),K=37,45) /
     *   1479.0271    ,  1516.1344    ,  1554.7670    ,  1594.9678    ,
     *   1636.7807    ,  1680.2507    ,  1725.4235    ,  1772.3459    ,
     *   1821.0659    ,
     *   1482.9986    ,  1519.9663    ,  1558.4617    ,  1598.5280    ,
     *   1640.2094    ,  1683.5508    ,  1728.5982    ,  1775.3985    ,
     *   1823.9999    ,
     *   1486.9684    ,  1523.7975    ,  1562.1566    ,  1602.0892    ,
     *   1643.6396    ,  1686.8529    ,  1731.7754    ,  1778.4540    ,
     *   1826.9370    ,
     *   1490.9361    ,  1527.6276    ,  1565.8513    ,  1605.6509    ,
     *   1647.0710    ,  1690.1569    ,  1734.9549    ,  1781.5122    ,
     *   1829.8771    ,
     *   1494.9014    ,  1531.4563    ,  1569.5456    ,  1609.2131    ,
     *   1650.5036    ,  1693.4626    ,  1738.1365    ,  1784.5729    ,
     *   1832.8201    ,
     *   1498.8642    ,  1535.2836    ,  1573.2393    ,  1612.7754    ,
     *   1653.9370    ,  1696.7697    ,  1741.3202    ,  1787.6360    ,
     *   1835.7658    ,
     *   1502.8242    ,  1539.1091    ,  1576.9321    ,  1616.3377    ,
     *   1657.3711    ,  1700.0781    ,  1744.5056    ,  1790.7013    ,
     *   1838.7140    ,
     *   1506.7812    ,  1542.9326    ,  1580.6239    ,  1619.8998    ,
     *   1660.8057    ,  1703.3876    ,  1747.6927    ,  1793.7687    ,
     *   1841.6647    ,
     *   1510.7349    ,  1546.7539    ,  1584.3145    ,  1623.4615    ,
     *   1664.2406    ,  1706.6981    ,  1750.8812    ,  1796.8381    ,
     *   1844.6177    /
        DATA ((SOSV  (J,K),J=64,72),K=46,54) /
     *   1514.6852    ,  1550.5728    ,  1588.0036    ,  1627.0226    ,
     *   1667.6756    ,  1710.0093    ,  1754.0710    ,  1799.9091    ,
     *   1847.5728    ,
     *   1518.6318    ,  1554.3892    ,  1591.6911    ,  1630.5829    ,
     *   1671.1106    ,  1713.3211    ,  1757.2620    ,  1802.9819    ,
     *   1850.5299    ,
     *   1522.5745    ,  1558.2027    ,  1595.3767    ,  1634.1422    ,
     *   1674.5454    ,  1716.6334    ,  1760.4541    ,  1806.0560    ,
     *   1853.4889    ,
     *   1526.5133    ,  1562.0133    ,  1599.0604    ,  1637.7003    ,
     *   1677.9798    ,  1719.9459    ,  1763.6469    ,  1809.1316    ,
     *   1856.4497    ,
     *   1530.4478    ,  1565.8207    ,  1602.7418    ,  1641.2572    ,
     *   1681.4136    ,  1723.2586    ,  1766.8405    ,  1812.2083    ,
     *   1859.4121    ,
     *   1534.3779    ,  1569.6249    ,  1606.4210    ,  1644.8126    ,
     *   1684.8467    ,  1726.5713    ,  1770.0346    ,  1815.2861    ,
     *   1862.3759    ,
     *   1538.3035    ,  1573.4255    ,  1610.0976    ,  1648.3663    ,
     *   1688.2790    ,  1729.8837    ,  1773.2292    ,  1818.3649    ,
     *   1865.3412    ,
     *   1542.2244    ,  1577.2225    ,  1613.7715    ,  1651.9183    ,
     *   1691.7103    ,  1733.1959    ,  1776.4241    ,  1821.4445    ,
     *   1868.3078    ,
     *   1546.1405    ,  1581.0158    ,  1617.4427    ,  1655.4683    ,
     *   1695.1405    ,  1736.5077    ,  1779.6191    ,  1824.5248    ,
     *   1871.2755    /
        DATA ((SOSV  (J,K),J=64,72),K=55,63) /
     *   1550.0515    ,  1584.8051    ,  1621.1109    ,  1659.0163    ,
     *   1698.5693    ,  1739.8188    ,  1782.8142    ,  1827.6057    ,
     *   1874.2442    ,
     *   1553.9575    ,  1588.5903    ,  1624.7760    ,  1662.5620    ,
     *   1701.9968    ,  1743.1293    ,  1786.0092    ,  1830.6870    ,
     *   1877.2138    ,
     *   1557.8581    ,  1592.3714    ,  1628.4378    ,  1666.1054    ,
     *   1705.4227    ,  1746.4389    ,  1789.2040    ,  1833.7687    ,
     *   1880.1843    ,
     *   1561.7534    ,  1596.1481    ,  1632.0963    ,  1669.6463    ,
     *   1708.8469    ,  1749.7475    ,  1792.3985    ,  1836.8506    ,
     *   1883.1555    ,
     *   1565.6432    ,  1599.9203    ,  1635.7514    ,  1673.1847    ,
     *   1712.2693    ,  1753.0551    ,  1795.5925    ,  1839.9326    ,
     *   1886.1273    ,
     *   1569.5274    ,  1603.6880    ,  1639.4028    ,  1676.7203    ,
     *   1715.6898    ,  1756.3615    ,  1798.7860    ,  1843.0146    ,
     *   1889.0996    ,
     *   1573.4058    ,  1607.4510    ,  1643.0505    ,  1680.2531    ,
     *   1719.1083    ,  1759.6666    ,  1801.9788    ,  1846.0966    ,
     *   1892.0723    ,
     *   1577.2784    ,  1611.2092    ,  1646.6943    ,  1683.7829    ,
     *   1722.5247    ,  1762.9702    ,  1805.1708    ,  1849.1783    ,
     *   1895.0453    ,
     *   1581.1450    ,  1614.9625    ,  1650.3343    ,  1687.3096    ,
     *   1725.9387    ,  1766.2724    ,  1808.3620    ,  1852.2598    ,
     *   1898.0185    /
        DATA ((SOSV  (J,K),J=64,72),K=64,72) /
     *   1585.0056    ,  1618.7108    ,  1653.9701    ,  1690.8332    ,
     *   1729.3505    ,  1769.5729    ,  1811.5522    ,  1855.3408    ,
     *   1900.9918    ,
     *   1588.8601    ,  1622.4540    ,  1657.6018    ,  1694.3536    ,
     *   1732.7597    ,  1772.8716    ,  1814.7413    ,  1858.4214    ,
     *   1903.9652    ,
     *   1592.7084    ,  1626.1920    ,  1661.2293    ,  1697.8705    ,
     *   1736.1664    ,  1776.1686    ,  1817.9293    ,  1861.5014    ,
     *   1906.9385    ,
     *   1596.5504    ,  1629.9247    ,  1664.8525    ,  1701.3840    ,
     *   1739.5705    ,  1779.4636    ,  1821.1160    ,  1864.5807    ,
     *   1909.9117    ,
     *   1600.3860    ,  1633.6520    ,  1668.4712    ,  1704.8940    ,
     *   1742.9717    ,  1782.7566    ,  1824.3013    ,  1867.6593    ,
     *   1912.8846    ,
     *   1604.2152    ,  1637.3739    ,  1672.0854    ,  1708.4003    ,
     *   1746.3702    ,  1786.0475    ,  1827.4852    ,  1870.7370    ,
     *   1915.8572    ,
     *   1608.0378    ,  1641.0903    ,  1675.6950    ,  1711.9028    ,
     *   1749.7657    ,  1789.3362    ,  1830.6676    ,  1873.8138    ,
     *   1918.8294    ,
     *   1611.8539    ,  1644.8011    ,  1679.2999    ,  1715.4016    ,
     *   1753.1582    ,  1792.6226    ,  1833.8484    ,  1876.8896    ,
     *   1921.8011    ,
     *   1615.6633    ,  1648.5062    ,  1682.9001    ,  1718.8965    ,
     *   1756.5476    ,  1795.9067    ,  1837.0274    ,  1879.9643    ,
     *   1924.7723    /
        DATA ((SOSV  (J,K),J=64,72),K=73,81) /
     *   1619.4660    ,  1652.2055    ,  1686.4954    ,  1722.3874    ,
     *   1759.9339    ,  1799.1883    ,  1840.2047    ,  1883.0378    ,
     *   1927.7429    ,
     *   1623.2620    ,  1655.8991    ,  1690.0859    ,  1725.8742    ,
     *   1763.3169    ,  1802.4674    ,  1843.3801    ,  1886.1100    ,
     *   1930.7127    ,
     *   1627.0511    ,  1659.5868    ,  1693.6714    ,  1729.3570    ,
     *   1766.6965    ,  1805.7439    ,  1846.5536    ,  1889.1810    ,
     *   1933.6817    ,
     *   1630.8333    ,  1663.2685    ,  1697.2518    ,  1732.8355    ,
     *   1770.0728    ,  1809.0177    ,  1849.7251    ,  1892.2505    ,
     *   1936.6499    ,
     *   1634.6086    ,  1666.9443    ,  1700.8272    ,  1736.3098    ,
     *   1773.4456    ,  1812.2888    ,  1852.8946    ,  1895.3186    ,
     *   1939.6172    ,
     *   1638.3770    ,  1670.6141    ,  1704.3975    ,  1739.7798    ,
     *   1776.8149    ,  1815.5571    ,  1856.0618    ,  1898.3851    ,
     *   1942.5835    ,
     *   1642.1383    ,  1674.2777    ,  1707.9625    ,  1743.2455    ,
     *   1780.1805    ,  1818.8225    ,  1859.2269    ,  1901.4500    ,
     *   1945.5487    ,
     *   1645.8926    ,  1677.9353    ,  1711.5223    ,  1746.7067    ,
     *   1783.5426    ,  1822.0850    ,  1862.3897    ,  1904.5133    ,
     *   1948.5128    ,
     *   1649.6398    ,  1681.5866    ,  1715.0767    ,  1750.1634    ,
     *   1786.9008    ,  1825.3444    ,  1865.5502    ,  1907.5748    ,
     *   1951.4758    /
        DATA ((SOSV  (J,K),J=73,81),K= 1, 9) /
     *   1773.8204    ,  1830.2480    ,  1888.4706    ,  1948.5454    ,
     *   2010.5313    ,  2074.4890    ,  2140.4812    ,  2208.5728    ,
     *   2278.8305    ,
     *   1776.4000    ,  1832.7238    ,  1890.8471    ,  1950.8267    ,
     *   2012.7214    ,  2076.5918    ,  2142.5005    ,  2210.5120    ,
     *   2280.6930    ,
     *   1778.9899    ,  1835.2093    ,  1893.2325    ,  1953.1163    ,
     *   2014.9193    ,  2078.7019    ,  2144.5264    ,  2212.4574    ,
     *   2282.5613    ,
     *   1781.5901    ,  1837.7043    ,  1895.6269    ,  1955.4143    ,
     *   2017.1249    ,  2080.8191    ,  2146.5590    ,  2214.4090    ,
     *   2284.4353    ,
     *   1784.2001    ,  1840.2086    ,  1898.0299    ,  1957.7203    ,
     *   2019.3381    ,  2082.9434    ,  2148.5982    ,  2216.3667    ,
     *   2286.3149    ,
     *   1786.8198    ,  1842.7219    ,  1900.4414    ,  1960.0343    ,
     *   2021.5587    ,  2085.0746    ,  2150.6438    ,  2218.3303    ,
     *   2288.2002    ,
     *   1789.4488    ,  1845.2441    ,  1902.8612    ,  1962.3561    ,
     *   2023.7866    ,  2087.2126    ,  2152.6958    ,  2220.2999    ,
     *   2290.0909    ,
     *   1792.0871    ,  1847.7750    ,  1905.2891    ,  1964.6855    ,
     *   2026.0216    ,  2089.3573    ,  2154.7540    ,  2222.2753    ,
     *   2291.9870    ,
     *   1794.7342    ,  1850.3142    ,  1907.7250    ,  1967.0223    ,
     *   2028.2637    ,  2091.5085    ,  2156.8183    ,  2224.2565    ,
     *   2293.8885    /
        DATA ((SOSV  (J,K),J=73,81),K=10,18) /
     *   1797.3901    ,  1852.8617    ,  1910.1687    ,  1969.3665    ,
     *   2030.5126    ,  2093.6663    ,  2158.8887    ,  2226.2433    ,
     *   2295.7953    ,
     *   1800.0545    ,  1855.4173    ,  1912.6200    ,  1971.7179    ,
     *   2032.7683    ,  2095.8303    ,  2160.9651    ,  2228.2356    ,
     *   2297.7073    ,
     *   1802.7271    ,  1857.9807    ,  1915.0787    ,  1974.0763    ,
     *   2035.0307    ,  2098.0007    ,  2163.0473    ,  2230.2335    ,
     *   2299.6244    ,
     *   1805.4077    ,  1860.5517    ,  1917.5447    ,  1976.4416    ,
     *   2037.2995    ,  2100.1771    ,  2165.1352    ,  2232.2367    ,
     *   2301.5466    ,
     *   1808.0961    ,  1863.1302    ,  1920.0177    ,  1978.8137    ,
     *   2039.5747    ,  2102.3596    ,  2167.2289    ,  2234.2453    ,
     *   2303.4738    ,
     *   1810.7921    ,  1865.7160    ,  1922.4978    ,  1981.1923    ,
     *   2041.8562    ,  2104.5479    ,  2169.3281    ,  2236.2592    ,
     *   2305.4059    ,
     *   1813.4955    ,  1868.3088    ,  1924.9846    ,  1983.5774    ,
     *   2044.1438    ,  2106.7421    ,  2171.4328    ,  2238.2782    ,
     *   2307.3428    ,
     *   1816.2061    ,  1870.9086    ,  1927.4780    ,  1985.9688    ,
     *   2046.4374    ,  2108.9420    ,  2173.5429    ,  2240.3023    ,
     *   2309.2846    ,
     *   1818.9237    ,  1873.5151    ,  1929.9779    ,  1988.3664    ,
     *   2048.7369    ,  2111.1475    ,  2175.6583    ,  2242.3314    ,
     *   2311.2310    /
        DATA ((SOSV  (J,K),J=73,81),K=19,27) /
     *   1821.6480    ,  1876.1281    ,  1932.4841    ,  1990.7701    ,
     *   2051.0422    ,  2113.3585    ,  2177.7789    ,  2244.3654    ,
     *   2313.1822    ,
     *   1824.3789    ,  1878.7476    ,  1934.9964    ,  1993.1796    ,
     *   2053.3531    ,  2115.5749    ,  2179.9046    ,  2246.4043    ,
     *   2315.1379    ,
     *   1827.1162    ,  1881.3732    ,  1937.5148    ,  1995.5950    ,
     *   2055.6696    ,  2117.7965    ,  2182.0354    ,  2248.4480    ,
     *   2317.0981    ,
     *   1829.8596    ,  1884.0048    ,  1940.0390    ,  1998.0159    ,
     *   2057.9915    ,  2120.0234    ,  2184.1711    ,  2250.4963    ,
     *   2319.0628    ,
     *   1832.6091    ,  1886.6424    ,  1942.5689    ,  2000.4425    ,
     *   2060.3188    ,  2122.2554    ,  2186.3117    ,  2252.5493    ,
     *   2321.0318    ,
     *   1835.3644    ,  1889.2856    ,  1945.1043    ,  2002.8744    ,
     *   2062.6512    ,  2124.4923    ,  2188.4571    ,  2254.6069    ,
     *   2323.0052    ,
     *   1838.1252    ,  1891.9344    ,  1947.6452    ,  2005.3115    ,
     *   2064.9887    ,  2126.7342    ,  2190.6071    ,  2256.6689    ,
     *   2324.9829    ,
     *   1840.8916    ,  1894.5885    ,  1950.1914    ,  2007.7539    ,
     *   2067.3313    ,  2128.9808    ,  2192.7618    ,  2258.7353    ,
     *   2326.9647    ,
     *   1843.6632    ,  1897.2479    ,  1952.7427    ,  2010.2012    ,
     *   2069.6786    ,  2131.2322    ,  2194.9210    ,  2260.8061    ,
     *   2328.9507    /
        DATA ((SOSV  (J,K),J=73,81),K=28,36) /
     *   1846.4399    ,  1899.9124    ,  1955.2991    ,  2012.6534    ,
     *   2072.0308    ,  2133.4882    ,  2197.0847    ,  2262.8811    ,
     *   2330.9407    ,
     *   1849.2216    ,  1902.5818    ,  1957.8603    ,  2015.1105    ,
     *   2074.3876    ,  2135.7487    ,  2199.2527    ,  2264.9604    ,
     *   2332.9348    ,
     *   1852.0080    ,  1905.2559    ,  1960.4262    ,  2017.5722    ,
     *   2076.7490    ,  2138.0137    ,  2201.4250    ,  2267.0437    ,
     *   2334.9328    ,
     *   1854.7990    ,  1907.9347    ,  1962.9967    ,  2020.0384    ,
     *   2079.1149    ,  2140.2830    ,  2203.6015    ,  2269.1311    ,
     *   2336.9346    ,
     *   1857.5944    ,  1910.6180    ,  1965.5718    ,  2022.5091    ,
     *   2081.4851    ,  2142.5565    ,  2205.7821    ,  2271.2225    ,
     *   2338.9404    ,
     *   1860.3941    ,  1913.3056    ,  1968.1511    ,  2024.9841    ,
     *   2083.8595    ,  2144.8342    ,  2207.9668    ,  2273.3178    ,
     *   2340.9498    ,
     *   1863.1980    ,  1915.9974    ,  1970.7347    ,  2027.4633    ,
     *   2086.2382    ,  2147.1160    ,  2210.1554    ,  2275.4169    ,
     *   2342.9630    ,
     *   1866.0058    ,  1918.6933    ,  1973.3224    ,  2029.9466    ,
     *   2088.6209    ,  2149.4018    ,  2212.3480    ,  2277.5198    ,
     *   2344.9799    ,
     *   1868.8174    ,  1921.3930    ,  1975.9141    ,  2032.4340    ,
     *   2091.0075    ,  2151.6915    ,  2214.5443    ,  2279.6265    ,
     *   2347.0003    /
        DATA ((SOSV  (J,K),J=73,81),K=37,45) /
     *   1871.6327    ,  1924.0966    ,  1978.5097    ,  2034.9252    ,
     *   2093.3980    ,  2153.9850    ,  2216.7444    ,  2281.7367    ,
     *   2349.0242    ,
     *   1874.4515    ,  1926.8039    ,  1981.1090    ,  2037.4201    ,
     *   2095.7924    ,  2156.2822    ,  2218.9482    ,  2283.8506    ,
     *   2351.0517    ,
     *   1877.2737    ,  1929.5147    ,  1983.7119    ,  2039.9188    ,
     *   2098.1903    ,  2158.5832    ,  2221.1556    ,  2285.9680    ,
     *   2353.0825    ,
     *   1880.0991    ,  1932.2288    ,  1986.3183    ,  2042.4210    ,
     *   2100.5919    ,  2160.8876    ,  2223.3665    ,  2288.0888    ,
     *   2355.1167    ,
     *   1882.9276    ,  1934.9463    ,  1988.9282    ,  2044.9268    ,
     *   2102.9970    ,  2163.1956    ,  2225.5809    ,  2290.2131    ,
     *   2357.1542    ,
     *   1885.7591    ,  1937.6669    ,  1991.5413    ,  2047.4358    ,
     *   2105.4055    ,  2165.5070    ,  2227.7987    ,  2292.3406    ,
     *   2359.1950    ,
     *   1888.5935    ,  1940.3906    ,  1994.1576    ,  2049.9482    ,
     *   2107.8174    ,  2167.8218    ,  2230.0197    ,  2294.4715    ,
     *   2361.2389    ,
     *   1891.4305    ,  1943.1172    ,  1996.7770    ,  2052.4638    ,
     *   2110.2324    ,  2170.1398    ,  2232.2441    ,  2296.6055    ,
     *   2363.2861    ,
     *   1894.2701    ,  1945.8466    ,  1999.3994    ,  2054.9824    ,
     *   2112.6507    ,  2172.4609    ,  2234.4716    ,  2298.7427    ,
     *   2365.3362    /
        DATA ((SOSV  (J,K),J=73,81),K=46,54) /
     *   1897.1122    ,  1948.5786    ,  2002.0246    ,  2057.5040    ,
     *   2115.0720    ,  2174.7852    ,  2236.7022    ,  2300.8829    ,
     *   2367.3895    ,
     *   1899.9566    ,  1951.3133    ,  2004.6526    ,  2060.0285    ,
     *   2117.4963    ,  2177.1126    ,  2238.9358    ,  2303.0262    ,
     *   2369.4457    ,
     *   1902.8032    ,  1954.0504    ,  2007.2833    ,  2062.5559    ,
     *   2119.9234    ,  2179.4428    ,  2241.1725    ,  2305.1725    ,
     *   2371.5048    ,
     *   1905.6519    ,  1956.7899    ,  2009.9165    ,  2065.0859    ,
     *   2122.3535    ,  2181.7760    ,  2243.4120    ,  2307.3217    ,
     *   2373.5668    ,
     *   1908.5025    ,  1959.5316    ,  2012.5522    ,  2067.6186    ,
     *   2124.7862    ,  2184.1120    ,  2245.6544    ,  2309.4737    ,
     *   2375.6317    ,
     *   1911.3550    ,  1962.2755    ,  2015.1903    ,  2070.1538    ,
     *   2127.2216    ,  2186.4507    ,  2247.8996    ,  2311.6285    ,
     *   2377.6993    ,
     *   1914.2093    ,  1965.0214    ,  2017.8306    ,  2072.6915    ,
     *   2129.6597    ,  2188.7921    ,  2250.1475    ,  2313.7861    ,
     *   2379.7697    ,
     *   1917.0652    ,  1967.7692    ,  2020.4732    ,  2075.2316    ,
     *   2132.1002    ,  2191.1362    ,  2252.3981    ,  2315.9463    ,
     *   2381.8427    ,
     *   1919.9227    ,  1970.5189    ,  2023.1178    ,  2077.7739    ,
     *   2134.5431    ,  2193.4827    ,  2254.6513    ,  2318.1092    ,
     *   2383.9184    /
        DATA ((SOSV  (J,K),J=73,81),K=55,63) /
     *   1922.7815    ,  1973.2704    ,  2025.7644    ,  2080.3185    ,
     *   2136.9885    ,  2195.8317    ,  2256.9070    ,  2320.2746    ,
     *   2385.9966    ,
     *   1925.6417    ,  1976.0235    ,  2028.4130    ,  2082.8652    ,
     *   2139.4361    ,  2198.1831    ,  2259.1652    ,  2322.4426    ,
     *   2388.0774    ,
     *   1928.5031    ,  1978.7781    ,  2031.0634    ,  2085.4139    ,
     *   2141.8859    ,  2200.5369    ,  2261.4258    ,  2324.6130    ,
     *   2390.1606    ,
     *   1931.3656    ,  1981.5342    ,  2033.7155    ,  2087.9646    ,
     *   2144.3379    ,  2202.8929    ,  2263.6888    ,  2326.7859    ,
     *   2392.2463    ,
     *   1934.2292    ,  1984.2917    ,  2036.3693    ,  2090.5172    ,
     *   2146.7919    ,  2205.2512    ,  2265.9540    ,  2328.9611    ,
     *   2394.3344    ,
     *   1937.0936    ,  1987.0505    ,  2039.0246    ,  2093.0716    ,
     *   2149.2479    ,  2207.6116    ,  2268.2216    ,  2331.1386    ,
     *   2396.4248    ,
     *   1939.9589    ,  1989.8104    ,  2041.6815    ,  2095.6277    ,
     *   2151.7059    ,  2209.9740    ,  2270.4913    ,  2333.3184    ,
     *   2398.5176    ,
     *   1942.8250    ,  1992.5715    ,  2044.3397    ,  2098.1855    ,
     *   2154.1658    ,  2212.3385    ,  2272.7631    ,  2335.5004    ,
     *   2400.6125    ,
     *   1945.6917    ,  1995.3336    ,  2046.9993    ,  2100.7449    ,
     *   2156.6274    ,  2214.7050    ,  2275.0370    ,  2337.6845    ,
     *   2402.7097    /
        DATA ((SOSV  (J,K),J=73,81),K=64,72) /
     *   1948.5589    ,  1998.0966    ,  2049.6602    ,  2103.3059    ,
     *   2159.0908    ,  2217.0733    ,  2277.3130    ,  2339.8708    ,
     *   2404.8091    ,
     *   1951.4267    ,  2000.8605    ,  2052.3223    ,  2105.8682    ,
     *   2161.5558    ,  2219.4435    ,  2279.5909    ,  2342.0591    ,
     *   2406.9106    ,
     *   1954.2948    ,  2003.6252    ,  2054.9854    ,  2108.4320    ,
     *   2164.0225    ,  2221.8155    ,  2281.8707    ,  2344.2494    ,
     *   2409.0141    ,
     *   1957.1632    ,  2006.3906    ,  2057.6496    ,  2110.9971    ,
     *   2166.4907    ,  2224.1891    ,  2284.1524    ,  2346.4417    ,
     *   2411.1197    ,
     *   1960.0319    ,  2009.1566    ,  2060.3148    ,  2113.5634    ,
     *   2168.9604    ,  2226.5645    ,  2286.4359    ,  2348.6359    ,
     *   2413.2272    ,
     *   1962.9007    ,  2011.9231    ,  2062.9808    ,  2116.1309    ,
     *   2171.4314    ,  2228.9415    ,  2288.7212    ,  2350.8320    ,
     *   2415.3368    ,
     *   1965.7696    ,  2014.6902    ,  2065.6477    ,  2118.6995    ,
     *   2173.9039    ,  2231.3200    ,  2291.0081    ,  2353.0299    ,
     *   2417.4482    ,
     *   1968.6385    ,  2017.4576    ,  2068.3153    ,  2121.2692    ,
     *   2176.3777    ,  2233.7000    ,  2293.2968    ,  2355.2296    ,
     *   2419.5615    ,
     *   1971.5072    ,  2020.2253    ,  2070.9836    ,  2123.8399    ,
     *   2178.8527    ,  2236.0815    ,  2295.5870    ,  2357.4310    ,
     *   2421.6766    /
        DATA ((SOSV  (J,K),J=73,81),K=73,81) /
     *   1974.3759    ,  2022.9934    ,  2073.6526    ,  2126.4115    ,
     *   2181.3288    ,  2238.4644    ,  2297.8788    ,  2359.6341    ,
     *   2423.7935    ,
     *   1977.2443    ,  2025.7616    ,  2076.3221    ,  2128.9840    ,
     *   2183.8062    ,  2240.8486    ,  2300.1721    ,  2361.8389    ,
     *   2425.9121    ,
     *   1980.1124    ,  2028.5299    ,  2078.9921    ,  2131.5572    ,
     *   2186.2845    ,  2243.2341    ,  2302.4669    ,  2364.0452    ,
     *   2428.0325    ,
     *   1982.9801    ,  2031.2983    ,  2081.6625    ,  2134.1313    ,
     *   2188.7639    ,  2245.6208    ,  2304.7631    ,  2366.2531    ,
     *   2430.1545    ,
     *   1985.8474    ,  2034.0667    ,  2084.3333    ,  2136.7060    ,
     *   2191.2443    ,  2248.0088    ,  2307.0607    ,  2368.4626    ,
     *   2432.2781    ,
     *   1988.7142    ,  2036.8350    ,  2087.0044    ,  2139.2813    ,
     *   2193.7256    ,  2250.3978    ,  2309.3596    ,  2370.6735    ,
     *   2434.4033    ,
     *   1991.5804    ,  2039.6032    ,  2089.6757    ,  2141.8572    ,
     *   2196.2077    ,  2252.7880    ,  2311.6598    ,  2372.8858    ,
     *   2436.5301    ,
     *   1994.4461    ,  2042.3712    ,  2092.3473    ,  2144.4337    ,
     *   2198.6906    ,  2255.1792    ,  2313.9612    ,  2375.0995    ,
     *   2438.6584    ,
     *   1997.3110    ,  2045.1390    ,  2095.0190    ,  2147.0106    ,
     *   2201.1743    ,  2257.5714    ,  2316.2638    ,  2377.3146    ,
     *   2440.7881    /
        DATA ((VISCV (J,K),J= 1, 9),K= 1, 9) /
     *  2.18205154E-06, 2.28525613E-06, 2.39201031E-06, 2.50241965E-06,
     *  2.61659528E-06, 2.73465434E-06, 2.85672056E-06, 2.98292473E-06,
     *  3.11340535E-06,
     *  3.30873565E-06, 3.30305384E-06, 3.31896035E-06, 3.35243131E-06,
     *  3.40045729E-06, 3.46085661E-06, 3.53206062E-06, 3.61294509E-06,
     *  3.70270756E-06,
     *  4.37916941E-06, 4.29595826E-06, 4.23291633E-06, 4.19069764E-06,
     *  4.16918581E-06, 4.16741835E-06, 4.18383226E-06, 4.21664314E-06,
     *  4.26415000E-06,
     *  5.26038397E-06, 5.13217943E-06, 5.02452767E-06, 4.93728573E-06,
     *  4.87029653E-06, 4.82331218E-06, 4.79589695E-06, 4.78735330E-06,
     *  4.79671581E-06,
     *  6.08797899E-06, 5.91015478E-06, 5.75675277E-06, 5.62696366E-06,
     *  5.51999647E-06, 5.43507879E-06, 5.37144320E-06, 5.32830063E-06,
     *  5.30480760E-06,
     *  6.90930759E-06, 6.67603128E-06, 6.47219615E-06, 6.29644189E-06,
     *  6.14744539E-06, 6.02392922E-06, 5.92466475E-06, 5.84846973E-06,
     *  5.79420020E-06,
     *  7.74265031E-06, 7.44833378E-06, 7.18929307E-06, 6.96357755E-06,
     *  6.76931672E-06, 6.60472571E-06, 6.46810739E-06, 6.35785174E-06,
     *  6.27243295E-06,
     *  8.59706700E-06, 8.23615552E-06, 7.91714702E-06, 7.63740750E-06,
     *  7.39444743E-06, 7.18592166E-06, 7.00962590E-06, 6.86349128E-06,
     *  6.74557778E-06,
     *  9.47803475E-06, 9.04483824E-06, 8.66100747E-06, 8.32310628E-06,
     *  8.02792805E-06, 7.77248760E-06, 7.55400994E-06, 7.36991717E-06,
     *  7.21781484E-06/
        DATA ((VISCV (J,K),J= 1, 9),K=10,18) /
     *  1.03894393E-05, 9.87803153E-06, 9.42435099E-06, 9.02402257E-06,
     *  8.67300755E-06, 8.36758481E-06, 8.10432945E-06, 7.88008992E-06,
     *  7.69196513E-06,
     *  1.13343971E-05, 1.07385517E-05, 1.02097667E-05, 9.74257418E-06,
     *  9.33197430E-06, 8.97340172E-06, 8.66269111E-06, 8.39604217E-06,
     *  8.16998551E-06,
     *  1.23156362E-05, 1.16287811E-05, 1.10193710E-05, 1.04806744E-05,
     *  1.00065870E-05, 9.59157929E-06, 9.23064545E-06, 8.91925291E-06,
     *  8.65329460E-06,
     *  1.33356899E-05, 1.25508698E-05, 1.18550187E-05, 1.12399505E-05,
     *  1.06982982E-05, 1.02234368E-05, 9.80941021E-06, 9.45086228E-06,
     *  9.14297236E-06,
     *  1.43970037E-05, 1.35068470E-05, 1.27184175E-05, 1.20218624E-05,
     *  1.14083774E-05, 1.08700974E-05, 1.03999969E-05, 9.99179688E-06,
     *  9.63988097E-06,
     *  1.55019991E-05, 1.44986858E-05, 1.36111955E-05, 1.28277723E-05,
     *  1.21379818E-05, 1.15325613E-05, 1.10032852E-05, 1.05428448E-05,
     *  1.01447392E-05,
     *  1.66531155E-05, 1.55283444E-05, 1.45349416E-05, 1.36589860E-05,
     *  1.28882002E-05, 1.22117500E-05, 1.16200689E-05, 1.11047021E-05,
     *  1.06581689E-05,
     *  1.78528393E-05, 1.65977935E-05, 1.54912339E-05, 1.45167811E-05,
     *  1.36600797E-05, 1.29085346E-05, 1.22510841E-05, 1.16780020E-05,
     *  1.11807252E-05,
     *  1.91037255E-05, 1.77090369E-05, 1.64816577E-05, 1.54024247E-05,
     *  1.44546450E-05, 1.36237547E-05, 1.28970289E-05, 1.22633347E-05,
     *  1.17129162E-05/
        DATA ((VISCV (J,K),J= 1, 9),K=19,27) /
     *  2.04084161E-05, 1.88641267E-05, 1.75078201E-05, 1.63171874E-05,
     *  1.52729113E-05, 1.43582308E-05, 1.35585761E-05, 1.28612602E-05,
     *  1.22552163E-05,
     *  2.17696551E-05, 2.00651759E-05, 1.85713613E-05, 1.72623529E-05,
     *  1.61158932E-05, 1.51127741E-05, 1.42363821E-05, 1.34723179E-05,
     *  1.28080761E-05,
     *  2.31903032E-05, 2.13143700E-05, 1.96739632E-05, 1.82392266E-05,
     *  1.69846128E-05, 1.58881933E-05, 1.49310945E-05, 1.40970331E-05,
     *  1.33719284E-05,
     *  2.46733510E-05, 2.26139763E-05, 2.08173576E-05, 1.92491414E-05,
     *  1.78801052E-05, 1.66852996E-05, 1.56433563E-05, 1.47359222E-05,
     *  1.39471939E-05,
     *  2.62219324E-05, 2.39663540E-05, 2.20033335E-05, 2.02934641E-05,
     *  1.88034231E-05, 1.75049117E-05, 1.63738104E-05, 1.53894963E-05,
     *  1.45342846E-05,
     *  2.78393380E-05, 2.53739633E-05, 2.32337434E-05, 2.13736005E-05,
     *  1.97556417E-05, 1.83478588E-05, 1.71231031E-05, 1.60582644E-05,
     *  1.51336069E-05,
     *  2.95290288E-05, 2.68393742E-05, 2.45105102E-05, 2.24909997E-05,
     *  2.07378616E-05, 1.92149841E-05, 1.78918861E-05, 1.67427360E-05,
     *  1.57455640E-05,
     *  3.12946509E-05, 2.83652763E-05, 2.58356331E-05, 2.36471590E-05,
     *  2.17512128E-05, 2.01071473E-05, 1.86808196E-05, 1.74434231E-05,
     *  1.63705576E-05,
     *  3.31400507E-05, 2.99544882E-05, 2.72111943E-05, 2.48436282E-05,
     *  2.27968577E-05, 2.10252271E-05, 1.94905736E-05, 1.81608417E-05,
     *  1.70089896E-05/
        DATA ((VISCV (J,K),J= 1, 9),K=28,36) /
     *  3.50692907E-05, 3.16099678E-05, 2.86393649E-05, 2.60820137E-05,
     *  2.38759941E-05, 2.19701237E-05, 2.03218304E-05, 1.88955138E-05,
     *  1.76612637E-05,
     *  3.70866672E-05, 3.33348224E-05, 3.01224123E-05, 2.73639832E-05,
     *  2.49898581E-05, 2.29427606E-05, 2.11752858E-05, 1.96479684E-05,
     *  1.83277863E-05,
     *  3.91967291E-05, 3.51323203E-05, 3.16627065E-05, 2.86912699E-05,
     *  2.61397273E-05, 2.39440872E-05, 2.20516508E-05, 2.04187428E-05,
     *  1.90089674E-05,
     *  4.14042976E-05, 3.70059022E-05, 3.32627272E-05, 3.00656768E-05,
     *  2.73269235E-05, 2.49750802E-05, 2.29516531E-05, 2.12083840E-05,
     *  1.97052222E-05,
     *  4.37144886E-05, 3.89591945E-05, 3.49250721E-05, 3.14890817E-05,
     *  2.85528159E-05, 2.60367458E-05, 2.38760385E-05, 2.20174493E-05,
     *  2.04169712E-05,
     *  4.61327363E-05, 4.09960225E-05, 3.66524640E-05, 3.29634421E-05,
     *  2.98188238E-05, 2.71301222E-05, 2.48255723E-05, 2.28465077E-05,
     *  2.11446413E-05,
     *  4.86648190E-05, 4.31204252E-05, 3.84477601E-05, 3.44907998E-05,
     *  3.11264203E-05, 2.82562807E-05, 2.58010404E-05, 2.36961407E-05,
     *  2.18886667E-05,
     *  5.13168881E-05, 4.53366711E-05, 4.03139605E-05, 3.60732867E-05,
     *  3.24771347E-05, 2.94163286E-05, 2.68032510E-05, 2.45669433E-05,
     *  2.26494893E-05,
     *  5.40954990E-05, 4.76492756E-05, 4.22542182E-05, 3.77131301E-05,
     *  3.38725566E-05, 3.06114105E-05, 2.78330357E-05, 2.54595247E-05,
     *  2.34275594E-05/
        DATA ((VISCV (J,K),J= 1, 9),K=37,45) /
     *  5.70076454E-05, 5.00630194E-05, 4.42718493E-05, 3.94126590E-05,
     *  3.53143392E-05, 3.18427112E-05, 2.88912511E-05, 2.63745097E-05,
     *  2.42233366E-05,
     *  6.00607972E-05, 5.25829687E-05, 4.63703443E-05, 4.11743100E-05,
     *  3.68042026E-05, 3.31114573E-05, 2.99787798E-05, 2.73125388E-05,
     *  2.50372902E-05,
     *  6.32629426E-05, 5.52144974E-05, 4.85533802E-05, 4.30006343E-05,
     *  3.83439382E-05, 3.44189196E-05, 3.10965320E-05, 2.82742700E-05,
     *  2.58698996E-05,
     *  6.66226338E-05, 5.79633112E-05, 5.08248331E-05, 4.48943047E-05,
     *  3.99354124E-05, 3.57664159E-05, 3.22454471E-05, 2.92603788E-05,
     *  2.67216555E-05,
     *  7.01490391E-05, 6.08354740E-05, 5.31887923E-05, 4.68581234E-05,
     *  4.15805710E-05, 3.71553127E-05, 3.34264948E-05, 3.02715601E-05,
     *  2.75930598E-05,
     *  7.38519991E-05, 6.38374366E-05, 5.56495759E-05, 4.88950300E-05,
     *  4.32814438E-05, 3.85870287E-05, 3.46406770E-05, 3.13085281E-05,
     *  2.84846269E-05,
     *  7.77420911E-05, 6.69760684E-05, 5.82117464E-05, 5.10081104E-05,
     *  4.50401493E-05, 4.00630368E-05, 3.58890292E-05, 3.23720181E-05,
     *  2.93968835E-05,
     *  8.18306998E-05, 7.02586924E-05, 6.08801293E-05, 5.32006062E-05,
     *  4.68589000E-05, 4.15848672E-05, 3.71726219E-05, 3.34627870E-05,
     *  3.03303699E-05,
     *  8.61300971E-05, 7.36931238E-05, 6.36598316E-05, 5.54759247E-05,
     *  4.87400075E-05, 4.31541105E-05, 3.84925630E-05, 3.45816145E-05,
     *  3.12856403E-05/
        DATA ((VISCV (J,K),J= 1, 9),K=46,54) /
     *  9.06535314E-05, 7.72877119E-05, 6.65562640E-05, 5.78376497E-05,
     *  5.06858886E-05, 4.47724207E-05, 3.98499988E-05, 3.57293039E-05,
     *  3.22632635E-05,
     *  9.54153288E-05, 8.10513876E-05, 6.95751628E-05, 6.02895535E-05,
     *  5.26990713E-05, 4.64415188E-05, 4.12461164E-05, 3.69066835E-05,
     *  3.32638234E-05,
     *  1.00431006E-04, 8.49937153E-05, 7.27226157E-05, 6.28356094E-05,
     *  5.47822016E-05, 4.81631960E-05, 4.26821453E-05, 3.81146076E-05,
     *  3.42879199E-05,
     *  1.05717402E-04, 8.91249506E-05, 7.60050893E-05, 6.54800055E-05,
     *  5.69380504E-05, 4.99393177E-05, 4.41593598E-05, 3.93539574E-05,
     *  3.53361693E-05,
     *  1.11292818E-04, 9.34561052E-05, 7.94294588E-05, 6.82271591E-05,
     *  5.91695208E-05, 5.17718275E-05, 4.56790808E-05, 4.06256426E-05,
     *  3.64092052E-05,
     *  1.17177195E-04, 9.79990185E-05, 8.30030419E-05, 7.10817334E-05,
     *  6.14796567E-05, 5.36627510E-05, 4.72426784E-05, 4.19306024E-05,
     *  3.75076791E-05,
     *  1.23392294E-04, 1.02766438E-04, 8.67336343E-05, 7.40486543E-05,
     *  6.38716512E-05, 5.56142009E-05, 4.88515740E-05, 4.32698067E-05,
     *  3.86322612E-05,
     *  1.29961924E-04, 1.07772111E-04, 9.06295507E-05, 7.71331296E-05,
     *  6.63488558E-05, 5.76283812E-05, 5.05072429E-05, 4.46442579E-05,
     *  3.97836410E-05,
     *  1.36912191E-04, 1.13030885E-04, 9.46996689E-05, 8.03406696E-05,
     *  6.89147907E-05, 5.97075927E-05, 5.22112169E-05, 4.60549917E-05,
     *  4.09625283E-05/
        DATA ((VISCV (J,K),J= 1, 9),K=55,63) /
     *  1.44271794E-04, 1.18558822E-04, 9.89534788E-05, 8.36771096E-05,
     *  7.15731553E-05, 6.18542381E-05, 5.39650874E-05, 4.75030793E-05,
     *  4.21696541E-05,
     *  1.52072362E-04, 1.24373331E-04, 1.03401137E-04, 8.71486340E-05,
     *  7.43278401E-05, 6.40708279E-05, 5.57705079E-05, 4.89896283E-05,
     *  4.34057709E-05,
     *  1.60348859E-04, 1.30493311E-04, 1.08053527E-04, 9.07618037E-05,
     *  7.71829390E-05, 6.63599864E-05, 5.76291974E-05, 5.05157846E-05,
     *  4.46716542E-05,
     *  1.69140048E-04, 1.36939326E-04, 1.12922327E-04, 9.45235848E-05,
     *  8.01427631E-05, 6.87244585E-05, 5.95429435E-05, 5.20827343E-05,
     *  4.59681032E-05,
     *  1.78489046E-04, 1.43733790E-04, 1.18020086E-04, 9.84413814E-05,
     *  8.32118550E-05, 7.11671165E-05, 6.15136062E-05, 5.36917054E-05,
     *  4.72959417E-05,
     *  1.88443984E-04, 1.50901190E-04, 1.23360304E-04, 1.02523070E-04,
     *  8.63950051E-05, 7.36909678E-05, 6.35431213E-05, 5.53439694E-05,
     *  4.86560190E-05,
     *  1.99058786E-04, 1.58468340E-04, 1.28957534E-04, 1.06777040E-04,
     *  8.96972686E-05, 7.62991629E-05, 6.56335047E-05, 5.70408436E-05,
     *  5.00492112E-05,
     *  2.10394126E-04, 1.66464676E-04, 1.34827479E-04, 1.11212235E-04,
     *  9.31239841E-05, 7.89950038E-05, 6.77868561E-05, 5.87836932E-05,
     *  5.14764222E-05,
     *  2.22518566E-04, 1.74922593E-04, 1.40987121E-04, 1.15838199E-04,
     *  9.66807943E-05, 8.17819538E-05, 7.00053638E-05, 6.05739335E-05,
     *  5.29385847E-05/
        DATA ((VISCV (J,K),J= 1, 9),K=64,72) /
     *  2.35509965E-04, 1.83877844E-04, 1.47454850E-04, 1.20665134E-04,
     *  1.00373668E-04, 8.46636468E-05, 7.22913095E-05, 6.24130321E-05,
     *  5.44366616E-05,
     *  2.49457206E-04, 1.93370008E-04, 1.54250621E-04, 1.25703953E-04,
     *  1.04208923E-04, 8.76438989E-05, 7.46470729E-05, 6.43025113E-05,
     *  5.59716470E-05,
     *  2.64462350E-04, 2.03443039E-04, 1.61396128E-04, 1.30966345E-04,
     *  1.08193255E-04, 9.07267190E-05, 7.70751376E-05, 6.62439511E-05,
     *  5.75445677E-05,
     *  2.80643344E-04, 2.14145916E-04, 1.68915006E-04, 1.36464851E-04,
     *  1.12333764E-04, 9.39163220E-05, 7.95780963E-05, 6.82389914E-05,
     *  5.91564847E-05,
     *  2.98137471E-04, 2.25533423E-04, 1.76833061E-04, 1.42212941E-04,
     *  1.16637988E-04, 9.72171421E-05, 8.21586573E-05, 7.02893356E-05,
     *  6.08084941E-05,
     *  3.17105794E-04, 2.37667083E-04, 1.85178535E-04, 1.48225104E-04,
     *  1.21113936E-04, 1.00633847E-04, 8.48196509E-05, 7.23967528E-05,
     *  6.25017292E-05,
     *  3.37738965E-04, 2.50616290E-04, 1.93982407E-04, 1.54516953E-04,
     *  1.25770127E-04, 1.04171354E-04, 8.75640365E-05, 7.45630818E-05,
     *  6.42373619E-05,
     *  3.60264961E-04, 2.64459685E-04, 2.03278758E-04, 1.61105332E-04,
     *  1.30615631E-04, 1.07834848E-04, 9.03949095E-05, 7.67902342E-05,
     *  6.60166041E-05,
     *  3.84959539E-04, 2.79286854E-04, 2.13105179E-04, 1.68008453E-04,
     *  1.35660117E-04, 1.11629797E-04, 9.33155102E-05, 7.90801981E-05,
     *  6.78407097E-05/
        DATA ((VISCV (J,K),J= 1, 9),K=73,81) /
     *  4.12160709E-04, 2.95200433E-04, 2.23503259E-04, 1.75246034E-04,
     *  1.40913901E-04, 1.15561976E-04, 9.63292315E-05, 8.14350420E-05,
     *  6.97109764E-05,
     *  4.42289231E-04, 3.12318747E-04, 2.34519161E-04, 1.82839469E-04,
     *  1.46388008E-04, 1.19637486E-04, 9.94396288E-05, 8.38569190E-05,
     *  7.16287478E-05,
     *  4.75878490E-04, 3.30779161E-04, 2.46204302E-04, 1.90812015E-04,
     *  1.52094231E-04, 1.23862780E-04, 1.02650429E-04, 8.63480708E-05,
     *  7.35954150E-05,
     *  5.13619541E-04, 3.50742383E-04, 2.58616163E-04, 1.99189007E-04,
     *  1.58045199E-04, 1.28244687E-04, 1.05965543E-04, 8.89108329E-05,
     *  7.56124191E-05,
     *  5.56431813E-04, 3.72398066E-04, 2.71819270E-04, 2.07998106E-04,
     *  1.64254463E-04, 1.32790444E-04, 1.09389075E-04, 9.15476393E-05,
     *  7.76812534E-05,
     *  6.05579813E-04, 3.95972229E-04, 2.85886371E-04, 2.17269584E-04,
     *  1.70736574E-04, 1.37507720E-04, 1.12925334E-04, 9.42610276E-05,
     *  7.98034657E-05,
     *  6.62878243E-04, 4.21737248E-04, 3.00899878E-04, 2.27036656E-04,
     *  1.77507187E-04, 1.42404659E-04, 1.16578853E-04, 9.70536449E-05,
     *  8.19806609E-05,
     *  7.31083557E-04, 4.50025596E-04, 3.16953641E-04, 2.37335859E-04,
     *  1.84583169E-04, 1.47489911E-04, 1.20354394E-04, 9.99282536E-05,
     *  8.42145037E-05,
     *  8.14730908E-04, 4.81249183E-04, 3.34155150E-04, 2.48207507E-04,
     *  1.91982724E-04, 1.52772676E-04, 1.24256972E-04, 1.02887738E-04,
     *  8.65067213E-05/
        DATA ((VISCV (J,K),J=10,18),K= 1, 9) /
     *  3.24830919E-06, 3.38779194E-06, 3.53201893E-06, 3.68116582E-06,
     *  3.83541937E-06, 3.99497830E-06, 4.16005411E-06, 4.33087205E-06,
     *  4.50767210E-06,
     *  3.80077995E-06, 3.90676661E-06, 4.02040055E-06, 4.14151251E-06,
     *  4.27000904E-06, 4.40585700E-06, 4.54907256E-06, 4.69971341E-06,
     *  4.85787336E-06,
     *  4.32489198E-06, 4.39768854E-06, 4.48161923E-06, 4.57598300E-06,
     *  4.68025671E-06, 4.79405966E-06, 4.91712550E-06, 5.04928057E-06,
     *  5.19042741E-06,
     *  4.82282424E-06, 4.86444407E-06, 4.92038555E-06, 4.98958720E-06,
     *  5.07115594E-06, 5.16437334E-06, 5.26868243E-06, 5.38366666E-06,
     *  5.50902783E-06,
     *  5.30004126E-06, 5.31299681E-06, 5.34261433E-06, 5.38782882E-06,
     *  5.44762752E-06, 5.52109819E-06, 5.60745912E-06, 5.70607010E-06,
     *  5.81642885E-06,
     *  5.76073841E-06, 5.74698087E-06, 5.75183222E-06, 5.77421028E-06,
     *  5.81306375E-06, 5.86739928E-06, 5.93631070E-06, 6.01900293E-06,
     *  6.11480621E-06,
     *  6.21040453E-06, 6.17039329E-06, 6.15109354E-06, 6.15126364E-06,
     *  6.16972719E-06, 6.20538024E-06, 6.25720384E-06, 6.32427911E-06,
     *  6.40580113E-06,
     *  6.65406741E-06, 6.58725776E-06, 6.54355632E-06, 6.52147610E-06,
     *  6.51963322E-06, 6.53674710E-06, 6.57164370E-06, 6.62326127E-06,
     *  6.69065735E-06,
     *  7.09547879E-06, 7.00084353E-06, 6.93199244E-06, 6.88715045E-06,
     *  6.86467892E-06, 6.86307286E-06, 6.88096016E-06, 6.91710250E-06,
     *  6.97039739E-06/
        DATA ((VISCV (J,K),J=10,18),K=10,18) /
     *  7.53728272E-06, 7.41357940E-06, 7.31858438E-06, 7.25020606E-06,
     *  7.20652231E-06, 7.18577390E-06, 7.18636060E-06, 7.20683920E-06,
     *  7.24592260E-06,
     *  7.98135028E-06, 7.82723493E-06, 7.70498163E-06, 7.61215514E-06,
     *  7.54652627E-06, 7.50605989E-06, 7.48890668E-06, 7.49339793E-06,
     *  7.51804220E-06,
     *  8.42904421E-06, 8.24311543E-06, 8.09242593E-06, 7.97416682E-06,
     *  7.88577769E-06, 7.82492744E-06, 7.78950029E-06, 7.77758614E-06,
     *  7.78747403E-06,
     *  8.88139581E-06, 8.66220992E-06, 8.48186594E-06, 8.33714756E-06,
     *  8.22513635E-06, 8.14318401E-06, 8.08889116E-06, 8.06009197E-06,
     *  8.05484328E-06,
     *  9.33921801E-06, 9.08529270E-06, 8.87404380E-06, 8.70181036E-06,
     *  8.56528612E-06, 8.46148206E-06, 8.38769677E-06, 8.34149406E-06,
     *  8.32068663E-06,
     *  9.80317731E-06, 9.51299084E-06, 9.26955633E-06, 9.06872768E-06,
     *  8.90677815E-06, 8.78035206E-06, 8.68642563E-06, 8.62227652E-06,
     *  8.58546083E-06,
     *  1.02738399E-05, 9.94582896E-06, 9.66889720E-06, 9.43836984E-06,
     *  9.25006440E-06, 9.10023028E-06, 8.98549903E-06, 8.90284478E-06,
     *  8.84955358E-06,
     *  1.07517019E-05, 1.03842591E-05, 1.00724859E-05, 9.81113238E-06,
     *  9.59552268E-06, 9.42148081E-06, 9.28526945E-06, 9.18354021E-06,
     *  9.11329441E-06,
     *  1.12372094E-05, 1.08286809E-05, 1.04806876E-05, 1.01873555E-05,
     *  9.94347495E-06, 9.74441231E-06, 9.58603537E-06, 9.46465266E-06,
     *  9.37696479E-06/
        DATA ((VISCV (J,K),J=10,18),K=19,27) /
     *  1.17307720E-05, 1.12794554E-05, 1.08938274E-05, 1.05673377E-05,
     *  1.02942008E-05, 1.00692907E-05, 9.88805284E-06, 9.74643065E-06,
     *  9.64080670E-06,
     *  1.22327731E-05, 1.17369153E-05, 1.13122001E-05, 1.09513461E-05,
     *  1.06479471E-05, 1.03963487E-05, 1.01915445E-05, 1.00290895E-05,
     *  9.90502989E-06,
     *  1.27435756E-05, 1.22013712E-05, 1.17360773E-05, 1.13396234E-05,
     *  1.10049355E-05, 1.07257928E-05, 1.04967064E-05, 1.03128181E-05,
     *  1.01698178E-05,
     *  1.32635283E-05, 1.26731173E-05, 1.21657126E-05, 1.17323930E-05,
     *  1.13653676E-05, 1.10578090E-05, 1.08037133E-05, 1.05977834E-05,
     *  1.04353323E-05,
     *  1.37929685E-05, 1.31524352E-05, 1.26013456E-05, 1.21298636E-05,
     *  1.17294291E-05, 1.13925664E-05, 1.11127230E-05, 1.08841351E-05,
     *  1.07017174E-05,
     *  1.43322255E-05, 1.36395966E-05, 1.30432048E-05, 1.25322315E-05,
     *  1.20972930E-05, 1.17302210E-05, 1.14238789E-05, 1.11720083E-05,
     *  1.09691027E-05,
     *  1.48816231E-05, 1.41348655E-05, 1.34915100E-05, 1.29396837E-05,
     *  1.24691217E-05, 1.20709174E-05, 1.17373132E-05, 1.14615264E-05,
     *  1.12376052E-05,
     *  1.54414809E-05, 1.46385004E-05, 1.39464741E-05, 1.33523990E-05,
     *  1.28450692E-05, 1.24147914E-05, 1.20531485E-05, 1.17528025E-05,
     *  1.15073318E-05,
     *  1.60121160E-05, 1.51507554E-05, 1.44083043E-05, 1.37705501E-05,
     *  1.32252824E-05, 1.27619711E-05, 1.23714994E-05, 1.20459417E-05,
     *  1.17783809E-05/
        DATA ((VISCV (J,K),J=10,18),K=28,36) /
     *  1.65938445E-05, 1.56718818E-05, 1.48772037E-05, 1.41943042E-05,
     *  1.36099022E-05, 1.31125783E-05, 1.26924736E-05, 1.23410417E-05,
     *  1.20508434E-05,
     *  1.71869824E-05, 1.62021285E-05, 1.53533718E-05, 1.46238244E-05,
     *  1.39990650E-05, 1.34667293E-05, 1.30161732E-05, 1.26381945E-05,
     *  1.23248038E-05,
     *  1.77918464E-05, 1.67417436E-05, 1.58370058E-05, 1.50592705E-05,
     *  1.43929027E-05, 1.38245361E-05, 1.33426955E-05, 1.29374866E-05,
     *  1.26003414E-05,
     *  1.84087549E-05, 1.72909744E-05, 1.63283011E-05, 1.55007992E-05,
     *  1.47915441E-05, 1.41861067E-05, 1.36721334E-05, 1.32390002E-05,
     *  1.28775307E-05,
     *  1.90380285E-05, 1.78500687E-05, 1.68274517E-05, 1.59485655E-05,
     *  1.51951150E-05, 1.45515459E-05, 1.40045763E-05, 1.35428137E-05,
     *  1.31564420E-05,
     *  1.96799912E-05, 1.84192748E-05, 1.73346509E-05, 1.64027223E-05,
     *  1.56037390E-05, 1.49209556E-05, 1.43401105E-05, 1.38490020E-05,
     *  1.34371424E-05,
     *  2.03349702E-05, 1.89988427E-05, 1.78500920E-05, 1.68634215E-05,
     *  1.60175378E-05, 1.52944354E-05, 1.46788196E-05, 1.41576371E-05,
     *  1.37196954E-05,
     *  2.10032970E-05, 1.95890236E-05, 1.83739683E-05, 1.73308140E-05,
     *  1.64366312E-05, 1.56720829E-05, 1.50207847E-05, 1.44687883E-05,
     *  1.40041621E-05,
     *  2.16853079E-05, 2.01900714E-05, 1.89064736E-05, 1.78050502E-05,
     *  1.68611382E-05, 1.60539938E-05, 1.53660850E-05, 1.47825229E-05,
     *  1.42906009E-05/
        DATA ((VISCV (J,K),J=10,18),K=37,45) /
     *  2.23813440E-05, 2.08022421E-05, 1.94478026E-05, 1.82862803E-05,
     *  1.72911767E-05, 1.64402626E-05, 1.57147980E-05, 1.50989059E-05,
     *  1.45790682E-05,
     *  2.30917522E-05, 2.14257949E-05, 1.99981513E-05, 1.87746545E-05,
     *  1.77268637E-05, 1.68309825E-05, 1.60669994E-05, 1.54180007E-05,
     *  1.48696184E-05,
     *  2.38168855E-05, 2.20609922E-05, 2.05577170E-05, 1.92703233E-05,
     *  1.81683160E-05, 1.72262457E-05, 1.64227639E-05, 1.57398691E-05,
     *  1.51623042E-05,
     *  2.45571033E-05, 2.27081000E-05, 2.11266987E-05, 1.97734378E-05,
     *  1.86156499E-05, 1.76261436E-05, 1.67821647E-05, 1.60645716E-05,
     *  1.54571766E-05,
     *  2.53127718E-05, 2.33673880E-05, 2.17052976E-05, 2.02841496E-05,
     *  1.90689817E-05, 1.80307670E-05, 1.71452745E-05, 1.63921674E-05,
     *  1.57542856E-05,
     *  2.60842644E-05, 2.40391302E-05, 2.22937167E-05, 2.08026114E-05,
     *  1.95284278E-05, 1.84402062E-05, 1.75121646E-05, 1.67227145E-05,
     *  1.60536796E-05,
     *  2.68719624E-05, 2.47236051E-05, 2.28921618E-05, 2.13289769E-05,
     *  1.99941048E-05, 1.88545511E-05, 1.78829061E-05, 1.70562703E-05,
     *  1.63554061E-05,
     *  2.76762550E-05, 2.54210959E-05, 2.35008409E-05, 2.18634010E-05,
     *  2.04661295E-05, 1.92738917E-05, 1.82575692E-05, 1.73928912E-05,
     *  1.66595115E-05,
     *  2.84975399E-05, 2.61318906E-05, 2.41199651E-05, 2.24060400E-05,
     *  2.09446195E-05, 1.96983174E-05, 1.86362239E-05, 1.77326328E-05,
     *  1.69660415E-05/
        DATA ((VISCV (J,K),J=10,18),K=46,54) /
     *  2.93362236E-05, 2.68562829E-05, 2.47497484E-05, 2.29570519E-05,
     *  2.14296929E-05, 2.01279182E-05, 1.90189396E-05, 1.80755502E-05,
     *  1.72750407E-05,
     *  3.01927220E-05, 2.75945715E-05, 2.53904079E-05, 2.35165961E-05,
     *  2.19214683E-05, 2.05627837E-05, 1.94057856E-05, 1.84216980E-05,
     *  1.75865533E-05,
     *  3.10674603E-05, 2.83470612E-05, 2.60421641E-05, 2.40848341E-05,
     *  2.24200655E-05, 2.10030042E-05, 1.97968308E-05, 1.87711303E-05,
     *  1.79006228E-05,
     *  3.19608742E-05, 2.91140628E-05, 2.67052412E-05, 2.46619291E-05,
     *  2.29256049E-05, 2.14486698E-05, 2.01921444E-05, 1.91239008E-05,
     *  1.82172922E-05,
     *  3.28734096E-05, 2.98958934E-05, 2.73798668E-05, 2.52480466E-05,
     *  2.34382084E-05, 2.18998715E-05, 2.05917950E-05, 1.94800628E-05,
     *  1.85366037E-05,
     *  3.38055233E-05, 3.06928765E-05, 2.80662725E-05, 2.58433542E-05,
     *  2.39579985E-05, 2.23567003E-05, 2.09958518E-05, 1.98396697E-05,
     *  1.88585995E-05,
     *  3.47576834E-05, 3.15053426E-05, 2.87646940E-05, 2.64480217E-05,
     *  2.44850993E-05, 2.28192481E-05, 2.14043836E-05, 2.02027743E-05,
     *  1.91833213E-05,
     *  3.57303699E-05, 3.23336293E-05, 2.94753712E-05, 2.70622215E-05,
     *  2.50196360E-05, 2.32876071E-05, 2.18174597E-05, 2.05694295E-05,
     *  1.95108102E-05,
     *  3.67240748E-05, 3.31780813E-05, 3.01985484E-05, 2.76861285E-05,
     *  2.55617354E-05, 2.37618704E-05, 2.22351495E-05, 2.09396881E-05,
     *  1.98411074E-05/
        DATA ((VISCV (J,K),J=10,18),K=55,63) /
     *  3.77393029E-05, 3.40390513E-05, 3.09344742E-05, 2.83199201E-05,
     *  2.61115255E-05, 2.42421317E-05, 2.26575226E-05, 2.13136029E-05,
     *  2.01742537E-05,
     *  3.87765721E-05, 3.49168995E-05, 3.16834023E-05, 2.89637766E-05,
     *  2.66691360E-05, 2.47284855E-05, 2.30846489E-05, 2.16912264E-05,
     *  2.05102897E-05,
     *  3.98364140E-05, 3.58119946E-05, 3.24455910E-05, 2.96178811E-05,
     *  2.72346983E-05, 2.52210272E-05, 2.35165988E-05, 2.20726115E-05,
     *  2.08492559E-05,
     *  4.09193742E-05, 3.67247136E-05, 3.32213038E-05, 3.02824199E-05,
     *  2.78083454E-05, 2.57198530E-05, 2.39534430E-05, 2.24578111E-05,
     *  2.11911927E-05,
     *  4.20260130E-05, 3.76554424E-05, 3.40108094E-05, 3.09575820E-05,
     *  2.83902119E-05, 2.62250601E-05, 2.43952526E-05, 2.28468782E-05,
     *  2.15361403E-05,
     *  4.31569060E-05, 3.86045760E-05, 3.48143819E-05, 3.16435599E-05,
     *  2.89804345E-05, 2.67367469E-05, 2.48420992E-05, 2.32398657E-05,
     *  2.18841389E-05,
     *  4.43126445E-05, 3.95725184E-05, 3.56323010E-05, 3.23405494E-05,
     *  2.95791518E-05, 2.72550124E-05, 2.52940550E-05, 2.36368272E-05,
     *  2.22352287E-05,
     *  4.54938361E-05, 4.05596839E-05, 3.64648523E-05, 3.30487495E-05,
     *  3.01865043E-05, 2.77799572E-05, 2.57511927E-05, 2.40378161E-05,
     *  2.25894500E-05,
     *  4.67011055E-05, 4.15664964E-05, 3.73123271E-05, 3.37683629E-05,
     *  3.08026345E-05, 2.83116826E-05, 2.62135856E-05, 2.44428861E-05,
     *  2.29468428E-05/
        DATA ((VISCV (J,K),J=10,18),K=64,72) /
     *  4.79350948E-05, 4.25933904E-05, 3.81750231E-05, 3.44995959E-05,
     *  3.14276871E-05, 2.88502916E-05, 2.66813076E-05, 2.48520914E-05,
     *  2.33074476E-05,
     *  4.91964644E-05, 4.36408109E-05, 3.90532442E-05, 3.52426586E-05,
     *  3.20618090E-05, 2.93958879E-05, 2.71544333E-05, 2.52654862E-05,
     *  2.36713047E-05,
     *  5.04858937E-05, 4.47092143E-05, 3.99473011E-05, 3.59977650E-05,
     *  3.27051493E-05, 2.99485770E-05, 2.76330380E-05, 2.56831253E-05,
     *  2.40384544E-05,
     *  5.18040816E-05, 4.57990683E-05, 4.08575108E-05, 3.67651329E-05,
     *  3.33578596E-05, 3.05084652E-05, 2.81171977E-05, 2.61050637E-05,
     *  2.44089373E-05,
     *  5.31517472E-05, 4.69108523E-05, 4.17841978E-05, 3.75449844E-05,
     *  3.40200937E-05, 3.10756608E-05, 2.86069891E-05, 2.65313568E-05,
     *  2.47827942E-05,
     *  5.45296311E-05, 4.80450583E-05, 4.27276934E-05, 3.83375457E-05,
     *  3.46920080E-05, 3.16502730E-05, 2.91024899E-05, 2.69620603E-05,
     *  2.51600659E-05,
     *  5.59384955E-05, 4.92021907E-05, 4.36883365E-05, 3.91430475E-05,
     *  3.53737614E-05, 3.22324127E-05, 2.96037783E-05, 2.73972305E-05,
     *  2.55407933E-05,
     *  5.73791254E-05, 5.03827671E-05, 4.46664735E-05, 3.99617249E-05,
     *  3.60655155E-05, 3.28221924E-05, 3.01109336E-05, 2.78369241E-05,
     *  2.59250178E-05,
     *  5.88523294E-05, 5.15873186E-05, 4.56624588E-05, 4.07938176E-05,
     *  3.67674346E-05, 3.34197259E-05, 3.06240360E-05, 2.82811981E-05,
     *  2.63127806E-05/
        DATA ((VISCV (J,K),J=10,18),K=73,81) /
     *  6.03589407E-05, 5.28163903E-05, 4.66766549E-05, 4.16395700E-05,
     *  3.74796855E-05, 3.40251289E-05, 3.11431663E-05, 2.87301102E-05,
     *  2.67041236E-05,
     *  6.18998178E-05, 5.40705418E-05, 4.77094326E-05, 4.24992315E-05,
     *  3.82024383E-05, 3.46385186E-05, 3.16684067E-05, 2.91837185E-05,
     *  2.70990885E-05,
     *  6.34758458E-05, 5.53503476E-05, 4.87611713E-05, 4.33730563E-05,
     *  3.89358657E-05, 3.52600139E-05, 3.21998399E-05, 2.96420816E-05,
     *  2.74977174E-05,
     *  6.50879371E-05, 5.66563979E-05, 4.98322594E-05, 4.42613041E-05,
     *  3.96801435E-05, 3.58897354E-05, 3.27375499E-05, 3.01052587E-05,
     *  2.79000528E-05,
     *  6.67370329E-05, 5.79892987E-05, 5.09230944E-05, 4.51642396E-05,
     *  4.04354507E-05, 3.65278056E-05, 3.32816217E-05, 3.05733095E-05,
     *  2.83061374E-05,
     *  6.84241038E-05, 5.93496727E-05, 5.20340832E-05, 4.60821330E-05,
     *  4.12019691E-05, 3.71743488E-05, 3.38321411E-05, 3.10462944E-05,
     *  2.87160141E-05,
     *  7.01501515E-05, 6.07381597E-05, 5.31656424E-05, 4.70152602E-05,
     *  4.19798842E-05, 3.78294912E-05, 3.43891954E-05, 3.15242742E-05,
     *  2.91297263E-05,
     *  7.19162097E-05, 6.21554174E-05, 5.43181989E-05, 4.79639028E-05,
     *  4.27693846E-05, 3.84933608E-05, 3.49528725E-05, 3.20073105E-05,
     *  2.95473175E-05,
     *  7.37233456E-05, 6.36021216E-05, 5.54921896E-05, 4.89283484E-05,
     *  4.35706623E-05, 3.91660878E-05, 3.55232619E-05, 3.24954655E-05,
     *  2.99688317E-05/
        DATA ((VISCV (J,K),J=19,27),K= 1, 9) /
     *  4.69071000E-06, 4.88025843E-06, 5.07660818E-06, 5.28006946E-06,
     *  5.49097330E-06, 5.70967301E-06, 5.93654582E-06, 6.17199457E-06,
     *  6.41644958E-06,
     *  5.02367863E-06, 5.19728542E-06, 5.37887848E-06, 5.56867039E-06,
     *  5.76690147E-06, 5.97384016E-06, 6.18978378E-06, 6.41505963E-06,
     *  6.65002642E-06,
     *  5.34053247E-06, 5.49961683E-06, 5.66774950E-06, 5.84504250E-06,
     *  6.03164755E-06, 6.22775388E-06, 6.43358704E-06, 6.64940852E-06,
     *  6.87551593E-06,
     *  5.64456663E-06, 5.79016651E-06, 5.94578102E-06, 6.11142422E-06,
     *  6.28716353E-06, 6.47311454E-06, 6.66943750E-06, 6.87633505E-06,
     *  7.09405104E-06,
     *  5.93815893E-06, 6.07099441E-06, 6.21476439E-06, 6.36937938E-06,
     *  6.53482006E-06, 6.71112848E-06, 6.89840154E-06, 7.09678633E-06,
     *  7.30647701E-06,
     *  6.22317966E-06, 6.34370635E-06, 6.47608297E-06, 6.62010715E-06,
     *  6.77566484E-06, 6.94271890E-06, 7.12129963E-06, 7.31149745E-06,
     *  7.51345741E-06,
     *  6.50108806E-06, 6.60958394E-06, 6.73085535E-06, 6.86458329E-06,
     *  7.01055240E-06, 7.16863948E-06, 7.33880250E-06, 7.52107110E-06,
     *  7.71553891E-06,
     *  6.77301501E-06, 6.86964634E-06, 6.97999195E-06, 7.10361630E-06,
     *  7.24019955E-06, 7.38952734E-06, 7.55147971E-06, 7.72602058E-06,
     *  7.91318827E-06,
     *  7.03988017E-06, 7.12472512E-06, 7.22424422E-06, 7.33788324E-06,
     *  7.46521485E-06, 7.60592936E-06, 7.75982409E-06, 7.92679236E-06,
     *  8.10681293E-06/
        DATA ((VISCV (J,K),J=19,27),K=10,18) /
     *  7.30247913E-06, 7.37553114E-06, 7.46425230E-06, 7.56796273E-06,
     *  7.68612203E-06, 7.81832011E-06, 7.96426657E-06, 8.12377925E-06,
     *  8.29677294E-06,
     *  7.56152268E-06, 7.62269418E-06, 7.70057913E-06, 7.79436168E-06,
     *  7.90338001E-06, 8.02711671E-06, 8.16518759E-06, 8.31732968E-06,
     *  8.48338897E-06,
     *  7.81764736E-06, 7.86677959E-06, 7.93372912E-06, 8.01753285E-06,
     *  8.11739776E-06, 8.23269069E-06, 8.36292647E-06, 8.50775510E-06,
     *  8.66694845E-06,
     *  8.07141692E-06, 8.10829350E-06, 8.16415637E-06, 8.23788453E-06,
     *  8.32854391E-06, 8.43537665E-06, 8.55778869E-06, 8.69533606E-06,
     *  8.84771057E-06,
     *  8.32332428E-06, 8.34768518E-06, 8.39226825E-06, 8.45578538E-06,
     *  8.53715237E-06, 8.63547801E-06, 8.75005127E-06, 8.88032695E-06,
     *  9.02591042E-06,
     *  8.57379628E-06, 8.58534983E-06, 8.61842788E-06, 8.67156726E-06,
     *  8.74352569E-06, 8.83327068E-06, 8.93996652E-06, 9.06295958E-06,
     *  9.20176224E-06,
     *  8.82320054E-06, 8.82163286E-06, 8.84295695E-06, 8.88552755E-06,
     *  8.94793736E-06, 9.02900554E-06, 9.12776471E-06, 9.24344588E-06,
     *  9.37546197E-06,
     *  9.07185320E-06, 9.05683510E-06, 9.06613917E-06, 9.09793159E-06,
     *  9.15063380E-06, 9.22291042E-06, 9.31365599E-06, 9.42197987E-06,
     *  9.54718933E-06,
     *  9.32002657E-06, 9.29121833E-06, 9.28822420E-06, 9.30901544E-06,
     *  9.35183646E-06, 9.41519171E-06, 9.49783202E-06, 9.59873925E-06,
     *  9.71710931E-06/
        DATA ((VISCV (J,K),J=19,27),K=19,27) /
     *  9.56795612E-06, 9.52501070E-06, 9.50943163E-06, 9.51898876E-06,
     *  9.55174389E-06, 9.60603612E-06, 9.68046735E-06, 9.77388675E-06,
     *  9.88537356E-06,
     *  9.81584657E-06, 9.75841166E-06, 9.72995485E-06, 9.72803776E-06,
     *  9.75053399E-06, 9.79561225E-06, 9.86172079E-06, 9.94757129E-06,
     *  1.00521214E-05,
     *  1.00638771E-05, 9.99159641E-06, 9.94996462E-06, 9.93632798E-06,
     *  9.94836607E-06, 9.98407231E-06, 1.00417367E-05, 1.01199291E-05,
     *  1.02174810E-05,
     *  1.03122057E-05, 1.02247196E-05, 1.01696123E-05, 1.01440069E-05,
     *  1.01453830E-05, 1.01715537E-05, 1.02206464E-05, 1.02910847E-05,
     *  1.03815700E-05,
     *  1.05609725E-05, 1.04579185E-05, 1.03890324E-05, 1.03512063E-05,
     *  1.03417131E-05, 1.03581806E-05, 1.03985690E-05, 1.04611519E-05,
     *  1.05444965E-05,
     *  1.08103032E-05, 1.06913159E-05, 1.06083455E-05, 1.05580443E-05,
     *  1.05374719E-05, 1.05440653E-05, 1.05756132E-05, 1.06302349E-05,
     *  1.07063599E-05,
     *  1.10603108E-05, 1.09250220E-05, 1.08276598E-05, 1.07646271E-05,
     *  1.07327636E-05, 1.07293096E-05, 1.07518776E-05, 1.07984290E-05,
     *  1.08672518E-05,
     *  1.13110978E-05, 1.11591367E-05, 1.10470729E-05, 1.09710509E-05,
     *  1.09276826E-05, 1.09140058E-05, 1.09274525E-05, 1.09658215E-05,
     *  1.10272560E-05,
     *  1.15627582E-05, 1.13937506E-05, 1.12666735E-05, 1.11774028E-05,
     *  1.11223146E-05, 1.10982383E-05, 1.11024200E-05, 1.11324925E-05,
     *  1.11864502E-05/
        DATA ((VISCV (J,K),J=19,27),K=28,36) /
     *  1.18153780E-05, 1.16289468E-05, 1.14865426E-05, 1.13837621E-05,
     *  1.13167377E-05, 1.12820838E-05, 1.12768556E-05, 1.12985154E-05,
     *  1.13449055E-05,
     *  1.20690369E-05, 1.18648016E-05, 1.17067542E-05, 1.15902015E-05,
     *  1.15110235E-05, 1.14656128E-05, 1.14508283E-05, 1.14639580E-05,
     *  1.15026880E-05,
     *  1.23238090E-05, 1.21013856E-05, 1.19273767E-05, 1.17967878E-05,
     *  1.17052375E-05, 1.16488897E-05, 1.16244018E-05, 1.16288825E-05,
     *  1.16598584E-05,
     *  1.25797635E-05, 1.23387643E-05, 1.21484732E-05, 1.20035825E-05,
     *  1.18994400E-05, 1.18319742E-05, 1.17976347E-05, 1.17933466E-05,
     *  1.18164732E-05,
     *  1.28369652E-05, 1.25769990E-05, 1.23701024E-05, 1.22106424E-05,
     *  1.20936871E-05, 1.20149211E-05, 1.19705810E-05, 1.19574034E-05,
     *  1.19725845E-05,
     *  1.30954754E-05, 1.28161468E-05, 1.25923189E-05, 1.24180207E-05,
     *  1.22880303E-05, 1.21977814E-05, 1.21432909E-05, 1.21211023E-05,
     *  1.21282407E-05,
     *  1.33553519E-05, 1.30562617E-05, 1.28151738E-05, 1.26257664E-05,
     *  1.24825177E-05, 1.23806022E-05, 1.23158110E-05, 1.22844893E-05,
     *  1.22834871E-05,
     *  1.36166498E-05, 1.32973946E-05, 1.30387151E-05, 1.28339259E-05,
     *  1.26771943E-05, 1.25634276E-05, 1.24881845E-05, 1.24476069E-05,
     *  1.24383657E-05,
     *  1.38794214E-05, 1.35395934E-05, 1.32629882E-05, 1.30425424E-05,
     *  1.28721021E-05, 1.27462986E-05, 1.26604519E-05, 1.26104951E-05,
     *  1.25929155E-05/
        DATA ((VISCV (J,K),J=19,27),K=37,45) /
     *  1.41437169E-05, 1.37829041E-05, 1.34880356E-05, 1.32516565E-05,
     *  1.30672803E-05, 1.29292536E-05, 1.28326509E-05, 1.27731910E-05,
     *  1.27471734E-05,
     *  1.44095842E-05, 1.40273701E-05, 1.37138980E-05, 1.34613068E-05,
     *  1.32627659E-05, 1.31123289E-05, 1.30048169E-05, 1.29357295E-05,
     *  1.29011736E-05,
     *  1.46770696E-05, 1.42730332E-05, 1.39406139E-05, 1.36715294E-05,
     *  1.34585940E-05, 1.32955581E-05, 1.31769832E-05, 1.30981433E-05,
     *  1.30549484E-05,
     *  1.49462177E-05, 1.45199331E-05, 1.41682197E-05, 1.38823589E-05,
     *  1.36547973E-05, 1.34789734E-05, 1.33491810E-05, 1.32604630E-05,
     *  1.32085281E-05,
     *  1.52170714E-05, 1.47681082E-05, 1.43967507E-05, 1.40938281E-05,
     *  1.38514072E-05, 1.36626048E-05, 1.35214398E-05, 1.34227177E-05,
     *  1.33619411E-05,
     *  1.54896725E-05, 1.50175954E-05, 1.46262402E-05, 1.43059681E-05,
     *  1.40484533E-05, 1.38464810E-05, 1.36937873E-05, 1.35849346E-05,
     *  1.35152143E-05,
     *  1.57640614E-05, 1.52684302E-05, 1.48567205E-05, 1.45188086E-05,
     *  1.42459636E-05, 1.40306290E-05, 1.38662500E-05, 1.37471396E-05,
     *  1.36683731E-05,
     *  1.60402776E-05, 1.55206471E-05, 1.50882224E-05, 1.47323782E-05,
     *  1.44439651E-05, 1.42150745E-05, 1.40388528E-05, 1.39093569E-05,
     *  1.38214414E-05,
     *  1.63183594E-05, 1.57742794E-05, 1.53207757E-05, 1.49467042E-05,
     *  1.46424834E-05, 1.43998419E-05, 1.42116192E-05, 1.40716099E-05,
     *  1.39744420E-05/
        DATA ((VISCV (J,K),J=19,27),K=46,54) /
     *  1.65983443E-05, 1.60293593E-05, 1.55544091E-05, 1.51618127E-05,
     *  1.48415429E-05, 1.45849547E-05, 1.43845720E-05, 1.42339203E-05,
     *  1.41273963E-05,
     *  1.68802690E-05, 1.62859183E-05, 1.57891503E-05, 1.53777291E-05,
     *  1.50411671E-05, 1.47704350E-05, 1.45577324E-05, 1.43963091E-05,
     *  1.42803250E-05,
     *  1.71641695E-05, 1.65439871E-05, 1.60250263E-05, 1.55944775E-05,
     *  1.52413786E-05, 1.49563042E-05, 1.47311211E-05, 1.45587962E-05,
     *  1.44332473E-05,
     *  1.74500810E-05, 1.68035955E-05, 1.62620632E-05, 1.58120815E-05,
     *  1.54421988E-05, 1.51425826E-05, 1.49047574E-05, 1.47214004E-05,
     *  1.45861818E-05,
     *  1.77380381E-05, 1.70647727E-05, 1.65002862E-05, 1.60305636E-05,
     *  1.56436488E-05, 1.53292897E-05, 1.50786601E-05, 1.48841400E-05,
     *  1.47391462E-05,
     *  1.80280751E-05, 1.73275473E-05, 1.67397201E-05, 1.62499459E-05,
     *  1.58457484E-05, 1.55164445E-05, 1.52528470E-05, 1.50470321E-05,
     *  1.48921572E-05,
     *  1.83202255E-05, 1.75919472E-05, 1.69803888E-05, 1.64702496E-05,
     *  1.60485171E-05, 1.57040648E-05, 1.54273354E-05, 1.52100932E-05,
     *  1.50452310E-05,
     *  1.86145225E-05, 1.78580000E-05, 1.72223158E-05, 1.66914953E-05,
     *  1.62519736E-05, 1.58921681E-05, 1.56021416E-05, 1.53733393E-05,
     *  1.51983830E-05,
     *  1.89109989E-05, 1.81257325E-05, 1.74655241E-05, 1.69137032E-05,
     *  1.64561361E-05, 1.60807711E-05, 1.57772815E-05, 1.55367855E-05,
     *  1.53516278E-05/
        DATA ((VISCV (J,K),J=19,27),K=55,63) /
     *  1.92096872E-05, 1.83951714E-05, 1.77100360E-05, 1.71368927E-05,
     *  1.66610219E-05, 1.62698901E-05, 1.59527704E-05, 1.57004463E-05,
     *  1.55049797E-05,
     *  1.95106195E-05, 1.86663428E-05, 1.79558736E-05, 1.73610830E-05,
     *  1.68666483E-05, 1.64595405E-05, 1.61286229E-05, 1.58643358E-05,
     *  1.56584520E-05,
     *  1.98138276E-05, 1.89392725E-05, 1.82030583E-05, 1.75862926E-05,
     *  1.70730316E-05, 1.66497377E-05, 1.63048532E-05, 1.60284675E-05,
     *  1.58120580E-05,
     *  2.01193431E-05, 1.92139859E-05, 1.84516113E-05, 1.78125396E-05,
     *  1.72801881E-05, 1.68404961E-05, 1.64814748E-05, 1.61928544E-05,
     *  1.59658100E-05,
     *  2.04271974E-05, 1.94905081E-05, 1.87015534E-05, 1.80398418E-05,
     *  1.74881333E-05, 1.70318301E-05, 1.66585012E-05, 1.63575089E-05,
     *  1.61197200E-05,
     *  2.07374216E-05, 1.97688641E-05, 1.89529051E-05, 1.82682167E-05,
     *  1.76968825E-05, 1.72237534E-05, 1.68359449E-05, 1.65224431E-05,
     *  1.62737998E-05,
     *  2.10500469E-05, 2.00490785E-05, 1.92056864E-05, 1.84976812E-05,
     *  1.79064506E-05, 1.74162794E-05, 1.70138184E-05, 1.66876688E-05,
     *  1.64280603E-05,
     *  2.13651040E-05, 2.03311756E-05, 1.94599174E-05, 1.87282521E-05,
     *  1.81168521E-05, 1.76094212E-05, 1.71921336E-05, 1.68531971E-05,
     *  1.65825125E-05,
     *  2.16826238E-05, 2.06151797E-05, 1.97156176E-05, 1.89599458E-05,
     *  1.83281013E-05, 1.78031913E-05, 1.73709023E-05, 1.70190391E-05,
     *  1.67371667E-05/
        DATA ((VISCV (J,K),J=19,27),K=64,72) /
     *  2.20026369E-05, 2.09011148E-05, 1.99728063E-05, 1.91927785E-05,
     *  1.85402121E-05, 1.79976023E-05, 1.75501357E-05, 1.71852051E-05,
     *  1.68920329E-05,
     *  2.23251741E-05, 2.11890048E-05, 2.02315028E-05, 1.94267660E-05,
     *  1.87531980E-05, 1.81926661E-05, 1.77298447E-05, 1.73517056E-05,
     *  1.70471210E-05,
     *  2.26502657E-05, 2.14788732E-05, 2.04917260E-05, 1.96619239E-05,
     *  1.89670725E-05, 1.83883945E-05, 1.79100402E-05, 1.75185504E-05,
     *  1.72024402E-05,
     *  2.29779425E-05, 2.17707439E-05, 2.07534946E-05, 1.98982678E-05,
     *  1.91818486E-05, 1.85847990E-05, 1.80907324E-05, 1.76857491E-05,
     *  1.73579997E-05,
     *  2.33082349E-05, 2.20646401E-05, 2.10168273E-05, 2.01358128E-05,
     *  1.93975392E-05, 1.87818909E-05, 1.82719315E-05, 1.78533112E-05,
     *  1.75138083E-05,
     *  2.36411733E-05, 2.23605854E-05, 2.12817425E-05, 2.03745740E-05,
     *  1.96141570E-05, 1.89796813E-05, 1.84536474E-05, 1.80212457E-05,
     *  1.76698746E-05,
     *  2.39767885E-05, 2.26586030E-05, 2.15482584E-05, 2.06145661E-05,
     *  1.98317144E-05, 1.91781807E-05, 1.86358897E-05, 1.81895615E-05,
     *  1.78262069E-05,
     *  2.43151110E-05, 2.29587162E-05, 2.18163934E-05, 2.08558038E-05,
     *  2.00502237E-05, 1.93774000E-05, 1.88186679E-05, 1.83582672E-05,
     *  1.79828133E-05,
     *  2.46561713E-05, 2.32609482E-05, 2.20861653E-05, 2.10983018E-05,
     *  2.02696968E-05, 1.95773494E-05, 1.90019912E-05, 1.85273712E-05,
     *  1.81397016E-05/
        DATA ((VISCV (J,K),J=19,27),K=73,81) /
     *  2.50000003E-05, 2.35653221E-05, 2.23575923E-05, 2.13420742E-05,
     *  2.04901458E-05, 1.97780390E-05, 1.91858685E-05, 1.86968817E-05,
     *  1.82968794E-05,
     *  2.53466286E-05, 2.38718611E-05, 2.26306922E-05, 2.15871355E-05,
     *  2.07115823E-05, 1.99794790E-05, 1.93703088E-05, 1.88668068E-05,
     *  1.84543543E-05,
     *  2.56960871E-05, 2.41805882E-05, 2.29054827E-05, 2.18334996E-05,
     *  2.09340180E-05, 2.01816792E-05, 1.95553206E-05, 1.90371541E-05,
     *  1.86121333E-05,
     *  2.60484068E-05, 2.44915267E-05, 2.31819816E-05, 2.20811806E-05,
     *  2.11574642E-05, 2.03846492E-05, 1.97409123E-05, 1.92079315E-05,
     *  1.87702236E-05,
     *  2.64036187E-05, 2.48046996E-05, 2.34602066E-05, 2.23301924E-05,
     *  2.13819323E-05, 2.05883986E-05, 1.99270924E-05, 1.93791462E-05,
     *  1.89286321E-05,
     *  2.67617541E-05, 2.51201300E-05, 2.37401751E-05, 2.25805488E-05,
     *  2.16074335E-05, 2.07929367E-05, 2.01138689E-05, 1.95508057E-05,
     *  1.90873653E-05,
     *  2.71228443E-05, 2.54378412E-05, 2.40219049E-05, 2.28322635E-05,
     *  2.18339788E-05, 2.09982728E-05, 2.03012499E-05, 1.97229170E-05,
     *  1.92464300E-05,
     *  2.74869206E-05, 2.57578562E-05, 2.43054134E-05, 2.30853502E-05,
     *  2.20615793E-05, 2.12044161E-05, 2.04892433E-05, 1.98954871E-05,
     *  1.94058325E-05,
     *  2.78540148E-05, 2.60801983E-05, 2.45907181E-05, 2.33398224E-05,
     *  2.22902457E-05, 2.14113756E-05, 2.06778567E-05, 2.00685230E-05,
     *  1.95655790E-05/
        DATA ((VISCV (J,K),J=28,36),K= 1, 9) /
     *  6.67037064E-06, 6.93424919E-06, 7.20861058E-06, 7.49401668E-06,
     *  7.79106850E-06, 8.10040920E-06, 8.42272724E-06, 8.75875985E-06,
     *  9.10929677E-06,
     *  6.89507593E-06, 7.15063491E-06, 7.41716723E-06, 7.69517629E-06,
     *  7.98520763E-06, 8.28785175E-06, 8.60374727E-06, 8.93358431E-06,
     *  9.27810815E-06,
     *  7.11224380E-06, 7.35996488E-06, 7.61909171E-06, 7.89007875E-06,
     *  8.17342467E-06, 8.46967510E-06, 8.77942561E-06, 9.10332501E-06,
     *  9.44207904E-06,
     *  7.32287016E-06, 7.56311840E-06, 7.81516402E-06, 8.07941911E-06,
     *  8.35634164E-06, 8.64643792E-06, 8.95026542E-06, 9.26843605E-06,
     *  9.60161973E-06,
     *  7.52771307E-06, 7.76077860E-06, 8.00600247E-06, 8.26375925E-06,
     *  8.53447079E-06, 8.81860835E-06, 9.11669524E-06, 9.42930994E-06,
     *  9.75708961E-06,
     *  7.72737557E-06, 7.95349672E-06, 8.19211343E-06, 8.44356609E-06,
     *  8.70824385E-06, 8.98658629E-06, 9.27908575E-06, 9.58629020E-06,
     *  9.90880670E-06,
     *  7.92235774E-06, 8.14173355E-06, 8.37392399E-06, 8.61923723E-06,
     *  8.87803210E-06, 9.15071902E-06, 9.43776190E-06, 9.73968073E-06,
     *  1.00570548E-05,
     *  8.11308788E-06, 8.32588532E-06, 8.55180318E-06, 8.79111820E-06,
     *  9.04416020E-06, 9.31131223E-06, 9.59301174E-06, 9.88975275E-06,
     *  1.02020887E-05,
     *  8.29994082E-06, 8.50629960E-06, 8.72607563E-06, 8.95951394E-06,
     *  9.20691583E-06, 9.46863799E-06, 9.74509284E-06, 1.00367500E-05,
     *  1.03441390E-05/
        DATA ((VISCV (J,K),J=28,36),K=10,18) /
     *  8.48324880E-06, 8.68328523E-06, 8.89703039E-06, 9.12469656E-06,
     *  9.36655633E-06, 9.62294044E-06, 9.89423715E-06, 1.01808930E-05,
     *  1.04834147E-05,
     *  8.66330871E-06, 8.85711882E-06, 9.06492684E-06, 9.28691074E-06,
     *  9.52331358E-06, 9.77444005E-06, 1.00406547E-05, 1.03223818E-05,
     *  1.06201064E-05,
     *  8.84038733E-06, 9.02804950E-06, 9.22999905E-06, 9.44637760E-06,
     *  9.67739748E-06, 9.92333678E-06, 1.01845364E-05, 1.04613988E-05,
     *  1.07543884E-05,
     *  9.01472561E-06, 9.19630264E-06, 9.39245906E-06, 9.60329780E-06,
     *  9.82899880E-06, 1.00698127E-05, 1.03260564E-05, 1.05981108E-05,
     *  1.08864201E-05,
     *  9.18654218E-06, 9.36208290E-06, 9.55249969E-06, 9.75785397E-06,
     *  9.97829140E-06, 1.02140339E-05, 1.04653738E-05, 1.07326705E-05,
     *  1.10163482E-05,
     *  9.35603634E-06, 9.52557691E-06, 9.71029679E-06, 9.91021285E-06,
     *  1.01254342E-05, 1.03561524E-05, 1.06026346E-05, 1.08652181E-05,
     *  1.11443075E-05,
     *  9.52339037E-06, 9.68695535E-06, 9.86601127E-06, 1.00605270E-05,
     *  1.02705726E-05, 1.04963077E-05, 1.07379727E-05, 1.09958825E-05,
     *  1.12704221E-05,
     *  9.68877153E-06, 9.84637486E-06, 1.00197908E-05, 1.02089366E-05,
     *  1.04138404E-05, 1.06346278E-05, 1.08715113E-05, 1.11247825E-05,
     *  1.13948066E-05,
     *  9.85233359E-06, 1.00039795E-05, 1.01717711E-05, 1.03555703E-05,
     *  1.05553604E-05, 1.07712305E-05, 1.10033638E-05, 1.12520276E-05,
     *  1.15175668E-05/
        DATA ((VISCV (J,K),J=28,36),K=19,27) /
     *  1.00142182E-05, 1.01599021E-05, 1.03220774E-05, 1.05005471E-05,
     *  1.06952460E-05, 1.09062247E-05, 1.11336350E-05, 1.13777191E-05,
     *  1.16388006E-05,
     *  1.01745557E-05, 1.03142651E-05, 1.04708254E-05, 1.06439765E-05,
     *  1.08336019E-05, 1.10397107E-05, 1.12624217E-05, 1.15019504E-05,
     *  1.17585987E-05,
     *  1.03334667E-05, 1.04671819E-05, 1.06181221E-05, 1.07859602E-05,
     *  1.09705250E-05, 1.11717817E-05, 1.13898137E-05, 1.16248085E-05,
     *  1.18770452E-05,
     *  1.04910619E-05, 1.06187571E-05, 1.07640664E-05, 1.09265922E-05,
     *  1.11061053E-05, 1.13025238E-05, 1.15158941E-05, 1.17463737E-05,
     *  1.19942183E-05,
     *  1.06474440E-05, 1.07690877E-05, 1.09087503E-05, 1.10659599E-05,
     *  1.12404260E-05, 1.14320173E-05, 1.16407402E-05, 1.18667211E-05,
     *  1.21101907E-05,
     *  1.08027073E-05, 1.09182634E-05, 1.10522590E-05, 1.12041444E-05,
     *  1.13735649E-05, 1.15603364E-05, 1.17644238E-05, 1.19859201E-05,
     *  1.22250299E-05,
     *  1.09569391E-05, 1.10663673E-05, 1.11946716E-05, 1.13412212E-05,
     *  1.15055940E-05, 1.16875508E-05, 1.18870119E-05, 1.21040357E-05,
     *  1.23387992E-05,
     *  1.11102201E-05, 1.12134765E-05, 1.13360616E-05, 1.14772606E-05,
     *  1.16365807E-05, 1.18137249E-05, 1.20085671E-05, 1.22211284E-05,
     *  1.24515573E-05,
     *  1.12626248E-05, 1.13596623E-05, 1.14764974E-05, 1.16123279E-05,
     *  1.17665877E-05, 1.19389193E-05, 1.21291475E-05, 1.23372548E-05,
     *  1.25633594E-05/
        DATA ((VISCV (J,K),J=28,36),K=28,36) /
     *  1.14142221E-05, 1.15049912E-05, 1.16160427E-05, 1.17464843E-05,
     *  1.18956737E-05, 1.20631904E-05, 1.22488078E-05, 1.24524679E-05,
     *  1.26742570E-05,
     *  1.15650759E-05, 1.16495246E-05, 1.17547566E-05, 1.18797866E-05,
     *  1.20238934E-05, 1.21865909E-05, 1.23675991E-05, 1.25668172E-05,
     *  1.27842983E-05,
     *  1.17152451E-05, 1.17933198E-05, 1.18926944E-05, 1.20122881E-05,
     *  1.21512981E-05, 1.23091703E-05, 1.24855691E-05, 1.26803491E-05,
     *  1.28935285E-05,
     *  1.18647848E-05, 1.19364300E-05, 1.20299076E-05, 1.21440384E-05,
     *  1.22779357E-05, 1.24309749E-05, 1.26027627E-05, 1.27931073E-05,
     *  1.30019903E-05,
     *  1.20137460E-05, 1.20789049E-05, 1.21664442E-05, 1.22750840E-05,
     *  1.24038511E-05, 1.25520482E-05, 1.27192221E-05, 1.29051326E-05,
     *  1.31097234E-05,
     *  1.21621761E-05, 1.22207907E-05, 1.23023492E-05, 1.24054684E-05,
     *  1.25290865E-05, 1.26724310E-05, 1.28349869E-05, 1.30164637E-05,
     *  1.32167655E-05,
     *  1.23101192E-05, 1.23621305E-05, 1.24376646E-05, 1.25352325E-05,
     *  1.26536814E-05, 1.27921617E-05, 1.29500942E-05, 1.31271367E-05,
     *  1.33231519E-05,
     *  1.24576167E-05, 1.25029648E-05, 1.25724297E-05, 1.26644145E-05,
     *  1.27776730E-05, 1.29112763E-05, 1.30645792E-05, 1.32371857E-05,
     *  1.34289160E-05,
     *  1.26047071E-05, 1.26433312E-05, 1.27066815E-05, 1.27930504E-05,
     *  1.29010961E-05, 1.30298087E-05, 1.31784748E-05, 1.33466430E-05,
     *  1.35340891E-05/
        DATA ((VISCV (J,K),J=28,36),K=37,45) /
     *  1.27514264E-05, 1.27832652E-05, 1.28404544E-05, 1.29211737E-05,
     *  1.30239837E-05, 1.31477909E-05, 1.32918122E-05, 1.34555389E-05,
     *  1.36387010E-05,
     *  1.28978085E-05, 1.29227999E-05, 1.29737810E-05, 1.30488164E-05,
     *  1.31463667E-05, 1.32652531E-05, 1.34046207E-05, 1.35639020E-05,
     *  1.37427797E-05,
     *  1.30438850E-05, 1.30619665E-05, 1.31066918E-05, 1.31760082E-05,
     *  1.32682742E-05, 1.33822236E-05, 1.35169282E-05, 1.36717595E-05,
     *  1.38463517E-05,
     *  1.31896858E-05, 1.32007943E-05, 1.32392157E-05, 1.33027774E-05,
     *  1.33897338E-05, 1.34987295E-05, 1.36287607E-05, 1.37791370E-05,
     *  1.39494421E-05,
     *  1.33352390E-05, 1.33393109E-05, 1.33713797E-05, 1.34291505E-05,
     *  1.35107715E-05, 1.36147960E-05, 1.37401432E-05, 1.38860587E-05,
     *  1.40520746E-05,
     *  1.34805710E-05, 1.34775425E-05, 1.35032095E-05, 1.35551526E-05,
     *  1.36314118E-05, 1.37304472E-05, 1.38510992E-05, 1.39925477E-05,
     *  1.41542718E-05,
     *  1.36257068E-05, 1.36155136E-05, 1.36347292E-05, 1.36808074E-05,
     *  1.37516780E-05, 1.38457059E-05, 1.39616507E-05, 1.40986256E-05,
     *  1.42560550E-05,
     *  1.37706701E-05, 1.37532473E-05, 1.37659616E-05, 1.38061375E-05,
     *  1.38715920E-05, 1.39605935E-05, 1.40718191E-05, 1.42043132E-05,
     *  1.43574444E-05,
     *  1.39154831E-05, 1.38907659E-05, 1.38969285E-05, 1.39311640E-05,
     *  1.39911748E-05, 1.40751305E-05, 1.41816242E-05, 1.43096301E-05,
     *  1.44584594E-05/
        DATA ((VISCV (J,K),J=28,36),K=46,54) /
     *  1.40601670E-05, 1.40280900E-05, 1.40276503E-05, 1.40559071E-05,
     *  1.41104462E-05, 1.41893364E-05, 1.42910852E-05, 1.44145950E-05,
     *  1.45591182E-05,
     *  1.42047420E-05, 1.41652396E-05, 1.41581466E-05, 1.41803859E-05,
     *  1.42294248E-05, 1.43032295E-05, 1.44002200E-05, 1.45192254E-05,
     *  1.46594382E-05,
     *  1.43492272E-05, 1.43022333E-05, 1.42884358E-05, 1.43046187E-05,
     *  1.43481286E-05, 1.44168273E-05, 1.45090458E-05, 1.46235384E-05,
     *  1.47594361E-05,
     *  1.44936407E-05, 1.44390890E-05, 1.44185354E-05, 1.44286227E-05,
     *  1.44665746E-05, 1.45301466E-05, 1.46175791E-05, 1.47275500E-05,
     *  1.48591275E-05,
     *  1.46379998E-05, 1.45758239E-05, 1.45484623E-05, 1.45524145E-05,
     *  1.45847789E-05, 1.46432033E-05, 1.47258354E-05, 1.48312754E-05,
     *  1.49585275E-05,
     *  1.47823211E-05, 1.47124540E-05, 1.46782324E-05, 1.46760095E-05,
     *  1.47027570E-05, 1.47560124E-05, 1.48338295E-05, 1.49347294E-05,
     *  1.50576504E-05,
     *  1.49266202E-05, 1.48489949E-05, 1.48078609E-05, 1.47994229E-05,
     *  1.48205235E-05, 1.48685883E-05, 1.49415757E-05, 1.50379257E-05,
     *  1.51565100E-05,
     *  1.50709123E-05, 1.49854613E-05, 1.49373623E-05, 1.49226689E-05,
     *  1.49380924E-05, 1.49809450E-05, 1.50490874E-05, 1.51408777E-05,
     *  1.52551194E-05,
     *  1.52152117E-05, 1.51218673E-05, 1.50667504E-05, 1.50457611E-05,
     *  1.50554772E-05, 1.50930954E-05, 1.51563776E-05, 1.52435980E-05,
     *  1.53534909E-05/
        DATA ((VISCV (J,K),J=28,36),K=55,63) /
     *  1.53595321E-05, 1.52582264E-05, 1.51960385E-05, 1.51687126E-05,
     *  1.51726907E-05, 1.52050523E-05, 1.52634586E-05, 1.53460989E-05,
     *  1.54516366E-05,
     *  1.55038869E-05, 1.53945516E-05, 1.53252394E-05, 1.52915357E-05,
     *  1.52897450E-05, 1.53168275E-05, 1.53703423E-05, 1.54483920E-05,
     *  1.55495678E-05,
     *  1.56482886E-05, 1.55308552E-05, 1.54543651E-05, 1.54142425E-05,
     *  1.54066520E-05, 1.54284328E-05, 1.54770400E-05, 1.55504883E-05,
     *  1.56472956E-05,
     *  1.57927494E-05, 1.56671491E-05, 1.55834273E-05, 1.55368444E-05,
     *  1.55234228E-05, 1.55398790E-05, 1.55835626E-05, 1.56523986E-05,
     *  1.57448304E-05,
     *  1.59372810E-05, 1.58034448E-05, 1.57124373E-05, 1.56593524E-05,
     *  1.56400683E-05, 1.56511768E-05, 1.56899203E-05, 1.57541330E-05,
     *  1.58421823E-05,
     *  1.60818946E-05, 1.59397531E-05, 1.58414056E-05, 1.57817769E-05,
     *  1.57565988E-05, 1.57623363E-05, 1.57961232E-05, 1.58557013E-05,
     *  1.59393608E-05,
     *  1.62266010E-05, 1.60760846E-05, 1.59703426E-05, 1.59041281E-05,
     *  1.58730241E-05, 1.58733672E-05, 1.59021809E-05, 1.59571130E-05,
     *  1.60363753E-05,
     *  1.63714106E-05, 1.62124495E-05, 1.60992583E-05, 1.60264158E-05,
     *  1.59893539E-05, 1.59842790E-05, 1.60081025E-05, 1.60583770E-05,
     *  1.61332347E-05,
     *  1.65163335E-05, 1.63488575E-05, 1.62281622E-05, 1.61486491E-05,
     *  1.61055973E-05, 1.60950806E-05, 1.61138969E-05, 1.61595021E-05,
     *  1.62299473E-05/
        DATA ((VISCV (J,K),J=28,36),K=64,72) /
     *  1.66613793E-05, 1.64853180E-05, 1.63570634E-05, 1.62708373E-05,
     *  1.62217631E-05, 1.62057807E-05, 1.62195726E-05, 1.62604966E-05,
     *  1.63265216E-05,
     *  1.68065574E-05, 1.66218401E-05, 1.64859709E-05, 1.63929888E-05,
     *  1.63378598E-05, 1.63163876E-05, 1.63251377E-05, 1.63613685E-05,
     *  1.64229653E-05,
     *  1.69518769E-05, 1.67584325E-05, 1.66148931E-05, 1.65151121E-05,
     *  1.64538955E-05, 1.64269092E-05, 1.64306001E-05, 1.64621255E-05,
     *  1.65192861E-05,
     *  1.70973464E-05, 1.68951037E-05, 1.67438382E-05, 1.66372151E-05,
     *  1.65698782E-05, 1.65373534E-05, 1.65359674E-05, 1.65627752E-05,
     *  1.66154912E-05,
     *  1.72429744E-05, 1.70318619E-05, 1.68728143E-05, 1.67593058E-05,
     *  1.66858155E-05, 1.66477276E-05, 1.66412469E-05, 1.66633245E-05,
     *  1.67115877E-05,
     *  1.73887691E-05, 1.71687149E-05, 1.70018290E-05, 1.68813915E-05,
     *  1.68017147E-05, 1.67580389E-05, 1.67464456E-05, 1.67637806E-05,
     *  1.68075824E-05,
     *  1.75347384E-05, 1.73056704E-05, 1.71308897E-05, 1.70034794E-05,
     *  1.69175828E-05, 1.68682943E-05, 1.68515703E-05, 1.68641499E-05,
     *  1.69034818E-05,
     *  1.76808900E-05, 1.74427358E-05, 1.72600035E-05, 1.71255767E-05,
     *  1.70334267E-05, 1.69785005E-05, 1.69566276E-05, 1.69644390E-05,
     *  1.69992923E-05,
     *  1.78272314E-05, 1.75799182E-05, 1.73891775E-05, 1.72476900E-05,
     *  1.71492530E-05, 1.70886640E-05, 1.70616238E-05, 1.70646540E-05,
     *  1.70950199E-05/
        DATA ((VISCV (J,K),J=28,36),K=73,81) /
     *  1.79737697E-05, 1.77172247E-05, 1.75184184E-05, 1.73698258E-05,
     *  1.72650681E-05, 1.71987909E-05, 1.71665650E-05, 1.71648010E-05,
     *  1.71906706E-05,
     *  1.81205120E-05, 1.78546618E-05, 1.76477327E-05, 1.74919907E-05,
     *  1.73808782E-05, 1.73088874E-05, 1.72714572E-05, 1.72648857E-05,
     *  1.72862500E-05,
     *  1.82674652E-05, 1.79922363E-05, 1.77771266E-05, 1.76141905E-05,
     *  1.74966893E-05, 1.74189592E-05, 1.73763060E-05, 1.73649138E-05,
     *  1.73817635E-05,
     *  1.84146358E-05, 1.81299543E-05, 1.79066063E-05, 1.77364314E-05,
     *  1.76125070E-05, 1.75290121E-05, 1.74811171E-05, 1.74648907E-05,
     *  1.74772167E-05,
     *  1.85620303E-05, 1.82678222E-05, 1.80361778E-05, 1.78587190E-05,
     *  1.77283372E-05, 1.76390515E-05, 1.75858956E-05, 1.75648216E-05,
     *  1.75726144E-05,
     *  1.87096551E-05, 1.84058458E-05, 1.81658468E-05, 1.79810590E-05,
     *  1.78441852E-05, 1.77490828E-05, 1.76906469E-05, 1.76647116E-05,
     *  1.76679619E-05,
     *  1.88575163E-05, 1.85440310E-05, 1.82956189E-05, 1.81034568E-05,
     *  1.79600562E-05, 1.78591110E-05, 1.77953760E-05, 1.77645656E-05,
     *  1.77632637E-05,
     *  1.90056198E-05, 1.86823834E-05, 1.84254996E-05, 1.82259176E-05,
     *  1.80759554E-05, 1.79691412E-05, 1.79000878E-05, 1.78643884E-05,
     *  1.78585248E-05,
     *  1.91539714E-05, 1.88209087E-05, 1.85554941E-05, 1.83484466E-05,
     *  1.81918879E-05, 1.80791782E-05, 1.80047869E-05, 1.79641845E-05,
     *  1.79537494E-05/
        DATA ((VISCV (J,K),J=37,45),K= 1, 9) /
     *  9.47518435E-06, 9.82799898E-06, 1.01030041E-05, 1.04877386E-05,
     *  1.09279354E-05, 1.13876244E-05, 1.18678549E-05, 1.23697090E-05,
     *  1.28943052E-05,
     *  9.63812320E-06, 9.98516647E-06, 1.02544643E-05, 1.06335210E-05,
     *  1.10680365E-05, 1.15220106E-05, 1.19964636E-05, 1.24924507E-05,
     *  1.30110653E-05,
     *  9.79645429E-06, 1.01379516E-05, 1.04017629E-05, 1.07753595E-05,
     *  1.12044105E-05, 1.16528857E-05, 1.21217775E-05, 1.26121145E-05,
     *  1.31249647E-05,
     *  9.95054832E-06, 1.02866891E-05, 1.05452015E-05, 1.09135257E-05,
     *  1.13373005E-05, 1.17804671E-05, 1.22439900E-05, 1.27288714E-05,
     *  1.32361540E-05,
     *  1.01007340E-05, 1.04316791E-05, 1.06850536E-05, 1.10482676E-05,
     *  1.14669310E-05, 1.19049566E-05, 1.23632818E-05, 1.28428824E-05,
     *  1.33447755E-05,
     *  1.02473053E-05, 1.05731923E-05, 1.08215676E-05, 1.11798125E-05,
     *  1.15935088E-05, 1.20265418E-05, 1.24798219E-05, 1.29542987E-05,
     *  1.34509640E-05,
     *  1.03905263E-05, 1.07114742E-05, 1.09549706E-05, 1.13083695E-05,
     *  1.17172256E-05, 1.21453973E-05, 1.25937684E-05, 1.30632626E-05,
     *  1.35548463E-05,
     *  1.05306362E-05, 1.08467480E-05, 1.10854703E-05, 1.14341311E-05,
     *  1.18382587E-05, 1.22616854E-05, 1.27052692E-05, 1.31699080E-05,
     *  1.36565427E-05,
     *  1.06678521E-05, 1.09792178E-05, 1.12132578E-05, 1.15572750E-05,
     *  1.19567726E-05, 1.23755577E-05, 1.28144628E-05, 1.32743604E-05,
     *  1.37561664E-05/
        DATA ((VISCV (J,K),J=37,45),K=10,18) /
     *  1.08023720E-05, 1.11090705E-05, 1.13385084E-05, 1.16779653E-05,
     *  1.20729201E-05, 1.24871553E-05, 1.29214788E-05, 1.33767382E-05,
     *  1.38538245E-05,
     *  1.09343769E-05, 1.12364774E-05, 1.14613842E-05, 1.17963540E-05,
     *  1.21868430E-05, 1.25966100E-05, 1.30264387E-05, 1.34771526E-05,
     *  1.39496178E-05,
     *  1.10640330E-05, 1.13615965E-05, 1.15820344E-05, 1.19125820E-05,
     *  1.22986733E-05, 1.27040446E-05, 1.31294564E-05, 1.35757081E-05,
     *  1.40436418E-05,
     *  1.11914928E-05, 1.14845733E-05, 1.17005972E-05, 1.20267797E-05,
     *  1.24085339E-05, 1.28095742E-05, 1.32306385E-05, 1.36725031E-05,
     *  1.41359863E-05,
     *  1.13168968E-05, 1.16055418E-05, 1.18172004E-05, 1.21390686E-05,
     *  1.25165392E-05, 1.29133060E-05, 1.33300850E-05, 1.37676301E-05,
     *  1.42267363E-05,
     *  1.14403742E-05, 1.17246262E-05, 1.19319627E-05, 1.22495613E-05,
     *  1.26227960E-05, 1.30153403E-05, 1.34278897E-05, 1.38611761E-05,
     *  1.43159718E-05,
     *  1.15620448E-05, 1.18419414E-05, 1.20449939E-05, 1.23583627E-05,
     *  1.27274036E-05, 1.31157712E-05, 1.35241407E-05, 1.39532231E-05,
     *  1.44037686E-05,
     *  1.16820189E-05, 1.19575935E-05, 1.21563961E-05, 1.24655704E-05,
     *  1.28304550E-05, 1.32146864E-05, 1.36189206E-05, 1.40438482E-05,
     *  1.44901980E-05,
     *  1.18003988E-05, 1.20716812E-05, 1.22662642E-05, 1.25712754E-05,
     *  1.29320371E-05, 1.33121684E-05, 1.37123071E-05, 1.41331241E-05,
     *  1.45753275E-05/
        DATA ((VISCV (J,K),J=37,45),K=19,27) /
     *  1.19172791E-05, 1.21842961E-05, 1.23746863E-05, 1.26755624E-05,
     *  1.30322307E-05, 1.34082942E-05, 1.38043729E-05, 1.42211191E-05,
     *  1.46592208E-05,
     *  1.20327479E-05, 1.22955233E-05, 1.24817449E-05, 1.27785105E-05,
     *  1.31311119E-05, 1.35031362E-05, 1.38951868E-05, 1.43078979E-05,
     *  1.47419382E-05,
     *  1.21468866E-05, 1.24054419E-05, 1.25875163E-05, 1.28801937E-05,
     *  1.32287516E-05, 1.35967623E-05, 1.39848131E-05, 1.43935211E-05,
     *  1.48235364E-05,
     *  1.22597713E-05, 1.25141256E-05, 1.26920721E-05, 1.29806810E-05,
     *  1.33252163E-05, 1.36892360E-05, 1.40733125E-05, 1.44780461E-05,
     *  1.49040693E-05,
     *  1.23714725E-05, 1.26216432E-05, 1.27954789E-05, 1.30800371E-05,
     *  1.34205683E-05, 1.37806174E-05, 1.41607420E-05, 1.45615271E-05,
     *  1.49835878E-05,
     *  1.24820562E-05, 1.27280586E-05, 1.28977992E-05, 1.31783223E-05,
     *  1.35148661E-05, 1.38709624E-05, 1.42471554E-05, 1.46440150E-05,
     *  1.50621399E-05,
     *  1.25915838E-05, 1.28334319E-05, 1.29990913E-05, 1.32755934E-05,
     *  1.36081645E-05, 1.39603241E-05, 1.43326033E-05, 1.47255581E-05,
     *  1.51397713E-05,
     *  1.27001126E-05, 1.29378190E-05, 1.30994096E-05, 1.33719035E-05,
     *  1.37005150E-05, 1.40487521E-05, 1.44171336E-05, 1.48062019E-05,
     *  1.52165250E-05,
     *  1.28076965E-05, 1.30412724E-05, 1.31988055E-05, 1.34673023E-05,
     *  1.37919660E-05, 1.41362933E-05, 1.45007913E-05, 1.48859895E-05,
     *  1.52924418E-05/
        DATA ((VISCV (J,K),J=37,45),K=28,36) /
     *  1.29143856E-05, 1.31438411E-05, 1.32973269E-05, 1.35618369E-05,
     *  1.38825632E-05, 1.42229918E-05, 1.45836188E-05, 1.49649616E-05,
     *  1.53675606E-05,
     *  1.30202271E-05, 1.32455713E-05, 1.33950188E-05, 1.36555511E-05,
     *  1.39723493E-05, 1.43088892E-05, 1.46656563E-05, 1.50431567E-05,
     *  1.54419179E-05,
     *  1.31252653E-05, 1.33465063E-05, 1.34919237E-05, 1.37484863E-05,
     *  1.40613647E-05, 1.43940247E-05, 1.47469418E-05, 1.51206113E-05,
     *  1.55155485E-05,
     *  1.32295415E-05, 1.34466865E-05, 1.35880812E-05, 1.38406815E-05,
     *  1.41496475E-05, 1.44784353E-05, 1.48275111E-05, 1.51973599E-05,
     *  1.55884855E-05,
     *  1.33330949E-05, 1.35461504E-05, 1.36835289E-05, 1.39321735E-05,
     *  1.42372336E-05, 1.45621562E-05, 1.49073982E-05, 1.52734352E-05,
     *  1.56607602E-05,
     *  1.34359622E-05, 1.36449339E-05, 1.37783022E-05, 1.40229969E-05,
     *  1.43241569E-05, 1.46452202E-05, 1.49866352E-05, 1.53488682E-05,
     *  1.57324022E-05,
     *  1.35381780E-05, 1.37430710E-05, 1.38724343E-05, 1.41131843E-05,
     *  1.44104493E-05, 1.47276587E-05, 1.50652525E-05, 1.54236884E-05,
     *  1.58034400E-05,
     *  1.36397749E-05, 1.38405935E-05, 1.39659566E-05, 1.42027666E-05,
     *  1.44961413E-05, 1.48095013E-05, 1.51432789E-05, 1.54979237E-05,
     *  1.58739002E-05,
     *  1.37407838E-05, 1.39375319E-05, 1.40588989E-05, 1.42917730E-05,
     *  1.45812613E-05, 1.48907760E-05, 1.52207417E-05, 1.55716005E-05,
     *  1.59438085E-05/
        DATA ((VISCV (J,K),J=37,45),K=37,45) /
     *  1.38412336E-05, 1.40339145E-05, 1.41512891E-05, 1.43802310E-05,
     *  1.46658366E-05, 1.49715094E-05, 1.52976669E-05, 1.56447441E-05,
     *  1.60131892E-05,
     *  1.39411519E-05, 1.41297684E-05, 1.42431539E-05, 1.44681669E-05,
     *  1.47498927E-05, 1.50517266E-05, 1.53740790E-05, 1.57173783E-05,
     *  1.60820653E-05,
     *  1.40405647E-05, 1.42251192E-05, 1.43345184E-05, 1.45556053E-05,
     *  1.48334540E-05, 1.51314515E-05, 1.54500015E-05, 1.57895260E-05,
     *  1.61504589E-05,
     *  1.41394965E-05, 1.43199909E-05, 1.44254063E-05, 1.46425697E-05,
     *  1.49165437E-05, 1.52107069E-05, 1.55254566E-05, 1.58612088E-05,
     *  1.62183910E-05,
     *  1.42379707E-05, 1.44144066E-05, 1.45158403E-05, 1.47290823E-05,
     *  1.49991835E-05, 1.52895143E-05, 1.56004654E-05, 1.59324472E-05,
     *  1.62858816E-05,
     *  1.43360094E-05, 1.45083880E-05, 1.46058419E-05, 1.48151643E-05,
     *  1.50813944E-05, 1.53678941E-05, 1.56750479E-05, 1.60032610E-05,
     *  1.63529496E-05,
     *  1.44336335E-05, 1.46019557E-05, 1.46954312E-05, 1.49008357E-05,
     *  1.51631961E-05, 1.54458658E-05, 1.57492234E-05, 1.60736687E-05,
     *  1.64196133E-05,
     *  1.45308630E-05, 1.46951293E-05, 1.47846277E-05, 1.49861156E-05,
     *  1.52446074E-05, 1.55234481E-05, 1.58230100E-05, 1.61436884E-05,
     *  1.64858901E-05,
     *  1.46277168E-05, 1.47879275E-05, 1.48734497E-05, 1.50710221E-05,
     *  1.53256463E-05, 1.56006584E-05, 1.58964250E-05, 1.62133368E-05,
     *  1.65517964E-05/
        DATA ((VISCV (J,K),J=37,45),K=46,54) /
     *  1.47242129E-05, 1.48803679E-05, 1.49619147E-05, 1.51555726E-05,
     *  1.54063298E-05, 1.56775138E-05, 1.59694851E-05, 1.62826303E-05,
     *  1.66173482E-05,
     *  1.48203683E-05, 1.49724675E-05, 1.50500393E-05, 1.52397833E-05,
     *  1.54866741E-05, 1.57540300E-05, 1.60422060E-05, 1.63515844E-05,
     *  1.66825605E-05,
     *  1.49161995E-05, 1.50642423E-05, 1.51378394E-05, 1.53236701E-05,
     *  1.55666947E-05, 1.58302226E-05, 1.61146028E-05, 1.64202139E-05,
     *  1.67474477E-05,
     *  1.50117218E-05, 1.51557076E-05, 1.52253302E-05, 1.54072478E-05,
     *  1.56464064E-05, 1.59061061E-05, 1.61866899E-05, 1.64885328E-05,
     *  1.68120239E-05,
     *  1.51069502E-05, 1.52468779E-05, 1.53125260E-05, 1.54905307E-05,
     *  1.57258233E-05, 1.59816943E-05, 1.62584810E-05, 1.65565548E-05,
     *  1.68763020E-05,
     *  1.52018987E-05, 1.53377673E-05, 1.53994405E-05, 1.55735323E-05,
     *  1.58049588E-05, 1.60570006E-05, 1.63299893E-05, 1.66242927E-05,
     *  1.69402949E-05,
     *  1.52965809E-05, 1.54283890E-05, 1.54860870E-05, 1.56562658E-05,
     *  1.58838259E-05, 1.61320378E-05, 1.64012273E-05, 1.66917589E-05,
     *  1.70040146E-05,
     *  1.53910095E-05, 1.55187557E-05, 1.55724779E-05, 1.57387435E-05,
     *  1.59624367E-05, 1.62068180E-05, 1.64722071E-05, 1.67589652E-05,
     *  1.70674727E-05,
     *  1.54851969E-05, 1.56088796E-05, 1.56586253E-05, 1.58209772E-05,
     *  1.60408030E-05, 1.62813528E-05, 1.65429401E-05, 1.68259231E-05,
     *  1.71306805E-05/
        DATA ((VISCV (J,K),J=37,45),K=55,63) /
     *  1.55791549E-05, 1.56987722E-05, 1.57445406E-05, 1.59029783E-05,
     *  1.61189362E-05, 1.63556534E-05, 1.66134374E-05, 1.68926433E-05,
     *  1.71936485E-05,
     *  1.56728947E-05, 1.57884448E-05, 1.58302348E-05, 1.59847578E-05,
     *  1.61968470E-05, 1.64297305E-05, 1.66837095E-05, 1.69591363E-05,
     *  1.72563870E-05,
     *  1.57664271E-05, 1.58779078E-05, 1.59157185E-05, 1.60663260E-05,
     *  1.62745456E-05, 1.65035942E-05, 1.67537666E-05, 1.70254121E-05,
     *  1.73189058E-05,
     *  1.58597625E-05, 1.59671715E-05, 1.60010017E-05, 1.61476929E-05,
     *  1.63520421E-05, 1.65772545E-05, 1.68236184E-05, 1.70914803E-05,
     *  1.73812145E-05,
     *  1.59529107E-05, 1.60562457E-05, 1.60860940E-05, 1.62288680E-05,
     *  1.64293458E-05, 1.66507206E-05, 1.68932742E-05, 1.71573501E-05,
     *  1.74433219E-05,
     *  1.60458812E-05, 1.61451398E-05, 1.61710048E-05, 1.63098606E-05,
     *  1.65064659E-05, 1.67240016E-05, 1.69627429E-05, 1.72230302E-05,
     *  1.75052369E-05,
     *  1.61386831E-05, 1.62338627E-05, 1.62557429E-05, 1.63906794E-05,
     *  1.65834110E-05, 1.67971062E-05, 1.70320331E-05, 1.72885293E-05,
     *  1.75669678E-05,
     *  1.62313252E-05, 1.63224230E-05, 1.63403169E-05, 1.64713330E-05,
     *  1.66601897E-05, 1.68700427E-05, 1.71011530E-05, 1.73538554E-05,
     *  1.76285226E-05,
     *  1.63238160E-05, 1.64108292E-05, 1.64247350E-05, 1.65518293E-05,
     *  1.67368099E-05, 1.69428190E-05, 1.71701106E-05, 1.74190164E-05,
     *  1.76899091E-05/
        DATA ((VISCV (J,K),J=37,45),K=64,72) /
     *  1.64161633E-05, 1.64990891E-05, 1.65090050E-05, 1.66321763E-05,
     *  1.68132793E-05, 1.70154429E-05, 1.72389134E-05, 1.74840199E-05,
     *  1.77511347E-05,
     *  1.65083752E-05, 1.65872103E-05, 1.65931345E-05, 1.67123814E-05,
     *  1.68896055E-05, 1.70879217E-05, 1.73075689E-05, 1.75488730E-05,
     *  1.78122066E-05,
     *  1.66004589E-05, 1.66752004E-05, 1.66771308E-05, 1.67924519E-05,
     *  1.69657955E-05, 1.71602626E-05, 1.73760841E-05, 1.76135829E-05,
     *  1.78731317E-05,
     *  1.66924218E-05, 1.67630663E-05, 1.67610010E-05, 1.68723946E-05,
     *  1.70418564E-05, 1.72324724E-05, 1.74444656E-05, 1.76781561E-05,
     *  1.79339167E-05,
     *  1.67842707E-05, 1.68508150E-05, 1.68447517E-05, 1.69522163E-05,
     *  1.71177946E-05, 1.73045576E-05, 1.75127202E-05, 1.77425992E-05,
     *  1.79945678E-05,
     *  1.68760123E-05, 1.69384529E-05, 1.69283895E-05, 1.70319235E-05,
     *  1.71936165E-05, 1.73765246E-05, 1.75808540E-05, 1.78069184E-05,
     *  1.80550913E-05,
     *  1.69676531E-05, 1.70259865E-05, 1.70119207E-05, 1.71115222E-05,
     *  1.72693285E-05, 1.74483795E-05, 1.76488732E-05, 1.78711197E-05,
     *  1.81154932E-05,
     *  1.70591993E-05, 1.71134219E-05, 1.70953513E-05, 1.71910186E-05,
     *  1.73449362E-05, 1.75201282E-05, 1.77167835E-05, 1.79352089E-05,
     *  1.81757792E-05,
     *  1.71506568E-05, 1.72007649E-05, 1.71786871E-05, 1.72704184E-05,
     *  1.74204456E-05, 1.75917764E-05, 1.77845906E-05, 1.79991917E-05,
     *  1.82359548E-05/
        DATA ((VISCV (J,K),J=37,45),K=73,81) /
     *  1.72420315E-05, 1.72880213E-05, 1.72619338E-05, 1.73497271E-05,
     *  1.74958621E-05, 1.76633296E-05, 1.78523000E-05, 1.80630734E-05,
     *  1.82960253E-05,
     *  1.73333289E-05, 1.73751965E-05, 1.73450968E-05, 1.74289501E-05,
     *  1.75711911E-05, 1.77347930E-05, 1.79199170E-05, 1.81268592E-05,
     *  1.83559959E-05,
     *  1.74245545E-05, 1.74622960E-05, 1.74281813E-05, 1.75080927E-05,
     *  1.76464376E-05, 1.78061718E-05, 1.79874465E-05, 1.81905541E-05,
     *  1.84158716E-05,
     *  1.75157134E-05, 1.75493248E-05, 1.75111924E-05, 1.75871598E-05,
     *  1.77216066E-05, 1.78774708E-05, 1.80548934E-05, 1.82541631E-05,
     *  1.84756573E-05,
     *  1.76068108E-05, 1.76362879E-05, 1.75941351E-05, 1.76661563E-05,
     *  1.77967031E-05, 1.79486949E-05, 1.81222626E-05, 1.83176907E-05,
     *  1.85353574E-05,
     *  1.76978514E-05, 1.77231901E-05, 1.76770139E-05, 1.77450868E-05,
     *  1.78717315E-05, 1.80198486E-05, 1.81895585E-05, 1.83811416E-05,
     *  1.85949766E-05,
     *  1.77888401E-05, 1.78100360E-05, 1.77598337E-05, 1.78239559E-05,
     *  1.79466964E-05, 1.80909365E-05, 1.82567856E-05, 1.84445201E-05,
     *  1.86545193E-05,
     *  1.78797814E-05, 1.78968302E-05, 1.78425987E-05, 1.79027680E-05,
     *  1.80216021E-05, 1.81619627E-05, 1.83239482E-05, 1.85078304E-05,
     *  1.87139894E-05,
     *  1.79706797E-05, 1.79835771E-05, 1.79253133E-05, 1.79815274E-05,
     *  1.80964528E-05, 1.82329315E-05, 1.83910504E-05, 1.85710768E-05,
     *  1.87733913E-05/
        DATA ((VISCV (J,K),J=46,54),K= 1, 9) /
     *  1.34428012E-05, 1.40163967E-05, 1.46163364E-05, 1.52439134E-05,
     *  1.59004718E-05, 1.65874103E-05, 1.73061849E-05, 1.80583128E-05,
     *  1.88453756E-05,
     *  1.35534409E-05, 1.41207548E-05, 1.47142301E-05, 1.53351394E-05,
     *  1.59848069E-05, 1.66646122E-05, 1.73759926E-05, 1.81204467E-05,
     *  1.88995377E-05,
     *  1.36614377E-05, 1.42226878E-05, 1.48099164E-05, 1.54243752E-05,
     *  1.60673682E-05, 1.67402554E-05, 1.74444550E-05, 1.81814468E-05,
     *  1.89527753E-05,
     *  1.37669231E-05, 1.43223099E-05, 1.49034937E-05, 1.55117045E-05,
     *  1.61482260E-05, 1.68143979E-05, 1.75116191E-05, 1.82413502E-05,
     *  1.90051164E-05,
     *  1.38700223E-05, 1.44197302E-05, 1.49950560E-05, 1.55972077E-05,
     *  1.62274480E-05, 1.68870960E-05, 1.75775307E-05, 1.83001928E-05,
     *  1.90565883E-05,
     *  1.39708541E-05, 1.45150527E-05, 1.50846934E-05, 1.56809621E-05,
     *  1.63050996E-05, 1.69584041E-05, 1.76422339E-05, 1.83580097E-05,
     *  1.91072174E-05,
     *  1.40695311E-05, 1.46083763E-05, 1.51724922E-05, 1.57630418E-05,
     *  1.63812437E-05, 1.70283746E-05, 1.77057716E-05, 1.84148348E-05,
     *  1.91570296E-05,
     *  1.41661601E-05, 1.46997954E-05, 1.52585346E-05, 1.58435178E-05,
     *  1.64559407E-05, 1.70970581E-05, 1.77681852E-05, 1.84707011E-05,
     *  1.92060502E-05,
     *  1.42608426E-05, 1.47893996E-05, 1.53428993E-05, 1.59224582E-05,
     *  1.65292489E-05, 1.71645034E-05, 1.78295149E-05, 1.85256405E-05,
     *  1.92543034E-05/
        DATA ((VISCV (J,K),J=46,54),K=10,18) /
     *  1.43536745E-05, 1.48772742E-05, 1.54256613E-05, 1.59999282E-05,
     *  1.66012239E-05, 1.72307574E-05, 1.78897992E-05, 1.85796840E-05,
     *  1.93018131E-05,
     *  1.44447466E-05, 1.49635003E-05, 1.55068921E-05, 1.60759901E-05,
     *  1.66719194E-05, 1.72958655E-05, 1.79490755E-05, 1.86328616E-05,
     *  1.93486023E-05,
     *  1.45341452E-05, 1.50481551E-05, 1.55866600E-05, 1.61507035E-05,
     *  1.67413868E-05, 1.73598710E-05, 1.80073799E-05, 1.86852021E-05,
     *  1.93946933E-05,
     *  1.46219517E-05, 1.51313115E-05, 1.56650299E-05, 1.62241256E-05,
     *  1.68096752E-05, 1.74228158E-05, 1.80647470E-05, 1.87367336E-05,
     *  1.94401078E-05,
     *  1.47082434E-05, 1.52130393E-05, 1.57420637E-05, 1.62963106E-05,
     *  1.68768320E-05, 1.74847401E-05, 1.81212103E-05, 1.87874832E-05,
     *  1.94848668E-05,
     *  1.47930933E-05, 1.52934045E-05, 1.58178204E-05, 1.63673107E-05,
     *  1.69429022E-05, 1.75456825E-05, 1.81768021E-05, 1.88374769E-05,
     *  1.95289906E-05,
     *  1.48765707E-05, 1.53724696E-05, 1.58923563E-05, 1.64371755E-05,
     *  1.70079293E-05, 1.76056801E-05, 1.82315533E-05, 1.88867400E-05,
     *  1.95724989E-05,
     *  1.49587411E-05, 1.54502944E-05, 1.59657248E-05, 1.65059525E-05,
     *  1.70719547E-05, 1.76647684E-05, 1.82854939E-05, 1.89352969E-05,
     *  1.96154108E-05,
     *  1.50396666E-05, 1.55269353E-05, 1.60379769E-05, 1.65736871E-05,
     *  1.71350180E-05, 1.77229817E-05, 1.83386526E-05, 1.89831710E-05,
     *  1.96577448E-05/
        DATA ((VISCV (J,K),J=46,54),K=19,27) /
     *  1.51194059E-05, 1.56024461E-05, 1.61091611E-05, 1.66404224E-05,
     *  1.71971574E-05, 1.77803527E-05, 1.83910571E-05, 1.90303850E-05,
     *  1.96995185E-05,
     *  1.51980149E-05, 1.56768778E-05, 1.61793236E-05, 1.67061999E-05,
     *  1.72584092E-05, 1.78369129E-05, 1.84427340E-05, 1.90769609E-05,
     *  1.97407494E-05,
     *  1.52755461E-05, 1.57502788E-05, 1.62485084E-05, 1.67710589E-05,
     *  1.73188083E-05, 1.78926925E-05, 1.84937089E-05, 1.91229196E-05,
     *  1.97814540E-05,
     *  1.53520497E-05, 1.58226951E-05, 1.63167574E-05, 1.68350371E-05,
     *  1.73783879E-05, 1.79477206E-05, 1.85440065E-05, 1.91682816E-05,
     *  1.98216486E-05,
     *  1.54275731E-05, 1.58941707E-05, 1.63841106E-05, 1.68981705E-05,
     *  1.74371801E-05, 1.80020248E-05, 1.85936504E-05, 1.92130663E-05,
     *  1.98613486E-05,
     *  1.55021613E-05, 1.59647469E-05, 1.64506059E-05, 1.69604935E-05,
     *  1.74952152E-05, 1.80556319E-05, 1.86426635E-05, 1.92572929E-05,
     *  1.99005692E-05,
     *  1.55758567E-05, 1.60344634E-05, 1.65162798E-05, 1.70220388E-05,
     *  1.75525227E-05, 1.81085675E-05, 1.86910676E-05, 1.93009794E-05,
     *  1.99393250E-05,
     *  1.56487001E-05, 1.61033578E-05, 1.65811666E-05, 1.70828378E-05,
     *  1.76091305E-05, 1.81608562E-05, 1.87388839E-05, 1.93441434E-05,
     *  1.99776299E-05,
     *  1.57207297E-05, 1.61714658E-05, 1.66452994E-05, 1.71429204E-05,
     *  1.76650653E-05, 1.82125216E-05, 1.87861325E-05, 1.93868019E-05,
     *  2.00154977E-05/
        DATA ((VISCV (J,K),J=46,54),K=28,36) /
     *  1.57919819E-05, 1.62388215E-05, 1.67087095E-05, 1.72023153E-05,
     *  1.77203530E-05, 1.82635862E-05, 1.88328331E-05, 1.94289713E-05,
     *  2.00529414E-05,
     *  1.58624916E-05, 1.63054572E-05, 1.67714269E-05, 1.72610497E-05,
     *  1.77750180E-05, 1.83140718E-05, 1.88790044E-05, 1.94706672E-05,
     *  2.00899738E-05,
     *  1.59322914E-05, 1.63714039E-05, 1.68334801E-05, 1.73191499E-05,
     *  1.78290840E-05, 1.83639993E-05, 1.89246644E-05, 1.95119049E-05,
     *  2.01266071E-05,
     *  1.60014129E-05, 1.64366908E-05, 1.68948965E-05, 1.73766408E-05,
     *  1.78825734E-05, 1.84133886E-05, 1.89698306E-05, 1.95526989E-05,
     *  2.01628532E-05,
     *  1.60698856E-05, 1.65013459E-05, 1.69557020E-05, 1.74335463E-05,
     *  1.79355080E-05, 1.84622590E-05, 1.90145195E-05, 1.95930635E-05,
     *  2.01987237E-05,
     *  1.61377378E-05, 1.65653959E-05, 1.70159215E-05, 1.74898893E-05,
     *  1.79879084E-05, 1.85106290E-05, 1.90587473E-05, 1.96330121E-05,
     *  2.02342294E-05,
     *  1.62049966E-05, 1.66288662E-05, 1.70755788E-05, 1.75456916E-05,
     *  1.80397946E-05, 1.85585162E-05, 1.91025295E-05, 1.96725581E-05,
     *  2.02693813E-05,
     *  1.62716875E-05, 1.66917810E-05, 1.71346964E-05, 1.76009743E-05,
     *  1.80911856E-05, 1.86059378E-05, 1.91458810E-05, 1.97117139E-05,
     *  2.03041896E-05,
     *  1.63378349E-05, 1.67541635E-05, 1.71932961E-05, 1.76557573E-05,
     *  1.81420996E-05, 1.86529100E-05, 1.91888160E-05, 1.97504918E-05,
     *  2.03386644E-05/
        DATA ((VISCV (J,K),J=46,54),K=37,45) /
     *  1.64034621E-05, 1.68160357E-05, 1.72513986E-05, 1.77100598E-05,
     *  1.81925542E-05, 1.86994487E-05, 1.92313485E-05, 1.97889037E-05,
     *  2.03728153E-05,
     *  1.64685913E-05, 1.68774188E-05, 1.73090237E-05, 1.77639003E-05,
     *  1.82425663E-05, 1.87455689E-05, 1.92734917E-05, 1.98269608E-05,
     *  2.04066517E-05,
     *  1.65332436E-05, 1.69383327E-05, 1.73661902E-05, 1.78172963E-05,
     *  1.82921519E-05, 1.87912852E-05, 1.93152584E-05, 1.98646742E-05,
     *  2.04401827E-05,
     *  1.65974392E-05, 1.69987967E-05, 1.74229164E-05, 1.78702647E-05,
     *  1.83413265E-05, 1.88366115E-05, 1.93566609E-05, 1.99020545E-05,
     *  2.04734169E-05,
     *  1.66611973E-05, 1.70588292E-05, 1.74792196E-05, 1.79228218E-05,
     *  1.83901051E-05, 1.88815613E-05, 1.93977113E-05, 1.99391118E-05,
     *  2.05063629E-05,
     *  1.67245363E-05, 1.71184478E-05, 1.75351164E-05, 1.79749829E-05,
     *  1.84385019E-05, 1.89261476E-05, 1.94384208E-05, 1.99758561E-05,
     *  2.05390289E-05,
     *  1.67874737E-05, 1.71776692E-05, 1.75906226E-05, 1.80267631E-05,
     *  1.84865307E-05, 1.89703827E-05, 1.94788005E-05, 2.00122968E-05,
     *  2.05714228E-05,
     *  1.68500262E-05, 1.72365095E-05, 1.76457536E-05, 1.80781765E-05,
     *  1.85342046E-05, 1.90142787E-05, 1.95188612E-05, 2.00484433E-05,
     *  2.06035522E-05,
     *  1.69122101E-05, 1.72949840E-05, 1.77005239E-05, 1.81292369E-05,
     *  1.85815363E-05, 1.90578471E-05, 1.95586130E-05, 2.00843042E-05,
     *  2.06354246E-05/
        DATA ((VISCV (J,K),J=46,54),K=46,54) /
     *  1.69740404E-05, 1.73531076E-05, 1.77549475E-05, 1.81799575E-05,
     *  1.86285381E-05, 1.91010989E-05, 1.95980659E-05, 2.01198884E-05,
     *  2.06670472E-05,
     *  1.70355320E-05, 1.74108942E-05, 1.78090379E-05, 1.82303508E-05,
     *  1.86752215E-05, 1.91440450E-05, 1.96372294E-05, 2.01552040E-05,
     *  2.06984269E-05,
     *  1.70966988E-05, 1.74683574E-05, 1.78628079E-05, 1.82804291E-05,
     *  1.87215981E-05, 1.91866955E-05, 1.96761127E-05, 2.01902591E-05,
     *  2.07295704E-05,
     *  1.71575542E-05, 1.75255102E-05, 1.79162699E-05, 1.83302039E-05,
     *  1.87676784E-05, 1.92290604E-05, 1.97147247E-05, 2.02250614E-05,
     *  2.07604843E-05,
     *  1.72181112E-05, 1.75823649E-05, 1.79694358E-05, 1.83796865E-05,
     *  1.88134731E-05, 1.92711493E-05, 1.97530740E-05, 2.02596184E-05,
     *  2.07911748E-05,
     *  1.72783821E-05, 1.76389335E-05, 1.80223169E-05, 1.84288877E-05,
     *  1.88589921E-05, 1.93129714E-05, 1.97911689E-05, 2.02939374E-05,
     *  2.08216481E-05,
     *  1.73383786E-05, 1.76952274E-05, 1.80749241E-05, 1.84778178E-05,
     *  1.89042452E-05, 1.93545356E-05, 1.98290173E-05, 2.03280254E-05,
     *  2.08519102E-05,
     *  1.73981122E-05, 1.77512575E-05, 1.81272681E-05, 1.85264867E-05,
     *  1.89492416E-05, 1.93958504E-05, 1.98666271E-05, 2.03618892E-05,
     *  2.08819666E-05,
     *  1.74575936E-05, 1.78070344E-05, 1.81793588E-05, 1.85749041E-05,
     *  1.89939903E-05, 1.94369242E-05, 1.99040056E-05, 2.03955352E-05,
     *  2.09118231E-05/
        DATA ((VISCV (J,K),J=46,54),K=55,63) /
     *  1.75168333E-05, 1.78625682E-05, 1.82312061E-05, 1.86230792E-05,
     *  1.90385000E-05, 1.94777648E-05, 1.99411601E-05, 2.04289699E-05,
     *  2.09414850E-05,
     *  1.75758413E-05, 1.79178685E-05, 1.82828192E-05, 1.86710209E-05,
     *  1.90827791E-05, 1.95183801E-05, 1.99780975E-05, 2.04621994E-05,
     *  2.09709575E-05,
     *  1.76346272E-05, 1.79729448E-05, 1.83342071E-05, 1.87187377E-05,
     *  1.91268355E-05, 1.95587774E-05, 2.00148245E-05, 2.04952296E-05,
     *  2.10002456E-05,
     *  1.76932003E-05, 1.80278061E-05, 1.83853786E-05, 1.87662379E-05,
     *  1.91706770E-05, 1.95989639E-05, 2.00513478E-05, 2.05280663E-05,
     *  2.10293544E-05,
     *  1.77515694E-05, 1.80824608E-05, 1.84363418E-05, 1.88135295E-05,
     *  1.92143111E-05, 1.96389465E-05, 2.00876735E-05, 2.05607151E-05,
     *  2.10582885E-05,
     *  1.78097430E-05, 1.81369174E-05, 1.84871048E-05, 1.88606200E-05,
     *  1.92577450E-05, 1.96787320E-05, 2.01238078E-05, 2.05931813E-05,
     *  2.10870525E-05,
     *  1.78677295E-05, 1.81911838E-05, 1.85376754E-05, 1.89075168E-05,
     *  1.93009857E-05, 1.97183267E-05, 2.01597565E-05, 2.06254702E-05,
     *  2.11156511E-05,
     *  1.79255365E-05, 1.82452678E-05, 1.85880610E-05, 1.89542271E-05,
     *  1.93440398E-05, 1.97577371E-05, 2.01955253E-05, 2.06575869E-05,
     *  2.11440884E-05,
     *  1.79831719E-05, 1.82991766E-05, 1.86382687E-05, 1.90007578E-05,
     *  1.93869140E-05, 1.97969690E-05, 2.02311198E-05, 2.06895362E-05,
     *  2.11723687E-05/
        DATA ((VISCV (J,K),J=46,54),K=64,72) /
     *  1.80406428E-05, 1.83529176E-05, 1.86883055E-05, 1.90471154E-05,
     *  1.94296144E-05, 1.98360283E-05, 2.02665453E-05, 2.07213229E-05,
     *  2.12004961E-05,
     *  1.80979562E-05, 1.84064975E-05, 1.87381780E-05, 1.90933064E-05,
     *  1.94721471E-05, 1.98749207E-05, 2.03018070E-05, 2.07529516E-05,
     *  2.12284747E-05,
     *  1.81551191E-05, 1.84599230E-05, 1.87878927E-05, 1.91393368E-05,
     *  1.95145180E-05, 1.99136517E-05, 2.03369098E-05, 2.07844268E-05,
     *  2.12563081E-05,
     *  1.82121379E-05, 1.85132005E-05, 1.88374557E-05, 1.91852128E-05,
     *  1.95567327E-05, 1.99522265E-05, 2.03718586E-05, 2.08157528E-05,
     *  2.12840003E-05,
     *  1.82690189E-05, 1.85663361E-05, 1.88868730E-05, 1.92309400E-05,
     *  1.95987966E-05, 1.99906502E-05, 2.04066582E-05, 2.08469338E-05,
     *  2.13115548E-05,
     *  1.83257682E-05, 1.86193358E-05, 1.89361505E-05, 1.92765240E-05,
     *  1.96407152E-05, 2.00289279E-05, 2.04413129E-05, 2.08779739E-05,
     *  2.13389752E-05,
     *  1.83823917E-05, 1.86722053E-05, 1.89852936E-05, 1.93219701E-05,
     *  1.96824933E-05, 2.00670642E-05, 2.04758274E-05, 2.09088770E-05,
     *  2.13662648E-05,
     *  1.84388949E-05, 1.87249502E-05, 1.90343078E-05, 1.93672836E-05,
     *  1.97241361E-05, 2.01050638E-05, 2.05102057E-05, 2.09396471E-05,
     *  2.13934272E-05,
     *  1.84952835E-05, 1.87775757E-05, 1.90831984E-05, 1.94124695E-05,
     *  1.97656484E-05, 2.01429312E-05, 2.05444521E-05, 2.09702877E-05,
     *  2.14204653E-05/
        DATA ((VISCV (J,K),J=46,54),K=73,81) /
     *  1.85515625E-05, 1.88300872E-05, 1.91319702E-05, 1.94575326E-05,
     *  1.98070346E-05, 2.01806708E-05, 2.05785706E-05, 2.10008026E-05,
     *  2.14473826E-05,
     *  1.86077372E-05, 1.88824895E-05, 1.91806282E-05, 1.95024776E-05,
     *  1.98482994E-05, 2.02182868E-05, 2.06125650E-05, 2.10311952E-05,
     *  2.14741819E-05,
     *  1.86638124E-05, 1.89347875E-05, 1.92291771E-05, 1.95473091E-05,
     *  1.98894470E-05, 2.02557832E-05, 2.06464392E-05, 2.10614689E-05,
     *  2.15008663E-05,
     *  1.87197928E-05, 1.89869859E-05, 1.92776214E-05, 1.95920315E-05,
     *  1.99304816E-05, 2.02931641E-05, 2.06801968E-05, 2.10916271E-05,
     *  2.15274386E-05,
     *  1.87756832E-05, 1.90390892E-05, 1.93259656E-05, 1.96366490E-05,
     *  1.99714074E-05, 2.03304332E-05, 2.07138414E-05, 2.11216729E-05,
     *  2.15539018E-05,
     *  1.88314878E-05, 1.90911016E-05, 1.93742139E-05, 1.96811657E-05,
     *  2.00122283E-05, 2.03675943E-05, 2.07473764E-05, 2.11516096E-05,
     *  2.15802585E-05,
     *  1.88872111E-05, 1.91430276E-05, 1.94223704E-05, 1.97255857E-05,
     *  2.00529480E-05, 2.04046510E-05, 2.07808051E-05, 2.11814400E-05,
     *  2.16065114E-05,
     *  1.89428571E-05, 1.91948710E-05, 1.94704391E-05, 1.97699128E-05,
     *  2.00935704E-05, 2.04416068E-05, 2.08141309E-05, 2.12111672E-05,
     *  2.16326631E-05,
     *  1.89984298E-05, 1.92466360E-05, 1.95184238E-05, 1.98141508E-05,
     *  2.01340990E-05, 2.04784651E-05, 2.08473568E-05, 2.12407941E-05,
     *  2.16587161E-05/
        DATA ((VISCV (J,K),J=55,63),K= 1, 9) /
     *  1.96690224E-05, 2.05309741E-05, 2.14330266E-05, 2.23770547E-05,
     *  2.33650165E-05, 2.43989570E-05, 2.54810130E-05, 2.66134171E-05,
     *  2.77985025E-05,
     *  1.97148961E-05, 2.05724358E-05, 2.14719900E-05, 2.24136693E-05,
     *  2.33994228E-05, 2.44312874E-05, 2.55113919E-05, 2.66419615E-05,
     *  2.78253227E-05,
     *  1.97600523E-05, 2.06132987E-05, 2.15104276E-05, 2.24498222E-05,
     *  2.34334239E-05, 2.44632621E-05, 2.55414587E-05, 2.66702323E-05,
     *  2.78519029E-05,
     *  1.98045107E-05, 2.06535780E-05, 2.15483516E-05, 2.24855234E-05,
     *  2.34670278E-05, 2.44948878E-05, 2.55712190E-05, 2.66982338E-05,
     *  2.78782466E-05,
     *  1.98482906E-05, 2.06932883E-05, 2.15857741E-05, 2.25207827E-05,
     *  2.35002426E-05, 2.45261710E-05, 2.56006777E-05, 2.67259701E-05,
     *  2.79043572E-05,
     *  1.98914108E-05, 2.07324442E-05, 2.16227068E-05, 2.25556096E-05,
     *  2.35330760E-05, 2.45571179E-05, 2.56298403E-05, 2.67534455E-05,
     *  2.79302381E-05,
     *  1.99338897E-05, 2.07710599E-05, 2.16591614E-05, 2.25900138E-05,
     *  2.35655359E-05, 2.45877350E-05, 2.56587118E-05, 2.67806643E-05,
     *  2.79558928E-05,
     *  1.99757453E-05, 2.08091492E-05, 2.16951493E-05, 2.26240046E-05,
     *  2.35976298E-05, 2.46180285E-05, 2.56872973E-05, 2.68076305E-05,
     *  2.79813247E-05,
     *  2.00169950E-05, 2.08467257E-05, 2.17306817E-05, 2.26575912E-05,
     *  2.36293654E-05, 2.46480046E-05, 2.57156019E-05, 2.68343484E-05,
     *  2.80065371E-05/
        DATA ((VISCV (J,K),J=55,63),K=10,18) /
     *  2.00576561E-05, 2.08838028E-05, 2.17657696E-05, 2.26907826E-05,
     *  2.36607501E-05, 2.46776694E-05, 2.57436307E-05, 2.68608220E-05,
     *  2.80315333E-05,
     *  2.00977451E-05, 2.09203933E-05, 2.18004237E-05, 2.27235877E-05,
     *  2.36917912E-05, 2.47070289E-05, 2.57713885E-05, 2.68870553E-05,
     *  2.80563168E-05,
     *  2.01372781E-05, 2.09565099E-05, 2.18346545E-05, 2.27560152E-05,
     *  2.37224959E-05, 2.47360891E-05, 2.57988802E-05, 2.69130524E-05,
     *  2.80808907E-05,
     *  2.01762709E-05, 2.09921650E-05, 2.18684723E-05, 2.27880737E-05,
     *  2.37528713E-05, 2.47648558E-05, 2.58261108E-05, 2.69388172E-05,
     *  2.81052583E-05,
     *  2.02147388E-05, 2.10273707E-05, 2.19018872E-05, 2.28197715E-05,
     *  2.37829243E-05, 2.47933347E-05, 2.58530848E-05, 2.69643537E-05,
     *  2.81294229E-05,
     *  2.02526967E-05, 2.10621386E-05, 2.19349089E-05, 2.28511168E-05,
     *  2.38126617E-05, 2.48215316E-05, 2.58798070E-05, 2.69896658E-05,
     *  2.81533876E-05,
     *  2.02901589E-05, 2.10964802E-05, 2.19675471E-05, 2.28821176E-05,
     *  2.38420903E-05, 2.48494520E-05, 2.59062820E-05, 2.70147571E-05,
     *  2.81771557E-05,
     *  2.03271395E-05, 2.11304066E-05, 2.19998111E-05, 2.29127818E-05,
     *  2.38712165E-05, 2.48771013E-05, 2.59325145E-05, 2.70396317E-05,
     *  2.82007301E-05,
     *  2.03636521E-05, 2.11639287E-05, 2.20317100E-05, 2.29431171E-05,
     *  2.39000469E-05, 2.49044849E-05, 2.59585087E-05, 2.70642930E-05,
     *  2.82241141E-05/
        DATA ((VISCV (J,K),J=55,63),K=19,27) /
     *  2.03997099E-05, 2.11970569E-05, 2.20632529E-05, 2.29731309E-05,
     *  2.39285878E-05, 2.49316082E-05, 2.59842693E-05, 2.70887449E-05,
     *  2.82473106E-05,
     *  2.04353256E-05, 2.12298017E-05, 2.20944483E-05, 2.30028307E-05,
     *  2.39568453E-05, 2.49584763E-05, 2.60098004E-05, 2.71129909E-05,
     *  2.82703227E-05,
     *  2.04705117E-05, 2.12621728E-05, 2.21253048E-05, 2.30322236E-05,
     *  2.39848254E-05, 2.49850943E-05, 2.60351064E-05, 2.71370346E-05,
     *  2.82931533E-05,
     *  2.05052803E-05, 2.12941801E-05, 2.21558305E-05, 2.30613166E-05,
     *  2.40125342E-05, 2.50114671E-05, 2.60601914E-05, 2.71608796E-05,
     *  2.83158054E-05,
     *  2.05396429E-05, 2.13258329E-05, 2.21860337E-05, 2.30901165E-05,
     *  2.40399773E-05, 2.50375998E-05, 2.60850596E-05, 2.71845292E-05,
     *  2.83382818E-05,
     *  2.05736109E-05, 2.13571404E-05, 2.22159220E-05, 2.31186301E-05,
     *  2.40671606E-05, 2.50634970E-05, 2.61097151E-05, 2.72079868E-05,
     *  2.83605854E-05,
     *  2.06071952E-05, 2.13881116E-05, 2.22455031E-05, 2.31468638E-05,
     *  2.40940894E-05, 2.50891636E-05, 2.61341617E-05, 2.72312559E-05,
     *  2.83827190E-05,
     *  2.06404066E-05, 2.14187550E-05, 2.22747846E-05, 2.31748241E-05,
     *  2.41207694E-05, 2.51146040E-05, 2.61584035E-05, 2.72543397E-05,
     *  2.84046854E-05,
     *  2.06732552E-05, 2.14490791E-05, 2.23037735E-05, 2.32025171E-05,
     *  2.41472057E-05, 2.51398229E-05, 2.61824442E-05, 2.72772414E-05,
     *  2.84264873E-05/
        DATA ((VISCV (J,K),J=55,63),K=28,36) /
     *  2.07057510E-05, 2.14790921E-05, 2.23324770E-05, 2.32299489E-05,
     *  2.41734036E-05, 2.51648246E-05, 2.62062876E-05, 2.72999643E-05,
     *  2.84481274E-05,
     *  2.07379038E-05, 2.15088018E-05, 2.23609019E-05, 2.32571254E-05,
     *  2.41993681E-05, 2.51896136E-05, 2.62299374E-05, 2.73225114E-05,
     *  2.84696083E-05,
     *  2.07697229E-05, 2.15382160E-05, 2.23890550E-05, 2.32840524E-05,
     *  2.42251042E-05, 2.52141939E-05, 2.62533972E-05, 2.73448859E-05,
     *  2.84909327E-05,
     *  2.08012174E-05, 2.15673422E-05, 2.24169427E-05, 2.33107356E-05,
     *  2.42506168E-05, 2.52385699E-05, 2.62766706E-05, 2.73670907E-05,
     *  2.85121030E-05,
     *  2.08323960E-05, 2.15961877E-05, 2.24445713E-05, 2.33371803E-05,
     *  2.42759106E-05, 2.52627456E-05, 2.62997611E-05, 2.73891289E-05,
     *  2.85331219E-05,
     *  2.08632673E-05, 2.16247594E-05, 2.24719470E-05, 2.33633921E-05,
     *  2.43009902E-05, 2.52867250E-05, 2.63226720E-05, 2.74110033E-05,
     *  2.85539918E-05,
     *  2.08938395E-05, 2.16530644E-05, 2.24990759E-05, 2.33893760E-05,
     *  2.43258602E-05, 2.53105119E-05, 2.63454068E-05, 2.74327169E-05,
     *  2.85747152E-05,
     *  2.09241208E-05, 2.16811091E-05, 2.25259637E-05, 2.34151372E-05,
     *  2.43505249E-05, 2.53341102E-05, 2.63679687E-05, 2.74542724E-05,
     *  2.85952944E-05,
     *  2.09541187E-05, 2.17089001E-05, 2.25526161E-05, 2.34406806E-05,
     *  2.43749887E-05, 2.53575236E-05, 2.63903609E-05, 2.74756727E-05,
     *  2.86157318E-05/
        DATA ((VISCV (J,K),J=55,63),K=37,45) /
     *  2.09838408E-05, 2.17364438E-05, 2.25790387E-05, 2.34660111E-05,
     *  2.43992558E-05, 2.53807559E-05, 2.64125867E-05, 2.74969203E-05,
     *  2.86360298E-05,
     *  2.10132945E-05, 2.17637461E-05, 2.26052368E-05, 2.34911334E-05,
     *  2.44233304E-05, 2.54038104E-05, 2.64346490E-05, 2.75180181E-05,
     *  2.86561906E-05,
     *  2.10424867E-05, 2.17908130E-05, 2.26312157E-05, 2.35160521E-05,
     *  2.44472163E-05, 2.54266909E-05, 2.64565510E-05, 2.75389686E-05,
     *  2.86762166E-05,
     *  2.10714244E-05, 2.18176503E-05, 2.26569804E-05, 2.35407717E-05,
     *  2.44709177E-05, 2.54494007E-05, 2.64782956E-05, 2.75597743E-05,
     *  2.86961098E-05,
     *  2.11001141E-05, 2.18442635E-05, 2.26825360E-05, 2.35652966E-05,
     *  2.44944383E-05, 2.54719431E-05, 2.64998857E-05, 2.75804379E-05,
     *  2.87158724E-05,
     *  2.11285623E-05, 2.18706582E-05, 2.27078872E-05, 2.35896309E-05,
     *  2.45177818E-05, 2.54943214E-05, 2.65213242E-05, 2.76009617E-05,
     *  2.87355067E-05,
     *  2.11567753E-05, 2.18968395E-05, 2.27330388E-05, 2.36137789E-05,
     *  2.45409519E-05, 2.55165389E-05, 2.65426139E-05, 2.76213483E-05,
     *  2.87550147E-05,
     *  2.11847590E-05, 2.19228127E-05, 2.27579953E-05, 2.36377446E-05,
     *  2.45639522E-05, 2.55385986E-05, 2.65637575E-05, 2.76415999E-05,
     *  2.87743985E-05,
     *  2.12125194E-05, 2.19485827E-05, 2.27827611E-05, 2.36615320E-05,
     *  2.45867862E-05, 2.55605037E-05, 2.65847577E-05, 2.76617190E-05,
     *  2.87936600E-05/
        DATA ((VISCV (J,K),J=55,63),K=46,54) /
     *  2.12400622E-05, 2.19741543E-05, 2.28073406E-05, 2.36851450E-05,
     *  2.46094573E-05, 2.55822571E-05, 2.66056171E-05, 2.76817078E-05,
     *  2.88128013E-05,
     *  2.12673928E-05, 2.19995323E-05, 2.28317381E-05, 2.37085872E-05,
     *  2.46319688E-05, 2.56038617E-05, 2.66263384E-05, 2.77015686E-05,
     *  2.88318244E-05,
     *  2.12945166E-05, 2.20247212E-05, 2.28559575E-05, 2.37318623E-05,
     *  2.46543240E-05, 2.56253206E-05, 2.66469239E-05, 2.77213036E-05,
     *  2.88507312E-05,
     *  2.13214388E-05, 2.20497255E-05, 2.28800030E-05, 2.37549740E-05,
     *  2.46765260E-05, 2.56466364E-05, 2.66673763E-05, 2.77409149E-05,
     *  2.88695235E-05,
     *  2.13481646E-05, 2.20745496E-05, 2.29038783E-05, 2.37779256E-05,
     *  2.46985779E-05, 2.56678118E-05, 2.66876979E-05, 2.77604047E-05,
     *  2.88882032E-05,
     *  2.13746986E-05, 2.20991975E-05, 2.29275873E-05, 2.38007206E-05,
     *  2.47204829E-05, 2.56888497E-05, 2.67078911E-05, 2.77797751E-05,
     *  2.89067722E-05,
     *  2.14010458E-05, 2.21236735E-05, 2.29511338E-05, 2.38233624E-05,
     *  2.47422437E-05, 2.57097526E-05, 2.67279583E-05, 2.77990281E-05,
     *  2.89252322E-05,
     *  2.14272108E-05, 2.21479814E-05, 2.29745212E-05, 2.38458540E-05,
     *  2.47638634E-05, 2.57305231E-05, 2.67479016E-05, 2.78181657E-05,
     *  2.89435850E-05,
     *  2.14531979E-05, 2.21721252E-05, 2.29977530E-05, 2.38681988E-05,
     *  2.47853447E-05, 2.57511637E-05, 2.67677234E-05, 2.78371899E-05,
     *  2.89618323E-05/
        DATA ((VISCV (J,K),J=55,63),K=55,63) /
     *  2.14790116E-05, 2.21961087E-05, 2.30208328E-05, 2.38903996E-05,
     *  2.48066904E-05, 2.57716769E-05, 2.67874258E-05, 2.78561026E-05,
     *  2.89799758E-05,
     *  2.15046560E-05, 2.22199354E-05, 2.30437637E-05, 2.39124597E-05,
     *  2.48279032E-05, 2.57920650E-05, 2.68070110E-05, 2.78749058E-05,
     *  2.89980172E-05,
     *  2.15301353E-05, 2.22436089E-05, 2.30665491E-05, 2.39343818E-05,
     *  2.48489857E-05, 2.58123305E-05, 2.68264810E-05, 2.78936012E-05,
     *  2.90159581E-05,
     *  2.15554535E-05, 2.22671328E-05, 2.30891920E-05, 2.39561688E-05,
     *  2.48699405E-05, 2.58324756E-05, 2.68458380E-05, 2.79121907E-05,
     *  2.90338002E-05,
     *  2.15806145E-05, 2.22905103E-05, 2.31116957E-05, 2.39778236E-05,
     *  2.48907701E-05, 2.58525026E-05, 2.68650839E-05, 2.79306761E-05,
     *  2.90515450E-05,
     *  2.16056219E-05, 2.23137448E-05, 2.31340629E-05, 2.39993488E-05,
     *  2.49114770E-05, 2.58724137E-05, 2.68842206E-05, 2.79490591E-05,
     *  2.90691940E-05,
     *  2.16304795E-05, 2.23368394E-05, 2.31562968E-05, 2.40207471E-05,
     *  2.49320635E-05, 2.58922111E-05, 2.69032503E-05, 2.79673414E-05,
     *  2.90867488E-05,
     *  2.16551908E-05, 2.23597973E-05, 2.31784001E-05, 2.40420210E-05,
     *  2.49525321E-05, 2.59118968E-05, 2.69221746E-05, 2.79855249E-05,
     *  2.91042109E-05,
     *  2.16797593E-05, 2.23826215E-05, 2.32003755E-05, 2.40631732E-05,
     *  2.49728849E-05, 2.59314729E-05, 2.69409955E-05, 2.80036110E-05,
     *  2.91215818E-05/
        DATA ((VISCV (J,K),J=55,63),K=64,72) /
     *  2.17041883E-05, 2.24053149E-05, 2.32222258E-05, 2.40842060E-05,
     *  2.49931242E-05, 2.59509415E-05, 2.69597148E-05, 2.80216014E-05,
     *  2.91388629E-05,
     *  2.17284810E-05, 2.24278804E-05, 2.32439537E-05, 2.41051219E-05,
     *  2.50132523E-05, 2.59703045E-05, 2.69783343E-05, 2.80394978E-05,
     *  2.91560555E-05,
     *  2.17526408E-05, 2.24503208E-05, 2.32655617E-05, 2.41259232E-05,
     *  2.50332712E-05, 2.59895639E-05, 2.69968557E-05, 2.80573016E-05,
     *  2.91731612E-05,
     *  2.17766706E-05, 2.24726389E-05, 2.32870522E-05, 2.41466122E-05,
     *  2.50531831E-05, 2.60087215E-05, 2.70152807E-05, 2.80750144E-05,
     *  2.91901813E-05,
     *  2.18005734E-05, 2.24948372E-05, 2.33084278E-05, 2.41671912E-05,
     *  2.50729899E-05, 2.60277793E-05, 2.70336110E-05, 2.80926378E-05,
     *  2.92071171E-05,
     *  2.18243523E-05, 2.25169184E-05, 2.33296909E-05, 2.41876623E-05,
     *  2.50926938E-05, 2.60467390E-05, 2.70518483E-05, 2.81101731E-05,
     *  2.92239700E-05,
     *  2.18480100E-05, 2.25388849E-05, 2.33508436E-05, 2.42080277E-05,
     *  2.51122966E-05, 2.60656024E-05, 2.70699941E-05, 2.81276219E-05,
     *  2.92407412E-05,
     *  2.18715493E-05, 2.25607393E-05, 2.33718884E-05, 2.42282895E-05,
     *  2.51318002E-05, 2.60843712E-05, 2.70880501E-05, 2.81449856E-05,
     *  2.92574320E-05,
     *  2.18949729E-05, 2.25824839E-05, 2.33928275E-05, 2.42484497E-05,
     *  2.51512066E-05, 2.61030472E-05, 2.71060177E-05, 2.81622655E-05,
     *  2.92740437E-05/
        DATA ((VISCV (J,K),J=55,63),K=73,81) /
     *  2.19182834E-05, 2.26041211E-05, 2.34136629E-05, 2.42685102E-05,
     *  2.51705175E-05, 2.61216321E-05, 2.71238985E-05, 2.81794631E-05,
     *  2.92905775E-05,
     *  2.19414834E-05, 2.26256531E-05, 2.34343969E-05, 2.42884732E-05,
     *  2.51897347E-05, 2.61401273E-05, 2.71416940E-05, 2.81965796E-05,
     *  2.93070346E-05,
     *  2.19645753E-05, 2.26470821E-05, 2.34550314E-05, 2.43083403E-05,
     *  2.52088601E-05, 2.61585347E-05, 2.71594056E-05, 2.82136164E-05,
     *  2.93234161E-05,
     *  2.19875617E-05, 2.26684104E-05, 2.34755684E-05, 2.43281136E-05,
     *  2.52278952E-05, 2.61768556E-05, 2.71770348E-05, 2.82305747E-05,
     *  2.93397234E-05,
     *  2.20104448E-05, 2.26896399E-05, 2.34960100E-05, 2.43477948E-05,
     *  2.52468418E-05, 2.61950917E-05, 2.71945829E-05, 2.82474559E-05,
     *  2.93559574E-05,
     *  2.20332269E-05, 2.27107728E-05, 2.35163581E-05, 2.43673857E-05,
     *  2.52657015E-05, 2.62132444E-05, 2.72120514E-05, 2.82642612E-05,
     *  2.93721194E-05,
     *  2.20559103E-05, 2.27318111E-05, 2.35366145E-05, 2.43868880E-05,
     *  2.52844759E-05, 2.62313153E-05, 2.72294415E-05, 2.82809919E-05,
     *  2.93882104E-05,
     *  2.20784972E-05, 2.27527568E-05, 2.35567810E-05, 2.44063035E-05,
     *  2.53031665E-05, 2.62493057E-05, 2.72467546E-05, 2.82976490E-05,
     *  2.94042315E-05,
     *  2.21009897E-05, 2.27736116E-05, 2.35768594E-05, 2.44256337E-05,
     *  2.53217750E-05, 2.62672172E-05, 2.72639920E-05, 2.83142338E-05,
     *  2.94201839E-05/
        DATA ((VISCV (J,K),J=64,72),K= 1, 9) /
     *  2.90387080E-05, 3.03365829E-05, 3.16947925E-05, 3.31161231E-05,
     *  3.46034883E-05, 3.61599347E-05, 3.77886483E-05, 3.94929607E-05,
     *  4.12763564E-05,
     *  2.90639076E-05, 3.03602593E-05, 3.17170373E-05, 3.31370226E-05,
     *  3.46231235E-05, 3.61783818E-05, 3.78059789E-05, 3.95092422E-05,
     *  4.12916521E-05,
     *  2.90888967E-05, 3.03837512E-05, 3.17391204E-05, 3.31577803E-05,
     *  3.46426344E-05, 3.61967200E-05, 3.78232141E-05, 3.95254401E-05,
     *  4.13068745E-05,
     *  2.91136782E-05, 3.04070608E-05, 3.17610436E-05, 3.31783977E-05,
     *  3.46620222E-05, 3.62149502E-05, 3.78403545E-05, 3.95415549E-05,
     *  4.13220241E-05,
     *  2.91382548E-05, 3.04301905E-05, 3.17828087E-05, 3.31988762E-05,
     *  3.46812881E-05, 3.62330733E-05, 3.78574011E-05, 3.95575872E-05,
     *  4.13371013E-05,
     *  2.91626293E-05, 3.04531424E-05, 3.18044174E-05, 3.32192174E-05,
     *  3.47004333E-05, 3.62510905E-05, 3.78743545E-05, 3.95735378E-05,
     *  4.13521068E-05,
     *  2.91868046E-05, 3.04759188E-05, 3.18258718E-05, 3.32394227E-05,
     *  3.47194590E-05, 3.62690025E-05, 3.78912155E-05, 3.95894073E-05,
     *  4.13670409E-05,
     *  2.92107833E-05, 3.04985219E-05, 3.18471734E-05, 3.32594936E-05,
     *  3.47383664E-05, 3.62868105E-05, 3.79079850E-05, 3.96051962E-05,
     *  4.13819043E-05,
     *  2.92345682E-05, 3.05209540E-05, 3.18683243E-05, 3.32794315E-05,
     *  3.47571566E-05, 3.63045153E-05, 3.79246636E-05, 3.96209052E-05,
     *  4.13966973E-05/
        DATA ((VISCV (J,K),J=64,72),K=10,18) /
     *  2.92581620E-05, 3.05432174E-05, 3.18893261E-05, 3.32992379E-05,
     *  3.47758309E-05, 3.63221179E-05, 3.79412523E-05, 3.96365349E-05,
     *  4.14114206E-05,
     *  2.92815675E-05, 3.05653141E-05, 3.19101808E-05, 3.33189144E-05,
     *  3.47943905E-05, 3.63396193E-05, 3.79577517E-05, 3.96520860E-05,
     *  4.14260747E-05,
     *  2.93047873E-05, 3.05872465E-05, 3.19308899E-05, 3.33384622E-05,
     *  3.48128365E-05, 3.63570204E-05, 3.79741627E-05, 3.96675592E-05,
     *  4.14406600E-05,
     *  2.93278241E-05, 3.06090166E-05, 3.19514555E-05, 3.33578830E-05,
     *  3.48311701E-05, 3.63743223E-05, 3.79904860E-05, 3.96829549E-05,
     *  4.14551771E-05,
     *  2.93506805E-05, 3.06306268E-05, 3.19718792E-05, 3.33771781E-05,
     *  3.48493925E-05, 3.63915258E-05, 3.80067224E-05, 3.96982740E-05,
     *  4.14696265E-05,
     *  2.93733592E-05, 3.06520790E-05, 3.19921628E-05, 3.33963491E-05,
     *  3.48675049E-05, 3.64086320E-05, 3.80228727E-05, 3.97135170E-05,
     *  4.14840087E-05,
     *  2.93958628E-05, 3.06733755E-05, 3.20123080E-05, 3.34153972E-05,
     *  3.48855085E-05, 3.64256418E-05, 3.80389378E-05, 3.97286845E-05,
     *  4.14983242E-05,
     *  2.94181938E-05, 3.06945184E-05, 3.20323167E-05, 3.34343241E-05,
     *  3.49034044E-05, 3.64425561E-05, 3.80549183E-05, 3.97437772E-05,
     *  4.15125736E-05,
     *  2.94403548E-05, 3.07155098E-05, 3.20521904E-05, 3.34531310E-05,
     *  3.49211939E-05, 3.64593760E-05, 3.80708150E-05, 3.97587958E-05,
     *  4.15267574E-05/
        DATA ((VISCV (J,K),J=64,72),K=19,27) /
     *  2.94623484E-05, 3.07363517E-05, 3.20719311E-05, 3.34718194E-05,
     *  3.49388779E-05, 3.64761023E-05, 3.80866287E-05, 3.97737408E-05,
     *  4.15408760E-05,
     *  2.94841769E-05, 3.07570463E-05, 3.20915402E-05, 3.34903907E-05,
     *  3.49564578E-05, 3.64927360E-05, 3.81023603E-05, 3.97886129E-05,
     *  4.15549300E-05,
     *  2.95058430E-05, 3.07775955E-05, 3.21110196E-05, 3.35088463E-05,
     *  3.49739346E-05, 3.65092780E-05, 3.81180104E-05, 3.98034127E-05,
     *  4.15689199E-05,
     *  2.95273489E-05, 3.07980014E-05, 3.21303709E-05, 3.35271875E-05,
     *  3.49913096E-05, 3.65257294E-05, 3.81335798E-05, 3.98181408E-05,
     *  4.15828462E-05,
     *  2.95486972E-05, 3.08182660E-05, 3.21495958E-05, 3.35454158E-05,
     *  3.50085837E-05, 3.65420909E-05, 3.81490693E-05, 3.98327979E-05,
     *  4.15967095E-05,
     *  2.95698901E-05, 3.08383913E-05, 3.21686958E-05, 3.35635325E-05,
     *  3.50257582E-05, 3.65583636E-05, 3.81644797E-05, 3.98473846E-05,
     *  4.16105102E-05,
     *  2.95909302E-05, 3.08583793E-05, 3.21876727E-05, 3.35815390E-05,
     *  3.50428341E-05, 3.65745483E-05, 3.81798117E-05, 3.98619016E-05,
     *  4.16242489E-05,
     *  2.96118196E-05, 3.08782318E-05, 3.22065281E-05, 3.35994365E-05,
     *  3.50598126E-05, 3.65906459E-05, 3.81950660E-05, 3.98763494E-05,
     *  4.16379260E-05,
     *  2.96325606E-05, 3.08979507E-05, 3.22252635E-05, 3.36172265E-05,
     *  3.50766948E-05, 3.66066575E-05, 3.82102435E-05, 3.98907286E-05,
     *  4.16515421E-05/
        DATA ((VISCV (J,K),J=64,72),K=28,36) /
     *  2.96531556E-05, 3.09175381E-05, 3.22438805E-05, 3.36349101E-05,
     *  3.50934818E-05, 3.66225838E-05, 3.82253448E-05, 3.99050399E-05,
     *  4.16650977E-05,
     *  2.96736067E-05, 3.09369957E-05, 3.22623808E-05, 3.36524889E-05,
     *  3.51101745E-05, 3.66384258E-05, 3.82403708E-05, 3.99192839E-05,
     *  4.16785932E-05,
     *  2.96939161E-05, 3.09563254E-05, 3.22807657E-05, 3.36699639E-05,
     *  3.51267742E-05, 3.66541844E-05, 3.82553220E-05, 3.99334611E-05,
     *  4.16920292E-05,
     *  2.97140861E-05, 3.09755290E-05, 3.22990369E-05, 3.36873366E-05,
     *  3.51432819E-05, 3.66698605E-05, 3.82701994E-05, 3.99475723E-05,
     *  4.17054062E-05,
     *  2.97341187E-05, 3.09946083E-05, 3.23171959E-05, 3.37046081E-05,
     *  3.51596987E-05, 3.66854548E-05, 3.82850035E-05, 3.99616179E-05,
     *  4.17187247E-05,
     *  2.97540160E-05, 3.10135651E-05, 3.23352442E-05, 3.37217797E-05,
     *  3.51760255E-05, 3.67009684E-05, 3.82997352E-05, 3.99755987E-05,
     *  4.17319851E-05,
     *  2.97737802E-05, 3.10324012E-05, 3.23531832E-05, 3.37388527E-05,
     *  3.51922634E-05, 3.67164020E-05, 3.83143951E-05, 3.99895152E-05,
     *  4.17451880E-05,
     *  2.97934132E-05, 3.10511182E-05, 3.23710144E-05, 3.37558283E-05,
     *  3.52084135E-05, 3.67317566E-05, 3.83289840E-05, 4.00033679E-05,
     *  4.17583339E-05,
     *  2.98129171E-05, 3.10697179E-05, 3.23887393E-05, 3.37727077E-05,
     *  3.52244767E-05, 3.67470329E-05, 3.83435025E-05, 4.00171575E-05,
     *  4.17714232E-05/
        DATA ((VISCV (J,K),J=64,72),K=37,45) /
     *  2.98322939E-05, 3.10882020E-05, 3.24063592E-05, 3.37894921E-05,
     *  3.52404541E-05, 3.67622319E-05, 3.83579514E-05, 4.00308846E-05,
     *  4.17844564E-05,
     *  2.98515455E-05, 3.11065721E-05, 3.24238756E-05, 3.38061827E-05,
     *  3.52563467E-05, 3.67773543E-05, 3.83723314E-05, 4.00445497E-05,
     *  4.17974340E-05,
     *  2.98706738E-05, 3.11248298E-05, 3.24412899E-05, 3.38227806E-05,
     *  3.52721555E-05, 3.67924011E-05, 3.83866431E-05, 4.00581534E-05,
     *  4.18103565E-05,
     *  2.98896808E-05, 3.11429769E-05, 3.24586034E-05, 3.38392871E-05,
     *  3.52878814E-05, 3.68073729E-05, 3.84008873E-05, 4.00716964E-05,
     *  4.18232244E-05,
     *  2.99085682E-05, 3.11610148E-05, 3.24758176E-05, 3.38557032E-05,
     *  3.53035254E-05, 3.68222706E-05, 3.84150647E-05, 4.00851791E-05,
     *  4.18360381E-05,
     *  2.99273380E-05, 3.11789451E-05, 3.24929336E-05, 3.38720302E-05,
     *  3.53190885E-05, 3.68370951E-05, 3.84291758E-05, 4.00986021E-05,
     *  4.18487982E-05,
     *  2.99459919E-05, 3.11967695E-05, 3.25099529E-05, 3.38882691E-05,
     *  3.53345716E-05, 3.68518471E-05, 3.84432215E-05, 4.01119660E-05,
     *  4.18615050E-05,
     *  2.99645317E-05, 3.12144893E-05, 3.25268768E-05, 3.39044210E-05,
     *  3.53499757E-05, 3.68665275E-05, 3.84572022E-05, 4.01252714E-05,
     *  4.18741591E-05,
     *  2.99829592E-05, 3.12321062E-05, 3.25437065E-05, 3.39204870E-05,
     *  3.53653016E-05, 3.68811369E-05, 3.84711188E-05, 4.01385188E-05,
     *  4.18867608E-05/
        DATA ((VISCV (J,K),J=64,72),K=46,54) /
     *  3.00012761E-05, 3.12496216E-05, 3.25604434E-05, 3.39364683E-05,
     *  3.53805504E-05, 3.68956763E-05, 3.84849719E-05, 4.01517088E-05,
     *  4.18993108E-05,
     *  3.00194841E-05, 3.12670369E-05, 3.25770885E-05, 3.39523659E-05,
     *  3.53957228E-05, 3.69101463E-05, 3.84987621E-05, 4.01648418E-05,
     *  4.19118094E-05,
     *  3.00375848E-05, 3.12843537E-05, 3.25936433E-05, 3.39681808E-05,
     *  3.54108199E-05, 3.69245477E-05, 3.85124900E-05, 4.01779185E-05,
     *  4.19242571E-05,
     *  3.00555799E-05, 3.13015732E-05, 3.26101089E-05, 3.39839140E-05,
     *  3.54258425E-05, 3.69388813E-05, 3.85261564E-05, 4.01909394E-05,
     *  4.19366543E-05,
     *  3.00734710E-05, 3.13186969E-05, 3.26264866E-05, 3.39995667E-05,
     *  3.54407915E-05, 3.69531478E-05, 3.85397618E-05, 4.02039050E-05,
     *  4.19490015E-05,
     *  3.00912596E-05, 3.13357263E-05, 3.26427774E-05, 3.40151399E-05,
     *  3.54556677E-05, 3.69673480E-05, 3.85533068E-05, 4.02168158E-05,
     *  4.19612991E-05,
     *  3.01089475E-05, 3.13526626E-05, 3.26589826E-05, 3.40306344E-05,
     *  3.54704721E-05, 3.69814826E-05, 3.85667922E-05, 4.02296725E-05,
     *  4.19735476E-05,
     *  3.01265360E-05, 3.13695071E-05, 3.26751033E-05, 3.40460514E-05,
     *  3.54852054E-05, 3.69955523E-05, 3.85802184E-05, 4.02424754E-05,
     *  4.19857474E-05,
     *  3.01440267E-05, 3.13862612E-05, 3.26911407E-05, 3.40613918E-05,
     *  3.54998685E-05, 3.70095578E-05, 3.85935861E-05, 4.02552251E-05,
     *  4.19978990E-05/
        DATA ((VISCV (J,K),J=64,72),K=55,63) /
     *  3.01614211E-05, 3.14029262E-05, 3.27070959E-05, 3.40766566E-05,
     *  3.55144622E-05, 3.70234999E-05, 3.86068960E-05, 4.02679221E-05,
     *  4.20100027E-05,
     *  3.01787206E-05, 3.14195034E-05, 3.27229700E-05, 3.40918467E-05,
     *  3.55289874E-05, 3.70373793E-05, 3.86201485E-05, 4.02805670E-05,
     *  4.20220590E-05,
     *  3.01959267E-05, 3.14359940E-05, 3.27387640E-05, 3.41069630E-05,
     *  3.55434449E-05, 3.70511966E-05, 3.86333444E-05, 4.02931602E-05,
     *  4.20340684E-05,
     *  3.02130408E-05, 3.14523992E-05, 3.27544791E-05, 3.41220066E-05,
     *  3.55578354E-05, 3.70649525E-05, 3.86464841E-05, 4.03057023E-05,
     *  4.20460313E-05,
     *  3.02300643E-05, 3.14687202E-05, 3.27701163E-05, 3.41369783E-05,
     *  3.55721598E-05, 3.70786477E-05, 3.86595683E-05, 4.03181936E-05,
     *  4.20579480E-05,
     *  3.02469985E-05, 3.14849584E-05, 3.27856767E-05, 3.41518790E-05,
     *  3.55864188E-05, 3.70922829E-05, 3.86725976E-05, 4.03306348E-05,
     *  4.20698190E-05,
     *  3.02638448E-05, 3.15011147E-05, 3.28011612E-05, 3.41667097E-05,
     *  3.56006133E-05, 3.71058588E-05, 3.86855725E-05, 4.03430263E-05,
     *  4.20816447E-05,
     *  3.02806046E-05, 3.15171905E-05, 3.28165710E-05, 3.41814711E-05,
     *  3.56147439E-05, 3.71193760E-05, 3.86984935E-05, 4.03553686E-05,
     *  4.20934255E-05,
     *  3.02972790E-05, 3.15331868E-05, 3.28319069E-05, 3.41961642E-05,
     *  3.56288114E-05, 3.71328351E-05, 3.87113613E-05, 4.03676621E-05,
     *  4.21051619E-05/
        DATA ((VISCV (J,K),J=64,72),K=64,72) /
     *  3.03138695E-05, 3.15491047E-05, 3.28471701E-05, 3.42107899E-05,
     *  3.56428167E-05, 3.71462368E-05, 3.87241764E-05, 4.03799073E-05,
     *  4.21168541E-05,
     *  3.03303772E-05, 3.15649455E-05, 3.28623614E-05, 3.42253489E-05,
     *  3.56567603E-05, 3.71595818E-05, 3.87369393E-05, 4.03921048E-05,
     *  4.21285027E-05,
     *  3.03468033E-05, 3.15807101E-05, 3.28774818E-05, 3.42398421E-05,
     *  3.56706431E-05, 3.71728707E-05, 3.87496507E-05, 4.04042549E-05,
     *  4.21401080E-05,
     *  3.03631492E-05, 3.15963996E-05, 3.28925323E-05, 3.42542704E-05,
     *  3.56844657E-05, 3.71861040E-05, 3.87623109E-05, 4.04163582E-05,
     *  4.21516704E-05,
     *  3.03794160E-05, 3.16120151E-05, 3.29075137E-05, 3.42686345E-05,
     *  3.56982289E-05, 3.71992824E-05, 3.87749206E-05, 4.04284151E-05,
     *  4.21631904E-05,
     *  3.03956048E-05, 3.16275577E-05, 3.29224271E-05, 3.42829353E-05,
     *  3.57119334E-05, 3.72124066E-05, 3.87874802E-05, 4.04404259E-05,
     *  4.21746682E-05,
     *  3.04117169E-05, 3.16430283E-05, 3.29372733E-05, 3.42971736E-05,
     *  3.57255798E-05, 3.72254770E-05, 3.87999903E-05, 4.04523913E-05,
     *  4.21861043E-05,
     *  3.04277533E-05, 3.16584280E-05, 3.29520531E-05, 3.43113501E-05,
     *  3.57391689E-05, 3.72384944E-05, 3.88124515E-05, 4.04643116E-05,
     *  4.21974990E-05,
     *  3.04437153E-05, 3.16737577E-05, 3.29667676E-05, 3.43254656E-05,
     *  3.57527013E-05, 3.72514593E-05, 3.88248642E-05, 4.04761873E-05,
     *  4.22088528E-05/
        DATA ((VISCV (J,K),J=64,72),K=73,81) /
     *  3.04596038E-05, 3.16890185E-05, 3.29814175E-05, 3.43395208E-05,
     *  3.57661777E-05, 3.72643722E-05, 3.88372288E-05, 4.04880187E-05,
     *  4.22201659E-05,
     *  3.04754199E-05, 3.17042113E-05, 3.29960037E-05, 3.43535166E-05,
     *  3.57795987E-05, 3.72772338E-05, 3.88495460E-05, 4.04998064E-05,
     *  4.22314389E-05,
     *  3.04911648E-05, 3.17193370E-05, 3.30105270E-05, 3.43674536E-05,
     *  3.57929651E-05, 3.72900446E-05, 3.88618163E-05, 4.05115507E-05,
     *  4.22426719E-05,
     *  3.05068394E-05, 3.17343966E-05, 3.30249883E-05, 3.43813326E-05,
     *  3.58062773E-05, 3.73028052E-05, 3.88740400E-05, 4.05232521E-05,
     *  4.22538655E-05,
     *  3.05224449E-05, 3.17493910E-05, 3.30393884E-05, 3.43951544E-05,
     *  3.58195362E-05, 3.73155161E-05, 3.88862177E-05, 4.05349111E-05,
     *  4.22650199E-05,
     *  3.05379822E-05, 3.17643211E-05, 3.30537281E-05, 3.44089195E-05,
     *  3.58327422E-05, 3.73281779E-05, 3.88983498E-05, 4.05465279E-05,
     *  4.22761356E-05,
     *  3.05534522E-05, 3.17791878E-05, 3.30680081E-05, 3.44226288E-05,
     *  3.58458960E-05, 3.73407912E-05, 3.89104369E-05, 4.05581030E-05,
     *  4.22872128E-05,
     *  3.05688560E-05, 3.17939920E-05, 3.30822293E-05, 3.44362829E-05,
     *  3.58589983E-05, 3.73533564E-05, 3.89224794E-05, 4.05696369E-05,
     *  4.22982520E-05,
     *  3.05841946E-05, 3.18087345E-05, 3.30963924E-05, 3.44498825E-05,
     *  3.58720496E-05, 3.73658740E-05, 3.89344777E-05, 4.05811299E-05,
     *  4.23092534E-05/
        DATA ((VISCV (J,K),J=73,81),K= 1, 9) /
     *  4.31424796E-05, 4.50951417E-05, 4.71383290E-05, 4.92762112E-05,
     *  5.15131495E-05, 5.38537056E-05, 5.63026511E-05, 5.88649771E-05,
     *  6.15459044E-05,
     *  4.31568490E-05, 4.51086408E-05, 4.71510104E-05, 4.92881243E-05,
     *  5.15243407E-05, 5.38642186E-05, 5.63125268E-05, 5.88742542E-05,
     *  6.15546190E-05,
     *  4.31711542E-05, 4.51220835E-05, 4.71636424E-05, 4.92999940E-05,
     *  5.15354939E-05, 5.38746983E-05, 5.63223735E-05, 5.88835057E-05,
     *  6.15633113E-05,
     *  4.31853955E-05, 4.51354703E-05, 4.71762253E-05, 4.93118207E-05,
     *  5.15466094E-05, 5.38851449E-05, 5.63321911E-05, 5.88927319E-05,
     *  6.15719813E-05,
     *  4.31995734E-05, 4.51488015E-05, 4.71887593E-05, 4.93236047E-05,
     *  5.15576873E-05, 5.38955585E-05, 5.63419798E-05, 5.89019327E-05,
     *  6.15806291E-05,
     *  4.32136882E-05, 4.51620773E-05, 4.72012449E-05, 4.93353459E-05,
     *  5.15687279E-05, 5.39059394E-05, 5.63517397E-05, 5.89111082E-05,
     *  6.15892547E-05,
     *  4.32277404E-05, 4.51752981E-05, 4.72136821E-05, 4.93470448E-05,
     *  5.15797312E-05, 5.39162876E-05, 5.63614710E-05, 5.89202586E-05,
     *  6.15978583E-05,
     *  4.32417304E-05, 4.51884642E-05, 4.72260713E-05, 4.93587016E-05,
     *  5.15906975E-05, 5.39266033E-05, 5.63711737E-05, 5.89293839E-05,
     *  6.16064398E-05,
     *  4.32556586E-05, 4.52015760E-05, 4.72384128E-05, 4.93703163E-05,
     *  5.16016270E-05, 5.39368866E-05, 5.63808479E-05, 5.89384842E-05,
     *  6.16149994E-05/
        DATA ((VISCV (J,K),J=73,81),K=10,18) /
     *  4.32695254E-05, 4.52146339E-05, 4.72507068E-05, 4.93818894E-05,
     *  5.16125197E-05, 5.39471377E-05, 5.63904939E-05, 5.89475597E-05,
     *  6.16235372E-05,
     *  4.32833313E-05, 4.52276380E-05, 4.72629535E-05, 4.93934209E-05,
     *  5.16233760E-05, 5.39573566E-05, 5.64001116E-05, 5.89566104E-05,
     *  6.16320532E-05,
     *  4.32970766E-05, 4.52405889E-05, 4.72751534E-05, 4.94049110E-05,
     *  5.16341959E-05, 5.39675436E-05, 5.64097012E-05, 5.89656363E-05,
     *  6.16405474E-05,
     *  4.33107617E-05, 4.52534867E-05, 4.72873065E-05, 4.94163602E-05,
     *  5.16449796E-05, 5.39776988E-05, 5.64192629E-05, 5.89746377E-05,
     *  6.16490201E-05,
     *  4.33243872E-05, 4.52663319E-05, 4.72994133E-05, 4.94277684E-05,
     *  5.16557274E-05, 5.39878224E-05, 5.64287967E-05, 5.89836145E-05,
     *  6.16574711E-05,
     *  4.33379533E-05, 4.52791248E-05, 4.73114740E-05, 4.94391360E-05,
     *  5.16664393E-05, 5.39979144E-05, 5.64383027E-05, 5.89925670E-05,
     *  6.16659007E-05,
     *  4.33514605E-05, 4.52918658E-05, 4.73234888E-05, 4.94504632E-05,
     *  5.16771157E-05, 5.40079750E-05, 5.64477811E-05, 5.90014951E-05,
     *  6.16743089E-05,
     *  4.33649093E-05, 4.53045551E-05, 4.73354581E-05, 4.94617502E-05,
     *  5.16877566E-05, 5.40180044E-05, 5.64572320E-05, 5.90103990E-05,
     *  6.16826958E-05,
     *  4.33783001E-05, 4.53171931E-05, 4.73473821E-05, 4.94729973E-05,
     *  5.16983623E-05, 5.40280027E-05, 5.64666555E-05, 5.90192787E-05,
     *  6.16910614E-05/
        DATA ((VISCV (J,K),J=73,81),K=19,27) /
     *  4.33916332E-05, 4.53297802E-05, 4.73592610E-05, 4.94842046E-05,
     *  5.17089329E-05, 5.40379701E-05, 5.64760518E-05, 5.90281345E-05,
     *  6.16994059E-05,
     *  4.34049092E-05, 4.53423167E-05, 4.73710952E-05, 4.94953723E-05,
     *  5.17194686E-05, 5.40479067E-05, 5.64854209E-05, 5.90369662E-05,
     *  6.17077292E-05,
     *  4.34181283E-05, 4.53548029E-05, 4.73828850E-05, 4.95065008E-05,
     *  5.17299696E-05, 5.40578127E-05, 5.64947629E-05, 5.90457742E-05,
     *  6.17160316E-05,
     *  4.34312911E-05, 4.53672392E-05, 4.73946306E-05, 4.95175902E-05,
     *  5.17404360E-05, 5.40676881E-05, 5.65040781E-05, 5.90545584E-05,
     *  6.17243130E-05,
     *  4.34443980E-05, 4.53796259E-05, 4.74063323E-05, 4.95286408E-05,
     *  5.17508681E-05, 5.40775333E-05, 5.65133664E-05, 5.90633189E-05,
     *  6.17325735E-05,
     *  4.34574493E-05, 4.53919634E-05, 4.74179904E-05, 4.95396527E-05,
     *  5.17612661E-05, 5.40873482E-05, 5.65226281E-05, 5.90720559E-05,
     *  6.17408133E-05,
     *  4.34704455E-05, 4.54042520E-05, 4.74296051E-05, 4.95506263E-05,
     *  5.17716301E-05, 5.40971331E-05, 5.65318632E-05, 5.90807695E-05,
     *  6.17490324E-05,
     *  4.34833870E-05, 4.54164920E-05, 4.74411768E-05, 4.95615617E-05,
     *  5.17819603E-05, 5.41068881E-05, 5.65410719E-05, 5.90894597E-05,
     *  6.17572308E-05,
     *  4.34962743E-05, 4.54286838E-05, 4.74527056E-05, 4.95724592E-05,
     *  5.17922569E-05, 5.41166133E-05, 5.65502542E-05, 5.90981266E-05,
     *  6.17654087E-05/
        DATA ((VISCV (J,K),J=73,81),K=28,36) /
     *  4.35091077E-05, 4.54408278E-05, 4.74641920E-05, 4.95833189E-05,
     *  5.18025200E-05, 5.41263089E-05, 5.65594104E-05, 5.91067704E-05,
     *  6.17735661E-05,
     *  4.35218876E-05, 4.54529241E-05, 4.74756361E-05, 4.95941412E-05,
     *  5.18127500E-05, 5.41359751E-05, 5.65685405E-05, 5.91153912E-05,
     *  6.17817032E-05,
     *  4.35346145E-05, 4.54649733E-05, 4.74870382E-05, 4.96049261E-05,
     *  5.18229468E-05, 5.41456120E-05, 5.65776447E-05, 5.91239889E-05,
     *  6.17898200E-05,
     *  4.35472887E-05, 4.54769756E-05, 4.74983987E-05, 4.96156741E-05,
     *  5.18331108E-05, 5.41552198E-05, 5.65867231E-05, 5.91325638E-05,
     *  6.17979165E-05,
     *  4.35599108E-05, 4.54889314E-05, 4.75097178E-05, 4.96263852E-05,
     *  5.18432421E-05, 5.41647985E-05, 5.65957757E-05, 5.91411160E-05,
     *  6.18059929E-05,
     *  4.35724810E-05, 4.55008410E-05, 4.75209957E-05, 4.96370598E-05,
     *  5.18533409E-05, 5.41743484E-05, 5.66048028E-05, 5.91496455E-05,
     *  6.18140492E-05,
     *  4.35849998E-05, 4.55127047E-05, 4.75322327E-05, 4.96476980E-05,
     *  5.18634074E-05, 5.41838696E-05, 5.66138044E-05, 5.91581524E-05,
     *  6.18220856E-05,
     *  4.35974677E-05, 4.55245229E-05, 4.75434292E-05, 4.96583001E-05,
     *  5.18734417E-05, 5.41933623E-05, 5.66227806E-05, 5.91666369E-05,
     *  6.18301020E-05,
     *  4.36098849E-05, 4.55362959E-05, 4.75545854E-05, 4.96688662E-05,
     *  5.18834441E-05, 5.42028265E-05, 5.66317317E-05, 5.91750990E-05,
     *  6.18380986E-05/
        DATA ((VISCV (J,K),J=73,81),K=37,45) /
     *  4.36222519E-05, 4.55480241E-05, 4.75657015E-05, 4.96793967E-05,
     *  5.18934147E-05, 5.42122625E-05, 5.66406577E-05, 5.91835388E-05,
     *  6.18460755E-05,
     *  4.36345691E-05, 4.55597077E-05, 4.75767778E-05, 4.96898916E-05,
     *  5.19033538E-05, 5.42216704E-05, 5.66495587E-05, 5.91919565E-05,
     *  6.18540328E-05,
     *  4.36468370E-05, 4.55713471E-05, 4.75878147E-05, 4.97003514E-05,
     *  5.19132614E-05, 5.42310504E-05, 5.66584348E-05, 5.92003521E-05,
     *  6.18619704E-05,
     *  4.36590558E-05, 4.55829426E-05, 4.75988123E-05, 4.97107761E-05,
     *  5.19231378E-05, 5.42404025E-05, 5.66672862E-05, 5.92087257E-05,
     *  6.18698886E-05,
     *  4.36712260E-05, 4.55944946E-05, 4.76097709E-05, 4.97211660E-05,
     *  5.19329832E-05, 5.42497270E-05, 5.66761131E-05, 5.92170775E-05,
     *  6.18777874E-05,
     *  4.36833481E-05, 4.56060033E-05, 4.76206909E-05, 4.97315214E-05,
     *  5.19427977E-05, 5.42590240E-05, 5.66849154E-05, 5.92254075E-05,
     *  6.18856668E-05,
     *  4.36954222E-05, 4.56174692E-05, 4.76315724E-05, 4.97418424E-05,
     *  5.19525815E-05, 5.42682936E-05, 5.66936934E-05, 5.92337158E-05,
     *  6.18935270E-05,
     *  4.37074490E-05, 4.56288924E-05, 4.76424158E-05, 4.97521292E-05,
     *  5.19623348E-05, 5.42775361E-05, 5.67024471E-05, 5.92420026E-05,
     *  6.19013680E-05,
     *  4.37194287E-05, 4.56402734E-05, 4.76532213E-05, 4.97623821E-05,
     *  5.19720578E-05, 5.42867515E-05, 5.67111768E-05, 5.92502679E-05,
     *  6.19091899E-05/
        DATA ((VISCV (J,K),J=73,81),K=46,54) /
     *  4.37313617E-05, 4.56516125E-05, 4.76639892E-05, 4.97726014E-05,
     *  5.19817507E-05, 5.42959399E-05, 5.67198824E-05, 5.92585119E-05,
     *  6.19169928E-05,
     *  4.37432485E-05, 4.56629099E-05, 4.76747197E-05, 4.97827871E-05,
     *  5.19914136E-05, 5.43051016E-05, 5.67285642E-05, 5.92667345E-05,
     *  6.19247768E-05,
     *  4.37550893E-05, 4.56741661E-05, 4.76854131E-05, 4.97929396E-05,
     *  5.20010468E-05, 5.43142367E-05, 5.67372222E-05, 5.92749360E-05,
     *  6.19325419E-05,
     *  4.37668846E-05, 4.56853812E-05, 4.76960697E-05, 4.98030591E-05,
     *  5.20106503E-05, 5.43233454E-05, 5.67458566E-05, 5.92831165E-05,
     *  6.19402883E-05,
     *  4.37786348E-05, 4.56965556E-05, 4.77066896E-05, 4.98131457E-05,
     *  5.20202245E-05, 5.43324277E-05, 5.67544674E-05, 5.92912759E-05,
     *  6.19480160E-05,
     *  4.37903402E-05, 4.57076897E-05, 4.77172733E-05, 4.98231997E-05,
     *  5.20297694E-05, 5.43414839E-05, 5.67630549E-05, 5.92994145E-05,
     *  6.19557251E-05,
     *  4.38020012E-05, 4.57187838E-05, 4.77278209E-05, 4.98332212E-05,
     *  5.20392852E-05, 5.43505140E-05, 5.67716192E-05, 5.93075324E-05,
     *  6.19634157E-05,
     *  4.38136181E-05, 4.57298381E-05, 4.77383327E-05, 4.98432107E-05,
     *  5.20487721E-05, 5.43595182E-05, 5.67801602E-05, 5.93156295E-05,
     *  6.19710879E-05,
     *  4.38251914E-05, 4.57408529E-05, 4.77488090E-05, 4.98531681E-05,
     *  5.20582304E-05, 5.43684968E-05, 5.67886783E-05, 5.93237061E-05,
     *  6.19787417E-05/
        DATA ((VISCV (J,K),J=73,81),K=55,63) /
     *  4.38367213E-05, 4.57518286E-05, 4.77592499E-05, 4.98630937E-05,
     *  5.20676601E-05, 5.43774497E-05, 5.67971734E-05, 5.93317622E-05,
     *  6.19863772E-05,
     *  4.38482083E-05, 4.57627655E-05, 4.77696559E-05, 4.98729878E-05,
     *  5.20770614E-05, 5.43863772E-05, 5.68056458E-05, 5.93397979E-05,
     *  6.19939945E-05,
     *  4.38596527E-05, 4.57736638E-05, 4.77800270E-05, 4.98828506E-05,
     *  5.20864346E-05, 5.43952794E-05, 5.68140955E-05, 5.93478134E-05,
     *  6.20015937E-05,
     *  4.38710549E-05, 4.57845239E-05, 4.77903636E-05, 4.98926822E-05,
     *  5.20957797E-05, 5.44041564E-05, 5.68225226E-05, 5.93558087E-05,
     *  6.20091749E-05,
     *  4.38824152E-05, 4.57953461E-05, 4.78006659E-05, 4.99024830E-05,
     *  5.21050970E-05, 5.44130084E-05, 5.68309274E-05, 5.93637838E-05,
     *  6.20167381E-05,
     *  4.38937340E-05, 4.58061306E-05, 4.78109341E-05, 4.99122529E-05,
     *  5.21143867E-05, 5.44218356E-05, 5.68393098E-05, 5.93717391E-05,
     *  6.20242835E-05,
     *  4.39050116E-05, 4.58168778E-05, 4.78211686E-05, 4.99219924E-05,
     *  5.21236489E-05, 5.44306381E-05, 5.68476700E-05, 5.93796744E-05,
     *  6.20318110E-05,
     *  4.39162484E-05, 4.58275879E-05, 4.78313695E-05, 4.99317016E-05,
     *  5.21328837E-05, 5.44394159E-05, 5.68560081E-05, 5.93875899E-05,
     *  6.20393209E-05,
     *  4.39274446E-05, 4.58382612E-05, 4.78415372E-05, 4.99413807E-05,
     *  5.21420914E-05, 5.44481693E-05, 5.68643243E-05, 5.93954858E-05,
     *  6.20468131E-05/
        DATA ((VISCV (J,K),J=73,81),K=64,72) /
     *  4.39386008E-05, 4.58488981E-05, 4.78516717E-05, 4.99510298E-05,
     *  5.21512721E-05, 5.44568985E-05, 5.68726187E-05, 5.94033620E-05,
     *  6.20542878E-05,
     *  4.39497171E-05, 4.58594988E-05, 4.78617735E-05, 4.99606493E-05,
     *  5.21604260E-05, 5.44656035E-05, 5.68808913E-05, 5.94112188E-05,
     *  6.20617450E-05,
     *  4.39607939E-05, 4.58700636E-05, 4.78718426E-05, 4.99702393E-05,
     *  5.21695533E-05, 5.44742844E-05, 5.68891423E-05, 5.94190561E-05,
     *  6.20691848E-05,
     *  4.39718316E-05, 4.58805928E-05, 4.78818794E-05, 4.99798000E-05,
     *  5.21786541E-05, 5.44829415E-05, 5.68973719E-05, 5.94268742E-05,
     *  6.20766073E-05,
     *  4.39828305E-05, 4.58910866E-05, 4.78918842E-05, 4.99893316E-05,
     *  5.21877285E-05, 5.44915749E-05, 5.69055800E-05, 5.94346730E-05,
     *  6.20840126E-05,
     *  4.39937910E-05, 4.59015454E-05, 4.79018570E-05, 4.99988343E-05,
     *  5.21967769E-05, 5.45001846E-05, 5.69137669E-05, 5.94424528E-05,
     *  6.20914007E-05,
     *  4.40047133E-05, 4.59119694E-05, 4.79117982E-05, 5.00083083E-05,
     *  5.22057992E-05, 5.45087709E-05, 5.69219327E-05, 5.94502135E-05,
     *  6.20987718E-05,
     *  4.40155977E-05, 4.59223588E-05, 4.79217080E-05, 5.00177538E-05,
     *  5.22147958E-05, 5.45173339E-05, 5.69300775E-05, 5.94579553E-05,
     *  6.21061259E-05,
     *  4.40264447E-05, 4.59327141E-05, 4.79315867E-05, 5.00271710E-05,
     *  5.22237667E-05, 5.45258737E-05, 5.69382013E-05, 5.94656783E-05,
     *  6.21134630E-05/
        DATA ((VISCV (J,K),J=73,81),K=73,81) /
     *  4.40372545E-05, 4.59430354E-05, 4.79414344E-05, 5.00365601E-05,
     *  5.22327121E-05, 5.45343904E-05, 5.69463043E-05, 5.94733825E-05,
     *  6.21207833E-05,
     *  4.40480274E-05, 4.59533230E-05, 4.79512514E-05, 5.00459213E-05,
     *  5.22416323E-05, 5.45428843E-05, 5.69543867E-05, 5.94810682E-05,
     *  6.21280869E-05,
     *  4.40587637E-05, 4.59635771E-05, 4.79610379E-05, 5.00552547E-05,
     *  5.22505272E-05, 5.45513554E-05, 5.69624485E-05, 5.94887352E-05,
     *  6.21353738E-05,
     *  4.40694638E-05, 4.59737981E-05, 4.79707942E-05, 5.00645606E-05,
     *  5.22593972E-05, 5.45598038E-05, 5.69704898E-05, 5.94963839E-05,
     *  6.21426441E-05,
     *  4.40801280E-05, 4.59839862E-05, 4.79805204E-05, 5.00738392E-05,
     *  5.22682423E-05, 5.45682297E-05, 5.69785108E-05, 5.95040142E-05,
     *  6.21498978E-05,
     *  4.40907566E-05, 4.59941417E-05, 4.79902169E-05, 5.00830906E-05,
     *  5.22770627E-05, 5.45766333E-05, 5.69865116E-05, 5.95116262E-05,
     *  6.21571352E-05,
     *  4.41013498E-05, 4.60042648E-05, 4.79998837E-05, 5.00923150E-05,
     *  5.22858587E-05, 5.45850146E-05, 5.69944922E-05, 5.95192200E-05,
     *  6.21643561E-05,
     *  4.41119080E-05, 4.60143558E-05, 4.80095212E-05, 5.01015127E-05,
     *  5.22946302E-05, 5.45933738E-05, 5.70024528E-05, 5.95267958E-05,
     *  6.21715608E-05,
     *  4.41224315E-05, 4.60244150E-05, 4.80191295E-05, 5.01106838E-05,
     *  5.23033776E-05, 5.46017111E-05, 5.70103936E-05, 5.95343537E-05,
     *  6.21787493E-05/
        DATA ((CONDV (J,K),J= 1, 9),K= 1, 9) /
     *  1.66342795E-02, 1.73659757E-02, 1.81164395E-02, 1.88871767E-02,
     *  1.96798325E-02, 2.04961758E-02, 2.13380851E-02, 2.22075381E-02,
     *  2.31066013E-02,
     *  2.47784971E-02, 2.48203522E-02, 2.49897012E-02, 2.52640733E-02,
     *  2.56258616E-02, 2.60623618E-02, 2.65647705E-02, 2.71271952E-02,
     *  2.77458774E-02,
     *  3.27423288E-02, 3.24883234E-02, 3.22612596E-02, 3.21003579E-02,
     *  3.20343105E-02, 3.20775313E-02, 3.22317090E-02, 3.24905358E-02,
     *  3.28444835E-02,
     *  3.87675337E-02, 3.85997667E-02, 3.83740001E-02, 3.81208736E-02,
     *  3.78742065E-02, 3.76678329E-02, 3.75317315E-02, 3.74885664E-02,
     *  3.75518713E-02,
     *  4.39115917E-02, 4.38670649E-02, 4.37227814E-02, 4.35004651E-02,
     *  4.32265205E-02, 4.29309850E-02, 4.26457866E-02, 4.24023665E-02,
     *  4.22289821E-02,
     *  4.85591772E-02, 4.86473476E-02, 4.86080620E-02, 4.84570610E-02,
     *  4.82148893E-02, 4.79065193E-02, 4.75605507E-02, 4.72079232E-02,
     *  4.68801539E-02,
     *  5.28674773E-02, 5.30936407E-02, 5.31716675E-02, 5.31126808E-02,
     *  5.29325431E-02, 5.26517813E-02, 5.22952169E-02, 5.18912395E-02,
     *  5.14706884E-02,
     *  5.69185163E-02, 5.72858580E-02, 5.74888996E-02, 5.75348968E-02,
     *  5.74357199E-02, 5.72079618E-02, 5.68728206E-02, 5.64557020E-02,
     *  5.59855004E-02,
     *  6.07628867E-02, 6.12730165E-02, 6.16059558E-02, 6.17655959E-02,
     *  6.17602793E-02, 6.16030370E-02, 6.13116466E-02, 6.09084600E-02,
     *  6.04199582E-02/
        DATA ((CONDV (J,K),J= 1, 9),K=10,18) /
     *  6.44354263E-02, 6.50887602E-02, 6.55545221E-02, 6.58336221E-02,
     *  6.59312325E-02, 6.58571201E-02, 6.56258360E-02, 6.52567134E-02,
     *  6.47736298E-02,
     *  6.79619117E-02, 6.87579884E-02, 6.93580922E-02, 6.97604661E-02,
     *  6.99674088E-02, 6.99856797E-02, 6.98267897E-02, 6.95071335E-02,
     *  6.90479172E-02,
     *  7.13623446E-02, 7.23000739E-02, 7.30350237E-02, 7.35630343E-02,
     *  7.38837871E-02, 7.40012630E-02, 7.39241133E-02, 7.36658993E-02,
     *  7.32451549E-02,
     *  7.46527582E-02, 7.57306086E-02, 7.66001749E-02, 7.72551208E-02,
     *  7.76927342E-02, 7.79144253E-02, 7.79261594E-02, 7.77387831E-02,
     *  7.73681988E-02,
     *  7.78463077E-02, 7.90624439E-02, 8.00658675E-02, 8.08482609E-02,
     *  8.14047153E-02, 8.17342583E-02, 8.18403344E-02, 8.17312009E-02,
     *  8.14201955E-02,
     *  8.09539784E-02, 8.23063598E-02, 8.34425001E-02, 8.43522691E-02,
     *  8.50287349E-02, 8.54687126E-02, 8.56732811E-02, 8.56482352E-02,
     *  8.54044305E-02,
     *  8.39850721E-02, 8.54715226E-02, 8.67389648E-02, 8.77756018E-02,
     *  8.85726321E-02, 8.91248113E-02, 8.94309973E-02, 8.94946465E-02,
     *  8.93242238E-02,
     *  8.69475562E-02, 8.85658133E-02, 8.99629459E-02, 9.11256173E-02,
     *  9.20432914E-02, 9.27088021E-02, 9.31189194E-02, 9.32748813E-02,
     *  9.31828566E-02,
     *  8.98483223E-02, 9.15960712E-02, 9.31211422E-02, 9.44087693E-02,
     *  9.54468008E-02, 9.62262725E-02, 9.67419888E-02, 9.69930826E-02,
     *  9.69835218E-02/
        DATA ((CONDV (J,K),J= 1, 9),K=19,27) /
     *  9.26933834E-02, 9.45682798E-02, 9.62194374E-02, 9.76307567E-02,
     *  9.87885753E-02, 9.96822416E-02, 0.10030471    , 0.10065310    ,
     *  0.10072929    ,
     *  9.54880264E-02, 9.74877119E-02, 9.92630335E-02, 0.10079664    ,
     *  0.10207346    , 0.10308123    , 0.10381118    , 0.10425852    ,
     *  0.10442310    ,
     *  9.82369332E-02, 0.10035904    , 0.10225656    , 0.10391094    ,
     *  0.10530579    , 0.10642735    , 0.10726516    , 0.10781265    ,
     *  0.10806773    ,
     *  0.10094428    , 0.10318645    , 0.10520415    , 0.10697772    ,
     *  0.10848949    , 0.10972429    , 0.11067008    , 0.11131857    ,
     *  0.11166582    ,
     *  0.10361380    , 0.10597368    , 0.10810953    , 0.11000064    ,
     *  0.11162811    , 0.11297545    , 0.11402911    , 0.11477915    ,
     *  0.11521984    ,
     *  0.10624888    , 0.10872411    , 0.11097606    , 0.11298299    ,
     *  0.11472488    , 0.11618392    , 0.11734514    , 0.11819701    ,
     *  0.11873213    ,
     *  0.10885258    , 0.11144080    , 0.11380678    , 0.11592781    ,
     *  0.11778273    , 0.11935252    , 0.12062083    , 0.12157464    ,
     *  0.12220488    ,
     *  0.11142768    , 0.11412656    , 0.11660449    , 0.11883782    ,
     *  0.12080435    , 0.12248385    , 0.12385867    , 0.12491431    ,
     *  0.12564015    ,
     *  0.11397677    , 0.11678393    , 0.11937172    , 0.12171556    ,
     *  0.12379221    , 0.12558031    , 0.12706091    , 0.12821816    ,
     *  0.12903987    /
        DATA ((CONDV (J,K),J= 1, 9),K=28,36) /
     *  0.11650218    , 0.11941526    , 0.12211082    , 0.12456334    ,
     *  0.12674859    , 0.12864409    , 0.13022969    , 0.13148816    ,
     *  0.13240587    ,
     *  0.11900610    , 0.12202274    , 0.12482394    , 0.12738329    ,
     *  0.12967558    , 0.13167725    , 0.13336696    , 0.13472617    ,
     *  0.13573984    ,
     *  0.12149058    , 0.12460837    , 0.12751308    , 0.13017739    ,
     *  0.13257513    , 0.13468168    , 0.13647455    , 0.13793393    ,
     *  0.13904339    ,
     *  0.12395750    , 0.12717402    , 0.13018009    , 0.13294748    ,
     *  0.13544905    , 0.13765914    , 0.13955415    , 0.14111304    ,
     *  0.14231803    ,
     *  0.12640865    , 0.12972147    , 0.13282672    , 0.13569527    ,
     *  0.13829901    , 0.14061129    , 0.14260737    , 0.14426503    ,
     *  0.14556518    ,
     *  0.12884573    , 0.13225235    , 0.13545458    , 0.13842235    ,
     *  0.14112660    , 0.14353965    , 0.14563569    , 0.14739132    ,
     *  0.14878618    ,
     *  0.13127031    , 0.13476821    , 0.13806521    , 0.14113023    ,
     *  0.14393328    , 0.14644566    , 0.14864050    , 0.15049325    ,
     *  0.15198229    ,
     *  0.13368394    , 0.13727055    , 0.14066002    , 0.14382032    ,
     *  0.14672044    , 0.14933069    , 0.15162313    , 0.15357208    ,
     *  0.15515471    ,
     *  0.13608807    , 0.13976074    , 0.14324040    , 0.14649395    ,
     *  0.14948938    , 0.15219600    , 0.15458482    , 0.15662901    ,
     *  0.15830457    /
        DATA ((CONDV (J,K),J= 1, 9),K=37,45) /
     *  0.13848409    , 0.14224013    , 0.14580763    , 0.14915238    ,
     *  0.15224134    , 0.15504280    , 0.15752671    , 0.15966516    ,
     *  0.16143294    ,
     *  0.14087338    , 0.14471001    , 0.14836294    , 0.15179680    ,
     *  0.15497748    , 0.15787223    , 0.16044994    , 0.16268160    ,
     *  0.16454084    ,
     *  0.14325725    , 0.14717160    , 0.15090751    , 0.15442835    ,
     *  0.15769890    , 0.16068535    , 0.16335553    , 0.16567933    ,
     *  0.16762922    ,
     *  0.14563698    , 0.14962610    , 0.15344246    , 0.15704811    ,
     *  0.16040666    , 0.16348320    , 0.16624448    , 0.16865931    ,
     *  0.17069901    ,
     *  0.14801384    , 0.15207467    , 0.15596890    , 0.15965713    ,
     *  0.16310176    , 0.16626674    , 0.16911773    , 0.17162245    ,
     *  0.17375107    ,
     *  0.15038909    , 0.15451843    , 0.15848786    , 0.16225641    ,
     *  0.16578516    , 0.16903690    , 0.17197619    , 0.17456962    ,
     *  0.17678624    ,
     *  0.15276396    , 0.15695850    , 0.16100036    , 0.16484690    ,
     *  0.16845778    , 0.17179458    , 0.17482071    , 0.17750165    ,
     *  0.17980531    ,
     *  0.15513967    , 0.15939595    , 0.16350741    , 0.16742953    ,
     *  0.17112050    , 0.17454061    , 0.17765211    , 0.18041933    ,
     *  0.18280903    ,
     *  0.15751748    , 0.16183186    , 0.16600996    , 0.17000520    ,
     *  0.17377417    , 0.17727582    , 0.18047118    , 0.18332341    ,
     *  0.18579814    /
        DATA ((CONDV (J,K),J= 1, 9),K=46,54) /
     *  0.15989861    , 0.16426729    , 0.16850896    , 0.17257479    ,
     *  0.17641963    , 0.18000100    , 0.18327866    , 0.18621461    ,
     *  0.18877333    ,
     *  0.16228433    , 0.16670330    , 0.17100536    , 0.17513915    ,
     *  0.17905765    , 0.18271688    , 0.18607528    , 0.18909364    ,
     *  0.19173525    ,
     *  0.16467593    , 0.16914095    , 0.17350006    , 0.17769910    ,
     *  0.18168903    , 0.18542421    , 0.18886175    , 0.19196116    ,
     *  0.19468456    ,
     *  0.16707471    , 0.17158131    , 0.17599398    , 0.18025548    ,
     *  0.18431450    , 0.18812370    , 0.19163872    , 0.19481782    ,
     *  0.19762187    ,
     *  0.16948201    , 0.17402543    , 0.17848804    , 0.18280907    ,
     *  0.18693480    , 0.19081602    , 0.19440686    , 0.19766422    ,
     *  0.20054776    ,
     *  0.17189922    , 0.17647442    , 0.18098313    , 0.18536068    ,
     *  0.18955065    , 0.19350185    , 0.19716678    , 0.20050098    ,
     *  0.20346282    ,
     *  0.17432780    , 0.17892938    , 0.18348016    , 0.18791108    ,
     *  0.19216275    , 0.19618183    , 0.19991910    , 0.20332866    ,
     *  0.20636758    ,
     *  0.17676923    , 0.18139143    , 0.18598004    , 0.19046105    ,
     *  0.19477180    , 0.19885659    , 0.20266441    , 0.20614784    ,
     *  0.20926258    ,
     *  0.17922511    , 0.18386173    , 0.18848369    , 0.19301136    ,
     *  0.19737847    , 0.20152676    , 0.20540329    , 0.20895904    ,
     *  0.21214834    /
        DATA ((CONDV (J,K),J= 1, 9),K=55,63) /
     *  0.18169709    , 0.18634148    , 0.19099204    , 0.19556280    ,
     *  0.19998344    , 0.20419294    , 0.20813629    , 0.21176280    ,
     *  0.21502536    ,
     *  0.18418693    , 0.18883191    , 0.19350605    , 0.19811612    ,
     *  0.20258737    , 0.20685573    , 0.21086396    , 0.21455962    ,
     *  0.21789411    ,
     *  0.18669651    , 0.19133431    , 0.19602666    , 0.20067211    ,
     *  0.20519092    , 0.20951571    , 0.21358685    , 0.21735002    ,
     *  0.22075507    ,
     *  0.18922784    , 0.19385002    , 0.19855486    , 0.20323156    ,
     *  0.20779476    , 0.21217347    , 0.21630546    , 0.22013447    ,
     *  0.22360869    ,
     *  0.19178306    , 0.19638043    , 0.20109168    , 0.20579524    ,
     *  0.21039954    , 0.21482957    , 0.21902033    , 0.22291344    ,
     *  0.22645542    ,
     *  0.19436453    , 0.19892703    , 0.20363814    , 0.20836397    ,
     *  0.21300591    , 0.21748458    , 0.22173195    , 0.22568741    ,
     *  0.22929570    ,
     *  0.19697476    , 0.20149138    , 0.20619534    , 0.21093855    ,
     *  0.21561455    , 0.22013907    , 0.22444083    , 0.22845683    ,
     *  0.23212993    ,
     *  0.19961654    , 0.20407513    , 0.20876438    , 0.21351982    ,
     *  0.21822610    , 0.22279359    , 0.22714746    , 0.23122215    ,
     *  0.23495854    ,
     *  0.20229292    , 0.20668005    , 0.21134645    , 0.21610864    ,
     *  0.22084125    , 0.22544871    , 0.22985232    , 0.23398379    ,
     *  0.23778193    /
        DATA ((CONDV (J,K),J= 1, 9),K=64,72) /
     *  0.20500728    , 0.20930803    , 0.21394274    , 0.21870586    ,
     *  0.22346066    , 0.22810497    , 0.23255589    , 0.23674220    ,
     *  0.24060049    ,
     *  0.20776337    , 0.21196110    , 0.21655456    , 0.22131240    ,
     *  0.22608502    , 0.23076295    , 0.23525867    , 0.23949780    ,
     *  0.24341462    ,
     *  0.21056542    , 0.21464147    , 0.21918323    , 0.22392916    ,
     *  0.22871502    , 0.23342319    , 0.23796111    , 0.24225101    ,
     *  0.24622468    ,
     *  0.21341820    , 0.21735150    , 0.22183018    , 0.22655712    ,
     *  0.23135139    , 0.23608626    , 0.24066369    , 0.24500225    ,
     *  0.24903107    ,
     *  0.21632714    , 0.22009382    , 0.22449691    , 0.22919726    ,
     *  0.23399482    , 0.23875274    , 0.24336690    , 0.24775192    ,
     *  0.25183413    ,
     *  0.21929849    , 0.22287126    , 0.22718504    , 0.23185062    ,
     *  0.23664608    , 0.24142319    , 0.24607119    , 0.25050043    ,
     *  0.25463425    ,
     *  0.22233948    , 0.22568696    , 0.22989626    , 0.23451828    ,
     *  0.23930591    , 0.24409818    , 0.24877703    , 0.25324818    ,
     *  0.25743177    ,
     *  0.22545862    , 0.22854443    , 0.23263242    , 0.23720138    ,
     *  0.24197510    , 0.24677832    , 0.25148492    , 0.25599558    ,
     *  0.26022705    ,
     *  0.22866600    , 0.23144753    , 0.23539549    , 0.23990109    ,
     *  0.24465446    , 0.24946420    , 0.25419531    , 0.25874302    ,
     *  0.26302044    /
        DATA ((CONDV (J,K),J= 1, 9),K=73,81) /
     *  0.23197375    , 0.23440065    , 0.23818760    , 0.24261867    ,
     *  0.24734480    , 0.25215642    , 0.25690869    , 0.26149091    ,
     *  0.26581228    ,
     *  0.23539672    , 0.23740870    , 0.24101108    , 0.24535544    ,
     *  0.25004701    , 0.25485561    , 0.25962553    , 0.26423965    ,
     *  0.26860292    ,
     *  0.23895341    , 0.24047730    , 0.24386843    , 0.24811281    ,
     *  0.25276196    , 0.25756240    , 0.26234634    , 0.26698962    ,
     *  0.27139270    ,
     *  0.24266738    , 0.24361292    , 0.24676243    , 0.25089226    ,
     *  0.25549060    , 0.26027743    , 0.26507159    , 0.26974123    ,
     *  0.27418195    ,
     *  0.24656946    , 0.24682302    , 0.24969612    , 0.25369538    ,
     *  0.25823390    , 0.26300139    , 0.26780179    , 0.27249488    ,
     *  0.27697102    ,
     *  0.25070134    , 0.25011637    , 0.25267284    , 0.25652386    ,
     *  0.26099287    , 0.26573495    , 0.27053745    , 0.27525097    ,
     *  0.27976024    ,
     *  0.25512188    , 0.25350334    , 0.25569635    , 0.25937955    ,
     *  0.26376858    , 0.26847882    , 0.27327908    , 0.27800990    ,
     *  0.28254995    ,
     *  0.25991906    , 0.25699641    , 0.25877081    , 0.26226439    ,
     *  0.26656215    , 0.27123374    , 0.27602721    , 0.28077209    ,
     *  0.28534047    ,
     *  0.26523526    , 0.26061074    , 0.26190092    , 0.26518051    ,
     *  0.26937477    , 0.27400045    , 0.27878236    , 0.28353794    ,
     *  0.28813215    /
        DATA ((CONDV (J,K),J=10,18),K= 1, 9) /
     *  2.40374241E-02, 2.50022326E-02, 2.60033269E-02, 2.70430792E-02,
     *  2.81239333E-02, 2.92484055E-02, 3.04190866E-02, 3.16386446E-02,
     *  3.29098287E-02,
     *  2.84186211E-02, 2.91443804E-02, 2.99229648E-02, 3.07548291E-02,
     *  3.16409220E-02, 3.25825786E-02, 3.35814415E-02, 3.46394056E-02,
     *  3.57585775E-02,
     *  3.32839967E-02, 3.38010422E-02, 3.43895758E-02, 3.50454656E-02,
     *  3.57662096E-02, 3.65506191E-02, 3.73985356E-02, 3.83106002E-02,
     *  3.92880766E-02,
     *  3.77264169E-02, 3.80102770E-02, 3.83975335E-02, 3.88806953E-02,
     *  3.94523969E-02, 4.01063573E-02, 4.08377812E-02, 4.16434153E-02,
     *  4.25214232E-02,
     *  4.21482657E-02, 4.21756803E-02, 4.23192693E-02, 4.25806363E-02,
     *  4.29566991E-02, 4.34416359E-02, 4.40285774E-02, 4.47108370E-02,
     *  4.54826639E-02,
     *  4.66072382E-02, 4.64155055E-02, 4.63258314E-02, 4.63525963E-02,
     *  4.65035965E-02, 4.67808449E-02, 4.71819625E-02, 4.77017751E-02,
     *  4.83337893E-02,
     *  5.10653544E-02, 5.07061928E-02, 5.04214352E-02, 5.02348767E-02,
     *  5.01646360E-02, 5.02226180E-02, 5.04147471E-02, 5.07418529E-02,
     *  5.12009564E-02,
     *  5.54935373E-02, 5.50121781E-02, 5.45732048E-02, 5.42060934E-02,
     *  5.39364051E-02, 5.37845302E-02, 5.37649851E-02, 5.38863636E-02,
     *  5.41519041E-02,
     *  5.98760033E-02, 5.93087779E-02, 5.87514447E-02, 5.82366005E-02,
     *  5.77946558E-02, 5.74523179E-02, 5.72313738E-02, 5.71479471E-02,
     *  5.72123266E-02/
        DATA ((CONDV (J,K),J=10,18),K=10,18) /
     *  6.42044973E-02, 6.35804602E-02, 6.29348063E-02, 6.23016281E-02,
     *  6.17143161E-02, 6.12040061E-02, 6.07981396E-02, 6.05193079E-02,
     *  6.03845289E-02,
     *  6.84748413E-02, 6.78175115E-02, 6.71085669E-02, 6.63825416E-02,
     *  6.56745073E-02, 6.50185833E-02, 6.44464336E-02, 6.39858991E-02,
     *  6.36599156E-02,
     *  7.26852308E-02, 7.20138871E-02, 7.12626111E-02, 7.04656642E-02,
     *  6.96588820E-02, 6.88782876E-02, 6.81586090E-02, 6.75318210E-02,
     *  6.70258498E-02,
     *  7.68353457E-02, 7.61659485E-02, 7.53900049E-02, 7.45410025E-02,
     *  7.36548746E-02, 7.27687344E-02, 7.19194559E-02, 7.11421981E-02,
     *  7.04689955E-02,
     *  8.09258336E-02, 8.02716931E-02, 7.94860534E-02, 7.86012692E-02,
     *  7.76528765E-02, 7.66784550E-02, 7.57162952E-02, 7.48039513E-02,
     *  7.39767801E-02,
     *  8.49579796E-02, 8.43302560E-02, 8.35476688E-02, 8.26411804E-02,
     *  8.16455564E-02, 8.05983575E-02, 7.95387075E-02, 7.85059007E-02,
     *  7.75379346E-02,
     *  8.89334823E-02, 8.83415715E-02, 8.75729330E-02, 8.66569509E-02,
     *  8.56273373E-02, 8.45212528E-02, 8.33781828E-02, 8.22386175E-02,
     *  8.11426089E-02,
     *  9.28542965E-02, 9.23061336E-02, 9.15607856E-02, 9.06459266E-02,
     *  8.95940007E-02, 8.84414677E-02, 8.72277911E-02, 8.59942028E-02,
     *  8.47823056E-02,
     *  9.67225220E-02, 9.62248247E-02, 9.55107966E-02, 9.46063119E-02,
     *  9.35423853E-02, 9.23545381E-02, 9.10818991E-02, 8.97660614E-02,
     *  8.84497461E-02/
        DATA ((CONDV (J,K),J=10,18),K=19,27) /
     *  0.10054033    , 0.10009879    , 9.94229978E-02, 9.85369647E-02,
     *  9.74701555E-02, 9.62569662E-02, 9.49359350E-02, 9.35486973E-02,
     *  9.21387202E-02,
     *  0.10430988    , 0.10392935    , 0.10329776    , 0.10243724    ,
     *  0.10137562    , 0.10014603    , 9.87861966E-02, 9.73375361E-02,
     *  9.58439405E-02,
     *  0.10803335    , 0.10771792    , 0.10713569    , 0.10630687    ,
     *  0.10525761    , 0.10401962    , 0.10262969    , 0.10112878    ,
     *  9.95609117E-02,
     *  0.11171281    , 0.11146597    , 0.11093757    , 0.11014589    ,
     *  0.10911533    , 0.10787615    , 0.10646402    , 0.10491926    ,
     *  0.10328582    ,
     *  0.11535030    , 0.11517502    , 0.11470429    , 0.11395452    ,
     *  0.11294832    , 0.11171442    , 0.11028726    , 0.10870637    ,
     *  0.10701541    ,
     *  0.11894778    , 0.11884656    , 0.11843685    , 0.11773316    ,
     *  0.11675635    , 0.11553354    , 0.11409788    , 0.11248795    ,
     *  0.11074695    ,
     *  0.12250710    , 0.12248205    , 0.12213625    , 0.12148235    ,
     *  0.12053940    , 0.11933293    , 0.11789468    , 0.11626221    ,
     *  0.11447810    ,
     *  0.12603003    , 0.12608294    , 0.12580355    , 0.12520267    ,
     *  0.12429759    , 0.12311216    , 0.12167672    , 0.12002769    ,
     *  0.11820689    ,
     *  0.12951828    , 0.12965063    , 0.12943980    , 0.12889480    ,
     *  0.12803114    , 0.12687103    , 0.12544331    , 0.12378319    ,
     *  0.12193165    /
        DATA ((CONDV (J,K),J=10,18),K=28,36) /
     *  0.13297345    , 0.13318646    , 0.13304605    , 0.13255944    ,
     *  0.13174038    , 0.13060943    , 0.12919390    , 0.12752775    ,
     *  0.12565099    ,
     *  0.13639705    , 0.13669174    , 0.13662333    , 0.13619732    ,
     *  0.13542571    , 0.13432738    , 0.13292813    , 0.13126058    ,
     *  0.12936372    ,
     *  0.13979054    , 0.14016771    , 0.14017267    , 0.13980919    ,
     *  0.13908756    , 0.13802500    , 0.13664575    , 0.13498107    ,
     *  0.13306886    ,
     *  0.14315527    , 0.14361557    , 0.14369505    , 0.14339579    ,
     *  0.14272642    , 0.14170246    , 0.14034661    , 0.13868873    ,
     *  0.13676556    ,
     *  0.14649256    , 0.14703647    , 0.14719143    , 0.14695789    ,
     *  0.14634278    , 0.14535999    , 0.14403065    , 0.14238319    ,
     *  0.14045316    ,
     *  0.14980363    , 0.15043150    , 0.15066275    , 0.15049621    ,
     *  0.14993716    , 0.14899787    , 0.14769788    , 0.14606418    ,
     *  0.14413108    ,
     *  0.15308965    , 0.15380171    , 0.15410991    , 0.15401149    ,
     *  0.15351011    , 0.15261640    , 0.15134836    , 0.14973150    ,
     *  0.14779886    ,
     *  0.15635173    , 0.15714810    , 0.15753377    , 0.15750444    ,
     *  0.15706215    , 0.15621593    , 0.15498221    , 0.15338503    ,
     *  0.15145613    ,
     *  0.15959091    , 0.16047162    , 0.16093519    , 0.16097576    ,
     *  0.16059382    , 0.15979681    , 0.15859957    , 0.15702471    ,
     *  0.15510260    /
        DATA ((CONDV (J,K),J=10,18),K=37,45) /
     *  0.16280821    , 0.16377319    , 0.16431496    , 0.16442614    ,
     *  0.16410566    , 0.16335939    , 0.16220064    , 0.16065051    ,
     *  0.15873802    ,
     *  0.16600457    , 0.16705369    , 0.16767386    , 0.16785623    ,
     *  0.16759820    , 0.16690407    , 0.16578562    , 0.16426245    ,
     *  0.16236224    ,
     *  0.16918089    , 0.17031395    , 0.17101264    , 0.17126669    ,
     *  0.17107196    , 0.17043123    , 0.16935473    , 0.16786060    ,
     *  0.16597513    ,
     *  0.17233805    , 0.17355476    , 0.17433203    , 0.17465813    ,
     *  0.17452745    , 0.17394125    , 0.17290823    , 0.17144505    ,
     *  0.16957660    ,
     *  0.17547687    , 0.17677690    , 0.17763271    , 0.17803117    ,
     *  0.17796519    , 0.17743452    , 0.17644636    , 0.17501589    ,
     *  0.17316660    ,
     *  0.17859813    , 0.17998109    , 0.18091536    , 0.18138639    ,
     *  0.18138566    , 0.18091143    , 0.17996939    , 0.17857326    ,
     *  0.17674512    ,
     *  0.18170259    , 0.18316804    , 0.18418060    , 0.18472435    ,
     *  0.18478934    , 0.18437235    , 0.18347759    , 0.18211730    ,
     *  0.18031218    ,
     *  0.18479096    , 0.18633843    , 0.18742907    , 0.18804563    ,
     *  0.18817672    , 0.18781768    , 0.18697124    , 0.18564819    ,
     *  0.18386780    ,
     *  0.18786393    , 0.18949289    , 0.19066136    , 0.19135073    ,
     *  0.19154825    , 0.19124778    , 0.19045062    , 0.18916608    ,
     *  0.18741204    /
        DATA ((CONDV (J,K),J=10,18),K=46,54) /
     *  0.19092217    , 0.19263205    , 0.19387803    , 0.19464019    ,
     *  0.19490437    , 0.19466303    , 0.19391601    , 0.19267116    ,
     *  0.19094497    ,
     *  0.19396631    , 0.19575650    , 0.19707964    , 0.19791449    ,
     *  0.19824553    , 0.19806380    , 0.19736768    , 0.19616362    ,
     *  0.19446667    ,
     *  0.19699696    , 0.19886682    , 0.20026673    , 0.20117413    ,
     *  0.20157215    , 0.20145042    , 0.20080592    , 0.19964365    ,
     *  0.19797725    ,
     *  0.20001470    , 0.20196357    , 0.20343980    , 0.20441956    ,
     *  0.20488464    , 0.20482327    , 0.20423101    , 0.20311144    ,
     *  0.20147681    ,
     *  0.20302009    , 0.20504726    , 0.20659936    , 0.20765125    ,
     *  0.20818340    , 0.20818268    , 0.20764323    , 0.20656720    ,
     *  0.20496546    ,
     *  0.20601369    , 0.20811842    , 0.20974588    , 0.21086964    ,
     *  0.21146884    , 0.21152899    , 0.21104284    , 0.21001113    ,
     *  0.20844333    ,
     *  0.20899600    , 0.21117755    , 0.21287982    , 0.21407513    ,
     *  0.21474132    , 0.21486253    , 0.21443012    , 0.21344343    ,
     *  0.21191055    ,
     *  0.21196755    , 0.21422511    , 0.21600163    , 0.21726816    ,
     *  0.21800122    , 0.21818362    , 0.21780533    , 0.21686431    ,
     *  0.21536726    ,
     *  0.21492881    , 0.21726157    , 0.21911174    , 0.22044911    ,
     *  0.22124890    , 0.22149257    , 0.22116874    , 0.22027397    ,
     *  0.21881358    /
        DATA ((CONDV (J,K),J=10,18),K=55,63) /
     *  0.21788026    , 0.22028738    , 0.22221058    , 0.22361838    ,
     *  0.22448471    , 0.22478970    , 0.22452061    , 0.22367262    ,
     *  0.22224967    ,
     *  0.22082236    , 0.22330297    , 0.22529854    , 0.22677634    ,
     *  0.22770899    , 0.22807531    , 0.22786119    , 0.22706046    ,
     *  0.22567567    ,
     *  0.22375555    , 0.22630875    , 0.22837602    , 0.22992335    ,
     *  0.23092207    , 0.23134968    , 0.23119074    , 0.23043769    ,
     *  0.22909173    ,
     *  0.22668027    , 0.22930515    , 0.23144341    , 0.23305977    ,
     *  0.23412427    , 0.23461311    , 0.23450949    , 0.23380451    ,
     *  0.23249799    ,
     *  0.22959692    , 0.23229254    , 0.23450107    , 0.23618594    ,
     *  0.23731592    , 0.23786588    , 0.23781770    , 0.23716112    ,
     *  0.23589460    ,
     *  0.23250592    , 0.23527132    , 0.23754936    , 0.23930220    ,
     *  0.24049731    , 0.24110826    , 0.24111560    , 0.24050771    ,
     *  0.23928171    ,
     *  0.23540766    , 0.23824185    , 0.24058864    , 0.24240887    ,
     *  0.24366875    , 0.24434052    , 0.24440342    , 0.24384448    ,
     *  0.24265948    ,
     *  0.23830254    , 0.24120450    , 0.24361923    , 0.24550627    ,
     *  0.24683052    , 0.24756293    , 0.24768139    , 0.24717162    ,
     *  0.24602805    ,
     *  0.24119092    , 0.24415963    , 0.24664148    , 0.24859471    ,
     *  0.24998290    , 0.25077573    , 0.25094974    , 0.25048933    ,
     *  0.24938756    /
        DATA ((CONDV (J,K),J=10,18),K=64,72) /
     *  0.24407317    , 0.24710756    , 0.24965570    , 0.25167448    ,
     *  0.25312619    , 0.25397917    , 0.25420869    , 0.25379778    ,
     *  0.25273818    ,
     *  0.24694965    , 0.25004865    , 0.25266221    , 0.25474588    ,
     *  0.25626063    , 0.25717351    , 0.25745845    , 0.25709716    ,
     *  0.25608004    ,
     *  0.24982071    , 0.25298321    , 0.25566131    , 0.25780919    ,
     *  0.25938651    , 0.26035898    , 0.26069923    , 0.26038765    ,
     *  0.25941330    ,
     *  0.25268671    , 0.25591158    , 0.25865331    , 0.26086470    ,
     *  0.26250406    , 0.26353581    , 0.26393125    , 0.26366943    ,
     *  0.26273810    ,
     *  0.25554796    , 0.25883405    , 0.26163849    , 0.26391267    ,
     *  0.26561355    , 0.26670424    , 0.26715470    , 0.26694267    ,
     *  0.26605458    ,
     *  0.25840481    , 0.26175094    , 0.26461714    , 0.26695337    ,
     *  0.26871522    , 0.26986448    , 0.27036978    , 0.27020756    ,
     *  0.26936289    ,
     *  0.26125759    , 0.26466254    , 0.26758954    , 0.26998705    ,
     *  0.27180931    , 0.27301675    , 0.27357670    , 0.27346426    ,
     *  0.27266317    ,
     *  0.26410660    , 0.26756916    , 0.27055595    , 0.27301398    ,
     *  0.27489606    , 0.27616128    , 0.27677565    , 0.27671293    ,
     *  0.27595557    ,
     *  0.26695216    , 0.27047107    , 0.27351666    , 0.27603439    ,
     *  0.27797568    , 0.27929826    , 0.27996680    , 0.27995375    ,
     *  0.27924021    /
        DATA ((CONDV (J,K),J=10,18),K=73,81) /
     *  0.26979460    , 0.27336857    , 0.27647191    , 0.27904853    ,
     *  0.28104841    , 0.28242790    , 0.28315035    , 0.28318687    ,
     *  0.28251723    ,
     *  0.27263420    , 0.27626192    , 0.27942197    , 0.28205664    ,
     *  0.28411447    , 0.28555041    , 0.28632648    , 0.28641245    ,
     *  0.28578678    ,
     *  0.27547127    , 0.27915141    , 0.28236709    , 0.28505895    ,
     *  0.28717406    , 0.28866599    , 0.28949537    , 0.28963066    ,
     *  0.28904899    ,
     *  0.27830611    , 0.28203731    , 0.28530750    , 0.28805569    ,
     *  0.29022741    , 0.29177481    , 0.29265718    , 0.29284164    ,
     *  0.29230399    ,
     *  0.28113902    , 0.28491987    , 0.28824347    , 0.29104709    ,
     *  0.29327471    , 0.29487708    , 0.29581210    , 0.29604555    ,
     *  0.29555190    ,
     *  0.28397029    , 0.28779936    , 0.29117522    , 0.29403335    ,
     *  0.29631617    , 0.29797298    , 0.29896029    , 0.29924254    ,
     *  0.29879287    ,
     *  0.28680020    , 0.29067603    , 0.29410299    , 0.29701470    ,
     *  0.29935199    , 0.30106269    , 0.30210192    , 0.30243275    ,
     *  0.30202701    ,
     *  0.28962905    , 0.29355016    , 0.29702701    , 0.29999135    ,
     *  0.30238237    , 0.30414639    , 0.30523714    , 0.30561634    ,
     *  0.30525446    ,
     *  0.29245713    , 0.29642197    , 0.29994750    , 0.30296351    ,
     *  0.30540748    , 0.30722425    , 0.30836612    , 0.30879344    ,
     *  0.30847533    /
        DATA ((CONDV (J,K),J=19,27),K= 1, 9) /
     *  3.42354731E-02, 3.56185026E-02, 3.70619374E-02, 3.85688993E-02,
     *  4.01426180E-02, 4.17864380E-02, 4.35038248E-02, 4.52983732E-02,
     *  4.71738142E-02,
     *  3.69412467E-02, 3.81898661E-02, 3.95070385E-02, 4.08955079E-02,
     *  4.23581552E-02, 4.38979969E-02, 4.55181855E-02, 4.72220130E-02,
     *  4.90129147E-02,
     *  4.03327156E-02, 4.14466554E-02, 4.26323469E-02, 4.38924995E-02,
     *  4.52300406E-02, 4.66480880E-02, 4.81499288E-02, 4.97390069E-02,
     *  5.14189143E-02,
     *  4.34711910E-02, 4.44931193E-02, 4.55884351E-02, 4.67590313E-02,
     *  4.80073362E-02, 4.93362109E-02, 5.07488694E-02, 5.22488174E-02,
     *  5.38398064E-02,
     *  4.63396125E-02, 4.72786473E-02, 4.82980884E-02, 4.93974774E-02,
     *  5.05774134E-02, 5.18393878E-02, 5.31856348E-02, 5.46190014E-02,
     *  5.61428396E-02,
     *  4.90713565E-02, 4.99084715E-02, 5.08402402E-02, 5.18630912E-02,
     *  5.29748129E-02, 5.41744847E-02, 5.54623529E-02, 5.68396856E-02,
     *  5.83086268E-02,
     *  5.17866706E-02, 5.24924804E-02, 5.33117666E-02, 5.42385296E-02,
     *  5.52678365E-02, 5.63960455E-02, 5.76208690E-02, 5.89413341E-02,
     *  6.03576817E-02,
     *  5.45605105E-02, 5.51080032E-02, 5.57883775E-02, 5.65949093E-02,
     *  5.75210218E-02, 5.85608931E-02, 5.97098305E-02, 6.09644570E-02,
     *  6.23227619E-02,
     *  5.74293604E-02, 5.77993023E-02, 5.83189320E-02, 5.89827545E-02,
     *  5.97841177E-02, 6.07161455E-02, 6.17724413E-02, 6.29475659E-02,
     *  6.42373194E-02/
        DATA ((CONDV (J,K),J=19,27),K=10,18) /
     *  6.04050432E-02, 6.05866304E-02, 6.09303579E-02, 6.14336117E-02,
     *  6.20912391E-02, 6.28966516E-02, 6.38427813E-02, 6.49228364E-02,
     *  6.61308432E-02,
     *  6.34858451E-02, 6.34752937E-02, 6.36344131E-02, 6.39646068E-02,
     *  6.44635109E-02, 6.51260937E-02, 6.59457379E-02, 6.69151984E-02,
     *  6.80273798E-02,
     *  6.66635772E-02, 6.64622516E-02, 6.64333624E-02, 6.65829681E-02,
     *  6.69124007E-02, 6.74192242E-02, 6.80983086E-02, 6.89428894E-02,
     *  6.99455166E-02,
     *  6.99275432E-02, 6.95402997E-02, 6.93239969E-02, 6.92895977E-02,
     *  6.94426777E-02, 6.97841549E-02, 7.03112474E-02, 7.10185325E-02,
     *  7.18989861E-02,
     *  7.32665891E-02, 7.27005141E-02, 7.23002359E-02, 7.20816063E-02,
     *  7.20547062E-02, 7.22243019E-02, 7.25906154E-02, 7.31502961E-02,
     *  7.38974712E-02,
     *  7.66700782E-02, 7.59335915E-02, 7.53547125E-02, 7.49540015E-02,
     *  7.47460986E-02, 7.47398955E-02, 7.49390779E-02, 7.53429473E-02,
     *  7.59474127E-02,
     *  8.01283007E-02, 7.92305418E-02, 7.84796981E-02, 7.79007641E-02,
     *  7.75128522E-02, 7.73290909E-02, 7.73569216E-02, 7.75987312E-02,
     *  7.80527308E-02,
     *  8.36325964E-02, 8.25830129E-02, 8.16676154E-02, 8.09155099E-02,
     *  8.03501049E-02, 7.99887570E-02, 7.98428203E-02, 7.99180705E-02,
     *  8.02154310E-02,
     *  8.71753420E-02, 8.59834168E-02, 8.49113052E-02, 8.39918828E-02,
     *  8.32526244E-02, 8.27150216E-02, 8.23943959E-02, 8.23001051E-02,
     *  8.24360939E-02/
        DATA ((CONDV (J,K),J=19,27),K=19,27) /
     *  9.07498775E-02, 8.94249501E-02, 8.82041501E-02, 8.71237780E-02,
     *  8.62151156E-02, 8.55036405E-02, 8.50086195E-02, 8.47430979E-02,
     *  8.47142619E-02,
     *  9.43504102E-02, 9.29015622E-02, 9.15401153E-02, 9.03054590E-02,
     *  8.92324083E-02, 8.83502425E-02, 8.76820953E-02, 8.72447359E-02,
     *  8.70487375E-02,
     *  9.79719149E-02, 9.64078985E-02, 9.49137453E-02, 9.35316106E-02,
     *  9.22995667E-02, 9.12504876E-02, 9.04112566E-02, 8.98023497E-02,
     *  8.94378114E-02,
     *  0.10161004    , 9.99392355E-02, 9.83201351E-02, 9.67973536E-02,
     *  9.54119473E-02, 9.42001665E-02, 9.31924995E-02, 9.24130718E-02,
     *  9.18794338E-02,
     *  0.10526102    , 0.10349141    , 0.10175489    , 0.10009824    ,
     *  9.85652253E-02, 9.71952602E-02, 9.60222725E-02, 9.50739496E-02,
     *  9.43713427E-02,
     *  0.10892159    , 0.10706078    , 0.10521409    , 0.10343022    ,
     *  0.10175540    , 0.10023197    , 9.88971344E-02, 9.77820243E-02,
     *  9.69111586E-02,
     *  0.11258895    , 0.11064411    , 0.10869422    , 0.10678963    ,
     *  0.10497879    , 0.10330675    , 0.10181379    , 0.10053439    ,
     *  9.94964536E-02,
     *  0.11626065    , 0.11423859    , 0.11219217    , 0.11017317    ,
     *  0.10823202    , 0.10641627    , 0.10476911    , 0.10332821    ,
     *  0.10212480    ,
     *  0.11993461    , 0.11784175    , 0.11570516    , 0.11357784    ,
     *  0.11151199    , 0.10955746    , 0.10776015    , 0.10616077    ,
     *  0.10479381    /
        DATA ((CONDV (J,K),J=19,27),K=28,36) /
     *  0.12360900    , 0.12145139    , 0.11923071    , 0.11700095    ,
     *  0.11481589    , 0.11272746    , 0.11078413    , 0.10902949    ,
     *  0.10750116    ,
     *  0.12728227    , 0.12506562    , 0.12276661    , 0.12044006    ,
     *  0.11814114    , 0.11592366    , 0.11383846    , 0.11193190    ,
     *  0.11024460    ,
     *  0.13095306    , 0.12868275    , 0.12631090    , 0.12389299    ,
     *  0.12148538    , 0.11914361    , 0.11692072    , 0.11486566    ,
     *  0.11302196    ,
     *  0.13462022    , 0.13230131    , 0.12986184    , 0.12735777    ,
     *  0.12484649    , 0.12238509    , 0.12002866    , 0.11782859    ,
     *  0.11583119    ,
     *  0.13828275    , 0.13592002    , 0.13341786    , 0.13083260    ,
     *  0.12822250    , 0.12564604    , 0.12316017    , 0.12081862    ,
     *  0.11867033    ,
     *  0.14193979    , 0.13953774    , 0.13697759    , 0.13431589    ,
     *  0.13161165    , 0.12892457    , 0.12631332    , 0.12383380    ,
     *  0.12153750    ,
     *  0.14559061    , 0.14315348    , 0.14053978    , 0.13780620    ,
     *  0.13501231    , 0.13221893    , 0.12948629    , 0.12687233    ,
     *  0.12443094    ,
     *  0.14923460    , 0.14676637    , 0.14410335    , 0.14130221    ,
     *  0.13842302    , 0.13552752    , 0.13267741    , 0.12993250    ,
     *  0.12734898    ,
     *  0.15287121    , 0.15037565    , 0.14766730    , 0.14480276    ,
     *  0.14184242    , 0.13884887    , 0.13588511    , 0.13301271    ,
     *  0.13029004    /
        DATA ((CONDV (J,K),J=19,27),K=37,45) /
     *  0.15650001    , 0.15398066    , 0.15123078    , 0.14830678    ,
     *  0.14526930    , 0.14218164    , 0.13910796    , 0.13611149    ,
     *  0.13325264    ,
     *  0.16012062    , 0.15758081    , 0.15479301    , 0.15181332    ,
     *  0.14870255    , 0.14552456    , 0.14234461    , 0.13922743    ,
     *  0.13623538    ,
     *  0.16373271    , 0.16117561    , 0.15835329    , 0.15532152    ,
     *  0.15214114    , 0.14887651    , 0.14559383    , 0.14235925    ,
     *  0.13923693    ,
     *  0.16733605    , 0.16476462    , 0.16191102    , 0.15883059    ,
     *  0.15558414    , 0.15223642    , 0.14885447    , 0.14550571    ,
     *  0.14225606    ,
     *  0.17093040    , 0.16834745    , 0.16546564    , 0.16233984    ,
     *  0.15903072    , 0.15560333    , 0.15212545    , 0.14866570    ,
     *  0.14529159    ,
     *  0.17451561    , 0.17192379    , 0.16901669    , 0.16584863    ,
     *  0.16248009    , 0.15897634    , 0.15540579    , 0.15183814    ,
     *  0.14834243    ,
     *  0.17809155    , 0.17549335    , 0.17256373    , 0.16935639    ,
     *  0.16593156    , 0.16235464    , 0.15869457    , 0.15502206    ,
     *  0.15140754    ,
     *  0.18165810    , 0.17905589    , 0.17610638    , 0.17286261    ,
     *  0.16938449    , 0.16573745    , 0.16199094    , 0.15821651    ,
     *  0.15448596    ,
     *  0.18521521    , 0.18261121    , 0.17964430    , 0.17636682    ,
     *  0.17283828    , 0.16912410    , 0.16529409    , 0.16142065    ,
     *  0.15757676    /
        DATA ((CONDV (J,K),J=19,27),K=46,54) /
     *  0.18876282    , 0.18615914    , 0.18317721    , 0.17986860    ,
     *  0.17629240    , 0.17251393    , 0.16860331    , 0.16463365    ,
     *  0.16067909    ,
     *  0.19230091    , 0.18969955    , 0.18670484    , 0.18336759    ,
     *  0.17974636    , 0.17590635    , 0.17191791    , 0.16785477    ,
     *  0.16379214    ,
     *  0.19582947    , 0.19323231    , 0.19022696    , 0.18686343    ,
     *  0.18319972    , 0.17930082    , 0.17523725    , 0.17108330    ,
     *  0.16691515    ,
     *  0.19934851    , 0.19675733    , 0.19374339    , 0.19035582    ,
     *  0.18665207    , 0.18269684    , 0.17856074    , 0.17431857    ,
     *  0.17004740    ,
     *  0.20285806    , 0.20027454    , 0.19725394    , 0.19384450    ,
     *  0.19010303    , 0.18609393    , 0.18188784    , 0.17755997    ,
     *  0.17318822    ,
     *  0.20635816    , 0.20378389    , 0.20075846    , 0.19732921    ,
     *  0.19355227    , 0.18949167    , 0.18521803    , 0.18080691    ,
     *  0.17633698    ,
     *  0.20984885    , 0.20728534    , 0.20425684    , 0.20080974    ,
     *  0.19699948    , 0.19288967    , 0.18855084    , 0.18405887    ,
     *  0.17949307    ,
     *  0.21333019    , 0.21077886    , 0.20774896    , 0.20428589    ,
     *  0.20044437    , 0.19628755    , 0.19188584    , 0.18731532    ,
     *  0.18265594    ,
     *  0.21680225    , 0.21426445    , 0.21123472    , 0.20775749    ,
     *  0.20388669    , 0.19968499    , 0.19522260    , 0.19057579    ,
     *  0.18582505    /
        DATA ((CONDV (J,K),J=19,27),K=55,63) /
     *  0.22026510    , 0.21774211    , 0.21471406    , 0.21122438    ,
     *  0.20732621    , 0.20308168    , 0.19856076    , 0.19383984    ,
     *  0.18899992    ,
     *  0.22371882    , 0.22121185    , 0.21818691    , 0.21468642    ,
     *  0.21076271    , 0.20647732    , 0.20189995    , 0.19710706    ,
     *  0.19218006    ,
     *  0.22716351    , 0.22467368    , 0.22165322    , 0.21814351    ,
     *  0.21419600    , 0.20987165    , 0.20523984    , 0.20037704    ,
     *  0.19536503    ,
     *  0.23059924    , 0.22812764    , 0.22511296    , 0.22159551    ,
     *  0.21762590    , 0.21326443    , 0.20858013    , 0.20364942    ,
     *  0.19855442    ,
     *  0.23402612    , 0.23157376    , 0.22856609    , 0.22504236    ,
     *  0.22105226    , 0.21665544    , 0.21192052    , 0.20692386    ,
     *  0.20174784    ,
     *  0.23744424    , 0.23501208    , 0.23201260    , 0.22848396    ,
     *  0.22447493    , 0.22004446    , 0.21526075    , 0.21020003    ,
     *  0.20494490    ,
     *  0.24085371    , 0.23844266    , 0.23545248    , 0.23192024    ,
     *  0.22789378    , 0.22343131    , 0.21860058    , 0.21347764    ,
     *  0.20814527    ,
     *  0.24425462    , 0.24186553    , 0.23888573    , 0.23535115    ,
     *  0.23130869    , 0.22681581    , 0.22193976    , 0.21675639    ,
     *  0.21134860    ,
     *  0.24764708    , 0.24528077    , 0.24231235    , 0.23877664    ,
     *  0.23471956    , 0.23019781    , 0.22527809    , 0.22003603    ,
     *  0.21455459    /
        DATA ((CONDV (J,K),J=19,27),K=64,72) /
     *  0.25103120    , 0.24868843    , 0.24573236    , 0.24219666    ,
     *  0.23812629    , 0.23357714    , 0.22861537    , 0.22331629    ,
     *  0.21776294    ,
     *  0.25440708    , 0.25208857    , 0.24914576    , 0.24561119    ,
     *  0.24152881    , 0.23695369    , 0.23195139    , 0.22659695    ,
     *  0.22097337    ,
     *  0.25777484    , 0.25548127    , 0.25255258    , 0.24902019    ,
     *  0.24492702    , 0.24032731    , 0.23528600    , 0.22987778    ,
     *  0.22418562    ,
     *  0.26113458    , 0.25886658    , 0.25595286    , 0.25242365    ,
     *  0.24832087    , 0.24369789    , 0.23861904    , 0.23315858    ,
     *  0.22739944    ,
     *  0.26448642    , 0.26224459    , 0.25934661    , 0.25582156    ,
     *  0.25171030    , 0.24706534    , 0.24195033    , 0.23643916    ,
     *  0.23061459    ,
     *  0.26783046    , 0.26561536    , 0.26273387    , 0.25921390    ,
     *  0.25509526    , 0.25042955    , 0.24527976    , 0.23971932    ,
     *  0.23383086    ,
     *  0.27116681    , 0.26897898    , 0.26611469    , 0.26260068    ,
     *  0.25847569    , 0.25379044    , 0.24860719    , 0.24299890    ,
     *  0.23704803    ,
     *  0.27449559    , 0.27233552    , 0.26948910    , 0.26598189    ,
     *  0.26185157    , 0.25714793    , 0.25193249    , 0.24627774    ,
     *  0.24026590    ,
     *  0.27781690    , 0.27568505    , 0.27285714    , 0.26935755    ,
     *  0.26522286    , 0.26050194    , 0.25525556    , 0.24955568    ,
     *  0.24348429    /
        DATA ((CONDV (J,K),J=19,27),K=73,81) /
     *  0.28113086    , 0.27902765    , 0.27621886    , 0.27272765    ,
     *  0.26858954    , 0.26385241    , 0.25857629    , 0.25283259    ,
     *  0.24670302    ,
     *  0.28443757    , 0.28236342    , 0.27957431    , 0.27609223    ,
     *  0.27195157    , 0.26719928    , 0.26189458    , 0.25610833    ,
     *  0.24992192    ,
     *  0.28773714    , 0.28569242    , 0.28292354    , 0.27945128    ,
     *  0.27530895    , 0.27054250    , 0.26521035    , 0.25938278    ,
     *  0.25314084    ,
     *  0.29102968    , 0.28901473    , 0.28626659    , 0.28280484    ,
     *  0.27866165    , 0.27388201    , 0.26852351    , 0.26265581    ,
     *  0.25635961    ,
     *  0.29431530    , 0.29233044    , 0.28960353    , 0.28615292    ,
     *  0.28200968    , 0.27721778    , 0.27183398    , 0.26592732    ,
     *  0.25957810    ,
     *  0.29759410    , 0.29563964    , 0.29293441    , 0.28949556    ,
     *  0.28535302    , 0.28054976    , 0.27514170    , 0.26919720    ,
     *  0.26279618    ,
     *  0.30086619    , 0.29894239    , 0.29625927    , 0.29283277    ,
     *  0.28869167    , 0.28387793    , 0.27844659    , 0.27246536    ,
     *  0.26601372    ,
     *  0.30413167    , 0.30223879    , 0.29957819    , 0.29616458    ,
     *  0.29202563    , 0.28720224    , 0.28174860    , 0.27573171    ,
     *  0.26923059    ,
     *  0.30739065    , 0.30552891    , 0.30289121    , 0.29949104    ,
     *  0.29535490    , 0.29052269    , 0.28504767    , 0.27899616    ,
     *  0.27244669    /
        DATA ((CONDV (J,K),J=28,36),K= 1, 9) /
     *  4.91340232E-02, 5.11830281E-02, 5.33250178E-02, 5.55643509E-02,
     *  5.79055652E-02, 6.03533864E-02, 6.29127387E-02, 6.55887541E-02,
     *  6.83867836E-02,
     *  5.08944756E-02, 5.28704367E-02, 5.49447030E-02, 5.71213523E-02,
     *  5.94046440E-02, 6.17990291E-02, 6.43091607E-02, 6.69399045E-02,
     *  6.96963503E-02,
     *  5.31933874E-02, 5.50663062E-02, 5.70416966E-02, 5.91237348E-02,
     *  6.13167543E-02, 6.36252534E-02, 6.60539055E-02, 6.86075697E-02,
     *  7.12913028E-02,
     *  5.55258001E-02, 5.73109493E-02, 5.91995758E-02, 6.11961615E-02,
     *  6.33053430E-02, 6.55319105E-02, 6.78808099E-02, 7.03571486E-02,
     *  7.29662031E-02,
     *  5.77609184E-02, 5.94773539E-02, 6.12965545E-02, 6.32231788E-02,
     *  6.52621038E-02, 6.74184024E-02, 6.96973283E-02, 7.21043064E-02,
     *  7.46449298E-02,
     *  5.98720615E-02, 6.15334967E-02, 6.32969597E-02, 6.51669138E-02,
     *  6.71481887E-02, 6.92459260E-02, 7.14655354E-02, 7.38126622E-02,
     *  7.62931636E-02,
     *  6.18712381E-02, 6.34842778E-02, 6.51998914E-02, 6.70218648E-02,
     *  6.89545724E-02, 7.10028860E-02, 7.31720983E-02, 7.54678602E-02,
     *  7.78961300E-02,
     *  6.37840607E-02, 6.53489007E-02, 6.70189395E-02, 6.87968142E-02,
     *  7.06860128E-02, 7.26907554E-02, 7.48158865E-02, 7.70667823E-02,
     *  7.94492714E-02,
     *  6.56388695E-02, 6.71507693E-02, 6.87729016E-02, 7.05063800E-02,
     *  7.23534281E-02, 7.43172509E-02, 7.64019103E-02, 7.86122077E-02,
     *  8.09535797E-02/
        DATA ((CONDV (J,K),J=28,36),K=10,18) /
     *  6.74619934E-02, 6.89128314E-02, 7.04813195E-02, 7.21668168E-02,
     *  7.39700027E-02, 7.58927689E-02, 7.79380953E-02, 8.01099238E-02,
     *  8.24130354E-02,
     *  6.92759140E-02, 7.06555483E-02, 7.21623718E-02, 7.37939151E-02,
     *  7.55491559E-02, 7.74284619E-02, 7.94334940E-02, 8.15670879E-02,
     *  8.38331283E-02,
     *  7.10988361E-02, 7.23961806E-02, 7.38319793E-02, 7.54020068E-02,
     *  7.71035042E-02, 7.89352034E-02, 8.08972829E-02, 8.29912806E-02,
     *  8.52199797E-02,
     *  7.29449163E-02, 7.41487345E-02, 7.55035465E-02, 7.70035665E-02,
     *  7.86443758E-02, 8.04230539E-02, 8.23382125E-02, 8.43899600E-02,
     *  8.65798186E-02,
     *  7.48247667E-02, 7.59242190E-02, 7.71880281E-02, 7.86091358E-02,
     *  8.01816331E-02, 8.19010167E-02, 8.37643216E-02, 8.57701571E-02,
     *  8.79186739E-02,
     *  7.67460354E-02, 7.77310301E-02, 7.88941503E-02, 8.02274153E-02,
     *  8.17236670E-02, 8.33769606E-02, 8.51828110E-02, 8.71383180E-02,
     *  8.92421992E-02,
     *  7.87139673E-02, 7.95753628E-02, 8.06286925E-02, 8.18654380E-02,
     *  8.32774825E-02, 8.48576377E-02, 8.66000118E-02, 8.85002370E-02,
     *  9.05555833E-02,
     *  8.07319044E-02, 8.14616033E-02, 8.23967793E-02, 8.35287724E-02,
     *  8.48488279E-02, 8.63487528E-02, 8.80214076E-02, 8.98610446E-02,
     *  9.18635127E-02,
     *  8.28017088E-02, 8.33926785E-02, 8.42021553E-02, 8.52217287E-02,
     *  8.64423403E-02, 8.78550578E-02, 8.94516877E-02, 9.12252273E-02,
     *  9.31701686E-02/
        DATA ((CONDV (J,K),J=28,36),K=19,27) /
     *  8.49241111E-02, 8.53703553E-02, 8.60474326E-02, 8.69475538E-02,
     *  8.80616919E-02, 8.93804556E-02, 9.08948153E-02, 9.25966676E-02,
     *  9.44792427E-02,
     *  8.70989912E-02, 8.73954921E-02, 8.79343044E-02, 8.87086068E-02,
     *  8.97097282E-02, 9.09281038E-02, 9.23541011E-02, 9.39786922E-02,
     *  9.57939659E-02,
     *  8.93255997E-02, 8.94682434E-02, 8.98637277E-02, 9.05065132E-02,
     *  9.13885942E-02, 9.25005137E-02, 9.38322772E-02, 9.53741242E-02,
     *  9.71171426E-02,
     *  9.16027326E-02, 9.15882272E-02, 9.18360744E-02, 9.23422983E-02,
     *  9.30998454E-02, 9.40996401E-02, 9.53315676E-02, 9.67853361E-02,
     *  9.84511878E-02,
     *  9.39288655E-02, 9.37546579E-02, 9.38512580E-02, 9.42165001E-02,
     *  9.48445470E-02, 9.57269636E-02, 9.68537539E-02, 9.82143001E-02,
     *  9.97981644E-02,
     *  9.63022574E-02, 9.59664530E-02, 9.59088355E-02, 9.61292644E-02,
     *  9.66233570E-02, 9.73835623E-02, 9.84002344E-02, 9.96626353E-02,
     *  0.10115982    ,
     *  9.87210300E-02, 9.82223163E-02, 9.80080918E-02, 9.80804244E-02,
     *  9.84365994E-02, 9.90701754E-02, 9.99720777E-02, 0.10113165    ,
     *  0.10253762    ,
     *  0.10118323    , 0.10052080    , 0.10014811    , 0.10006957    ,
     *  0.10028432    , 0.10078726    , 0.10157007    , 0.10262239    ,
     *  0.10393278    ,
     *  0.10368686    , 0.10286038    , 0.10232781    , 0.10209608    ,
     *  0.10216636    , 0.10253503    , 0.10319476    , 0.10413565    ,
     *  0.10534629    /
        DATA ((CONDV (J,K),J=28,36),K=28,36) /
     *  0.10622994    , 0.10523943    , 0.10454602    , 0.10415922    ,
     *  0.10408236    , 0.10431350    , 0.10484648    , 0.10567205    ,
     *  0.10677897    ,
     *  0.10881051    , 0.10765636    , 0.10680149    , 0.10625811    ,
     *  0.10603184    , 0.10612255    , 0.10652541    , 0.10723200    ,
     *  0.10823143    ,
     *  0.11142664    , 0.11010951    , 0.10909293    , 0.10839181    ,
     *  0.10801419    , 0.10796189    , 0.10823157    , 0.10881578    ,
     *  0.10970416    ,
     *  0.11407647    , 0.11259730    , 0.11141900    , 0.11055931    ,
     *  0.11002872    , 0.10983115    , 0.10996485    , 0.11042355    ,
     *  0.11119752    ,
     *  0.11675820    , 0.11511812    , 0.11377839    , 0.11275957    ,
     *  0.11207469    , 0.11172985    , 0.11172507    , 0.11205533    ,
     *  0.11271174    ,
     *  0.11947010    , 0.11767044    , 0.11616978    , 0.11499151    ,
     *  0.11415128    , 0.11365747    , 0.11351194    , 0.11371109    ,
     *  0.11424697    ,
     *  0.12221051    , 0.12025276    , 0.11859186    , 0.11725407    ,
     *  0.11625768    , 0.11561341    , 0.11532510    , 0.11539068    ,
     *  0.11580327    ,
     *  0.12497784    , 0.12286361    , 0.12104335    , 0.11954615    ,
     *  0.11839301    , 0.11759704    , 0.11716415    , 0.11709391    ,
     *  0.11738062    ,
     *  0.12777059    , 0.12550160    , 0.12352300    , 0.12186671    ,
     *  0.12055641    , 0.11960771    , 0.11902864    , 0.11882051    ,
     *  0.11897894    /
        DATA ((CONDV (J,K),J=28,36),K=37,45) /
     *  0.13058731    , 0.12816539    , 0.12602959    , 0.12421466    ,
     *  0.12274701    , 0.12164473    , 0.12091808    , 0.12057020    ,
     *  0.12059811    ,
     *  0.13342664    , 0.13085368    , 0.12856195    , 0.12658899    ,
     *  0.12496393    , 0.12370741    , 0.12283196    , 0.12234263    ,
     *  0.12223796    ,
     *  0.13628727    , 0.13356523    , 0.13111894    , 0.12898868    ,
     *  0.12720631    , 0.12579505    , 0.12476974    , 0.12413743    ,
     *  0.12389826    ,
     *  0.13916799    , 0.13629887    , 0.13369944    , 0.13141273    ,
     *  0.12947328    , 0.12790693    , 0.12673087    , 0.12595420    ,
     *  0.12557877    ,
     *  0.14206762    , 0.13905345    , 0.13630241    , 0.13386018    ,
     *  0.13176402    , 0.13004236    , 0.12871479    , 0.12779255    ,
     *  0.12727922    ,
     *  0.14498505    , 0.14182792    , 0.13892682    , 0.13633010    ,
     *  0.13407769    , 0.13220063    , 0.13072094    , 0.12965202    ,
     *  0.12899932    ,
     *  0.14791924    , 0.14462122    , 0.14157170    , 0.13882159    ,
     *  0.13641349    , 0.13438104    , 0.13274874    , 0.13153219    ,
     *  0.13073875    ,
     *  0.15086921    , 0.14743240    , 0.14423610    , 0.14133377    ,
     *  0.13877063    , 0.13658292    , 0.13479763    , 0.13343261    ,
     *  0.13249718    ,
     *  0.15383400    , 0.15026051    , 0.14691912    , 0.14386579    ,
     *  0.14114834    , 0.13880560    , 0.13686704    , 0.13535283    ,
     *  0.13427427    /
        DATA ((CONDV (J,K),J=28,36),K=46,54) /
     *  0.15681275    , 0.15310466    , 0.14961990    , 0.14641684    ,
     *  0.14354587    , 0.14104840    , 0.13895641    , 0.13729238    ,
     *  0.13606967    ,
     *  0.15980460    , 0.15596402    , 0.15233762    , 0.14898614    ,
     *  0.14596251    , 0.14331070    , 0.14106519    , 0.13925081    ,
     *  0.13788304    ,
     *  0.16280877    , 0.15883778    , 0.15507147    , 0.15157293    ,
     *  0.14839755    , 0.14559185    , 0.14319283    , 0.14122767    ,
     *  0.13971400    ,
     *  0.16582450    , 0.16172518    , 0.15782072    , 0.15417649    ,
     *  0.15085031    , 0.14789125    , 0.14533879    , 0.14322251    ,
     *  0.14156221    ,
     *  0.16885109    , 0.16462548    , 0.16058463    , 0.15679610    ,
     *  0.15332014    , 0.15020829    , 0.14750255    , 0.14523488    ,
     *  0.14342728    ,
     *  0.17188786    , 0.16753800    , 0.16336251    , 0.15943111    ,
     *  0.15580639    , 0.15254239    , 0.14968358    , 0.14726432    ,
     *  0.14530887    ,
     *  0.17493417    , 0.17046208    , 0.16615370    , 0.16208086    ,
     *  0.15830847    , 0.15489299    , 0.15188138    , 0.14931042    ,
     *  0.14720660    ,
     *  0.17798943    , 0.17339709    , 0.16895757    , 0.16474473    ,
     *  0.16082576    , 0.15725954    , 0.15409546    , 0.15137273    ,
     *  0.14912011    ,
     *  0.18105306    , 0.17634244    , 0.17177351    , 0.16742214    ,
     *  0.16335771    , 0.15964149    , 0.15632532    , 0.15345083    ,
     *  0.15104906    /
        DATA ((CONDV (J,K),J=28,36),K=55,63) /
     *  0.18412453    , 0.17929756    , 0.17460095    , 0.17011249    ,
     *  0.16590375    , 0.16203834    , 0.15857051    , 0.15554431    ,
     *  0.15299308    ,
     *  0.18720332    , 0.18226191    , 0.17743934    , 0.17281526    ,
     *  0.16846336    , 0.16444957    , 0.16083056    , 0.15765276    ,
     *  0.15495182    ,
     *  0.19028894    , 0.18523498    , 0.18028815    , 0.17552990    ,
     *  0.17103603    , 0.16687471    , 0.16310502    , 0.15977577    ,
     *  0.15692494    ,
     *  0.19338095    , 0.18821629    , 0.18314687    , 0.17825592    ,
     *  0.17362125    , 0.16931329    , 0.16539346    , 0.16191296    ,
     *  0.15891210    ,
     *  0.19647891    , 0.19120537    , 0.18601503    , 0.18099282    ,
     *  0.17621855    , 0.17176484    , 0.16769544    , 0.16406394    ,
     *  0.16091297    ,
     *  0.19958239    , 0.19420177    , 0.18889216    , 0.18374014    ,
     *  0.17882747    , 0.17422893    , 0.17001057    , 0.16622834    ,
     *  0.16292721    ,
     *  0.20269103    , 0.19720508    , 0.19177782    , 0.18649743    ,
     *  0.18144756    , 0.17670512    , 0.17233843    , 0.16840580    ,
     *  0.16495450    ,
     *  0.20580443    , 0.20021489    , 0.19467159    , 0.18926427    ,
     *  0.18407841    , 0.17919301    , 0.17467864    , 0.17059595    ,
     *  0.16699453    ,
     *  0.20892225    , 0.20323083    , 0.19757308    , 0.19204024    ,
     *  0.18671960    , 0.18169219    , 0.17703083    , 0.17279844    ,
     *  0.16904698    /
        DATA ((CONDV (J,K),J=28,36),K=64,72) /
     *  0.21204416    , 0.20625253    , 0.20048189    , 0.19482494    ,
     *  0.18937072    , 0.18420228    , 0.17939461    , 0.17501295    ,
     *  0.17111155    ,
     *  0.21516985    , 0.20927964    , 0.20339766    , 0.19761800    ,
     *  0.19203141    , 0.18672291    , 0.18176965    , 0.17723914    ,
     *  0.17318793    ,
     *  0.21829900    , 0.21231183    , 0.20632003    , 0.20041905    ,
     *  0.19470129    , 0.18925371    , 0.18415558    , 0.17947668    ,
     *  0.17527585    ,
     *  0.22143134    , 0.21534879    , 0.20924868    , 0.20322774    ,
     *  0.19738001    , 0.19179433    , 0.18655208    , 0.18172526    ,
     *  0.17737501    ,
     *  0.22456659    , 0.21839022    , 0.21218326    , 0.20604373    ,
     *  0.20006722    , 0.19434443    , 0.18895881    , 0.18398458    ,
     *  0.17948514    ,
     *  0.22770451    , 0.22143583    , 0.21512349    , 0.20886670    ,
     *  0.20276260    , 0.19690369    , 0.19137547    , 0.18625434    ,
     *  0.18160595    ,
     *  0.23084483    , 0.22448534    , 0.21806905    , 0.21169634    ,
     *  0.20546582    , 0.19947180    , 0.19380175    , 0.18853424    ,
     *  0.18373719    ,
     *  0.23398734    , 0.22753851    , 0.22101968    , 0.21453235    ,
     *  0.20817659    , 0.20204844    , 0.19623734    , 0.19082401    ,
     *  0.18587859    ,
     *  0.23713180    , 0.23059507    , 0.22397509    , 0.21737444    ,
     *  0.21089461    , 0.20463332    , 0.19868196    , 0.19312337    ,
     *  0.18802990    /
        DATA ((CONDV (J,K),J=28,36),K=73,81) /
     *  0.24027802    , 0.23365479    , 0.22693502    , 0.22022234    ,
     *  0.21361959    , 0.20722615    , 0.20113534    , 0.19543205    ,
     *  0.19019087    ,
     *  0.24342579    , 0.23671744    , 0.22989924    , 0.22307579    ,
     *  0.21635127    , 0.20982667    , 0.20359719    , 0.19774980    ,
     *  0.19236126    ,
     *  0.24657492    , 0.23978282    , 0.23286750    , 0.22593452    ,
     *  0.21908936    , 0.21243460    , 0.20606725    , 0.20007636    ,
     *  0.19454083    ,
     *  0.24972523    , 0.24285070    , 0.23583956    , 0.22879830    ,
     *  0.22183363    , 0.21504968    , 0.20854528    , 0.20241148    ,
     *  0.19672935    ,
     *  0.25287655    , 0.24592089    , 0.23881522    , 0.23166689    ,
     *  0.22458382    , 0.21767166    , 0.21103102    , 0.20475493    ,
     *  0.19892659    ,
     *  0.25602871    , 0.24899321    , 0.24179427    , 0.23454007    ,
     *  0.22733970    , 0.22030030    , 0.21352423    , 0.20710647    ,
     *  0.20113234    ,
     *  0.25918157    , 0.25206748    , 0.24477649    , 0.23741760    ,
     *  0.23010104    , 0.22293537    , 0.21602467    , 0.20946587    ,
     *  0.20334638    ,
     *  0.26233497    , 0.25514351    , 0.24776170    , 0.24029930    ,
     *  0.23286762    , 0.22557665    , 0.21853214    , 0.21183292    ,
     *  0.20556850    ,
     *  0.26548877    , 0.25822115    , 0.25074971    , 0.24318494    ,
     *  0.23563922    , 0.22822390    , 0.22104639    , 0.21420741    ,
     *  0.20779849    /
        DATA ((CONDV (J,K),J=37,45),K= 1, 9) /
     *  7.13124076E-02, 7.43714473E-02, 7.75699766E-02, 8.09143344E-02,
     *  8.44111367E-02, 8.80672905E-02, 9.18900069E-02, 9.58868162E-02,
     *  0.10006558    ,
     *  7.25838235E-02, 7.56078973E-02, 7.87744051E-02, 8.20894532E-02,
     *  8.55594344E-02, 8.91910415E-02, 9.29912811E-02, 9.69674889E-02,
     *  0.10112734    ,
     *  7.41103724E-02, 7.70702707E-02, 8.01767288E-02, 8.34357317E-02,
     *  8.68535343E-02, 9.04366773E-02, 9.41920039E-02, 9.81266766E-02,
     *  0.10224820    ,
     *  7.57134293E-02, 7.86044750E-02, 8.16451934E-02, 8.48416585E-02,
     *  8.82001817E-02, 9.17273294E-02, 9.54299414E-02, 9.93151504E-02,
     *  0.10339040    ,
     *  7.73249598E-02, 8.01503315E-02, 8.31271613E-02, 8.62617585E-02,
     *  8.95606386E-02, 9.30305398E-02, 9.66784401E-02, 0.10051158    ,
     *  0.10453747    ,
     *  7.89130920E-02, 8.16786865E-02, 8.45963686E-02, 8.76727441E-02,
     *  9.09146095E-02, 9.43289615E-02, 9.79230110E-02, 0.10170420    ,
     *  0.10568022    ,
     *  8.04631343E-02, 8.31753384E-02, 8.60394254E-02, 8.90622830E-02,
     *  9.22509972E-02, 9.56128518E-02, 9.91553336E-02, 0.10288614    ,
     *  0.10681320    ,
     *  8.19695682E-02, 8.46342197E-02, 8.74500625E-02, 9.04241911E-02,
     *  9.35639340E-02, 9.68768398E-02, 0.10037067    , 0.10405340    ,
     *  0.10793321    ,
     *  8.34320047E-02, 8.60539250E-02, 8.88261798E-02, 9.17559512E-02,
     *  9.48507218E-02, 9.81182421E-02, 0.10156651    , 0.10520375    ,
     *  0.10903841    /
        DATA ((CONDV (J,K),J=37,45),K=10,18) /
     *  8.48529374E-02, 8.74357610E-02, 9.01681718E-02, 9.30572939E-02,
     *  9.61106452E-02, 9.93360860E-02, 0.10274178    , 0.10633616    ,
     *  0.11012790    ,
     *  8.62364232E-02, 8.87825847E-02, 9.14779198E-02, 9.43293330E-02,
     *  9.73442417E-02, 0.10053050    , 0.10389636    , 0.10745037    ,
     *  0.11120142    ,
     *  8.75872835E-02, 9.00980883E-02, 9.27581597E-02, 9.55740179E-02,
     *  9.85528344E-02, 0.10170234    , 0.10503075    , 0.10854668    ,
     *  0.11225912    ,
     *  8.89106139E-02, 9.13863496E-02, 9.40120787E-02, 9.67937768E-02,
     *  9.97382231E-02, 0.10285289    , 0.10614585    , 0.10962570    ,
     *  0.11330145    ,
     *  9.02114835E-02, 9.26515477E-02, 9.52430535E-02, 9.79912817E-02,
     *  0.10090248    , 0.10398373    , 0.10724285    , 0.11068829    ,
     *  0.11432904    ,
     *  9.14947551E-02, 9.38977860E-02, 9.64544816E-02, 9.91692929E-02,
     *  0.10204780    , 0.10509658    , 0.10832307    , 0.11173548    ,
     *  0.11534267    ,
     *  9.27649816E-02, 9.51289832E-02, 9.76496732E-02, 0.10033056    ,
     *  0.10317642    , 0.10619322    , 0.10938792    , 0.11276836    ,
     *  0.11634318    ,
     *  9.40263532E-02, 9.63488110E-02, 9.88317844E-02, 0.10147773    ,
     *  0.10429056    , 0.10727546    , 0.11043883    , 0.11378807    ,
     *  0.11733148    ,
     *  9.52826759E-02, 9.75606607E-02, 0.10000378    , 0.10261336    ,
     *  0.10539234    , 0.10834507    , 0.11147725    , 0.11479575    ,
     *  0.11830847    /
        DATA ((CONDV (J,K),J=37,45),K=19,27) /
     *  9.65373712E-02, 9.87676317E-02, 0.10116840    , 0.10373984    ,
     *  0.10648380    , 0.10940375    , 0.11250459    , 0.11579256    ,
     *  0.11927507    ,
     *  9.77934887E-02, 9.99725313E-02, 0.10232818    , 0.10485939    ,
     *  0.10756688    , 0.11045313    , 0.11352219    , 0.11677960    ,
     *  0.12023218    ,
     *  9.90537257E-02, 0.10117788    , 0.10348543    , 0.10597406    ,
     *  0.10864337    , 0.11149476    , 0.11453138    , 0.11775795    ,
     *  0.12118067    ,
     *  0.10032045    , 0.10238594    , 0.10464223    , 0.10708576    ,
     *  0.10971495    , 0.11253010    , 0.11553337    , 0.11872865    ,
     *  0.12212140    ,
     *  0.10159574    , 0.10359872    , 0.10580047    , 0.10819622    ,
     *  0.11078317    , 0.11356050    , 0.11652935    , 0.11969267    ,
     *  0.12305516    ,
     *  0.10288137    , 0.10481797    , 0.10696184    , 0.10930700    ,
     *  0.11184945    , 0.11458723    , 0.11752040    , 0.12065095    ,
     *  0.12398274    ,
     *  0.10417890    , 0.10604526    , 0.10812785    , 0.11041953    ,
     *  0.11291511    , 0.11561146    , 0.11850755    , 0.12160437    ,
     *  0.12490488    ,
     *  0.10548964    , 0.10728194    , 0.10929985    , 0.11153509    ,
     *  0.11398133    , 0.11663428    , 0.11949176    , 0.12255376    ,
     *  0.12582227    ,
     *  0.10681471    , 0.10852920    , 0.11047902    , 0.11265485    ,
     *  0.11504922    , 0.11765667    , 0.12047392    , 0.12349988    ,
     *  0.12673557    /
        DATA ((CONDV (J,K),J=37,45),K=28,36) /
     *  0.10815505    , 0.10978805    , 0.11166641    , 0.11377983    ,
     *  0.11611974    , 0.11867956    , 0.12145486    , 0.12444346    ,
     *  0.12764541    ,
     *  0.10951145    , 0.11105937    , 0.11286295    , 0.11491096    ,
     *  0.11719380    , 0.11970377    , 0.12243532    , 0.12538518    ,
     *  0.12855235    ,
     *  0.11088453    , 0.11234390    , 0.11406943    , 0.11604906    ,
     *  0.11827220    , 0.12073007    , 0.12341602    , 0.12632566    ,
     *  0.12945696    ,
     *  0.11227481    , 0.11364227    , 0.11528654    , 0.11719486    ,
     *  0.11935567    , 0.12175917    , 0.12439760    , 0.12726549    ,
     *  0.13035973    ,
     *  0.11368269    , 0.11495499    , 0.11651490    , 0.11834899    ,
     *  0.12044485    , 0.12279168    , 0.12538066    , 0.12820521    ,
     *  0.13126115    ,
     *  0.11510847    , 0.11628249    , 0.11775500    , 0.11951201    ,
     *  0.12154033    , 0.12382819    , 0.12636573    , 0.12914531    ,
     *  0.13216166    ,
     *  0.11655238    , 0.11762511    , 0.11900729    , 0.12068442    ,
     *  0.12264261    , 0.12486920    , 0.12735332    , 0.13008626    ,
     *  0.13306168    ,
     *  0.11801455    , 0.11898313    , 0.12027211    , 0.12186664    ,
     *  0.12375217    , 0.12591519    , 0.12834389    , 0.13102848    ,
     *  0.13396160    ,
     *  0.11949506    , 0.12035674    , 0.12154978    , 0.12305904    ,
     *  0.12486940    , 0.12696658    , 0.12933784    , 0.13197238    ,
     *  0.13486176    /
        DATA ((CONDV (J,K),J=37,45),K=37,45) /
     *  0.12099394    , 0.12174609    , 0.12284053    , 0.12426192    ,
     *  0.12599465    , 0.12802375    , 0.13033555    , 0.13291830    ,
     *  0.13576251    ,
     *  0.12251115    , 0.12315128    , 0.12414456    , 0.12547555    ,
     *  0.12712825    , 0.12908702    , 0.13133737    , 0.13386658    ,
     *  0.13666415    ,
     *  0.12404662    , 0.12457234    , 0.12546200    , 0.12670015    ,
     *  0.12827046    , 0.13015670    , 0.13234360    , 0.13481753    ,
     *  0.13756696    ,
     *  0.12560023    , 0.12600929    , 0.12679296    , 0.12793590    ,
     *  0.12942151    , 0.13123305    , 0.13335453    , 0.13577142    ,
     *  0.13847122    ,
     *  0.12717185    , 0.12746209    , 0.12813752    , 0.12918294    ,
     *  0.13058160    , 0.13231631    , 0.13437040    , 0.13672850    ,
     *  0.13937717    ,
     *  0.12876131    , 0.12893069    , 0.12949569    , 0.13044137    ,
     *  0.13175089    , 0.13340668    , 0.13539145    , 0.13768902    ,
     *  0.14028502    ,
     *  0.13036840    , 0.13041500    , 0.13086750    , 0.13171129    ,
     *  0.13292953    , 0.13450435    , 0.13641787    , 0.13865317    ,
     *  0.14119500    ,
     *  0.13199293    , 0.13191492    , 0.13225291    , 0.13299274    ,
     *  0.13411763    , 0.13560945    , 0.13744984    , 0.13962116    ,
     *  0.14210728    ,
     *  0.13363464    , 0.13343030    , 0.13365189    , 0.13428576    ,
     *  0.13531528    , 0.13672214    , 0.13848753    , 0.14059315    ,
     *  0.14302205    /
        DATA ((CONDV (J,K),J=37,45),K=46,54) /
     *  0.13529331    , 0.13496100    , 0.13506437    , 0.13559035    ,
     *  0.13652254    , 0.13784251    , 0.13953107    , 0.14156931    ,
     *  0.14393946    ,
     *  0.13696868    , 0.13650686    , 0.13649028    , 0.13690652    ,
     *  0.13773946    , 0.13897067    , 0.14058059    , 0.14254976    ,
     *  0.14485966    ,
     *  0.13866047    , 0.13806770    , 0.13792951    , 0.13823422    ,
     *  0.13896608    , 0.14010668    , 0.14163620    , 0.14353464    ,
     *  0.14578279    ,
     *  0.14036842    , 0.13964334    , 0.13938196    , 0.13957342    ,
     *  0.14020242    , 0.14125061    , 0.14269798    , 0.14452407    ,
     *  0.14670897    ,
     *  0.14209225    , 0.14123357    , 0.14084751    , 0.14092407    ,
     *  0.14144846    , 0.14240250    , 0.14376602    , 0.14551813    ,
     *  0.14763831    ,
     *  0.14383167    , 0.14283820    , 0.14232602    , 0.14228610    ,
     *  0.14270421    , 0.14356239    , 0.14484039    , 0.14651693    ,
     *  0.14857091    ,
     *  0.14558639    , 0.14445700    , 0.14381736    , 0.14365943    ,
     *  0.14396963    , 0.14473030    , 0.14592113    , 0.14752054    ,
     *  0.14950686    ,
     *  0.14735614    , 0.14608977    , 0.14532137    , 0.14504398    ,
     *  0.14524470    , 0.14590623    , 0.14700829    , 0.14852902    ,
     *  0.15044625    ,
     *  0.14914062    , 0.14773629    , 0.14683790    , 0.14643964    ,
     *  0.14652937    , 0.14709020    , 0.14810191    , 0.14954244    ,
     *  0.15138914    /
        DATA ((CONDV (J,K),J=37,45),K=55,63) /
     *  0.15093954    , 0.14939632    , 0.14836680    , 0.14784632    ,
     *  0.14782360    , 0.14828218    , 0.14920201    , 0.15056084    ,
     *  0.15233562    ,
     *  0.15275262    , 0.15106965    , 0.14990789    , 0.14926391    ,
     *  0.14912731    , 0.14948217    , 0.15030860    , 0.15158427    ,
     *  0.15328572    ,
     *  0.15457957    , 0.15275605    , 0.15146100    , 0.15069230    ,
     *  0.15044045    , 0.15069013    , 0.15142171    , 0.15261276    ,
     *  0.15423952    ,
     *  0.15642009    , 0.15445530    , 0.15302598    , 0.15213136    ,
     *  0.15176294    , 0.15190605    , 0.15254133    , 0.15364635    ,
     *  0.15519704    ,
     *  0.15827392    , 0.15616715    , 0.15460263    , 0.15358097    ,
     *  0.15309472    , 0.15312987    , 0.15366745    , 0.15468504    ,
     *  0.15615834    ,
     *  0.16014077    , 0.15789139    , 0.15619079    , 0.15504100    ,
     *  0.15443568    , 0.15436157    , 0.15480007    , 0.15572887    ,
     *  0.15712345    ,
     *  0.16202037    , 0.15962780    , 0.15779028    , 0.15651134    ,
     *  0.15578576    , 0.15560108    , 0.15593917    , 0.15677783    ,
     *  0.15809239    ,
     *  0.16391244    , 0.16137613    , 0.15940092    , 0.15799183    ,
     *  0.15714486    , 0.15684837    , 0.15708474    , 0.15783194    ,
     *  0.15906519    ,
     *  0.16581671    , 0.16313618    , 0.16102253    , 0.15948236    ,
     *  0.15851288    , 0.15810337    , 0.15823674    , 0.15889119    ,
     *  0.16004187    /
        DATA ((CONDV (J,K),J=37,45),K=64,72) /
     *  0.16773292    , 0.16490771    , 0.16265494    , 0.16098278    ,
     *  0.15988974    , 0.15936603    , 0.15939515    , 0.15995559    ,
     *  0.16102245    ,
     *  0.16966082    , 0.16669052    , 0.16429796    , 0.16249296    ,
     *  0.16127533    , 0.16063628    , 0.16055994    , 0.16102512    ,
     *  0.16200693    ,
     *  0.17160013    , 0.16848437    , 0.16595142    , 0.16401276    ,
     *  0.16266956    , 0.16191405    , 0.16173107    , 0.16209978    ,
     *  0.16299534    ,
     *  0.17355061    , 0.17028906    , 0.16761514    , 0.16554204    ,
     *  0.16407233    , 0.16319929    , 0.16290851    , 0.16317955    ,
     *  0.16398766    ,
     *  0.17551202    , 0.17210437    , 0.16928895    , 0.16708067    ,
     *  0.16548352    , 0.16449191    , 0.16409220    , 0.16426441    ,
     *  0.16498391    ,
     *  0.17748411    , 0.17393010    , 0.17097268    , 0.16862850    ,
     *  0.16690304    , 0.16579185    , 0.16528212    , 0.16535434    ,
     *  0.16598408    ,
     *  0.17946663    , 0.17576603    , 0.17266614    , 0.17018540    ,
     *  0.16833079    , 0.16709904    , 0.16647821    , 0.16644933    ,
     *  0.16698818    ,
     *  0.18145937    , 0.17761197    , 0.17436918    , 0.17175123    ,
     *  0.16976665    , 0.16841340    , 0.16768043    , 0.16754935    ,
     *  0.16799618    ,
     *  0.18346208    , 0.17946771    , 0.17608162    , 0.17332586    ,
     *  0.17121052    , 0.16973485    , 0.16888872    , 0.16865436    ,
     *  0.16900810    /
        DATA ((CONDV (J,K),J=37,45),K=73,81) /
     *  0.18547454    , 0.18133306    , 0.17780329    , 0.17490914    ,
     *  0.17266230    , 0.17106331    , 0.17010304    , 0.16976435    ,
     *  0.17002391    ,
     *  0.18749654    , 0.18320782    , 0.17953402    , 0.17650094    ,
     *  0.17412188    , 0.17239871    , 0.17132333    , 0.17087928    ,
     *  0.17104360    ,
     *  0.18952786    , 0.18509180    , 0.18127367    , 0.17810113    ,
     *  0.17558915    , 0.17374098    , 0.17254953    , 0.17199912    ,
     *  0.17206717    ,
     *  0.19156828    , 0.18698482    , 0.18302205    , 0.17970958    ,
     *  0.17706402    , 0.17509002    , 0.17378160    , 0.17312383    ,
     *  0.17309459    ,
     *  0.19361760    , 0.18888669    , 0.18477903    , 0.18132614    ,
     *  0.17854636    , 0.17644576    , 0.17501948    , 0.17425339    ,
     *  0.17412584    ,
     *  0.19567562    , 0.19079723    , 0.18654443    , 0.18295069    ,
     *  0.18003608    , 0.17780812    , 0.17626311    , 0.17538775    ,
     *  0.17516092    ,
     *  0.19774214    , 0.19271626    , 0.18831810    , 0.18458311    ,
     *  0.18153308    , 0.17917702    , 0.17751243    , 0.17652687    ,
     *  0.17619979    ,
     *  0.19981697    , 0.19464361    , 0.19009990    , 0.18622326    ,
     *  0.18303724    , 0.18055238    , 0.17876738    , 0.17767073    ,
     *  0.17724245    ,
     *  0.20189991    , 0.19657910    , 0.19188967    , 0.18787101    ,
     *  0.18454847    , 0.18193411    , 0.18002791    , 0.17881928    ,
     *  0.17828886    /
        DATA ((CONDV (J,K),J=46,54),K= 1, 9) /
     *  0.10443452    , 0.10900220    , 0.11377759    , 0.11877005    ,
     *  0.12398935    , 0.12944572    , 0.13514982    , 0.14111281    ,
     *  0.14734634    ,
     *  0.10547889    , 0.11003053    , 0.11479108    , 0.11976976    ,
     *  0.12497620    , 0.13042051    , 0.13611325    , 0.14206545    ,
     *  0.14828868    ,
     *  0.10656441    , 0.11108356    , 0.11581425    , 0.12076552    ,
     *  0.12594683    , 0.13136809    , 0.13703968    , 0.14297248    ,
     *  0.14917788    ,
     *  0.10766347    , 0.11214250    , 0.11683599    , 0.12175285    ,
     *  0.12690240    , 0.13229442    , 0.13793914    , 0.14384728    ,
     *  0.15003008    ,
     *  0.10876394    , 0.11319913    , 0.11785154    , 0.12273003    ,
     *  0.12784388    , 0.13320278    , 0.13881686    , 0.14469675    ,
     *  0.15085357    ,
     *  0.10985902    , 0.11424887    , 0.11885834    , 0.12369633    ,
     *  0.12877215    , 0.13409546    , 0.13967639    , 0.14552551    ,
     *  0.15165385    ,
     *  0.11094469    , 0.11528902    , 0.11985494    , 0.12465147    ,
     *  0.12968798    , 0.13497423    , 0.14052034    , 0.14633690    ,
     *  0.15243494    ,
     *  0.11201852    , 0.11631801    , 0.12084058    , 0.12559544    ,
     *  0.13059212    , 0.13584048    , 0.14135074    , 0.14713352    ,
     *  0.15319990    ,
     *  0.11307917    , 0.11733494    , 0.12181489    , 0.12652842    ,
     *  0.13148524    , 0.13669538    , 0.14216919    , 0.14791741    ,
     *  0.15395117    /
        DATA ((CONDV (J,K),J=46,54),K=10,18) /
     *  0.11412594    , 0.11833944    , 0.12277780    , 0.12745067    ,
     *  0.13236797    , 0.13753992    , 0.14297705    , 0.14869022    ,
     *  0.15469069    ,
     *  0.11515864    , 0.11933143    , 0.12372943    , 0.12836254    ,
     *  0.13324090    , 0.13837495    , 0.14377540    , 0.14945330    ,
     *  0.15542006    ,
     *  0.11617739    , 0.12031107    , 0.12467003    , 0.12926440    ,
     *  0.13410457    , 0.13920118    , 0.14456518    , 0.15020780    ,
     *  0.15614060    ,
     *  0.11718252    , 0.12127866    , 0.12559993    , 0.13015667    ,
     *  0.13495949    , 0.14001928    , 0.14534717    , 0.15095464    ,
     *  0.15685342    ,
     *  0.11817453    , 0.12223463    , 0.12651953    , 0.13103977    ,
     *  0.13580616    , 0.14082980    , 0.14612206    , 0.15169463    ,
     *  0.15755944    ,
     *  0.11915403    , 0.12317945    , 0.12742925    , 0.13191410    ,
     *  0.13664500    , 0.14163324    , 0.14689043    , 0.15242844    ,
     *  0.15825945    ,
     *  0.12012167    , 0.12411368    , 0.12832956    , 0.13278010    ,
     *  0.13747644    , 0.14243007    , 0.14765278    , 0.15315666    ,
     *  0.15895410    ,
     *  0.12107816    , 0.12503786    , 0.12922092    , 0.13363818    ,
     *  0.13830089    , 0.14322068    , 0.14840955    , 0.15387977    ,
     *  0.15964395    ,
     *  0.12202422    , 0.12595258    , 0.13010380    , 0.13448873    ,
     *  0.13911869    , 0.14400545    , 0.14916112    , 0.15459821    ,
     *  0.16032949    /
        DATA ((CONDV (J,K),J=46,54),K=19,27) /
     *  0.12296057    , 0.12685840    , 0.13097867    , 0.13533215    ,
     *  0.13993021    , 0.14478469    , 0.14990784    , 0.15531232    ,
     *  0.16101111    ,
     *  0.12388794    , 0.12775590    , 0.13184597    , 0.13616882    ,
     *  0.14073577    , 0.14555871    , 0.15065000    , 0.15602244    ,
     *  0.16168917    ,
     *  0.12480703    , 0.12864565    , 0.13270617    , 0.13699909    ,
     *  0.14153567    , 0.14632778    , 0.15138787    , 0.15672882    ,
     *  0.16236396    ,
     *  0.12571852    , 0.12952818    , 0.13355969    , 0.13782332    ,
     *  0.14233020    , 0.14709216    , 0.15212167    , 0.15743171    ,
     *  0.16303572    ,
     *  0.12662306    , 0.13040403    , 0.13440695    , 0.13864184    ,
     *  0.14311963    , 0.14785207    , 0.15285161    , 0.15813130    ,
     *  0.16370467    ,
     *  0.12752130    , 0.13127369    , 0.13524837    , 0.13945497    ,
     *  0.14390421    , 0.14860772    , 0.15357788    , 0.15882776    ,
     *  0.16437099    ,
     *  0.12841384    , 0.13213767    , 0.13608431    , 0.14026301    ,
     *  0.14468419    , 0.14935930    , 0.15430064    , 0.15952126    ,
     *  0.16503484    ,
     *  0.12930125    , 0.13299643    , 0.13691516    , 0.14106625    ,
     *  0.14545979    , 0.15010699    , 0.15502003    , 0.16021191    ,
     *  0.16569632    ,
     *  0.13018409    , 0.13385041    , 0.13774126    , 0.14186496    ,
     *  0.14623122    , 0.15085096    , 0.15573619    , 0.16089983    ,
     *  0.16635556    /
        DATA ((CONDV (J,K),J=46,54),K=28,36) /
     *  0.13106286    , 0.13470003    , 0.13856296    , 0.14265942    ,
     *  0.14699867    , 0.15159135    , 0.15644924    , 0.16158511    ,
     *  0.16701264    ,
     *  0.13193807    , 0.13554569    , 0.13938057    , 0.14344985    ,
     *  0.14776235    , 0.15232831    , 0.15715927    , 0.16226785    ,
     *  0.16766762    ,
     *  0.13281017    , 0.13638778    , 0.14019439    , 0.14423652    ,
     *  0.14852243    , 0.15306197    , 0.15786639    , 0.16294810    ,
     *  0.16832057    ,
     *  0.13367959    , 0.13722666    , 0.14100472    , 0.14501962    ,
     *  0.14927907    , 0.15379246    , 0.15857068    , 0.16362593    ,
     *  0.16897154    ,
     *  0.13454675    , 0.13806266    , 0.14181183    , 0.14579939    ,
     *  0.15003243    , 0.15451987    , 0.15927221    , 0.16430139    ,
     *  0.16962056    ,
     *  0.13541203    , 0.13889610    , 0.14261598    , 0.14657601    ,
     *  0.15078267    , 0.15524432    , 0.15997107    , 0.16497453    ,
     *  0.17026765    ,
     *  0.13627579    , 0.13972730    , 0.14341741    , 0.14734969    ,
     *  0.15152992    , 0.15596591    , 0.16066731    , 0.16564538    ,
     *  0.17091283    ,
     *  0.13713837    , 0.14055653    , 0.14421635    , 0.14812059    ,
     *  0.15227432    , 0.15668473    , 0.16136098    , 0.16631397    ,
     *  0.17155613    ,
     *  0.13800008    , 0.14138405    , 0.14501303    , 0.14888890    ,
     *  0.15301599    , 0.15740086    , 0.16205215    , 0.16698034    ,
     *  0.17219753    /
        DATA ((CONDV (J,K),J=46,54),K=37,45) /
     *  0.13886122    , 0.14221014    , 0.14580765    , 0.14965477    ,
     *  0.15375505    , 0.15811439    , 0.16274086    , 0.16764449    ,
     *  0.17283706    ,
     *  0.13972207    , 0.14303501    , 0.14660040    , 0.15041836    ,
     *  0.15449162    , 0.15882539    , 0.16342715    , 0.16830645    ,
     *  0.17347469    ,
     *  0.14058287    , 0.14385890    , 0.14739148    , 0.15117981    ,
     *  0.15522581    , 0.15953394    , 0.16411107    , 0.16896623    ,
     *  0.17411044    ,
     *  0.14144388    , 0.14468201    , 0.14818105    , 0.15193926    ,
     *  0.15595771    , 0.16024010    , 0.16479265    , 0.16962385    ,
     *  0.17474428    ,
     *  0.14230532    , 0.14550454    , 0.14896928    , 0.15269684    ,
     *  0.15668742    , 0.16094393    , 0.16547193    , 0.17027932    ,
     *  0.17537621    ,
     *  0.14316739    , 0.14632668    , 0.14975632    , 0.15345268    ,
     *  0.15741503    , 0.16164550    , 0.16614893    , 0.17093263    ,
     *  0.17600622    ,
     *  0.14403028    , 0.14714859    , 0.15054233    , 0.15420688    ,
     *  0.15814062    , 0.16234486    , 0.16682369    , 0.17158380    ,
     *  0.17663429    ,
     *  0.14489419    , 0.14797044    , 0.15132743    , 0.15495956    ,
     *  0.15886429    , 0.16304207    , 0.16749623    , 0.17223283    ,
     *  0.17726040    ,
     *  0.14575927    , 0.14879238    , 0.15211176    , 0.15571083    ,
     *  0.15958611    , 0.16373717    , 0.16816658    , 0.17287972    ,
     *  0.17788454    /
        DATA ((CONDV (J,K),J=46,54),K=46,54) /
     *  0.14662568    , 0.14961454    , 0.15289544    , 0.15646078    ,
     *  0.16030614    , 0.16443021    , 0.16883477    , 0.17352447    ,
     *  0.17850669    ,
     *  0.14749356    , 0.15043707    , 0.15367858    , 0.15720951    ,
     *  0.16102446    , 0.16512125    , 0.16950081    , 0.17416708    ,
     *  0.17912683    ,
     *  0.14836305    , 0.15126009    , 0.15446129    , 0.15795710    ,
     *  0.16174114    , 0.16581031    , 0.17016472    , 0.17480756    ,
     *  0.17974494    ,
     *  0.14923427    , 0.15208370    , 0.15524368    , 0.15870364    ,
     *  0.16245624    , 0.16649745    , 0.17082653    , 0.17544589    ,
     *  0.18036100    ,
     *  0.15010733    , 0.15290802    , 0.15602584    , 0.15944921    ,
     *  0.16316982    , 0.16718271    , 0.17148625    , 0.17608209    ,
     *  0.18097499    ,
     *  0.15098233    , 0.15373316    , 0.15680785    , 0.16019388    ,
     *  0.16388193    , 0.16786611    , 0.17214390    , 0.17671614    ,
     *  0.18158689    ,
     *  0.15185938    , 0.15455919    , 0.15758981    , 0.16093772    ,
     *  0.16459264    , 0.16854769    , 0.17279949    , 0.17734805    ,
     *  0.18219669    ,
     *  0.15273856    , 0.15538621    , 0.15837179    , 0.16168081    ,
     *  0.16530199    , 0.16922750    , 0.17345305    , 0.17797781    ,
     *  0.18280436    ,
     *  0.15361996    , 0.15621430    , 0.15915387    , 0.16242320    ,
     *  0.16601002    , 0.16990556    , 0.17410458    , 0.17860543    ,
     *  0.18340989    /
        DATA ((CONDV (J,K),J=46,54),K=55,63) /
     *  0.15450363    , 0.15704353    , 0.15993612    , 0.16316495    ,
     *  0.16671680    , 0.17058190    , 0.17475410    , 0.17923088    ,
     *  0.18401325    ,
     *  0.15538967    , 0.15787398    , 0.16071860    , 0.16390612    ,
     *  0.16742235    , 0.17125655    , 0.17540163    , 0.17985419    ,
     *  0.18461442    ,
     *  0.15627812    , 0.15870571    , 0.16150137    , 0.16464677    ,
     *  0.16812673    , 0.17192954    , 0.17604718    , 0.18047533    ,
     *  0.18521340    ,
     *  0.15716904    , 0.15953878    , 0.16228449    , 0.16538694    ,
     *  0.16882997    , 0.17260090    , 0.17669075    , 0.18109432    ,
     *  0.18581016    ,
     *  0.15806248    , 0.16037324    , 0.16306802    , 0.16612669    ,
     *  0.16953212    , 0.17327066    , 0.17733237    , 0.18171114    ,
     *  0.18640469    ,
     *  0.15895849    , 0.16120914    , 0.16385201    , 0.16686605    ,
     *  0.17023320    , 0.17393883    , 0.17797204    , 0.18232580    ,
     *  0.18699697    ,
     *  0.15985711    , 0.16204653    , 0.16463650    , 0.16760507    ,
     *  0.17093326    , 0.17460545    , 0.17860977    , 0.18293829    ,
     *  0.18758698    ,
     *  0.16075838    , 0.16288546    , 0.16542153    , 0.16834380    ,
     *  0.17163232    , 0.17527053    , 0.17924559    , 0.18354861    ,
     *  0.18817471    ,
     *  0.16166233    , 0.16372597    , 0.16620716    , 0.16908227    ,
     *  0.17233043    , 0.17593410    , 0.17987949    , 0.18415676    ,
     *  0.18876015    /
        DATA ((CONDV (J,K),J=46,54),K=64,72) /
     *  0.16256899    , 0.16456808    , 0.16699341    , 0.16982051    ,
     *  0.17302760    , 0.17659618    , 0.18051148    , 0.18476274    ,
     *  0.18934327    ,
     *  0.16347838    , 0.16541184    , 0.16778033    , 0.17055857    ,
     *  0.17372387    , 0.17725679    , 0.18114159    , 0.18536654    ,
     *  0.18992407    ,
     *  0.16439053    , 0.16625727    , 0.16856794    , 0.17129646    ,
     *  0.17441926    , 0.17791595    , 0.18176981    , 0.18596818    ,
     *  0.19050254    ,
     *  0.16530545    , 0.16710441    , 0.16935628    , 0.17203423    ,
     *  0.17511381    , 0.17857368    , 0.18239616    , 0.18656764    ,
     *  0.19107867    ,
     *  0.16622316    , 0.16795327    , 0.17014538    , 0.17277191    ,
     *  0.17580753    , 0.17922999    , 0.18302066    , 0.18716492    ,
     *  0.19165243    ,
     *  0.16714368    , 0.16880388    , 0.17093526    , 0.17350951    ,
     *  0.17650046    , 0.17988492    , 0.18364329    , 0.18776003    ,
     *  0.19222383    ,
     *  0.16806702    , 0.16965626    , 0.17172595    , 0.17424707    ,
     *  0.17719261    , 0.18053846    , 0.18426409    , 0.18835296    ,
     *  0.19279284    ,
     *  0.16899317    , 0.17051043    , 0.17251748    , 0.17498461    ,
     *  0.17788400    , 0.18119065    , 0.18488305    , 0.18894372    ,
     *  0.19335947    ,
     *  0.16992216    , 0.17136640    , 0.17330985    , 0.17572215    ,
     *  0.17857466    , 0.18184149    , 0.18550019    , 0.18953230    ,
     *  0.19392370    /
        DATA ((CONDV (J,K),J=46,54),K=73,81) /
     *  0.17085398    , 0.17222418    , 0.17410310    , 0.17645971    ,
     *  0.17926461    , 0.18249101    , 0.18611552    , 0.19011872    ,
     *  0.19448553    ,
     *  0.17178864    , 0.17308380    , 0.17489724    , 0.17719732    ,
     *  0.17995386    , 0.18313921    , 0.18672904    , 0.19070296    ,
     *  0.19504494    ,
     *  0.17272613    , 0.17394525    , 0.17569229    , 0.17793499    ,
     *  0.18064244    , 0.18378611    , 0.18734076    , 0.19128503    ,
     *  0.19560194    ,
     *  0.17366646    , 0.17480856    , 0.17648826    , 0.17867275    ,
     *  0.18133036    , 0.18443174    , 0.18795069    , 0.19186493    ,
     *  0.19615650    ,
     *  0.17460961    , 0.17567372    , 0.17728517    , 0.17941060    ,
     *  0.18201764    , 0.18507609    , 0.18855885    , 0.19244267    ,
     *  0.19670864    ,
     *  0.17555560    , 0.17654074    , 0.17808303    , 0.18014857    ,
     *  0.18270430    , 0.18571918    , 0.18916523    , 0.19301824    ,
     *  0.19725833    ,
     *  0.17650441    , 0.17740962    , 0.17888185    , 0.18088667    ,
     *  0.18339034    , 0.18636104    , 0.18976986    , 0.19359165    ,
     *  0.19780558    ,
     *  0.17745603    , 0.17828038    , 0.17968164    , 0.18162491    ,
     *  0.18407580    , 0.18700166    , 0.19037273    , 0.19416290    ,
     *  0.19835039    ,
     *  0.17841046    , 0.17915301    , 0.18048241    , 0.18236331    ,
     *  0.18476067    , 0.18764107    , 0.19097386    , 0.19473200    ,
     *  0.19889274    /
        DATA ((CONDV (J,K),J=55,63),K= 1, 9) /
     *  0.15386257    , 0.16067425    , 0.16779464    , 0.17523765    ,
     *  0.18301779    , 0.19115022    , 0.19965079    , 0.20853607    ,
     *  0.21782335    ,
     *  0.15479502    , 0.16159712    , 0.16870819    , 0.17614206    ,
     *  0.18391318    , 0.19203668    , 0.20052835    , 0.20940471    ,
     *  0.21868304    ,
     *  0.15566782    , 0.16245479    , 0.16955186    , 0.17697274    ,
     *  0.18473175    , 0.19284389    , 0.20132487    , 0.21019110    ,
     *  0.21945977    ,
     *  0.15649933    , 0.16326736    , 0.17034710    , 0.17775210    ,
     *  0.18549655    , 0.19359532    , 0.20206398    , 0.21091883    ,
     *  0.22017693    ,
     *  0.15729897    , 0.16404515    , 0.17110493    , 0.17849170    ,
     *  0.18621952    , 0.19430313    , 0.20275795    , 0.21160016    ,
     *  0.22084670    ,
     *  0.15807300    , 0.16479505    , 0.17183271    , 0.17919927    ,
     *  0.18690866    , 0.19497549    , 0.20341506    , 0.21224342    ,
     *  0.22147739    ,
     *  0.15882598    , 0.16552208    , 0.17253585    , 0.17988050    ,
     *  0.18756987    , 0.19561846    , 0.20404145    , 0.21285479    ,
     *  0.22207516    ,
     *  0.15956141    , 0.16623008    , 0.17321849    , 0.18053978    ,
     *  0.18820773    , 0.19623675    , 0.20464193    , 0.21343911    ,
     *  0.22264488    ,
     *  0.16028205    , 0.16692211    , 0.17388392    , 0.18118061    ,
     *  0.18882590    , 0.19683415    , 0.20522037    , 0.21400032    ,
     *  0.22319048    /
        DATA ((CONDV (J,K),J=55,63),K=10,18) /
     *  0.16099012    , 0.16760063    , 0.17453482    , 0.18180583    ,
     *  0.18942737    , 0.19741375    , 0.20577995    , 0.21454165    ,
     *  0.22371525    ,
     *  0.16168744    , 0.16826767    , 0.17517340    , 0.18241781    ,
     *  0.19001463    , 0.19797815    , 0.20632334    , 0.21506582    ,
     *  0.22422194    ,
     *  0.16237553    , 0.16892490    , 0.17580148    , 0.18301851    ,
     *  0.19058976    , 0.19852954    , 0.20685281    , 0.21557516    ,
     *  0.22471291    ,
     *  0.16305563    , 0.16957373    , 0.17642061    , 0.18360960    ,
     *  0.19115453    , 0.19906977    , 0.20737028    , 0.21607166    ,
     *  0.22519020    ,
     *  0.16372880    , 0.17021534    , 0.17703208    , 0.18419248    ,
     *  0.19171045    , 0.19960043    , 0.20787742    , 0.21655703    ,
     *  0.22565555    ,
     *  0.16439594    , 0.17085073    , 0.17763700    , 0.18476835    ,
     *  0.19225881    , 0.20012289    , 0.20837567    , 0.21703278    ,
     *  0.22611052    ,
     *  0.16505778    , 0.17148073    , 0.17823631    , 0.18533825    ,
     *  0.19280072    , 0.20063835    , 0.20886627    , 0.21750020    ,
     *  0.22655646    ,
     *  0.16571498    , 0.17210609    , 0.17883080    , 0.18590305    ,
     *  0.19333714    , 0.20114782    , 0.20935033    , 0.21796045    ,
     *  0.22699456    ,
     *  0.16636808    , 0.17272739    , 0.17942117    , 0.18646352    ,
     *  0.19386889    , 0.20165220    , 0.20982879    , 0.21841453    ,
     *  0.22742587    /
        DATA ((CONDV (J,K),J=55,63),K=19,27) /
     *  0.16701752    , 0.17334516    , 0.18000799    , 0.18702029    ,
     *  0.19439670    , 0.20215227    , 0.21030248    , 0.21886332    ,
     *  0.22785131    ,
     *  0.16766370    , 0.17395985    , 0.18059177    , 0.18757393    ,
     *  0.19492117    , 0.20264870    , 0.21077214    , 0.21930761    ,
     *  0.22827172    ,
     *  0.16830695    , 0.17457182    , 0.18117292    , 0.18812492    ,
     *  0.19544285    , 0.20314208    , 0.21123841    , 0.21974808    ,
     *  0.22868782    ,
     *  0.16894755    , 0.17518140    , 0.18175182    , 0.18867368    ,
     *  0.19596219    , 0.20363293    , 0.21170185    , 0.22018535    ,
     *  0.22910027    ,
     *  0.16958573    , 0.17578885    , 0.18232876    , 0.18922053    ,
     *  0.19647959    , 0.20412169    , 0.21216296    , 0.22061994    ,
     *  0.22950964    ,
     *  0.17022169    , 0.17639439    , 0.18290400    , 0.18976580    ,
     *  0.19699540    , 0.20460874    , 0.21262215    , 0.22105234    ,
     *  0.22991646    ,
     *  0.17085559    , 0.17699821    , 0.18347777    , 0.19030973    ,
     *  0.19750990    , 0.20509442    , 0.21307982    , 0.22148296    ,
     *  0.23032116    ,
     *  0.17148757    , 0.17760046    , 0.18405023    , 0.19085252    ,
     *  0.19802334    , 0.20557902    , 0.21353628    , 0.22191217    ,
     *  0.23072417    ,
     *  0.17211774    , 0.17820127    , 0.18462154    , 0.19139437    ,
     *  0.19853594    , 0.20606279    , 0.21399182    , 0.22234028    ,
     *  0.23112583    /
        DATA ((CONDV (J,K),J=55,63),K=28,36) /
     *  0.17274618    , 0.17880074    , 0.18519183    , 0.19193541    ,
     *  0.19904787    , 0.20654593    , 0.21444669    , 0.22276759    ,
     *  0.23152646    ,
     *  0.17337297    , 0.17939894    , 0.18576117    , 0.19247577    ,
     *  0.19955928    , 0.20702862    , 0.21490109    , 0.22319433    ,
     *  0.23192635    ,
     *  0.17399816    , 0.17999595    , 0.18632966    , 0.19301553    ,
     *  0.20007028    , 0.20751101    , 0.21535521    , 0.22362072    ,
     *  0.23232573    ,
     *  0.17462180    , 0.18059180    , 0.18689734    , 0.19355478    ,
     *  0.20058098    , 0.20799323    , 0.21580921    , 0.22404694    ,
     *  0.23272483    ,
     *  0.17524390    , 0.18118652    , 0.18746425    , 0.19409356    ,
     *  0.20109145    , 0.20847538    , 0.21626320    , 0.22447315    ,
     *  0.23312383    ,
     *  0.17586450    , 0.18178014    , 0.18803043    , 0.19463193    ,
     *  0.20160175    , 0.20895753    , 0.21671730    , 0.22489949    ,
     *  0.23352289    ,
     *  0.17648360    , 0.18237265    , 0.18859588    , 0.19516989    ,
     *  0.20211192    , 0.20943975    , 0.21717160    , 0.22532607    ,
     *  0.23392216    ,
     *  0.17710119    , 0.18296407    , 0.18916060    , 0.19570746    ,
     *  0.20262199    , 0.20992209    , 0.21762615    , 0.22575298    ,
     *  0.23432175    ,
     *  0.17771729    , 0.18355437    , 0.18972459    , 0.19624465    ,
     *  0.20313197    , 0.21040458    , 0.21808102    , 0.22618029    ,
     *  0.23472177    /
        DATA ((CONDV (J,K),J=55,63),K=37,45) /
     *  0.17833187    , 0.18414354    , 0.19028784    , 0.19678145    ,
     *  0.20364186    , 0.21088723    , 0.21853624    , 0.22660808    ,
     *  0.23512230    ,
     *  0.17894491    , 0.18473157    , 0.19085031    , 0.19731783    ,
     *  0.20415166    , 0.21137005    , 0.21899184    , 0.22703637    ,
     *  0.23552340    ,
     *  0.17955641    , 0.18531841    , 0.19141198    , 0.19785377    ,
     *  0.20466135    , 0.21185305    , 0.21944784    , 0.22746522    ,
     *  0.23592514    ,
     *  0.18016634    , 0.18590405    , 0.19197282    , 0.19838925    ,
     *  0.20517090    , 0.21233620    , 0.21990423    , 0.22789464    ,
     *  0.23632756    ,
     *  0.18077467    , 0.18648845    , 0.19253279    , 0.19892422    ,
     *  0.20568030    , 0.21281950    , 0.22036101    , 0.22832464    ,
     *  0.23673068    ,
     *  0.18138137    , 0.18707156    , 0.19309184    , 0.19945864    ,
     *  0.20618949    , 0.21330290    , 0.22081817    , 0.22875522    ,
     *  0.23713453    ,
     *  0.18198642    , 0.18765335    , 0.19364994    , 0.19999247    ,
     *  0.20669844    , 0.21378639    , 0.22127568    , 0.22918638    ,
     *  0.23753912    ,
     *  0.18258977    , 0.18823378    , 0.19420702    , 0.20052565    ,
     *  0.20720711    , 0.21426992    , 0.22173353    , 0.22961811    ,
     *  0.23794445    ,
     *  0.18319141    , 0.18881280    , 0.19476305    , 0.20105814    ,
     *  0.20771543    , 0.21475344    , 0.22219166    , 0.23005038    ,
     *  0.23835052    /
        DATA ((CONDV (J,K),J=55,63),K=46,54) /
     *  0.18379129    , 0.18939036    , 0.19531797    , 0.20158989    ,
     *  0.20822337    , 0.21523692    , 0.22265006    , 0.23048317    ,
     *  0.23875731    ,
     *  0.18438939    , 0.18996643    , 0.19587172    , 0.20212082    ,
     *  0.20873087    , 0.21572030    , 0.22310867    , 0.23091644    ,
     *  0.23916481    ,
     *  0.18498566    , 0.19054096    , 0.19642426    , 0.20265090    ,
     *  0.20923786    , 0.21620352    , 0.22356745    , 0.23135016    ,
     *  0.23957299    ,
     *  0.18558007    , 0.19111389    , 0.19697552    , 0.20318005    ,
     *  0.20974428    , 0.21668653    , 0.22402634    , 0.23178430    ,
     *  0.23998182    ,
     *  0.18617259    , 0.19168518    , 0.19752546    , 0.20370821    ,
     *  0.21025008    , 0.21716927    , 0.22448530    , 0.23221879    ,
     *  0.24039127    ,
     *  0.18676318    , 0.19225479    , 0.19807401    , 0.20423534    ,
     *  0.21075520    , 0.21765167    , 0.22494426    , 0.23265360    ,
     *  0.24080130    ,
     *  0.18735180    , 0.19282266    , 0.19862112    , 0.20476135    ,
     *  0.21125956    , 0.21813369    , 0.22540317    , 0.23308867    ,
     *  0.24121187    ,
     *  0.18793844    , 0.19338876    , 0.19916674    , 0.20528620    ,
     *  0.21176310    , 0.21861524    , 0.22586197    , 0.23352395    ,
     *  0.24162293    ,
     *  0.18852304    , 0.19395303    , 0.19971080    , 0.20580982    ,
     *  0.21226577    , 0.21909627    , 0.22632059    , 0.23395939    ,
     *  0.24203444    /
        DATA ((CONDV (J,K),J=55,63),K=55,63) /
     *  0.18910558    , 0.19451543    , 0.20025326    , 0.20633214    ,
     *  0.21276748    , 0.21957671    , 0.22677898    , 0.23439492    ,
     *  0.24244635    ,
     *  0.18968602    , 0.19507592    , 0.20079406    , 0.20685312    ,
     *  0.21326819    , 0.22005649    , 0.22723706    , 0.23483048    ,
     *  0.24285860    ,
     *  0.19026434    , 0.19563445    , 0.20133315    , 0.20737268    ,
     *  0.21376782    , 0.22053556    , 0.22769478    , 0.23526602    ,
     *  0.24327114    ,
     *  0.19084050    , 0.19619098    , 0.20187047    , 0.20789077    ,
     *  0.21426631    , 0.22101383    , 0.22815207    , 0.23570147    ,
     *  0.24368390    ,
     *  0.19141447    , 0.19674546    , 0.20240597    , 0.20840732    ,
     *  0.21476359    , 0.22149124    , 0.22860885    , 0.23613677    ,
     *  0.24409685    ,
     *  0.19198622    , 0.19729786    , 0.20293960    , 0.20892229    ,
     *  0.21525960    , 0.22196774    , 0.22906507    , 0.23657185    ,
     *  0.24450990    ,
     *  0.19255573    , 0.19784814    , 0.20347131    , 0.20943560    ,
     *  0.21575428    , 0.22244324    , 0.22952066    , 0.23700665    ,
     *  0.24492301    ,
     *  0.19312296    , 0.19839625    , 0.20400105    , 0.20994721    ,
     *  0.21624756    , 0.22291769    , 0.22997554    , 0.23744111    ,
     *  0.24533611    ,
     *  0.19368789    , 0.19894216    , 0.20452878    , 0.21045705    ,
     *  0.21673939    , 0.22339102    , 0.23042966    , 0.23787515    ,
     *  0.24574914    /
        DATA ((CONDV (J,K),J=55,63),K=64,72) /
     *  0.19425050    , 0.19948583    , 0.20505444    , 0.21096508    ,
     *  0.21722969    , 0.22386317    , 0.23088295    , 0.23830871    ,
     *  0.24616204    ,
     *  0.19481075    , 0.20002722    , 0.20557800    , 0.21147123    ,
     *  0.21771842    , 0.22433406    , 0.23133533    , 0.23874173    ,
     *  0.24657474    ,
     *  0.19536863    , 0.20056631    , 0.20609939    , 0.21197546    ,
     *  0.21820550    , 0.22480364    , 0.23178675    , 0.23917414    ,
     *  0.24698718    ,
     *  0.19592411    , 0.20110305    , 0.20661859    , 0.21247771    ,
     *  0.21869089    , 0.22527184    , 0.23223714    , 0.23960588    ,
     *  0.24739930    ,
     *  0.19647717    , 0.20163741    , 0.20713555    , 0.21297793    ,
     *  0.21917452    , 0.22573861    , 0.23268644    , 0.24003688    ,
     *  0.24781103    ,
     *  0.19702779    , 0.20216936    , 0.20765023    , 0.21347608    ,
     *  0.21965635    , 0.22620387    , 0.23313458    , 0.24046707    ,
     *  0.24822231    ,
     *  0.19757594    , 0.20269888    , 0.20816258    , 0.21397210    ,
     *  0.22013630    , 0.22666758    , 0.23358149    , 0.24089639    ,
     *  0.24863308    ,
     *  0.19812161    , 0.20322592    , 0.20867258    , 0.21446595    ,
     *  0.22061434    , 0.22712967    , 0.23402712    , 0.24132478    ,
     *  0.24904327    ,
     *  0.19866478    , 0.20375047    , 0.20918017    , 0.21495758    ,
     *  0.22109040    , 0.22759008    , 0.23447140    , 0.24175218    ,
     *  0.24945282    /
        DATA ((CONDV (J,K),J=55,63),K=73,81) /
     *  0.19920543    , 0.20427249    , 0.20968533    , 0.21544694    ,
     *  0.22156444    , 0.22804875    , 0.23491428    , 0.24217851    ,
     *  0.24986166    ,
     *  0.19974354    , 0.20479196    , 0.21018802    , 0.21593400    ,
     *  0.22203640    , 0.22850564    , 0.23535569    , 0.24260373    ,
     *  0.25026974    ,
     *  0.20027910    , 0.20530885    , 0.21068820    , 0.21641871    ,
     *  0.22250624    , 0.22896068    , 0.23579557    , 0.24302776    ,
     *  0.25067699    ,
     *  0.20081209    , 0.20582313    , 0.21118584    , 0.21690102    ,
     *  0.22297390    , 0.22941382    , 0.23623387    , 0.24345055    ,
     *  0.25108335    ,
     *  0.20134249    , 0.20633480    , 0.21168091    , 0.21738090    ,
     *  0.22343935    , 0.22986501    , 0.23667053    , 0.24387204    ,
     *  0.25148876    ,
     *  0.20187030    , 0.20684381    , 0.21217338    , 0.21785832    ,
     *  0.22390252    , 0.23031419    , 0.23710548    , 0.24429216    ,
     *  0.25189317    ,
     *  0.20239550    , 0.20735015    , 0.21266321    , 0.21833322    ,
     *  0.22436339    , 0.23076132    , 0.23753869    , 0.24471086    ,
     *  0.25229650    ,
     *  0.20291807    , 0.20785380    , 0.21315038    , 0.21880558    ,
     *  0.22482190    , 0.23120634    , 0.23797009    , 0.24512809    ,
     *  0.25269870    ,
     *  0.20343801    , 0.20835474    , 0.21363486    , 0.21927535    ,
     *  0.22527801    , 0.23164922    , 0.23839963    , 0.24554379    ,
     *  0.25309972    /
        DATA ((CONDV (J,K),J=64,72),K= 1, 9) /
     *  0.22753073    , 0.23767710    , 0.24828222    , 0.25936671    ,
     *  0.27095216    , 0.28306109    , 0.29571707    , 0.30894471    ,
     *  0.32276974    ,
     *  0.22838140    , 0.23851865    , 0.24911453    , 0.26018966    ,
     *  0.27176559    , 0.28386485    , 0.29651099    , 0.30972862    ,
     *  0.32354345    ,
     *  0.22914886    , 0.23927715    , 0.24986432    , 0.26093091    ,
     *  0.27249844    , 0.28458939    , 0.29722725    , 0.31043660    ,
     *  0.32424312    ,
     *  0.22985615    , 0.23997519    , 0.25055362    , 0.26161191    ,
     *  0.27317149    , 0.28525476    , 0.29788516    , 0.31108721    ,
     *  0.32488654    ,
     *  0.23051533    , 0.24062461    , 0.25119402    , 0.26224393    ,
     *  0.27379566    , 0.28587154    , 0.29849492    , 0.31169025    ,
     *  0.32548309    ,
     *  0.23113459    , 0.24123349    , 0.25179343    , 0.26283468    ,
     *  0.27437846    , 0.28644699    , 0.29906354    , 0.31225246    ,
     *  0.32603925    ,
     *  0.23172007    , 0.24180787    , 0.25235779    , 0.26338998    ,
     *  0.27492554    , 0.28698661    , 0.29959633    , 0.31277899    ,
     *  0.32655996    ,
     *  0.23227661    , 0.24235256    , 0.25289182    , 0.26391445    ,
     *  0.27544143    , 0.28749477    , 0.30009755    , 0.31327391    ,
     *  0.32704917    ,
     *  0.23280815    , 0.24287145    , 0.25339938    , 0.26441188    ,
     *  0.27592982    , 0.28797510    , 0.30057069    , 0.31374064    ,
     *  0.32751015    /
        DATA ((CONDV (J,K),J=64,72),K=10,18) /
     *  0.23331797    , 0.24336782    , 0.25388371    , 0.26488545    ,
     *  0.27639384    , 0.28843065    , 0.30101874    , 0.31418205    ,
     *  0.32794568    ,
     *  0.23380883    , 0.24384443    , 0.25434755    , 0.26533790    ,
     *  0.27683616    , 0.28886403    , 0.30144423    , 0.31460061    ,
     *  0.32835817    ,
     *  0.23428313    , 0.24430367    , 0.25479327    , 0.26577156    ,
     *  0.27725912    , 0.28927752    , 0.30184940    , 0.31499851    ,
     *  0.32874972    ,
     *  0.23474291    , 0.24474761    , 0.25522296    , 0.26618850    ,
     *  0.27766473    , 0.28967312    , 0.30223621    , 0.31537764    ,
     *  0.32912219    ,
     *  0.23518997    , 0.24517807    , 0.25563843    , 0.26659054    ,
     *  0.27805479    , 0.29005260    , 0.30260640    , 0.31573971    ,
     *  0.32947724    ,
     *  0.23562589    , 0.24559663    , 0.25604128    , 0.26697926    ,
     *  0.27843091    , 0.29041755    , 0.30296151    , 0.31608625    ,
     *  0.32981635    ,
     *  0.23605205    , 0.24600470    , 0.25643293    , 0.26735611    ,
     *  0.27879451    , 0.29076937    , 0.30330296    , 0.31641863    ,
     *  0.33014087    ,
     *  0.23646968    , 0.24640355    , 0.25681466    , 0.26772236    ,
     *  0.27914687    , 0.29110935    , 0.30363201    , 0.31673810    ,
     *  0.33045202    ,
     *  0.23687987    , 0.24679428    , 0.25718761    , 0.26807917    ,
     *  0.27948914    , 0.29143864    , 0.30394979    , 0.31704578    ,
     *  0.33075092    /
        DATA ((CONDV (J,K),J=64,72),K=19,27) /
     *  0.23728357    , 0.24717790    , 0.25755279    , 0.26842757    ,
     *  0.27982237    , 0.29175828    , 0.30425735    , 0.31734270    ,
     *  0.33103857    ,
     *  0.23768167    , 0.24755529    , 0.25791113    , 0.26876849    ,
     *  0.28014750    , 0.29206922    , 0.30455564    , 0.31762982    ,
     *  0.33131592    ,
     *  0.23807492    , 0.24792727    , 0.25826345    , 0.26910278    ,
     *  0.28046540    , 0.29237233    , 0.30484553    , 0.31790799    ,
     *  0.33158381    ,
     *  0.23846401    , 0.24829454    , 0.25861049    , 0.26943121    ,
     *  0.28077685    , 0.29266840    , 0.30512781    , 0.31817802    ,
     *  0.33184305    ,
     *  0.23884956    , 0.24865776    , 0.25895294    , 0.26975448    ,
     *  0.28108256    , 0.29295816    , 0.30540322    , 0.31844062    ,
     *  0.33209435    ,
     *  0.23923212    , 0.24901751    , 0.25929139    , 0.27007322    ,
     *  0.28138317    , 0.29324227    , 0.30567242    , 0.31869649    ,
     *  0.33233840    ,
     *  0.23961218    , 0.24937431    , 0.25962641    , 0.27038799    ,
     *  0.28167929    , 0.29352134    , 0.30593604    , 0.31894623    ,
     *  0.33257582    ,
     *  0.23999019    , 0.24972864    , 0.25995850    , 0.27069934    ,
     *  0.28197146    , 0.29379593    , 0.30619464    , 0.31919044    ,
     *  0.33280718    ,
     *  0.24036652    , 0.25008092    , 0.26028809    , 0.27100773    ,
     *  0.28226018    , 0.29406654    , 0.30644875    , 0.31942964    ,
     *  0.33303304    /
        DATA ((CONDV (J,K),J=64,72),K=28,36) /
     *  0.24074154    , 0.25043153    , 0.26061562    , 0.27131360    ,
     *  0.28254590    , 0.29433366    , 0.30669886    , 0.31966432    ,
     *  0.33325388    ,
     *  0.24111556    , 0.25078081    , 0.26094144    , 0.27161734    ,
     *  0.28282903    , 0.29459772    , 0.30694541    , 0.31989495    ,
     *  0.33347017    ,
     *  0.24148884    , 0.25112907    , 0.26126589    , 0.27191931    ,
     *  0.28310996    , 0.29485911    , 0.30718882    , 0.32012196    ,
     *  0.33368236    ,
     *  0.24186165    , 0.25147659    , 0.26158927    , 0.27221985    ,
     *  0.28338904    , 0.29511821    , 0.30742947    , 0.32034573    ,
     *  0.33389083    ,
     *  0.24223419    , 0.25182361    , 0.26191186    , 0.27251924    ,
     *  0.28366658    , 0.29537535    , 0.30766771    , 0.32056664    ,
     *  0.33409598    ,
     *  0.24260666    , 0.25217035    , 0.26223390    , 0.27281776    ,
     *  0.28394289    , 0.29563084    , 0.30790388    , 0.32078502    ,
     *  0.33429814    ,
     *  0.24297923    , 0.25251700    , 0.26255561    , 0.27311565    ,
     *  0.28421821    , 0.29588497    , 0.30813827    , 0.32100119    ,
     *  0.33449765    ,
     *  0.24335204    , 0.25286374    , 0.26287719    , 0.27341313    ,
     *  0.28449281    , 0.29613801    , 0.30837117    , 0.32121545    ,
     *  0.33469481    ,
     *  0.24372521    , 0.25321073    , 0.26319882    , 0.27371041    ,
     *  0.28476689    , 0.29639019    , 0.30860283    , 0.32142807    ,
     *  0.33488990    /
        DATA ((CONDV (J,K),J=64,72),K=37,45) /
     *  0.24409886    , 0.25355808    , 0.26352065    , 0.27400766    ,
     *  0.28504067    , 0.29664173    , 0.30883350    , 0.32163929    ,
     *  0.33508321    ,
     *  0.24447309    , 0.25390593    , 0.26384283    , 0.27430505    ,
     *  0.28531432    , 0.29689284    , 0.30906338    , 0.32184937    ,
     *  0.33527496    ,
     *  0.24484795    , 0.25425437    , 0.26416547    , 0.27460272    ,
     *  0.28558801    , 0.29714370    , 0.30929269    , 0.32205851    ,
     *  0.33546539    ,
     *  0.24522354    , 0.25460349    , 0.26448869    , 0.27490081    ,
     *  0.28586190    , 0.29739449    , 0.30952161    , 0.32226691    ,
     *  0.33565472    ,
     *  0.24559988    , 0.25495335    , 0.26481258    , 0.27519942    ,
     *  0.28613611    , 0.29764535    , 0.30975032    , 0.32247477    ,
     *  0.33584314    ,
     *  0.24597703    , 0.25530403    , 0.26513722    , 0.27549866    ,
     *  0.28641078    , 0.29789643    , 0.30997896    , 0.32268226    ,
     *  0.33603086    ,
     *  0.24635501    , 0.25565557    , 0.26546269    , 0.27579863    ,
     *  0.28668601    , 0.29814786    , 0.31020770    , 0.32288954    ,
     *  0.33621803    ,
     *  0.24673385    , 0.25600801    , 0.26578904    , 0.27609939    ,
     *  0.28696189    , 0.29839976    , 0.31043665    , 0.32309675    ,
     *  0.33640482    ,
     *  0.24711355    , 0.25636138    , 0.26611632    , 0.27640102    ,
     *  0.28723852    , 0.29865222    , 0.31066595    , 0.32330404    ,
     *  0.33659138    /
        DATA ((CONDV (J,K),J=64,72),K=46,54) /
     *  0.24749412    , 0.25671571    , 0.26644457    , 0.27670358    ,
     *  0.28751597    , 0.29890534    , 0.31089570    , 0.32351152    ,
     *  0.33677786    ,
     *  0.24787556    , 0.25707100    , 0.26677382    , 0.27700712    ,
     *  0.28779431    , 0.29915921    , 0.31112600    , 0.32371933    ,
     *  0.33696437    ,
     *  0.24825786    , 0.25742727    , 0.26710411    , 0.27731167    ,
     *  0.28807360    , 0.29941390    , 0.31135694    , 0.32392755    ,
     *  0.33715105    ,
     *  0.24864100    , 0.25778451    , 0.26743543    , 0.27761728    ,
     *  0.28835389    , 0.29966948    , 0.31158862    , 0.32413630    ,
     *  0.33733800    ,
     *  0.24902497    , 0.25814271    , 0.26776781    , 0.27792396    ,
     *  0.28863522    , 0.29992601    , 0.31182110    , 0.32434566    ,
     *  0.33752533    ,
     *  0.24940973    , 0.25850188    , 0.26810125    , 0.27823174    ,
     *  0.28891763    , 0.30018354    , 0.31205444    , 0.32455570    ,
     *  0.33771312    ,
     *  0.24979526    , 0.25886199    , 0.26843574    , 0.27854062    ,
     *  0.28920114    , 0.30044211    , 0.31228872    , 0.32476651    ,
     *  0.33790148    ,
     *  0.25018152    , 0.25922301    , 0.26877128    , 0.27885063    ,
     *  0.28948578    , 0.30070176    , 0.31252397    , 0.32497816    ,
     *  0.33809047    ,
     *  0.25056847    , 0.25958493    , 0.26910785    , 0.27916176    ,
     *  0.28977156    , 0.30096253    , 0.31276026    , 0.32519069    ,
     *  0.33828017    /
        DATA ((CONDV (J,K),J=64,72),K=55,63) /
     *  0.25095608    , 0.25994771    , 0.26944544    , 0.27947400    ,
     *  0.29005851    , 0.30122444    , 0.31299761    , 0.32540417    ,
     *  0.33847065    ,
     *  0.25134430    , 0.26031132    , 0.26978404    , 0.27978735    ,
     *  0.29034661    , 0.30148751    , 0.31323607    , 0.32561865    ,
     *  0.33866197    ,
     *  0.25173309    , 0.26067573    , 0.27012360    , 0.28010181    ,
     *  0.29063589    , 0.30175175    , 0.31347565    , 0.32583416    ,
     *  0.33885419    ,
     *  0.25212239    , 0.26104090    , 0.27046412    , 0.28041734    ,
     *  0.29092632    , 0.30201719    , 0.31371640    , 0.32605075    ,
     *  0.33904735    ,
     *  0.25251216    , 0.26140678    , 0.27080555    , 0.28073394    ,
     *  0.29121791    , 0.30228381    , 0.31395832    , 0.32626844    ,
     *  0.33924150    ,
     *  0.25290234    , 0.26177333    , 0.27114786    , 0.28105159    ,
     *  0.29151066    , 0.30255164    , 0.31420143    , 0.32648727    ,
     *  0.33943668    ,
     *  0.25329288    , 0.26214051    , 0.27149102    , 0.28137025    ,
     *  0.29180453    , 0.30282066    , 0.31444575    , 0.32670726    ,
     *  0.33963293    ,
     *  0.25368372    , 0.26250826    , 0.27183499    , 0.28168990    ,
     *  0.29209952    , 0.30309087    , 0.31469128    , 0.32692842    ,
     *  0.33983027    ,
     *  0.25407481    , 0.26287655    , 0.27217973    , 0.28201051    ,
     *  0.29239561    , 0.30336226    , 0.31493802    , 0.32715079    ,
     *  0.34002874    /
        DATA ((CONDV (J,K),J=64,72),K=64,72) /
     *  0.25446609    , 0.26324531    , 0.27252519    , 0.28233204    ,
     *  0.29269278    , 0.30363483    , 0.31518598    , 0.32737435    ,
     *  0.34022836    ,
     *  0.25485749    , 0.26361450    , 0.27287134    , 0.28265447    ,
     *  0.29299100    , 0.30390856    , 0.31543515    , 0.32759914    ,
     *  0.34042914    ,
     *  0.25524897    , 0.26398406    , 0.27321812    , 0.28297775    ,
     *  0.29329024    , 0.30418343    , 0.31568553    , 0.32782514    ,
     *  0.34063111    ,
     *  0.25564046    , 0.26435394    , 0.27356549    , 0.28330185    ,
     *  0.29359048    , 0.30445942    , 0.31593711    , 0.32805237    ,
     *  0.34083428    ,
     *  0.25603190    , 0.26472408    , 0.27391340    , 0.28362672    ,
     *  0.29389168    , 0.30473651    , 0.31618988    , 0.32828082    ,
     *  0.34103866    ,
     *  0.25642324    , 0.26509443    , 0.27426180    , 0.28395233    ,
     *  0.29419382    , 0.30501468    , 0.31644382    , 0.32851050    ,
     *  0.34124425    ,
     *  0.25681440    , 0.26546493    , 0.27461064    , 0.28427863    ,
     *  0.29449685    , 0.30529391    , 0.31669893    , 0.32874138    ,
     *  0.34145106    ,
     *  0.25720533    , 0.26583552    , 0.27495987    , 0.28460557    ,
     *  0.29480073    , 0.30557416    , 0.31695517    , 0.32897348    ,
     *  0.34165910    ,
     *  0.25759596    , 0.26620615    , 0.27530943    , 0.28493312    ,
     *  0.29510544    , 0.30585541    , 0.31721254    , 0.32920677    ,
     *  0.34186835    /
        DATA ((CONDV (J,K),J=64,72),K=73,81) /
     *  0.25798625    , 0.26657676    , 0.27565928    , 0.28526121    ,
     *  0.29541094    , 0.30613762    , 0.31747100    , 0.32944124    ,
     *  0.34207883    ,
     *  0.25837611    , 0.26694729    , 0.27600937    , 0.28558982    ,
     *  0.29571718    , 0.30642077    , 0.31773054    , 0.32967689    ,
     *  0.34229052    ,
     *  0.25876551    , 0.26731768    , 0.27635963    , 0.28591889    ,
     *  0.29602411    , 0.30670482    , 0.31799114    , 0.32991368    ,
     *  0.34250342    ,
     *  0.25915436    , 0.26768788    , 0.27671001    , 0.28624836    ,
     *  0.29633171    , 0.30698973    , 0.31825275    , 0.33015162    ,
     *  0.34271751    ,
     *  0.25954262    , 0.26805782    , 0.27706046    , 0.28657820    ,
     *  0.29663993    , 0.30727547    , 0.31851537    , 0.33039067    ,
     *  0.34293279    ,
     *  0.25993023    , 0.26842745    , 0.27741093    , 0.28690835    ,
     *  0.29694872    , 0.30756201    , 0.31877895    , 0.33063082    ,
     *  0.34314925    ,
     *  0.26031712    , 0.26879672    , 0.27776135    , 0.28723876    ,
     *  0.29725804    , 0.30784930    , 0.31904348    , 0.33087204    ,
     *  0.34336687    ,
     *  0.26070323    , 0.26916556    , 0.27811169    , 0.28756939    ,
     *  0.29756784    , 0.30813731    , 0.31930891    , 0.33111431    ,
     *  0.34358564    ,
     *  0.26108852    , 0.26953391    , 0.27846187    , 0.28790017    ,
     *  0.29787808    , 0.30842600    , 0.31957521    , 0.33135760    ,
     *  0.34380553    /
        DATA ((CONDV (J,K),J=73,81),K= 1, 9) /
     *  0.33721902    , 0.35232067    , 0.36810403    , 0.38459979    ,
     *  0.40184001    , 0.41985820    , 0.43868937    , 0.45837011    ,
     *  0.47893868    ,
     *  0.33798237    , 0.35307347    , 0.36884611    , 0.38533098    ,
     *  0.40256014    , 0.42056711    , 0.43938691    , 0.45905614    ,
     *  0.47961305    ,
     *  0.33867368    , 0.35375634    , 0.36952044    , 0.38599664    ,
     *  0.40321702    , 0.42121505    , 0.44002577    , 0.45968577    ,
     *  0.48023329    ,
     *  0.33930996    , 0.35438549    , 0.37014245    , 0.38661146    ,
     *  0.40382457    , 0.42181523    , 0.44061847    , 0.46027084    ,
     *  0.48081060    ,
     *  0.33990018    , 0.35496951    , 0.37072033    , 0.38718322    ,
     *  0.40439019    , 0.42237467    , 0.44117163    , 0.46081763    ,
     *  0.48135089    ,
     *  0.34045057    , 0.35551434    , 0.37125974    , 0.38771731    ,
     *  0.40491901    , 0.42289822    , 0.44168988    , 0.46133051    ,
     *  0.48185831    ,
     *  0.34096585    , 0.35602449    , 0.37176500    , 0.38821786    ,
     *  0.40541495    , 0.42338962    , 0.44217675    , 0.46181283    ,
     *  0.48233601    ,
     *  0.34144982    , 0.35650362    , 0.37223960    , 0.38868818    ,
     *  0.40588117    , 0.42385187    , 0.44263510    , 0.46226729    ,
     *  0.48278656    ,
     *  0.34190563    , 0.35695474    , 0.37268643    , 0.38913105    ,
     *  0.40632032    , 0.42428749    , 0.44306731    , 0.46269616    ,
     *  0.48321210    /
        DATA ((CONDV (J,K),J=73,81),K=10,18) /
     *  0.34233596    , 0.35738042    , 0.37310797    , 0.38954882    ,
     *  0.40673465    , 0.42469862    , 0.44347542    , 0.46310138    ,
     *  0.48361449    ,
     *  0.34274312    , 0.35778292    , 0.37350634    , 0.38994355    ,
     *  0.40712613    , 0.42508714    , 0.44386123    , 0.46348464    ,
     *  0.48399531    ,
     *  0.34312916    , 0.35816417    , 0.37388345    , 0.39031705    ,
     *  0.40749648    , 0.42545471    , 0.44422631    , 0.46384745    ,
     *  0.48435601    ,
     *  0.34349587    , 0.35852593    , 0.37424097    , 0.39067094    ,
     *  0.40784725    , 0.42580280    , 0.44457206    , 0.46419115    ,
     *  0.48469786    ,
     *  0.34384486    , 0.35886976    , 0.37458040    , 0.39100665    ,
     *  0.40817982    , 0.42613273    , 0.44489977    , 0.46451694    ,
     *  0.48502200    ,
     *  0.34417759    , 0.35919705    , 0.37490309    , 0.39132549    ,
     *  0.40849546    , 0.42644572    , 0.44521057    , 0.46482594    ,
     *  0.48532949    ,
     *  0.34449537    , 0.35950908    , 0.37521029    , 0.39162867    ,
     *  0.40879532    , 0.42674287    , 0.44550553    , 0.46511914    ,
     *  0.48562129    ,
     *  0.34479937    , 0.35980701    , 0.37550312    , 0.39191725    ,
     *  0.40908043    , 0.42702517    , 0.44578560    , 0.46539748    ,
     *  0.48589828    ,
     *  0.34509071    , 0.36009191    , 0.37578260    , 0.39219225    ,
     *  0.40935176    , 0.42729357    , 0.44605169    , 0.46566180    ,
     *  0.48616127    /
        DATA ((CONDV (J,K),J=73,81),K=19,27) /
     *  0.34537036    , 0.36036474    , 0.37604970    , 0.39245458    ,
     *  0.40961022    , 0.42754892    , 0.44630462    , 0.46591289    ,
     *  0.48641103    ,
     *  0.34563926    , 0.36062642    , 0.37630528    , 0.39270510    ,
     *  0.40985661    , 0.42779202    , 0.44654516    , 0.46615150    ,
     *  0.48664826    ,
     *  0.34589824    , 0.36087775    , 0.37655015    , 0.39294460    ,
     *  0.41009170    , 0.42802360    , 0.44677402    , 0.46637832    ,
     *  0.48687362    ,
     *  0.34614808    , 0.36111952    , 0.37678507    , 0.39317380    ,
     *  0.41031622    , 0.42824437    , 0.44699186    , 0.46659397    ,
     *  0.48708773    ,
     *  0.34638952    , 0.36135244    , 0.37701074    , 0.39339340    ,
     *  0.41053082    , 0.42845496    , 0.44719931    , 0.46679908    ,
     *  0.48729116    ,
     *  0.34662321    , 0.36157717    , 0.37722781    , 0.39360403    ,
     *  0.41073614    , 0.42865598    , 0.44739697    , 0.46699419    ,
     *  0.48748447    ,
     *  0.34684979    , 0.36179432    , 0.37743689    , 0.39380628    ,
     *  0.41093274    , 0.42884799    , 0.44758537    , 0.46717985    ,
     *  0.48766815    ,
     *  0.34706982    , 0.36200448    , 0.37763854    , 0.39400073    ,
     *  0.41112118    , 0.42903154    , 0.44776504    , 0.46735655    ,
     *  0.48784271    ,
     *  0.34728386    , 0.36220818    , 0.37783331    , 0.39418789    ,
     *  0.41130198    , 0.42920713    , 0.44793647    , 0.46752478    ,
     *  0.48800858    /
        DATA ((CONDV (J,K),J=73,81),K=28,36) /
     *  0.34749240    , 0.36240592    , 0.37802168    , 0.39436825    ,
     *  0.41147561    , 0.42937522    , 0.44810011    , 0.46768497    ,
     *  0.48816622    ,
     *  0.34769592    , 0.36259817    , 0.37820412    , 0.39454228    ,
     *  0.41164254    , 0.42953627    , 0.44825642    , 0.46783756    ,
     *  0.48831603    ,
     *  0.34789485    , 0.36278537    , 0.37838108    , 0.39471042    ,
     *  0.41180319    , 0.42969070    , 0.44840578    , 0.46798294    ,
     *  0.48845841    ,
     *  0.34808960    , 0.36296794    , 0.37855297    , 0.39487307    ,
     *  0.41195797    , 0.42983890    , 0.44854861    , 0.46812151    ,
     *  0.48859371    ,
     *  0.34828055    , 0.36314626    , 0.37872018    , 0.39503062    ,
     *  0.41210727    , 0.42998126    , 0.44868527    , 0.46825361    ,
     *  0.48872230    ,
     *  0.34846807    , 0.36332070    , 0.37888306    , 0.39518344    ,
     *  0.41225144    , 0.43011814    , 0.44881612    , 0.46837960    ,
     *  0.48884451    ,
     *  0.34865249    , 0.36349159    , 0.37904198    , 0.39533187    ,
     *  0.41239084    , 0.43024987    , 0.44894148    , 0.46849980    ,
     *  0.48896067    ,
     *  0.34883412    , 0.36365927    , 0.37919724    , 0.39547624    ,
     *  0.41252578    , 0.43037678    , 0.44906168    , 0.46861452    ,
     *  0.48907107    ,
     *  0.34901326    , 0.36382401    , 0.37934916    , 0.39561685    ,
     *  0.41265657    , 0.43049917    , 0.44917701    , 0.46872408    ,
     *  0.48917601    /
        DATA ((CONDV (J,K),J=73,81),K=37,45) /
     *  0.34919018    , 0.36398612    , 0.37949802    , 0.39575400    ,
     *  0.41278350    , 0.43061733    , 0.44928778    , 0.46882873    ,
     *  0.48927577    ,
     *  0.34936514    , 0.36414586    , 0.37964409    , 0.39588796    ,
     *  0.41290686    , 0.43073155    , 0.44939425    , 0.46892877    ,
     *  0.48937062    ,
     *  0.34953839    , 0.36430348    , 0.37978764    , 0.39601899    ,
     *  0.41302690    , 0.43084207    , 0.44949667    , 0.46902445    ,
     *  0.48946080    ,
     *  0.34971015    , 0.36445921    , 0.37992890    , 0.39614735    ,
     *  0.41314388    , 0.43094916    , 0.44959532    , 0.46911601    ,
     *  0.48954657    ,
     *  0.34988062    , 0.36461327    , 0.38006810    , 0.39627325    ,
     *  0.41325802    , 0.43105305    , 0.44969041    , 0.46920368    ,
     *  0.48962815    ,
     *  0.35005002    , 0.36476587    , 0.38020546    , 0.39639692    ,
     *  0.41336956    , 0.43115397    , 0.44978217    , 0.46928771    ,
     *  0.48970576    ,
     *  0.35021853    , 0.36491721    , 0.38034118    , 0.39651858    ,
     *  0.41347870    , 0.43125213    , 0.44987083    , 0.46936830    ,
     *  0.48977963    ,
     *  0.35038631    , 0.36506748    , 0.38047546    , 0.39663842    ,
     *  0.41358566    , 0.43134774    , 0.44995659    , 0.46944565    ,
     *  0.48984996    ,
     *  0.35055354    , 0.36521683    , 0.38060846    , 0.39675662    ,
     *  0.41369062    , 0.43144099    , 0.45003965    , 0.46951997    ,
     *  0.48991694    /
        DATA ((CONDV (J,K),J=73,81),K=46,54) /
     *  0.35072036    , 0.36536545    , 0.38074037    , 0.39687337    ,
     *  0.41379376    , 0.43153208    , 0.45012019    , 0.46959144    ,
     *  0.48998076    ,
     *  0.35088692    , 0.36551347    , 0.38087135    , 0.39698884    ,
     *  0.41389526    , 0.43162117    , 0.45019840    , 0.46966025    ,
     *  0.49004160    ,
     *  0.35105335    , 0.36566104    , 0.38100154    , 0.39710317    ,
     *  0.41399529    , 0.43170844    , 0.45027444    , 0.46972657    ,
     *  0.49009964    ,
     *  0.35121977    , 0.36580830    , 0.38113110    , 0.39721653    ,
     *  0.41409400    , 0.43179404    , 0.45034849    , 0.46979056    ,
     *  0.49015504    ,
     *  0.35138629    , 0.36595538    , 0.38126015    , 0.39732906    ,
     *  0.41419154    , 0.43187814    , 0.45042069    , 0.46985239    ,
     *  0.49020796    ,
     *  0.35155303    , 0.36610238    , 0.38138882    , 0.39744089    ,
     *  0.41428804    , 0.43196088    , 0.45049120    , 0.46991220    ,
     *  0.49025855    ,
     *  0.35172009    , 0.36624942    , 0.38151724    , 0.39755214    ,
     *  0.41438366    , 0.43204239    , 0.45056016    , 0.46997014    ,
     *  0.49030697    ,
     *  0.35188755    , 0.36639660    , 0.38164552    , 0.39766295    ,
     *  0.41447851    , 0.43212282    , 0.45062772    , 0.47002635    ,
     *  0.49035335    ,
     *  0.35205550    , 0.36654403    , 0.38177375    , 0.39777343    ,
     *  0.41457271    , 0.43220228    , 0.45069399    , 0.47008097    ,
     *  0.49039783    /
        DATA ((CONDV (J,K),J=73,81),K=55,63) /
     *  0.35222403    , 0.36669179    , 0.38190205    , 0.39788367    ,
     *  0.41466638    , 0.43228091    , 0.45075910    , 0.47013412    ,
     *  0.49044054    ,
     *  0.35239319    , 0.36683995    , 0.38203050    , 0.39799379    ,
     *  0.41475964    , 0.43235880    , 0.45082318    , 0.47018593    ,
     *  0.49048160    ,
     *  0.35256307    , 0.36698861    , 0.38215920    , 0.39810389    ,
     *  0.41485257    , 0.43243608    , 0.45088634    , 0.47023651    ,
     *  0.49052114    ,
     *  0.35273373    , 0.36713784    , 0.38228822    , 0.39821404    ,
     *  0.41494529    , 0.43251285    , 0.45094869    , 0.47028599    ,
     *  0.49055927    ,
     *  0.35290521    , 0.36728770    , 0.38241764    , 0.39832434    ,
     *  0.41503788    , 0.43258920    , 0.45101033    , 0.47033445    ,
     *  0.49059610    ,
     *  0.35307757    , 0.36743825    , 0.38254754    , 0.39843488    ,
     *  0.41513043    , 0.43266524    , 0.45107136    , 0.47038202    ,
     *  0.49063174    ,
     *  0.35325086    , 0.36758955    , 0.38267798    , 0.39854571    ,
     *  0.41522303    , 0.43274105    , 0.45113189    , 0.47042879    ,
     *  0.49066630    ,
     *  0.35342512    , 0.36774166    , 0.38280902    , 0.39865692    ,
     *  0.41531575    , 0.43281671    , 0.45119198    , 0.47047485    ,
     *  0.49069986    ,
     *  0.35360040    , 0.36789462    , 0.38294073    , 0.39876858    ,
     *  0.41540867    , 0.43289232    , 0.45125175    , 0.47052030    ,
     *  0.49073253    /
        DATA ((CONDV (J,K),J=73,81),K=64,72) /
     *  0.35377671    , 0.36804848    , 0.38307316    , 0.39888074    ,
     *  0.41550187    , 0.43296794    , 0.45131126    , 0.47056522    ,
     *  0.49076439    ,
     *  0.35395410    , 0.36820328    , 0.38320635    , 0.39899346    ,
     *  0.41559539    , 0.43304365    , 0.45137060    , 0.47060970    ,
     *  0.49079554    ,
     *  0.35413260    , 0.36835906    , 0.38334036    , 0.39910681    ,
     *  0.41568932    , 0.43311951    , 0.45142985    , 0.47065381    ,
     *  0.49082606    ,
     *  0.35431222    , 0.36851585    , 0.38347522    , 0.39922083    ,
     *  0.41578371    , 0.43319561    , 0.45148907    , 0.47069764    ,
     *  0.49085602    ,
     *  0.35449298    , 0.36867368    , 0.38361099    , 0.39933557    ,
     *  0.41587862    , 0.43327199    , 0.45154833    , 0.47074126    ,
     *  0.49088552    ,
     *  0.35467491    , 0.36883258    , 0.38374769    , 0.39945107    ,
     *  0.41597409    , 0.43334871    , 0.45160770    , 0.47078474    ,
     *  0.49091461    ,
     *  0.35485802    , 0.36899257    , 0.38388535    , 0.39956739    ,
     *  0.41607018    , 0.43342585    , 0.45166724    , 0.47082814    ,
     *  0.49094337    ,
     *  0.35504232    , 0.36915367    , 0.38402401    , 0.39968454    ,
     *  0.41616693    , 0.43350343    , 0.45172702    , 0.47087154    ,
     *  0.49097187    ,
     *  0.35522781    , 0.36931591    , 0.38416370    , 0.39980258    ,
     *  0.41626439    , 0.43358153    , 0.45178708    , 0.47091498    ,
     *  0.49100018    /
        DATA ((CONDV (J,K),J=73,81),K=73,81) /
     *  0.35541452    , 0.36947930    , 0.38430444    , 0.39992154    ,
     *  0.41636260    , 0.43366018    , 0.45184748    , 0.47095853    ,
     *  0.49102836    ,
     *  0.35560243    , 0.36964384    , 0.38444625    , 0.40004143    ,
     *  0.41646160    , 0.43373943    , 0.45190827    , 0.47100225    ,
     *  0.49105647    ,
     *  0.35579156    , 0.36980957    , 0.38458915    , 0.40016231    ,
     *  0.41656141    , 0.43381932    , 0.45196950    , 0.47104619    ,
     *  0.49108457    ,
     *  0.35598190    , 0.36997647    , 0.38473316    , 0.40028418    ,
     *  0.41666208    , 0.43389989    , 0.45203122    , 0.47109041    ,
     *  0.49111271    ,
     *  0.35617345    , 0.37014456    , 0.38487830    , 0.40040707    ,
     *  0.41676363    , 0.43398118    , 0.45209346    , 0.47113494    ,
     *  0.49114095    ,
     *  0.35636621    , 0.37031385    , 0.38502457    , 0.40053100    ,
     *  0.41686610    , 0.43406323    , 0.45215628    , 0.47117983    ,
     *  0.49116934    ,
     *  0.35656016    , 0.37048433    , 0.38517199    , 0.40065600    ,
     *  0.41696951    , 0.43414606    , 0.45221970    , 0.47122514    ,
     *  0.49119792    ,
     *  0.35675532    , 0.37065601    , 0.38532057    , 0.40078207    ,
     *  0.41707388    , 0.43422970    , 0.45228377    , 0.47127090    ,
     *  0.49122675    ,
     *  0.35695166    , 0.37082888    , 0.38547031    , 0.40090924    ,
     *  0.41717923    , 0.43431420    , 0.45234852    , 0.47131716    ,
     *  0.49125587    /
insert bottomNL.inc
